﻿program breeze_program_global;

uses 'breeze_program_variables.pas';

function GetTab(Active: Boolean; TabName, Link: String; First: Boolean=False): String;
var
	s: String;
begin
	s := '';
	if Active then begin
		s := '<div class="inactive-tabs" style="background-image: url(' + GetProperPath(ImgPath + 'active-tab-button.gif') + '); border-left: 1px solid #387fc1;' + Format(' font-size: %dpt;', [BasicFontSize + NormalModifier]) + '">' + TabName + '</div>';
	end
	else begin
		s := '<div class="inactive-tabs" style="' + Format('font-size: %dpt;', [BasicFontSize + NormalModifier]);
		if First then
			s := s + ' border-left: 1px solid #387fc1;';
		s := s + '"><a class="pic" href="' + Link + '">' + TabName + '</a></div>';
	end;
	Result := s;
end;

function GetTextTab(Active: Boolean; TabName, Link: String): String;
var
	s: String;
begin
	s := '';
	if Active then begin
		s := ' | ' + TabName;
	end
	else
		s := ' | ' + '<a href="' + Link + '">' + TabName + '</a>';
	Result := s;
end;

function GetSortIcons(sort_order: String; PersonCode: Integer;
  PersonType: String; AProgramType: Integer; AAddRating: Boolean = False): String;
begin
	result := '';
	if (RegReadInteger('SortIcons', 0) = 1) then begin
		if (sort_order <> 'title asc') then
			result := result + format('&nbsp;<a class="pic" href="userref:%d231,%d;%s">', [AProgramType, PersonCode, PersonType]) + format('<img alt="%s" border="0" src="%stitle-sort-ascend.png" align="absmiddle"></a>', [GetLangStr(1477), ImgPath]);
		if (sort_order <> 'title desc') then
			result := result + format('&nbsp;<a class="pic" href="userref:%d232,%d;%s">', [AProgramType, PersonCode, PersonType]) + format('<img alt="%s" border="0" src="%stitle-sort-descend.png" align="absmiddle"></a>', [GetLangStr(1478), ImgPath]);
		if (sort_order <> 'year asc') then
			result := result + format('&nbsp;<a class="pic" href="userref:%d233,%d;%s">', [AProgramType, PersonCode, PersonType]) + format('<img alt="%s" border="0" src="%syear-sort-ascend.png" align="absmiddle"></a>', [GetLangStr(1479), ImgPath]);
		if (sort_order <> 'year desc') then
			result := result + format('&nbsp;<a class="pic" href="userref:%d234,%d;%s">', [AProgramType, PersonCode, PersonType]) + format('<img alt="%s" border="0" src="%syear-sort-descend.png" align="absmiddle"></a>', [GetLangStr(1480), ImgPath]);
		if ((AAddRating) and
        (RegReadInteger('ShowRating', 1) = 1)) then
    begin
			if (sort_order <> 'rating asc') then
				result := result + format('&nbsp;<a class="pic" href="userref:%d235,%d;%s">', [AProgramType, PersonCode, PersonType]) + format('<img alt="%s" border="0" src="%ssort-rating-asc.png" align="absmiddle"></a>', [GetLangStr(7007), ImgPath]);
			if (sort_order <> 'rating desc') then
				result := result + format('&nbsp;<a class="pic" href="userref:%d236,%d;%s">', [AProgramType, PersonCode, PersonType]) + format('<img alt="%s" border="0" src="%ssort-rating-desc.png" align="absmiddle"></a>', [GetLangStr(7008), ImgPath]);
		end;
	end;
end;

function GetShots(Code, ImageMode: Integer; MyObject: String; AdditionalImageMode: Integer=0; AdditionalImageMode2: Integer=0): String;
var
	sl: TStringList;
	i, j, kol, RecordCount, page_width, page_width_copy, PicWidth, PicHeight: Integer;
	s, FileName, temp, ImageModes : String;
begin
	s := '';
	if AdditionalImageMode > 0 then
		ImageModes := Format('%d, %d', [ImageMode, AdditionalImageMode])
	else
		ImageModes := IntToStr(ImageMode);
	if AdditionalImageMode2 > 0 then
		ImageModes := Format('%s, %d', [ImageModes, AdditionalImageMode2]);
	sl := TStringList.Create;
	with sl do begin
		Clear;
		Add('select * from images');
		Add(format('where %s=%d and mode in (%s)', [MyObject, Code, ImageModes]));
		Add('order by sort_order');
	end;
	RecordCount:=ExecuteSQL(sl.text);
	if RecordCount>0 then begin
		page_width := GetHTMLWidth - WholePageBorder;
		page_width_copy := page_width;
		j := 0;
		temp := '';
		s := '<table style="margin: 10px;"><tr>';
		//skip the first photo
		if MyObject = 'person' then begin
			GetNextRecord;
			RecordCount := RecordCount - 1;
		end;
		for i:=1 to RecordCount do begin
			j := j+1;
			PicHeight := GetIntegerField('height');
			if PicHeight > 0 then
				PicWidth := Round(GetIntegerField('width') * (ShotHeight / PicHeight)) + SmallImageBorder
			else
				PicWidth := StandardShotWidth + SmallImageBorder;
			page_width_copy := page_width_copy - PicWidth;
			if (page_width_copy < 0) then begin
				s := s + temp + '</tr></table><table style="margin: 10px;"><tr>';
				temp := '';
				page_width_copy := page_width - PicWidth;
			end;
			FileName:=ImagesPath+GetStringField('path');
			if (MyFileExists(FileName)) then
				temp:=temp+'<td style="vertical-align: top; text-align: center;"><a class="pic" ' + format('href="ShowImage:%d"><img src="%s" style="height: %dpx;"></a></td>', [GetIntegerField('code'), FileName, ShotHeight]);
			GetNextRecord;
		end;
		s := s + temp;
//		if temp <> '' then
//			s := s + format('<td style="width: %dpx">&nbsp;</td>', [page_width_copy]);
		s := s + '</tr></table>';
	end;
	sl.Free;
	result := s;
end;


function GetPartnerImageFile(ASite: string; APicture: string): string;

begin

  Result := APicture;
  if (Result = '') then
  begin
    Result := ASite + '.gif';
    if (not MyFileExists(PicturesPath + Result)) then
      Result := '';
  end;
end;

//14.03.13
function StringReplaceIgnoreCase(AText: string; AReplaceWhat: string; AReplaceTo: string): string;
var
  TextPos: integer;
begin
  Result := AText;
  AReplaceWhat := LowerCase(AReplaceWhat);
  TextPos := Pos(AReplaceWhat, LowerCase(Result));
  while (TextPos > 0) do
  begin
    Delete(Result, TextPos, Length(AReplaceWhat));
    Insert(AReplaceTo, Result, TextPos);
    TextPos := MyPos(AReplaceWhat, LowerCase(Result), TextPos + Length(AReplaceTo));
  end;
end;

function GetFileSize(AFilePath: string): Integer;
var
  FileStream: TFileStream;
begin
  Result := 0;
  if (MyFileExists(AFilePath)) then
  begin
    FileStream := TFileStream.Create(AFilePath, fmOpenRead or fmShareDenyNone);
    try
      Result := FileStream.Size;
    finally
      FileStream.Free();
    end;
  end;
end;

// Fade. Add fix for files whose size is more than 1 Мб
function NeedToCreateThumbFile(AThumbFilePath: string): Boolean;
const
  // max file size
  MAX_FILE_SIZE = 1 * 1024 * 1024;
begin
  Result := True;
  if (MyFileExists(AThumbFilePath)) then
  begin
    Result := Result and (GetFileSize(AThumbFilePath) >= MAX_FILE_SIZE);
    if (Result) then
      DeleteFile(AThumbFilePath);
  end;
end;

function MarkPreviousAsSeen: Boolean;
var
	btnSelected: Integer;
begin
	btnSelected := MessageDlg(GetLangStr(2953), mtConfirmation, mbYes + mbNo, 0);
	if btnSelected = mrYes then
		Result := True
	else
		Result := False;
end;

function GetUserReferenceProgramType(ACode: Integer): Integer;
begin
  Result := MOVIENIZER_PROGRAM;
  if (ACode in [1000..1999]) then
    Result := MUSICNIZER_PROGRAM
  else if (ACode in [2000..2999]) then
    Result := BOOKNIZER_PROGRAM
  else if (ACode in [3000..3999]) then
    Result := GAMENIZER_PROGRAM;
end;

function GetOldReferenceCodeForNewCode(ACode: Integer): Integer;
begin
  Result := ACode;
  case GetUserReferenceProgramType(ACode) of
    MUSICNIZER_PROGRAM: Result := Result - 1000;
    BOOKNIZER_PROGRAM: Result := Result - 2000;
    GAMENIZER_PROGRAM: Result := Result - 3000;
  end;
end;

function ProcessMovieReference(AProgramType: Integer;
  text: String; page: integer; header_img: String = ''): String;
var
  i, j, kol, RecordCount, rating, page_width, my_i: integer;
  s, description, year, director, writer, actor, bio, character, movie, movie_top: string;
  all, FileName, img, rate, BackgroundMovieRef: string;
  IMDBRating, SiteRating: double;
  ii, TotalItems, PageItems, lines, PicWidth, PicHeight, page_width_copy: integer;
  fl: boolean;
  ItemCode: string;
  CodesList: TStringList;
begin
	all := '';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
  try
    CountedPages := 0;
    page_width:=GetHTMLWidth - WholePageBorder;
    GetFirstRecord();
    RecordCount := GetRecordsCount();
    lines := RegReadInteger('BreezeLinesMovies', DefaultLinesMovies);
    //count how many items were listed on the previous pages
    TotalItems := CountItemsForPages(page_width, page, RecordCount, 0, lines,
      HomeCoverHeight[AProgramType], HomeCoverWidth[AProgramType]);
    i := ProcessedRecords;
    fl:=true;
    PageItems := 0;
    page_width_copy := page_width;
    movie := '';
    CodesList := TStringList.Create();
    try
      CodesList.Sorted := True;
      //list movies on the current page
      while (i<RecordCount) and fl do
      begin
        ItemCode := GetStringField('code');
        if (CodesList.IndexOf(ItemCode) < 0) then
        begin
          CodesList.Add(ItemCode);
          rating:=GetIntegerField('rating');
          rate:='';
          PicHeight := HomeCoverHeight[AProgramType];
          PicWidth := HomeCoverWidth[AProgramType] + NormalImageBorders;
          page_width_copy := page_width_copy - PicWidth;
          if (page_width_copy < 0) then begin
            all := all + movie + '<td></td></tr></table><table class="whole-page-images"><tr>';
            movie := '';
            lines := lines - 1;
            page_width_copy := page_width - PicWidth;
          end;
          if (page<>0) and (lines <= 0) then
            fl:=false
          else begin
            if rating > 0 then begin
              for my_i:=1 to 10 do begin
                if my_i mod 2=1 then begin
                  if my_i<=rating then
                rate:=rate+format('<img src="%shalfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  else
                rate:=rate+format('<img src="%snot-halfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                end
                else begin
                  if my_i<=rating then
                rate:=rate+format('<img src="%shalfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  else
                rate:=rate+format('<img src="%snot-halfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                end;
              end;
            end;
            IMDBRating := GetFloatField('imdb_rating');
            SiteRating := GetFloatField('KinopoiskRating');

            FileName := GetImageFileName(GetStringField('path'), ThumbsHomeMovies, NO_COVER_FILE[AProgramType], HomeCoverWidth[AProgramType], HomeCoverHeight[AProgramType], True);
            movie:=movie+'<td style="background-color: white; border: 1px solid ' + WhiteAreaBorderColor + '; width: 100px; padding: 5px;"><a class="pic"'+format(' href="movie:%s"><img style="height: %dpx" src="', [ItemCode, HomeCoverHeight[AProgramType]])+FileName+'"></a>';

            if (SiteRating > 0) and (RegReadInteger('ShowKinopoiskRatingUnderCovers', 1) = 1) then
            begin
              s := Format('<img src="%skinopoisk-ico.png">&nbsp;', [PicturesPath]);
              movie:=movie+'<div style="vertical-align: middle; font-weight: bold; margin-top: 5;">' + s + format('%s: %0.1f</div>', [GetLangStr(3419), SiteRating]);
            end;

            if (IMDBRating > 0) and (RegReadInteger('ShowIMDBRatingUnderCovers', 1) = 1) then
              movie:=movie+'<div style="vertical-align: middle; font-weight: bold; margin-top: 5;"><img ' + Format('src="%stag-icon.gif"/>&nbsp;', [ImgPath]) + format('IMDB: %0.1f</div>', [IMDBRating]);

             if (rate<>'') and (RegReadInteger('ShowUserRatingUnderCovers', 1) = 1) then
                movie := movie + '<div style="vertical-align: bottom; margin-top: 5;">' + rate + '</div>';
            {if SiteRating <> 0 then
              movie:=movie+'<div style="vertical-align: middle; font-weight: bold; margin-top: 5;">' + format('%s: %0.1f</div>', [GetLangStr(3419), SiteRating]);
            if IMDBRating <> 0 then
              movie:=movie + '<div style="vertical-align: middle; font-weight: bold; margin: 5 0">' + format('IMDB: %0.1f</div>', [IMDBRating]);
            if (rate<>'') and (RegReadInteger('ShowRating', 1) = 1) then
              movie:=movie + '<div style="vertical-align: bottom;">' + rate + '</div>';}
            //sequence number
            if TempReference = 22 then
              movie:=movie + '<p style="margin: 5 0;">' + GetLangStr(529) + IntToStr(GetIntegerField('series_nom')) + ': </p>';
            movie := movie + format('<p style="margin: 5 0;"><a href="movie:%s">%s</a></p>', [ItemCode, GetStringField('title')]);
            movie := movie + '</td>';

            PageItems:=PageItems+1;
            GetNextRecord;
            i := i+1;
          end;
        end
        else begin
          GetNextRecord;
          i:=i+1;
        end;
      end;//while
      TotalItems := TotalItems + PageItems;
      all := all + movie;
      if movie <> '' then
        //all := all + Format('<td style="width: %dpx"></td>', [page_width_copy - BigImageBorders]);
        all := all + '<td></td>';
      all := all + '<td></td></tr></table>';
      kol := 0;
      lines := RegReadInteger('BreezeLinesMovies', DefaultLinesMovies);
      if (page > 0) and (i < RecordCount) then
      begin
        //set the maximum number of pages to 2000
        TotalItems := TotalItems + CountItemsForPages(page_width, 2000, RecordCount,
          i, lines, HomeCoverHeight[AProgramType], HomeCoverWidth[AProgramType]);
        kol := CountedPages;
      end;
      //get the top of the page (we need to know how many movies were there)
      movie_top:=GetReferenceTop;
      if header_img <> '' then
        header_img := '<img border="0" style="float: left; margin-right: 10; vertical-align: middle;" src="' + header_img + '">';
      movie_top:=movie_top + Format('<p class="page-header" style="font-size: %dpt;">', [BasicFontSize + PageHeaderModifier]) + header_img + text + format(' (%d)', [TotalItems]);
      movie_top:=movie_top+'</p>'+ClosePatternTop;
      movie_top := movie_top + '<table class="whole-page-images"><tr>';
      case TempReference of
        1: s:='video_standard:'+IntToStr(TempReferenceCode);
        2: s:='media_format:'+IntToStr(TempReferenceCode);
        3: s:='media_type:'+IntToStr(TempReferenceCode);
        4: s:='aspect_ratio:'+IntToStr(TempReferenceCode);
        5: s:='resolution:'+IntToStr(TempReferenceCode);
        6: s:='subtitle:'+IntToStr(TempReferenceCode);
        7: s:='audio_track:'+IntToStr(TempReferenceCode);
        8: s:='genre:'+IntToStr(TempReferenceCode);
        9: s:='country:'+IntToStr(TempReferenceCode);
        10: s:='location:'+IntToStr(TempReferenceCode);
        11: s:='mpaa:'+IntToStr(TempReferenceCode);
        12: s:='studio:'+IntToStr(TempReferenceCode);
        13: s:='custom1:'+IntToStr(TempReferenceCode);
        14: s:='custom2:'+IntToStr(TempReferenceCode);
        15: s:='custom3:'+IntToStr(TempReferenceCode);
        16: s:='custom4:'+IntToStr(TempReferenceCode);
        17: s:='custom5:'+IntToStr(TempReferenceCode);
        18: s:='custom6:'+IntToStr(TempReferenceCode);
        19: s:='video_codec:'+IntToStr(TempReferenceCode);
        20: s:='disc_label:'+IntToStr(TempReferenceCode);
        22: s:='sequence:'+IntToStr(TempReferenceCode);
        23: s:='book_language:'+IntToStr(TempReferenceCode);
        300: s:='year:'+IntToStr(TempReferenceCode) + ',' + IntToStr(AProgramType);
        301: s := 'show_my_rating:' + IntToStr(TempReferenceCode) + ',' + IntToStr(AProgramType);
        666: s:='userref:'+IntToStr(TempReferenceCode)+','+TempText;
      else
        s:='';
      end;
      if (page > 1) or (kol > 0) then begin
        all:=all+ Format('<center><hr><p>', [page_width div 3, page_width div 3]);
        if (page>1) or (kol > 0) then
          all:=all+format('<a href="%s,%d">%s</a>   ', [s, 0, GetLangStr(1330)]);
        if page>1 then
          all:=all+format('<a href="%s,%d">%s</a>   ', [s, page-1, GetLangStr(1328)]);
        for i:=1 to page do begin
          if page=i then
            all:=all+format(' <b class="search-active">%d</b> ', [i])
          else
            all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
        end;
        for i:=(page+1) to (page+kol) do
          all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
        if kol>0 then
          all:=all+format('   <a href="%s,%d">%s</a> ', [s, page+1, GetLangStr(1329)]);
        all:=all+'</p></center>';
      end;
      all:=movie_top+all;
      Result := all;
    finally
      CodesList.Free();
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

function ProcessPersonReference(AProgramType: Integer;
  text: String; page: integer; header_img: String = ''): String;
var
  i, j, kol, RecordCount, rating, page_width, my_i: integer;
  s, description, year, director, writer, actor, bio, character, person, person_top: string;
  all, FileName, img, rate, BackgroundMovieRef: string;
  SiteRating: double;
  ItemCode: string;
  ii, TotalItems, PageItems, lines, PicWidth, PicHeight, page_width_copy: integer;
  fl: boolean;
  CodesList: TStringList;
begin
	all := '';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
  try
    CountedPages := 0;
    page_width:=GetHTMLWidth - WholePageBorder;

    GetFirstRecord();
    RecordCount := GetRecordsCount();
    lines := RegReadInteger('BreezeLinesMovies', DefaultLinesMovies);
    //count how many items were listed on the previous pages
    TotalItems := CountItemsForPages(page_width, page, RecordCount, 0, lines,
      HomeCoverHeight[AProgramType], HomeCoverWidth[AProgramType]);
    i := ProcessedRecords;

    fl:=true;
    PageItems := 0;
    page_width_copy := page_width;
    person := '';
    CodesList := TStringList.Create();
    try
      CodesList.Sorted := True;
      //list persons on the current page
      while (i<RecordCount) and fl do
      begin
        ItemCode := GetStringField('code');
        if (CodesList.IndexOf(ItemCode) < 0) then
        begin
          CodesList.Add(ItemCode);
          rating:=GetIntegerField('rating');
          rate:='';
          PicHeight := HomeCoverHeight[AProgramType];
          PicWidth := HomeCoverWidth[AProgramType] + NormalImageBorders;
          page_width_copy := page_width_copy - PicWidth;
          if (page_width_copy < 0) then begin
            all := all + person + '<td></td></tr></table><table class="whole-page-images"><tr>';
            person := '';
            lines := lines - 1;
            page_width_copy := page_width - PicWidth;
          end;
          if (page<>0) and (lines <= 0) then
            fl:=false
          else begin
            if rating > 0 then begin
              for my_i:=1 to 10 do begin
                if my_i mod 2=1 then begin
                  if my_i<=rating then
                rate:=rate+format('<img src="%shalfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  else
                rate:=rate+format('<img src="%snot-halfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                end
                else begin
                  if my_i<=rating then
                rate:=rate+format('<img src="%shalfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  else
                rate:=rate+format('<img src="%snot-halfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                end;
              end;
            end;
            SiteRating := GetFloatField('SiteRating');

            FileName := GetImageFileName(GetStringField('path'), ThumbsHomeMovies, NO_PHOTO_FILE[AProgramType], HomeCoverWidth[AProgramType], HomeCoverHeight[AProgramType], True);
            person:=person+'<td style="background-color: white; border: 1px solid ' + WhiteAreaBorderColor + '; width: 100px; padding: 5px;"><a class="pic"'+format(' href="person:%s"><img style="height: %dpx" src="', [ItemCode, HomeCoverHeight[AProgramType]])+FileName+'"></a>';
            if SiteRating <> 0 then
              person:=person+'<div style="vertical-align: middle; font-weight: bold; margin-top: 5;">' + format('%s: %0.1f</div>', [GetLangStr(3419), SiteRating]);
            if (rate<>'') and (RegReadInteger('ShowRating', 1) = 1) then
              person:=person + '<div style="vertical-align: bottom;">' + rate + '</div>';
            //sequence number
            person := person + format('<p style="margin: 5 0;"><a href="person:%s">%s</a></p>', [ItemCode, GetStringField('name')]);
            person := person + '</td>';

            PageItems:=PageItems+1;
            GetNextRecord;
            i := i+1;
          end;
        end
        else begin
          GetNextRecord;
          i:=i+1;
        end;
      end;//while
      TotalItems := TotalItems + PageItems;
      all := all + person;
      if person <> '' then
        //all := all + Format('<td style="width: %dpx"></td>', [page_width_copy - BigImageBorders]);
        all := all + '<td></td>';
      all := all + '<td></td></tr></table>';
      kol := 0;
      lines := RegReadInteger('BreezeLinesMovies', DefaultLinesMovies);
      if (page > 0) and (i < RecordCount) then begin
        //set the maximum number of pages to 2000
        TotalItems := TotalItems + CountItemsForPages(page_width, 2000, RecordCount, i, lines, HomeCoverHeight[AProgramType], HomeCoverWidth[AProgramType]);
        kol := CountedPages;
      end;
      //get the top of the page (we need to know how many persons were there)
      person_top:=GetReferenceTop;
      if header_img <> '' then
        header_img := '<img border="0" style="float: left; margin-right: 10; vertical-align: middle;" src="' + header_img + '">';
      person_top:=person_top + Format('<p class="page-header" style="font-size: %dpt;">', [BasicFontSize + PageHeaderModifier]) + header_img + text + format(' (%d)', [TotalItems]);
      person_top:=person_top+'</p>'+ClosePatternTop;
      person_top := person_top + '<table class="whole-page-images"><tr>';

      case TempReference of
        24: s:='custom_person1:'+IntToStr(TempReferenceCode);
        25: s:='custom_person2:'+IntToStr(TempReferenceCode);
        26: s:='custom_person3:'+IntToStr(TempReferenceCode);
        27: s:='custom_person4:'+IntToStr(TempReferenceCode);
        28: s:='custom_person5:'+IntToStr(TempReferenceCode);
        29: s:='custom_person6:'+IntToStr(TempReferenceCode);
      else
        s:='';
      end;
      if (page > 1) or (kol > 0) then begin
        all:=all+ Format('<center><hr><p>', [page_width div 3, page_width div 3]);
        if (page>1) or (kol > 0) then
          all:=all+format('<a href="%s,%d">%s</a>   ', [s, 0, GetLangStr(1330)]);
        if page>1 then
          all:=all+format('<a href="%s,%d">%s</a>   ', [s, page-1, GetLangStr(1328)]);
        for i:=1 to page do begin
          if page=i then
            all:=all+format(' <b class="search-active">%d</b> ', [i])
          else
            all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
        end;
        for i:=(page+1) to (page+kol) do
          all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
        if kol>0 then
          all:=all+format('   <a href="%s,%d">%s</a> ', [s, page+1, GetLangStr(1329)]);
        all:=all+'</p></center>';
      end;


      all:=person_top+all;
      Result := all;
    finally
      CodesList.Free();
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

(*counts how many movies/persons would fit the previous pages (before the current page),
or how many pages would be needed for the given number of movies/persons
(after the current page)
returns the number of movies that would fit the given number of pages
saves the number of processed records to the ProcessedRecords global variable
saves the number of counted pages to the CountedPages global variable *)
function CountItemsForPages(page_width, prev_page, RecordCount, i, lines, ItemHeight, StandardWidth: Integer): Integer;
var
	page_width_copy, j, PicWidth, TotalItems, total_pages, PicHeight, lines_copy: Integer;
  ItemCode: string;
  CodesList: TStringList;
begin
	page_width_copy := page_width;
	lines_copy := lines;
	j := 0;
	TotalItems := 0;
	total_pages := 0;
  CodesList := TStringList.Create();
  try
    CodesList.Sorted := True;
    while (i<RecordCount) and (prev_page > 1) do
    begin
      ItemCode := GetStringField('code');
      //disregard duplicate items
      if (CodesList.IndexOf(ItemCode) < 0) then
      begin
        CodesList.Add(ItemCode);
        //check the width of every item
        PicHeight := ItemHeight;
        PicWidth := StandardWidth + NormalImageBorders;
        page_width_copy := page_width_copy - PicWidth;
        //if it still fits the page, count it
        if (page_width_copy >= 0) then begin
          j := j + 1;
        end
        //if the item doesn't fit the page anymore, remember how many items fit the page
        else if lines_copy > 1 then begin
          //proceed to the next line
          page_width_copy := page_width - PicWidth;
          TotalItems := TotalItems + j;
          //the current record goes to the next line
          j := 1;
          lines_copy := lines_copy - 1;
        end
        //next page
        else begin
          lines_copy := lines;
          TotalItems := TotalItems + j;
          total_pages := total_pages + 1;
          prev_page := prev_page - 1;
          page_width_copy := page_width - PicWidth;
          //if prev_page <= 1, the loop will be broken, and the record
          //will go to the current page (j := 0), otherwise the record will
          //go to another previous page (j := 1)
          if (prev_page > 1) then
            j := 1
          else
            j := 0;
        end;
      end
      else begin
        GetNextRecord;
        i := i + 1;
      end;
    end;
    if j > 0 then begin
      total_pages := total_pages + 1;
      TotalItems := TotalItems + j;
    end;
    //a global variable is used to return the second result
    ProcessedRecords := i;
    //a global variable is used to return the third result
    CountedPages := total_pages;
    Result := TotalItems;
  finally
    CodesList.Free();
  end;
end;


procedure GenerateSQLForMoviesPages(ASQL: TStringList; AProgramType: Integer;

  AMode: Integer; AMaxRecordsCount: Integer = -1);

var
  I: Integer;
  mc_rating: string;
  RatingIndex: Integer;
  current_site: string;
  ShowLastUpdated: integer;
  kinopoisk_rating: string;
  IndexByFieldsName: string;
  OrderByFieldsName: string;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
  try
    ShowLastUpdated := RegReadInteger('ShowLastUpdated', 0);
    RatingIndex := RegReadInteger('MyRatingTabRating', 2);
    if RatingIndex = 2 then
      current_site := GetMovieCurrentScript(AProgramType);
    //Get movies
    IndexByFieldsName := 'ind_movies_rating_date_add_desc';
    OrderByFieldsName := 'rating desc, date_add desc';
    if ((RatingIndex = 3) or
        ((RatingIndex = 2) and
         (current_site = 'imdb'))) then
    begin
      IndexByFieldsName := 'ind_movies_imdb_rating_date_add_desc';
      OrderByFieldsName := 'imdb_rating desc, date_add desc';
    end;
    kinopoisk_rating := ', (select Rating from movies_codes where movie =movies.code and script=''kinopoisk'' LIMIT 1) as KinopoiskRating';
    mc_rating := '';
    if ((RatingIndex = 2) and
        (current_site <> 'imdb')) then
    begin
      IndexByFieldsName := '';
      OrderByFieldsName := 'SiteRating desc, rating desc, date_add desc';
      mc_rating := Format(', (select Rating from movies_codes where movie=movies.code and script=''%s'' LIMIT 1) as SiteRating', [current_site]);
    end;
    if (AMode = 5) then
    begin
      OrderByFieldsName := 'title_sort, year';
      IndexByFieldsName := '';
    end
    else if (AMode <> 3) then
    begin
      OrderByFieldsName := 'date_update desc';
      IndexByFieldsName := 'ind_movies_date_update_desc';
      if ((AMode <> 2) and
          (ShowLastUpdated = 0)) then
      begin
        OrderByFieldsName := 'date_add desc';
        IndexByFieldsName := 'ind_movies_date_add_desc';
      end;
    end;
    with ASQL do
    begin
      Clear;
      Add('SELECT *,');
      Add('substr(ImageInfo, 1, 1) as mode,');
      Add('substr(ImageInfo, 3, length(ImageInfo) - 2) as path');
      Add('FROM (');
      Add('select code, title, title_sort, year, imdb_rating, date_add, item_type, date_update, rating');
      if (AProgramType = MOVIENIZER_PROGRAM) then
        Add(kinopoisk_rating);
      Add(mc_rating);
      Add(', (SELECT mode || '';'' || path FROM images iim');
      Add('WHERE iim.movie = movies.code');
      Add('AND iim.mode = 1');
      Add('AND IFNULL(iim.sort_order, 0) = (select IFNULL(Min(Sort_order), 0) from images where movie = iim.movie and mode = 1)) as ImageInfo');
      Add('FROM movies');
      if (IndexByFieldsName <> '') then
        Add('INDEXED BY ' + IndexByFieldsName);
      Add('WHERE in_collection=1');
      Add('AND item_type = ' + IntToStr(AProgramType));
      case AMode of
        4: Add('AND seen<>1');
      end;
      if (RegReadInteger('ShowDummyCoversNew', 1) = 0) then
        Add('AND ImageInfo is not NULL');

      if (OrderByFieldsName <> '') then
        Add('ORDER BY ' + OrderByFieldsName);
      if (AMaxRecordsCount > 0) then
        Add('LIMIT ' + IntToStr(AMaxRecordsCount));
      Add(') as MoviesSubQuery');
      if (OrderByFieldsName = '') then
        OrderByFieldsName := 'Code'
      else
        OrderByFieldsName := OrderByFieldsName + ', Code';
      if (OrderByFieldsName <> '') then
        Add('ORDER BY ' + OrderByFieldsName);
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

procedure GenerateSQLForPersonPages(ASQL: TStringList; AMode: Integer;
  AMaxRecordsCount: Integer = -1);
var
  I: Integer;
  AdditionalSQL: string;
  OrderByFieldsName: string;
  DateDay: Integer;
  DateYear: Integer;
  DateMonth: Integer;
  ShowLastUpdated: integer;
  PersonsProgramTypesSQL: string;
begin
  OrderByFieldsName := '';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
  try
    ShowLastUpdated := RegReadInteger('ShowLastUpdated', 0);
    //Get persons
    with ASQL do
    begin
      Clear;
      Add('SELECT *,');
      Add('substr(ImageInfo, 1, 1) as mode,');
      Add('substr(ImageInfo, 3, length(ImageInfo) - 2) as path');
      Add('FROM (');
      Add('select code, name, date_add, date_update, rating, item_type, birth_date, death_date, ');
      Add('(SELECT mode || '';'' || path FROM images iim');
      Add('WHERE iim.person = persons.code');
      Add('AND iim.mode = 6');
      Add('AND IFNULL(iim.sort_order, 0) = (select IFNULL(Min(Sort_order), 0) from images where person = iim.person and mode = 6)) as ImageInfo');
      Add('from persons');
      AdditionalSQL := '';
      case AMode of
        2:
        begin
          OrderByFieldsName := 'date_update desc';
          Add('INDEXED BY ind_persons_date_update_desc');
        end;
        3:
        begin
          OrderByFieldsName := 'rating desc, date_add desc';
          Add('INDEXED BY ind_persons_rating_date_add_desc');
        end;
        4: AdditionalSQL := 'AND birth_date like ''%' + Format('%s', [GetTodaysDate]) + '%''';
        else
        begin
          if ShowLastUpdated = 0 then
          begin
            OrderByFieldsName := 'date_add desc';
            Add('INDEXED BY ind_persons_date_add_desc');
          end
          else
          begin
            OrderByFieldsName := 'date_update desc';
            Add('INDEXED BY ind_persons_date_update_desc');
          end;
        end;
      end;
      Add('WHERE in_collection=1');
      Add(AdditionalSQL);
      // generate SQL for select persons with or without covers

      PersonsProgramTypesSQL := '';
      // I is Program Type
      for I := LOW_PROGRAM_TYPE to HIGH_PROGRAM_TYPE do
      begin
        if (IsProgramUsed(I)) then
        begin
          SetRegistrySubKey(REGISTRY_SUB_KEYS[I]);
          try
            if (PersonsProgramTypesSQL <> '') then
              PersonsProgramTypesSQL := PersonsProgramTypesSQL + ' OR ';
            PersonsProgramTypesSQL := PersonsProgramTypesSQL + '((item_type = ' + IntToStr(I) + ') ';
            if (not RegReadBoolean('ShowPersonDummyCoversNew', True)) then
              PersonsProgramTypesSQL := PersonsProgramTypesSQL + 'AND (ImageInfo IS NOT NULL)';
            PersonsProgramTypesSQL := PersonsProgramTypesSQL + ')';
          finally
            ResetRegistrySubKey();
          end;
        end;
      end;
      if (PersonsProgramTypesSQL <> '') then
        Add(Format('AND (%s)', [PersonsProgramTypesSQL]));

      if (OrderByFieldsName <> '') then
        Add('ORDER BY ' + OrderByFieldsName);
      if (AMaxRecordsCount > 0) then
        Add('LIMIT ' + IntToStr(AMaxRecordsCount));
      Add(') as PersonsSubQuery');
      if (OrderByFieldsName = '') then
        OrderByFieldsName := 'Code'
      else
        OrderByFieldsName := OrderByFieldsName + ', Code';
      Add('ORDER BY ' + OrderByFieldsName);
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

begin

end.
