﻿program breeze_program_part12;

uses 'breeze_program_variables.pas', 'breeze_program_global.pas';

function GetThumbnailGame(code, mode: integer; title, year: string; InCollection, rating: integer;
  AFullDescription: string = ''; ASearchDescription: string = ''): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img: string;
  fl, showCoversInList, FullList, ThisChecked, ShowCurrent, ShowDiscNr: boolean;
  i, j, kol, dir, amount, RecordCount, ThumbWidth: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
	BigOpen, BigClose, SmallOpen, SmallClose: string;
	kinopoisk_rating, imdb_rating, current_rating, current_site, disc_number: String;
	imdb_rating_number, kinopoisk_rating_number, current_rating_number: double;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[GAMENIZER_PROGRAM]);
  try
    sl:=TStringList.Create;
    amount:=mode;
    s:='';
    ThumbWidth := RegReadInteger('ListCoverWidth', DefaultThumbWidth);
    ThumbsPath:=ImagesPath+Thumbs +'\';
    i := RegReadInteger('ShowCoversInList', 1);
    if i = 1 then
      showCoversInList := True
    else
      showCoversInList := False;
    i := RegReadInteger('MinimaList', 0);
    if i = 1 then
      FullList := False
    else
      FullList := True;
    if (RegReadInteger('ShowDiscNrInList', 0) = 1) then
      ShowDiscNr := True
    else
      ShowDiscNr := False;
      fl:=false;
      genres:='';
      directors:='';
      actors:='';
    ThisChecked := False;
    imdb_rating := '';
    kinopoisk_rating := '';
    current_rating := '';
    current_site := '';
    imdb_rating_number := 0;
    kinopoisk_rating_number := 0;
    current_rating_number := 0;
    disc_number := '';

    if RegReadInteger('ShowCurrentRatingInList', 1) = 1 then
      ShowCurrent := True
    else
      ShowCurrent := False;

    if GroupOperation then
      ThisChecked := IsMovieChecked(code);

      // Fade 16.08.2011 - For Search Thumbs do not add CheckBox picture
      if ((mode <> 7) and (GroupOperation) and (mode <> 5)) then begin

        if ThisChecked then
          CheckMode:=format('<a href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
        CheckMode := '<div id="group_overlay_image">' + CheckMode + '</div>';
      end
      else
        CheckMode:='';

      //получаем дополнительную информацию о фильме, если он из коллекции
      if (InCollection=1) then begin
      if showCoversInList then begin
        //обложка
        with sl do begin
          Clear;
          Add('select path from images');
          Add(format('where movie=%d and mode=1', [code]));
          Add('order by sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          FileIn:=ImagesPath+GetStringField('path');
          FileName:=ThumbsPath+GetStringField('path');

          if MyFileExists(FileIn) then begin
            if not MyFileExists(FileName) then begin
              ConvertThumb3(FileIn, FileName, Thumbs, ThumbWidth, 0, false);
            end;
            if not MyFileExists(FileName) then
              FileName:=FileIn;
          end
          else
            FileName:=FileIn;
          if MyFileExists(FileName) then
            fl:=true;
        end;
        if not fl then begin
          FileName:=ImgPath + NO_COVER_FILE[GAMENIZER_PROGRAM];
          fl:=true;
        end;
      end
      else
        FileName := '';

      //current site rating
      if ShowCurrent then
      begin
        current_site := GetMovieCurrentScript(GAMENIZER_PROGRAM);
        if (current_site <> '') and (current_site <> 'kinopoisk') and (current_site <> 'imdb') then begin
          with sl do begin
            Clear;
            Add('select rating from movies_codes');
            Add(format('where movie=%d and script=''%s''', [code, current_site]));
          end;
          RecordCount := ExecuteSQL(sl.text);
          if RecordCount > 0 then begin
            current_rating_number := GetFloatField('rating');
            if current_rating_number > 0 then
              current_rating := '<NOBR>' + current_site + ': ' + FloatToStr(current_rating_number) + '</NOBR>; ';
          end;
        end;
      end;

      //imdb rating
      if (RegReadInteger('ShowIMDBRatingInList', 0) = 1) or ((current_site = 'imdb') and ShowCurrent) then begin
        with sl do begin
          Clear;
          Add('select imdb_rating from movies');
          Add(format('where code=%d', [code]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          imdb_rating_number := GetFloatField('imdb_rating');
          if (imdb_rating_number > 0) then
            imdb_rating := Format('<NOBR><img align="absmiddle" src="%simdb-ico.png"> ', [PicturesPath]) + FloatToStr(imdb_rating_number) + '</NOBR>; ';
        end;
      end;

      //kinopoisk rating
      if (RegReadInteger('ShowKinopoiskRatingInList', 1) = 1) or ((current_site = 'kinopoisk') and ShowCurrent) then begin
        with sl do begin
          Clear;
          Add('select rating from movies_codes');
          Add(format('where movie=%d and script=''kinopoisk''', [code]));
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          kinopoisk_rating_number := GetFloatField('rating');
          if (kinopoisk_rating_number > 0) then
            kinopoisk_rating := Format('<NOBR><img align="absmiddle" src="%skinopoisk-ico.png"> ', [PicturesPath]) + Format('%.1f', [kinopoisk_rating_number]) + '</NOBR>; ';
        end;
      end;

      //disc number (only first edition)
      if ShowDiscNr then begin
        with sl do begin
          Clear;
          Add('select disc_nom from editions');
          Add(format('where movie=%d', [code]));
          Add('order by sort_order');
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          s := GetStringField('disc_nom');
          if (s <> '') and (s <> '0') then
            disc_number := Format('<NOBR>%s: %s</NOBR>', [GetLangStr(35037), s]);
        end;
      end;

        if amount>0 then begin
        //жанры
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=8', [code]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        for j:=1 to RecordCount do begin
          genres:=genres+format('<a href="genre:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        if genres<>'' then
          genres:=copy(genres, 1, length(genres)-2);

        //режиссеры и актеры
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection, d.mode from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode in (1,3)', [code]));
          //Add('and d.sort_order<10');//27.07.07
          Add('order by d.mode, d.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        i:=0;
        j:=0;
        dir:=0;
        while (i<RecordCount) and (j<amount) do begin
          s := GetStringField('p.name');
          if GetIntegerField('p.in_collection')=1 then begin
            img:=format('<NOBR><img src="%sperson.gif" align="absmiddle" border="0" style="margin-right: 2px;">', [ImgPath]);
            s := ReplaceStr(s, ' ', '</NOBR> ');
          end
          else
            img:='';
          if GetIntegerField('d.mode')=1 then begin
            if dir<=3 then begin
              directors:=directors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), s]);
              dir:=dir+1;
            end;
          end
          else begin
            actors:=actors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), s, j]);
            j:=j+1;
          end;
          i:=i+1;
          GetNextRecord;
        end;
      end;
      if directors<>'' then
        directors:=copy(directors, 1, length(directors)-2);

      if actors<>'' then
        actors:=copy(actors, 1, length(actors)-2);

      if year<>'' then
        year:=format(' (%s)', [year]);

      if rating>0 then
        rate:=format(' <NOBR><img src="%sstar-transp.gif" width="17" height="16" border="0" align="absmiddle">%d</NOBR>', [ImgPath, rating])
      else
        rate:='';

      s := '<div style="background-color: white; padding: 5px; margin: 3; border: 1px solid ' + WhiteAreaBorderColor + '; font-size: ' + IntToStr(ListFontSize) + 'pt;">';
      if showCoversInList then
      begin
        s:= s + '<div style="float: left; margin: 0 5 5 0;">' + CheckMode +
          '<a class="pic" ' + format('href="movie:%d"><img border="0" style="width: %dpx;" src="%s"', [code, ThumbWidth, FileName]);
        if not GetCutePreview and (mode<>7) then
          s:=s+' width="50" align="left"';
        s:=s+'></a></div>';
      end;
      s := s+format('<a href="movie:%d"><big><b>%s</b></big></a>%s%s<br>', [code, title, year, rate]);



      //site ratings
      if FullList and ((imdb_rating <> '') or (kinopoisk_rating <> '') or (current_rating <> '')) then begin
        s := s + current_rating + imdb_rating + kinopoisk_rating;
        s := copy(s, 1, length(s)-2) + '<br>';
      end;

      //disc number
      if (disc_number <> '') and FullList then
        s := s + disc_number + '<br>';

      //Genres
      if (genres<>'') and FullList then begin
        if mode<>1 then
          genres:=GetLangStr(179)+': '+genres;
        s:=s+genres+'<br>';
      end;
      //Directors
      if FullList and (mode<>1) and (directors<>'') then
        s:=s+GetLangStr(35025)+': '+directors+'<br>';
      //Actors
      if FullList and (actors<>'') then begin
        if mode<>1 then
          actors:=GetLangStr(35012)+': '+actors;
        s:=s+actors+'<br>';
      end;
      s := s+SmallClose;
      end
      else begin
      s := '<div style="background-color: white; padding: 5px; margin: 3; border: 1px solid ' + WhiteAreaBorderColor + '; font-size: ' + IntToStr(ListFontSize) + 'pt;">';
      if year<>'' then
        year:=format(' (%s)', [year]);
      s:=s+format('<a href="movie:%d"><b>%s</b>%s</a>', [code, title, year]);
      end;

        //14.03.13
    s := s + GenerateHTMLForDescriptionSearching(AFullDescription, ASearchDescription);
    s := s+'</div>';
    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetThumbnailGameExtended(code, mode: integer; title: string): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img: string;
  fl, CutThumb: boolean;
  i, j, kol, dir, amount, RecordCount, CoverWidth, CoverHeight: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
  ProgramType: Integer;
begin
	result:='';
  ProgramType := GAMENIZER_PROGRAM;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    sl:=TStringList.Create;
    amount:=mode;
    s:='';

    ThumbsPath:=ImagesPath+Thumbs2+'\';

    fl:=false;
    genres:='';
    directors:='';
    actors:='';


      //обложка
      with sl do begin
        Clear;
        Add('select * from images');
        Add(format('where movie=%d and mode=1', [code]));
        Add('order by sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);

      CoverWidth := RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[ProgramType]);
      CoverHeight := RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[ProgramType]);

      if (CoverWidth <= 0) and (CoverHeight <= 0) then begin
        CoverWidth := DefaultMultiCoverWidth[ProgramType];
        CoverHeight := DefaultMultiCoverHeight[ProgramType];
      end;

      if RecordCount>0 then
      begin
        i := RegReadInteger('CutThumb', 1);
        if i = 1 then
          CutThumb := True
        else
          CutThumb := False;
        FileIn:=ImagesPath+GetStringField('path');
        FileName:=ThumbsPath+GetStringField('path');
        if MyFileExists(FileName) then
          fl:=true
        else if MyFileExists(FileIn) then
          ConvertThumb3(FileIn, FileName, Thumbs2, CoverWidth, CoverHeight, CutThumb);
        if MyFileExists(FileName) then
          fl:=true;
      end;
      if not fl then
      begin
        FileIn:=ImgPath + NO_COVER_FILE[GAMENIZER_PROGRAM];
        FileName:=ThumbsPath + NO_COVER_FILE[GAMENIZER_PROGRAM];
        //ShowMessage('FileName='+FileName);
        //ShowMessage('FileIn='+FileIn);
        if ((not MyFileExists(FileName)) and
            (MyFileExists(FileIn))) then
        begin
          ConvertThumb3(FileIn, FileName, Thumbs2, CoverWidth, CoverHeight, CutThumb);
        end;
        fl:=true;
      end;

      if GroupOperation then
      begin
        if (IsMovieChecked(code)) then
          CheckMode:=format('<div><a class="pic" href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" position="absolute" border="0"></a></div>',  [code, PicturesPath])
        else
          CheckMode:=format('<div><a class="pic" href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" position="absolute" border="0"></a></div>',  [code, PicturesPath]);
        CheckMode := '<div id="group_overlay_image_multi">' + CheckMode + '</div>';
      end
      else
        CheckMode:='';

      s:='<div style="height: 100%; background-color: white; padding: 5px; margin: 5 5 0 5; border: 1px solid ' + WhiteAreaBorderColor + '; font-size: ' + IntToStr(ListFontSize) + 'pt;"><div style="float: left; margin: 0 5 5 0;">' +
        CheckMode + '<a class="pic" href="movie:' + format('%d"><img src="%s" border="0">', [code, FileName])+'</a></div><div style="clear:both"></div><div>'+format('<a href="movie:%d"><b>%s', [code, title]) + '</b></a></div></div>';


    if mode=7 then
      s:='<tr><td>'+s+'</td></tr>';

    //if amount=3 then
      //s:='<div class="preview">'+s+'</div>';
    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;


function GetGameTabs(MovieCode, SeasonNr, SeasonCnt: Integer; Awards, Shots, Params, Posters, Trailers, Desc, Connections: Boolean; AdditionalSpace: Integer = 0): String;
var
	s, media_format, prev_media_format, prefix: String;
	i, k, my_tabs, PageWidth, SeasonTabs, PageTabs, RecordCount, MyIconSpace: Integer;
	sl: TStringList;
begin
	RemainingTabs := '';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[GAMENIZER_PROGRAM]);
  try
    MyIconSpace := IconSpace;
    if (RegReadInteger('ShowSeenStatusIcon', 1) = 0) then
      MyIconSpace := MyIconSpace - IconSpace div 4;
    if (RegReadInteger('ShowInCollectionStatusIcon', 1) = 0) then
      MyIconSpace := MyIconSpace - IconSpace div 4;
    if (RegReadInteger('ShowWantedStatusIcon', 0) = 0) then
      MyIconSpace := MyIconSpace - IconSpace div 4;
    if (RegReadInteger('ShowForSaleStatusIcon', 0) = 0) then
      MyIconSpace := MyIconSpace - IconSpace div 4;
    PageWidth := GetHTMLWidth - LeftColumnWidth - MyIconSpace;
    SeasonTabs := PageWidth div SeasonTabWidth;
    PageTabs := PageWidth div TabWidth;
    s := '';

    s := '<div style="margin-left: 200px; color: white; vertical-align: bottom; font-weight: bold; line-height: 46px;">';

    //general info tab
    s := s + GetTab(ActiveTab = 1, GetLangStr(161), Format('userref:%d,%d', [3109, MovieCode]), True);
    PageTabs := PageTabs - 1;

    //screenshots
    if (Shots) and (RegReadInteger('ShowShotTab', 1) = 1) then begin
      if (PageTabs > 0) then begin
        PageTabs := PageTabs - 1;
        s := s + GetTab(ActiveTab = 2, GetLangStr(35278), Format('userref:%d,%d', [3110, MovieCode]));
      end
      else
        RemainingTabs := RemainingTabs + GetTextTab(ActiveTab = 2, GetLangStr(35278), Format('userref:%d,%d', [3110, MovieCode]));
    end;
    //posters
    if (Posters) and (RegReadInteger('ShowPosterTab', 1) = 1) then begin
      if (PageTabs > 0) then begin
        PageTabs := PageTabs - 1;
        s := s + GetTab(ActiveTab = 7, GetLangStr(1425), Format('userref:%d,%d', [3115, MovieCode]));
      end
      else
        RemainingTabs := RemainingTabs + GetTextTab(ActiveTab = 7, GetLangStr(1425), Format('userref:%d,%d', [3115, MovieCode]));
    end;
    //trailers
    if (Trailers) and (RegReadInteger('ShowTrailerTab', 1) = 1) then begin
      if (PageTabs > 0) then begin
        PageTabs := PageTabs - 1;
        s := s + GetTab(ActiveTab = 9, GetLangStr(1458), Format('userref:%d,%d', [3117, MovieCode]));
      end
      else
        RemainingTabs := RemainingTabs + GetTextTab(ActiveTab = 9, GetLangStr(1458), Format('userref:%d,%d', [3117, MovieCode]));
    end;

    //awards
    if (Awards) and (RegReadInteger('ShowAwardsTab', 1) = 1) then begin
      if PageTabs > 0 then begin
        PageTabs := PageTabs - 1;
        s := s + GetTab(ActiveTab = 3, GetLangStr(574), Format('userref:%d,%d', [3111, MovieCode]));
      end
      else
        RemainingTabs := RemainingTabs + GetTextTab(ActiveTab = 3, GetLangStr(574), Format('userref:%d,%d', [3111, MovieCode]));
    end;

    //description
    if (Desc) and (RegReadInteger('ShowDescriptionTab', 1) = 1) then begin
      if PageTabs > 0 then begin
        PageTabs := PageTabs - 1;
        s := s + GetTab(ActiveTab = 10, GetLangStr(162), Format('userref:%d,%d', [3118, MovieCode]));
      end
      else
        RemainingTabs := RemainingTabs + GetTextTab(ActiveTab = 10, GetLangStr(162), Format('userref:%d,%d', [3118, MovieCode]));
    end;

    s := s + '</div>';
    if RemainingTabs <> '' then
      RemainingTabs := RemainingTabs + ' |';
    Result := s;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetGamePage(MovieCode, season: integer; FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
var
  sl, TempList, SeenList, UnseenList: TStringList;
  duration, i, j, k, l, kol, rmax, RecordCount: integer;
  all, s, s2, s3, country, description, comment, genre, year, director, writer, composer, actor, character, down, salary, awards, studios: string;
  rating: integer;
  IMDBRating, SiteRating, EditionCost: double;
  FileName, img, OriginalTitle, site, url, ShortFilename: string;
  flCollection, flSeen, flWanted, flForSale, LastCode: integer;
  collection, seen, wanted, sale, rate, mpaa, mpaa_desc, disc_nom: string;
  VideoStandard, ScreenRatio, resolution, mpaa_code, VideoBitrate, VideoCodec, filesize, GameLanguage: integer;
  DiscLabel: integer;
  custom: array[1..6] of integer;
  cust: string;
  DateAdd, DateUpdate, DateSeen, loan_date, return_date: string;
  age, border, bckgrnd: string;
  editions: array [1..1000] of integer;
  EditionsCount, EditionCode, MediaFormat, ie: integer;
  ed, temp, barcode, OtherRating, EditionFeatures, EditionComment, VideoFileFolder, VideoFileName, TagLine: string;
  PrevBlockCnt, ThisBlockCnt, ShotCnt, MaxShots, hours, minutes, PosterCnt, ConnectionsCnt: Integer;
  page_width, PicWidth, PicHeight, TrailerCnt, AdditionalSpace, ScreenshotTotalHeight, page_width_rest, page_width_copy, MediaType, PrevPicWidth, this_width, this_height, this_season: Integer;
  NoTrailerAdded, ShowScreenshots, fl, FixedContentsWidth: Boolean;
  trunc_name, trunc_character, media_format, prev_media_format: String;
  OldLinkStatus, MovieSeries, MovieSeriesNumber: Integer;
  LinkYearStr, LinkMovieStr, LinkMovieStatusTitle, FullAwardsText, name, status, ends_with, temp_name, new_name: string;
  IsEpisodeCorrect: Boolean;
begin
	result:='';
	sl:=TStringList.Create;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[GAMENIZER_PROGRAM]);
  try
    all:='';
    OtherRating := '';

    if (RegReadInteger('FixedContentsWidthOnMoviePage', 0) = 1) then
      FixedContentsWidth := True
    else
      FixedContentsWidth := False;

    bckgrnd := ' style="background-image: url(' + GetProperPath(ImgPath + 'list-background.gif') + ');"';
    with sl do begin
      Clear;
      Add('select code from images');
      Add(format('where movie=%d and mode in (3, 5, 7)', [MovieCode]));
      Add('order by sort_order');
    end;
    ShotCnt:=ExecuteSQL(sl.text);

    with sl do begin
      Clear;
      Add('select count(code) as amount from movies_codes');
      Add(format('where movie=%d and script=''trailer''', [MovieCode]));
    end;
    RecordCount:=ExecuteSQL(sl.text);
    TrailerCnt := GetIntegerField('amount');
    // count movie connections
    with sl do begin
      Clear;
      Add('select count(code) as amount from movies_links');
      Add(Format('where movie_primary=%d', [MovieCode]));
    end;
    RecordCount := ExecuteSQL(sl.text);
    ConnectionsCnt := GetIntegerField('amount');


      with sl do begin
          Clear;
          Add('select * from movies');
          Add(format('where code=%d', [MovieCode]));
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount=0 then
          exit;
      s:='movie:'+IntToStr(MovieCode);
      movie:=GetStringField('title');

      OriginalTitle:=GetStringField('original_title');
      rating:=GetIntegerField('rating');
      IMDBRating:=GetFloatField('imdb_rating');

    flCollection:=GetIntegerField('in_collection');
    flSeen:=GetIntegerField('seen');
    flWanted:=GetIntegerField('wanted');
    flForSale:=GetIntegerField('for_sale');
    mpaa_code:=GetIntegerField('mpaa');
    mpaa_desc:=GetStringField('mpaa_rating');
    MediaType := GetIntegerField('media_type');

    DateAdd:=GetStringField('date_add');
    DateUpdate:=GetStringField('date_update');
    DateSeen:=GetStringField('date_seen');
    TagLine := GetStringField('tagline');
    MovieSeriesNumber := GetIntegerField('series_nom');
    MovieSeries := GetIntegerField('series');

    if (ConnectionsCnt <= 0) and (MovieSeries > 0) then
      ConnectionsCnt := 1;

      //GoForward(s, GetStringField('m.title'), ChangeHistory);

      description:=GetStringField('description');
      salary:=GetStringField('salary');
      awards:=GetStringField('awards');
    FullAwardsText := awards;
    comment:=GetStringField('comment');

    custom[1]:=GetIntegerField('custom1');
    custom[2]:=GetIntegerField('custom2');
    custom[3]:=GetIntegerField('custom3');
    custom[4]:=GetIntegerField('custom4');

      if GetStringField('duration')='' then
          duration:=0
      else
          duration:=GetIntegerField('duration');
      year:=GetStringField('year');

      disc_nom:=GetStringField('disc_nom');

    collection := '';
      if (flCollection=0) then begin
      s2 := GetLangStr(35013);
      i := Pos('"', s2);
      while i > 0 do begin
        delete(s2, i, 1);
        i := Pos('"', s2);
      end;
      if (RegReadInteger('ShowInCollectionStatusIcon', 1) = 1) then
        collection:=format('<a class="pic" href="collection:%d"><img class="icons" src="%snot-in-collection.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, s2]);
    end
      else begin
      s2 := GetLangStr(35014);
      i := Pos('"', s2);
      while i > 0 do begin
        delete(s2, i, 1);
        i := Pos('"', s2);
      end;
        collection:=format('<a class="pic" href="collection:%d"><img class="icons" src="%sin-collection.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, s2]);
    end;

    seen := '';
      if (flSeen=0) then begin
      s2 := GetLangStr(35016);
      i := Pos('"', s2);
      while i > 0 do begin
        delete(s2, i, 1);
        i := Pos('"', s2);
      end;
      if (RegReadInteger('ShowSeenStatusIcon', 1) = 1) then
        seen:=format('<a class="pic" href="seen:%d"><img class="icons" src="%snot-seen.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, s2]);
    end
      else begin
      s2 := GetLangStr(35015);
      i := Pos('"', s2);
      while i > 0 do begin
        delete(s2, i, 1);
        i := Pos('"', s2);
      end;
        seen:=format('<a class="pic" href="seen:%d"><img class="icons" src="%sseen.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, s2]);
    end;

    wanted := '';
      if (flWanted=0) then begin
      s2 := GetLangStr(35018);
      i := Pos('"', s2);
      while i > 0 do begin
        delete(s2, i, 1);
        i := Pos('"', s2);
      end;
      if (RegReadInteger('ShowWantedStatusIcon', 0) = 1) then
        wanted:=format('<a class="pic" href="wanted:%d"><img class="icons" src="%snot-wanted.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, s2]);
    end
      else begin
      s2 := GetLangStr(35017);
      i := Pos('"', s2);
      while i > 0 do begin
        delete(s2, i, 1);
        i := Pos('"', s2);
      end;
        wanted:=format('<a class="pic" href="wanted:%d"><img class="icons" src="%swanted.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, s2]);
    end;
    sale := '';
      if (flForSale=0) then begin
      s2 := GetLangStr(35020);
      i := Pos('"', s2);
      while i > 0 do begin
        delete(s2, i, 1);
        i := Pos('"', s2);
      end;
      if (RegReadInteger('ShowForSaleStatusIcon', 0) = 1) then
        sale:=format('<a class="pic" href="sale:%d"><img class="icons" src="%snot-for-sale.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, s2]);
    end
      else begin
      s2 := GetLangStr(35019);
      i := Pos('"', s2);
      while i > 0 do begin
        delete(s2, i, 1);
        i := Pos('"', s2);
      end;
        sale:=format('<a class="pic" href="sale:%d"><img class="icons" src="%sfor-sale.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, s2]);
    end;

    rate:='';
    for i:=1 to 10 do begin
      if i mod 2=1 then begin
        if i<=rating then
              rate:=rate+format('<a class="pic" href="rating:%d"><img src="%shalfstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
        else
              rate:=rate+format('<a class="pic" href="rating:%d"><img src="%snot-halfstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
      end
      else begin
        if i<=rating then
              rate:=rate+format('<a class="pic" href="rating:%d"><img src="%shalfstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
        else
              rate:=rate+format('<a class="pic" href="rating:%d"><img src="%snot-halfstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
      end;
    end;

    //description
    if description<>'' then
    begin
      if (ActiveTab <> 10) and (not FullDesc) and (length(description)>DescriptionLength) then
      begin
        description:=copy(description, 1, DescriptionLength);
        description:=RemoveUnclosedTags(description);

        description := ReverseString(description);
        try
          i := Pos(' ', description);
          if i>0 then
            delete(description, 1, i);
        finally
          description := ReverseString(description);
          description:=description+format(GetLangStr(566), [MovieCode]);
        end;
      end;
    end;

    if description='' then
      down:='<br>'+format('<a href="DownloadMovie:%d">', [MovieCode])+GetLangStr(324)+'</a>'
    else
      down:='';


    with sl do begin
      Clear;
          Add('select code from images');
          Add(format('where movie=%d and mode=4', [MovieCode]));
          Add('order by sort_order');
      end;
      PosterCnt:=ExecuteSQL(sl.text);

    if (ActiveTab <> 3) and (not FullAwards) and (length(awards)>DescriptionLength) then begin
      awards:=copy(awards, 1, DescriptionLength);
      awards:=RemoveUnclosedTags(awards);
      awards:=awards+format(GetLangStr(1331), [MovieCode]);
    end;

    //Check if the active tab exists
    //no seasons
    if
    //no parameters
    ((ActiveTab = 5) and (EditionsCount = 1) and (VideoFileName = '')) or
    //no awards
    ((ActiveTab = 3) and (awards = '')) or
    //no shots
    ((ActiveTab = 2) and (shotCnt = 0)) or
    //no posters
    ((ActiveTab = 7) and (PosterCnt = 0)) or
    //no trailers
    ((ActiveTab = 9) and (TrailerCnt = 0)) or
    //No connections
    ((ActiveTab = 11) and (ConnectionsCnt = 0)) then begin
      ActiveTab := 1;
      Result := GetGamePage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
      exit;
    end;

    all:=GetPatternTop;
    all:= all + Format('<p class="page-header" style="font-size: %dpt;">', [BasicFontSize + PageHeaderModifier]) + movie;
    if (OriginalTitle <> '') and (OriginalTitle <> movie) then
      all := all + Format(' / <span style="font-size: %dpt;">', [BasicFontSize + SubHeaderModifier])+OriginalTitle+'</span>';
    all:= all + '</p>';

    //tab background
    all := all + '<table class="envelope"><tr><td><div style="margin-left: 10px; margin-right: 10px; height: 46px; background-image: url(' +GetProperPath(ImgPath + 'inactive-tab-button.gif') + ');">';
    //icons
    all := all + '<div class="icon-container">' + collection + seen + wanted + sale + '</div>';
    //tabs
    all := all + GetGameTabs(MovieCode, season, 0, awards<>'', shotCnt>0, (EditionsCount > 1) or (VideoFileName <>''), PosterCnt>0, TrailerCnt>0, description <> '', ConnectionsCnt>0);
    //close tab background
    all := all + '</div></td></tr></table>';

    //shots from the movie
    AdditionalSpace := 0;
    ShowScreenshots := False;
    MaxShots := RegReadInteger('ShotsCnt', 5);
    if (ActiveTab = 1) and (MaxShots > 0) then begin
      showScreenshots := True;
      i := GetHTMLWidth - LeftColumnWidth - ScreenshotWidth;
      if (i < DataArea) then
        showScreenshots := False;
    end;

    ScreenshotTotalHeight := 0;
    if ShowScreenshots then begin
      AdditionalSpace := ScreenshotWidth + NormalImageBorders;
      s := '';
      if (RegReadInteger('ShowCoversOnTheRight', 1) = 1) then
        s := '2';
      if (RegReadInteger('ShowPostersOnTheRight', 0) = 1) then begin
        if s<>'' then
          s := s + ',';
        s := s + '4';
      end;
      if (RegReadInteger('ShowBackdropsOnTheRight', 1) = 1) then begin
        if s<>'' then
          s := s + ',';
        s := s + '7';
      end;
      if (RegReadInteger('ShowShotsOnTheRight', 1) = 1) then begin
        if s<>'' then
          s := s + ',';
        s := s + '3';
      end;
      with sl do begin
        Clear;
        Add('select path, i.code as code, mode, width, height from images i');
        Add('inner join images_modes im on i.mode=im.code');
        Add(format('where movie=%d', [MovieCode]));
        Add(format('and mode in (%s)', [s]));
        Add('order by im.sort_order, i.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      j := 0;
      //if there are other pictures than the main cover, show them according to the settings
      if ((fl or (GetIntegerField('mode') <> 1)) and (RecordCount>0)) or (RecordCount>1) then begin
        all := all + '<div class="shot-space">';
        if RecordCount < MaxShots then
          MaxShots := RecordCount;
        ScreenshotTotalHeight := ScreenshotTotalHeight + ScreenshotPadding div 2;
        for i:=1 to MaxShots do begin
          //skip the main cover
          if (RegReadInteger('OnlyShots', 1) <> 1) and (GetIntegerField('mode') = 1) and (j = 0) then
            j := 1
          else
            if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
              FileName := GetImageFileName(GetStringField('path'), ThumbsScreenshots, '', ScreenshotWidth, 0);
              all:=all+'<div class="shots"><div><a class="pic" '+format('href="ShowImage:%d"><img style="width: %dpx" border="0" src="%s"></a></div></div>', [GetIntegerField('code'), ScreenshotWidth, FileName]);
              ScreenshotTotalHeight := ScreenshotTotalHeight + Round(GetIntegerField('height') * (ScreenshotWidth / GetIntegerField('width'))) + ScreenshotPadding div 2;
            end;
          GetNextRecord;
        end;
        if RecordCount > MaxShots then begin
          all:=all+format('<div class="arrow-down"><a class="pic" href="userref:3110,%d"><img border="0" alt="%s" src="%sarrow-down.gif"></a></div>', [MovieCode, GetLangStr(35021), ImgPath]);
          ScreenshotTotalHeight := ScreenshotTotalHeight + 30; //arrow down height
        end;
        all := all + '</div>';
      end; //if
    end;

    if not (ActiveTab in [2, 6, 7]) then begin
      //pictures
      with sl do begin
        Clear;
        Add('select path, code from images');
        Add(format('where movie=%d and mode=1', [MovieCode]));
        Add('order by sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      all:=all+Format('<div class="cover-space" style="font-size: %dpt;">', [BasicFontSize + BiggerModifier]);
      fl := False;
      if RecordCount>0 then begin
        if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
            FileName := GetImageFileName(GetStringField('path'), ThumbsCovers, '', MainCoverWidth, 0);
          all:=all+'<div style="padding: 3px;"><a class="pic"'+format(' href="ShowImage:%d"><img style="width: %dpx;" border="0" src="%s"></a></div>',
                [GetIntegerField('code'), MainCoverWidth, FileName]);
          fl := True;
          end;
      end;
      if not fl then begin
        FileName:=ImgPath + NO_COVER_FILE[GAMENIZER_PROGRAM];
        if (MyFileExists(FileName)) then
          all:=all+format('<div style="padding: 3px;"><img class="cover-image" border="0" src="%s"></div>', [FileName]);
      end;

      //imdb rating
      if (IMDBRating <> 0) then
        all := all + '<div style="vertical-align: middle; font-weight: bold;"><img src="' + GetProperPath(ImgPath + 'tag-icon.gif') + '"/>&nbsp;' + Format ('IMDB:&nbsp;%0.1f</div>', [IMDBRating]);

      //my rating
      i := RegReadInteger('ShowRating', 1);
      if i=1 then begin
        all := all + '<hr class="line-separator">';
        all := all + '<div style="vertical-align: middle; color: #666666; margin-bottom: 5px;">' + Format('%s:</div>', [GetLangStr(298)]);
        all := all + '<div>' + rate + '</div>';
      end;

      //awards
      if FullAwardsText <> '' then begin
        s2 := '';
        temp := LowerCase(FullAwardsText);
        i := Pos('<br>', temp);
        //remove the general description for awards received from kinopoisk
        s := copy(temp, 1, i-1);
        if (Pos('.', s) > 5) then
          delete(temp, 1, i+3);
        sl.LoadFromFile(PicturesPath + 'awards\awards.txt');
        for i := 0 to sl.Count - 1 do begin
          name := sl.Names[i];
          j := Pos(':', name);
          status := '';
          ends_with := '';
          if j > 0 then begin
            status := LowerCase(copy(name, j+1, length(name)-j));
            delete(name, j, length(name)-j+1);
            j := Pos(':', status);
            if j > 0 then begin
              ends_with := copy(status, j+1, length(status)-j);
              delete(status, j, length(status)-j+1);
            end;
          end;
          j := Pos(LowerCase(name), temp);
          s := '';
          if j > 0 then begin
            k := MyPos(ends_with, temp, j+1);
            if k = 0 then
              k := Length(temp);
            s := copy(temp, j, k-j);
          end;
          if Pos('<br>'+ status, s) > 0 then
            s2 := s2 + '<a class="pic" href="userref:3302,' + name + '"><img border="0" alt="'+ name + '" src="' + PicturesPath + 'awards\' + sl.Values[sl.Names[i]] + '"></a>';
        end;
        if s2 <> '' then
          all := all + '<hr class="line-separator"><div>' + s2 + '</div>';
      end;

      //site links
      with sl do begin
        Clear;
        Add('select distinct mc.code, mc.site, mc.script, mc.rating, p.* from movies_codes mc');
        Add('left outer join partners p on mc.script=p.site');
        Add('AND mc.item_type = p.item_type');
        Add(format('where movie=%d', [MovieCode]));
        Add('order by p.sort_order, mc.script');
      end;
      RecordCount:=ExecuteSQL(sl.text);

      for i:=1 to RecordCount do
      begin
        site:=GetStringField('mc.script');
        url:=GetStringField('mc.site');
        if (site <> 'trailer') and (url <> '') then
        begin
          url := AddPostfixToURL(url, GetStringField('p.postfix'));
          all := all+'<hr class="line-separator"><div>';
          if site='buy' then begin
            if Pos('amazon', url)>0 then
              all:=all+'<a class="pic" alt="Buy at Amazon"  href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%samazon.gif" border="0"></a> ', [PicturesPath])
            else if Pos('ozon', url)> 0 then
              all := all + '<a class="pic" alt="Купить на озоне"  href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%sozon.gif" border="0"></a> ', [PicturesPath])
            else
              all:=all+format(GetLangStr(375), ['http://www.medianizer.com/redirect/'+url, movie])+' ';
          end
          else
          begin
            s:=GetPartnerImageFile(site, GetStringField('p.picture'));
            if s='' then
            all:=all+'<a href="link:http://www.medianizer.com/redirect/'+url+format('">%s</a> ', [site])
            else
              all:=all+'<a class="pic" href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%s%s" border="0"></a> ', [PicturesPath, s]);
          end;
          all := all + '</div>';
          i := RegReadInteger('ShowSiteRating', 1);
          if i=1 then begin
            SiteRating:=GetFloatField('mc.rating');
            if (SiteRating>0) and (site<>'imdb') then
              all := all + format('<div style="font-weight: bold;">%s: %f</div>', [GetLangStr(75),SiteRating]);
          end;
        end;
        GetNextRecord;
      end; //for

      if RegReadInteger('ShowCodecLogos', 1) = 1 then begin
        //media format logo
        with sl do begin
          Clear;
          Add('select m.name, e.filename from editions e');
          Add('left outer join manuals m on m.code=e.media_format');
          Add(format('where e.movie=%d', [MovieCode]));
          Add('order by e.media_format');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        prev_media_format := 'dummy';
        s := '';
        for i:=1 to RecordCount do begin
          media_format := LowerCase(GetStringField('m.name'));
          if (prev_media_format <> media_format) then begin
            if (media_format = 'blu-ray') then begin
              s := s + format('<hr class="line-separator"><div><img alt="Blu-Ray" src="%sbd-logo-medium.gif"></div>', [ImgPath]);
            end;
            if (media_format = 'dvd') then begin
              s := s + format('<hr class="line-separator"><div><img alt="DVD" src="%sdvd-logo-medium.gif"></div>', [ImgPath]);
            end;
            if (media_format = 'hd dvd') then begin
              s := s + format('<hr class="line-separator"><div><img alt="HD DVD" src="%shddvd-logo-medium.gif"></div>', [ImgPath]);
            end;
            if (Pos('mkv', media_format)>0) or
            (Pos('.mkv', LowerCase(GetStringField('e.filename')))>0) then begin
              s := s + format('<hr class="line-separator"><div><img alt="MKV Matroska" src="%smkv-logo-medium.gif"></div>', [ImgPath]);
            end;
            prev_media_format := media_format;
          end;
          GetNextRecord;
        end;
        //video codec logo (divx, xvid)
        with sl do begin
          Clear;
          Add('select m.name from editions e');
          Add('left outer join manuals m on m.code=e.video_codec');
          Add(format('where e.movie=%d', [MovieCode]));
          Add('order by e.video_codec');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        prev_media_format := '';
        for i:=1 to RecordCount do begin
          media_format := LowerCase(GetStringField('m.name'));
          if (media_format <> prev_media_format) then begin
            if (Pos('divx', media_format)>0) then begin
              s := s + format('<hr class="line-separator"><div><img alt="DivX" src="%sdivx-logo-medium.gif"></div>', [ImgPath]);
            end;
            if (Pos('xvid', media_format)>0) then begin
              s := s + format('<hr class="line-separator"><div><img alt="XviD" src="%sxvid-logo-medium.gif"></div>', [ImgPath]);
            end;
            prev_media_format := media_format;
          end;
          GetNextRecord;
        end;
        all := all + s;
      end;

      all := all + '<div class="free-space-bottom" style="background-image: url(' + GetProperPath(ImgPath + 'bottom-shadow.gif') +')"></div></div>';

    end; //if ActiveTab <> 2


    all := all + Format('<div style="font-size: %dpt; line-height: %dpx; text-align: center;">', [BasicFontSize, LineSpace]) + RemainingTabs + '</div>';
    //actors
    if ActiveTab = 4 then begin
      all := all + GetCast(MovieCode);
    end;

    //Shots
    if ActiveTab = 2 then
      all := all + GetShots(MovieCode, 3, 'movie', 7, 5);
    //Posters
    if ActiveTab = 7 then
      all := all + GetShots(MovieCode, 4, 'movie');

    if ActiveTab = 1 then begin
      if FixedContentsWidth then
        all := all + '<table class="envelope"><tr><td>';
      all := all + Format('<table class="names-values" style="font-size: %dpt; line-height: %dpx;">', [BasicFontSize + BiggerModifier, LineSpace]);
      ThisBlockCnt := 0;
      //Tagline
      if TagLine <> '' then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        all := all + '<tr><td class="small-table-name"' + border + Format('>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"', [GetLangStr(3406)])+ border + '>"' + TagLine + '"</td></tr>';
      end;

      //sequence
      with sl do begin
        Clear;
        Add('select m.code, m.name, mov.series_nom from movies mov');
        Add('join manuals m on m.code=mov.series');
        Add(format('where mov.code=%d', [MovieCode]));
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        all := all + '<tr><td class="small-table-name"' + border + Format('>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"', [GetLangStr(20271)])+ border + '>';
        all := all + Format('<a href="sequence:%d">%s</a>', [GetIntegerField('m.code'), GetStringField('m.name')]);
        if (GetIntegerField('mov.series_nom') > 0) then
          all := all + Format(' %s%d', [GetLangStr(529), GetIntegerField('mov.series_nom')]);
        all:=all+'</td></tr>';
      end;

      //media type
      if MediaType > 0 then begin
        with sl do begin
          Clear;
          Add('select * from manuals');
          Add(Format('where code=%d', [MediaType]));
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          ThisBlockCnt := ThisBlockCnt + 1;
          if (ThisBlockCnt mod 2 = 1) then
            border := bckgrnd
          else
            border := '';
          all := all + Format('<tr><td class="small-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"%s>', [border, GetLangStr(35234), border]);
          all := all + Format('<a href="media_type:%d">%s</a></td></tr>', [GetIntegerField('code'), GetStringField('name')]);
        end;
      end;

      //genres
      with sl do begin
        Clear;
        Add('select m.code, m.name from movies_manuals mm');
        Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference надо ли???
        Add(format('where mm.movie=%d and m.reference=8', [MovieCode]));
        Add('order by m.name');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        //'Genres: '
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        all:=all + '<tr><td class="small-table-name"' + border + Format('>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"', [GetLangStr(72)])+ border + '>';
        for i:=1 to RecordCount do begin
          if i>1 then
            all := all + ' / ';
          all:=all+format('<a href="genre:%d">%s</a>', [GetIntegerField('m.code'), GetStringField('m.name')]);
        GetNextRecord;
        end;
        all:=all+'</td></tr>';
      end;

      //year
      if year<>'' then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        all:=all+format('<tr><td class="small-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"%s><a href="year:%s,%d">%s</a></td></tr>',
          [border, GetLangStr(169), border, year, GAMENIZER_PROGRAM, year]);
      end;

      //countries
      with sl do begin
        Clear;
        Add('select m.code, m.name from movies_manuals mm');
        Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference надо ли???
        Add(format('where mm.movie=%d and m.reference=9', [MovieCode]));
        Add('order by m.name');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        //'Countries: '
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        all := all + Format('<tr><td class="small-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"%s>', [border, GetLangStr(35022), border]);
        country := '';
        for i:=1 to RecordCount do begin
          country:=country+format('<a href="country:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        country:=copy(country, 1, length(country)-3);
        all:=all + country + '</td></tr>';
      end;


      //duration
      hours := duration div 60;
      minutes := duration mod 60;
      s := '';
      if hours>0 then
        s:=format(' (%d:%.2d)', [hours, minutes]);
      if duration>0 then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        all:=all+format('<tr><td class="small-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"%s>%d %s%s</td></tr>', [border, GetLangStr(705), border, duration, GetLangStr(706), s]);
      end;

      //
      mpaa:='';
      if mpaa_code>0 then begin
        with sl do begin
          Clear;
          Add('select name from manuals');
          Add(format('where code=%d', [mpaa_code]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          ThisBlockCnt := ThisBlockCnt + 1;
          if (ThisBlockCnt mod 2 = 1) then
            border := bckgrnd
          else
            border := '';
          s:=Format('<a href="mpaa:%d">%s</a>', [mpaa_code, GetStringField('name')]);
          mpaa:=s;
          if mpaa_desc<>'' then
            mpaa:=mpaa+' '+mpaa_desc;
          all := all + Format('<tr><td class="small-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"%s>%s</td></tr>', [border, GetLangStr(35023), border, mpaa]);
        end;
      end;

      //studios
      studios:='';
      with sl do begin
        Clear;
        Add('select m.code, m.name from movies_manuals mm');
        Add('join manuals m on m.code=mm.ref_code');
        Add(format('where mm.movie=%d and m.reference=12', [MovieCode]));
        Add('order by m.name');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        studios := format('<tr><td class="small-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"%s>', [border, GetLangStr(35024), border]);
        for i:=1 to RecordCount do begin
          studios := studios + format('<a href="studio:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        studios := copy(studios, 1, length(studios)-3);
        all := all + studios + '</td></tr>';
      end;

      // developers (actors)
      s := '';
      with sl do begin
        Clear;
        Add('select distinct p.code, p.name, p.in_collection from data d');
        Add('inner join persons p on p.code=d.person');
        Add(format('where d.movie=%d and d.mode=3', [MovieCode]));
        Add('order by d.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        all:=all + Format('<tr><td class="small-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"%s>', [border, GetLangStr(35012), border]);
        i:=1;
        while i<=RecordCount do begin
          if GetIntegerField('p.in_collection')=1 then
            img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
          else
            img:='';
          s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
          if (i=5) and (i<RecordCount) and not FullPersons then
            i:=RecordCount;
          i:=i+1;
          GetNextRecord;
        end; //while
        s:=copy(s, 1, length(s)-2);
        if (RecordCount>=6) and not FullPersons then
          s:=s+format(GetLangStr(1251), [MovieCode]);
        all:=all+s+'</td></tr>';
      end; //if

      // publishers (directors)
      s := '';
      with sl do begin
        Clear;
        Add('select distinct p.code, p.name, p.in_collection from data d');
        Add('inner join persons p on p.code=d.person');
        Add(format('where d.movie=%d and d.mode=1', [MovieCode]));
        Add('order by d.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        //'Directors: ';
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        all:=all + Format('<tr><td class="small-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="small-table-value"%s>', [border, GetLangStr(35025), border]);
        i:=1;
        while i<=RecordCount do begin
          if GetIntegerField('p.in_collection')=1 then
            img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
          else
            img:='';
          s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
          if (i=5) and (i<RecordCount) and not FullPersons then
            i:=RecordCount;
          i:=i+1;
          GetNextRecord;
        end; //while
        s:=copy(s, 1, length(s)-2);
        if (RecordCount>=6) and not FullPersons then
          s:=s+format(GetLangStr(1251), [MovieCode]);
        all:=all+s+'</td></tr>';
      end; //if

      all := all + '</table>';
    end;

    if (ActiveTab = 1) or (ActiveTab = 10) then begin
      //description
      if description<>'' then begin
        all:=all+Format('<table class="description" style="font-size: %dpt; line-height: %dpx;"><tr><td>', [BasicFontSize + BiggerModifier, LineSpace]);
        all := all + '<hr style="margin: 0;">';
        all := all + '<p>'+description+'</p>';
        all := all + '<hr style="margin: 0;">';
        all := all + '</td></tr></table>';
      end;
    end;

    if (ActiveTab = 1) then begin
      if not FixedContentsWidth then
        all := all + '<div style="clear:left;"></div><table class="envelope"><tr><td>';
      //photos of people
      temp := '';
      if (RegReadInteger('HidePhotosCovers', 0) = 0) then begin
        LastCode:=0;
        with sl do begin
          Clear;
          Add('select i.path as path, i.width, i.height, i.person as code, i.mode, p.name, p.birth_date, c.name');
          Add('from data d');
          Add('inner join images i on i.person=d.person');
          Add('inner join persons p on p.code=d.person');
          Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
          Add(format('where d.movie=%d', [MovieCode]));
          Add('order by d.mode, d.sort_order, i.person, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);

        page_width := GetHTMLWidth - WholePageBorder;
        if FixedContentsWidth then
          page_width := page_width - LeftColumnWidth;
        i := ScreenshotAreaHeight;
        if page_width > WidePage then
          i := i - 100;
        if ScreenshotTotalHeight > i then
          page_width := page_width - ScreenshotWidth - ScreenshotPadding;
        if RecordCount>0 then
        begin
          TempList := TStringList.Create;
          all:=all+'<table class="photos"><tr>';
          j := 0;
          kol := 0;
          i := 0;
          fl := True;
          while (i < RecordCount) and fl do begin
            //only photos! no custom images are allowed
            if (GetIntegerField('i.mode') = 6) then begin
              if (TempList.IndexOf(IntToStr(GetIntegerField('code'))) < 0) then begin
                kol := kol + 1;
                TempList.Add(IntToStr(GetIntegerField('code')));
                PicHeight := GetIntegerField('i.height');
                if PicHeight > 0 then
                  PicWidth := Round(GetIntegerField('i.width') * (SmallCoverHeight / PicHeight)) + BigImageBorders
                else
                  PicWidth := StandardCoverWidth + BigImageBorders;
                if PicWidth < StandardCoverWidth then
                  PicWidth := StandardCoverWidth + BigImageBorders;

                age := '';
                if (YearsBetween(GetStringField('p.birth_date'), year) > 0) then
                  age := IntToStr(YearsBetween(GetStringField('p.birth_date'), year));

                if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
                  temp := temp + '<td class="one-photo">';
                  trunc_name := TruncateName(GetStringField('p.name'), MaxNameLength);
                  trunc_character := TruncateName(GetStringField('c.name'), MaxCharacterNameLength);

                  FileName := GetImageFileName(GetStringField('path'), ThumbsMoviePhotos, NO_PHOTO_FILE[GAMENIZER_PROGRAM], 0, SmallCoverHeight);
                  temp:=temp+format('<a class="pic" href="person:%d"><img style="height: %dpx" src="%s" border="0"></a><p><a href="person:%d">%s</a></p>', [GetIntegerField('code'), SmallCoverHeight, FileName, GetIntegerField('code'), trunc_name]);
                //end 2.05.11


                  if age <> '' then
                    temp := temp + '<p style="color: #666666;">' + Format(GetLangStr(1410), [age]) + '</p>';
                  if trunc_character <> '' then
                    temp := temp + '<p>' + trunc_character + '</p>';
                  temp := temp + '</td>';
                  page_width := page_width - PicWidth;
                  if (page_width >= 0) then begin
                    all := all + temp;
                    j := j + 1;
                    temp := '';
                    page_width_rest := page_width;
                  end
                  else
                    fl := False;
                end;//if MyFileExists
              end;
            end;
            GetNextRecord;
            i := i + 1;
          end;//while
          //all := all + '<td colspan="' + IntToStr(kol-j) + '">';
          all := all + '<td></td>';
          all := all + '</tr></table>';
          TempList.Free;
        end;//if recordcount
      end;


      //custom fields
      cust:='';
      PrevBlockCnt:=0;
      for i:=1 to 4 do begin
        if custom[i]>0 then begin
          with sl do begin
            Clear;
            Add('select name from manuals');
            Add(format('where code=%d', [custom[i]]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if RecordCount>0 then begin
            PrevBlockCnt:=PrevBlockCnt+1;
            if (PrevBlockCnt mod 2 = 1) then
              border := bckgrnd
            else border := '';
            cust:=cust+Format('<tr><td class="big-table-name"%s>', [border])+format(GetLangStr(539+i), [s])+format('</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border])+format('<a href="custom%d:%d">', [i, custom[i]])+GetStringField('name')+'</a></td></tr>';
          end;
        end;
      end;

      //custom list1
      with sl do begin
        Clear;
        Add('select m.code, m.name from movies_manuals mm');
        Add('join manuals m on m.code=mm.ref_code');
        Add(format('where mm.movie=%d and m.reference=17', [MovieCode]));
        Add('order by m.name');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        PrevBlockCnt:=PrevBlockCnt+1;
        if (PrevBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        cust:=cust+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(544), border]);
        for i:=1 to RecordCount do begin
          cust:=cust+format('<a href="custom5:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        cust:=copy(cust, 1, length(cust)-2);
        cust:=cust+'</td></tr>';
      end;

      //custom list2
      with sl do begin
        Clear;
        Add('select m.code, m.name from movies_manuals mm');
        Add('join manuals m on m.code=mm.ref_code');
        Add(format('where mm.movie=%d and m.reference=18', [MovieCode]));
        Add('order by m.name');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        PrevBlockCnt:=PrevBlockCnt+1;
        if (PrevBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        cust:=cust+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(545), border]);
        for i:=1 to RecordCount do begin
          cust:=cust+format('<a href="custom6:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        cust:=copy(cust, 1, length(cust)-2);
        cust:=cust+'</td></tr>';
      end;
      if cust <> '' then
        all:=all+Format('<table class="names-values" style="font-size: %dpt; line-height: %dpx;">', [BasicFontSize + BiggerModifier, LineSpace])+cust+'</table>';
    end; //if ActiveTab = 1


    //Trailers
    if (ActiveTab = 9) then begin
      with sl do begin
        Clear;
        Add('select i.path, i.width, i.height, mc.id, mc.site from movies_codes mc');
        Add('left join images i');
        Add('on i.code=mc.code');
        Add(format('where mc.movie=%d and mc.script=''trailer''', [MovieCode]));
        Add('order by i.sort_order')
      end;
      RecordCount := ExecuteSQL(sl.text);
      page_width := GetHTMLWidth - LeftColumnWidth;
      all := all + '<table style="width: 100%;"><tr><td><table><tr>';
      temp := '';
      for i := 1 to RecordCount do begin
        PicWidth := GetIntegerField('i.width');
        if PicWidth = 0 then
          PicWidth := DefaultTrailerWidth;
        PicWidth := PicWidth + NormalImageBorders;
        FileName := ImagesPath + GetStringField('i.path');
        if not (MyFileExists(FileName)) then
          FileName := ImgPath + 'trailer.gif';
        url := GetStringField('mc.site');
        page_width := page_width - PicWidth;
        if page_width < 0 then begin
          temp := temp + '</tr></table><table><tr>';
          page_width := GetHTMLWidth - LeftColumnWidth - PicWidth;
        end;
        if (Pos('http://', url) > 0) or (Pos('https://', url) > 0) then
          url := '<a class="pic" href="trailer_link:' + IntToStr(GetIntegerField('mc.id')) + '">'
        else
          url := '<a class="pic" href="play:' + url + '">';
        temp := temp + '<td><div style="width: 5px; vertical-align: middle;">'+url+format('<img class="trailer" src="%s"></a></div></td>', [FileName]);
        GetNextRecord;
      end;
      if temp <> '' then
        all := all + temp + '</tr></table></td></tr></table>';
    end;



      //editions
    if ((ActiveTab = 1) and
    (((RegReadInteger('ShowEditionsOnMainTab', 1) = 1))))
    or (ActiveTab = 5) or (ActiveTab = 8) then begin
      with sl do begin
        Clear;
        Add('select e.code from editions e');
        Add('left outer join manuals m on m.code=e.edition and m.reference=21');
        Add(format('where e.movie=%d', [MovieCode]));
        Add('order by e.sort_order');
      end;
      EditionsCount:=ExecuteSQL(sl.text);

      for ie:=1 to EditionsCount do begin
        editions[ie]:=GetIntegerField('e.code');
        GetNextRecord;
      end;

      if EditionsCount > 0 then
        //all := all + '<table class="envelope-table"><tr><td>';

      for ie:=1 to EditionsCount do begin
        EditionCode:=editions[ie];
        //editions
        with sl do begin
          Clear;
          Add('select * from editions e');
          Add('left outer join manuals m on m.code=e.edition and m.reference=21');
          Add(format('where e.code=%d', [EditionCode]));
        end;
        ExecuteSQL(sl.text);

        ed:='';

        //video parameters
        VideoBitrate:=GetIntegerField('e.video_bitrate');
        filesize:=GetIntegerField('e.filesize');
        DiscLabel:=GetIntegerField('e.disc_label');
        disc_nom:=GetStringField('e.disc_nom');
        duration:=GetIntegerField('e.duration');
        barcode:=GetStringField('e.barcode');
        GameLanguage := GetIntegerField('e.book_language');

        VideoStandard:=GetIntegerField('e.video_standard');
        ScreenRatio:=GetIntegerField('e.screen_ratio');
        resolution:=GetIntegerField('e.resolution');
        VideoCodec:=GetIntegerField('e.video_codec');
        MediaFormat:=GetIntegerField('e.media_format');

        EditionFeatures:=GetStringField('e.features');
        EditionComment:=GetStringField('e.comment');
        EditionCost:=GetFloatField('e.cost');

        if ((EditionsCount > 1) or (RegReadInteger('ShowEditions', 0) = 1) or (ActiveTab = 5) or (ActiveTab=8)) then begin
          PrevBlockCnt:=-1;
          VideoFileName := GetStringField('e.filename');
          VideoFileFolder := VideoFileName;
          while (length(VideoFileFolder)>0) and (pos(VideoFileFolder[length(VideoFileFolder)],'/\')=0) do delete(VideoFileFolder,length(VideoFileFolder),1);
          ed:=ed + Format('<p class="header" style="font-size: %dpt;">', [BasicFontSize + SubHeaderModifier]);
          if VideoFileFolder<>'' then
            ed:=ed+format('&nbsp;<a class="pic" href="explore:%s">', [VideoFileName])+format('<img src="%sfolder.png" align="absmiddle" border="0" alt="%s"></a> ', [ImgPath, VideoFileName])+'&nbsp;';
          i := GetIntegerField('e.season');
          j := GetIntegerField('e.episode');
          if (i<=0) and ((RegReadInteger('OnlyEditionName', 0) = 0) or (GetStringField('m.name') = '')) then
            ed:=ed+format(GetLangStr(1260), [ie])+'. ';
          if GetStringField('m.name')<>'' then
            ed:=ed+GetStringField('m.name')+'. ';
          barcode := GetStringField('e.barcode');
          if VideoFileName<>'' then
            ed:=ed+format('<a class="pic" href="play:%s">', [VideoFileName])+format('<img src="%splay.png" align="absmiddle" border="0" alt="%s"></a> ', [ImgPath, VideoFileName]);


          if duration>0 then
            ed:=ed+Format('(%d:%0.2d) ', [duration div 60, duration mod 60]);
          if barcode<>'' then
            ed:=ed+GetLangStr(1259)+': '+barcode;
          ed := ed + '</p>';
        end;

        all:=all+ed;


        //editions
        if (ActiveTab = 1) or (ActiveTab = 5) then begin
          ed:=Format('<table class="names-values" style="font-size: %dpt; line-height: %dpx;">', [BasicFontSize + BiggerModifier, LineSpace]);
          ThisBlockCnt := 0;

          if (ActiveTab = 1) then begin
            //disc #
            if disc_nom<>'' then begin
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              ed:=ed+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(35037), border, disc_nom]);
            end;
            //disc label
            if DiscLabel>0 then begin
              with sl do begin
                Clear;
                Add('select name from manuals');
                Add(format('where code=%d', [DiscLabel]));
              end;
              RecordCount:=ExecuteSQL(sl.text);
              if RecordCount>0 then begin
                ThisBlockCnt := ThisBlockCnt + 1;
                if (ThisBlockCnt mod 2 = 1) then
                  border := bckgrnd
                else
                  border := '';
                ed:=ed+format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s><a href="disc_label:%d">%s</a></td></tr>', [border, GetLangStr(1000), border, DiscLabel, GetStringField('name')]);
              end;
            end;
            //edition cost
            if EditionCost > 0 then begin
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              ed:=ed+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%f</td></tr>', [border, GetLangStr(3350), border, EditionCost]);
            end;

            //loans
            border:='';
            with sl do begin
              Clear;
              Add('select l.location, m.name from loans l');
              Add('inner join manuals m on m.code=l.location');
              Add(format('where edition=%d', [EditionCode]));
              Add('and (return_date='''' or return_date is null)');
              Add('order by loan_date desc');
            end;
            RecordCount:=ExecuteSQL(sl.text);
            if RecordCount>0 then begin
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              ed:=ed+Format('<tr><td class="big-table-name"%s>', [border])+GetLangStr(35253)+format('</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s><a href="location:%d">%s</a></td></tr>', [border, GetIntegerField('l.location'), GetStringField('m.name')]);
            end;
          end;

          if (ed<>'') then
            all := all + ed;

          //parameters
          with sl do begin
            Clear;
            Add('select name, reference from manuals');
            Add(format('where code in (%d, %d, %d, %d, %d, %d)', [VideoStandard, ScreenRatio, resolution, VideoCodec, MediaFormat, GameLanguage]));
            Add('order by reference');
          end;
          RecordCount:=ExecuteSQL(sl.text);
          for i:=1 to RecordCount do begin
            if GetIntegerField('reference')=1 then begin
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              //Video standard
              all:=all+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(201), border, GetStringField('name')]);
            end
            else if GetIntegerField('reference')=2 then begin
              //media format
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              all:=all+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s><a href="media_format:%d">%s</a></td></tr>', [border, GetLangStr(249), border, MediaFormat, GetStringField('name')]);
            end
            else if GetIntegerField('reference')=23 then begin
              // game language
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              all:=all+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s><a href="book_language:%d">%s</a></td></tr>', [border, GetLangStr(35251), border, GameLanguage, GetStringField('name')]);
            end
            else if GetIntegerField('reference')=4 then begin
              //screen ratio
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              all:=all+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s><a href="aspect_ratio:%d">%s</a></td></tr>', [border, GetLangStr(202), border, ScreenRatio, GetStringField('name')]);
            end

            else if GetIntegerField('reference')=5 then begin
              //resolution
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              all:=all+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s><a href="resolution:%d">%s</a></td></tr>', [border, GetLangStr(203), border, resolution, GetStringField('name')]);
            end

            else if GetIntegerField('reference')=19 then begin
              //video codec
              ThisBlockCnt := ThisBlockCnt + 1;
              if (ThisBlockCnt mod 2 = 1) then
                border := bckgrnd
              else
                border := '';
              all:=all+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s><a href="video_codec:%d">%s</a></td></tr>', [border, GetLangStr(571), border, VideoCodec, GetStringField('name')]);
            end;
            GetNextRecord;
          end;
          s2:='';
          //video bitrate
          if VideoBitrate>0 then begin
            ThisBlockCnt := ThisBlockCnt + 1;
            if (ThisBlockCnt mod 2 = 1) then
              border := bckgrnd
            else
              border := '';
            s2:=format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%d</td></tr>', [border, GetLangStr(630), border, VideoBitrate]);
          end;
          //filesize
          if filesize>0 then begin
            ThisBlockCnt := ThisBlockCnt + 1;
            if (ThisBlockCnt mod 2 = 1) then
              border := bckgrnd
            else
              border := '';
            s2:=s2+format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%d</td></tr>', [border, GetLangStr(35254), border, filesize]);
          end;

          //duration
          if (duration>0) and (EditionsCount=1) then begin
            ThisBlockCnt := ThisBlockCnt + 1;
            if (ThisBlockCnt mod 2 = 1) then
              border := bckgrnd
            else
              border := '';
            s2:=s2+format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%d %s', [border, GetLangStr(147), border, duration, GetLangStr(706)]);
            s2:=s2+format(' (%d:%.2d)</td></tr>', [duration div 60, duration mod 60]);
          end;

          all:=all+s2;

          //audio tracks
          with sl do begin
            Clear;
            Add('select m.code, m.name, am.Bitrate, am.Codec, am.Channel, am.Short_Comment from audio_manuals am');
            Add('left join manuals m on m.code=am.reference');
            Add(format('where am.edition=%d and am.media_type=0', [EditionCode]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if RecordCount>0 then begin
            //Audio tracks
            ThisBlockCnt := ThisBlockCnt + 1;
            if (ThisBlockCnt mod 2 = 1) then
              border := bckgrnd
            else
              border := '';
            all:=all+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(254), border]);
            for i:=1 to RecordCount do begin
                s2 := ' ' + GetStringField('am.codec');
              if (s2 <> '') then
                S2 := s2 + ' ';
              if (GetIntegerField('am.channel') > 0) then
                s2 := s2 + GetStringField('am.channel') + ' ch ';
              if (GetIntegerField('am.Bitrate') > 0) then
                s2 := s2 + GetStringField('am.Bitrate') + ' kbps ';
              if (GetStringField('am.Short_Comment') <> '') then
                s2 := s2 + GetStringField('am.Short_Comment') + ' ';
              if (s2<>'') then
                s2 := copy(s2, 1, length(s2) - 1);
              all:=all+format('<a href="audio_track:%d">%s</a>%s, ', [GetIntegerField('m.code'), GetStringField('m.name'), s2]);

              GetNextRecord;
            end;
            all:=copy(all, 1, length(all)-2);
            all := all + '</td></tr>';
          end;

          //subtitles
          with sl do begin
            Clear;
            Add('select m.code, m.name, am.Short_Comment from audio_manuals am');
            Add('join manuals m on m.code=am.reference');
            Add(format('where am.edition=%d and am.media_type=1', [EditionCode]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if RecordCount>0 then begin
            //Subtitles
            ThisBlockCnt := ThisBlockCnt + 1;
            if (ThisBlockCnt mod 2 = 1) then
              border := bckgrnd
            else
              border := '';
            all:=all+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(253), border]);
            for i:=1 to RecordCount do begin
              s2 := '';
              if (GetStringField('am.Short_Comment') <> '') then
                s2 := ' ' + Trim(GetStringField('am.Short_Comment'));
              all:=all+format('<a href="subtitle:%d">%s</a>%s, ', [GetIntegerField('m.code'), GetStringField('m.name'), s2]);
              GetNextRecord;
            end;
            all:=copy(all, 1, length(all)-2);
            all := all + '</td></tr>';
          end;
          //show filename
          if (RegReadInteger('ShowFileNames', 1) = 1) and (VideoFileName<>'') then begin
            ThisBlockCnt := ThisBlockCnt + 1;
            if (ThisBlockCnt mod 2 = 1) then
              border := bckgrnd
            else
              border := '';
            all := all + Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(195), border]);
            all := all + Format('<a href="play:%s">%s</a></td></tr>', [VideoFileName, VideoFileName]);
          end;
          // DVD Features
          if EditionFeatures<>'' then begin
            ThisBlockCnt := ThisBlockCnt + 1;
            if (ThisBlockCnt mod 2 = 1) then
              border := bckgrnd
            else
              border := '';
            all := all + Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(1537), border]);
            all := all + EditionFeatures + '</td></tr>';
          end;

          //Edition comments
          if EditionComment<>'' then begin
            ThisBlockCnt := ThisBlockCnt + 1;
            if (ThisBlockCnt mod 2 = 1) then
              border := bckgrnd
            else
              border := '';
            all := all + Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(163), border]);
            all := all + EditionComment + '</td></tr>';
          end;
          all := all + '</table>';

        end;
      end; //editions
      //if EditionsCount > 0 then
        //all := all + '</td></tr></table>';
    end;


    if (ActiveTab = 1) then begin
      //dates
      s:='';
      ThisBlockCnt := 0;
      s := Format('<table class="names-values" style="font-size: %dpt; line-height: %dpx;">', [BasicFontSize + BiggerModifier, LineSpace]);
      if DateAdd<>'' then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        s:=s+format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(670), border, SQLDate2Str(DateAdd)]);
      end;
      if DateUpdate<>'' then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        s:=s+format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(671), border, SQLDate2Str(DateUpdate)]);
      end;
      if DateSeen<>'' then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        s:=s+format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(35280), border, SQLDate2Str(DateSeen)]);
      end;
      all:=all+s+'</table>';



      //salary
      cust := '';
      if salary<>'' then
        cust:=cust+Format('<table class="description" style="font-size: %dpt; line-height: %dpx;"><tr><td>', [BasicFontSize + BiggerModifier, LineSpace])+salary+'</td></tr></table>';
      all := all + cust;

      //comments
      cust := '';
      if comment<>'' then begin
        if not FullComments and (length(comment)>DescriptionLength) then begin
          comment:=copy(comment, 1, DescriptionLength);
          comment:=comment+format(GetLangStr(1250), [MovieCode]);
        end;
        cust:=cust+Format('<table class="description" style="font-size: %dpt; line-height: %dpx;"><tr><td>', [BasicFontSize + BiggerModifier, LineSpace])+comment+'</td></tr></table>';
      end;

      all := all + cust;
    end;

    cust := '';

    //awards
    if (ActiveTab = 3) then
    begin
      if awards<>'' then begin
        cust := '';
        sl.Clear;
        sl.LoadFromFile(PicturesPath + 'awards\awards.txt');
        //the general description from kinopoisk
        i := Pos('<br>', awards);
        temp := copy(awards, 1, i-1);
        if Pos('.', temp) > 5 then begin
          cust := temp + '<br>';
          delete(awards, 1, i+3);
        end;
        temp := '';
        while awards <> '' do begin
          i := Pos('<br><br>', awards) + 8;
          if i = 8 then
            i := Pos('<br> <br>', awards) + 9;
          if i = 9 then
            i := length(awards) + 1;
          //process each award separately
          s := copy(awards, 1, i-1);
          j := Pos(',', s);
          k := Pos('<br>', s);
          if (k < j) or (j = 0) then
            j := k;
          temp_name := copy(s, 1, j-1);
          j := Pos('"', temp_name);
          if j > 0 then
            temp_name := GetStr(temp_name, '"', '"');
          new_name := '<a href="userref:3302,' + temp_name + '">' + temp_name + '</a>';
          s := ReplaceStr(s, temp_name, new_name);
          for k := 0 to sl.Count - 1 do begin
            name := sl.Names[k];
            s3 := sl.Values[sl.Names[k]];
            s3 := ReplaceStr(s3, '-mid.', '.');
            j := Pos(':', name);
            if j > 0 then
              delete(name, j, length(name)-j+1);
            j := Pos('">' + LowerCase(name), LowerCase(new_name));
            if (j > 0) then
              l := Pos(LowerCase(new_name), LowerCase(s))
            else
              l := Pos(LowerCase(name), LowerCase(s));
            if (l = 1) or ((l > 0) and (s[l-1] = '>')) then begin
              s2 := '<div style="clear:both"><div style="float: left; margin: 5px;"><a class="pic" href="userref:3302,'+ name + '"><img border="0" alt="' + name + '" src="' + PicturesPath + 'awards\' + s3 + '"></a></div>';
              insert(s2, s, l);
            end;
          end;
          temp := temp + s;
          delete(awards, 1, i - 1);
        end;
        cust:=Format('<table class="description" style="font-size: %dpt; line-height: %dpx;"><tr><td>', [BasicFontSize + BiggerModifier, LineSpace])+cust+temp+'</td></tr></table>';
      end;
      all := all + cust;
    end;
    if ((ActiveTab = 1) and (RegReadInteger('ShowAwardsOnGeneralTab', 0) = 1)) then begin
      if awards <> '' then
        all := all + Format('<table class="description" style="font-size: %dpt; line-height: %dpx;"><tr><td>', [BasicFontSize + BiggerModifier, LineSpace]) + awards + '</td></tr></table>';
    end;

    if (ActiveTab = 1) then
      all := all + '</td></tr></table>';

    all := all + '</div>';

    sl.Free;
    result:=all;
  finally
    ResetRegistrySubKey();
  end;
end;

//show movies by selected user reference
//links like <a href='userref:Code,Text'>link</a>
//links like <a href='userref:Code,Text,Page'>link</a>
function GetUserReferenceForGame(code: integer; text: string; Page: Integer = 1): string;
var
  sl, TempList: TStringList;
  i, j, kol, RecordCount, rating, page_width, LastCode, my_i, my_code, movie_code: integer;
  s, s2, description, year, director, writer, actor, bio, character, movie, movie_top, temp, header_img: string;
  all, FileName, img, rate: string;
  IMDBRating: double;
  StartItem, EndItem, MoviesPage, ii, TotalItems, lines, SeasonNr, PageItems: integer;
  fl, loan_page: boolean;
  dd, mm, yy, loan_code, page_width_copy, PicWidth, PicHeight: integer;
  RatingIndex: Integer;
  ShowLastUpdated: Boolean;
  current_site, sortby_string, mc_rating: String;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[GAMENIZER_PROGRAM]);
  try
    ProgramReference:='';
    TempReferenceCode:=code;
    code := GetOldReferenceCodeForNewCode(code);
    TempReference:=666;
    TempText:=text;
    if code=100 then
      result := GetPatternTop + Format('<p class="page-header" style="font-size: %dpt;">',
        [BasicFontSize + PageHeaderModifier]) + format('%s</p>',
        [GetLangStr(1333)]) + ClosePatternTop +
        Format('<p class="header" style="font-size: %dpt;">',
        [BasicFontSize + SubHeaderModifier]) + ShowScriptOptions
    //Movie tabs
    else if code in [109..129]	then begin
      my_code := 0;
      SeasonNr := 0;
      i := Pos(';', text);
      if i>0 then begin
        s := copy(text, i+1, length(text) - i);
        delete(text, i, length(text) - i + 1);
        try
          SeasonNr := StrToInt(s);
        except
        end;
      end;
      try
        my_code := StrToInt(text);
      except
      end;

      //18.11.10
      SetMode(1, my_code);

      ActiveTab := code - 108;
      if my_code > 0 then
        result := GetGamePage(my_code, SeasonNr, false, false, false, false);
    end
    //person tabs
    else if code in [200..209] then begin
      my_code := 0;
      try
        my_code := StrToInt(text);
      except
      end;
      PersonActiveTab := code - 199;
      SetMode(2, my_code);
      if my_code > 0 then
        result := GetPerson(my_code, false, false);
    end
    else
    begin

      sl:=TStringList.Create;
      all:='';



      // movies by studio
      if code = 12 then begin
        with sl do begin
          Clear;
          Add('select m.title as title, m.code as code, m.in_collection as in_collection,');
          Add('m.rating as raing, m.imdb_rating as imdb_rating, i.path as path');
          Add('from movies m');
          Add('inner join movies_manuals mm on mm.movie=m.code and mm.reference=12');
          Add('inner join manuals mg on mg.code=mm.ref_code');
          Add('left outer join images i on i.movie=m.code and i.mode=1');
          Add(format('where mg.name=%s and m.in_collection=1', [TempText]));
          Add('AND m.item_type=' + IntToStr(GAMENIZER_PROGRAM));
          Add('order by m.title_sort, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        all := ProcessMovieReference(GAMENIZER_PROGRAM, text, page);
      end;

      // movies by award
      if code = 302 then
      begin
        //detect award winners
        with sl do begin
          Clear;
          Add('select code, awards from movies');
          Add('where awards like ''%' + TempText + '%'' and in_collection=1');
          Add('AND item_type=' + IntToStr(GAMENIZER_PROGRAM));
        end;
        RecordCount := ExecuteSQL(sl.text);
        TempList := TStringList.Create;
        header_img := '';
        i := 0;
        while i < RecordCount do begin
          s := LowerCase(GetStringField('awards'));
          s2 := '';
          j := Pos(LowerCase(TempText), s);
          if j > 0 then begin
            my_i := MyPos('<br><br>', s, j + 1);
            if my_i = 0 then
              my_i := MyPos('<br> <br>', s, j + 1);
            if my_i = 0 then
              my_i := Length(s);
            s2 := copy(s, j, my_i - j);
          end;
          //imdb - kinopoisk - kinoteatr
          TempList.Add(IntToStr(GetIntegerField('code')));
          GetNextRecord;
          i := i + 1;
        end;
        //select award winners
        with sl do begin
          Clear;
          Add('select m.title as title, m.code as code, m.in_collection as in_collection,');
          Add('m.rating as rating, m.imdb_rating as imdb_rating, i.path as path');
          Add('from movies m');
          Add('left outer join images i on i.movie=m.code and i.mode=1');
          Add(Format('where m.code in (%s)', [TempList.CommaText]));
          Add('order by m.title_sort, i.sort_order');
        end;
        TempList.LoadFromFile(PicturesPath + 'awards\awards.txt');
        for i := 0 to TempList.Count - 1 do
          if Pos(LowerCase(TempText), LowerCase(TempList[i])) = 1 then
            header_img := TempList.Values[TempList.Names[i]];
        TempList.Free;
        RecordCount:=ExecuteSQL(sl.text);
        if header_img <> '' then
          header_img := PicturesPath + 'awards/' + header_img;
        all := ProcessMovieReference(GAMENIZER_PROGRAM, TempText, page, header_img);
      end;

      //filmography sorting
      if code in [231..236] then
      begin
        my_code := 0;
        i := Pos(';', text);
        s := copy(text, 1, i-1);
        try
          my_code := StrToInt(s);
        except
        end;
        delete(text, 1, i);
        s := text+'FilmSort';
        if code = 231 then
          RegWriteString(s, 'title asc');
        if code = 232 then
          RegWriteString(s, 'title desc');
        if code = 233 then
          RegWriteString(s, 'year asc');
        if code = 234 then
          RegWriteString(s, 'year desc');
        if code = 235 then
          RegWriteString(s, 'rating asc');
        if code = 236 then
          RegWriteString(s, 'rating desc');
        SetMode(2, my_code);
        all := GetPerson(my_code, false, false);
      end;

      //movies from the home page
      if ((code >= 1) and (code <= 5)) then
      begin
        GenerateSQLForMoviesPages(sl, GAMENIZER_PROGRAM, code);
        ExecuteSQL(sl.text);
        all := ProcessMovieReference(GAMENIZER_PROGRAM, text, page);
      end;

      // people by award
      if code = 303 then
      begin
        header_img := '';
        //detect award winners
        with sl do begin
          Clear;
          Add('select code, awards from persons');
          Add('where awards like ''%' + TempText + '%'' and in_collection=1');
          Add('AND item_type=' + IntToStr(GAMENIZER_PROGRAM));
        end;
        RecordCount := ExecuteSQL(sl.text);
        TempList := TStringList.Create;
        i := 0;
        while i < RecordCount do begin
          s := LowerCase(GetStringField('awards'));
          s2 := '';
          temp := s;
          j := Pos(LowerCase(TempText), temp);
          while j > 0 do begin
            my_i := MyPos('<br><br>', temp, j + 1);
            if my_i = 0 then
              my_i := MyPos('<br> <br>', temp, j + 1);
            if my_i = 0 then
              my_i := Length(temp);
            s2 := copy(temp, j, my_i - j);
            TempList.Add(IntToStr(GetIntegerField('code')));
            delete(temp, 1, j);
            j := Pos(LowerCase(TempText), temp);
          end;
          GetNextRecord;
          i := i + 1;
        end;
        //select award winners
        with sl do begin
          Clear;
          Add('select p.code as code, p.name as name, p.rating as rating, p.birth_date as birth_date, i.path as path, i.width, i.height, p.in_collection');
          Add('from persons p');
          Add('left outer join images i on i.person=p.code');
          Add(Format('where p.code in (%s)', [TempList.CommaText]));
          Add('order by p.name, i.sort_order');
        end;
        TempList.LoadFromFile(PicturesPath + 'awards\awards.txt');
        for i := 0 to TempList.Count - 1 do
          if Pos(LowerCase(TempText), LowerCase(TempList[i])) = 1 then
            header_img := TempList.Values[TempList.Names[i]];
        TempList.Free();
        if header_img <> '' then
          header_img := PicturesPath + 'awards/' + header_img;
        RecordCount:=ExecuteSQL(sl.text);
      end;

      //people from the homepage
       if (code in [6..9, 303, 210, 211]) then
       begin
        s2 := Text;
        ShowLastUpdated := (RegReadInteger('ShowLastUpdated', 0) = 1);
        //303 is for awards
        if (not (code in [303])) then
        begin
          if (code in [6..9]) then
            GenerateSQLForPersonPages(sl, code - 5)
          else
          begin
            with sl do
            begin
              Clear;
              Add('select p.code as code, p.name as name, p.rating as rating,');
              Add('p.birth_date as birth_date, i.path as path, i.width, i.height, p.in_collection');
              Add('from persons p');
              Add('left outer join images i on i.person=p.code');
              case code of
                210: Add('where p.birthplace like ''%' + s2 + '%''');
                211: Add('where p.death_date<>''''');
              end;
              Add('and p.in_collection=1');
              Add('AND p.item_type=' + IntToStr(GAMENIZER_PROGRAM));
              if ShowLastUpdated then
                Add('order by p.date_update desc, p.code, i.mode desc, i.sort_order')
              else
                Add('order by p.date_add desc, p.code, i.mode desc, i.sort_order');
            end;
          end;
          RecordCount:=ExecuteSQL(sl.text);
        end;
        lines := RegReadInteger('BreezeLinesPeople', DefaultLinesPeople);
        page_width := GetHTMLWidth - WholePageBorder;
        CountedPages := 0;
        TotalItems := CountItemsForPages(page_width, page, RecordCount, 1, lines, HomePhotoHeight[GAMENIZER_PROGRAM], HomePhotoWidth[GAMENIZER_PROGRAM]);
        i := ProcessedRecords;
        movie := '';
        all := '';
        fl:=true;
        PageItems := 0;
        LastCode := 0;
        page_width_copy := page_width;
        while (i<=RecordCount) and fl do begin
          my_code:=GetIntegerField('code');
          if LastCode<>my_code then
          begin
            LastCode:=my_code;
            PicHeight := GetIntegerField('i.height');
            PicWidth := HomePhotoWidth[GAMENIZER_PROGRAM] + NormalImageBorders;
            page_width_copy := page_width_copy - PicWidth;
            if (page_width_copy < 0) then begin
              all := all + movie + '<td></td></tr></table><table class="whole-page-images"><tr>';
              movie := '';
              lines := lines - 1;
              page_width_copy := page_width - PicWidth;
            end;
            if (page<>0) and (lines <= 0) then
            begin
              Dec(i);
              fl:=false;
            end
            else begin

              rating := GetIntegerField('rating');
              rate:='';
              if rating > 0 then begin
                for my_i:=1 to 10 do begin
                  if my_i mod 2=1 then begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%shalfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-halfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  end
                  else begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%shalfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-halfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  end;
                end;
              end;
              FileName := GetImageFileName(GetStringField('path'), ThumbsHomePhotos, NO_PHOTO_FILE[GAMENIZER_PROGRAM], HomePhotoWidth[GAMENIZER_PROGRAM], HomePhotoHeight[GAMENIZER_PROGRAM], True);
              movie:=movie+'<td style="background-color: white; border: 1px solid ' + WhiteAreaBorderColor + '; width: 100px; padding: 5px;"><a class="pic"'+format(' href="person:%d"><img style="height: %dpx" border="0" src="%s"></a>', [my_code, HomePhotoHeight[GAMENIZER_PROGRAM], FileName]);
              //movie := movie + '<div class="image-text">';
              movie:=movie + format('<div style="margin: 5 0;"><a href="person:%d">%s</a>', [my_code, GetStringField('name')]);
              if (code = 9) then begin
                DecodeDate(Date, kol, ii, my_i);
                movie := movie + ' (' + IntToStr(YearsBetween(GetStringField('birth_date'), IntToStr(kol))) + ')';
              end;
              movie := movie + '</div>';
              if rate<>'' then
                movie := movie + '<div style="vertical-align: bottom;">' + rate + '</div>';
              movie := movie + '</td>';

              PageItems:=PageItems+1;
            end;
          end
          else begin
            GetNextRecord;
            i:=i+1;
          end;
        end;
        TotalItems := TotalItems + PageItems;
        all := all+movie;
        if movie <> '' then
          //all := all + format('<td style="width: %dpx;"></td>', [page_width_copy  - BigImageBorders]);
          all := all + '<td></td>';
        all:=all+'</tr></table>';

        kol := 0;
        lines := RegReadInteger('BreezeLinesPeople', DefaultLinesPeople);
        if (page > 0) and (i < RecordCount) then
        begin
          //set the maximum number of pages to 2000
          TotalItems := TotalItems + CountItemsForPages(page_width, 2000, RecordCount, i, lines, HomePhotoHeight[GAMENIZER_PROGRAM], HomePhotoWidth[GAMENIZER_PROGRAM]);
          kol := CountedPages;
        end;
        if header_img <> '' then
          header_img := '<img border="0" style="float: left; margin-right: 10; vertical-align: middle;" src="' + header_img + '">';
        movie_top:=GetReferenceTop;
        movie_top:= movie_top + Format('<p class="page-header" style="font-size: %dpt;">', [BasicFontSize + PageHeaderModifier]) + header_img + text + format(' (%d)', [TotalItems]);
        movie_top:=movie_top+'</p>'+ClosePatternTop;
        movie_top:=movie_top+'<table class="whole-page-images"><tr>';

        all := movie_top + all;

        s:='userref:'+IntToStr(TempReferenceCode)+','+TempText;
        if (kol > 0) or (page > 1) then begin
          all:=all+Format('<center><hr><p><big>', [page_width div 3, page_width div 3]);
          if (kol>0) or (page > 1) then
            all:=all+format('<a href="%s,%d">%s</a>   ', [s, 0, GetLangStr(1330)]);
          if page>1 then
            all:=all+format('<a href="%s,%d">%s</a>   ', [s, page-1, GetLangStr(1328)]);
          for i:=1 to page do begin
            if page=i then
              all:=all+format(' <b>%d</b> ', [i])
            else
              all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
          end;
          for i:=(page+1) to (page+kol) do
            all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
          if kol>0 then
            all:=all+format('   <a href="%s,%d">%s</a> ', [s, page+1, GetLangStr(1329)]);
          all:=all+'</big></p></center>';
        end;
      end;

      sl.Free;
      result := all;
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

begin

end.
