﻿program breeze_program_part7;
                                                
uses 'breeze_program_variables.pas', 'breeze_program_global.pas';

//показ уменьшенной карточки человека
function GetThumbnailPersonAlbum(code, mode: integer; Name: string): string;
var
  sl: TStringList;
  s, rate, FileName, img, PersonName, BirthDate: string;
  fl, PersonStatsInCollection: boolean;
  j, kol, amount, RecordCount, DirectorCount, WriterCount, ActorCount, ComposerCount, years: integer;
  InCollection, rating, ThumbWidth: integer;
  ThumbsPath, FileIn, FileOut: string;
  BigOpen, BigClose, SmallOpen, SmallClose: string;
  CheckMode: string;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MUSICNIZER_PROGRAM]);
  try
    sl:=TStringList.Create;

    if mode=1 then
      amount:=3
    else
      amount:=7;
    s:='';

    ThumbWidth := RegReadInteger('ListCoverWidth', DefaultThumbWidth);

    ThumbsPath:=ImagesPath+Thumbs+'\';

      fl:=false;

      with sl do begin
        Clear;
        Add('select p.code, p.name, p.in_collection, p.birth_date, p.rating, i.path from persons p');
        Add('left outer join images i on i.person=p.code and i.mode=6');
        Add(format('where p.code=%d', [code]));
        Add('order by i.sort_order')
      end;
      RecordCount:=ExecuteSQL(sl.text);
      PersonName:=GetStringField('p.name');
      if (Name <> '') then
        PersonName := Name;
      InCollection:=GetIntegerField('p.in_collection');
      rating:=GetIntegerField('p.rating');

      if rating>0 then
        rate:=format(' <NOBR><img src="%sstar-transp.gif" width=17 height=16 border=0 align="absmiddle">%d</NOBR>', [ImgPath, rating])
      else
        rate:='';

      BirthDate:=GetStringField('p.birth_date');
      if BirthDate<>'' then
        BirthDate:=Date2Str(BirthDate);

      // Fade 16.08.2011 - For Search Thumbs do not add CheckBox picture
      if ((Mode <> 2) and (GroupOperation)) then
      begin
        if (IsPersonChecked(code)) then
          CheckMode:=format('<a class="pic" href="group_person_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a class="pic" href="group_person_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
        if (InCollection=1) then
          CheckMode := '<div id="group_overlay_image">' + CheckMode + '</div>';
      end
      else if (InCollection <> 1) then
        CheckMode:='<div id="group_image_no_cover">&nbsp;</div>'
      else
        CheckMode:='';

      //получаем дополнительную информацию о фильме, если он из коллекции
      if InCollection=1 then begin
        //обложка
        if GetStringField('i.path')<>'' then begin
  //      	FileName:=ImagesPath+GetStringField('i.path');

          FileIn:=ImagesPath+GetStringField('i.path');
          FileName:=ThumbsPath+GetStringField('i.path');
          if MyFileExists(FileIn) then begin
            if not MyFileExists(FileName) then begin
              //ShowMessage('Convert '+FileIn+' to '+FileName);
              ConvertThumb3(FileIn, FileName, Thumbs, ThumbWidth, 0, false);
            end;
            if not MyFileExists(FileName) then
              FileName:=FileIn;
          end
          else
            FileName:=FileIn;

          if MyFileExists(FileName) then
            fl:=true;
        end;
        if not fl then begin
          FileName:=ImgPath + NO_PHOTO_FILE[MUSICNIZER_PROGRAM];
          fl:=true;
        end;
        if RegReadInteger('PersonStatsInCollection', 0) = 1 then
      PersonStatsInCollection := True
      else
      PersonStatsInCollection := False;
        //кол-во фильмов, как актер
      with sl do begin
          Clear;
          Add('select distinct d.movie as amount from data d');
      Add('join movies m on d.movie=m.code');
          Add(format('where d.person=%d and d.mode=3', [code]));
      if PersonStatsInCollection then
        Add('and m.in_collection=1');
        end;
        ActorCount:=ExecuteSQL(sl.text);
      //number of movies as director
      with sl do begin
          Clear;
          Add('select distinct d.movie as amount from data d');
      Add('join movies m on d.movie=m.code');
          Add(format('where d.person=%d and d.mode=1', [code]));
      if PersonStatsInCollection then
        Add('and m.in_collection=1');
        end;
        DirectorCount:=ExecuteSQL(sl.text);
      //number of movies as writer
      with sl do begin
          Clear;
          Add('select distinct d.movie as amount from data d');
      Add('join movies m on d.movie=m.code');
          Add(format('where d.person=%d and d.mode=2', [code]));
      if PersonStatsInCollection then
        Add('and m.in_collection=1');
        end;
        WriterCount:=ExecuteSQL(sl.text);
      //number of movies as composer
      with sl do begin
          Clear;
          Add('select distinct d.movie as amount from data d');
      Add('join movies m on d.movie=m.code');
          Add(format('where d.person=%d and d.mode=4', [code]));
      if PersonStatsInCollection then
        Add('and m.in_collection=1');
        end;
        ComposerCount:=ExecuteSQL(sl.text);
        s:='<div style="background-color: white; padding: 5px; margin: 3; border: 1px solid ' + WhiteAreaBorderColor + '; font-size: ' + IntToStr(ListFontSize) + 'pt;"><div style="float: left; margin: 0 5 5 0;">' +
          CheckMode + '<a class="pic" href="person:' + format('%d"><img border="0" src="%s" style="width: %dpx;"', [code, FileName, ThumbWidth]);
      if not GetCutePreview and (mode<>7) then
      s:=s+' width=50 border="0" align=left';
      // fade group operations
      s:=s+format('></a></div><div style="margin-top: 5px;"><a href="person:%d"><big><b>%s</b></big></a>%s<br>', [code, PersonName, rate]);
        if BirthDate<>'' then begin
          //ShowMessage(BirthDate);
          s:=s+BirthDate;
          try
            //years:=StrToDate(BirthDate);
          except
          end;
          s:=s+'<br>';
      end;
      if DirectorCount>0 then
      s:=s+format('%s: %d', [GetLangStr(10000), DirectorCount]);
        s:=s+SmallClose;
      end
      else begin
        s := '<div style="background-color: white; padding: 5px; margin: 3; border: 1px solid ' + WhiteAreaBorderColor + '; font-size: ' + IntToStr(ListFontSize) + 'pt;">';
        s:=s + CheckMode + format('<a href="person:%d"><b>%s</b></a>', [code, PersonName]);
      end;

    s := s+'</div></div>';
    //s:='<tr><td class="text-box">'+s+'</td></tr>';
    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetThumbnailPersonAlbumExtended(code, mode: integer; Name: string): string;
var
  sl: TStringList;
  CheckMode: string;
  s, rate, FileName, img, PersonName, BirthDate: string;
  fl, CutThumb: boolean;
  i, j, kol, amount, RecordCount, DirectorCount, WriterCount, ActorCount, years: integer;
  InCollection, rating, PhotoWidth, PhotoHeight: integer;
  ThumbsPath, FileIn, FileOut: string;
  ProgramType: Integer;
begin
	result:='';
  ProgramType := MUSICNIZER_PROGRAM;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    sl:=TStringList.Create;

    if mode=1 then
      amount:=3
    else
      amount:=7;
    s:='';

    ThumbsPath:=ImagesPath+Thumbs2+'\';

      fl:=false;

      with sl do begin
        Clear;
        Add('select p.code, p.name, p.in_collection, p.birth_date, p.rating, i.path from persons p');
        Add('left outer join images i on i.person=p.code and i.mode=6');
        Add(format('where p.code=%d', [code]));
        Add('order by i.sort_order')
      end;
      RecordCount:=ExecuteSQL(sl.text);
      PersonName:=GetStringField('p.name');
      if (Name <> '') then
        PersonName := Name;
      InCollection:=GetIntegerField('p.in_collection');

        //обложка
      PhotoWidth := RegReadInteger('ThPhotoWidth', DefaultMultiCoverWidth[ProgramType]);
      PhotoHeight := RegReadInteger('ThPhotoHeight', DefaultMultiCoverHeight[ProgramType]);

      if (PhotoWidth <= 0) and (PhotoHeight <= 0) then
      begin
        PhotoWidth := DefaultMultiCoverWidth[ProgramType];
        PhotoHeight := DefaultMultiCoverHeight[ProgramType];
      end;

      i := RegReadInteger('CutPhotoThumb', 1);
      if i = 1 then
        CutThumb := True
      else
        CutThumb := False;

      //получаем дополнительную информацию о фильме, если он из коллекции
      if InCollection=1 then
      begin

      if GetStringField('i.path')<>'' then
      begin
  //      	FileName:=ImagesPath+GetStringField('i.path');
        FileIn:=ImagesPath+GetStringField('i.path');
        FileName:=ThumbsPath+GetStringField('i.path');
        if MyFileExists(FileName) then
          fl:=true
        else if MyFileExists(FileIn) then
          ConvertThumb3(FileIn, FileName, Thumbs2, PhotoWidth, PhotoHeight, CutThumb);
        if MyFileExists(FileName) then
          fl:=true;
      end;
    end;

      if GroupOperation then
      begin
        if (IsPersonChecked(code)) then
          CheckMode:=format('<a class="pic" href="group_person_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a class="pic" href="group_person_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);

        CheckMode := '<div id="group_overlay_image_multi">' + CheckMode + '</div>';
      end
      else
        CheckMode:='';

        if not fl then begin
          FileIn:=ImgPath + NO_PHOTO_FILE[MUSICNIZER_PROGRAM];
          //FileName:=ThumbsPath+'no-cover.jpeg';
          FileName:=ThumbsPath + NO_PHOTO_FILE[MUSICNIZER_PROGRAM];
          if ((NeedToCreateThumbFile(FileName)) and
              (MyFileExists(FileIn))) then
          begin
            ConvertThumb3(FileIn, FileName, Thumbs2, PhotoWidth, PhotoHeight, CutThumb);
          end;
          fl:=true;
        end;

        s:='<div style="height: 100%; background-color: white; padding: 5px; margin: 5 5 0 5; border: 1px solid ' + WhiteAreaBorderColor + '; font-size: ' + IntToStr(ListFontSize) + 'pt;"><div style="float: left; margin: 0 5 5 0;">' +
          CheckMode + format('<a class="pic" href="person:%d"><img border="0" src="%s"></a></div><div style="clear:both"></div><div><a href="person:%d"><b>%s</b></a></div></div>', [code, FileName, code, PersonName]);
    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;


function GetPersonAlbumTabs(PersonCode: Integer; Bio, Facts, Photos: Boolean; AdditionalSpace: Integer = 0): String;
var
	s, prefix: String;
	i, my_tabs, PageWidth, PageTabs: Integer;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MUSICNIZER_PROGRAM]);
  try
    PageWidth := GetHTMLWidth - LeftColumnWidth - IconSpace;
    PageTabs := PageWidth div TabWidth;
    s := '';
    s := '<div style="margin-left: 200px; color: white; vertical-align: bottom; font-weight: bold; line-height: 46px;">';

    //general info tab
    s := s + GetTab(PersonActiveTab = 1, GetLangStr(161), Format('userref:%d,%d', [1200, PersonCode]), True);
    PageTabs := PageTabs - 1;
    i := PersonActiveTab;

    //photos
    if (Photos) and (PageTabs > 0) then begin
      s := s + GetTab(PersonActiveTab = 2, GetLangStr(1400), Format('userref:%d,%d', [1201, PersonCode]));
      PageTabs := PageTabs - 1;
      i := PersonActiveTab - 1;
    end;

    //biography
    if (Bio) and (PageTabs > 0) then begin
      s := s + GetTab(PersonActiveTab = 3, GetLangStr(282), Format('userref:%d,%d', [1202, PersonCode]));
      PageTabs := PageTabs - 1;
      i := PersonActiveTab - 2;
    end;

    //facts
    if (Facts) and (PageTabs > 0) then begin
      s := s + GetTab(PersonActiveTab = 4, GetLangStr(1435), Format('userref:%d,%d', [1203, PersonCode]));
      PageTabs := PageTabs - 1;
      i := PersonActiveTab - 3;
    end;

    //filmography
    if (PageTabs > 0) then begin
      s := s + GetTab(PersonActiveTab = 5, GetLangStr(10009), Format('userref:%d,%d', [1204, PersonCode]));
      i := PersonActiveTab - 4;
    end;

    s := s + '</div>';
    result := s;
  finally
    ResetRegistrySubKey();
  end;
end;


function GetPersonAlbumPage(PersonCode: integer; FullBio, FullDesc: boolean): string;
var
  sl, CodeList: TStringList;
  s, s2, cust, all, OriginalName, collection, bio, description, BirthDateStr, DeathDateStr, birthplace: string;
  rate, FileName, movie, year, character, img, title, comment, down: string;
  rating, flCollection, i, j, my_i, AlbumCode: integer;
  RecordCount, height, LastCode, AdditionalSpace: integer;
	site, url: string;
	tmp, age, CurrentDateStr: String;
	kol, PhotoCnt, MaxPhotos, page_width, page_width_copy, PicHeight, PicWidth, ThisBlockCnt, SpouseStatus, ChildrenCount, SpousePersonCode, person_type: integer;
	fl, ShowSeenIcon, ShowInCollectionIcon, ShowWantedIcon, ShowForSaleIcon, IconsOnTheRight, ShowScreenshots, SomeData, IsUnique: boolean;
	sort_order, border, bckgrnd, SpousePerson, SpouseStatusStr, date_start, date_end: string;
	custom: array[1..6] of integer;
	PrevBlockCnt: Integer;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MUSICNIZER_PROGRAM]);
  try
    bckgrnd := ' style="background-image: url(' + GetProperPath(ImgPath + 'list-background.gif') + ');"';
    sl:=TStringList.Create;
    SomeData := False;
    CodeList := TStringList.Create;

    with sl do begin
      Clear;
      Add('select code from images');
      Add(format('where person=%d and mode=6', [PersonCode]));
      Add('order by sort_order');
    end;
    PhotoCnt:=ExecuteSQL(sl.text);

    if (RegReadInteger('ShowInCollectionIcon', 1) = 1) then
      ShowInCollectionIcon := true
    else
      ShowInCollectionIcon := false;

    if (RegReadInteger('ShowSeenIcon', 0) = 1) then
      ShowSeenIcon := true
    else
      ShowSeenIcon := false;

    if (RegReadInteger('ShowWantedIcon', 0) = 1) then
      ShowWantedIcon := true
    else
      ShowWantedIcon := false;

    if (RegReadInteger('ShowForSaleIcon', 0) = 1) then
      ShowForSaleIcon := true
    else
      ShowForSaleIcon := false;
    if (RegReadInteger('IconsOnTheRight', 0) = 1) then
      IconsOnTheRight := true
    else
      IconsOnTheRight := false;

    all:='';
    CurrentDateStr := FormatDateTimeEx('mm/dd/yyyy', Now());
        with sl do begin
          Clear;
          Add('select * from persons');
          Add(format('where code=%d', [PersonCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount=0 then
          exit;
        s:='person:'+IntToStr(PersonCode);
        person:=GetStringField('name');
        OriginalName:=GetStringField('original_name');
        rating:=GetIntegerField('rating');

        flCollection:=GetIntegerField('in_collection');

        bio:=GetStringField('biography');
        description:=GetStringField('description');
        comment:=GetStringField('comment');
        BirthDateStr:=GetStringField('birth_date');
        birthplace:=GetStringField('birthplace');
        DeathDateStr:=GetStringField('death_date');
        height:=GetIntegerField('height');
      person_type := GetIntegerField('person_type');

      // custom fileds
        custom[1]:=GetIntegerField('custom1');
        custom[2]:=GetIntegerField('custom2');
        custom[3]:=GetIntegerField('custom3');
        custom[4]:=GetIntegerField('custom4');

      //if no info for the tab, switch to the main
      if ((PersonActiveTab = 2) and (PhotoCnt = 0)) or
      ((PersonActiveTab = 3) and (bio = '')) or
      ((PersonActiveTab = 4) and (description = '')) then begin
      PersonActiveTab := 1;
      result := GetPersonAlbumPage(PersonCode, FullBio, FullDesc);
      exit;
      end;

        if flCollection=0 then
          collection:=format('<a class="pic" href="collection_person:%d"><img src="%snot-in-collection.gif" border="0" alt="Person is not in collection"></a>',  [PersonCode, ImgPath])
        else
          collection:=format('<a class="pic" href="collection_person:%d"><img src="%sin-collection.gif" border="0" alt="Person in collection"></a>',  [PersonCode, ImgPath]);

        rate:='';
        for i:=1 to 10 do begin
          if i mod 2=1 then begin
            if i<=rating then
              rate:=rate+format('<a class="pic" href="rating_person:%d"><img src="%shalfstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
            else
              rate:=rate+format('<a class="pic" href="rating_person:%d"><img src="%snot-halfstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
          end
          else begin
            if i<=rating then
              rate:=rate+format('<a class="pic" href="rating_person:%d"><img src="%shalfstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
            else
              rate:=rate+format('<a class="pic" href="rating_person:%d"><img src="%snot-halfstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
          end;
        end;

        if (description='') and (BirthDateStr='') then
          down:='<br>'+format('<a href="DownloadPerson:%d">', [PersonCode])+GetLangStr(324)+'</a>'
        else
          down:='';

        //ShowMessage(rate);
    with sl do begin
      Clear;
      Add(Format('select * from persons where name=''%s''', [person]));
    end;
    RecordCount := ExecuteSQL(sl.text);
    if RecordCount = 1 then
      IsUnique := True
    else
      IsUnique := False;

    all:=GetPatternTop;
    all:=all + Format('<p class="page-header" style="font-size: %dpt;">', [BasicFontSize + PageHeaderModifier]) + person;
    while (Pos(' ', OriginalName) = 1) do
      delete(OriginalName, 1, 1);
    if (OriginalName <> '') and (OriginalName <> person) then
      all:=all+ Format(' / <span style="font-size: %dpt;">', [BasicFontSize + SubHeaderModifier]) + OriginalName + '</span>';
    all:=all+'</p>';

    //tab background
    all := all + '<table style="border-collapse: collapse; width: 100%;"><tr><td><div style="margin-left: 10px; margin-right: 10px; height: 46px; background-image: url(' +GetProperPath(ImgPath + 'inactive-tab-button.gif') + ');">';
    //icons
    all := all + '<div class="icon-container">' + collection + '</div>';

    //tabs
    //if RegReadInteger('HideNavigationMenu', 0) = 0 then
    all := all + GetPersonAlbumTabs(PersonCode, bio<>'', description<>'', PhotoCnt>1, AdditionalSpace);

    AdditionalSpace := 0;

    all := all + '</div></td></tr></table>';

    if (PersonActiveTab <> 2) then begin

      ShowScreenshots := False;
      MaxPhotos := RegReadInteger('PhotosCnt', 5);
      if (PersonActiveTab = 1) and (MaxPhotos > 0) then begin
        showScreenshots := True;
        i := GetHTMLWidth - LeftColumnWidth - ScreenshotWidth;
        if (i < DataArea) then
          showScreenshots := False;
      end;

      PhotoCnt := 0;
      with sl do begin
        Clear;
        Add('select path, code from images');
        Add(format('where person=%d order by mode desc, sort_order', [PersonCode]));
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if ShowScreenshots then begin
        AdditionalSpace := ScreenshotWidth + NormalImageBorders;
        //фотки человека
        if RecordCount>1 then begin
        all:=all+'<div class="shot-space">';
        if RecordCount <= MaxPhotos then
          MaxPhotos := RecordCount-1;
        GetNextRecord;
        for i:=1 to MaxPhotos do begin
          PhotoCnt := PhotoCnt + 1;
          FileName:=ImagesPath+GetStringField('path');
          if (MyFileExists(FileName)) then begin
            FileName := GetImageFileName(GetStringField('path'), ThumbsPhotos, NO_PHOTO_FILE[MUSICNIZER_PROGRAM], ScreenshotWidth, 0);
            all:=all+'<div class="shots"><div><a class="pic" '+format('href="ShowImage:%d"><img style="width: %dpx" src="%s"></a></div></div>', [GetIntegerField('code'), ScreenshotWidth, FileName]);
          end;
          GetNextRecord;
        end;
        if PhotoCnt < (RecordCount - 1) then begin
          all:=all+format('<div class="arrow-down"><a class="pic" href="userref:1201,%d"><img border="0" alt="%s" src="%sarrow-down.gif"></a></div>', [PersonCode, person, ImgPath]);
          //ScreenshotTotalHeight := ScreenshotTotalHeight + 30; //arrow down width
        end;
        all:=all+'</div>'
        end;
      end
      else
        PhotoCnt := RecordCount;

        //поиск картинок
        with sl do begin
        Clear;
        Add('select * from images');
        Add(format('where person=%d and mode=6', [PersonCode]));
        Add('order by sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        all:=all+ Format('<div class="cover-space" style="font-size: %dpt;">', [BasicFontSize + BiggerModifier]);
        if RecordCount>0 then begin
        if (MyFileExists(ImagesPath + GetStringField('path'))) then begin
          FileName := GetImageFileName(GetStringField('path'), ThumbsMainPhoto, NO_PHOTO_FILE[MUSICNIZER_PROGRAM], MainPhotoWidth, 0);

          all:=all+'<div style="padding: 3px;"><a class="pic"'+format(' href="ShowImage:%d"><img style="width: %dpx" border="0" src="%s"></a></div>',
                [GetIntegerField('code'), MainPhotoWidth, FileName]);
        end;
        end
        else begin
        FileName:=ImgPath + NO_PHOTO_FILE[MUSICNIZER_PROGRAM];
        if (MyFileExists(FileName)) then
          all:=all+format('<div style="padding: 3px;"><img class="cover-image" border="0" src="%s"></div>', [FileName]);
        end;

      //My rating
      i := RegReadInteger('ShowRating', 1);
      if i=1 then begin
        all := all + '<div style="vertical-align: middle; color: #666666; margin-bottom: 5px;">' + Format('<b>%s:</b></div>', [GetLangStr(298)]);
        all := all + '<div>' + rate + '</div>';
      end;


        //links
        with sl do begin
        Clear;
        Add('select distinct pc.code, pc.script, pc.site, p.* from persons_codes pc');
        Add('left outer join partners p on pc.script=p.site');
        Add('AND pc.item_type = p.item_type');
        Add(format('where person=%d', [PersonCode]));
        Add('order by p.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
        for i:=1 to RecordCount do begin
          site:=GetStringField('pc.script');
          url:=GetStringField('pc.site');
          if url<>'' then
          begin
            url := AddPostfixToURL(url, GetStringField('p.postfix'));
            all := all+'<hr class="line-separator"><div>';
            s:=GetPartnerImageFile(site, GetStringField('p.picture'));
            if s='' then
              all:=all+'<a href="link:http://www.medianizer.com/redirect/'+url+format('">%s</a>', [site])
            else
              all:=all+'<a class="pic" href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%s%s" border="0" align="absmiddle"></a>', [PicturesPath, s]);
            all := all + '</div>';
          end;
          GetNextRecord;
        end;
        end;

      all := all + '<div class="free-space-bottom" style="background-image: url(' + GetProperPath(ImgPath + 'bottom-shadow.gif') +')"></div></div>'; //end photo block
    end; //if PersonActiveTab <> 2

    //photos
    if PersonActiveTab = 2 then begin
      all := all + GetShots(PersonCode, 6, 'person', 5);
    end;

    //biography
      if (bio<>'') and ((PersonActiveTab = 1) or (PersonActiveTab = 3)) then begin
      if not FullBio and (length(bio)>700) and (PersonActiveTab <> 3) then begin
        bio:=copy(bio, 1, 700);
        bio:=RemoveUnclosedTags(bio);
        bio:=bio+format(GetLangStr(369), [PersonCode]);
      end;
         all:=all+ Format('<table class="description" style="font-size: %dpt; line-height: %dpx;"><tr><td><p>', [BasicFontSize + BiggerModifier, LineSpace])+bio+'</p><hr></td></tr></table>';
    end;

    //personal details
    if PersonActiveTab = 1 then begin
      tmp := '';
      ThisBlockCnt := 0;
      if BirthDateStr<>'' then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        //Date of birth
        if person_type = 0 then
          s := GetLangStr(294)
        else
          s := GetLangStr(10210);
        tmp := tmp + '<tr><td class="big-table-name"' + border + Format('>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"', [s])+ border + '>' + GetSmartDate(BirthDateStr);
        (*if DeathDateStr='' then begin
          s := Format(GetLangStr(838), [GetAge(CurrentDateStr, BirthDateStr)]);
          tmp := tmp + s;
        end;*)
        tmp := tmp + '</td></tr>';
      end;

      if birthplace<>'' then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        if person_type = 0 then
          s := GetLangStr(287)
        else
          s := GetLangStr(10340);
        //Location of birth
        tmp:=tmp + '<tr><td class="big-table-name"' + border + Format('>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"', [s])+ border + '>' + birthplace + '</td></tr>';
      end;

      age := '';
      if DeathDateStr<>'' then begin
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        //Date of death
        if person_type = 0 then
          s := GetLangStr(295)
        else
          s := GetLangStr(10348);
        tmp:=tmp+'<tr><td class="big-table-name"' + border + Format('>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"', [s])+ border + '>' + GetSmartDate(DeathDateStr);
        //tmp:=tmp +  ' ' + format(GetLangStr(839), [GetAge(DeathDateStr, BirthDateStr)]);
        tmp:=tmp+'</td></tr>';
      end;


      //height
      if height>0 then begin
        if height<100 then
          s:='0.'+IntToStr(height)
        else begin
          s:=IntToStr(height);
          s:=copy(s, 1, 1)+DecimalSeparator+copy(s, 2, length(s)-1);
        end;
        ThisBlockCnt := ThisBlockCnt + 1;
        if (ThisBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        tmp:=tmp+'<tr><td class="big-table-name"' + border + Format('>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"', [GetLangStr(372)])+ border + '>' + s + '</td></tr>';
      end;


      if tmp <> '' then begin
        all := all + Format('<table class="names-values" style="font-size: %dpt; line-height: %dpx;">', [BasicFontSize + BiggerModifier, LineSpace]) + tmp + '</table>';
        SomeData := True;
      end;

    //group - members
      with sl do begin
        Clear;
        Add('select *, (select name from persons');
        Add(Format('where code = case when persons_links.person_main=%d', [PersonCode]));
        Add('then persons_links.person_secondary');
        Add('else persons_links.person_main');
        Add('end) as PersonName, ');
        Add('(select code from persons');
        Add(Format('where code = case when persons_links.person_main=%d', [PersonCode]));
        Add('then persons_links.person_secondary');
        Add('else persons_links.person_main');
        Add('end) as PersonID, manuals.name as role from persons_links');
        Add('join manuals on persons_links.link_type=manuals.code');
        Add(Format('where (person_main=%d) or (person_secondary=%d)', [PersonCode, PersonCode]));
        Add('order by PersonID');
      end;
      RecordCount := ExecuteSQL(sl.text);
      if RecordCount > 0 then begin
        all := all + Format('<table class="description" style="font-size: %dpt; line-height: %dpx; width: auto; margin-left: 20px;">', [BasicFontSize + BiggerModifier, LineSpace]);
        if person_type = 1 then
          s := GetLangStr(10736)
        else
          s := GetLangStr(10735);
        all := all + Format('<tr><td><p class="header" style="font-size: %dpt; margin-left: 0px;">', [BasicFontSize + SubHeaderModifier])+s+':</td></tr>';
        s := '';
        tmp := '';
        LastCode := 0;
        for i := 1 to RecordCount do begin
          j := GetIntegerField('PersonID');
          if j <> LastCode then
            s := s + Format('<tr><td><a href="person:%d">', [j]) + GetStringField('PersonName') + '</a>';
          date_start := GetSmartDate(GetStringField('persons_links.date_start'));
          date_end := GetSmartDate(GetStringField('persons_links.date_end'));
          character := GetStringField('role');
          if (character <> '') then begin
            if (j <> LastCode) then
              s := s + ': '
            else begin
              delete(s, length(s)-9, 10);
              s := s + ', ';
            end;
            s := s + character;
          end;
          if (date_start <> '') or (date_end <> '') then begin
            s := s + ' (';
            if date_start <> '' then
              s := s + date_start
            else
              s := s + GetSmartDate(BirthDateStr);
            s := s + ' - ';
            if date_end <> '' then
              s := s + date_end
            else if DeathDateStr <> '' then
              s := s + GetSmartDate(DeathDateStr)
            else
              s := s + GetLangStr(7015);
            s := s + ')';
          end;
          s := s + '</td></tr>';
          tmp := character;
          LastCode := j;
          GetNextRecord;
        end;
        all:=all+s+'</table>';
      end;
        //custom fields
        cust:='';
        PrevBlockCnt:=0;
        for i:=1 to 4 do
        begin
        if custom[i]>0 then
        begin
          with sl do
          begin
          Clear;
          Add('select name from manuals');
          Add(format('where code=%d', [custom[i]]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if RecordCount>0 then
          begin
          PrevBlockCnt:=PrevBlockCnt+1;
          if (PrevBlockCnt mod 2 = 1) then
            border := bckgrnd
          else border := '';
          cust:=cust+Format('<tr><td class="big-table-name"%s>', [border])+format(GetLangStr(4539+i), [s])+format('</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border])+format('<a href="custom_person%d:%d">', [i, custom[i]])+GetStringField('name')+'</a></td></tr>';
          end;
        end;
        end;

        //custom list1
        with sl do begin
        Clear;
        Add('select m.code, m.name from persons_manuals pm');
        Add('join manuals m on m.code=pm.ref_code');
        Add(format('where pm.person=%d and m.reference=28', [PersonCode]));
        Add('order by m.name');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
        PrevBlockCnt:=PrevBlockCnt+1;
        if (PrevBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        cust:=cust+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(4544), border]);
        for i:=1 to RecordCount do begin
          cust:=cust+format('<a href="custom_person5:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        cust:=copy(cust, 1, length(cust)-2);
        cust:=cust+'</td></tr>';
        end;

        //custom list2
        with sl do begin
        Clear;
        Add('select m.code, m.name from persons_manuals pm');
        Add('join manuals m on m.code=pm.ref_code');
        Add(format('where pm.person=%d and m.reference=29', [PersonCode]));
        Add('order by m.name');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
        PrevBlockCnt:=PrevBlockCnt+1;
        if (PrevBlockCnt mod 2 = 1) then
          border := bckgrnd
        else
          border := '';
        cust:=cust+Format('<tr><td class="big-table-name"%s>%s</td><!-- <td class="middle-cell"></td> --><td class="big-table-value"%s>', [border, GetLangStr(4545), border]);
        for i:=1 to RecordCount do begin
          cust:=cust+format('<a href="custom_person6:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        cust:=copy(cust, 1, length(cust)-2);
        cust:=cust+'</td></tr>';
        end;
        if cust <> '' then
        all:=all+Format('<table class="names-values" style="font-size: %dpt; line-height: %dpx;">', [BasicFontSize + BiggerModifier, LineSpace])+cust+'</table>';

    end;

        //обложки фильмов
    if (RegReadInteger('HidePhotosCovers', 0) = 0) and (PersonActiveTab = 1) then begin
      LastCode:=0;
      with sl do begin
        Clear;
        Add('select distinct i.path as path, i.width, i.height, i.movie as code, m.year, m.in_collection, m.title, c.name');
        Add('from data d');
        Add('inner join images i on i.movie=d.movie');
        Add('inner join movies m on m.code=d.movie');
        Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
        Add(format('where d.person=%d', [PersonCode]));
        Add('and i.mode=1');
        Add('order by d.movies_sort_order, m.year desc, i.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      page_width := GetHTMLWidth - WholePageBorder;
      if PhotoCnt > 0 then
        page_width := page_width - ScreenshotWidth;
      page_width_copy := page_width;
      tmp := '';
      if RecordCount>0 then begin
        all:=all+'<div style="clear:left;"></div><table class="photos" style="margin-left: 10px;"><tr>';
        j := 0;
        kol := 1;
        sl.Clear;
        i := 0;
        fl := True;
        while (i < RecordCount) and fl do begin
          if (sl.IndexOf(IntToStr(GetIntegerField('code')))<0) then begin
            sl.Add(IntToStr(GetIntegerField('code')));
            PicHeight:=GetIntegerField('i.height');
            if PicHeight > 0 then
              PicWidth := Round(GetIntegerField('i.width') * (SmallCoverHeight / PicHeight)) + NormalImageBorders
            else
              PicWidth := StandardCoverWidth + NormalImageBorders;
            FileName:=ImagesPath+GetStringField('path');
            if (MyFileExists(FileName)) and (GetStringField('m.in_collection') = '1') then
            begin

              age := '';
              if (YearsBetween(BirthDateStr, GetStringField('m.year')) > 0) then
                age := IntToStr(YearsBetween(BirthDateStr, GetStringField('m.year')));


              FileName := GetImageFileName(GetStringField('path'), ThumbsPersonMovies, 'no-cover.gif', 0, SmallCoverHeight);
              tmp:=tmp+'<td class="one-photo"><a class="pic" ' + format('href="movie:%d"><img style="height: %dpx" border="0" src="%s"></a><p><a href="movie:%d">%s</a></p>', [GetIntegerField('code'), SmallCoverHeight, FileName, GetIntegerField('code'), GetStringField('m.title')]);

              page_width_copy := page_width_copy - PicWidth;
              if page_width_copy >= 0 then begin
                all := all + tmp;
                j := j + 1;
                tmp := '';
              end
              else begin
                if (kol >= RegReadInteger('CoverRows', DefaultCoverRows)) then
                  fl := false
                else begin
                  all := all + '<td></td></tr><tr>' + tmp;
                  kol := kol + 1;
                  page_width_copy := page_width - PicWidth;
                  tmp := '';
                end;
              end;
            end;
          end;
          i := i + 1;
          GetNextRecord;
        end;
        all := all + '<td></td>';
  (*			if kol > j then
          all := all + '<td class="arrow-left-page"><a class="pic" href="#">' + Format('<img border="0" src="%sarrow-left.gif"/>', [ImgPath])+'</a></td>';
  *)			all := all + '</tr></table>';
        SomeData := True;
      end;
    end;

    //description
      if (description<>'') and ((PersonActiveTab = 1) or (PersonActiveTab = 4)) then begin
      if not FullDesc and (length(description)>1000) and (PersonActiveTab <> 4) then begin
        description:=copy(description, 1, 1000);
        description:=RemoveUnclosedTags(description);
        description:=description+format(GetLangStr(370), [PersonCode]);
      end;
      all:=all+Format('<table class="description" style="font-size: %dpt; line-height: %dpx;"><tr><td>', [BasicFontSize + BiggerModifier, LineSpace]);
      if (PersonActiveTab = 1) and SomeData then
        all := all + '<hr>';
      all := all + '<p>'+description+'</p><hr></td></tr></table>';
      SomeData := True;
    end;

    //comments
    if (PersonActiveTab = 1) then begin
      if comment<>'' then begin
        all:=all+Format('<table class="description" style="font-size: %dpt; line-height: %dpx;"><tr><td><p>', [BasicFontSize + BiggerModifier, LineSpace])+comment+'</p></td></tr></table>';
        SomeData := True;
      end;
    end;

    if (PersonActiveTab = 1) or (PersonActiveTab = 5) then begin
      all := all + '<table class="envelope"><tr><td>';

      //movies by director
      sort_order := RegReadString('DirectorFilmSort', 'year desc');
        with sl do begin
          Clear;
          Add('select distinct m.title, m.code, m.year, e.filename, m.in_collection, m.seen, m.wanted, m.for_sale, m.rating from data d');
          Add('inner join movies m on m.code=d.movie');
          //Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
      Add('left outer join editions e on e.movie=m.code');
          Add(format('where d.person=%d', [PersonCode]));
          Add('and d.mode=1');
      if (RegReadInteger('ShowOnlyMoviesInCollection', 0) = 1) then
        Add('and m.in_collection=1');
          //17.03.09
          //Add('order by d.movies_sort_order');
          Add(format('order by m.%s, d.movies_sort_order', [sort_order]));
        end;
        RecordCount:=ExecuteSQL(sl.text);

        if RecordCount>0 then begin
          //Director - filmography
      movie := '';
      if SomeData then
        movie := '<hr>';
          movie := movie + Format('<p class="header" style="font-size: %dpt;">', [BasicFontSize + SubHeaderModifier])+GetLangStr(10174)+':';
      movie := movie + GetSortIcons(sort_order, PersonCode, 'Director', MUSICNIZER_PROGRAM);
      movie := movie + Format('</p><div class="filmography" style="font-size: %dpt; line-height: %dpx;"><ol>', [BasicFontSize + BiggerModifier, LineSpace]);
          for i:=1 to RecordCount do begin
        AlbumCode := GetIntegerField('m.code');
        if (CodeList.IndexOf(IntToStr(AlbumCode)) < 0) then begin
          CodeList.Add(IntToStr(AlbumCode));
          rate := '';
          rating := GetIntegerField('m.rating');
          if rating > 0 then begin
            for my_i:=1 to 10 do begin
              if my_i mod 2=1 then begin
                if my_i<=rating then
              rate:=rate+format('<img src="%shalfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                else
              rate:=rate+format('<img src="%snot-halfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
              end
              else begin
                if my_i<=rating then
                  rate:=rate+format('<img src="%shalfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                else
                  rate:=rate+format('<img src="%snot-halfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
              end;
            end;
          end;
          year:=GetStringField('m.year');
          character:=GetStringField('c.name');
          img:='';
          if (GetIntegerField('m.in_collection')=1) and ShowInCollectionIcon then
          img:=format('<img src="%sin-collection-small.gif" align="absmiddle">', [ImgPath]);
          if (GetIntegerField('m.seen')=1) and ShowSeenIcon then
          img := img + '&nbsp;' + format('<img src="%sseen-small.gif" align="absmiddle">', [ImgPath]);
          if (GetIntegerField('m.wanted')=1) and ShowWantedIcon then
          img := img + '&nbsp;' + format('<img src="%swanted-small.gif" align="absmiddle">', [ImgPath]);
          if (GetIntegerField('m.for_sale')=1) and ShowForSaleIcon then
          img := img + '&nbsp;' + format('<img src="%sfor-sale-small.gif" align="absmiddle">', [ImgPath]);
          if img<>'' then begin
          if IconsOnTheRight then
            img := '&nbsp;' + img
          else
            img := img + '&nbsp;';
          end;
          title:=GetStringField('m.title');
          movie := movie + '<li>';
          if not IconsOnTheRight then
          movie := movie + img;
          if year='' then
          movie:=movie+format('<a href="movie:%d">',
            [AlbumCode])+title+'</a>'
          else
          movie:=movie+format('<a href="movie:%d">%s</a> (%s)',
            [AlbumCode, title, year]);
          if rate <> '' then
          movie := movie + ' ' + rate;
          if GetStringField('e.filename') <> '' then
          movie:=movie+format('  <a href="playAlbum:%d">', [AlbumCode])+format('<img src="%splay.png" align="absmiddle" border="0"></a>', [ImgPath]);
          if IconsOnTheRight then
          movie := movie + img;
          movie := movie + '</li>';
        end;
        GetNextRecord;
          end;
          movie:=movie+'</ol></div>';
          all:=all+movie;
        end;
      CodeList.Clear;
      //collections
      if IsUnique then
      begin
        sort_order := RegReadString('DirectorFilmSort', 'year desc');
        with sl do begin
        Clear;
        Add('select distinct m.title, m.code, m.year, e.filename, m.in_collection, m.seen, m.wanted, m.for_sale, m.rating from data d');
        Add('inner join movies m on m.code=d.movie');
        Add('join tracks t on t.movie=m.code');
        Add('left outer join editions e on e.movie=m.code');
        Add(format('where d.person<>%d', [PersonCode]));
        Add(format('and t.artist=''%s''', [person]));
        //Add('and d.mode=1');
        if (RegReadInteger('ShowOnlyMoviesInCollection', 0) = 1) then
          Add('and m.in_collection=1');
        //17.03.09
        //Add('order by d.movies_sort_order');
        Add(format('order by m.%s, d.movies_sort_order', [sort_order]));
        end;
        RecordCount:=ExecuteSQL(sl.text);

        if RecordCount>0 then begin
        //collections
        movie := '';
        if SomeData then
          movie := '<hr>';
        movie := movie + Format('<p class="header" style="font-size: %dpt;">', [BasicFontSize + SubHeaderModifier])+GetLangStr(10657)+':';
        movie := movie + GetSortIcons(sort_order, PersonCode, 'Director', MUSICNIZER_PROGRAM);
        movie := movie + Format('</p><div class="filmography" style="font-size: %dpt; line-height: %dpx;"><ol>', [BasicFontSize + BiggerModifier, LineSpace]);
        for i:=1 to RecordCount do begin
          AlbumCode := GetIntegerField('m.code');
          if (CodeList.IndexOf(IntToStr(AlbumCode)) < 0) then begin
            CodeList.Add(IntToStr(AlbumCode));
            rate := '';
            rating := GetIntegerField('m.rating');
            if rating > 0 then begin
              for my_i:=1 to 10 do begin
                if my_i mod 2=1 then begin
                  if my_i<=rating then
                rate:=rate+format('<img src="%shalfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  else
                rate:=rate+format('<img src="%snot-halfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                end
                else begin
                  if my_i<=rating then
                    rate:=rate+format('<img src="%shalfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  else
                    rate:=rate+format('<img src="%snot-halfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                end;
              end;
            end;
            year:=GetStringField('m.year');
            character:=GetStringField('c.name');
            img:='';
            if (GetIntegerField('m.in_collection')=1) and ShowInCollectionIcon then
            img:=format('<img src="%sin-collection-small.gif" align="absmiddle">', [ImgPath]);
            if (GetIntegerField('m.seen')=1) and ShowSeenIcon then
            img := img + '&nbsp;' + format('<img src="%sseen-small.gif" align="absmiddle">', [ImgPath]);
            if (GetIntegerField('m.wanted')=1) and ShowWantedIcon then
            img := img + '&nbsp;' + format('<img src="%swanted-small.gif" align="absmiddle">', [ImgPath]);
            if (GetIntegerField('m.for_sale')=1) and ShowForSaleIcon then
            img := img + '&nbsp;' + format('<img src="%sfor-sale-small.gif" align="absmiddle">', [ImgPath]);
            if img<>'' then begin
            if IconsOnTheRight then
              img := '&nbsp;' + img
            else
              img := img + '&nbsp;';
            end;
            title:=GetStringField('m.title');
            movie := movie + '<li>';
            if not IconsOnTheRight then
            movie := movie + img;
            if year='' then
            movie:=movie+format('<a href="movie:%d">',
              [GetIntegerField('m.code')])+title+'</a>'
            else
            movie:=movie+format('<a href="movie:%d">%s</a> (%s)',
              [GetIntegerField('m.code'), title, year]);
            if rate <> '' then
            movie := movie + ' ' + rate;
            if GetStringField('e.filename') <> '' then
            movie:=movie+format('  <a href="playAlbum:%s">', [GetStringField('m.Code')])+format('<img src="%splay.png" align="absmiddle" border="0"></a>', [ImgPath]);
            if IconsOnTheRight then
            movie := movie + img;
            movie := movie + '</li>';
          end;
          GetNextRecord;
        end;
        movie:=movie+'</ol></div>';
        all:=all+movie;
        end;
      end;

      all := all + '</td></tr></table>';
    end;

    sl.Free;
    CodeList.Free;
    result:=all;
  finally
    ResetRegistrySubKey();
  end;
end;

begin

end.