﻿const
	script_name='cdon';
	language='Norwegian';
	version=6;
	author='Vlad';
	MinProgramBuild=8000;
	PCount = 12;
	//MaxPicturesCount = 3;
var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments, 
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList: boolean;
	MaxShotsCount, MaxPostersCount: integer;

	title, MovieName, s, s2, s3, s4, year, director, name, character, BasicURL, country, description, salary, awards: string;
	episodes, movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	i, j: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	rating, imdb_rating: double;
	front_cover_url: string;
	posters_exists, ask_amazon: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	RequestParameters: TStringList;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(s1, str);
	if I > 0 then
	begin
		J := MyPos(s2, str, I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;
	
function DeleteBadChars(text: String): String;
var
	i: Integer;
	s : String;
begin
	s := '';
	for i := 1 to Length(text) do begin
		if not (ord(text[i]) in [1..20]) then
			s := s + text[i];
	end;
	Result := s;
end;

function MovieSearch: integer;
var
	i, j, k, l: integer;
	title, tempCode, small_cover, year, director, description, temp: string;
begin
	s:='';
	titles_count:=0;
	i := Pos('<div class="search-results">', all);
	if i > 0 then begin
		delete(all, 1, i-1);
		i := Pos('<article class="product', all);
		while i > 0 do begin
			tempCode := GetStr(all, '<article class="product', '</article>');
			temp := GetStr(tempCode, 'class="category-title" value="', '"');
			if Pos('movie', LowerCase(temp)) > 0 then begin
				title := GetStr(tempCode, 'class="full-title" value="', '"');
				title_code := GetStr(tempCode, 'class="product-id" value="', '"');
				description := GetStr(tempCode, '<p class="description">', '</p>');
				small_cover := GetStr(tempCode, 'data-src="', '"');
				if (title <> '') and (title_code <> '') then begin
					Inc(titles_count);
					SetSearchResult2(title, title_code, '', '', description, small_cover);
				end;
			end;
			delete(all, 1, i);
			i := Pos('<article class="product', all);
		end;
	end;

	result:=titles_count;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
	url:=format('https://cdon.no/search?category=1769&q=%s', [MovieName]);
	url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
	result := format('https://cdon.no/film/s-%s', [code]);
end;



//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
  fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;



function GetInfo(url: string; images_only: boolean): string;
var 
	keyword, s, s2, s3, plot_outline, shot, shot_prefix, shot_ext, my_url, temp, small_photo: string;
	i, j, k, l, frames_count: integer;
	actors, awards_exist: boolean;
begin
	result:='';
	all := DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;
		
	movie_code := ParseString(url, '(\d+)$', 1);
	movie_site_url:=GetMovieSiteURL(movie_code);
	media_format := '';
		
	//movie title
	s := GetStr(all, '<h1', '</h1>');
	if s <> '' then
		s := RemoveTags('<' + s);
	title := ClearExtraBlankCharacters(DecodeHTML(s));
	i := Pos('(', title);
	if i > 0 then begin
		media_format := GetStr(title, '(', ')');
		media_format := ClearExtraBlankCharacters(DecodeHTML(media_format));
		delete(title, i, length(title)-i+1);
	end;
	title := ClearExtraBlankCharacters(title);
	if title='' then
		exit;
		
	//description
	description := GetStr(all, 'itemprop="description"', '</div>');
	if description <> '' then
		description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + description)));
	
	//movie details
	temp := GetStr(all, 'id="facts-', '</table>');
	
	//year
	year := GetStr(temp, '>Produksjons&#229;r:</th>', '</td>');
	year := ParseString(year, '(\d+)', 1);
	
	//original title
	original_title := GetStr(temp, '>Originaltittel:</th>', '</td>');
	original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(original_title)));
	
	//age certification
	mpaa := GetStr(temp, '>Alder:</th>', '</td>');
	mpaa := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(mpaa)));
	
	//genres
	s := GetStr(temp, '>Kategori:</th>', '</td>');
	s := RemoveTags(s);
	repeat
		i := Pos(',', s);
		if i > 0 then
			s2 := copy(s, 1, i-1)
		else
			s2 := s;
		s2 := ClearExtraBlankCharacters(DecodeHTML(s2));
		if s2 <> '' then
			SetGenre(s2);
		delete(s, 1, i);
	until i = 0;
	
	//duration
	duration := 0;
	s := GetStr(temp, '>Spilletid (min):</th>', '</td>');
	s2 := ParseString(s, '(\d+)', 1);
	if s2 <> '' then
		try
			duration := StrToInt(s2);
		except
		end;
	
	//cover
	front_cover_url := GetStr(all, 'class="product-image-container"', '</a>');
	front_cover_url := GetStr(front_cover_url, 'src="', '"');
	
	//actors
	s := GetStr(temp, '>Medvirkende:</th>', '</td>');
	i := Pos('<a href', s);
	while i > 0 do begin
		s2 := GetStr(s, '<a href', '</a>');
		if s2 <> '' then begin
			name := RemoveTags('<' + s2);
			code := ParseString(s2, '"/film/medvirkende/(.*?)/">', 1);
			SetPersonName(name, '', 3, code);
		end;
		delete(s, 1, i);
		i := Pos('<a href', s);
	end;
	
	//directors
	s := GetStr(temp, '>Regiss&#248;r:</th>', '</td>');
	i := Pos('<a href', s);
	while i > 0 do begin
		s2 := GetStr(s, '<a href', '</a>');
		if s2 <> '' then begin
			name := RemoveTags('<' + s2);
			code := ParseString(s2, '"/film/medvirkende/(.*?)/">', 1);
			SetPersonName(name, '', 1, code);
		end;
		delete(s, 1, i);
		i := Pos('<a href', s);
	end;
	
	//subtitles
	s := GetStr(temp, '>Tekst:</th>', '</td>');
	s := RemoveTags(s);
	repeat
		i := Pos(',', s);
		if i > 0 then
			s2 := copy(s, 1, i-1)
		else
			s2 := s;
		s2 := ClearExtraBlankCharacters(DecodeHTML(s2));
		if s2 <> '' then
			SetSubtitle(s2);
		delete(s, 1, i);
	until i = 0;
	
	//audio
	s := GetStr(temp, '>Spr&#229;k:</th>', '</td>');
	s := RemoveTags(s);
	repeat
		i := Pos(',', s);
		if i > 0 then
			s2 := copy(s, 1, i-1)
		else
			s2 := s;
		s2 := ClearExtraBlankCharacters(DecodeHTML(s2));
		if s2 <> '' then
			SetAudioTrack(s2);
		delete(s, 1, i);
	until i = 0;
	
	//dvd features
	s := GetStr(temp, '>Ekstramateriale:</th>', '</td>');
	features := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	
end;

//returned images links
procedure GetImages;
begin
	if front_cover_url<>'' then
		SetImageName('', front_cover_url, '', 1);
		//GetAmazonImages;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result := format('https://cdon.no/film/s-%s', [code]);
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://cdon.no/film/medvirkende/'+code+'/';
end;


begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

  RequestParameters := TStringList.Create();
  RequestParameters.Add('Host=cdon.no');
  //RequestParameters.Add('AcceptLanguage=en-US');
  RequestParameters.Add('Connection=Close'); 
  RequestParameters.Add('useragent=Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; WOW64; Trident/6.0)');

end.