﻿const
	script_name='cinematografo.it';
	language='Italian';
	version=2;
	author='Vlad';
	MinProgramBuild=8000;
	PCount = 12;
	//MAX_PHOTOS_COUNT = 3;
var
	DownloadPersonBiography, DownloadPersonAdditionalInfo: boolean;
	MaxPhotosCount: integer;
	persons_count: integer;
	persons: array of string;
	imdb_codes: array of string;
	imdb_code, person_code: string;
	name, code, year, description: string;
	person, BasicURL, biography, trivia, character, birth_date, birthplace, birth_name, salary, height, original_name, death_date, person_site_url: string;
	photo_url: string;
	monthes: array [1..12] of string;
	prefixes: array [1..PCount] of string;
	movie_html: string;
	person_height: integer;

function DeleteBadChars(text: String): String;
var
	i: Integer;
	s : String;
begin
	s := '';
	for i := 1 to Length(text) do begin
		if not (ord(text[i]) in [1..20]) then
			s := s + text[i];
	end;
	Result := s;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(s1, str);
	if I > 0 then
	begin
		J := MyPos(s2, str, I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;
	

function GetSearchURLbyName(PersonName: string): string;
var
	url: string;
begin
	PersonName := EncodeURL(PersonName, 'utf-8');
	url:='https://www.cinematografo.it/wp-content/themes/cinematografo-it/cinedatabase/ProxyCast.php?mdr=' + PersonName + '&page=1&order=titolofilm%20asc';
	//url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURLWithReferer(url, 'https://www.cinematografo.it/cinedatabase/ricerca-cast/?mdr=');
	if all='-1' then
		result:=-1
	else
		result:=PersonSearch;
end;

function PersonSearch: integer;
var
	url, s, s2, tempCode, small_photo, code, name, description: string;
	i, j, k: integer;
begin
	persons_count:=0;
	s:='';
	i := Pos('{"ID_ANAGRAFICA":', all);
	while (i > 0) do begin
		s := GetStr(all, '{"ID_ANAGRAFICA":', '}');
		code := ParseString(s, '^(\d+)', 1);
		name := GetStr(s, '"NOME":"', '"');
		s2 := GetStr(s, '"COGNOME":"', '"');
		if (name <> '') then begin
			if s2 <> '' then
				name := name + ' ' + s2;
		end
		else
			name := s2;
		description := GetStr(s, '"DATANASCITA":"', '"');
		j := Pos('12:00', description);
		if j > 0 then
			delete(description, j, length(description)-j+1);
		if (name <> '') and (code <> '') then begin
			Inc(persons_count);
			SetSearchResult2(name, code, '', '', description, '');
		end;
		delete(all, 1, i);
		i := Pos('{"ID_ANAGRAFICA":', all);
	end;	
	result:=persons_count;
end;

function GetPersonURL(code: string; images_only: boolean): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.cinematografo.it/cinedatabase/cast/p/'+code+'/';
end;



//returnes images links
procedure GetImages;
var
	img_cnt: Integer;
begin
	img_cnt := 0;
	if photo_url<>'' then begin
		SetImageName('', photo_url, '', 6);
		img_cnt := 1;
	end;
end;

function GetGoogleImage: boolean;
var
	all, url: string;
	i, j: integer;
begin
	url:=format('http://images.google.com/images?svnum=20&hl=en&lr=&safe=on&c2coff=1&q=%%22%s%%22', [person]);
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	i:=pos('dyn.Img(', all);
	if i>0 then begin
		i:=MyPos('","', all, i+1);
		i:=MyPos('","', all, i+1);
		i:=MyPos('","', all, i+1) + 3;
		j:=MyPos('","', all, i+1);
		if j>0 then begin
			url:=copy(all, i, j-i);
			SetImageName('', url, '', 6);
		end;
	end;
end;

function SavePhoto(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearBrackets(name: string): string;
var
	i: integer;
begin
	// clear word in brackets at the end of name
	i := pos(' (', name);
	if i>0 then
		name := copy(name, 1, i-1);
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;


function GetInfo(url: string; images_only: boolean): string;
var
	s, s2, s3, s4, day, month, year, side_details, temp, mov_title, mov_code, character: string;
	i, j, k, l, mode: integer;
	to_actor: boolean;
begin
	result:='';
	BasicURL:=url;
	person_code:=ParseString(url, '(\d+)/$', 1);
	person_site_url:=GetPersonSiteURL(person_code);
	all:=DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;
		
	//details
	temp := GetStr(all, 'class="content"', 'class="share"');
		
	//name
	person := GetStr(temp, 'itemprop="name">', '</h2>');
	person := RemoveTags(person);
	person := ClearExtraBlankCharacters(DecodeHTML(person));
	
	//original name
	i := Pos('(', person);
	original_name := GetStr(person, '(', ')');
	if i > 0 then
		delete(person, i, length(person)-i+1);
	person := ClearExtraBlankCharacters(person);
	
	//birth details
	s := GetStr(temp, '<div class="meta-info">', '</div>');
	death_date := '';
	i := Pos('<br>', s);
	if i > 0 then begin
		s2 := copy(s, i, length(s)-i+1);
		j := Pos(',', s2);
		while j > 0 do begin
			delete(s2, 1, j);
			j := Pos(',', s2);
		end;
		s2 := ClearExtraBlankCharacters(DecodeHTML(s2));
		day := ParseString(s2, '^(\d+)', 1);
		month := GetStr(s2, ' ', ' ');
		year := ParseString(s2, ' (\d+)$', 1);
		j := 1;
		while (j<=12) and (monthes[j]<>month) do
			j:=j+1;
		if (j<=12) and (month<>'') and (day <> '') then
			death_date:=IntToStr(j)+format('/%s/%s', [day, year]);
		delete(s, i, length(s)-i+1);
	end;
	//birth date and place
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	birthplace := '';
	birth_date := '';
	i := Pos(',', s);
	while i > 0 do begin
		birthplace := birthplace + copy(s, 1, i);
		delete(s, 1, i);
		i := Pos(',', s);
	end;
	if birthplace <> '' then begin
		delete(birthplace, length(birthplace), 1);
		birthplace := ReplaceStr(birthplace, ' (', ', ', -1);
		birthplace := ReplaceStr(birthplace, ')', '', -1);
	end;
	s := ClearExtraBlankCharacters(s);
	day := ParseString(s, '^(\d+)', 1);
	month := GetStr(s, ' ', ' ');
	year := ParseString(s, ' (\d+)$', 1);
	j := 1;
	while (j<=12) and (monthes[j]<>month) do
		j:=j+1;
	if (j<=12) and (month<>'') and (day <> '') then
		birth_date:=IntToStr(j)+format('/%s/%s', [day, year]);
	
	//biography
	temp := GetStr(all, 'BIOGRAFIA</h3>', '</section');
	photo_url := GetStr(temp, '<img src="', '"');
	biography := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	
	//filmography
	temp := GetStr(all, 'FILMOGRAFIA</h3>', '</section');
	i := Pos('<li>', temp);
	while i > 0 do begin
		s := GetStr(temp, '<li>', '</li>');
		mov_title := '';
		s2 := GetStr(s, '<a', '</a>');
		if s2 <> '' then
			mov_title := RemoveTags('<' + s2);
		mov_code := GetStr(s2, 'href="', '"');
		mov_code := ParseString(mov_code, '(\d+)$', 1);
		year := ParseString(mov_title, '^(\d+)', 1);
		j := Pos(' - ', mov_title);
		if j > 0 then
			delete(mov_title, 1, j+2);
		mov_title := ClearExtraBlankCharacters(DecodeHTML(mov_title));
		mov_title := LowerCase(mov_title);
		mov_title[1] := UpperCase(mov_title[1]);
		character := GetStr(s, '<i>', '</i>');
		s2 := '';
		j := Pos('</a> -', s);
		if j > 0 then
			s2 := copy(s, j, length(s)-j+1);
		j := Pos('<i>', s2);
		if j > 0 then
			delete(s2, j, length(s2)-j+1);
		if (mov_title <> '') then begin
			if Pos('Regia', s2) > 0 then
				SetMovieName(mov_title, '', 1, mov_code, year);
			if Pos('Sceneggiatura', s2) > 0 then
				SetMovieName(mov_title, '', 2, mov_code, year);
			if Pos('Attore', s2) > 0 then
				SetMovieName(mov_title, character, 3, mov_code, year);
			if Pos('Musiche', s2) > 0 then
				SetMovieName(mov_title, '', 4, mov_code, year);
			if Pos('Fotografia', s2) > 0 then
				SetMovieName(mov_title, '', 6, mov_code, year);
		end;
		delete(temp, 1, i);
		i := Pos('<li>', temp);
	end;
end;

	
//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.cinematografo.it/cinedatabase/film/s/'+code+'/';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.cinematografo.it/cinedatabase/cast/p/'+code+'/';
end;


begin

	monthes[1]:='gennaio';
	monthes[2]:='febbraio';
	monthes[3]:='marzo';
	monthes[4]:='aprile';
	monthes[5]:='maggio';
	monthes[6]:='giugno';
	monthes[7]:='luglio';
	monthes[8]:='agosto';
	monthes[9]:='settembre';
	monthes[10]:='ottobre';
	monthes[11]:='novembre';
	monthes[12]:='dicembre';

	prefixes[1]:='The';
	prefixes[2]:='A';
	prefixes[3]:='An';
	prefixes[4]:='La';
	prefixes[5]:='Les';
	prefixes[6]:='Des';
	prefixes[7]:='L''';
	prefixes[8]:='Un';
	prefixes[9]:='El';
	prefixes[10]:='Il';
	prefixes[11]:='Le';
	prefixes[12]:='Uno';

end.