﻿const
	script_name='Film.tv.it';
	language='Italian';
	version=38;
	author='Vlad';
	MinProgramBuild=6000;
	PCount = 12;
	//MaxPicturesCount = 3;
var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments, 
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList: boolean;
	MaxShotsCount, MaxPostersCount: integer;

	title, MovieName, s, s2, s3, s4, year, director, name, character, BasicURL, country, description, salary: string;
	episodes, movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	i, j: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	rating, imdb_rating: double;
	front_cover_url: string;
	posters_exists, ask_amazon: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	
	foto_referer, search_url: String;
	
function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function MovieSearch: integer;
var
	i, j, k, l: integer;
	title, year, description, small_cover, original_title: string;
begin
	s:='';
	titles_count:=0;
	//if the search is forwarded to the movie's page (only one result)
	if (pos('risultati per', all)<=0) then begin
		title_code:=ParseString(all, '<li id="sel"><a href="/scheda.php/film/(\d+)/', 1);
		if title_code<>'' then begin
			SetSearchResult('movie', title_code);
			titles_count:=1;
		end;
	end
	//otherwise check seach results
	else begin
		s := GetStr(all, 'class="serp-result"', '</section>');
		if (s='') or (pos('<p>Nessun risultato trovato.', all)>0) then
			//Movie not found
		else begin
			i := pos('<article',s);
			while i>0 do begin
				s2 := GetStr(s, '<article', '</article>');
				
				title := GetStr(s2, '<h2', '</h2>');
				title_code:=ParseString(title, ' href="/film/(\d+)/', 1);
				if title <> '' then
					title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + title)));

				small_cover := GetStr(s2, ' src="', '"');
				if Pos('DUMMY', small_cover) > 0 then
					small_cover := '';
        if (small_cover <> '') then
          small_cover := 'https://www.filmtv.it' + small_cover;
				
				description := GetStr(s2, '<p class="trama">', '</p>');
				description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));
				year := GetStr(s2, '<span class="anno">', '</span>');
				year := ParseString(year, '(\d+)', 1);
				
				original_title := GetStr(s2, 'Titolo originale:', '</li');
				original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(original_title)));
				
				if (title <> '') and (title_code <> '') then begin
					SetSearchResult2(title, title_code, year, original_title, description, small_cover, search_url);
					titles_count:=titles_count+1;
				end;
				delete(s, 1, i);
				i := pos('<article',s);
			end;
		end;
	end;
	result:=titles_count;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
	MovieName := EncodeURL(MovieName, 'utf-8');
	url:=format('https://www.filmtv.it/cerca/?q=%s&t=film', [MovieName]);
	//url:=ReplaceStr(url, ' ', '+', -1);
	search_url := url;
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
		result:=format('https://www.filmtv.it/film/%s/', [code]);
end;

//returned link to front cover
function GetAmazonImages: string;
var
	res, all, url, s, s2, s3, amazon_url: string;
	i, j: integer;
begin
	//discard info in brackets
	s:=original_title;
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [original_title]);
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	amazon_url:='';
	i:=pos('<Item>', all);
	while (i>0) and (amazon_url='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			s3:=DecodeHTML(s3);
			if s3<>'' then 
			begin
				//if title=s3 then begin //!!!
				if pos(UpperCase(original_title), UpperCase(s3))=1 then 
				begin
					amazon_url:=ParseString(s2, '<LargeImage><URL>(.*?)</URL>', 1);
				end;
			end;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	if amazon_url<>'' then begin
		SetImageName('', amazon_url, '', 1);
		res:=amazon_url;
	end;
	result:=res;
end;

//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
	fs: TFileStream;
	s, referer: string;
	i: integer;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank characters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;


function GetInfo(url: string; images_only: boolean): string;
var 
	keyword, s, s2, s3, plot_outline, shot, shot_prefix, shot_ext, temp, cast_url: string;
	i, j, k, frames_count, mode: integer;
	actors: boolean;
	film_dati: String;
begin
	result:='';
	all:=DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;
	cast_url := '';
	if (Pos('cast/', all) > 0) then begin
		cast_url := url + '1/cast/';
		AddRequestForHTMLPageContent(cast_url, True);
	end;

	movie_code:=ParseString(url, 'film/(\d+)/',1);
	movie_site_url:=GetMovieSiteURL(movie_code);
	foto_referer := movie_site_url + 'foto/';
	temp := GetStr(all, ' class="wrap-head"', 'class="cast"');
	if temp = '' then
		temp := GetStr(all, ' class="wrap-head"', '<menu');
	//movie title
	title:=GetStr(temp, '<h1', '/h1>');
	title:=GetStr(title, '>', '<');
	title:=RemoveTags(title);
	title:=DecodeHTML(title);
	title:=ClearExtraSpaces(title);
	i:=pos('>', title);
	if i>0 then
		delete(title, 1, i);
	i := Pos(' (', title);
	if i>0 then
		delete(title, i, length(title) - i + 1);
	title := ClearExtraQuotes(title);
	title := MovePrefixLeft(title);
	title := ClearExtraBlankCharacters(title);
	if title='' then
		exit;

	duration:=0;
	//original title
	original_title := GetStr(temp, '<h2>', '</h2>');
	original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(original_title)));
	
	//countries
	s := GetStr(temp, '</h2></li>', '<time>');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	repeat
		i := Pos('/', s);
		s2 := copy(s, i+1, length(s)-i);
		if (s2='USA') or (s2='Gran Bretagna') or (s2='Australia') then
			ask_amazon:=true;
		SetCountry(ClearExtraBlankCharacters(s2));
		delete(s, i, length(s)-i+1);
	until i = 0;
	
	//Year
	year := ParseString(temp, '<time>(\d+)</time>', 1);
	
	//Genre
	s := GetStr(temp, 'Genere:', '</li>');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	if s <> '' then
		SetGenre(s);
		
	
	//Duration
	duration := 0;
	s := GetStr(temp, 'durata', '''');
	s := ParseString(s, '(\d+)', 1);
	try
		duration:=StrToInt(s);
	except
	end;
	
	//cover
	s := GetStr(temp, 'class="locandina"', '</figure');
	front_cover_url := GetStr(s, ' src="', '"');
	if (Pos('/imgbank/DUMMY/locandina.gif', front_cover_url) > 0) or (Pos('no_locandina', front_cover_url) > 0) then
		front_cover_url := '';
		
	//description
	s := GetStr(all, '<h2>Trama</h2>', '</p>');
	description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	
	//rating
	rating := 0;
	s := GetStr(all, '<span data-updcnt="voto-ftv-film', '/span');
	s2 := GetStr(s, '>', '<');
	i := Pos('.', s2);
	if i > 0 then begin
		s2[i] := DecimalSeparator;
		try
			rating := StrToFloat(s2);
		except
		end;
	end;
		
	
	//cast
	temp := GetHTMLPageContentFromRequest(cast_url);
	s := GetStr(temp, 'class="cast"', '</section>');
	i := Pos('<article', s);
	while i > 0 do begin
		s2 := GetStr(s, '<article', '</article>');
		code := ParseString(s2, 'href="/persona/(\d+)', 1);
		name := GetStr(s2, '<h3', '</h3>');
		if name <> '' then
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + name)));
		shot := GetStr(s2, ' src="', '"');
		if (Pos('no_portrait', shot) > 0) then
			shot := '';
		if Pos('>Regia<', s2) > 0 then
			mode := 1
		else
			mode := 3;
		if (name <> '') then
			SetPersonName(name, '', mode, code, shot);
		delete(s, 1, i);
		i := Pos('<article', s);
	end;

end;

//returned images links
procedure GetImages;
var
	temp, s, s2: String;
	i, j: Integer;
begin
	if front_cover_url <> '' then
		SetImageName('', front_cover_url, '', 1, true, foto_referer);
		
	temp := GetStr(all, 'Foto Gallery', '</section>');
	i := Pos(' src="', temp);
	while i > 0 do begin
		s := GetStr(temp, ' src="', '"');
		if (s <> '') and (Pos('galleryxl', LowerCase(s)) > 0) then
			SetImageName('', s, '', 3, true, foto_referer);
		delete(temp, 1, i);
		i := Pos(' src="', temp);
	end;
	//if ask_amazon then
	//	GetAmazonImages;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.filmtv.it/film/'+code+'/';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.filmtv.it/persona/'+code+'/';
end;


begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.
