const
	script_name='Film.tv.it';
	language='Italian';
	version=12;
	author='Vlad';
	MinProgramBuild=7000;
	PCount = 12;
	//MAX_PHOTOS_COUNT = 3;
var
	persons_count: integer;
	persons: array of string;
	imdb_codes: array of string;
	imdb_code, person_code: string;
	name, code, year, description: string;
	person, BasicURL, biography, trivia, character, birth_date, birthplace, birth_name, salary, height, original_name, death_date, person_site_url: string;
	photo_url, foto_referer, SearchURL: string;
	monthes: array [1..12] of string;
	prefixes: array [1..PCount] of string;
	movie_html: string;
	person_height: integer;
	
function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank characters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;

function GetSearchURLbyName(PersonName: string): string;
var
	url: string;
begin
	PersonName := EncodeURL(PersonName, 'utf-8');
	url:=format('https://www.filmtv.it/cerca/?q=%s&t=persona', [PersonName]);
	//url:=ReplaceStr(url, ' ', '+', -1);
	SearchURL := url;
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=PersonSearch;
end;

function PersonSearch: integer;
var
	url, s, s2, small_photo, description, person_code, name: string;
	i, j, k: integer;
begin
	persons_count:=0;
	s:='';
	//we check if we're forwarded to the filmography page
	s2:=ParseString(all, '<title>(.*?)</title>', 1);
	i:=pos('risultati per', s2);
	if i<=0 then begin
		name:=ParseString(s2, '^(.*?) | Film.tv.it', 1);
		person_code:=ParseString(all, '/persona/(\d+)/.*?', 1);
		SetSearchResult(name, person_code);
		persons_count:=1;
		SetLength(persons, persons_count);
	end;

	//if it's a usual search results page
	if i>0 then begin
		s := GetStr(all, 'class="serp-result"', '</section>');
		if (s='') or (pos('<p>Nessun risultato trovato.', all)>0) then
			//Person not found
		else begin
			i := pos('<article',s);
			while i>0 do begin
				s2 := GetStr(s, '<article', '</article>');
				code := ParseString(s2, ' href="/persona/(\d+)', 1);
				name := GetStr(s2, '<h2', '</h2>');
				if (name <> '') then
					name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + name)));
				description := GetStr(s2, '<ul', '</ul>');
				if description <> '' then
					description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + description)));
				small_photo := GetStr(s2, ' src="', '"');
				if (Pos('no_portrait', small_photo) > 0) then
					small_photo := '';
        if (small_photo <> '') then
          small_photo := 'https://www.filmtv.it' + small_photo;

				if (Name <> '') and (code <> '') then begin
					Inc(persons_count);
					SetSearchResult2(name, code, '', description, '', small_photo, SearchURL);
				end;
				delete(s, 1, i);
				i := pos('<article',s);
			end;
		end;
	end;
	result:=persons_count;
end;

function GetPersonURL(code: string; images_only: boolean): string;
begin
		result:=format('https://www.filmtv.it/persona/%s/', [code])
end;


//returnes images links
procedure GetImages;
begin
	if photo_url<>'' then
		SetImageName('', photo_url, '', 6, true, foto_referer);
	//GetPhotos;
	//GetGoogleImage;
end;

function GetGoogleImage: boolean;
var
	all, url: string;
	i, j: integer;
begin
	url:=format('http://images.google.com/images?svnum=20&hl=en&lr=&safe=on&c2coff=1&q=%%22%s%%22', [person]);
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	i:=pos('dyn.Img(', all);
	if i>0 then begin
		i:=MyPos('","', all, i+1);
		i:=MyPos('","', all, i+1);
		i:=MyPos('","', all, i+1) + 3;
		j:=MyPos('","', all, i+1);
		if j>0 then begin
			url:=copy(all, i, j-i);
			SetImageName('', url, '', 6);
		end;
	end;
end;

function SavePhoto(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearBrackets(name: string): string;
var
	i: integer;
begin
	// clear word in brackets at the end of name
	i := pos(' (', name);
	if i>0 then
		name := copy(name, 1, i-1);
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes \xAB"\xBB
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // \xC2\xFB\xF0\xE5\xE7\xE0\xE5\xF2 \xEA\xF3\xF1\xEE\xEA \xF1\xF2\xF0\xEE\xEA\xE8 \xEC\xE5\xE6\xE4\xF3 s1 \xE8 s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;


function GetInfo(url: string; images_only: boolean): string;
var
	s, s2, s3, s4, one_movie: string;
	i, j, k, l, pages, mode, actor_start, next_page: integer;
	to_actor: boolean;
begin
	result:='';
	BasicURL:=url;
	person_code:=ParseString(url, 'persona/(\d+)/', 1);
	person_site_url:=GetPersonSiteURL(person_code);
	//url := url + person_code+'/filmografia';
	all:=DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;
	//name
	s := GetStr(all, 'scheda-persona-head', '</header');
	person:=GetStr(s, '<h1>', '</h1>');
	i := Pos('Filmografia', person);
	if i>0 then
		delete(person, 1, 15);
	person := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(person)));

	original_name:='';
	
	foto_referer := url;
	
	//photo
	s2 := GetStr(s, 'class="foto"', '</figure');
	photo_url := GetStr(s2, 'src="', '"');
	if Pos('DUMMY', photo_url) > 0 then
		photo_url := '';
	
	//filmography
	s2 := GetStr(all, 'id="item-list-container"', '</section>');
	i := Pos('<article', s2);
	while i > 0 do begin
		one_movie := GetStr(s2, '<article', '</article>');
		name := GetStr(one_movie, '<h2', '</h2>');
		code := ParseString(name, '/film/(\d+)', 1);
		if name <> '' then
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + name)));
		year := GetStr(one_movie, '<time>', '</time>');
		year := ParseString(year, '(\d+)', 1);
		s3 := GetStr(one_movie, '<p class="regia">', '</p>');
		if Pos(person, s3) > 0 then
			mode := 1
		else
			mode := 3;
		if name<>'' then
			SetMovieName(name, '', mode, code, year);
		delete(s2, 1, i);
		i := Pos('<article', s2);
	end;
end;

	
//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.filmtv.it/film/'+code+'/';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else	
		result:=format('https://www.filmtv.it/persona/%s/', [code]);
end;

begin
monthes[1]:='Janvier';
monthes[2]:='F\xE9vrier';
monthes[3]:='Mars';
monthes[4]:='Avril';
monthes[5]:='Mai';
monthes[6]:='Juin';
monthes[7]:='Juillet';
monthes[8]:='Ao\xFBt';
monthes[9]:='Septembre';
monthes[10]:='Octobre';
monthes[11]:='Novembre';
monthes[12]:='D\xE9cembre';

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.
