﻿//Fixed bug on Original title when using local service
//Added options - reorganized options interface

const
	script_name='imdb';
	language='Multiple';
	version=225;
	author='JeF';
	MinProgramBuild=8000;
	PCount = 12;
	main_server=['imdb.com', 'imdb.de', 'imdb.es', 'imdb.fr', 'imdb.it', 'imdb.pt'];
	defaultPicSizeX=800;
	defaultPicSizeY=600;

  USER_MOVIES_PER_PAGE = 100;
  LIST_MOVIES_URL_TEMPLATE = 'https://www.imdb.com/list/ls%s/?page=%d';
  USER_MOVIES_RATING_URL_TEMPLATE = 'https://www.imdb.com/user/ur%s/ratings?page=%d';

  USER_MOVIES_WATCHLIST_URL_TEMPLATE = 'https://www.imdb.com/user/ur%s/watchlist';
  USER_MOVIES_WATCHLIST_AJAX_URL_TEMPLATE = 'https://www.imdb.com/title/data?ids=%s' +
    '&tracking_tag=&pageId=%s&pageType=list&subpageType=watchlist';

var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast,
	DownloadMovieBigDescription, DownloadMovieComments,
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings,
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList, DownloadMovieLinks: boolean;
	MaxShotsCount, MaxPostersCount, MaxBackdropsCount: integer;
	// 10.11.2010
	MaxTrailersCount: Integer;
	DownloadSeasonsCovers: Boolean;
	DownloadEpisodesCovers: Boolean;
	DownloadedPersonPhotosForMovie: Integer;

	OvrMainDlOptions, DlOriginalTitle, DlYear, DlGenres, DlCountries, DlDuration, DlStudios, DlEpisodes : boolean;
	DlDirectors, DlActors, DlWriters, DlComposers, DlAwards, DlProducers, DlCameraMan : boolean;

	title, MovieName, MovieTitle, MovieYear, MovieBarcode, year, director, name, character, BasicURL, description, comments, country, salary, awards, tagline, media_type: string;
	movie_code, movie_site_url, title_code, imdb_code: string;
	duration: integer;
	titles_count: integer;
	i, j: integer;
	code: string;
	imdb_rating, rating: double;
	front_cover_url: string;
	posters_exist: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	monthes: array [1..12] of string;
	goCode: string;  // 20090519-JeF
	jShowTraceSettings, jTraceMode, jTraceLevel, jTraceAsk: integer;   // 20101017-JeF
	DownloadTrivia, DownloadGoofs, DownloadQuotes, DownloadConnections, DownloadSoundtracks, ImportDesc, AkaSearch, ShowPlotAuthors, EpisodeFullDesc, AkasInDesc, ImportMPAAReasons, IMDBLocalService: Integer;
	TitleLang, MPAADefault, MPAAReplace: String;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: String;
	SubtitlesCount: Integer;
	AudioTracksCount: Integer;
	tmdb_code, tvdb_code: String;
	RequestParameters, EpisodeURLs{, SeasonURLs}: TStringList;
	RequestParametersWithCookies: TStringList;
	EpisodesDownloading, PostersDownloading, BackdropsDownloading, ShotsDownloading, DlUnknown, TVDBNothingFound, TVDBSearchEnded: Boolean;
	UseTMDBPosters, UseTMDBSnapshots, DownloadTVDBEpisodeDescriptions, DownloadTVDBEpisodes,
    DownloadTVDBEnglishDesc, DownloadSeasonPosters, DownloadEpisodeImages,
    UseTVDBPosters, UseTVDBFanart, TVDBLID, DownloadActorsEpisodesForTVSeries: integer;
	
	f: TForm;
	b: TButton;
	edUserName, edPassword, edURL: TEdit;
	labCaption, labCaption2, labUserName, labPassword: TLabel;

	// 18.03.2013. Fade - global cookies from HTTPS
	GlobalHTTPSCookies: string;
	
	LatinTitle, ExTitle, ExYear, ExBarcode, ExSiteCode, ExOrigTitle: String;
	
function ParseTitleFormat(title, format: String): String;
const
	TITLE_VAR = '%T';
	YEAR_VAR = '%Y';
	BARCODE_VAR = '%B';
	SITE_CODE_VAR = '%C';
	ORIG_TITLE_VAR = '%O';
var
	i, j, k: Integer;
	s, extracted, temp: String;
begin
	exTitle := title;
	result := title;
	if Pos(TITLE_VAR, format) > 0 then begin
		i := Pos('%', format);
		while (i > 0) and (title <> '') do begin
			extracted := '';
			//copy the complete format to temp
			temp := format;
			//extract any characters before %
			if i > 1 then begin
				s := copy(format, 1, i-1);
				delete(format, 1, i-1);
				//update temp
				temp := format;
				k := Pos(s, title);
				if k > 0 then
					delete(title, 1, k+length(s)-1);
			end;
			// delete %
			delete(format, 1, 1);
			s := '';
			j := Pos('%', format);
			if j > 0 then
				s := copy(format, 2, j-2)
			else if length(format) > 1 then
				s := copy(format, 2, length(format)-1);
			if s <> '' then begin
				k := Pos(s, title);
				if k > 0 then begin
					extracted := copy(title, 1, k - 1);
					delete(title, 1, k + length(s) - 1);
				end;
			end;
			if extracted = '' then begin
				extracted := title;
				title := '';
			end;
			if Pos(TITLE_VAR, temp) = 1 then
				result := extracted
			else if Pos(YEAR_VAR, temp) = 1 then
				ExYear := extracted
			else if Pos(BARCODE_VAR, temp) = 1 then
				ExBarcode := extracted
			else if Pos(SITE_CODE_VAR, temp) = 1 then
				ExSiteCode := extracted;
			//delete the variable
			delete(format, 1, 1+length(s));
			i := Pos('%', format);
		end;
	end;
	exTitle := result;
end;


	
//determine if MovieName is a code number and remember this code  // 20090519-JeF
function checkCode(MovieName: string): Boolean;
var
	i,j: integer;
begin
	goCode:='';
	while (copy(MovieName,1,1)=' ') do delete(MovieName,1,1);
	while (copy(MovieName,length(MovieName),1)=' ') do delete(MovieName,length(MovieName),1);
	//Check if only a code
	i:=1;
	if (length(MovieName)>0) then goCode:=MovieName;
	while (i<length(goCode)) do begin 
		if (copy(goCode,i,1) < '0') or (copy(goCode,i,1) > '9') then goCode:='';
		i:=i+1;
	end;
	if (length(goCode)<7) then goCode:='';
	//Check if tt999999 somewhere in title
	i:=pos('TT',UpperCase(MovieName));
	while (i>0) and (goCode='') do begin
		j:=i+2;
		while (j<=length(MovieName)) and (goCode='') do begin
			if (copy(MovieName,j,1) < '0') or (copy(MovieName,j,1) > '9') then goCode:=copy(MovieName,i+2,j-i-2);
			if (j=length(MovieName)) and (goCode='') then goCode:=copy(MovieName,i+2,j-i-1);  //20120414-JeF
			j:=j+1;
		end;
		if (length(goCode)<7) then goCode:='';
		i:=MyPos('TT',UpperCase(MovieName),i+1);
	end;
	result:=(goCode>'');
end;
	
function MovieSearch: integer;
const
	pop_match=['<p><b>Popular Titles</b>', '<p><b>Meistgesuchte Titel</b>', 'tulos Populares</b> (Mostrando', '<p><b>Titres Populaires</b>', '<p><b>Titoli popolari</b>', 'tulos Populares</b> (Exibir'];
	exact_match=['<p><b>Titles (Exact Matches)', '<p><b>Titel (genaue ', 'tulos (Resultados Exactos)</b> (Mostrando', 'sultats Exacts)</b> (Affichant', '<p><b>Titoli (risultati esatti)', 'tulos (Exato)</b> (Exibir'];
	partial_match=['<p><b>Titles (Partial Matches)</b>', '<p><b>Titel (teilweise ', 'tulos (Resultados Parciales)</b> (Mostrando', 'sultats Partiels)</b>', '<p><b>Titoli (risultati parziali)', 'o Parcial)</b> (Exibir'];
	no_match=['<b>No Matches.</b>', '<b>Keine Treffer.</b>', '<b>No hay resultados.</b>', '<b>Pas de ', '<b>Nessun risultato.</b>', '<b>Busca imcompat'];
var
	i, j, k, l, next_section: integer;
	title, s, s2, s3, year, original_title, description, small_cover: string;
begin
	//is MovieName a code number ? Yes => force url and only ONE result to continue directly to movie download // 20090519-JeF
	if length(goCode)>0 then begin
		titles_count:=1;
		SetSearchResult(goCode, goCode);
		result:=titles_count;
		exit;
	end;

	s:='';
	next_section:=0;
	titles_count:=0;
	
	//this is for the method used with barcodes
	i := Pos('<table class="results">', all);
	if i>0 then begin
		j := MyPos('</table>', all, i+1);
		s := copy(all, i, j-i);
		if s<>'' then begin
			i := Pos('<tr class="even detailed">', s);
			delete(s, 1, i-1);
			i := Pos('</tr>', s);
			while i>0 do begin
				s2 := copy(s, 1, i-1);
				k := Pos('<a href="/title/tt', s2);
				if k>0 then begin
					j := MyPos('</a>', s2, k + 1);
					s3 := copy(s2, k, j-k);
					title_code := ParseString(s3, '<a href="/title/tt(\d+)/', 1);
					title := ParseString(s3, '\/" title="(.*?)"><img', 1);
					title := DecodeHTML(title);
					small_cover := ParseString(s3, '<img src="(.*?).jpg" ', 1);
					if small_cover <>'' then
						small_cover := small_cover + '.jpg';
					if title_code <> '' then begin
						titles_count := titles_count + 1;
						SetSearchResult2(title, title_code, '', '', '', small_cover);
					end;
				end;
				delete(s, 1, i+3);
				i := Pos('</tr>', s);
				if MovieBarcode <> '' then
					i := 0; //let's grab only the first result
			end;
		end;
	end
	else begin	
		//new search design - 2012-11-28
		i := Pos('<a name="tt"></a>Titles</h3>', all);
		if i>0 then begin
			j := MyPos('</table>', all, i+1);
			s := copy(all, i, j-i);
			if s <> '' then begin
				i := Pos('<tr class="findResult', s);
				while i>0 do begin
					s2 := GetStr(s, '<tr class="findResult', '</tr>');
					title := GetStr(s2, '<td class="result_text">', '</a>');
					title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(title)));
					title_code := ParseString(s2, '<a href="/title/tt(\d+)', 1);
					s3 := GetStr(s2, '<td class="result_text">', '</td>');
					k := Pos('</a>', s3);
					delete(s3, 1, k + 3);
					year := ParseString(s3, '.*? \((\d+)\)', 1);
					description := ParseString(s2, '\(\d+\) \((.*?)\)', 1);
					description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));
					small_cover := GetStr(s2, ' src="', '"');
					small_cover := ReplaceStr(small_cover, 'https://images-na.ssl-images-amazon.com', 'https://ia.media-imdb.com', -1);
					if (Pos('nopicture', small_cover)>0) then
						small_cover := '';
					original_title := '';
					original_title := GetStr(s3, '<i>', '</i>');
					original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(original_title)));
					if (Pos('Video Game', description)>0) then
						title := '';
					if (title <> '') and (title_code <> '') then begin
						inc(titles_count);
						SetSearchResult2(title, title_code, year, original_title, description, small_cover);
					end;
					delete(s, 1, i);
					i := Pos('<tr class="findResult', s);
				end;
			end;
		end
		//end new search design -2012-11-28
		else begin
			i := Pos(exact_match[ifthen((AkaSearch=1),0,0)], all);    //20110123-JeF
			j := Pos('<p><b>Titles (Approx Matches)</b> (Displaying', all);
			k := Pos(pop_match[ifthen((AkaSearch=1),0,0)], all);      //20110123-JeF
			l := Pos(partial_match[ifthen((AkaSearch=1),0,0)], all);  //20110123-JeF
			if (k<i) and (k>0) then begin
				next_section := i;
				i := k;
			end
			else if (i=0) then
				i := k
			else
				next_section := k;
			if (l<j) and (l>0) then
				j := l;
			if (i=0) and (k=0) then
				i := j;
			//for the movie info page (no search results shown)
			s3 := ReplaceStr('href="https://www.imdb.com/title/tt', 'imdb.com', main_server[ifthen((AkaSearch=1),0,0)], -1);    //20110123-JeF
			if i=0 then begin
				if (Pos('<h1', all)>0) then begin
					i := Pos('<link rel="canonical" ' + s3, all);
					if i>0 then begin
						j := MyPos('>', all, i+1);
						s := copy(all, i, j-i);
						title_code := ParseString(s, s3+'(\d+)"', 1);
						if title_code = '' then
							title_code := ParseString(s, s3+'(\d+)/', 1);
						titles_count := 1;
						SetSearchResult('title', title_code);
						i := 0;
						s := '';
					end;
				end;
			end;
			//end for short titles
			if i>0 then begin
				j:=MyPos('</td></tr></table>', all, i+1);
				if j>0 then
					s:=copy(all, i+3, j-i-3);
			end;

			if (s='') or (pos(no_match[ifthen((AkaSearch=1),0,0)], all)>0) then
				//Movie not found
			else begin
				repeat
				  i := pos('<table>',s);
				  s := copy(s,i+7,length(s));
				  i:=pos('</tr>', s);
				  if i=0 then
					i:=next_section;
				  if i=0 then
					i:=Length(s);
				  while i>0 do begin
						titles_count:=titles_count+1;
						s2:=copy(s, 1, i-1);

						j:=Pos('<a href="/title/tt', s2);
						k:=MyPos('</a>', s2, j+1);
						s3:=copy(s2, j, k-j);
						title_code:=ParseString(s3, '<a href="/title/tt(\d+)/"', 1);
						
						title := '';
						k := Pos('<br><a href="/title/', s2);
						if k=0 then
							k := Pos('<td valign="top"><a href="/title/', s2);
						if k>0 then begin
							l := MyPos('</a>', s2, k+1);
							title := copy(s2, k, l-k);
						end;
						title:=RemoveTags(title);
						title:=DecodeHTML(title);
						title:=ClearExtraSpaces(title);
						
						original_title := '';
						
						year := '';
						k := Pos('</a> (', s2);
						if k>0 then begin
							l := MyPos(')', s2, k);
							year := copy(s2, k+6, l-k-6);
						end;
						
						small_cover := '';
						k := Pos('<img src="https://ia.media-imdb.com/images/', s2);
						if k >0 then begin
							l := MyPos('"', s2, k+11);
							small_cover := copy(s2, k+10, l-k-10);
							k := Pos('_V1._', small_cover);
							if k = 0 then
								k := Pos('_V1_', small_cover);
							if k>0 then begin
								l := MyPos('_.', small_cover, k+5);
								s3 := copy(small_cover, l, length(small_cover)-l+1);
								delete(small_cover, k+5, length(small_cover)-k-4);
								//set maximum image resolution
								small_cover := small_cover + 'SY100_SX100' +  s3;
							end;
						end;
						
						description := '';
						k := Pos('<p ', s2);
						if k>0 then begin
							description := copy(s2, k, length(s2)-k+1);
							description := ReplaceStr(description, '</p>', ' ', -1);
							description := RemoveTags(description);
							description := DecodeHTML(description);
							description := ClearExtraSpaces(description);
						end;
						// showMessage(description);
						
						while (length(title)>0) and (title[1]=' ') do
							delete(title, 1, 1);
						SetSearchResult2(title, title_code, year, original_title, description, small_cover);
						delete(s, 1, i+4);
						i:=pos('</tr>', s);
						if i=0 then
							i:=Length(s);
					end;
					//this will work for short titles
					i:=next_section;
					next_section:=MyPos(partial_match[ifthen((AkaSearch=1),0,0)], all, i+1);
					s:='';
					if i>0 then begin
						j:=MyPos('</td></tr></table>', all, i+1);
						if j>0 then
							s:=copy(all, i+3, j-i-3);
					end;
				until s='';
				//end sort titles
			end;
		end;
	end;
	//if nothing is found by title and year, then try again by title only
	if (titles_count = 0) and (MovieYear <> '') then begin
		s := GetSearchURLByName(MovieTitle, '', '');
		all := DownloadURL(s, False, RequestParametersWithCookies);
		result := MovieSearch;
		exit;
	end;
	result:=titles_count;
end;

//get movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('https://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url, False, RequestParametersWithCookies);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

// 18.03.2013. Fade - function connects to imdb using given ALogin-APassword
function ConnectToIMDB(ALogin: string; APassword: string): Boolean;
const
  LOGIN_FORM_URL = 'https://secure.imdb.com/oauth/login?origurl=https://www.imdb.com/&show_imdb_panel=1';
  ENABLE_ADULT_CONTENT_URL = 'https://www.imdb.com/find';
  HIDDEN_VALUE_NAME = '49e6c';
  HIDDEN_VALUE_SEARCH = 'input type="hidden" name="' + HIDDEN_VALUE_NAME + '" value="';
var
  I: Integer;
  HiddenValue: string;
  HiddenValuePos: Integer;
  LoginFormContent, ResponsePage: string;
begin
  // open login form for parsing hidden value
  Result := True;
  LoginFormContent := DownloadURLWithRefererThroughHTTPS(LOGIN_FORM_URL, '',
    GlobalHTTPSCookies);
  HiddenValue := '';
  HiddenValuePos := MyPos(HIDDEN_VALUE_SEARCH, LoginFormContent, -1);
  // if hidden value wasn't found - we already connected to IMDB
  if (HiddenValuePos > 0) then
  begin
    HiddenValuePos := HiddenValuePos + Length(HIDDEN_VALUE_SEARCH);
    if (MyPos('"', LoginFormContent, HiddenValuePos) > 0) then
    begin
      // connect to IMDB taking into account hidden value/login/password
      HiddenValue := Copy(LoginFormContent, HiddenValuePos,
        MyPos('"', LoginFormContent, HiddenValuePos) - HiddenValuePos);
      if (HiddenValue <> '') then
      begin
        // now connect to imdb
        ResponsePage := DownloadURLWithRefererThroughHTTPS(LOGIN_FORM_URL, LOGIN_FORM_URL, GlobalHTTPSCookies,
          [HIDDEN_VALUE_NAME + '=' + HiddenValue, 'login=' + ALogin, 'password=' + APassword]);
        // enable adult content
        DownloadURLWithRefererThroughHTTPS(ENABLE_ADULT_CONTENT_URL, '', GlobalHTTPSCookies,
          ['q=', 's=all', 'ttype=', 'toggleAdult=1']);
		//check if the login was successful
		if (Pos('<h1>Sign in ', ResponsePage) > 0) then Result := False;
      end;
    end;
  end;
end;
//Get search URL by movie name
function GetSearchURLbyName(MovieName: string; AYear: string; ABarcode: String): string;
var
	url, s: string;
	i: integer;
	site: string;		// 20090701-JeF
begin
	exYear := '';
	exTitle := '';
	exSiteCode := '';
	exBarcode := '';
	if RegReadInteger('IMDbParseTitles', 0) = 1 then begin
		s := RegReadString('IMDbParseFormat', '%T');
		MovieName := ClearExtraBlankCharacters(ParseTitleFormat(MovieName, s));
		exYear := ParseString(exYear, '(\d+)', 1);
		if (exYear <> '') and (AYear = '') then
			AYear := exYear;
	end;

	s := copy(MovieName, 1, Length(MovieName));
	s := ClearExtraBlankCharacters(s);
	s := EncodeURL(s, 'utf-8');
	
	MovieTitle := MovieName;
	MovieYear := AYear;
	MovieBarcode := ABarcode;
	if AYear <> '' then begin
		i := Pos(' (', s);
		if i>0 then
			delete(s, i, length(s)- i + 1);
		url := Format('https://www.imdb.com/search/title?release_date=%s,%s&title=%s', [AYear, AYear, s]);
		url:=ReplaceStr(url, ' ', '+', -1);
	end
	else begin
		if AkaSearch=1 then site:='https://akas.imdb.com/'
		else site:='https://www.imdb.com/';
		url:=site+format('find?q=%s&s=tt&ref_=fn_al_tt_ex', [s]);
		url:=ReplaceStr(url, ' ', '+', -1);
		goCode := '';
		if (length(s)>5) and (checkCode(s)) then url:=GetMovieSiteURL(goCode);  // 20090519-JeF
	end;
	result:=url;
end;
procedure LoginButtonClick(Sender: TButton);
begin
	if (edUserName.Text <> '') and (edPassword.Text <> '') then begin
		UserName:=edUserName.Text;
		UserPassword:=edPassword.Text;
		SaveLoginInfo(UserName, UserPassword, script_name);
		if ConnectToIMDB(UserName, UserPassword) then
			f.ModalResult := mrOk
		else begin
			showMessage(GetLangStr(3707));
			f.ModalResult := mrNone;
		end;
	end
	else begin
		if (edUserName.Text = '') then
			ShowMessage(GetLangStr(3708))
		else if (edPassword.Text = '') then
			ShowMessage(GetLangStr(3709));
		f.ModalResult := mrNone;
	end;
end;

procedure ShowLoginForm;
begin
	f := TForm.Create(nil);
	f.Caption := GetLangStr(3701) + ': IMDb';
	f.BorderStyle := bsDialog;
	f.Position := poScreenCenter;
	f.Width:=400;


	labCaption := TLabel.Create(f);
	labCaption.Name := 'labCaption';
	labCaption.Parent := f;
	labCaption.SetBounds(10, 10, 380, 25);
	labCaption.Caption := GetLangStr(3701) + ': IMDb';

	labUserName := TLabel.Create(f);
	labUserName.Name := 'labUserName';
	labUserName.Parent := f;
	labUserName.SetBounds(10, 40, 100, 25);
	labUserName.Caption := GetLangStr(1835) + ':';

	edUserName := TEdit.Create(f);
	edUserName.Name := 'Name';
	edUserName.Parent := f;
	edUserName.SetBounds(120, 40, 175, 25);
	edUserName.Text := UserName;

	labPassword := TLabel.Create(f);
	labPassword.Name := 'labPassword';
	labPassword.Parent := f;
	labPassword.SetBounds(10, 70, 380, 25);
	labPassword.Caption := GetLangStr(1836) + ':';

	edPassword := TEdit.Create(f);
	edPassword.Name := 'edPassword';
	edPassword.Parent := f;
	edPassword.SetBounds(120, 70, 175, 25);
	edPassword.Text := UserPassword;

	b := TButton.Create(f);
	b.Name := 'btnOK';
	b.Parent := f;
	b.SetBounds(300, 70, 75, 25);
	b.Caption := GetLangStr(3693);
	b.OnClick := @LoginButtonClick;


	labCaption2 := TLabel.Create(f);
	labCaption2.Name := 'labCaption2';
	labCaption2.Parent := f;
	labCaption2.SetBounds(10, 100, 275, 25);
	labCaption2.Caption := GetLangStr(3717) + ':';

	edURL := TEdit.Create(f);
	edURL.Name := 'URL';
	edURL.Parent := f;
	edURL.SetBounds(10, 125, 370, 25);
	edURL.Text := 'https://secure.imdb.com/register-imdb/form-v2';

	f.ShowModal;
	f.Free;
end;


//Download search results from URL
function DownloadSearchURL(url: string): integer;
var
	s: String;
begin
	exSiteCode := ClearExtraBlankCharacters(exSiteCode);
	if exSiteCode <> '' then begin
		if exTitle <> '' then
			s := exTitle
		else
			s := exSiteCode;
		SetSearchResult(s, exSiteCode);
		result := 1;
	end
	else begin
		if (jTraceLevel > 0) then TraceAlert;   				 // 20101017-JeF
		all:=DownloadURL(url, False, RequestParametersWithCookies);
		if (jTraceLevel >= 1) then TraceExecute('Search',all);   // 20101017-JeF
		if all='-1' then
			result:=-1
		else
			result:=MovieSearch;
	end;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
	if images_only then
		result:=format('https://www.imdb.com/title/tt%s', [code])
	else
		result:=format('https://www.imdb.com/title/tt%s/reference', [code])
end;

                          
//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
  fs: TFileStream;
	s: string;
begin
	all:=DownloadURL(url, False, RequestParametersWithCookies);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;

function RemoveSpacesInText(text: String): String;
var
	i: Integer;
begin
	i := Pos('  ', text);
	while i>0 do begin
		delete(text, i, 1);
		i := Pos('  ', text);
	end;
	result := text;
end;

function ExtractAwards(text: String): String;
var
	s, temp, s2, aw_owner, aw_name, aw_status, aw_year, aw_subj, aw_persons, prev_aw_name, prev_aw_year: String;
	i, j, k, l: Integer;
begin
	Result := '';
	i := Pos('<h3>', text);
	while i > 0 do begin
		j := Pos('</table>', text);
		s := copy(text, 1, j-1);
		aw_owner := GetStr(s, '<h3>', '<a ');
		aw_owner := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(aw_owner)));
		if Result <> '' then
			Result := Result + #13#10#13#10;
		Result := Result + aw_owner;
		aw_year := GetStr(s, 'class="event_year"', '</h3>');
		aw_year := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(aw_year, '>', '</a>'))));
		k := Pos('<tr>', s);
		while k > 0 do begin
			temp := GetStr(s, '<tr>', '</tr>');
			aw_persons := '';
			aw_status := GetStr(temp, 'class="title_award_outcome"', '<br');
			aw_status := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(aw_status, '<b>', '</b>'))));
			aw_name := GetStr(temp, 'class="award_category"', '/span>');
			aw_name := ClearExtraBlankCharacters(DecodeHTML(GetStr(aw_name, '>', '<')));
			aw_subj := GetStr(temp, 'class="award_description"', '<br');
			l := Pos('>', aw_subj);
			if l > 0 then
				delete(aw_subj, 1, l);
			aw_subj := ClearExtraBlankCharacters(DecodeHTML(aw_subj));
			l := Pos('href="/name/', temp);
			while l > 0 do begin
				s2 := GetStr(temp, 'href="/name/', '/a>');
				s2 := GetStr(s2, '>', '<');
				s2 := ClearExtraBlankCharacters(DecodeHTML(s2));
				if s2 <> '' then begin
					if aw_persons <> '' then
						aw_persons := aw_persons + ', ';
					aw_persons := aw_persons + s2;
				end;
				delete(temp, 1, l);
				l := Pos('href="/name/', temp);
			end;
			if (aw_name <> '') and (prev_aw_name <> aw_name) then begin
				Result := Result + #13#10 + aw_name;
				prev_aw_name := aw_name;
				if aw_year <> '' then
					Result := Result + ' - ' + aw_year;
			end;
			if aw_status <> '' then
				Result := Result + #13#10 + aw_status;
			if aw_subj <> '' then begin
				Result := Result + #13#10 + aw_subj;
				if aw_persons <> '' then
					Result := Result + ' : ' + aw_persons;
			end;
			delete(s, 1, k);
			k := Pos('<tr>', s);
		end;
		delete(text, 1, j);
		i := Pos('<h3>', text);
	end;
end;

procedure ParseImageSizeFromURL(AURL: string; var AHeight: Integer; var AWidth: Integer);
var
  TempStr: string;
  SearchCount: Integer;
  Index: Integer;
  DeltaX: Integer;
  DeltaY: Integer;
begin
  if (AURL <> '') then
  begin
    AHeight := 0;
    AWidth := 0;
    Index := Length(AURL);
    SearchCount := 0;
    TempStr := '';
    DeltaX := 0;
    DeltaY := 0;

    if (AURL[Index] = '_') then
    begin
      Dec(Index);
      while ((Index > 0) and
             (SearchCount < 4)) do
      begin
        if ((AURL[Index] = ',') or
            (AURL[Index] = 'R')) then
        begin
          case SearchCount of
            0: AHeight := StrToInt(TempStr);
            1: AWidth := StrToInt(TempStr);
            2: DeltaY := StrToInt(TempStr);
            3: DeltaX := StrToInt(TempStr);
          end;
          TempStr := '';
          Inc(SearchCount);
        end
        else
          TempStr := AURL[Index] + TempStr;
        Dec(Index);
      end;
    end;
    if (AWidth > 0) then
      AWidth := AWidth + Round(2 * DeltaX);
    if (AHeight > 0) then
      AHeight := AHeight + Round(2 * DeltaY);
  end;
end;

//gets movie frames
function GetFramesPreview(AMovieCode: string; frame_type: string; frame_limit, frame_code: integer): integer;
var
  url, all, s, frame_url: string;
  preview_url: string;
  i, j, k, picSizeX, picSizeY: Integer;
  frames_count: Integer;
  Height: Integer;
  Width: Integer;
  SizeURL: string;
begin
  frames_count:=0;
  if frames_count=0 then
  begin
    picSizeX := 150;
    picSizeY := 150;
    url := 'https://www.imdb.com/title/tt' + AMovieCode + '/mediaindex?refine='+frame_type;
    all:=DownloadURL(url, False, RequestParametersWithCookies);
    if (all <> '')and(all <> '-1') then
    begin
      j := pos('<div class="thumb_list"', all);
      k := MyPos('</div>', all, j);
      if (j>0) and (k>0) then begin
        s := copy(all, j, k-j);
        i := pos(' src=', s);
        delete(s,1,i);
        while (i>0) and (frames_count<frame_limit) do begin
          i:= pos('"', s) + 1;
          j:= MyPos('"', s, i+1);
          frame_url:=copy(s, i, j-i);
          //cut off the filename of the url
          i:= pos('V1._', frame_url);
		  if i = 0 then
			i:= pos('V1_', frame_url);
          if i>0 then
          begin
            SizeURL := frame_url;
            if Pos('_SS', SizeURL) > 0 then
              SIzeURL := copy(SizeURL, 1, Pos('_SS', SizeURL));

            frame_url:=copy(frame_url, 1, i+1);
            //insert the pattern to load the larger image
            preview_url := frame_url;
            preview_url := preview_url + '_SX' + IntToStr(picSizeX);
            preview_url := preview_url + '_SY' + IntToStr(picSizeY);
            preview_url := preview_url + '_';

            ParseImageSizeFromURL(SizeURL, Height, Width);
            frame_url:=frame_url+'.jpg';
            preview_url := preview_url + '.jpg';
          end;
          SetImagePreviewLink(preview_url, frame_url, frame_code, Height, Width);
          frames_count:=frames_count+1;
          i:=pos(' src=', s);
          delete(s, 1, i);
        end;
      end;
    end;
  end;
  result := frames_count;
end;


procedure GetImagesPreview(url: string);
const
  MAX_LOAD_IMAGE_COUNT = 100;
var
  I: Integer;
  J: Integer;
  S: string;
  S2: string;
  DownloadStr: string;
  BasicURL: string;
  FrontCoverUrl: string;
  PostersExists: Boolean;
  ImdbCode: string;
  MovieCode: string;

  PreviewURL: string;
	shots_downloaded, shots_left, posters_downloaded, bts_downloaded: Integer;   //20101017-JeF
  // fade
  Height: Integer;
  Width: Integer;
  SizeURL: string;
begin
	i:=pos('/combined', url);
	if I>0 then
		BasicURL:=copy(url, 1, i-1)
	else
		BasicURL:=url;
	DownloadStr := DownloadURL(ReplaceStr(BasicURL, 'imdb.com', main_server[0], -1), False, RequestParametersWithCookies);
	imdbCode := ParseString(url, '//www.imdb.com/title/tt(\d+)', 1);
	MovieCode := ImdbCode;
  FrontCoverUrl := '';
	if ((DownloadStr <> '-1') and
      (DownloadStr <> '')) then
  begin
    // search front cover
    s2 := '<a name="poster" href="photogDownloadStrery" ';
    i := pos(s2, DownloadStr);
    if i=0 then begin
      s2 := '<a name="poster" href="';
      i := pos(s2, DownloadStr);
    end;
    if i=0 then
      i := Pos('id="img_primary">', DownloadStr);
    if i=0 then
      i := Pos('<div class="media_strip_thumbs">',DownloadStr);   //20101017-JeF
    if i > 0 then
    begin
      j := MyPos('</a>', DownloadStr, i+1);
      s := copy(DownloadStr, i, j-i);
      //do not download any video frames
      if (Pos('<img class="video"', s) = 0) then
      begin
        i := MyPos('src="',DownloadStr,i+1) + 5;
        j := MyPos('"',DownloadStr,i+1);
        if j > 0 then
        begin
          FrontCoverUrl := copy(DownloadStr,i,j-i);
          i:=pos('V1._', FrontCoverUrl);
		  if i = 0 then
			i:=pos('V1_', FrontCoverUrl);
          if (i>0) then
          begin
            SizeURL := FrontCoverUrl;
            if Pos('_SS', SizeURL) > 0 then
              SIzeURL := copy(SizeURL, 1, Pos('_SS', SizeURL))
            else if Pos('_.jpg', SizeURL) > 0 then
              SizeURL := copy(SizeURL, 1, Pos('_.jpg', SizeURL));
            FrontCoverUrl:=copy(FrontCoverUrl, 1, i+1);
            PreviewURL := FrontCoverUrl;
            ParseImageSizeFromURL(SizeURL, Height, Width);
            FrontCoverUrl := FrontCoverUrl+'.jpg';

            PreviewURL := PreviewURL + '_SX' + IntToStr(150);
            PreviewURL := PreviewURL + '_SY' + IntToStr(150);
            PreviewURL := PreviewURL + '_';
            PreviewURL := PreviewURL+'.jpg';
            SetImagePreviewLink(PreviewURL, FrontCoverUrl, 1, Height, Width);
          end;
        end;
      end;
    end;

    PostersExists := False;
    s := '/title/tt' + MovieCode + '/posters';
    if pos(s, DownloadStr)>0 then
      PostersExists:=true;


    shots_downloaded := GetFramesPreview(MovieCode, 'still_frame', MAX_LOAD_IMAGE_COUNT, 3);
    // posters and shots
    if PostersExists then
      posters_downloaded := GetFramesPreview(MovieCode, 'poster', MAX_LOAD_IMAGE_COUNT, 4);
    bts_downloaded := GetFramesPreview(MovieCode, 'behind_the_scenes', MAX_LOAD_IMAGE_COUNT, 3);
    //20101017-JeF : No image found, try with no frame type
    // GetFramesPreview(MovieCode, '', MaxPostersCount + MaxShotsCount, 6);
  end;
end;

procedure ExtractPeople(text: string; start, mode: integer; marker: string = '');
var
	ends, i, j: Integer;
	s, temp, name, code: String;
begin
	if start > 0 then begin
		ends := MyPos('</table>', text, start + 1);
		if ends > 0 then begin
			s := copy(text, start, ends - start);
			i := Pos('href="/name/nm', s);
			while i > 0 do begin
				temp := GetStr(s, 'href="/name/nm', '</tr>');
				if (marker = '') or (Pos(marker, temp) > 0) then begin
					code := ParseString(temp, '^(\d+)', 1);
					name := GetStr(temp, '>', '</');
					name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(name)));
					if (name <> '') then begin
						SetPersonName(name, '', mode, code);
					end;
				end;
				delete(s, 1, i);
				i := Pos('href="/name/nm', s);
			end;
		end;
	end;
end;

function GetInfo(url: string; images_only: boolean): string;
const
	user_rating_name=['<h5>User Rating:</h5>', '<h5>Nutzer-Bewertung:</h5>', '<h5>Calificaci', '<h5>Note G', '<h5>Voti degli utenti:</h5>', '<h5>Classifica'];
	cert_name=['<h5>Certification:</h5>', '<h5>Altersfreigabe:</h5>', '<h5>Clasificaci', '<h5>Classification:</h5>', '<h5>Divieti:</h5>', '<h5>Certifica'];
	fun_stuff_name=['<h3>Fun Stuff</h3>', '<h3>Unterhaltsames</h3>', '<h3>Cosas divertidas</h3>', '<h3>Curiosit', '<h3>Info divertenti</h3>', '<h3>Fatos engra'];
	fun_facts_name=['<h2>Fun Facts</h2>', '<h3>Unterhaltsames</h3>', '<h3>Cosas divertidas</h3>', '<h3>Curiosit', '<h3>Info divertenti</h3>', '<h3>Fatos engra'];	
	director_short_cast=['Director:', 'Regisseur:', 'Director:', 'alisateur</h5>', '<h5>Regista', '<h5>Diretor:'];
	directors_short_cast=['Directors:', 'Regisseur:', 'Director:', 'alisateur</h5>', '<h5>Regista', '<h5>Diretor:'];
	writer_short_cast=['Writer:', '<h5>Drehbuchautor', '<h5>Guionista', '<h5>Sc', '<h5>Sceneggiatore', '<h5>Roteirista'];
	writers_short_cast=['Writers:', '<h5>Drehbuchautor', '<h5>Guionista', '<h5>Sc', '<h5>Sceneggiatore', '<h5>Roteirista'];
	runtime_name=['Runtime:', 'nge:</h5>', '<h5>Duraci', '<h5>Dur', '<h5>Durata:</h5>', '<h5>Dura'];
	genre_name=['Genre:', '<h5>Genre:</h5>', 'nero:</h5>', '<h5>Genre:</h5>', '<h5>Genere:</h5>', 'nero:</h5>'];
	genres_name=['Genres:', '<h5>Genre:</h5>', 'nero:</h5>', '<h5>Genre:</h5>', '<h5>Genere:</h5>', 'nero:</h5>'];
	country_name=['Country:', '<h5>Land:</h5>', '<h5>Pa', '<h5>Pays:</h5>', '<h5>Nazionalit', '<h5>Pa'];
	studio_name=['Production Co:', '<h5>Firma:</h5>', '<h5>Compa', '<h5>Soci', '<h5>Compagnia:</h5>', '<h5>Companhia :'];
	studio2_name=['Production Comp', '<h5>Firma:</h5>', '<h5>Compa', '<h5>Soci', '<h5>Compagnia:</h5>', '<h5>Companhia :'];
	plot_name=['<h5>Plot:</h5>', '<h5>Handlung:</h5>', '<h5>Trama:</h5>', '<h5>Intrigue:</h5>', '<h5>Trama:</h5>', '<h5>Argumento:</h5>'];
	story_name=['<h2>Storyline</h2>', '<h5>Handlung:</h5>', '<h5>Trama:</h5>', '<h5>Intrigue:</h5>', '<h5>Trama:</h5>', '<h5>Argumento:</h5>'];
	aka_name=['<h5>Also known as:</h5>', '<h5>Auch bekannt als:</h5>', '<h5>Conocido como:</h5>', '<h5>Alias:</h5>', '<h5>Alias:</h5>', 'Conhecido Como:</h5>'];
	original_title_name=['(original title)','(Originaltitel)','tulo original)','(titre original)','(titolo originale)','tulo original)'];  //20111009-JeF
	episodes_name=['Seasons', 'Staffeln', 'Temporadas', 'Saisons', 'Stagioni', 'Temporadas'];
	
var 
	keyword, s, s2, s3, s4, plot_outline, photo_url, temp, temp1: string;
	i, j, kol, k, l, m, p, season, episode, last_season: integer;
	AirDate, EpisodeTitle, EpisodeIMDB, EpisodeDescription, EpisodeCover, day, month, ayear: string;
	LoadSummary, LoadSynopsis: boolean;					//20090317-JeF
	EpisodeUrl, EpisodePage, EpFullDesc: string;		//20090709-JeF
	TVShow, GetOriginalTitle, FirstMethod, isTVSeries: boolean;
	FunStuffInfo, LocalURL, EpisodeRequestURL: string;								// 20090808-JeF
	sl: TStringList;    //20110114-JeF
	RequestURL, TVDBURL, TMDBURL: string;
	picSizeX, picSizeY, EpCnt, TitleLangMatchCnt: Integer;
	SeasonList: TStringList;
	FirstCountry: string;
begin
	// 05.04.2012. Fade: add initialization of the local variables
	plot_outline := '';
	FunStuffInfo := '';
    media_type := '';
	FirstCountry := '';
	TitleLangMatchCnt := 0;
	if (RegReadInteger('IMDBDlUnknown', 1) = 1) then
		DlUnknown := True
	else
		DlUnknown := False;
		
	picSizeX := RegReadInteger('IMDBPicSizeX', defaultPicSizeX);
	picSizeY := RegReadInteger('IMDBPicSizeY', defaultPicSizeY);

	EpisodeURLs := TStringList.Create;
	result:='';
	i:=pos('/reference', url);
	LocalURL := ReplaceStr(url, 'imdb.com', main_server[0], -1);
	if i>0 then
		BasicURL:=copy(url, 1, i-1)
	else
		BasicURL:=url;

	imdb_code:=ParseString(url, '//www.imdb.com/title/tt(\d+)', 1);
	movie_code:=imdb_code;
	movie_site_url:=GetMovieSiteURL(movie_code);
	
	if DownloadMovieAdditionalInfo or DownloadMovieEarnings then begin
		if (BasicURL <> url) then
			AddRequestForHTMLPageContent(BasicURL);
	end;

  // Fade: add threaded Requests for page
  // add request for full credits URL
  AddRequestForHTMLPageContent('https://www.imdb.com/title/tt'+movie_code+'/fullcredits', False);
  // add request for awards
  if DownloadMovieAwards or (OvrMainDlOptions and DlAwards) then
	AddRequestForHTMLPageContent(BasicURL+'/awards', False);
  // add request for akas
  AddRequestForHTMLPageContent(BasicURL+'/releaseinfo', False);
  // add request for trivia
	if DownloadMovieAdditionalInfo then begin
		AddRequestForHTMLPageContent(BasicURL + '/trivia', False);
	end;
  // add request for goofs
  if (DownloadGoofs = 1) then 
    AddRequestForHTMLPageContent(BasicURL + '/goofs', False);
  // add request for quotes
  if (DownloadQuotes = 1) then
    AddRequestForHTMLPageContent(BasicURL + '/quotes', False);
  // add request for movie connection
  if DownloadMovieLinks then
    AddRequestForHTMLPageContent(BasicURL + '/movieconnections', False, '', '', RequestParameters);
  // add request for soundtracks
  if (DownloadSoundtracks = 1) then
    AddRequestForHTMLPageContent(BasicURL + '/soundtrack', False);
  // add requests for trailers
  if (MaxTrailersCount > 0) then
    AddRequestForHTMLPageContent('https://www.imdb.com/title/tt' + movie_code + '/videogallery', False);
  // plot
  AddRequestForHTMLPageContent(BasicURL + '/plotsummary', False);
  AddRequestForHTMLPageContent(ReplaceStr(BasicURL, 'imdb.com',
    main_server[0], -1) + '/plotsummary', False);
	
	

	// add requests for images
	RequestURL := 'https://www.imdb.com/title/tt'+movie_code+'/mediaindex?refine=';

	if (MaxShotsCount > 0) then begin
		AddRequestForHTMLPageContent(RequestURL + 'still_frame', False);
		AddRequestForHTMLPageContent(RequestURL + 'behind_the_scenes', False);
		AddRequestForHTMLPageContent(RequestURL, False);
	end;
  // FAde - end adding request for additional pages

	if (jTraceLevel > 0) then TraceAlert;   			   // 20101017-JeF
	if DownloadMovieFullCast then
		all:=DownloadURLWithReferer(LocalURL, '', False, RequestParametersWithCookies)
	else
		all:=DownloadURLWithReferer(ReplaceStr(BasicURL, 'imdb.com', main_server[0], -1), '', False, RequestParametersWithCookies);

	if all='-1' then
		result:='-1'
	else
		result:=all;
		
		
	GetOriginalTitle := False;
	s2:=GetStr(all, '<title>', '</title>');
	//type of the video
	if Pos('(V)', s2) > 0 then
		media_type := 'Video';
	if Pos('(TV)', s2) > 0 then
		media_type := 'TV movie';
	if Pos('TV Series:</h5>', all) > 0 then
		media_type := 'TV episode';
	//movie year
	year := ParseString(s2, '\((\d+)\)', 1);
	if year = '' then begin
		s3 := GetStr(all, '<h1', '</h1>');
		year := GetStr(s3, '<a href="/year/', '/');
		year := ParseString(year, '(\d+)', 1);
		if year = '' then
			year := ParseString(s2, '\((\d+)', 1);
		if year = '' then
			year := ParseString(s2, '\(TV Series (\d+)', 1);
	end;
	//movie title
	title:=ParseString(s2, '^(.*?) \(', 1);
	title:=RemoveTags(title);
	if (Pos('&#', title)>0) then
		GetOriginalTitle := True;
	title:=DecodeHTML(title);
	title:=ClearExtraSpaces(title);
	title := ClearExtraQuotes(title);
	title := MovePrefixLeft(title);
	
	if Pos('IMDb - ', title)>0 then
		delete(title, 1, 7);
		
	posters_exist:=true;
		
	if posters_exist and (MaxPostersCount > 0) then begin
		AddRequestForHTMLPageContent(RequestURL + 'poster', False);
	end;
		
	EpisodesDownloading := False;
	PostersDownloading := False;
	BackdropsDownloading := False;
	//detect if this is a tv series
	isTVSeries := False;
	TVDBNothingFound := True;
	TVDBSearchEnded := True;
	temp := format('<h5>%s:</h5>', [episodes_name[0]]);
	temp1 := 'tt' + movie_code + '/episodes';
	if (Pos(temp, all)>0) or (Pos('<h4 class="inline">Season: </h4>', all)>0) or (Pos(temp1, all)>0) then
		isTVSeries := True;
		
	//download information from thetvdb, if applicable
	if isTVSeries and ((DownloadTVDBEpisodes = 1) or (((UseTVDBPosters=1) or (not posters_exist)) and (MaxPostersCount>0)) 
	or ((UseTVDBFanart=1) and (MaxBackdropsCount>0))) then begin
		if (DownloadTVDBEpisodes = 1) then
			EpisodesDownloading := True;
		if (UseTVDBPosters=1) and (MaxPostersCount>0) then
			PostersDownloading := True;
		if (UseTVDBFanart=1) and (MaxBackdropsCount>0) then
			BackdropsDownloading := True;
		TVDBURL := format('https://www.thetvdb.com/search?q=%s&l=en', [title]);
		TVDBURL := ReplaceStr(TVDBURL, ' ', '+', -1);
		AddRequestForHTMLPageContent(TVDBURL, False, '', 'OnTVDBMainPageLoaded');
		TVDBNothingFound := False;
		TVDBSearchEnded := False;
	end;
	//download information from themoviedb, if applicable
	if (not isTVSeries) and (((UseTMDBPosters=1) or (not posters_exist)) and (MaxPostersCount > 0)) or ((UseTMDBSnapshots=1) and (MaxBackdropsCount > 0)) then begin
		if (UseTMDBPosters=1) and (MaxPostersCount > 0) then
			PostersDownloading := True;
		if (UseTMDBSnapshots=1) and (MaxBackdropsCount > 0) then
			BackdropsDownloading := True;
		TMDBURL := format('https://www.themoviedb.org/search/movie?query=%s&movie_page=&movie_collection_page=&person_page=&company_page=&keyword_page=&active=0', [title]);
		TMDBURL := ReplaceStr(TMDBURL, ' ', '+', -1);
		AddRequestForHTMLPageContent(TMDBURL, False, '', 'OnITDBLoaded');
	end;
	//seasons
	if isTVSeries then begin
		while not TVDBSearchEnded do
			Application.ProcessMessages;
	end;
	SeasonList := TStringList.Create;
	if DownloadMovieSeasonsList and ((DownloadTVDBEpisodes = 0) or TVDBNothingFound) then begin
		EpisodeRequestURL := 'https://www.imdb.com/title/tt'+movie_code+'/episodes/_ajax?season=';
		if isTVSeries then begin
			i := Pos(temp1, all);
			FirstMethod := False;
			if i=0 then begin
				i := Pos('<h4 class="inline">Season: </h4>', all);
				FirstMethod := True;
			end;
			j := MyPos('</div>', all, i+1);
			s := copy(all, i, j-i);
			i := 1;
			p := 0;
			if FirstMethod then
				i := Pos('href="episodes?', s);
			while i>0 do begin
				j := MyPos('</a>', s, i+1);
				s2 := copy(s, i, j-i);
				s2 := '<' + s2;
				s2 := RemoveTags(s2);
				if LowerCase(s2) = 'unknown' then
					s2 := '-1';
				if Length(s2) < 3 then begin
					try
						p := StrToInt(s2);
					except
					end;
					SeasonList.Add(s2);
					AddRequestForHTMLPageContent(EpisodeRequestURL + s2, False);
				end;
				delete(s, 1, j);
				i := Pos('<a href', s);
				if FirstMethod then
					i := Pos('href="episodes?', s);
			end;
			while (p > 0) do begin
				SeasonList.Add(IntToStr(p));
				AddRequestForHTMLPageContent(EpisodeRequestURL + IntToStr(p), False);
				p := p - 1;
			end;
		end;
	end;
		
		
	if (jTraceLevel >= 2) then TraceExecute('Info',all);   // 20101017-JeF

	
	original_title := '';
	if DlOriginalTitle then begin
		i := Pos('<span class="title-extra">', all);
		if i>0 then begin
			j := MyPos(' <i>(original title)', all, i+1);
			if j>i then begin
				s2 := copy(all, i+26, j-i-26);
				s2 := DecodeHTML(s2);
				if s2 <>'' then begin
					original_title := s2;
					GetOriginalTitle := True;    //20110113-JeF
				end;
			end;
		end;
		if (original_title = '') then begin
			s2 := GetStr(all, '<h3 itemprop="name">', '(original title)');
			if s2 <> '' then begin
				original_title := GetStr(s2, '</h3>', '<');
				original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(original_title)));
			end;
		end;
	end;
	
	
	//replace title with original title, if a localized version was received
//	if GetOriginalTitle and (original_title <> '') then
//		title := original_title;
	//copy title to original title, if there is no original title
	if (original_title = '') and DlOriginalTitle then
		original_title := title;
	if title='' then
		exit;
		

	sl:=TStringList.Create;
	
	//imdb rating
	imdb_rating:=0;
	rating:=0;
	s := GetStr(all, 'rating-star__rating">', '</span>');
	s := ClearExtraBlankCharacters(RemoveTags(s));
	i:=pos('.', s);
	if i>0 then
		s[i]:=DecimalSeparator;
		try
			imdb_rating:=StrToFloat(s);
			rating:=imdb_rating;
		except
		end;
	
	//mpaa
	s2 := '';
	mpaa:=MPAADefault;
	mpaa_rating:='';
	i:=pos('<h5><a href="/mpaa">MPAA</a>:</h5>', all);    // 20091120-JeF
	if i=0 then
		i:=Pos('ng (<a href="/mpaa">MPAA</a>)</h4>', all);
	if i>0 then begin
		j:=MyPos('</div>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i+34, j-i-34);    // 20091120-JeF
			i := Pos('<span', s2);
			if i>0 then
				delete(s2, i, length(s2) - i + 1);
		end;
	end
	else begin
		s2 := GetStr(all, 'Certification</td>', '</ul>');
		mpaa := GetStr(s2, 'United States:', '</');
	end;
	if (mpaa = '') then begin
		//alternative mpaa
		i := Pos('<span itemprop="contentRating">', all);
		if i>0 then begin
			j:= MyPos('</span>', all, i+1);
			s2 := copy(all, i+length('<span itemprop="contentRating">'), j-i-length('<span itemprop="contentRating">'));
		end;
		
		//extract mpaa
		i:=pos('Rated ', s2);
		if i>0 then begin
			delete(s2, 1, i+5);
			i:=pos(' ', s2);
			if i>0 then begin
				mpaa:=copy(s2, 1, i-1);
				delete(s2, 1, i);
				if ImportMPAAReasons = 1 then begin
					mpaa_rating:=s2;
				end;
			end;
		end;
	end;

	//certification
	i := Pos('Certification', all);
	if i>0 then begin
		j := MyPos('</ul>', all, i+1);
		s := copy(all, i, j-i);
		MPAAReplace := UpperCase(MPAAReplace);
		s := UpperCase(RemoveTags(s));
		i := Pos(MPAAReplace, s);
		s2 := '';
		if i>0 then begin
			i := MyPos(':', s, i+1);
			j := MyPos(' ', s, i+1);
			s2 := copy(s, i+1, j-i-1);
		end;
		if s2<>'' then
			mpaa := s2;
	end;
	
	//Tagline
	tagline := '';
	i:=Pos('Taglines</td>', all);
	if i>0 then begin
		s := GetStr(all, 'Taglines</td>', '</td>');
		i := Pos('<a ', s);
		if i>0 then
			delete(s, i, length(s)-i+1);
		s := RemoveTags(s);
		s := DecodeHTML(s);
		i := Pos('(season', LowerCase(s));
		if i>0 then
			delete(s, i, length(s)-i+1);
		i := Pos('(re-release', s);
		if i>0 then
			delete(s, i, length(s)-i+1);			
		tagline := ClearExtraBlankCharacters(s);
	end;
		
	// 20090808-JeF_Begin : Add Fun Stuff at bottom of description
	i:=pos(fun_stuff_name[0],all);
	if i=0 then
		i:=Pos('<h3>Did You Know?</h3>', all);
	if i=0 then
		i:=Pos('<h2>Did You Know?</h2>', all);
	if (i>0) then begin
		j:=MyPos('<hr/>',all,i+1);
		if j=0 then
			j := MyPos('<noscript>', all, i+1);
		FunStuffInfo:=copy(all,i,j-i);
	end;
	// 20090808-JeF_End
	
	if i=0 then begin
		i:=pos(fun_facts_name[0],all);
		if (i>0) then begin
			j:=MyPos('<h2>',all,i+1);
			FunStuffInfo:=copy(all,i,j-i);
		end;		
	end;
	
	// 20090710-JeF_Begin : Person search for TV shows differs from a movie search : cast is on another page...
	TVShow:=isTVSeries;
	// 20100221-JeF //if (pos('<a href="episodes" class="link">', all)>0) then begin
	// 20100921-JeF //if (pos('href="episodes" class="link">', all)>0) then begin   // 20100221-JeF
	if (TVShow) then begin   // 20100921-JeF
		//TVShow:=true;
		EpisodeUrl:='https://www.imdb.com/title/tt'+movie_code+'/fullcredits';
		// EpisodePage:=DownloadURL(EpisodeUrl);
    EpisodePage := GetHTMLPageContentFromRequest(EpisodeUrl);
		if (jTraceLevel >= 3) then TraceExecute('FullCredits',all);   // 20101017-JeF
		if (EpisodePage='-1') then EpisodePage:='';
	end;
	// 20090710-JeF_End
	
	//movie directors
	if DlDirectors then begin
		if (TVShow) then begin
			i := Pos('Directed by', EpisodePage);
			ExtractPeople(EpisodePage, i, 1);
		end
		else begin
			i := Pos('id="directors"', all);
			ExtractPeople(all, i, 1);
		end;
	end;
	
	
	//movie writers
	if DlWriters then begin
		if (TVShow) then begin
			i := Pos('Writing Credits', EpisodePage);
			ExtractPeople(EpisodePage, i, 2);
		end
		else begin
			i := Pos('id="writers"', all);
			ExtractPeople(all, i, 2, '(screenplay by)');
			ExtractPeople(all, i, 2, '(written by)');
		end;
	end;

	//movie composers
	if DlComposers then begin
		if (TVShow) then begin
			i := Pos('Music by', EpisodePage);
			ExtractPeople(EpisodePage, i, 4);
		end
		else begin
			i := Pos('id="composers"', all);
			ExtractPeople(all, i, 4);
		end;
	end;
	
	//movie producers
	if DlProducers then begin
		if (TVShow) then begin
			i := Pos('Produced by', EpisodePage);
			ExtractPeople(EpisodePage, i, 5);
		end
		else begin
			i := Pos('id="producers"', all);
			ExtractPeople(all, i, 5, '>producer<');
		end;
	end;

	//movie cameraman
	if DlCameraMan then begin
		if (TVShow) then begin
			i := Pos('Cinematography by', EpisodePage);
			ExtractPeople(EpisodePage, i, 6);
		end
		else begin
			i := Pos('id="cinematographers"', all);
			ExtractPeople(all, i, 6);
		end;
	end;
	
	//movie cast
	if DlActors then begin
		i:=pos('<table class="cast">', all);
		if i=0 then
			i := Pos('<table class="cast_list">', all);
		if TVShow then i:=pos('<table class="cast', EpisodePage);   // 20090710-JeF
		if i>0 then begin
			j:=MyPos('</table>', all, i+1);
			if TVShow then j:=MyPos('</table>', EpisodePage, i+1);   // 20090710-JeF
			if j>0 then begin
				kol:=0;
				s2:=copy(all, i, j-i);
				if TVShow then s2 := copy(EpisodePage, i, j-i);   // 20090710-JeF
				if length(s2)>0 then begin
					i:=pos('</tr>', s2);
					while (i>0) and (kol<=MaxPersonsCount) do begin
						s3:=copy(s2, 1, i+4);
						code:=ParseString(s3, ' href="/name/nm(\d+)/', 1);
						// 20090626-JeF // name:=ParseString(s3, '<a href="/name/nm\d+/">(.*?)</a>', 1);
						name := GetStr(s3, 'title="', '"');
						if (name = '') then
							name:=ParseString(s3, 'link=/name/nm\d+/.;">(.*?)</a>', 1);  // 20090626-JeF
						photo_url := GetStr(s3, 'loadlate="', '"');
						if (photo_url <> '') then
							photo_url := GetStr(photo_url, '/images/', '_V1');
						if photo_url = '' then
							photo_url := GetStr(s3, 'loadlate="https://ia.media-imdb.com/images/', '_V1');
						if photo_url = '' then begin
							photo_url := ParseString(s3, 'src="https://ia.media-imdb.com/images/(.*?)\._SY44_', 1);
							if photo_url = '' then
								photo_url := ParseString(s3, '<img src="(.*?)\._SY30_SX23_.jpg"', 1);
							if photo_url = '' then
								photo_url := ParseString(s3, 'src="https://ia.media-imdb.com/images/(.*?)\._SX32_', 1);
							if photo_url = '' then
								photo_url := ParseString(s3, 'src="https://ia.media-imdb.com/images/(.*?)\._SX23_', 1);
							if photo_url = '' then
								photo_url := ParseString(s3, 'src="https://images-na.ssl-images-amazon.com/images/(.*?)\._SX23_', 1);
							if photo_url = '' then
								photo_url := GetStr(s3, 'loadlate="https://ia.media-imdb.com/images/', '_SX32');
							if photo_url = '' then
								photo_url := GetStr(s3, 'loadlate="https://ia.media-imdb.com/images/', '_SY');
						end;
						if photo_url <> '' then
							photo_url := 'https://ia.media-imdb.com/images/' + photo_url;
						if photo_url <> '' then begin
							if picSizeX>0 then
								photo_url := photo_url + '_SX' + IntToStr(picSizeX);
							if picSizeY>0 then
								photo_url := photo_url + '_SY' + IntToStr(picSizeY);
							if (picSizeX>0) or (picSizeY>0) then
								photo_url := photo_url + '_';
							photo_url := photo_url + '.jpg';
						end;
						if (RemoveTags(name)='') then 
							name:=ParseString(s3, ' href="/name/nm.*?">(.*?)</a>', 1);   // 20090710-JeF
						//2011-11-07 Vlad
						if (name='') then
							name :=ClearExtraBlankCharacters(RemoveTags(ParseString(s3, '<td class="name">(.*?)</td>', 1)));
						j:=pos(' ...', s3);
						if j>0 then begin
							character:=s3;
							delete(character, 1, j+length(' ...')-1);
							character:=RemoveTags(character);
							character:=DecodeHTML(character);
							j:=pos(' ...',character);   // 20090710-JeF
							if (j>0) then delete(character,j-1,6);   // 20090710-JeF
							//remove (as <actor's name>) in the character string
							j:=Pos('(', character);
							if IntToBool(RegReadInteger('IMDBFullCharacterName', 0)) then j:=0;   //20120414-JeF
							// 20100921-JeF //if (j>0) then
              // 20.12.2012 - Fade (add option for actors episodes downloading)
							if (j>0) and ((not TVShow) or (not IntToBool(DownloadActorsEpisodesForTVSeries))) then  // 20100921-JeF
								delete(character, j, length(character)-j+1);
							character := ReplaceStr(character, #10, '', -1);
							j := Pos('  ', character);
							while j > 0 do begin
								delete(character, j, 1);
								j := Pos('  ', character);
							end;
							character:=ClearExtraSpaces(character);
						end
						// 20090714-JeF_Begin
						else if TVShow then begin
							character:='';
							j:=pos('<td class="char">',s3);
							k:=MyPos('</td>',s3,j+1);
							s3:=copy(s3,j,k-j+5);
							s3:=RemoveTags(s3);
							s3:=DecodeHTML(s3);
							s3:=ClearExtraSpaces(s3);
							if (pos('(',s3)>0) and (pos(')',s3)>0) then character:=s3;
						end
						// 20090714-JeF_End
						else
							character:='';
						name:=RemoveTags(name);
						name:=DecodeHTML(name);
						name:=ClearExtraSpaces(name);
						if name<>'' then begin
							SetPersonName(name, character, 3, code, photo_url);
							kol:=kol+1;
						end;
						delete(s2, 1, i+4);
						i:=pos('</tr>', s2);
					end;
				end
			end;
		end;
	end;
	

	//movie image
	s := 'class="poster"';
	i := Pos(s, all);
	if i = 0 then
		s := 'alt="Poster';
	i := Pos(s, all);
	if i > 0 then begin
		s2 := GetStr(all, s, '</div>');
		front_cover_url := GetStr(s2, 'src="', '"');
	end;
	
	
	if front_cover_url = '' then begin
		s2 := '<a name="poster" href="photogallery" ';
		i := pos(s2, all);
		if i=0 then begin
			s2 := '<a name="poster" href="';
			i := pos(s2, all);
		end;
		if i=0 then
			i := Pos('id="img_primary">', all);
		if i=0 then
			i := Pos('<div class="media_strip_thumbs">',all);   //20101017-JeF
		if i > 0 then begin
			j := MyPos('</a>', all, i+1);
			s := copy(all, i, j-i);
			//do not download any video frames
			if (Pos('<img class="video"', s) = 0) then
		begin
				i := MyPos('src="',all,i+1) + 5;
				j := MyPos('"',all,i+1);
				if j > 0 then begin
					front_cover_url := copy(all,i,j-i);
				end;
			end;
		end;
		
		if front_cover_url = '' then
			front_cover_url := GetStr(all, 'rel="image_src" href="', '"');
	end;
	
	front_cover_url := ResizeIMDBImage(front_cover_url);
	
	//movie duration (minutes)
	duration:=0;
	if DlDuration then begin
		i := Pos('Runtime:', all);
		if i>0 then begin
			j := MyPos('</div>', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('|', s);
			if i > 0 then
				delete(s, i, length(s)-i+1);
			i := Pos('(', s);
			if i>0 then
				delete(s, i, length(s) - i + 1);
			s2:=ParseString(s, '.*?(\d+?) ', 1);
			duration:=0;
			if s2<>'' then
				try
					duration:=StrToInt(s2);
				except
				end;
		end;
	end;
	
	if DlDuration and (duration = 0) then begin
		s := GetStr(all, 'Runtime</td>', '</ul>');
		s2 := ClearExtraBlankCharacters(RemoveTags(s));
		s2 := ParseString(s2, '(\d+)', 1);
		if s2<>'' then
			try
				duration:=StrToInt(s2);
			except
			end;
	end;

	//movie genres
	if DlGenres then begin
		i := Pos('Genres</td>', all);
		if i=0 then
			i := Pos('Genre</td>', all);
		if i>0 then begin
			j := MyPos('</ul>', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('<a href="/genre/', s);
			while (i > 0) do begin
				s2 := GetStr(s, '<a href="/genre/', '</');
				if (s2 <> '') then begin
					s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)));
					SetGenre(s2);
				end;
				delete(s, 1, i);
				i := Pos('<a href="/genre/', s);
			end;
		end;
	end;

	//movie countries
	if DlCountries then begin
		i := Pos('Country</td>', all);
		if i>0 then begin
			j :=MyPos('</ul>', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('<a href="/country/', s);
			while (i > 0) do begin
				s2 := GetStr(s, '<a href="/country/', '</');
				if (s2 <> '') then begin
					s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)));
					SetCountry(s2);
				end;
				delete(s, 1, i);
				i := Pos('<a href="/country/', s);
			end;
		end;
	end;
	
	//original_title
	if (1>0) and DlOriginalTitle then begin
		i := Pos(aka_name[0], all);
		if i>0 then begin
			{ 20111009-JeF
			i := MyPos('>"', all, i+1);
			if i>0 then begin
				j := MyPos('"', all, i+2);
				original_title := copy(all, i+2, j-i-2);
				original_title := DecodeHTML(original_title);
			end;  
			20111009-JeF }
			// 20111009-JeF
			i := i + length(aka_name[0]);
			j := MyPos('<h', all, i+1);
			if j>0 then begin
				s := copy(all, i, j-i);
				i := 1;
				while (j>0) do begin
					j := Pos('<br>', s);
					if (j>0) then begin
						s2 := copy(s,i,j);
						k := Pos(original_title_name[0], s);
						if k>0 then begin
							s2 := copy(s2,1,k-1);
							s2 := RemoveTags(s2);
							s2 := ClearExtraBlankCharacters(s2);
							if pos('"',s2) >0 then begin
								while s2[length(s2)] <> '"' do delete(s2,length(s2),1);
							end;
							s2 := ClearExtraQuotes(s2);
							s2 := DecodeHTML(s2);
							original_title := s2;
							j := 0;
						end;
					end;
					delete(s, 1, j+3); //Vlad
				end;
			end;
		end;
	end;
	
	//movie studios
	if DownloadMovieStudios or (OvrMainDlOptions and DlStudios) then begin
		i := Pos('Production Companies</h4>', all);
		if i=0 then
			i := Pos(studio2_name[0], all);
		if i>0 then begin
			j := MyPos('</ul>', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('<a href="/company/', s);
			while (i > 0) do begin
				s2 := GetStr(s, '<a href="/company/', '</');
				if (s2 <> '') then begin
					s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)));
					SetStudio(s2);
				end;
				delete(s, 1, i);
				i := Pos('<a href="/company/', s);
			end;
		end;
	end;		

	plot_outline := GetStr(all, '"titlereference-section-overview"', '</');
	if (plot_outline <> '') then
		plot_outline := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + plot_outline)));
	description := plot_outline;
	
	i := Pos(story_name[0], all);
	if i>0 then begin
		j := MyPos('</p>', all, i+1);
		k := MyPos('</div>', all, i+1);
		if j<k then begin
			s := copy(all, i, j-i);
			plot_outline := ParseString(s, '<p>(.*?)$', 1);
		end
		else begin
			s := copy(all, i, k-i);
			plot_outline := ParseString(s, '</h5>(.*?)$', 1);
		end;
		k := Pos('<a ', plot_outline);
		delete(plot_outline, k, length(plot_outline) - k + 1);
		plot_outline:=DecodeHTML(plot_outline);
		plot_outline:=RemoveTags(plot_outline);
		plot_outline:=ClearExtraSpaces(plot_outline);
		plot_outline:=ClearExtraBlankCharacters(plot_outline);
		description := plot_outline;
	end;
	
	//gross
	if DownloadMovieEarnings then begin
		if (BasicURL <> url) then
			temp := GetHTMLPageContentFromRequest(BasicURL)
		else
			temp := all;
		s := GetStr(temp, '<h3>Box Office</h3>', '<hr />');
		if s = '' then
			s := GetStr(temp, '>Box Office</h', '<hr');
		temp := '';
		i := Pos('<div', s);
		while i>0 do begin
			s2 := GetStr(s, '<div', '</div>');
			if s2 <> '' then
				s2 := RemoveTags('<' + s2);
			s2 := ReplaceStr(s2, #10, ' ', -1);
			s2 := ClearExtraBlankCharacters(DecodeHTML(s2));
			s2 := RemoveSpacesInText(s2);
			if temp <> '' then
				temp := temp + #13#10;
			temp := temp + s2;
			delete(s, 1, i);
			i := Pos('<div', s);
		end;
		salary := temp;
	end;

	//20090317-JeF_Begin
	// Remeber if extended plot is present before loading another page
	LoadSummary:=(  (pos('href="plotsummary"',all)>0) or
					(pos('href="/title/tt'+movie_code+'/plotsummary',all)>0)	);
	LoadSynopsis:=(pos('href="synopsis"',all)>0);
	//20090317-JeF_End

	//episodes
	if (not EpisodesDownloading) and (DownloadMovieSeasonsList or (OvrMainDlOptions and DlEpisodes)) then begin
		for EpCnt := 0 to SeasonList.Count - 1 do begin
			season := 0;
			episode := 0;
			try
				season := StrToInt(SeasonList[EpCnt]);
			except
			end;
			if season = -1 then
				season := 999;
			temp := GetHTMLPageContentFromRequest(EpisodeRequestURL + SeasonList[EpCnt]);
			if (jTraceLevel >= 3) then TraceExecute('Episodes',temp);   // 20101017-JeF
			if temp<>'-1' then begin
				i:=pos('<div class="list_item ', temp);
				while i>0 do begin
					j := MyPos('<div class="clear">', temp, i+1);
					s := copy(temp, i, j-i);
					s2 := ParseString(s, '<meta itemprop="episodeNumber" content="(\d+)"', 1);
					if s2<> '' then
						try
							episode := StrToInt(s2);
						except
						end;
					if s2 = '' then
						episode := episode + 1;
					AirDate := '';
					s2 := ParseString(s, '<div class="airdate">(.*?)</div>', 1);
					s2 := ClearExtraBlankCharacters(s2);
					if s2 > '' then begin
  					  // AirDate format : day month year
                      if (copy(s2,1,1) >= '0') and (copy(s2,1,1) <= '9') then begin
                        k:=pos(' ', s2);
                        if k>0 then begin
                          day:=copy(s2, 1, k-1);
                          delete(s2, 1, k);
                          k:=pos(' ', s2);
                          if k>0 then begin
                            month:=copy(s2, 1, k-1);
                            delete(s2, 1, k);
                            k := Pos('.', month);
                            if k>0 then
                              delete(month, k, 1);
                            ayear:=s2;
                            k:=1;
                            while (k<=12) and (Pos(month, monthes[k]) = 0) do begin	
                              k:=k+1;
                            end;
                            if (k<=12) and (month<>'') then begin
                              AirDate:=IntToStr(k)+format('/%s/%s', [day, ayear])
                            end;
                          end;
                        end;
                      end
                      else begin   // AirDate format : month day, year
                        k:=pos(' ', s2);
    					if k>0 then begin
    						month:=copy(s2, 1, k-1);
    						delete(s2, 1, k);
    						k := Pos('.', month);
    						if k>0 then
    							delete(month, k, 1);
    						k:=pos(', ', s2);
    						if k>0 then begin
    							day:=copy(s2, 1, k-1);
    							delete(s2, 1, k+1);
    							ayear:=s2;
    
    							k:=1;
    							while (k<=12) and (Pos(month, monthes[k]) = 0) do begin	
    								k:=k+1;
    							end;
    							if (k<=12) and (month<>'') then begin
    								AirDate:=IntToStr(k)+format('/%s/%s', [day, ayear])
    							end;
    						end;
    					end;
                      end;  
                    end;  
					EpisodeCover := GetStr(s, 'src="', '"');
					EpisodeCover := ResizeIMDBImage(EpisodeCover);
          
					EpisodeTitle := ParseString(s, '<strong>(.*?)</strong>', 1);
					EpisodeTitle := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(EpisodeTitle)));
					EpisodeDescription := ParseString(s, 'itemprop="description">(.*?)</div>', 1);
					EpisodeDescription := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(EpisodeDescription)));
          EpisodeIMDB:=ParseString(s, 'href="/title/tt(\d+)/', 1);  // 20140221-JeF
					if (EpisodeIMDB > '') and IntToBool(RegReadInteger('IMDB_Mov_ImdbIdInEpisodeTitle', 0))
						then EpisodeTitle := EpisodeTitle + ' (tt' + EpisodeIMDB + ')';    //20120414-JeF
// {dbg} showMessage(Format('SE%d EP%d: %s (%s) %s: %s', [season, episode, EpisodeIMDB, AirDate, EpisodeTitle, EpisodeDescription]));
					
							// 20090709-JeF_Begin : Load episode full description if exists and episode full desc option is on
							if EpisodeFullDesc = 1 then begin
								EpisodeUrl:='https://www.imdb.com/title/tt'+EpisodeIMDB+'/plotsummary';
								EpisodePage:=DownloadURL(EpisodeUrl);
								if (jTraceLevel >= 3) then TraceExecute('EpPlotSummary',all);   // 20101017-JeF
								if (EpisodePage<>'-1') then begin
									EpFullDesc:= '';
									k:=pos('<p class="plotpar">',EpisodePage);
									while k>0 do 
									begin
										k:=k+19;
										l:=MyPos('<i>',EpisodePage,k+1);
										if l>0 then
										begin
											s3:= copy(EpisodePage,k+1,l-k-2);
											k := l + 3;
											l := MyPos('</i>',EpisodePage,k+1);
											s2 := copy(EpisodePage,k,l-k);
											s2 := RemoveTags(s2);
											s2 := ReplaceStr(s2, #10, '', -1);
											s2:=ClearExtraSpaces(s2);
											s2:=ClearExtraCharacters(s2);
											if ShowPlotAuthors=1 then   // 20090706-JeF
												EpFullDesc := EpFullDesc + s3 + #10 + '//' + s2 + #10 + #10
											else EpFullDesc := EpFullDesc + s3 + #10 + #10;   // 20090706-JeF
										end;
										delete(EpisodePage,1,k-1);
										k := pos('<p class="plotpar">',EpisodePage);
									end;						
									delete(EpFullDesc,length(EpFullDesc)-1,2);
									if (length(EpFullDesc)>0) then EpisodeDescription:=EpFullDesc;
								end;
							end;
							// 20090709-JeF_End
							
					if DlUnknown or ((episode<=100) and (season < 999)) then begin
						if season = 999 then begin
							season := 99;
							//while (SeasonList.IndexOf(IntToStr(season)) > -1) do
								//Inc(season);
						end;
						if DownloadEpisodesCovers then
							SetImageName('', EpisodeCover, '', 10, false, '', season, episode);
						SetEpisode(season, episode, EpisodeTitle, EpisodeDescription, EpisodeIMDB, AirDate);
					end;
					delete(temp, 1, j);
					i:=pos('<div class="list_item ', temp);
				end;
			end;
			last_season := season;
		end;
	end;

	SeasonList.Free;

	// keywods
	if pos('<div class="link"><i>-</i><a href="keywords">plot keywords</a></div>',all) > 0 then
	begin
		// New page for getting keywords
		url := 'https://www.imdb.com/title/tt'+movie_code+'/keywords';
//		all:=DownloadURL(url);
		i := pos('<ul>'+#10+'<li><b class="keyword">',all);
		j := Mypos('</ul>'+#10,all, i+1);
		//s2 := ''; /////////// for testing
		if (i>0)and(j>0) then
		begin
			i := i + 55;
			s := copy(all,i,j-i);
			i := pos('<a href="/keyword/',s);
			while i>0 do
			begin
				j := MyPos('</a>',s,i+1);
				if j>0 then
				begin
					keyword := copy(s,i,j-i);
					keyword := DecodeHTML(keyword);
					keyword := RemoveTags(keyword);
					keyword := ClearExtraSpaces(keyword);
					////
					//  СОХРАНЕНИЕ КЛЮЧЕВОГО СЛОВА
					//  SetMovieKeyword(movie_code, keyword);
					////
					//s2 := s2 + ', ' + keyword; ///////////// for testing keywords
				end;
				delete(s,1,j+3);
				i := pos('<a href="/keyword/',s);
			end;
		end;
		//ShowMessage('KEYWORDS: ' + s2); ///////////// for testing keywords
	end;

  // comments
  if ((not images_only) and
      (DownloadMovieComments)) then
  begin
    comments := GetStr(all, '<a name="comment"><h3>User Reviews', '</form>');
    if (comments <> '') then
    begin
      i := pos('Author:', comments);
      if (i > 0) then
      begin
        comments := Copy(comments, i, Length(comments) - i);
        comments := GetStr(comments, '</div>', '<div');
        if (comments <> '') then
        begin
          comments:=DecodeHTML(comments);
          comments:=ClearExtraSpaces(comments);
          comments:=ReplaceStr(comments, '</p>', #13#10, -1);
          comments:=ReplaceStr(comments, '<br>', #13#10, -1);
          comments:=RemoveTags(comments);
          comments:=ClearExtraCharacters(comments);
          comments:=ClearExtraSpaces(comments);;
        end;
      end;
    end;
  end;


	// if not images_only then begin   // 20090627-JeF
	if (not images_only) and (DownloadMovieBigDescription or (OvrMainDlOptions and (ImportDesc = 1))) then
  begin   // 20090627-JeF
		if (plot_outline='') or LoadSummary or LoadSynopsis then begin  // 20090317-JeF
		//movie plot
			// 20090317-JeF //if (pos('<a href="plotsummary">', all)>0) or (pos('<a href="synopsis">', all)>0) then begin
			if LoadSummary or LoadSynopsis then begin  // 20090317-JeF
				if (description='') then
					url:=BasicURL+'/plotsummary'
				else
					url:=ReplaceStr(BasicURL, 'imdb.com', main_server[0], -1) + '/plotsummary';
				// all:=DownloadURL(url);
				All := GetHTMLPageContentFromRequest(url);
				if (jTraceLevel >= 3) then TraceExecute('PlotSummary',all);   // 20101017-JeF
			
				description := '';
				s := GetStr(all, 'id="summary', '</li>');
				i := Pos('<div class="author', s);
				delete(s, i, length(s) - i + 1);
				if (s <> '') then
					description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s)));
				// old stuff  - may need to delete
				if description = '' then begin
					i := pos('id="synopsis-',all);
					if i=0 then begin
						i:=Pos('<div class="desc">', all);
						if i>0 then begin
							j := MyPos('</ul>', all, i+1);
							s := copy(all, i, j-i);
							s := GetStr(s, '<li', '</li>');
							description := GetStr(s, '<p>', '<br');
							description := RemoveTags(description);
							description := DecodeHTML(description);
							description := ClearExtraBlankCharacters(description);
							s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(s, '<em>', '</em>'))));
							s2 := ReplaceStr(s2, #10, ' ', -1);
							if (ShowPlotAuthors = 1) and (description <> '') then
								description := description + #10 + '//' + s2;
						end;
					end
					else begin
						s := GetStr(all, 'id="synopsis-', '</li>');
						s := ReplaceStr(s, '<br/><br/>', #13#10#13#10, -1);
						if (s <> '') then
							s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s)));
						description := description + s + #10 + #10;
					end;
					delete(description,length(description)-1,2);
				end;
				// end old stuff
				if description='' then
					description:=plot_outline;
			end
			else
				description:=plot_outline;
		end
		else description:=plot_outline;

		description:=ReplaceStr(description, '</p>', #10, -1);
		description:=ReplaceStr(description, '<br>', #10, -1);
		description:=DecodeHTML(description);
		description:=RemoveTags(description);
		description:=ReplaceStr(description, #10, '<br>', -1);
		description:=ClearExtraBlankCharacters(description); ///////
	end;
	if (ImportDesc = 0) then description:='';   // 20090627-JeF
	//Awards
	awards:='';
	if DownloadMovieAwards or (OvrMainDlOptions and DlAwards) then begin
		url:=BasicURL+'/awards';
		// all:=DownloadURL(url);
		all := GetHTMLPageContentFromRequest(url); 
		s := GetStr(all, 'Awards</h1>', 'id="see_also"');
		if s = '' then
			s := GetStr(all, 'Awards</h1>', '<script');
		awards := ExtractAwards(s);
	end;

	// 20090627-JeF_Begin : Set Title to aka in local language
	if (TitleLang>'') or (AkasInDesc = 1) then begin
		// Load akas page
		url:=BasicURL+'/releaseinfo';
		//all:=DownloadURL(url);
    all := GetHTMLPageContentFromRequest(url);    
		if (jTraceLevel >= 3) then TraceExecute('ReleaseInfo',all);   // 20101017-JeF
		// extract akas
		i:=pos('"aka-item__name',all);
		if (i = 0) then
			i := Pos(' id="akas"', all);
		j:=MyPos('</table>',all,i+15);
		s2:=copy(all,i+15,j-i-15);
		if Pos('we don''t have any AKAs for this title', s2) > 0 then
			s2 := ''
		else begin
			if (TitleLang>'') then begin
				//20110114-JeF : TitleLang can now be an ordered list, search each value and stops at first match
				j:=0;
				sl.CommaText:=TitleLang;
				while (j<sl.count) do begin
					i:=pos(UpperCase(sl[j]),UpperCase(s2));
					if (i>0) then begin
						delete(s2, 1, i-1);
						s3 := GetStr(s2, '<td', '</td');
						if (s3 <> '') then
							s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s3)));
						if (s3<>'') and (Pos('<', s3) = 0) then begin
							Inc(TitleLangMatchCnt);
							title := s3;
						end;
						j:=sl.count;
					end;
					j:=j+1;
				end;
				//set title to original_title, if the first country of the movie is in TitleLang
				if (TitleLangMatchCnt = 0) and (Pos(FirstCountry, TitleLang) > 0) and (original_title <> '') then
					title := original_title;
			end;
			// 20090729-JeF_Begin : Add akas in description
			if AkasInDesc = 1 then begin
				if description <> '' then
					description := description + '<br><br>';
				description:=description+'Also Known As:';
				i:=pos('<tr',s2);
				while (i>0) do begin
					s3 := GetStr(s2, '<tr', '</tr>');
					s3:=DecodeHTML(s3);
					temp := '';
					k := Pos('<td', s3);
					while k > 0 do begin
						s4 := GetStr(s3, '<td', '</td>');
						temp1 := '';
						if (s4 <> '') then
							temp1 := ClearExtraBlankCharacters(RemoveTags('<' + s4));
						if (temp <> '') and (temp1 <> '') then
							temp := temp + ' - ';
						temp := temp + temp1;
						delete(s3, 1, k);
						k := Pos('<td', s3);
					end;
					description:=description+'<br>'+temp;
					delete(s2, 1, i);
					i:=pos('<tr',s2);
				end;
			end;
		end;
		// 20090729-JeF_End
	end;
	// 20090627-JeF_End
	
	// 20090808-JeF_Begin : Add Fun Stuff at bottom of description
	// 20100419-Rewritten by Vlad because of changes on IMDB
	//FUN STUFF begin
	if DownloadMovieAdditionalInfo or OvrMainDlOptions then begin
		s:=FunStuffInfo;
		//TRIVIA
		if (DownloadTrivia = 1) then begin
				 //all := DownloadURL(BasicURL + '/trivia');
        all := GetHTMLPageContentFromRequest(BasicURL + '/trivia');        
			i := Pos('<div class="sodatext">', all);    //20120419-JeF
			if (i>0) then begin
				if (jTraceLevel >= 8) then TraceExecute('Trivia',all);   // 20101017-JeF

        // Fade: 05.04.2012 - Add TRIVIA only if text exists
				if description <> '' then
					description := description + '<br><br>';
				description := description + 'TRIVIA:<br><br>';
				k := Pos('<div class="sodatext">', all);
				while k>0 do begin
					// Get Sub Section Title before proceeding
					m := Pos('<h4', all);
					if (m>0) then p := MyPos('</h4>', all, m+1)
					else p:=0;
					if (m>0) and (m<k) and (p>0) then begin  
						s2 := copy(all, m, p-m);
						s2 := RemoveTags(s2);
						s2 := DecodeHTML(s2);
						s2 := ClearExtraBlankCharacters(s2);
						if (s2>'') then begin
							s2 := ' --- '+s2+' ---<br><br>';
							description := description + s2;
						end;
					end;
					// Proceed with item
					l := MyPos('</div>', all, k+1);
					s2 := copy(all, k, l-k);
					s2 := RemoveTags(s2);
					s2 := DecodeHTML(s2);
					s2 := ReplaceStr(s2, #10#10, #10, -1);
					s2 := ReplaceStr(s2, #10, #13#10, -1);
					s2 := ClearExtraBlankCharacters(s2);
					if s2<>'' then
						description := description + s2 + '<br><br>';
					delete(all, 1, l-1);
					k := Pos('<div class="sodatext">', all);
				end;
				delete(description, length(description)-7, 8);
			end;
		end;
		//GOOFS
		if (DownloadGoofs = 1) then begin
				 //all := DownloadURL(BasicURL + '/goofs');
        all := GetHTMLPageContentFromRequest(BasicURL + '/goofs');        
			i := Pos('<li><a name=', all);    //20120419-JeF
			if (i=0) then i := Pos('<div id="gf', all);
			if (i>0) then begin
				if (jTraceLevel >= 8) then TraceExecute('Goofs',all);   // 20101017-JeF
				if description <> '' then
					description := description + '<br><br>';
				description := description + 'GOOFS:<br><br>';
				k := Pos('<li><a name=', all);
				FirstMethod := True;
				if k=0 then begin
					k := Pos('<div id="gf', all);
					FirstMethod := False;
				end;
				while k>0 do begin
					// Get Sub Section Title before proceeding
					m := Pos('<h4', all);
					if (m>0) then p := MyPos('</h4>', all, m+1)
					else p:=0;
					if (m>0) and (m<k) and (p>0) then begin  
						s2 := copy(all, m, p-m);
						s2 := RemoveTags(s2);
						s2 := DecodeHTML(s2);
						s2 := ClearExtraBlankCharacters(s2);
						if (s2>'') then begin
							s2 := ' --- '+s2+' ---<br><br>';
							description := description + s2;
						end;
					end;
					// Proceed with item
					if FirstMethod then
						l := MyPos('<br>', all, k+1)
					else
						l := MyPos('</div', all, k+1);
					s2 := copy(all, k, l-k);
					s2 := ReplaceStr(s2, '</h4>', ':&nbsp;</h4>', -1);
					s2 := RemoveTags(s2);
					s2 := DecodeHTML(s2);
					s2 := ReplaceStr(s2, #10, '', -1);
					s2 := ClearExtraBlankCharacters(s2);
					if s2<>'' then
						description := description + s2 + '<br><br>';
					delete(all, 1, l-1);
					k := Pos('<li><a name=', all);
					if k=0 then
						k := Pos('<div id="gf', all);
				end;
				delete(description, length(description)-7, 8);
			end;
		end;
		//QUOTES
		if (DownloadQuotes = 1) then begin
				 //all := DownloadURL(BasicURL + '/quotes');
        all := GetHTMLPageContentFromRequest(BasicURL + '/quotes');        
			i := Pos(' class="quote soda', all);    //20120419-JeF
			if (i>0) then begin
				if (jTraceLevel >= 8) then TraceExecute('Quotes',all);   // 20101017-JeF
				if description <> '' then
					description := description + '<br><br>';
				description := description + 'QUOTES:<br><br>';
				k := Pos(' class="quote soda', all);
				while k>0 do begin
					l := MyPos('</div', all, k+1);
					s2 := copy(all, k, l-k);
					s2 := ReplaceStr(s2, '>Share this quote<', '><', -1);
					if s2 <> '' then
						s2 := RemoveTags('<' + s2);
					s2 := DecodeHTML(s2);
					s2 := ReplaceStr(s2, #10#10#10, #10#10, -1);
					s2 := ReplaceStr(s2, #10, #13#10, -1);
					s2 := ClearExtraBlankCharacters(s2);
					if s2<>'' then
						description := description + s2 + '<br><br>';
					delete(all, 1, l-1);
					k := Pos(' class="quote soda', all);
				end;
				delete(description, length(description)-7, 8);
			end;
		end;
		//SOUNDTRACK
		if (DownloadSoundtracks = 1) then begin
				 //all := DownloadURL(BasicURL + '/soundtrack');
        all := GetHTMLPageContentFromRequest(BasicURL + '/soundtrack');
			i := Pos('class="soundTrack soda', all);      //20120419-JeF
			if (i>0) then begin
				if (jTraceLevel >= 8) then TraceExecute('Soundtrack',all);   // 20101017-JeF
				if description <> '' then
					description := description + '<br><br>';
				description := description + 'SOUNDTRACK:<br><br>';
				k := Pos('class="soundTrack soda', all);
				while k > 0 do begin
					l := MyPos('</div>', all, k+1);
					s2 := copy(all, k, l-k);
					s2 := ReplaceStr(s2, '<br />', #13#10, -1);
					if s2 <> '' then
						s2 := RemoveTags('<' + s2);
					s2 := DecodeHTML(s2);
					s2 := ClearExtraBlankCharacters(s2);
					if s2<>'' then
						description := description + s2 + '<br><br>';
					delete(all, 1, l-1);
					k := Pos('class="soundTrack soda', all);
				end;
				delete(description, length(description)-7, 8);
			end;
		end;
	end;
	
	//MOVIE CONNECTIONS
	if DownloadMovieLinks then begin
        all := GetHTMLPageContentFromRequest(BasicURL + '/movieconnections');
		//prequel
		i := Pos('Follows&nbsp;</h4>', all);
		if i>0 then begin
			delete(all, 1, i);
			ExtractMovieLinks(all, 1);
		end;
		//sequel
		i := Pos('Followed by&nbsp;</h4>', all);
		if i>0 then begin
			delete(all, 1, i);
			ExtractMovieLinks(all, 1);
		end;
		//references
		i := Pos('References&nbsp;</h4>', all);
		if i>0 then begin
			delete(all, 1, i);
			ExtractMovieLinks(all, 4);
		end;
		//referenced in
		i := Pos('Referenced in&nbsp;</h4>', all);
		if i>0 then begin
			delete(all, 1, i);
			ExtractMovieLinks(all, 5);
		end;
		//spoofs
		i := Pos('Spoofs&nbsp;</h4>', all);
		if i>0 then begin
			delete(all, 1, i);
			ExtractMovieLinks(all, 2);
		end;
		//spoofed in
		i := Pos('Spoofed in&nbsp;</h4>', all);
		if i>0 then begin
			delete(all, 1, i);
			ExtractMovieLinks(all, 3);
		end;
	end;
	if Not DlYear then year := '';   //Only Done here to keep year info available for other functions
	GetAllTrailers();
	sl.Free;   //20110114-JeF
  
	//types of movies
	if isTVSeries then
		media_type := 'TV Series';
	if media_type = '' then
		media_type := 'Movie';
	
	if RegReadInteger('IMDB_Mov_DlType', 1) = 0 then
		media_type := '';
  
end;

procedure ExtractMovieLinks(text: String; link_type: Integer);
var
	s, temp, title, year, code, page_url: String;
	i, j: Integer;
const
	do_not_include=['Video Game', 'TV Episode'];
begin
	i := Pos('<h4 ', text);
	if i = 0 then
		i := Length(text);
	s := copy(text, 1, i-1);
	i := Pos('<div class="soda', s);
	while i>0 do begin
		temp := GetStr(s, '<div class="soda', '</div>');
		title := GetStr(temp, ' href="/title/', '</a>');
		code := ParseString(title, '^tt(\d+)', 1);
		title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + title)));
		year := ParseString(temp, 'nbsp;\((\d+)\)', 1);
		page_url := GetMovieSiteURL(code);
		for j := 0 to length(do_not_include) - 1 do begin
			if Pos(do_not_include[j], temp) > 0 then
				title := '';
		end;
		if (title <> '') and (code <> '') then
			SetMovieLink(title, code, year, '', link_type, page_url);
		delete(s, 1, i);
		i := Pos('<div class="soda', s);
	end;
end;

function GetRating(movie_code: String): double;
var
	s, temp, url: string;
	i: Integer;
begin
	rating := 0;
	imdb_rating := 0;
	url := 'https://www.imdb.com/title/tt' + movie_code + '/ratings';
	temp := DownloadURL(url, True, RequestParametersWithCookies);
	s := GetStr(temp, 'User Ratings</h1>', '</div>');
	s := GetStr(s, '<span class="">', '</');
	s := ClearExtraBlankCharacters(s);
	i := Pos('.', s);
	if i > 0 then
		s[i] := DecimalSeparator;
	try
		imdb_rating := StrToFloat(s);
	except
	end;
	result := imdb_rating;
end;

procedure GetAllTrailers;
var
  MainTrailerURL: string;
  URL: string;
  S: String;
  S2, anchor: string;
  I: Integer;
  J: Integer;
  K: Integer;
  TrailerDescription: string;
  TrailerImage: string;
  TrailersCount: Integer;
begin
  TrailersCount := 0;
  MainTrailerURL := '';  
  // Load all trailers from trailer page
  if (TrailersCount < MaxTrailersCount) then
  begin
    // receive Trailer page
    S2 := 'https://www.imdb.com/title/tt' + movie_code + '/videogallery';
    // Load all trailers from trailer page
    // S := DownloadURL(S2);
    S := GetHTMLPageContentFromRequest(S2);
    if ((S <> '') and (S <> '-1')) then
    begin
	  anchor := ' href="/video/imdb';
      J := Pos(anchor, S);
	  if (j = 0) then begin
		anchor := ' href="/videoplayer';
		J := Pos(anchor, S);
	  end;
      while ((J > 0) and
             (TrailersCount < MaxTrailersCount)) do
      begin
        // Parse URL
        K := MyPos('</a>', S, J + Length(anchor));
        if (K > J) then
        begin
          S2 := Copy(S, J, K - J);
          K := MyPos('"', S2, Length(' href="/'));
          if (K > 0) then
          begin
            // Parse URL and if it's not empty parse trailer description
            URL := Copy(S2, Length(' href="') + 1, K - Length(' href="/'));
            if ((URL <> '') and
                (URL <> MainTrailerURL)) then
            begin
              TrailerDescription := '';
              // Parse trailer description
              I := Pos('alt="', S2);
              if (I > 0) then
              begin
                K := MyPos('"', S2, I + Length('alt="'));
                if (K > I) then
                  TrailerDescription := Copy(S2, I + Length('alt="'), K - I - Length('alt="'));
              end;
              // parse trailer image link
              TrailerImage := '';
              I := Pos('loadlate="', S2);
              if (I > 0) then
              begin
                K := MyPos('"', S2, I + Length('loadlate="'));
                if (K > I) then
                  TrailerImage := Copy(S2, I + Length('loadlate="'), K - I - Length('loadlate="'));
              end;
              // set Trailer info
              SetTrailer('https://www.imdb.com' + URL, TrailerDescription, TrailerImage);
              Inc(TrailersCount);
            end;
          end;
        end;
        Delete(S, 1, J + Length(anchor));
        // links for trailers are duplicate (for text and video). Delete if it's exist
        I := Pos(URL, S);
        if (I > 0) then
          Delete(S, 1, I + Length(URL));
        J := Pos(anchor, S);
      end;
    end;
  end;
end;

function ResizeIMDBImage(frame_url: String): String;
var
	picSizeX, picSizeY, i: Integer;
begin
	picSizeX := RegReadInteger('IMDBPicSizeX', defaultPicSizeX);
	picSizeY := RegReadInteger('IMDBPicSizeY', defaultPicSizeY);
	//cut off the filename of the url
	i:= pos('V1._', frame_url);
	if i = 0 then
		i:= pos('V1_', frame_url);
	if i>0 then begin
		frame_url:=copy(frame_url, 1, i+1);
		//insert the pattern to load the larger image
		if picSizeX>0 then
			frame_url := frame_url + '_SX' + IntToStr(picSizeX);
		if picSizeY>0 then
			frame_url := frame_url + '_SY' + IntToStr(picSizeY);
		if (picSizeX>0) or (picSizeY>0) then
			frame_url := frame_url + '_';
		frame_url:=frame_url+'.jpg';
	end;
	result := frame_url;
end;

//gets movie frames
function GetFrames(frame_type: string; frame_limit, frame_code: integer): integer;
var
	url, all, s, frame_url: string;
	i, j, k, picSizeX, picSizeY: Integer;
	frames_count: Integer;
begin
	frames_count:=0;
	if frames_count=0 then begin
		url := 'https://www.imdb.com/title/tt'+movie_code+'/mediaindex?refine='+frame_type;
		// all := DownloadURL(url);
		All := GetHTMLPageContentFromRequest(url);
		if (jTraceLevel >= 5) then TraceExecute('Mediaindex_'+frame_type,all);   // 20101017-JeF
		if (all <> '')and(all <> '-1') then
		begin
			j := pos('<div class="media_index_thumb_list"', all);
			k := MyPos('</div>', all, j);
			if (j>0) and (k>0) then begin
				s := copy(all, j, k-j);
				i := pos('src=', s);
				delete(s,1,i);
				while (i>0) and (frames_count<frame_limit) do begin
					i:= pos('"', s) + 1;
					j:= MyPos('"', s, i+1);
					frame_url:=copy(s, i, j-i);
					frame_url := ResizeIMDBImage(frame_url);
					SetImageName('', frame_url, '', frame_code);
					frames_count:=frames_count+1;
					i:=pos('src=', s);
					delete(s, 1, i);
				end;
			end;
		end;
	end;
	result := frames_count;
end;


//returned images links
procedure GetImages;
var
	shots_downloaded, shots_left, posters_downloaded, bts_downloaded: Integer;   //20101017-JeF
begin
	posters_downloaded := 0;
	shots_downloaded := 0;
	if (front_cover_url<>'') and (Pos('logo.png', front_cover_url) = 0) then // front-cover from movie site
		SetImageName('', front_cover_url, '', 1);
	if posters_exist and (MaxPostersCount>0) then begin
		posters_downloaded := GetFrames('poster', MaxPostersCount, 4);
	end;
	if MaxShotsCount>0 then begin
		shots_downloaded := GetFrames('still_frame', MaxShotsCount, 3);
		if shots_downloaded<MaxShotsCount then begin
			shots_left := MaxShotsCount - shots_downloaded;
			bts_downloaded := GetFrames('behind_the_scenes', shots_left, 3);
		end;
	end;
	//20101017-JeF : No image found, try with no frame type
	if ((posters_downloaded + shots_downloaded + bts_downloaded = 0) and
      (MaxPostersCount + MaxShotsCount > 0)) then begin
		GetFrames('', MaxPostersCount + MaxShotsCount, 5);
	end;
	while EpisodesDownloading do 
		Application.ProcessMessages;
	while PostersDownloading do
		Application.ProcessMessages;
	while ShotsDownloading do
		Application.ProcessMessages;
	while BackdropsDownloading do
		Application.ProcessMessages;
	for i := 0 to EpisodeURLs.Count - 1 do
		GetHTMLPageContentFromRequest(EpisodeURLs[i]);
	EpisodeURLs.Free;
	if RegReadInteger('IMDB_Mov_DlTitle', 1) = 0 then
		title := '';
	
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.imdb.com/title/tt'+code;
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else	
		result:=format('https://www.imdb.com/name/nm%s', [code]);
end;


// File Exists Tool // 20101017-JeF
function MyFileExists(FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	try
		fs:=TFileStream.Create(FileName, fmOpenRead);
		fs.Free;
		result:=true;
	except
		result:=false;
	end;
end;

function IfThen(AValue: Boolean; const ATrue: Integer; const AFalse: Integer = 0): Integer;
begin
	if AValue then result := ATrue
	else result := AFalse;
end;

// Trace Message when Trace is Active (Debug) // 20101017-JeF
procedure TraceAlert;
var
	s: string;
begin
	if (jTraceMode=1) then s:=GetLangStr(1687)
	else s:=GetLangStr(1688);
	showmessage(format(GetLangStr(1689),[s,IntToStr(jTraceLevel)]));
end;

// Save Trace To Disc (Debug) // 20101017-JeF
procedure SaveTraceToDisc(DumpName, DumpData: string);
var
	DumpFile: string;
	sl: TStringList;
begin
	sl:=TStringList.Create;
	DumpFile:=ScriptsPath+script_name+'_'+DumpName+'.trc';
	try
		sl.Text:=DumpData;
		sl.SaveToFile(DumpFile);
	except
		sl.Clear;
	end;
	sl.Free;
end;

// Load Trace From Disc (Debug) // 20101017-JeF
function LoadTraceFromDisc(DumpName: string): string;
var
	DumpFile: string;
	LoadIt: Boolean;
	i: integer;
	s: string;
	sl: TStringList;
begin
	result:='';
	sl:=TStringList.Create;
	DumpFile:=ScriptsPath+script_name+'_'+DumpName+'.trc';
	LoadIt:=False;
	if MyFileExists(DumpFile) then begin
		if jTraceAsk then begin
			s:=Format(GetLangStr(1690),[DumpName]);
			i:=MessageDlg(s,mtCustom,mbYes+mbCancel, 0);
			LoadIt:=(i=mrYes);
		end;
		if LoadIt then begin
			try
				sl.LoadFromFile(DumpFile);
				result:=sl.Text;
			except
				result:='';
			end;
		end;
	end;
	sl.Free;
end;

// Load or Save Trace according to Trace Mode (Debug) // 20101017-JeF
procedure TraceExecute(DumpName: string; VAR DumpData: string);
var
	DumpFile, s: string;
begin
	s:=DumpData;
	if jTraceMode = 1 then begin
		s:=LoadTraceFromDisc(DumpName);
		if (s <> '') then DumpData:=s;
	end
	else SaveTraceToDisc(DumpName, DumpData);
end;

function BoolToInt(b: boolean): integer;
begin
  if b then result:=1
  else result:=0;
end;

function IntToBool(intval: integer): boolean;
begin
  if intval < 1 then result := false
  else result := true;
end;

procedure OnITDBLoaded(AContent: string);
var
	url, all, s, s2, nocaps, movie_link, temp, movie_year, movie_title, temp_code: string;
	i, j, k, kol, year_int: integer;
	found: Boolean;
begin
	all := AContent;
	if (all='-1') or (pos('Nothing found', all)>0) then begin
		if (UseTMDBPosters = 1) then
			PostersDownloading := False;
		if (UseTMDBSnapshots = 1) then
			BackdropsDownloading := False;
		exit;
	end;

	if (tmdb_code = '') then begin
		//загрузилась страница фильма
		if pos('search_results movie', all)=0 then begin
		  s2:='<link rel="canonical" href="https://www.themoviedb.org/movie/';
		  i:=pos(s2, all);
		  if i>0 then begin
			j:=MyPos('"', all, i+length(s2));
			if j>0 then
			  tmdb_code:=copy(all, i+length(s2), j-i-length(s2));
		  end;
		end;
		i := Pos('<div class="search_results', all);
		if i > 0 then begin
			delete(all, 1, i);
			found := False;
			year_int := 0;
			try
				year_int := StrToInt(year);
			except
			end;
			i := Pos('<div class="item', all);
			while (i > 0) and (not found) do begin
				temp := GetStr(all, '<div class="item', ' class="view_more"');
				delete(all, 1, i);
				movie_title := GetStr(temp, '<a id="movie', '</a>');
				temp_code := GetStr(movie_title, '_', '"');
				if movie_title <> '' then
					movie_title := ClearExtraBlankCharacters(DecodeHTML(GetStr(movie_title, 'title="', '"')));
				s := GetStr(temp, '<span>', '</span>'#10);
				s := ClearExtraBlankCharacters(s);
				movie_year := ParseString(s, '(\d+)$', 1);
				if length(movie_year) < 4 then
					movie_year := ParseString(s, '^(\d+)', 1);
				if (LowerCase(movie_title) = LowerCase(title)) and ((movie_year = year) or (movie_year = IntToStr(year_int - 1)) or (movie_year = IntToStr(year_int + 1))) then begin
					found := True;
					tmdb_code := temp_code;
				end;
				i := Pos('<div class="item', all);
			end;
		end;

		(*s:=format('%s</a><span> (%s)</span>', [title, year]);
		nocaps := LowerCase(all);
		i:=pos(LowerCase(s), nocaps);
		//previous and next year
		if i=0 then begin
			try
				year_int := StrToInt(year);
			except
			end;
			s := format('%s</a><span> (%d)</span>', [title, year_int-1]);
			i := pos(LowerCase(s), nocaps);
			if i=0 then begin
				s := format('%s</a><span> (%d)</span>', [title, year_int+1]);
				i := pos(LowerCase(s), nocaps);
			end;
		end;
		if i>0 then begin
		  if (Pos(' href="https://www.themoviedb.org/movie/', all) > 0) then
			movie_link := ' href="https://www.themoviedb.org/movie/'
		  else
			movie_link := ' href="/movie/';
		  while (MyPos(movie_link, all, i-1)<>i) and (i>0) do
				i := i - 1;
		  s2:=movie_link;
		  i:=MyPos(s2, all, i);
		  if i>0 then begin
			j:=MyPos('"', all, i+10);
			if j>0 then begin
				tmdb_code:=copy(all, i+length(s2), j-i-length(s2));
			end;
		  end;
		end;*)
	end;
	if tmdb_code='' then begin
		if (UseTMDBPosters = 1) then
			PostersDownloading := False;
		if (UseTMDBSnapshots = 1) then
			BackdropsDownloading := False;
		exit;
	end;
	if (UseTMDBPosters = 1) then begin
		url:=format('https://www.themoviedb.org/movie/%s/images/posters', [tmdb_code]);
		AddRequestForHTMLPageContent(url, False, '', 'ParseTMDBPosters');
	end;
	if (UseTMDBSnapshots = 1) then begin
		url:=format('https://www.themoviedb.org/movie/%s/images/backdrops', [tmdb_code]);
		AddRequestForHTMLPageContent(url, False, '', 'ParseTMDBBackdrops');
	end;
end;

//download posters from themoviesdb.org
procedure ParseTMDBPosters(all: String);
var
	url, s, s2: string;
	i, j, k, kol: integer;
begin
	if (MaxPostersCount<=0) or (tmdb_code='') or (all='-1') then begin
		PostersDownloading := False;
		exit;
	end;

	i:=pos('class="images posters', all);
	if i<=0 then begin
		PostersDownloading := False;
		exit;
	end;

	kol:=0;
	i:=pos('<a class="image" href="', all);
	while (i>0) and (kol<MaxPostersCount) do begin
		url:=GetStr(all, '<a class="image" href="', '"');
		//always use the first server
		//k := Pos('.', url);
		//delete(url, 1, k-1);
		//url := 'https://cf2' + url;
		SetImageName('', url, '', 4);
		kol:=kol+1;
		delete(all, 1, i);
		//delete(all, 1, j);
		i:=pos('<a class="image" href="', all);
	end;
	PostersDownloading := False;
end;


procedure ParseTMDBBackdrops(all: String);
var
	url, s, s2: string;
	i, j, k, kol: integer;
begin
	if MaxBackdropsCount<=0 then begin
		BackdropsDownloading := False;
		exit;
	end;

	if tmdb_code='' then
		exit;
	if all='-1' then
		exit;
	i:=pos('class="images backdrops', all);
	if i<=0 then begin
		BackdropsDownloading := False;
		exit;
	end;

	kol:=0;
	i:=pos('<a class="image" href="', all);
	while (i>0) and (kol<MaxBackdropsCount) do begin
		url := GetStr(all, '<a class="image" href="', '"');
		//url := GetStr(s, ' href="', '"');
		//always download from the first server
		//k := Pos('.', url);
		//delete(url, 1, k-1);
		//url := 'https://cf2' + url;
		SetImageName('', url, '', 7);
		kol:=kol+1;
		delete(all, 1, i);
		i:=pos('<a class="image" href="', all);
	end;
	BackdropsDownloading := False;
end;

//search for the title and grab the first search result
//returns the tvdb code of the first search result
function SearchTVDB(tv_name: String; lang: Integer): string;
var
	i, j: Integer;
	s, url, all: String;
begin
	Result := '-1';
	if (tv_name <> '') then begin
		url := format('https://www.thetvdb.com/index.php?seriesname=%s&fieldlocation=1&language=%d&genre=&year=&network=&zap2it_id=&tvcom_id=&imdb_id=&order=translation&searching=Search&tab=advancedsearch', [EncodeURL(tv_name, 'utf-8'), lang]);
		url:=ReplaceStr(url, ' ', '+', -1);
	  // all := DownloadURL(url);
	  AddRequestForHTMLPageContent(url, False);
	  All := GetHTMLPageContentFromRequest(url); 
	  //all := GetHTMLPageContentFromRequest(url);
		if (all<>'-1') and (Pos('No series found', all)=0) then
	  begin
		if (tvdb_code = '') then
		begin
		  tvdb_code := '';
		  i := Pos('<h1>Results', all);
		  if i>0 then begin
			j := MyPos('</table>', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('<a href="/index.php?tab=series&amp;id=', s);
			if i>0 then begin
			  j := MyPos('&amp;lid', s, i+38);
			  tvdb_code := copy(s, i+38, j-i-38);
			  tvdb_code := ClearExtraBlankCharacters(tvdb_code);
			end;
		  end;
		end;
			result := tvdb_code;
		end
		else
			result := '-1';
	end;
end;

function InRange(AValue: Integer; AFrom: Integer; ATo: Integer): Boolean;
begin
  Result := (AValue >= AFrom);
  Result := Result and (AValue <= ATo);
end;

function CompareTVSeriesYears(AYear1Str: string; AYear2Str: string): Boolean;
var
  Year1: Integer;
  Year2: Integer;
begin
  Result := (AYear1Str <> '');
  Result := Result and (AYear2Str <> '');
  Result := Result and (TryStrToInt(AYear1Str, Year1));
  Result := Result and (TryStrToInt(AYear2Str, Year2));
  if (Result) then
  begin
    Result := Result and (InRange(Year1, Year2 - 1, Year2 + 1));
    Result := Result or (InRange(Year2, Year1 - 1, Year1 + 1));
  end;
end;

procedure OnTVDBMainPageLoaded(AContent: string);
var
	i, j: Integer;
	s, url, all, temp: String;
	found: boolean;
  TVDBURL: string;
  YearStr: string;
  TempInt: Integer;
  TVDBTitle: string;
  ProbablyFound: Boolean;
  ContentWithYear: string;
begin
  all := AContent;
  tvdb_code := '';
  found := false;
  ContentWithYear := '';
  // Fade. 18.07.2019
  while (all <> '') do
  begin
    if (all<>'-1') and (Pos('No series found', all)=0) then
    begin
      i := Pos('<h2>Search Results', all);
      if i>0 then
      begin
        j := MyPos('</table>', all, i+1);
        s := copy(all, i, j-i);
        i := Pos('<tr>', s);
        while (i > 0) and (not found) do
        begin
          temp := GetStr(s, '<tr>', '</tr>');
          if (Pos(title, temp) > 0) then
          begin
            if (Pos('<a href="', temp) > 0) then
            begin
              tvdb_code := GetStr(temp, '<a href="', '"');
              TVDBTitle := GetStr(temp, '<a href="', '</a>');
              if (TVDBTitle <> '') then
              begin
                TVDBTitle := RemoveTags('<a' + TVDBTitle + '</a>');
                if (Pos('(', TVDBTitle) > 0) then
                  Delete(TVDBTitle, Pos('(', TVDBTitle), Length(TVDBTitle));
                TVDBTitle := Trim(TVDBTitle);
              end;
              Delete(temp, 1, Pos('<a href="', temp));
            end;
            // try to parse year
            // skip id
            ParseTagWithCutting(temp, '<td>', '</td>');
            // skip status
            ParseTagWithCutting(temp, '<td>', '</td>');
            // skip network
            ParseTagWithCutting(temp, '<td>', '</td>');
            // parse year
            YearStr := Trim(ParseTag(temp, '<td>', '</td>'));
            YearStr := ParseTag(YearStr, ' ', '');
            if (not TryStrToInt(YearStr, TempInt)) then
              YearStr := '';
            if ((WideLowerCase(title) = WideLowerCase(TVDBTitle)) and
                ((CompareTVSeriesYears(Year, YearStr)) or
                 (Year = ''))) then
            begin
              found := true;
            end;
          end;
          delete(s, 1, i);
          i := Pos('<tr>', s);
        end;
      end;
    end;
    all := '';
    // try to search results with year in
    if ((year <> '') and (ContentWithYear = '') and (not found)) then
    begin
      TVDBURL := format('https://www.thetvdb.com/search?q=%s&l=en', [title + ' ' + year]);
      TVDBURL := ReplaceStr(TVDBURL, ' ', '+', -1);
      ContentWithYear := DownloadURLHTTPS(TVDBURL);
      all := ContentWithYear;
    end;
  end;

		//if (tvdb_code = '-1') or (tvdb_code = '') then 
			//tvdb_code := SearchTVDB(title, 7);
  if (tvdb_code <> '-1') and (tvdb_code <> '') then
  begin
    if (DownloadTVDBEpisodes=1) then begin
      url := 'https://www.thetvdb.com' + tvdb_code;
      AddRequestForHTMLPageContent(url, False, '', 'OnTVDBHomePageLoaded');
    end
    else
      EpisodesDownloading := False;
    if (UseTVDBPosters=1) then begin
      url := 'https://www.thetvdb.com' + tvdb_code + '/artwork/poster';
      AddRequestForHTMLPageContent(url, False, '', 'ParseTVDBPosters');
    end;
    if (UseTVDBFanart=1) then begin
      url := 'https://www.thetvdb.com' + tvdb_code + '/artwork/fanart';
      AddRequestForHTMLPageContent(url, False, '', 'ParseTVDBFanart');
    end;
  end
  else begin
    if (DownloadTVDBEpisodes = 1) then
      EpisodesDownloading := False;
    if (UseTVDBPosters = 1) then
      PostersDownloading := False;
    if (UseTVDBFanart = 1) then
      BackdropsDownloading := False;
    TVDBNothingFound := True;
  end;
	TVDBSearchEnded := True;
end;

procedure OnTVDBHomePageLoaded(AContent: string);
var
	i, j, seasonNr: Integer;
	temp, s, s2, marker, url: String;
begin
	marker := '<h2>Seasons</h2>';
	i := Pos(marker, AContent);
	if (i > 0) then begin
		temp := GetStr(AContent, marker, '</ul>');
		i := Pos('<li', temp);
		while i > 0 do begin
			seasonNr := 0;
			s := GetStr(temp, ' href="/series/', '"');
			s := ParseString(s, 'seasons/(\d+)', 1);
			if s <> '' then begin
				try
					seasonNr := StrToInt(s);
				except
				end;
			end;
			if (seasonNr > 0) then
      begin
				url := 'https://www.thetvdb.com' + tvdb_code + '/seasons/' + IntToStr(seasonNr);
				// SeasonURLs.add(url);
				AddRequestForHTMLPageContent(url, False, '', 'ParseTVDBSeasonPage');
			end;
			delete(temp, 1, i);
			i := Pos('<li', temp);
		end;
	end;
end;

procedure ParseTVDBSeasonPage(AContent: string);
var
	i, j, k, l, season, episode, episodes_count, special_episode: Integer;
	s, s2, s3, s4, url, all, EpisodeTitle, AirDate, EpisodeDescription, EpisodeIMDB, year, month, day, NotConvertedTitle, SeasonImage, EpisodeImage, season_id, series_id, episode_id, last_season_id, temp: String;
begin
	episodes_count := 0;
	EpisodeIMDB := '';
	EpisodeDescription := '';
	if (tvdb_code <> '-1') and (tvdb_code <> '') then begin
		season := -1;
		s := GetStr(AContent, '<h2', '</h2>');
		if (s <> '') then
			s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s)));
		s2 := ParseString(s, '(\d+)$', 1);
		if (s2 <> '') then begin
			try
				season := StrToInt(s2);
			except
			end;
		end;
		if (season >= 0) then begin
			
			// download season covers
			if (DownloadSeasonsCovers) and (not ExistSeasonImage(season)) then begin
				i := Pos('<h2>Posters</h2>', AContent);
				s := 'https://www.thetvdb.com/banners/seasons/';
				if (i > 0) then begin
					temp := GetStr(AContent, s, '.jpg');
					if (temp <> '') then begin
						SeasonImage := s + temp + '.jpg';
						SetImageName('', SeasonImage, '', 9, False, '', season, 0);
					end;
				end;
			end;
			
			// download episode names
			episodes_count := 0;
			temp := GetStr(AContent, '<tbody>', '</tbody>');
			i := Pos('<tr>', temp);
			while i > 0 do begin
				episode := -1;
				EpisodeDescription := '';
				EpisodeIMDB := '';
				s := GetStr(temp, '<tr>', '</tr>');
				
				// Episode number and ID
				s2 := GetStr(s, '<td>', '</td>');
				url := GetStr(s2, 'href="', '"');
				if (url <> '') then
					url := 'https://www.thetvdb.com' + url;
				episode_id := ParseString(s2, '/episodes/(\d+)', 1);
				s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
				s3 := ParseString(s3, '(\d+)', 1);
				if (s3 <> '') then begin
					try
						episode := StrToInt(s3);
					except
					end;
				end;
				delete(s, 1, Pos('</td>', s));
				
				// Episode title
				s2 := GetStr(s, '<td>', '</td>');
				EpisodeTitle := GetStr(s2, 'data-language="en"', '</');
				if (EpisodeTitle <> '') then begin
					EpisodeTitle := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + EpisodeTitle)));
				end;
				delete(s, 1, Pos('</td>', s));
				
				// Episode air date
				s2 := GetStr(s, '<td>', '</td>');
				AirDate := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
				delete(s, 1, Pos('</td>', s));
				
				// Episode cover
				s2 := GetStr(s, '<td>', '</td>');
				EpisodeImage := GetStr(s2, ' href="', '"');
				if (EpisodeImage <> '') and (DownloadEpisodesCovers) and (not ExistEpisodeImage(season, episode)) then begin
					SetImageName('', EpisodeImage, '', 10, False, '', season, episode);
				end;
				
				// download episode descriptions
				if DownloadMovieSeasonsList and (DownloadTVDBEpisodeDescriptions = 1) then begin
					AddRequestForHTMLPageContent(url, False, '', 'GetTVDBEpisodeDescription');
					EpisodeURLs.Add(url);
					episodes_count := episodes_count + 1;
				end
				// or save information about the episode
				else begin
					episodes_count := episodes_count + 1;
					SetEpisode(season, episode, EpisodeTitle, EpisodeDescription, EpisodeIMDB, AirDate);
				end;
				delete(temp, 1, i);
				i := Pos('<tr>', temp);
			end;
		end;
	end;
	EpisodesDownloading := False;
end;

//download page with episode description and extract the description
procedure GetTVDBEpisodeDescription(all: string);
var
	i, j, k : Integer;
	s, s2, s3, desc: String;
	not_done: boolean;
	EpisodeTitle, EpisodeDescription, AirDate, day, month, year: String;
	season, episode: Integer;
begin
	desc := '';
	if all<>'-1' then begin
		s := GetStr(all, 'id="translations"', 'class="footer"');
		AirDate := '';
		
		// season number
		season := 0;
		s3 := ParseString(all, '/seasons/(\d+)', 1);
		if (s3 <> '') then
			try
				season := StrToInt(s3);
			except
			end;
		episode := 0;
		
		// episode title and description
		EpisodeDescription := GetStr(s, 'data-language="en"', '</p>');
		EpisodeTitle := GetStr(EpisodeDescription, 'data-title="', '"');
		EpisodeTitle := DecodeHTML(EpisodeTitle);
		if (EpisodeDescription <> '') then
			EpisodeDescription := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + EpisodeDescription)));
		
		// episode number
		s3 := GetStr(s, 'Episode Number</strong>', '</li');
		s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s3)));
		s3 := ParseString(s3, '(\d+)', 1);
		if (s3 <> '') then
			try
				episode := StrToInt(s3);
			except
			end;
			
		// air date
		s3 := GetStr(s, 'Originally Aired</strong>', '</li');
		s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s3)));
		if s3 <> '' then begin
			i := Pos(',', s3);
			delete(s3, 1, i + 1);
			month := ParseString(s3, '^(.*?) \d+,', 1);
			day := ParseString(s3, '(\d+),', 1);
			year := ParseString(s3, '(\d+)$', 1);
			k := 1;
            while (k <= 12) and (Pos(month, monthes[k]) = 0) do
				k := k + 1;
			if (k <= 12) and (month <> '') then
				AirDate := IntToStr(k) + format('/%s/%s', [day, year]);
		end;
		if (season > 0) and (episode > 0) then begin
			SetEpisode(season, episode, EpisodeTitle, EpisodeDescription, '', AirDate);			
		end;
	end;
end;


procedure ParseTVDBPosters(all: String);
var
	i, j, posters_count: Integer;
	s, poster_code, poster_url, url: String;
begin
	posters_count := 0;
	if all <> '-1' then begin
		i := Pos('Poster', all);
		if i>0 then begin
			j := MyPos('class="footer">', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('banners/posters/', s);
			while (i>0) and (posters_count < MaxPostersCount) do begin
				posters_count := posters_count + 1;
				j := MyPos('.jpg"', s, i+1);
				poster_code := copy(s, i+16, j-i-16);
				poster_url := 'https://www.thetvdb.com/banners/posters/'+poster_code+'.jpg';
				SetImageName('', poster_url, '', 4);
				delete(s, 1, j);
				i := Pos('banners/posters/', s);
			end;
		end;
	end;
	PostersDownloading := False;
end;

procedure ParseTVDBFanart(all: String);
var
	i, j, posters_count: Integer;
	s, poster_code, poster_url, url: String;
begin
	posters_count := 0;
	if all <> '-1' then begin
		i := Pos('Fanart', all);
		if i>0 then begin
			j := MyPos('class="footer">', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('banners/fanart/', s);
			while (i>0) and (posters_count < MaxPostersCount) do begin
				posters_count := posters_count + 1;
				j := MyPos('.jpg"', s, i+1);
				poster_code := copy(s, i+15, j-i-15);
				poster_url := 'https://www.thetvdb.com/banners/fanart/'+poster_code+'.jpg';
				SetImageName('', poster_url, '', 7);
				delete(s, 1, j);
				i := Pos('banners/fanart/', s);
			end;
		end;
	end;
	BackdropsDownloading := False;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(s1, str);
	if I > 0 then
	begin
		J := MyPos(s2, str, I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function GetUserMoviesURLByID(AID: string; AMode: Integer;
  APageNumber: Integer = 1): string;
var
  StartIndex: Integer;
  TemplateURL: string;
begin
  Result := '';
  if ((AID <> '') and
      (APageNumber >= 0)) then
  begin
    if (APageNumber = 0) then
      APageNumber := 1;
    StartIndex := USER_MOVIES_PER_PAGE * (APageNumber - 1) + 1;
    TemplateURL := '';
    case AMode of
      0: TemplateURL := USER_MOVIES_RATING_URL_TEMPLATE;
      1: TemplateURL := USER_MOVIES_WATCHLIST_URL_TEMPLATE;
      2: TemplateURL := LIST_MOVIES_URL_TEMPLATE;
    end;
    if (TemplateURL <> '') then
      Result := Format(TemplateURL, [AID, APageNumber]);
  end;
end;

procedure ParseUserMoviePersonsForTag(AMovieCode: string;
  AContent: string; AMode: Integer; AStartTag: string; AEndTag: string);
var
  PersonCode: string;
  PersonName: string;
  PersonInfo: string;
  PersonsListStr: string;
begin
  PersonsListStr := ParseTag(AContent, AStartTag, AEndTag);
  if (PersonsListStr <> '') then
  begin
    repeat
      PersonInfo := ParseTagTakingIntoAccountNestingLevelWithCutting(
        PersonsListStr, '<a href=', '<a', '</a>');
      if (PersonInfo <> '') then
      begin
        PersonCode := ParseTag(PersonInfo, '/name/nm', '/');
        PersonName := ParseTag(PersonInfo, '>', '');
        if ((PersonName <> '') and
            (PersonCode <> '')) then
        begin
          SetUserMoviePerson(AMovieCode, PersonCode, PersonName, AMode);
        end;
      end;
    until (PersonInfo = '');
  end;
end;

procedure ParseUserMoviePersonsForTagWatchlist(AMovieCode: string;
  AContent: string; AMode: Integer; AStartTag: string; AEndTag: string);
var
  PersonCode: string;
  PersonName: string;
  PersonInfo: string;
  PersonsListStr: string;
begin

  PersonsListStr := ParseTag(AContent, AStartTag, AEndTag);
  if (PersonsListStr <> '') then
  begin
    repeat
      PersonInfo := ParseTagTakingIntoAccountNestingLevelWithCutting(
        PersonsListStr, '{', '{', '}');
      if (PersonInfo <> '') then
      begin
        PersonCode := ParseTag(PersonInfo, '/name/nm', '"');
        PersonName := ParseTag(PersonInfo, '"name":"', '"');
        if ((PersonName <> '') and
            (PersonCode <> '')) then
        begin
          SetUserMoviePerson(AMovieCode, PersonCode, PersonName, AMode);
        end;
      end;
    until (PersonInfo = '');
  end;

end;

procedure ParseUserMoviePersons(AMovieCode: string; AContent: string);
begin
  // directors
  ParseUserMoviePersonsForTag(AMovieCode, AContent, 1, 'Director:', 'Stars:');
  // actors
  ParseUserMoviePersonsForTag(AMovieCode, AContent, 3, 'Stars:', '</p>');
end;

procedure ParseUserMoviePersonsWatchlist(AMovieCode: string; AContent: string);
begin
  // directors
  ParseUserMoviePersonsForTagWatchlist(AMovieCode, AContent, 1, '"director":[', ']');
  // actors
  ParseUserMoviePersonsForTagWatchlist(AMovieCode, AContent, 3, '"star":[', ']');
end;

function ParseAndAddUserMovies(APageIndex: Integer; AContent: string;
  var WasCanceled: Boolean): integer;
var
  s: string;
  MovieYear: string;
  MovieCode: string;
  MovieTitle: string;
  MovieCoverURL: string;
  MovieOriginalTitle: string;
  UserRating: Double;
  MovieContent: string;
  MovieInfo: string;
  MovieDescription: string;
begin
  Result := 0;
  AContent := ParseTag(AContent, 'class="lister-list">', '');
  if (AContent <> '') then
  begin
    repeat
      MovieContent := ParseTagTakingIntoAccountNestingLevelWithCutting(
        AContent, '<div class="lister-item ', '<div', '</div>');
      if (MovieContent <> '') then
      begin
        MovieCode := ParseTag(MovieContent, 'href="/title/tt', '/');
        if (MovieCode <> '') then
        begin
          MovieCoverURL := ParseTag(MovieContent, 'loadlate="', '"');
          MovieInfo := ParseTag(MovieContent, '<div class="lister-item-content', '</h3>');
          MovieTitle := ParseTag(MovieInfo, '<a href="', '</a>');
          MovieTitle := ParseTag(MovieTitle, '>', '');
          MovieTitle := DecodeHTML(MovieTitle);
          MovieTitle := Trim(RemoveTags(MovieTitle));
          MovieYear := ParseTag(MovieInfo, 'span class="lister-item-year text-muted unbold">(', ')');
          MovieDescription := Trim(ParseTag(MovieContent, '<p class="">', '</p>'));
          if (Pos('...', MovieDescription) > 0) then
            MovieDescription := Trim(Copy(MovieDescription, 1, Pos('...', MovieDescription) - 1));
          S := ParseTag(MovieContent, 'your|', '|');
          if (not TryStrToFloat(S, UserRating)) then
            UserRating := 0;
          SetUserMovie(APageIndex, MovieCode, MovieTitle, '',
            MovieYear, UserRating, '', WasCanceled, MovieCoverURL, MovieDescription);
          ParseUserMoviePersons(MovieCode, MovieContent);
          if (WasCanceled) then
            Break;
          Inc(Result);
        end;
      end;
    until (MovieContent = '');
  end;
end;

function ParseAndAddUserMoviesForWatchList(APageIndex: Integer; AContent: string;
  var WasCanceled: Boolean): integer;
var
  MovieYear: string;
  MovieCode: string;
  MovieTitle: string;
  MovieCoverURL: string;
  MovieIMDBRating: Double;
  MovieIMDBRatingStr: string;
  MovieOriginalTitle: string;
  MovieContent: string;
  MovieDescription: string;
begin
  Result := 0;
  if (Pos('"titles":{', AContent) > 0) then
    AContent := ParseTag(AContent, '"titles":{', '');
  if (AContent <> '') then
  begin
    repeat
      MovieContent := ParseTagTakingIntoAccountNestingLevelWithCutting(
        AContent, '"tt', '{', '}');
      if (MovieContent <> '') then
      begin
        MovieCode := ParseTag(MovieContent, 'href":"/title/tt', '"');
        if (MovieCode <> '') then
        begin
          MovieCoverURL := ParseTag(MovieContent, '"poster":{', '}');
          if (MovieCoverURL <> '') then
            MovieCoverURL := ParseTag(MovieCoverURL, '"url":"', '"');
          {MovieInfo := ParseTagTakingIntoAccountNestingLevel(MovieContent,
            '<div class="lister-item-content">', '<div', '</div>');}
          MovieTitle := ParseTag(MovieContent, '"title":"', '"');
          MovieYear := ParseTag(MovieContent, '"year":["', '"');
          MovieDescription := ParseTag(MovieContent, '"plot":"', '"');
          MovieDescription := Trim(DecodeHTML(MovieDescription));
          MovieIMDBRating := 0;
          {MovieIMDBRatingStr := ParseTag(MovieContent, '"rating":', ',');
          MovieIMDBRatingStr := ReplaceStr(MovieIMDBRatingStr, '.', DecimalSeparator, -1);
          if (not TryStrToFloat(MovieIMDBRatingStr, MovieIMDBRating)) then
            MovieIMDBRating := 0;}
          SetUserMovie(APageIndex, MovieCode, MovieTitle, '', MovieYear, MovieIMDBRating, '',
            WasCanceled, MovieCoverURL, MovieDescription);
          ParseUserMoviePersonsWatchlist(MovieCode, MovieContent);
          if (WasCanceled) then
            Break;
          Inc(Result);
        end;
      end;
    until (MovieContent = '');
  end;
end;

function ParseUserMoviesCount(AContent: string; var AMoviesCount: Integer;
  var APagesCount: Integer): Boolean;
var
  s: string;
begin
  Result := False;
  if (AContent <> '') then
  begin
    APagesCount := 0;
    AMoviesCount := 0;
    // Parse and calculate Total Movies/Total Pages count
    AContent := Trim(ParseTag(AContent, '<span title="Detail view"', ''));
    // ShowMessage(AContent);
    if (AContent <> '') then
    begin
      s := Trim(ParseTag(AContent, '<div class="desc', '</div>'));
      s := Trim(ParseTag(s, '>', 'titles'));
    end;
    Result := TryStrToInt(s, AMoviesCount);
    if (Result) then
    begin
      APagesCount := (AMoviesCount div USER_MOVIES_PER_PAGE);
      if ((AMoviesCount mod USER_MOVIES_PER_PAGE) > 0) then
        Inc(APagesCount);
      SetUserMoviesCount(AMoviesCount, APagesCount);
    end;
  end;
end;

function ParseUserMoviesCountWatchlist(AContent: string; var AMoviesCount: Integer;
  var APagesCount: Integer; var APageID: string; var ACodesList: TStringList): Boolean;
var
  s: string;
  ItemsStr: string;
  MovieCode: string;
  MovieInfo: string;
  AllItemsContent: string;
begin
  Result := False;
  ACodesList := nil;
  if (AContent <> '') then
  begin
    APageID := '';
    APagesCount := 0;
    AMoviesCount := 0;
    ACodesList := TStringList.Create();
    // Parse and calculate Total Movies/Total Pages count
    AllItemsContent := ParseTag(AContent, '"list":{', '');
    APageID := ParseTag(AllItemsContent, '"id":"', '"');
    ItemsStr := ParseTagTakingIntoAccountNestingLevelWithCutting(AllItemsContent, '"items":[', '[', ']');
    if ((AllItemsContent <> '') and
        (APageID <> '') and
        (ItemsStr <> '')) then
    begin
      repeat
        MovieInfo := ParseTagTakingIntoAccountNestingLevelWithCutting(
          ItemsStr, '{', '{', '}');
        if (MovieInfo <> '') then
        begin
          MovieCode := ParseTag(MovieInfo, '"const":"', '"');
          if (MovieCode <> '') then
            ACodesList.Add(MovieCode);
        end;
      until (MovieInfo = '');
      AMoviesCount := ACodesList.Count;
      Result := (AMoviesCount > 0);
      if (Result) then
      begin
        APagesCount := (AMoviesCount div USER_MOVIES_PER_PAGE);
        if ((AMoviesCount mod USER_MOVIES_PER_PAGE) > 0) then
          Inc(APagesCount);
        SetUserMoviesCount(AMoviesCount, APagesCount);
      end;
    end;
  end;
end;

// Fade. Description.
// AMode - mode of the list type (for URL generating)
// 0 - user movies list with ratings. URL: https://www.imdb.com/user/ur5132634/ratings
// 1 - user movies WatchList. URL: https://www.imdb.com/user/ur5132634/watchlist
// 2 - any list. AID stores identificator of a list (not a user). URL: https://www.imdb.com/list/ls073625083/
//
// Modes 0, 2 - have equal parsing algorithm. Mode 2 has own algorithm

function GetUserMoviesByIDRating(AID: string; AMode: Integer = 0): Integer;
var
  URL: string;
  Content: string;
  PageIndex: Integer;
  TotalPagesCount: Integer;
  TotalMoviesCount: Integer;
  WasCanceled: Boolean;
begin
  Result := 0;
  if (AID <> '') then
  begin
    PageIndex := 1;
    TotalPagesCount := 0;
    TotalMoviesCount := 0;
    repeat
      URL := GetUserMoviesURLByID(AID, AMode, PageIndex);
      Content := DownloadURL(URL, True, RequestParameters);
      if (Content <> '') then
      begin
        if ((TotalMoviesCount = 0) and
            (not ParseUserMoviesCount(Content, TotalMoviesCount, TotalPagesCount))) then
        begin
          Break;
        end;
        // Parse Movies from current page
        Result := Result + ParseAndAddUserMovies(PageIndex, Content, WasCanceled);
        if (WasCanceled) then
          Break;
        Inc(PageIndex);
      end;
    until ((Content = '') or
           (PageIndex > TotalPagesCount));
  end;
end;

function GetUserMoviesByIDWatchlist(AID: string): Integer;
var
  I: Integer;
  URL: string;
  PageID: string;
  Content: string;
  NextCodes: string;
  PageIndex: Integer;
  WasCanceled: Boolean;
  CodesToIndex: Integer;
  CodesFromIndex: Integer;
  CodesList: TStringList;
  TotalPagesCount: Integer;
  TotalMoviesCount: Integer;
begin
  Result := 0;
  if (AID <> '') then
  begin
    PageIndex := 1;
    PageID := '';
    CodesList := nil;
    TotalPagesCount := 0;
    TotalMoviesCount := 0;
    try
      URL := GetUserMoviesURLByID(AID, 1);
      repeat
        Content := DownloadURL(URL, True, RequestParameters);
        if (Content <> '') then
        begin
          if ((TotalMoviesCount = 0) and
              (not ParseUserMoviesCountWatchlist(Content, TotalMoviesCount, TotalPagesCount, PageID, CodesList))) then
          begin
            Break;
          end;
          Result := Result + ParseAndAddUserMoviesForWatchList(PageIndex, Content, WasCanceled);
          if (WasCanceled) then
            Break;
          Inc(PageIndex);
          NextCodes := '';
          CodesFromIndex := (PageIndex - 1) * USER_MOVIES_PER_PAGE;
          CodesToIndex := (PageIndex) * USER_MOVIES_PER_PAGE;
          if (CodesToIndex > CodesList.Count) then
            CodesToIndex := CodesList.Count;
          for I := CodesFromIndex to CodesToIndex - 1 do
          begin
            NextCodes := NextCodes + CodesList[I];
            if (I <> (CodesToIndex - 1)) then
              NextCodes := NextCodes + ',';
          end;
          if (NextCodes <> '') then
            URL := Format(USER_MOVIES_WATCHLIST_AJAX_URL_TEMPLATE, [NextCodes, PageID]);
        end;
      until ((Content = '') or
             (NextCodes = '')  or
             (PageIndex > TotalPagesCount));
    finally
      if (CodesList <> nil) then
        CodesList.Free();
    end;
  end;
end;

function GetUserMoviesByID(AID: string; AMode: Integer = 0): Integer;
begin
  if (AMode = 1) then
    Result := GetUserMoviesByIDWatchlist(AID)
  else
    Result := GetUserMoviesByIDRating(AID, AMode);
end;


//show available settings for the script
function ShowScriptOptions: integer;
var
	s: string;
	f: TForm;
	b: TButton;
	cbDownloadTrivia, cbDownloadGoofs, cbDownloadQuotes, cbDownloadConnections, cbDownloadSoundtracks, cbImportDesc, cbAkaSearch: TCheckBox;
	cbShowPlotAuthors, cbEpisodeFullDesc, cbAkasInDesc, cbImportMPAAReasons, cbAdvSearch: TCheckBox;
	cbOvrMainDlOptions, cbDlOriginalTitle, cbDlYear, cbDlGenres, cbDlCountries, cbDlDuration, cbDlType: TCheckBox;
	cbDlDirectors, cbDlActors, cbDlWriters, cbDlComposers, cbDlProducers, cbDlCameraman, cbDlStudios, cbDlEpisodes, cbDlAwards: TCheckBox;
	cbImdbIdInEpisodeTitle, cbFullCharacterName: TCheckBox;
	gbDlOptions, gbDescOptions, gbPictures, gbLanguage, gbSearch, gbMpaa, gbTVSeries: TGroupBox;
	labTitleLang, labMPAADefault, labMPAAReplace, labLocalService, labPicSize, labPicMulti, labParse: TLabel;
	edTitleLang, edMPAADefault, edMPAAReplace, edPicSizeX, edPicSizeY, edFormat: TEdit;
	comboLocalService: TComboBox;
	gbTrace: TGroupBox;								  // 20101017-JeF
	rbTraceModeSave, rbTraceModeLoad: TRadioButton;   // 20101017-JeF
	labTraceLevel: TLabel;							  // 20101017-JeF
	edTraceLevel: TEdit;							  // 20101017-JeF
	cbTraceAsk, cbTVDBPosters, cbTVDBFanart, cbParseTitles: TCheckBox;							  // 20101017-JeF
	posx, posy, my_value: integer;
	cbTMDBPosters, cbTMDBImages, cbTVDBEpisodes, cbTVDBEpisodeDesc,
    cbTVDBEpisodeDescEng, cbTVSeriesSaveActorsEpisodesNumbers, cbAdultContent, cbDlTitle, cbDlUnknown, cbParseTypeFromGenre: TCheckBox;
	
procedure ParseClick(Sender: TCheckBox);
begin
	if cbParseTitles.Checked then
		edFormat.Enabled := True
	else
		edFormat.Enabled := False;
end;

procedure ButtonClick(Sender: TButton);
var
	zn: integer;
begin
	try
		RegWriteInteger('IMDB_Mov_OvrMainDlOptions', BoolToInt(cbOvrMainDlOptions.Checked));
		RegWriteInteger('IMDB_Mov_DlOriginalTitle' , BoolToInt(cbDlOriginalTitle.Checked));
		RegWriteInteger('IMDB_Mov_DlYear'          , BoolToInt(cbDlYear.Checked));
		RegWriteInteger('IMDB_Mov_DlGenres'        , BoolToInt(cbDlGenres.Checked));
		RegWriteInteger('IMDB_Mov_DlCountries'     , BoolToInt(cbDlCountries.Checked));
		RegWriteInteger('IMDB_Mov_DlDuration'      , BoolToInt(cbDlDuration.Checked));
		RegWriteInteger('IMDB_Mov_DlStudios'       , BoolToInt(cbDlStudios.Checked));
		RegWriteInteger('IMDB_Mov_DlType'          , BoolToInt(cbDlType.Checked));
		RegWriteInteger('IMDB_Mov_DlEpisodes'      , BoolToInt(cbDlEpisodes.Checked));
		RegWriteInteger('IMDB_Mov_DlDirectors'     , BoolToInt(cbDlDirectors.Checked));
		RegWriteInteger('IMDB_Mov_DlActors'        , BoolToInt(cbDlActors.Checked));
		RegWriteInteger('IMDB_Mov_DlWriters'       , BoolToInt(cbDlWriters.Checked));
		RegWriteInteger('IMDB_Mov_DlComposers'     , BoolToInt(cbDlComposers.Checked));
		RegWriteInteger('IMDB_Mov_DlProducers'     , BoolToInt(cbDlProducers.Checked));
		RegWriteInteger('IMDB_Mov_DlCameraman'     , BoolToInt(cbDlCameraman.Checked));
		RegWriteInteger('IMDB_Mov_DlAwards'        , BoolToInt(cbDlAwards.Checked));
		RegWriteInteger('IMDB_Mov_DlTitle'        , BoolToInt(cbDlTitle.Checked));

		RegWriteInteger('IMDBDownloadTrivia', BoolToInt(cbDownloadTrivia.Checked));
		RegWriteInteger('IMDBDownloadGoofs', BoolToInt(cbDownloadGoofs.Checked));
		RegWriteInteger('IMDBDownloadQuotes', BoolToInt(cbDownloadQuotes.Checked));
		RegWriteInteger('IMDBDownloadConnections', BoolToInt(cbDownloadConnections.Checked));
		RegWriteInteger('IMDBDownloadSoundtracks', BoolToInt(cbDownloadSoundtracks.Checked));
		RegWriteInteger('IMDBImportDesc', BoolToInt(cbImportDesc.Checked));

		RegWriteInteger('IMDB_Mov_ImdbIdInEpisodeTitle' , BoolToInt(cbImdbIdInEpisodeTitle.Checked));  //20120414-JeF
		RegWriteInteger('IMDBFullCharacterName'         , BoolToInt(cbFullCharacterName.Checked));     //20120414-JeF
		RegWriteInteger('IMDBUseTmdbPosters', BoolToInt(cbTMDBPosters.Checked));
		RegWriteInteger('IMDBUseTmdbBackdrops', BoolToInt(cbTMDBImages.Checked));
		RegWriteInteger('IMDBUseTvdbPosters', BoolToInt(cbTVDBPosters.Checked));
		RegWriteInteger('IMDBUseTvdbFanart', BoolToInt(cbTVDBFanart.Checked));
		RegWriteInteger('IMDBTVDBEpisodes', BoolToInt(cbTVDBEpisodes.Checked));
		RegWriteInteger('IMDBTVDBDescriptions', BoolToInt(cbTVDBEpisodeDesc.Checked));
		RegWriteInteger('IMDBDownloadActorsEpisodesForTVSeries', BoolToInt(cbTVSeriesSaveActorsEpisodesNumbers.Checked));

		if cbAkaSearch.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBAkaSearch', zn);
		if cbShowPlotAuthors.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBShowPlotAuthors', zn);	
		if cbEpisodeFullDesc.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBEpisodeFullDesc', zn);
		if cbAkasInDesc.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBAkasInDesc', zn);
		try 
			zn := StrToInt(edPicSizeX.Text);
			RegWriteInteger('IMDBPicSizeX', zn);
		except
		end;
		try
			zn := StrToInt(edPicSizeY.Text);
			RegWriteInteger('IMDBPicSizeY', zn);
		except
		end;
		if cbImportMPAAReasons.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBImportMPAAReasons', zn);			

		// 20101017-JeF
		if rbTraceModeLoad.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBTraceMode', zn);
		try 
			zn := StrToInt(edTraceLevel.Text);
			RegWriteInteger('IMDBTraceLevel', zn);
		except
		end;
		if cbTraceAsk.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBTraceAsk', zn);
		if cbAdvSearch.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBAdvSearch', zn);
		
		if cbTMDBPosters.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBTMDBPosters', zn);
		if cbTMDBImages.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBTMDBImages', zn);
		if cbAdultContent.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBAdultContent', zn);
		if cbDlUnknown.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBDlUnknown', zn);
		if cbParseTypeFromGenre.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDBParseTypeFromGenre', zn);
		
		RegWriteString('IMDBTitleLang', edTitleLang.Text);
		RegWriteString('IMDBMPAADefault', edMPAADefault.Text);
		RegWriteString('IMDBMPAAReplace', edMPAAReplace.Text);
		RegWriteInteger('IMDBLocalService', comboLocalService.ItemIndex);
		if cbParseTitles.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IMDbParseTitles', zn);
		RegWriteString('IMDbParseFormat', edFormat.Text);
	except
	end;

	jTraceMode := RegReadInteger('IMDBTraceMode', 0);     // 20101017-JeF
	jTraceLevel := RegReadInteger('IMDBTraceLevel', 0);   // 20101017-JeF
	jTraceAsk := RegReadInteger('IMDBTraceAsk', 1);  	  // 20101017-JeF

	f.ModalResult := mrOk;
end;

begin
	result:=0;
	f := TForm.Create(nil);
	f.Caption := GetLangStr(1924);
	f.BorderStyle := bsDialog;
	f.Position := poScreenCenter;
	f.Width:=900;
	if jShowTraceSettings then f.Width:=1000;  // 20101017-JeF
	f.Height:=500;
	f.AutoSize:=false;

	posx :=  10;
	posy := -10;
	
	posy := posy + 20;
	cbOvrMainDlOptions := TCheckBox.Create(f);
	cbOvrMainDlOptions.Name := 'cbOvrMainDlOptions';
	cbOvrMainDlOptions.Parent := f;
	cbOvrMainDlOptions.SetBounds(posx, posy, 350, 20);
	if GetLangStr(2744) = '' 
		then cbOvrMainDlOptions.Caption := 'Override Global Download Options (F10)'
	else cbOvrMainDlOptions.Caption := GetLangStr(2744);
	if GetLangStr(2745) = '' 
		then cbOvrMainDlOptions.Hint := 'Override values/flags set in main download options window (F10)'
	else cbOvrMainDlOptions.Hint := GetLangStr(2745);
	cbOvrMainDlOptions.Checked := IntToBool(RegReadInteger('IMDB_Mov_OvrMainDlOptions', 0));

	{--------------}
	{--- Search ---}
	{--------------}
	posx :=  10;
	posy := posy + 50;

	gbSearch:=TGroupBox.Create(f);
	gbSearch.Name:='gbSearch';
	gbSearch.Parent:=f;
	gbSearch.SetBounds(posx, posy, 485, 30);
	gbSearch.Caption:=' ' + GetLangStr(44) + ' ';
	gbSearch.Hint:=GetLangStr(44);
	posy := 0;
	
	posy := posy + 20;
	gbSearch.Height := gbSearch.Height + 20;
	cbAkaSearch := TCheckBox.Create(f);
	cbAkaSearch.Name := 'cbAkaSearch';
	cbAkaSearch.Parent := gbSearch;
	cbAkaSearch.SetBounds(posx, posy, 370, 20);
	cbAkaSearch.Caption := GetLangStr(1939);
	my_value := RegReadInteger('IMDBAkaSearch', 0);
	if my_value=1 then
		cbAkaSearch.Checked := True;
		
		

	{-----------------}
	{--- Main Data ---}
	{-----------------}
	posx :=  10;
	posy := gbSearch.Top + gbSearch.Height + 15;

	gbDlOptions:=TGroupBox.Create(f);
	gbDlOptions.Name:='gbDlOptions';
	gbDlOptions.Parent:=f;
	gbDlOptions.SetBounds(posx, posy, 485, 30);
	if GetLangStr(2746) = '' 
		then gbDlOptions.Caption := ' Main Data '
	else gbDlOptions.Caption := ' ' + GetLangStr(2746) + ' ';
	gbDlOptions.Hint := gbDlOptions.Caption;
	posy := 0;
	
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlOriginalTitle := TCheckBox.Create(f);
	cbDlOriginalTitle.Name := 'cbDlOriginalTitle';
	cbDlOriginalTitle.Parent := gbDlOptions;
	cbDlOriginalTitle.SetBounds(posx, posy, 200, 20);
	cbDlOriginalTitle.Caption := GetLangStr(167);
	cbDlOriginalTitle.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlOriginalTitle', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlDuration := TCheckBox.Create(f);
	cbDlDuration.Name := 'cbDlDuration';
	cbDlDuration.Parent := gbDlOptions;
	cbDlDuration.SetBounds(posx, posy, 200, 20);
	cbDlDuration.Caption := GetLangStr(147);
	cbDlDuration.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlDuration', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlYear := TCheckBox.Create(f);
	cbDlYear.Name := 'cbDlYear';
	cbDlYear.Parent := gbDlOptions;
	cbDlYear.SetBounds(posx, posy, 200, 20);
	cbDlYear.Caption := GetLangStr(169);
	cbDlYear.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlYear', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlGenres := TCheckBox.Create(f);
	cbDlGenres.Name := 'cbDlGenres';
	cbDlGenres.Parent := gbDlOptions;
	cbDlGenres.SetBounds(posx, posy, 200, 20);
	cbDlGenres.Caption := GetLangStr(179);
	cbDlGenres.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlGenres', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlCountries := TCheckBox.Create(f);
	cbDlCountries.Name := 'cbDlCountries';
	cbDlCountries.Parent := gbDlOptions;
	cbDlCountries.SetBounds(posx, posy, 200, 20);
	cbDlCountries.Caption := GetLangStr(180);
	cbDlCountries.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlCountries', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlStudios := TCheckBox.Create(f);
	cbDlStudios.Name := 'cbDlStudios';
	cbDlStudios.Parent := gbDlOptions;
	cbDlStudios.SetBounds(posx, posy, 200, 20);
	cbDlStudios.Caption := GetLangStr(493);
	cbDlStudios.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlStudios', 1));
	
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlType := TCheckBox.Create(f);
	cbDlType.Name := 'cbDlType';
	cbDlType.Parent := gbDlOptions;
	cbDlType.SetBounds(posx, posy, 200, 20);
	cbDlType.Caption := GetLangStr(173);
	cbDlType.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlType', 1));

	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlAwards := TCheckBox.Create(f);
	cbDlAwards.Name := 'cbDlAwards';
	cbDlAwards.Parent := gbDlOptions;
	cbDlAwards.SetBounds(posx, posy, 200, 20);
	cbDlAwards.Caption := GetLangStr(574);
	cbDlAwards.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlAwards', 1));	

	posx := 220;
	posy := 0;
	
	posy := posy + 20;
	cbDlEpisodes := TCheckBox.Create(f);
	cbDlEpisodes.Name := 'cbDlEpisodes';
	cbDlEpisodes.Parent := gbDlOptions;
	cbDlEpisodes.SetBounds(posx, posy, 200, 20);
	cbDlEpisodes.Caption := GetLangStr(525);
	cbDlEpisodes.Hint := GetLangStr(1285);
	cbDlEpisodes.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlEpisodes', 1));

	posy := posy + 20;
	cbDlDirectors := TCheckBox.Create(f);
	cbDlDirectors.Name := 'cbDlDirectors';
	cbDlDirectors.Parent := gbDlOptions;
	cbDlDirectors.SetBounds(posx, posy, 200, 20);
	cbDlDirectors.Caption := GetLangStr(181);
	cbDlDirectors.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlDirectors', 1));
		
	posy := posy + 20;
	cbDlActors := TCheckBox.Create(f);
	cbDlActors.Name := 'cbDlActors';
	cbDlActors.Parent := gbDlOptions;
	cbDlActors.SetBounds(posx, posy, 200, 20);
	cbDlActors.Caption := GetLangStr(164);
	cbDlActors.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlActors', 1));
		
	posy := posy + 20;
	cbDlWriters := TCheckBox.Create(f);
	cbDlWriters.Name := 'cbDlWriters';
	cbDlWriters.Parent := gbDlOptions;
	cbDlWriters.SetBounds(posx, posy, 200, 20);
	cbDlWriters.Caption := GetLangStr(182);
	cbDlWriters.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlWriters', 1));
		
	posy := posy + 20;
	cbDlComposers := TCheckBox.Create(f);
	cbDlComposers.Name := 'cbDlComposers';
	cbDlComposers.Parent := gbDlOptions;
	cbDlComposers.SetBounds(posx, posy, 200, 20);
	cbDlComposers.Caption := GetLangStr(491);
	cbDlComposers.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlComposers', 1));
	
	posy := posy + 20;
	cbDlProducers := TCheckBox.Create(f);
	cbDlProducers.Name := 'cbDlProducers';
	cbDlProducers.Parent := gbDlOptions;
	cbDlProducers.SetBounds(posx, posy, 200, 20);
	cbDlProducers.Caption := GetLangStr(71);
	cbDlProducers.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlProducers', 1));
	
	posy := posy + 20;
	cbDlCameraman := TCheckBox.Create(f);
	cbDlCameraman.Name := 'cbDlCameraman';
	cbDlCameraman.Parent := gbDlOptions;
	cbDlCameraman.SetBounds(posx, posy, 200, 20);
	cbDlCameraman.Caption := GetLangStr(4576);
	cbDlCameraman.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlCameraman', 1));
		
	
	posy := posy + 20;
	cbDlTitle := TCheckBox.Create(f);
	cbDlTitle.Name := 'cbDlTitle';
	cbDlTitle.Parent := gbDlOptions;
	cbDlTitle.SetBounds(posx, posy, 200, 20);
	cbDlTitle.Caption := GetLangStr(48);
	cbDlTitle.Checked := IntToBool(RegReadInteger('IMDB_Mov_DlTitle', 1));
	
	{--------------------}
	{--- Descriptions ---}
	{--------------------}
	posx := gbDlOptions.Left + gbDlOptions.Width + 20;
	posy := gbSearch.Top;

	gbDescOptions:=TGroupBox.Create(f);
	gbDescOptions.Name:='gbDescOptions';
	gbDescOptions.Parent:=f;
	gbDescOptions.SetBounds(posx, posy, 485, 30);
	gbDescOptions.Caption:=' ' + GetLangStr(162) + ' ';
	gbDescOptions.Hint:=GetLangStr(162);
	posx := 10;
	posy := 0;
	
	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbImportDesc := TCheckBox.Create(f);
	cbImportDesc.Name := 'cbImportDesc';
	cbImportDesc.Parent := gbDescOptions;
	cbImportDesc.SetBounds(posx, posy, 370, 20);
	cbImportDesc.Caption := GetLangStr(1938);
	my_value := RegReadInteger('IMDBImportDesc', 1);
	if my_value=1 then
		cbImportDesc.Checked := True;
		
	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbShowPlotAuthors := TCheckBox.Create(f);
	cbShowPlotAuthors.Name := 'cbShowPlotAuthors';
	cbShowPlotAuthors.Parent := gbDescOptions;
	cbShowPlotAuthors.SetBounds(posx, posy, 370, 20);
	cbShowPlotAuthors.Caption := GetLangStr(1940);
	my_value := RegReadInteger('IMDBShowPlotAuthors', 1);
	if my_value=1 then
		cbShowPlotAuthors.Checked := True;
		
	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbAkasInDesc := TCheckBox.Create(f);
	cbAkasInDesc.Name := 'cbAkasInDesc';
	cbAkasInDesc.Parent := gbDescOptions;
	cbAkasInDesc.SetBounds(posx, posy, 370, 20);
	cbAkasInDesc.Caption := GetLangStr(1942);
	my_value := RegReadInteger('IMDBAkasInDesc', 0);
	if my_value=1 then
		cbAkasInDesc.Checked := True;
		
	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbDownloadTrivia := TCheckBox.Create(f);
	cbDownloadTrivia.Name := 'cbDownloadTrivia';
	cbDownloadTrivia.Parent := gbDescOptions;
	cbDownloadTrivia.SetBounds(posx, posy, 350, 20);
	cbDownloadTrivia.Caption := GetLangStr(1933);
	my_value := RegReadInteger('IMDBDownloadTrivia', 1);
	if my_value=1 then
		cbDownloadTrivia.Checked := True;
		
	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbDownloadGoofs := TCheckBox.Create(f);
	cbDownloadGoofs.Name := 'cbDownloadGoofs';
	cbDownloadGoofs.Parent := gbDescOptions;
	cbDownloadGoofs.SetBounds(posx, posy, 350, 20);
	cbDownloadGoofs.Caption := GetLangStr(1934);
	my_value := RegReadInteger('IMDBDownloadGoofs', 1);
	if my_value=1 then
		cbDownloadGoofs.Checked := True;
		
	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbDownloadQuotes := TCheckBox.Create(f);
	cbDownloadQuotes.Name := 'cbDownloadQuotes';
	cbDownloadQuotes.Parent := gbDescOptions;
	cbDownloadQuotes.SetBounds(posx, posy, 350, 20);
	cbDownloadQuotes.Caption := GetLangStr(1935);
	my_value := RegReadInteger('IMDBDownloadQuotes', 0);
	if my_value=1 then
		cbDownloadQuotes.Checked := True;
		
	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbDownloadConnections := TCheckBox.Create(f);
	cbDownloadConnections.Name := 'cbDownloadConnections';
	cbDownloadConnections.Parent := gbDescOptions;
	cbDownloadConnections.SetBounds(posx, posy, 350, 20);
	cbDownloadConnections.Caption := GetLangStr(1936);
	my_value := RegReadInteger('IMDBDownloadConnections', 0);
	if my_value=1 then
		cbDownloadConnections.Checked := True;

	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbDownloadSoundtracks := TCheckBox.Create(f);
	cbDownloadSoundtracks.Name := 'cbDownloadSoundtracks';
	cbDownloadSoundtracks.Parent := gbDescOptions;
	cbDownloadSoundtracks.SetBounds(posx, posy, 370, 20);
	cbDownloadSoundtracks.Caption := GetLangStr(1937);
	my_value := RegReadInteger('IMDBDownloadSoundtracks', 0);
	if my_value=1 then
		cbDownloadSoundtracks.Checked := True;	
		
	posy := posy + 20;
	gbDescOptions.Height := gbDescOptions.Height + 20;
	cbEpisodeFullDesc := TCheckBox.Create(f);
	cbEpisodeFullDesc.Name := 'cbEpisodeFullDesc';
	cbEpisodeFullDesc.Parent := gbDescOptions;
	cbEpisodeFullDesc.SetBounds(posx, posy, 370, 20);
	cbEpisodeFullDesc.Caption := GetLangStr(1941);
	my_value := RegReadInteger('IMDBEpisodeFullDesc', 0);
	if my_value=1 then
		cbEpisodeFullDesc.Checked := True;
		
	{-----------------------------}
	{-------- TV series ----------}
	{-----------------------------}
		
	posy := gbDescOptions.Top + gbDescOptions.Height + 20;
	posx := gbDescOptions.Left;

	gbTVSeries:=TGroupBox.Create(f);
	gbTVSeries.Name:='gbTVSeries';
	gbTVSeries.Parent:=f;
	gbTVSeries.SetBounds(posx, posy, 485, 30);
	if GetLangStr(3875) = '' 
		then gbTVSeries.Caption := ' TV Series '
	else gbTVSeries.Caption := ' ' + GetLangStr(3875) + ' ';
	gbTVSeries.Hint := gbTVSeries.Caption;
	posx := 10;
	posy := 0;
		
	posy := posy + 20;
	gbTVSeries.Height := gbTVSeries.Height + 20;
	cbTVDBEpisodes := TCheckBox.Create(f);
	cbTVDBEpisodes.Name := 'cbTVDBEpisodes';
	cbTVDBEpisodes.Parent := gbTVSeries;
	cbTVDBEpisodes.SetBounds(posx, posy, 420, 20);
	cbTVDBEpisodes.Caption := 'Download episode names, season posters, episode covers from thetvdb.com';
	s := GetLangStr(3880);
	if s<>'' then
		cbTVDBEpisodes.Caption := Format(s, ['thetvdb.com']);
	my_value := RegReadInteger('IMDBTVDBEpisodes', 1);
	if my_value=1 then
		cbTVDBEpisodes.Checked := True;

	posy := posy + 20;
	gbTVSeries.Height := gbTVSeries.Height + 20;
	cbTVDBEpisodeDesc := TCheckBox.Create(f);
	cbTVDBEpisodeDesc.Name := 'cbTVDBEpisodeDesc';
	cbTVDBEpisodeDesc.Parent := gbTVSeries;
	cbTVDBEpisodeDesc.SetBounds(posx, posy, 420, 20);
	cbTVDBEpisodeDesc.Caption := 'Download episode descriptions from thetvdb.com (time consuming)';
	s := GetLangStr(3881);
	if s<>'' then
		cbTVDBEpisodeDesc.Caption := Format(s, ['thetvdb.com']);
	my_value := RegReadInteger('IMDBTVDBDescriptions', 1);
	if my_value=1 then
		cbTVDBEpisodeDesc.Checked := True;
		
  // SaAve actors' episodes for TVSeries
	posy := posy + 20;
	gbTVSeries.Height := gbTVSeries.Height + 20;
	cbTVSeriesSaveActorsEpisodesNumbers := TCheckBox.Create(f);
	cbTVSeriesSaveActorsEpisodesNumbers.Name := 'cbTVSeriesSaveActorsEpisodesNumbers';
	cbTVSeriesSaveActorsEpisodesNumbers.Parent := gbTVSeries;
	cbTVSeriesSaveActorsEpisodesNumbers.SetBounds(posx, posy, 420, 20);
	cbTVSeriesSaveActorsEpisodesNumbers.Caption := 'Download actors episodes for TV Series';
	s := GetLangStr(3927);
	if s<>'' then
		cbTVSeriesSaveActorsEpisodesNumbers.Caption := s;
	my_value := RegReadInteger('IMDBDownloadActorsEpisodesForTVSeries', 0);
	if my_value=1 then
		cbTVSeriesSaveActorsEpisodesNumbers.Checked := True;
		
	//Download unknown seasons and episodes
	posy := posy + 20;
	gbTVSeries.Height := gbTVSeries.Height + 20;
	cbDlUnknown := TCheckBox.Create(f);
	cbDlUnknown.Name := 'cbDlUnknown';
	cbDlUnknown.Parent := gbTVSeries;
	cbDlUnknown.SetBounds(posx, posy, 420, 20);
	cbDlUnknown.Caption := 'Download information about additional episodes';
	s := GetLangStr(7001);
	if s<>'' then
		cbDlUnknown.Caption := s;
	my_value := RegReadInteger('IMDBDlUnknown', 0);
	if my_value=1 then
		cbDlUnknown.Checked := True;


	{-----------------------------}
	{--- Miscellaneous options ---}
	{-----------------------------}
	posx := gbDescOptions.Left + 10;
	posy := 10;
	
	//20120414-JeF
	cbImdbIdInEpisodeTitle := TCheckBox.Create(f);
	cbImdbIdInEpisodeTitle.Name := 'cbImdbIdInEpisodeTitle';
	cbImdbIdInEpisodeTitle.Parent := f;
	cbImdbIdInEpisodeTitle.SetBounds(posx, posy, 370, 20);
	cbImdbIdInEpisodeTitle.Caption := GetLangStr(2747);
	if cbImdbIdInEpisodeTitle.Caption = '' 
		then cbImdbIdInEpisodeTitle.Caption := 'Add episode imdb id to episode title : (tt...)';
	cbImdbIdInEpisodeTitle.Checked := IntToBool(RegReadInteger('IMDB_Mov_ImdbIdInEpisodeTitle', 0));

	//20120414-JeF
	posy := posy + 20;
	cbFullCharacterName := TCheckBox.Create(f);
	cbFullCharacterName.Name := 'cbFullCharacterName';
	cbFullCharacterName.Parent := f;
	cbFullCharacterName.SetBounds(posx, posy, 370, 20);
	cbFullCharacterName.Caption := GetLangStr(2748);
	if cbFullCharacterName.Caption = '' 
		then cbFullCharacterName.Caption := 'Full Character Name (including brackets)';
	cbFullCharacterName.Checked := IntToBool(RegReadInteger('IMDBFullCharacterName', 0));

	{----------------}
	{--- Pictures ---}
	{----------------}
	posx :=  10;
	posy := gbDlOptions.Top + gbDlOptions.Height + 15;

	gbPictures:=TGroupBox.Create(f);
	gbPictures.Name:='gbPictures';
	gbPictures.Parent:=f;
	gbPictures.SetBounds(posx, posy, 485, 35);
	gbPictures.Caption:=' ' + GetLangStr(199) + ' ';
	gbPictures.Hint:=GetLangStr(199);
	posy := 0;
	
	posy := posy + 20;
	gbPictures.Height := gbPictures.Height + 25;
	edPicSizeX := TEdit.Create(f);
	edPicSizeX.Name := 'edPicSizeX';
	edPicSizeX.Parent := gbPictures;
	edPicSizeX.SetBounds(posx, posy, 40, 25);
	edPicSizeX.Text := IntToStr(RegReadInteger('IMDBPicSizeX', defaultPicSizeX));
	
	labPicMulti := TLabel.Create(f);
	labPicMulti.Name := 'labPicMulti';
	labPicMulti.Parent := gbPictures;
	labPicMulti.SetBounds(posx + 46, edPicSizeX.Top + 3, 10, 25);
	labPicMulti.Caption := 'X';
	
	edPicSizeY := TEdit.Create(f);
	edPicSizeY.Name := 'edPicSizeY';
	edPicSizeY.Parent := gbPictures;
	edPicSizeY.SetBounds(posx + 60, posy, 40, 25);
	edPicSizeY.Text := IntToStr(RegReadInteger('IMDBPicSizeY', defaultPicSizeY));
	
	labPicSize := TLabel.Create(f);
	labPicSize.Name := 'labPicSize';
	labPicSize.Parent := gbPictures;
	labPicSize.SetBounds(posx + 110, edPicSizeX.Top + 3, 160, 25);
	labPicSize.Caption := GetLangStr(1948);
	posy := posy + 10;

	posy := posy + 20;
	gbPictures.Height := gbPictures.Height + 20;
	cbTMDBPosters := TCheckBox.Create(f);
	cbTMDBPosters.Name := 'cbTMDBPosters';
	cbTMDBPosters.Parent := gbPictures;
	cbTMDBPosters.SetBounds(posx, posy, 370, 20);
	cbTMDBPosters.Caption := 'Download movie posters from themoviedb.org';
	s := GetLangStr(3876);
	if s<>'' then
		cbTMDBPosters.Caption := Format(s, ['themoviedb.org']);;
	my_value := RegReadInteger('IMDBUseTmdbPosters', 0);
	if my_value=1 then
		cbTMDBPosters.Checked := True;
		
	posy := posy + 20;
	gbPictures.Height := gbPictures.Height + 20;
	cbTMDBImages := TCheckBox.Create(f);
	cbTMDBImages.Name := 'cbTMDBImages';
	cbTMDBImages.Parent := gbPictures;
	cbTMDBImages.SetBounds(posx, posy, 370, 20);
	cbTMDBImages.Caption := 'Download movie backdrops from themoviedb.org';
	s := GetLangStr(3877);
	if s<>'' then
		cbTMDBImages.Caption := Format(s, ['themoviedb.org']);
	my_value := RegReadInteger('IMDBUseTmdbBackdrops', 1);
	if my_value=1 then
		cbTMDBImages.Checked := True;
		
	posy := posy + 20;
	gbPictures.Height := gbPictures.Height + 20;
	cbTVDBPosters := TCheckBox.Create(f);
	cbTVDBPosters.Name := 'cbTVDBPosters';
	cbTVDBPosters.Parent := gbPictures;
	cbTVDBPosters.SetBounds(posx, posy, 370, 20);
	cbTVDBPosters.Caption := 'Download posters for TV series from thetvdb.com';
	s := GetLangStr(3878);
	if s<>'' then
		cbTVDBPosters.Caption := Format(s, ['thetvdb.com']);
	my_value := RegReadInteger('IMDBUseTvdbPosters', 0);
	if my_value=1 then
		cbTVDBPosters.Checked := True;
		
	posy := posy + 20;
	gbPictures.Height := gbPictures.Height + 20;
	cbTVDBFanart := TCheckBox.Create(f);
	cbTVDBFanart.Name := 'cbTVDBFanart';
	cbTVDBFanart.Parent := gbPictures;
	cbTVDBFanart.SetBounds(posx, posy, 370, 20);
	cbTVDBFanart.Caption := 'Download backdrops for TV series from thetvdb.com';
	s := GetLangStr(3879);
	if s<>'' then
		cbTVDBFanart.Caption := Format(s, ['thetvdb.com']);
	my_value := RegReadInteger('IMDBUseTvdbFanart', 1);
	if my_value=1 then
		cbTVDBFanart.Checked := True;

	{----------------}
	{--- Language ---}
	{----------------}
	posx :=  10;
	posy := gbPictures.Top + gbPictures.Height + 15;

	gbLanguage:=TGroupBox.Create(f);
	gbLanguage.Name:='gbLanguage';
	gbLanguage.Parent:=f;
	gbLanguage.SetBounds(posx, posy, 485, 35);
	gbLanguage.Caption:=' ' + GetLangStr(87) + ' ';
	gbLanguage.Hint:=GetLangStr(87);
	posy := 0;
	
	posy := posy + 20;
	gbLanguage.Height := gbLanguage.Height + 20;
	comboLocalService := TComboBox.Create(f);
	comboLocalService.Name := 'comboLocalService';
	comboLocalService.Parent := gbLanguage;
	comboLocalService.SetBounds(posx, posy, 100, 20);
	comboLocalService.Style := csDropDownList;
	comboLocalService.Items.Add('imdb.com');
	comboLocalService.Items.Add('imdb.de');
	comboLocalService.Items.Add('imdb.es');
	comboLocalService.Items.Add('imdb.fr');
	comboLocalService.Items.Add('imdb.it');
	comboLocalService.Items.Add('imdb.pt');
	comboLocalService.ItemIndex := RegReadInteger('IMDBLocalService', 0);
	
	labLocalService:=TLabel.Create(f);
	labLocalService.Name := 'labLocalService';
	labLocalService.Parent := gbLanguage;
	labLocalService.SetBounds(posx + 110, comboLocalService.Top + 3, 160, 20);
	labLocalService.Caption := GetLangStr(1947);
	posy := posy + 10;
	gbLanguage.Height := gbLanguage.Height + 10;
		
	posy := posy + 20;
	gbLanguage.Height := gbLanguage.Height + 20;
	edTitleLang := TEdit.Create(f);
	edTitleLang.Name := 'edTitleLang';
	edTitleLang.Parent := gbLanguage;
	edTitleLang.SetBounds(posx, posy, 100, 25);
	edTitleLang.Text := RegReadString('IMDBTitleLang', '');
		
	labTitleLang:=TLabel.Create(f);
	labTitleLang.Name := 'labTitleLang';
	labTitleLang.Parent := gbLanguage;
	labTitleLang.SetBounds(posx + 110, edTitleLang.Top + 3, 160, 25);
	labTitleLang.Caption := GetLangStr(1943);
	posy := posy + 10;
		
	{------------}
	{--- MPAA ---}
	{------------}
	posx := gbTVSeries.Left;
	posy := gbTVSeries.Top + gbTVSeries.Height + 15;

	gbMpaa:=TGroupBox.Create(f);
	gbMpaa.Name:='gbMpaa';
	gbMpaa.Parent:=f;
	gbMpaa.SetBounds(posx, posy, 485, 35);
	gbMpaa.Caption:=' ' + GetLangStr(383) + ' ';
	gbMpaa.Hint:=GetLangStr(383);
	posx := 10;
	posy := 0;
	
	posy := posy + 20;
	gbMpaa.Height := gbMpaa.Height + 20;
	cbImportMPAAReasons := TCheckBox.Create(f);
	cbImportMPAAReasons.Name := 'cbImportMPAAReasons';
	cbImportMPAAReasons.Parent := gbMpaa;
	cbImportMPAAReasons.SetBounds(posx, posy, 370, 20);
	cbImportMPAAReasons.Caption := GetLangStr(1946);
	my_value := RegReadInteger('IMDBImportMPAAReasons', 1);
	if my_value=1 then
		cbImportMPAAReasons.Checked := True;
		
	posy := posy + 25;
	gbMpaa.Height := gbMpaa.Height + 25;
	edMPAADefault := TEdit.Create(f);
	edMPAADefault.Name := 'edMPAADefault';
	edMPAADefault.Parent := gbMpaa;
	edMPAADefault.SetBounds(posx, posy, 100, 25);
	edMPAADefault.Text := RegReadString('IMDBMPAADefault', '');
		
	labMPAADefault:=TLabel.Create(f);
	labMPAADefault.Name := 'labMPAADefault';
	labMPAADefault.Parent := gbMpaa;
	labMPAADefault.SetBounds(posx + 110, edMPAADefault.Top + 3, 160, 25);
	labMPAADefault.Caption := GetLangStr(1944);
	posy := posy + 10;
	gbMpaa.Height := gbMpaa.Height + 10;
		
	posy := posy + 20;
	gbMpaa.Height := gbMpaa.Height + 20;
	edMPAAReplace := TEdit.Create(f);
	edMPAAReplace.Name := 'edMPAAReplace';
	edMPAAReplace.Parent := gbMpaa;
	edMPAAReplace.SetBounds(posx, posy, 100, 25);
	edMPAAReplace.Text := RegReadString('IMDBMPAAReplace', '');
		
	labMPAAReplace:=TLabel.Create(f);
	labMPAAReplace.Name := 'labMPAAReplace';
	labMPAAReplace.Parent := gbMpaa;
	labMPAAReplace.SetBounds(posx + 110, edMPAAReplace.Top + 3, 160, 25);
	labMPAAReplace.Caption := GetLangStr(1945);
	
	posx := gbMpaa.Left + 10;
	posy := gbMpaa.Top + gbMpaa.Height + 10;
	//posy := posy + 25;
	cbParseTypeFromGenre := TCheckBox.Create(f);
	cbParseTypeFromGenre.Name := 'cbParseTypeFromGenre';
	cbParseTypeFromGenre.Parent := f;
	cbParseTypeFromGenre.SetBounds(posx, posy, 320, 25);
	cbParseTypeFromGenre.Caption := 'Use genres to detect types of movies';
	s := GetLangStr(7002);
	if s<>'' then
		cbParseTypeFromGenre.Caption := s;
	my_value := RegReadInteger('IMDBParseTypeFromGenre', 0);
	if my_value = 1 then
		cbParseTypeFromGenre.Checked := True;
		
	posy := posy + 20;
	cbParseTitles := TCheckBox.Create(f);
	cbParseTitles.Name := 'cbParseTitles';
	cbParseTitles.Parent := f;
	cbParseTitles.SetBounds(posx, posy, 380, 20);
	cbParseTitles.Caption := 'Extract data from titles using the following format';
	s := GetLangStr(7020);
	if s<>'' then
		cbParseTitles.Caption := s;
	my_value := RegReadInteger('IMDbParseTitles', 0);
	if my_value = 1 then
		cbParseTitles.Checked := True;
		
	posy := posy + 20;
	edFormat := TEdit.Create(f);
	edFormat.Name := 'edFormat';
	edFormat.Parent := f;
	edFormat.SetBounds(posx, posy, 380, 25);
	edFormat.Text := RegReadString('IMDbParseFormat', '%T');
	cbParseTitles.Onclick := @ParseClick;
	ParseClick(cbParseTitles);
	
	posy := posy + 25;
	labParse := TLabel.Create(f);
	labParse.Name := 'labParse';
	labParse.Parent := f;
	labParse.SetBounds(posx, posy, 380, 20);
	labParse.Caption := 'Hint: %Т - movie title, %Y - year, %C - movie code on the site';
	s := GetLangStr(7021);
	if s<>'' then
		labParse.Caption := s;

	posx :=  10;
	posy := gbLanguage.Top + gbLanguage.Height - 5;

	// 20101017-JeF
	if jShowTraceSettings then begin
		gbTrace:=TGroupBox.Create(f);
		gbTrace.Name:='gbTrace';
		gbTrace.Parent:=f;
		gbTrace.SetBounds(gbDescOptions.Left  + gbDescOptions.Width - 200, 10, 200, 105);
		gbTrace.Caption:=GetLangStr(1691);
		gbTrace.Hint:=GetLangStr(1692);
		rbTraceModeSave:=TRadioButton.Create(f);
		rbTraceModeSave.Name:='rbTraceModeSave';
		rbTraceModeSave.Parent:=gbTrace;
		rbTraceModeSave.SetBounds(10, 20, 80, 20);
		rbTraceModeSave.Caption:=GetLangStr(1688);
		rbTraceModeSave.Hint:=GetLangStr(1693);
		rbTraceModeLoad:=TRadioButton.Create(f);
		rbTraceModeLoad.Name:='rbTraceModeLoad';
		rbTraceModeLoad.Parent:=gbTrace;
		rbTraceModeLoad.SetBounds(100, 20, 100, 20);
		rbTraceModeLoad.Caption:=GetLangStr(1687);
		rbTraceModeLoad.Hint:=GetLangStr(1694);
		my_value := RegReadInteger('IMDBTraceMode', 0);
		if my_value=0 then
			rbTraceModeSave.Checked := True
		else if my_value=1 then
			rbTraceModeLoad.Checked := True;
		labTraceLevel:=TLabel.Create(f);
		labTraceLevel.Name := 'labTraceLevel';
		labTraceLevel.Parent := gbTrace;
		labTraceLevel.SetBounds(10, 50, 100, 25);
		labTraceLevel.Caption := GetLangStr(1695);
		labTraceLevel.Hint:=GetLangStr(1696);
		edTraceLevel := TEdit.Create(f);
		edTraceLevel.Name := 'edTraceLevel';
		edTraceLevel.Parent := gbTrace;
		edTraceLevel.SetBounds(170, 45, 20, 25);
		edTraceLevel.Text := IntToStr(RegReadInteger('IMDBTraceLevel', 0));
		edTraceLevel.Hint := labTraceLevel.Hint;
		cbTraceAsk := TCheckBox.Create(f);
		cbTraceAsk.Name := 'cbTraceAsk';
		cbTraceAsk.Parent := gbTrace;
		cbTraceAsk.SetBounds(10, 80, 185, 20);
		cbTraceAsk.Caption := GetLangStr(1697);
		my_value := RegReadInteger('IMDBTraceAsk', 1);
		if my_value=1 then
			cbTraceAsk.Checked := True;
	end;

	f.Height := posy + 110;
	f.Width  := gbDescOptions.Left + gbDescOptions.Width + 20;
	
	b := TButton.Create(f);
	b.Name := 'btnOK';
	b.Parent := f;
	b.SetBounds(trunc(f.width/2)-40, f.Height-70, 80, 25);
	b.Caption := '&OK';
	b.OnClick := @ButtonClick;

	f.ShowModal;
	f.Free;
end;


begin

	monthes[1]:='January';
	monthes[2]:='February';
	monthes[3]:='March';
	monthes[4]:='April';
	monthes[5]:='May';
	monthes[6]:='June';
	monthes[7]:='July';
	monthes[8]:='August';
	monthes[9]:='September';
	monthes[10]:='October';
	monthes[11]:='November';
	monthes[12]:='December';

	prefixes[1]:='The';
	prefixes[2]:='A';
	prefixes[3]:='An';
	prefixes[4]:='La';
	prefixes[5]:='Les';
	prefixes[6]:='Des';
	prefixes[7]:='L''';
	prefixes[8]:='Un';
	prefixes[9]:='El';
	prefixes[10]:='Il';
	prefixes[11]:='Le';
	prefixes[12]:='Uno';

	//RegWriteInteger('IMDBShowTraceSettings', 1);
	jShowTraceSettings := RegReadInteger('IMDBShowTraceSettings', 0);
	jTraceMode := RegReadInteger('IMDBTraceMode', 0);     // 20101017-JeF
	jTraceLevel := RegReadInteger('IMDBTraceLevel', 0);   // 20101017-JeF
	jTraceAsk := RegReadInteger('IMDBTraceAsk', 1);  	  // 20101017-JeF

	OvrMainDlOptions := IntToBool(RegReadInteger('IMDB_Mov_OvrMainDlOptions', 0));
	DlOriginalTitle  := IntToBool(RegReadInteger('IMDB_Mov_DlOriginalTitle', 1));
	DlYear           := IntToBool(RegReadInteger('IMDB_Mov_DlYear', 1));
	DlGenres         := IntToBool(RegReadInteger('IMDB_Mov_DlGenres', 1));
	DlCountries      := IntToBool(RegReadInteger('IMDB_Mov_DlCountries', 1));
	DlDuration       := IntToBool(RegReadInteger('IMDB_Mov_DlDuration', 1));
	DlStudios        := IntToBool(RegReadInteger('IMDB_Mov_DlStudios', 1));
	DlEpisodes       := IntToBool(RegReadInteger('IMDB_Mov_DlEpisodes', 1));
	DlDirectors      := IntToBool(RegReadInteger('IMDB_Mov_DlDirectors', 1));
	DlActors         := IntToBool(RegReadInteger('IMDB_Mov_DlActors', 1));
	DlWriters        := IntToBool(RegReadInteger('IMDB_Mov_DlWriters', 1));
	DlComposers      := IntToBool(RegReadInteger('IMDB_Mov_DlComposers', 1));
	DlAwards         := IntToBool(RegReadInteger('IMDB_Mov_DlAwards', 1));
	DlProducers      := IntToBool(RegReadInteger('IMDB_Mov_DlProducers', 1));
	DlCameraMan      := IntToBool(RegReadInteger('IMDB_Mov_DlCameraman', 1));
	
	DownloadTrivia := RegReadInteger('IMDBDownloadTrivia', 1);
	DownloadGoofs := RegReadInteger('IMDBDownloadGoofs', 1);
	DownloadQuotes := RegReadInteger('IMDBDownloadQuotes', 0);
	DownloadConnections := RegReadInteger('IMDBDownloadConnections', 0);
	DownloadSoundtracks := RegReadInteger('IMDBDownloadSoundtracks', 0);
	ImportDesc := RegReadInteger('IMDBImportDesc', 1);
	AkaSearch := RegReadInteger('IMDBAkaSearch', 0);
	ShowPlotAuthors := RegReadInteger('IMDBShowPlotAuthors', 1);
	EpisodeFullDesc := RegReadInteger('IMDBEpisodeFullDesc', 0);
	AkasInDesc := RegReadInteger('IMDBAkasInDesc', 0);
	ImportMPAAReasons := RegReadInteger('IMDBImportMPAAReasons', 1);
	TitleLang := RegReadString('IMDBTitleLang', '');
	MPAADefault := RegReadString('IMDBMPAADefault', '');
	MPAAReplace := RegReadString('IMDBMPAAReplace', '');
	IMDBLocalService := RegReadInteger('IMDBLocalService', 0);
	RequestParameters := TStringList.Create;
	RequestParametersWithCookies := TStringList.Create();
	RequestParameters.Add('Accept=text/html, application/xhtml+xml, */*');
	RequestParameters.Add('AcceptLanguage=en-US');
	RequestParameters.Add('Host=www.imdb.com');
	RequestParameters.Add('Connection=Close'); 
	RequestParameters.Add('useragent=Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko');
	RequestParametersWithCookies.Assign(RequestParameters);

	case IMDBLocalService of
		1: TVDBLID := 14;
		2: TVDBLID := 16;
		3: TVDBLID := 17;
		4: TVDBLID := 15;
		5: TVDBLID := 26;
	else
		TVDBLID := 7;
	end;
	UseTMDBPosters:=RegReadInteger('IMDBUseTmdbPosters', 0);
	UseTMDBSnapshots:=RegReadInteger('IMDBUseTmdbBackdrops', 1);
	DownloadTVDBEpisodeDescriptions:=RegReadInteger('IMDBTVDBDescriptions', 1);
	DownloadActorsEpisodesForTVSeries := RegReadInteger('IMDBDownloadActorsEpisodesForTVSeries', 0);
	DownloadTVDBEpisodes:=RegReadInteger('IMDBTVDBEpisodes', 1);
	DownloadTVDBEnglishDesc:=RegReadInteger('IMDBTVDBEngDesc', 1);
	UseTVDBPosters:=RegReadInteger('IMDBUseTvdbPosters', 0);
	UseTVDBFanart:=RegReadInteger('IMDBUseTvdbFanart', 1);

end.
