﻿const
	script_name='interSinema';
	language='Turkish';
	version=9;
	author='Vlad';
	MinProgramBuild=8000;
	PCount = 12;
	//MaxPicturesCount = 3;
var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments,
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings,
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList, DownloadMovieLinks: boolean;
	MaxShotsCount, MaxPostersCount, MaxBackdropsCount: integer;
	// 10.11.2010
	MaxTrailersCount: Integer;
	DownloadSeasonsCovers: Boolean;
	DownloadEpisodesCovers: Boolean;
	
	title, MovieName, s, s2, s3, s4, year, director, name, character, BasicURL, country, description, salary, tagline: string;
	episodes, movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	i, j: integer;
	director_code, code: string;
	//directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	rating, imdb_rating: double;
	front_cover_url, image_page_url: string;
	posters_exists, ask_amazon: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
const
	SITE_URL = 'https://www.intersinema.com';

function MovieSearch: integer;
var
	i, j, k: integer;
	title, description, year, small_cover: string;
begin
	s:='';
	titles_count:=0;
	i:=pos('class="title">Filmler:', all);
	if i>0 then begin
		j:=MyPos('</ul>', all, i+1);
		if j>0 then
			s:=copy(all, i, j-i);
	end;
	if (s='') or (pos('bir film bulunamad', all)>0) then
		//Movie not found
	else begin
		i:=Pos('<li', s);
		while i>0 do begin
			j:=MyPos('</li>', s, i+1);
			s2:=copy(s, i, j-i);
			// code
			title_code := ParseString(s2, '<a href="/(.*?)-filmi/"', 1);
			// movie title
			title := GetStr(s2, ' title="', '"');
			title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(title)));
			// description and year
			description := GetStr(s2, ' class="extra"', '</');
			year := ParseString(description, '\((\d+)\)', 1);
			if description <> '' then
				description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + description)));
			k := Pos('(', description);
			if k > 0 then
				delete(description, k, length(description) - k + 1);
			description := ClearExtraBlankCharacters(description);
			// cover
			small_cover := GetStr(s2, 'src="', '"');
			if small_cover <> '' then
				small_cover := SITE_URL + small_cover;
			if (title <> '') and (title_code <> '') then begin
				Inc(titles_count);
				SetSearchResult2(title, title_code, year, '', description, small_cover);
			end;
			delete(s, 1, j);
			i:=Pos('<li', s);
		end;
	end;
	result:=titles_count;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('https://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
	MovieName := EncodeURL(MovieName, 'windows-1254');
	url := SITE_URL + '/ara.asp?ara=' + MovieName;
	//url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
		result:=format('https://www.intersinema.com/%s-filmi', [code]);
end;

//returned link to front cover
function GetAmazonImages: string;
var
	res, all, url, s, s2, s3, amazon_url: string;
	i, j: integer;
begin
	s:=original_title;
	url:=format('https://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [original_title]);
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	amazon_url:='';
	i:=pos('<Item>', all);
	while (i>0) and (amazon_url='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			s3 := DecodeHTML(s3);
			if s3<>'' then begin
				if pos(UpperCase(original_title), UpperCase(s3))=1 then begin
					amazon_url:=ParseString(s2, '<LargeImage><URL>(.*?)</URL>', 1);
				end;
			end;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	if amazon_url<>'' then begin
		SetImageName('', amazon_url, '', 1);
		res:=amazon_url;
	end;
	result:=res;
end;

//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
  fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;


function GetInfo(url: string; images_only: boolean): string;
var 
	keyword, s, s2, s3, s4, cast_page, cast_url, plot_outline, name, code, small_photo, character: string;
	i, j, k: integer;
begin
	result:='';
	all:=DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;

	movie_code:=ParseString(url, 'https://www.intersinema.com/(.*?)-filmi$',1);
	movie_site_url:=GetMovieSiteURL(movie_code);
	
	if DownloadMovieFullCast then begin
		cast_url:='https://www.intersinema.com/'+movie_code+'-filmi-ekibi/';
		AddRequestForHTMLPageContent(cast_url, True, '');
	end;
	
	if MaxShotsCount > 0 then begin
		image_page_url := 'https://www.intersinema.com/'+movie_code+'-filmi-resimleri/';
		AddRequestForHTMLPageContent(image_page_url, True, '');
	end;
	
	//movie title and original_title
	title := GetStr(all, '<h1 class="title">', '</h1>');
	original_title := '';
	i := Pos('<span>(', title);
	if i > 0 then begin
		original_title := ParseString(title, '\((.*?)\)', 1);
		delete(title, i, length(title) - i + 1);
	end;
	if title <> '' then
		title := RemoveTags('<' + title);
	title := ClearExtraBlankCharacters(DecodeHTML(title));
	if title='' then
		exit;
		
	// small cover
	front_cover_url := GetStr(all, 'div class="poster', '</div>');
  front_cover_url := GetStr(front_cover_url, 'src="', '"');
	if front_cover_url <> '' then
		front_cover_url := SITE_URL + front_cover_url;
	front_cover_url := ReplaceStr(front_cover_url, '_kucuk', '_enbuyuk', -1);

	// description
	description := GetStr(all, '"description": "', '"');
	if description <> '' then
		description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));

	// genres
	s := GetStr(all, '"genre": [', ']');
	if s <> '' then
		s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	repeat
		i := Pos(',', s);
		if i > 0 then begin
			s2 := copy(s, 1, i-1);
			delete(s, 1, i);
		end
		else
			s2 := s;
		s2 := ClearExtraBlankCharacters(s2);
    s2 := RemoveStartEndBrackets(s2, '"', '"', False);
		if s2 <> '' then
			SetGenre(s2);
	until i = 0;
	
	// slogan
	s := GetStr(all, '<span>Slogan</span>:', '<');
	tagline := ClearExtraBlankCharacters(DecodeHTML(s));
	
	// year
	s := GetStr(all, '"datePublished":"', '"');
	if s <> '' then
		s := ClearExtraBlankCharacters(RemoveTags(s));
	year := ParseString(s, '(\d+)', 1);

	// duration
	duration := 0;
	s := GetStr(all, '"duration": "', '"');
	if s <> '' then
		s := ClearExtraBlankCharacters(RemoveTags(s));
	try
		duration := StrToInt(s);
	except
	end;
	
	// studio
	s := GetStr(all, '"productionCompany": {', '}');
	if s <> '' then
  begin
    s := GetStr(all, '"name": "', '"');
		s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
		SetStudio(s);
	end;
	
	// countries
	s := GetStr(all, 'Ülkesi</span>:', '<');
	if s <> '' then begin
		s := ClearExtraBlankCharacters(DecodeHTML(s));
		i := Pos('/', s);
		if i > 0 then
			s3 := '/'
		else
			s3 := ' ';
		repeat
			i := Pos(s3, s);
			if i > 0 then begin
				s2 := copy(s, 1, i-1);
				delete(s, 1, i);
			end
			else
				s2 := s;
			s2 := ClearExtraBlankCharacters(s2);
			if s2 <> '' then
				SetCountry(s2);
		until i = 0;
	end;
	
	// people
	if DownloadMovieFullCast then begin
		cast_page := GetHTMLPageContentFromRequest(cast_url);
		i := Pos('<div class="cast">', cast_page);
		if i > 0 then
			delete(cast_page, 1, i-1);
		// directors
		i := Pos('itemprop="director"', cast_page);
		if i > 0 then begin
			s := GetStr(cast_page, 'itemprop="director"', '</ul>');
			ExtractPeople(s, 1, 'Yönetmen');
		end;
		// writers
		i := Pos('itemprop="director"', cast_page);
		if i > 0 then begin
			s := GetStr(cast_page, 'itemprop="director"', '</ul>');
			ExtractPeople(s, 2, 'Senarist');
		end;
		// actors
		i := Pos('ve Karakterleri', cast_page);
		if i > 0 then begin
			s := GetStr(cast_page, 've Karakterleri', '</ul>');
			ExtractPeople(s, 3);
		end;
		// crew area
		s := GetStr(cast_page, 'Görevlileri', '</table>');
		// composers
		ExtractCrew(s, 4, 'Müzik');
		// producers
		ExtractCrew(s, 5, 'Yapımcı');
		// cinematographers
		ExtractCrew(s, 6, 'Görüntü Yönetmeni');
		ExtractCrew(s, 6, 'Sinematografi');
	end
	else begin
		// actors
		s := GetStr(all, 'person-photos', '</ul>');
		i := Pos('<li', s);
		while i > 0 do begin
			s2 := GetStr(s, '<li', '</li>');
			name := GetStr(s2, ' alt="', '"');
			name := ClearExtraBlankCharacters(DecodeHTML(name));
			code := GetStr(s2, 'href="/', '-filmleri/');
			small_photo := GetStr(s2, 'src="', '"');
			if (small_photo <> '') then begin
				if (Pos('https:', small_photo) = 0) then
					small_photo := SITE_URL + small_photo;
				small_photo := ReplaceStr(small_photo, '/ort_', '/', -1);
				if (Pos('logo', small_photo) > 0) then
					small_photo := '';
			end;
			character := GetStr(s2, '<span>', '</span>');
			character := ClearExtraBlankCharacters(DecodeHTML(character));
			if (name <> '') then
				SetPersonName(name, character, 3, code, small_photo);
			delete(s, 1, i);
			i := Pos('<li', s);
		end;
		// directors
		s := GetStr(all, '<span>Yönetmen</span>', '<br');
		i := Pos('<a ', s);
		while i > 0 do begin
			s2 := GetStr(s, '<a ', '</a>');
			code := GetStr(s2, 'href="/', '-filmleri/');
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)));
			if name <> '<' then
				SetPersonName(name, '', 1, code);
			delete(s, 1, i);
			i := Pos('<a ', s);
		end;
		// writers
		s := GetStr(all, '<span>Senaryo</span>', '<br');
		i := Pos('<a ', s);
		while i > 0 do begin
			s2 := GetStr(s, '<a ', '</a>');
			code := GetStr(s2, 'href="/', '-filmleri/');
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)));
			if name <> '<' then
				SetPersonName(name, '', 2, code);
			delete(s, 1, i);
			i := Pos('<a ', s);
		end;
	end;
	
end;

procedure ExtractPeople(text: String; mode: integer; role: String = '');
var
	i, j: Integer;
	s, temp, name, code, character, small_photo: String;
begin
	i := Pos('<li', text);
	while i > 0 do begin
		temp := GetStr(text, '<li', '</li>');
		code := GetStr(temp, 'href="/', '-filmleri/"');
		name := GetStr(temp, 'itemprop="name"', '</a');
		if name <> '' then
			name := RemoveTags('<' + name);
		if name = '' then
			name := GetStr(temp, 'title="', '"');
		name := ClearExtraBlankCharacters(DecodeHTML(name));
		small_photo := GetStr(temp, 'src="', '"');
		if (small_photo <> '') and (Pos('https:', small_photo) = 0) then
			small_photo := SITE_URL + small_photo;
		if (Pos('logo', small_photo) > 0) then
			small_photo := '';
		small_photo := ReplaceStr(small_photo, '/kk_', '/br', -1);
		character := GetStr(temp, 'class="role">', '</');
		character := ClearExtraBlankCharacters(DecodeHTML(character));
		if (mode <> 3) then begin
			if Pos(role, character) = 0 then
				name := '';
			character := '';
		end;
		if (name <> '') then
			SetPersonName(name, character, mode, code, small_photo);
		delete(text, 1, i);
		i := Pos('<li', text);
	end;
end;

procedure ExtractCrew(text: String; mode: Integer; role: String = '');
var
	i, j: Integer;
	s, name, code: String;
begin
	i := Pos('<tr>', text);
	while i > 0 do begin
		s := GetStr(text, '<tr>', '</tr>');
		if (Pos(role, s) > 0) then begin
			name := GetStr(s, 'href=', '</a>');
			code := GetStr(name, '"/', '-filmleri/');
			if name <> '' then begin
				name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + name)));
				SetPersonName(name, '', mode, code);
			end;
		end;
		delete(text, 1, i);
		i := Pos('<tr>', text);
	end;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;

//returned images links
procedure GetImages;
var
	temp, img_url: String;
	i, img_cnt: Integer;
begin
	//if ask_amazon then
		//GetAmazonImages;
	if front_cover_url<>'' then
		SetImageName('', front_cover_url, '', 1);
	img_cnt := 0;
	temp := GetHTMLPageContentFromRequest(image_page_url);
	temp := GetStr(temp, 'class="image-gallery-box"', '</ul>');
	i := Pos(' src="', temp);
	while (i > 0) and (img_cnt < MaxShotsCount) do begin
		img_url := GetStr(temp, ' src="', '"');
		if img_url <> '' then begin
			if (Pos('https:', img_url) = 0) then
				img_url := SITE_URL + img_url;
			img_url := ReplaceStr(img_url, '/k_', '/', -1);
			SetImageName('', img_url, '', 3);
			Inc(img_cnt);
		end;
		delete(temp, 1, i);
		i := Pos(' src="', temp);
	end;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.intersinema.com/'+code+'-filmi/';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:=format('https://www.intersinema.com/%s-filmleri/', [code]);
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;


begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.
