﻿const
	script_name='interSinema';
	language='Turkish';
	version=7;
	author='Vlad';
	MinProgramBuild=8000;
	PCount = 12;
	//MAX_PHOTOS_COUNT = 3;
var
	DownloadPersonBiography, DownloadPersonAdditionalInfo: boolean;
	MaxPhotosCount: integer;
	
	persons_count: integer;
	persons: array of string;
	imdb_codes: array of string;
	imdb_code, person_code: string;
	name, code, year, description: string;
	person, BasicURL, biography, trivia, character, birth_date, birthplace, birth_name, salary, height, original_name, death_date, person_site_url: string;
	photo_url: string;
	monthes: array [1..12] of string;
	prefixes: array [1..PCount] of string;
	movie_html: string;
	person_height: integer;
	
const
	SITE_URL = 'https://www.intersinema.com';

function GetSearchURLbyName(PersonName: string): string;
var
	url: string;
begin
	PersonName := EncodeURL(PersonName, 'windows-1254');
	// url := SITE_URL + '/kisiler/?ara=' + PersonName;
	url:=format('https://www.intersinema.com/ara.asp?ara=%s', [PersonName]);
	//url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=PersonSearch;
end;

function PersonSearch: integer;
var
	url, s, s2, s3, temp, name, code, small_photo, desc, dates: string;
	i, j, k: integer;
begin
	persons_count:=0;

	s:='';
	i := Pos('<div class="title">Kişiler:', all);
	if i > 0 then
  begin
		s := GetStr(all, '<div class="title">Kişiler:', '</ul>');
  end;
	i := Pos('<li', s);
	while i > 0 do begin
		temp := GetStr(s, '<li', '</li>');
		code := GetStr(temp, 'href="/', '-filmleri/');
		small_photo := GetStr(temp, 'src="', '"');
		if (small_photo <> '') then begin
			if Pos('https:', small_photo) = 0 then
				small_photo := SITE_URL + small_photo;
			if Pos('logo', small_photo) > 0 then
				small_photo := '';
		end;
		name := GetStr(temp, 'title="', '"');
		if name <> '' then
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(name)));
		dates := GetStr(temp, 'itemprop="birthDate"', '</');
		if dates <> '' then
			dates := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + dates)));
		desc := GetStr(temp, 'itemprop="homeLocation"', '</');
		if desc <> '' then
			desc := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + desc)));
		if (name <> '') and (code <> '') then begin
			Inc(persons_count);
			SetSearchResult2(name, code, dates, '', desc, small_photo);
		end;
		delete(s, 1, i);
		i := Pos('<li', s);
	end;
	result:=persons_count;
end;

function GetPersonURL(code: string; images_only: boolean): string;
begin
		result:= SITE_URL + format('/%s-filmleri/', [code])
end;


//returnes images links
procedure GetImages;
begin
	if photo_url<>'' then
		SetImageName('', photo_url, '', 6);
	GetPhotos;
end;

procedure GetPhotos;
var
	i, photo_cnt: integer;
	s, temp, img_url: String;
begin
	photo_cnt := 0;
	s := GetStr(all, 'Fotoğrafları</h2>', '</ul>');
	i := Pos('<li', s);
	while (i > 0) and (photo_cnt < MaxPhotosCount) do begin
		temp := GetStr(s, '<li', '</li>');
		img_url := GetStr(temp, 'src="', '"');
		if Pos('logo', img_url) > 0 then
			img_url := '';
		if Pos('https:', img_url) = 0 then
			img_url := SITE_URL + img_url;
		img_url := ReplaceStr(img_url, '_orta', '', -1);
		if (img_url <> '') then begin
			Inc(photo_cnt);
			SetImageName('', img_url, '', 6);
		end;
		delete(s, 1, i);
		i := Pos('<li', s);
	end;
end;


function SavePhoto(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearBrackets(name: string): string;
var
	i: integer;
begin
	// clear word in brackets at the end of name
	i := pos(' (', name);
	if i>0 then
		name := copy(name, 1, i-1);
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;


function GetInfo(url: string; images_only: boolean): string;
var
	b_day, b_month, b_year, s, s2, s3, s4, temp, code, movie: string;
	i, j, k, ke, mode: integer;
begin
	result:='';
	BasicURL:=url;
	person_code:=ParseString(url, SITE_URL + '/(.*?)-filmleri/', 1);
	person_site_url:=GetPersonSiteURL(person_code);
	
	all:=DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;
		
	// name
	name := GetStr(all, '<h1 itemprop="name', '</h1>');
	name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + name)));
	if name = '' then
		exit;

	// original name
	original_name:='';
	
	// photo
	s := GetStr(all, 'itemprop="image"', '>');
	photo_url := GetStr(s, 'src="', '"');
	if (Pos('logo', photo_url) > 0) then
		photo_url := '';
	if photo_url <> '' then begin
		if (Pos('https:', photo_url) = 0) then
			photo_url := SITE_URL + photo_url;
		photo_url := ReplaceStr(photo_url, '/kk_', '/br', -1);
	end;
	
	//date of birth
	s := GetStr(all, ' itemprop="birthDate"', '</');
	if s <> '' then
		s := ClearExtraBlankCharacters(RemoveTags('<' + s));
	b_day := ParseString(s, '^(\d+)', 1);
	b_month := ParseString(s, '\.(\d+)\.', 1);
	b_year := ParseString(s, '(\d+)$', 1);
	birth_date := '';
	if b_year <> '' then begin
		if (b_day <> '') and (b_month <> '') then
			birth_date := Format('%s/%s/%s', [b_month, b_day, b_year])
		else
			birth_date := b_year;
	end;
	
	// place
	birthplace := '';
	s := GetStr(all, 'itemprop="addressLocality"', #10);
	if s <> '' then
		birthplace := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s)));
	
	//date of death
	s := GetStr(all, 'itemprop="deathDate"', '</');
	if s <> '' then
		s := ClearExtraBlankCharacters(RemoveTags('<' + s));
	b_day := ParseString(s, '^(\d+)', 1);
	b_month := ParseString(s, '\.(\d+)\.', 1);
	b_year := ParseString(s, '(\d+)$', 1);
	death_date := '';
	if b_year <> '' then begin
		if (b_day <> '') and (b_month <> '') then
			death_date := Format('%s/%s/%s', [b_month, b_day, b_year])
		else
			death_date := b_year;
	end;
	
	// bio
	biography := GetStr(all, 'class="biyografi"', '</p>  ');
	biography := ReplaceStr(biography, '</div><div><br></div><div>', #13#10#13#10, -1);
	biography := ReplaceStr(biography, '</div><div>', #13#10, -1);
	biography := ReplaceStr(biography, '</p>', #13#10#13#10, -1);
	biography := ReplaceStr(biography, '<br>', #13#10, -1);
	if biography <> '' then
		biography := RemoveTags('<' + biography);
	biography := ClearExtraBlankCharacters(DecodeHTML(biography));
	
	// filmography
	s := GetStr(all, 'class="filmography"', '</ul>');
	i := Pos('<li', s);
	while i > 0 do begin
		temp := GetStr(s, '<li', '</li>');
		code := GetStr(temp, 'href="/', '-filmi/');
		movie := GetStr(temp, '<a ', '</a>');
		if movie <> '' then
			movie := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + movie)));
		b_year := ParseString(temp, ', (\d+)', 1);
		if (movie <> '') then begin
			delete(temp, 1, Pos('</a>', temp));
			if (Pos('Yönetmen', temp) > 0) then
				SetMovieName(movie, '', 1, code, b_year);
			if (Pos('Senarist', temp) > 0) then
				SetMovieName(movie, '', 2, code, b_year);
			if (Pos('Oyuncu', temp) > 0) then
				SetMovieName(movie, '', 3, code, b_year);
			if (Pos('Müzik', temp) > 0) then
				SetMovieName(movie, '', 4, code, b_year);
			if (Pos('Yapımcı', temp) > 0) then
				SetMovieName(movie, '', 5, code, b_year);
			if (Pos('Görüntü Yönetmeni', temp) > 0) or (Pos('Sinematografi', temp) > 0) then
				SetMovieName(movie, '', 6, code, b_year);
		end;
		delete(s, 1, i);
		i := Pos('<li', s);
	end;
	
end;

	
//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:= SITE_URL + '/' + code + '-filmi/';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:=SITE_URL + format('/%s-filmleri/', [code]);
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;


begin
monthes[1]:='January';
monthes[2]:='February';
monthes[3]:='March';
monthes[4]:='April';
monthes[5]:='May';
monthes[6]:='June';
monthes[7]:='July';
monthes[8]:='August';
monthes[9]:='September';
monthes[10]:='October';
monthes[11]:='November';
monthes[12]:='December';

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.
