﻿const
	script_name='kinopoisk';
	language='Russian';
	version=269;
	author='Alex';
	MinProgramBuild=10100;
	PCount = 14;
	EMPTY_PERSON_IMAGE_URL = 'https://st.kinopoisk.ru/images/no-poster.gif';

  USER_MOVIES_PER_PAGE = 200;
  USER_MOVIES_URL_TEMPLATE = 'https://www.kinopoisk.ru/user/%s/votes/list/ord/date/perpage/200/page/%d/#list';
	
	//default settings
	DL_TMDB_POSTERS = 1;
	DL_TMDB_BACKDROPS = 0;
	DL_TVDB_DESCRIPTIONS = 0;
	DL_TVDB_EPISODES = 1;
	DL_TVDB_ENG_DESC = 0;
	DL_TVDB_POSTERS = 1;
	DL_TVDB_FANART = 0;
	NO_SMALL_COVER = 1;
	NEVER_USE_AMAZON = 0;
	NO_AMAZON_COVER_IF_BIG_AVAILABLE = 1;
	ALWAYS_USE_AMAZON = 0;
	DL_BIG_KINOPOISK_COVER = 1;

const
  MANUAL_REF_GENRE = 1;
  MANUAL_REF_COUNTRY = 2;

var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast,
	DownloadMovieBigDescription, DownloadMovieComments,
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList: boolean;
	DownloadMovieLinks: Boolean;
	NoVideosInSeries: Boolean;
	MaxShotsCount, MaxPostersCount: integer;
	// Fade: flags for download seasons/episodes covers 
	DownloadSeasonsCovers: Boolean;
	DownloadEpisodesCovers: Boolean;
	// 10.11.2010
	MaxTrailersCount, MaxBackdropsCount: Integer;
	DownloadedPersonPhotosForMovie: Integer;
	title, MovieName, MovieYear, year, director, name, character, BasicURL, country, description, comments, salary, awards, media_type: string;
	movie_code, movie_site_url, title_code{?}, imdb_code: string;
	titles_count: integer;
	director_code, code: string;
	directors_count, writers_count, actors_count, genres_count: integer;
	duration: integer;
	Tagline: string;  
	imdb_rating, rating: double;
	front_cover_url: string;
	posters_exists: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	is_frames_present, is_posters_present, flEpisodes, last_time: boolean;
	f: TForm;
	b: TButton;
	edUserName, edPassword, edURL: TEdit;
	labCaption, labCaption2, labUserName, labPassword: TLabel;
	monthes: array [1..12] of string;

	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	duration_min: integer;
	subtitles, AudioTracks: array of string;
	SubtitlesCount, AudioTracksCount: integer;
	flUseTMDB: boolean;
	tmdb_code, tvdb_code: string;
	UseTMDBPosters, UseTMDBSnapshots, DownloadTVDBEpisodeDescriptions, DownloadTVDBEpisodes, DownloadTVDBEnglishDesc, DownloadSeasonPosters, DownloadEpisodeImages, UseTVDBPosters, UseTVDBFanart: integer;
	flEpisodesTitle, FoundBigKinopoiskPoster: boolean;
	EpisodesDownloading, PostersDownloading, BackdropsDownloading, ShotsDownloading, DlUnknown, TVDBNothingFound, TVDBSearchEnded: Boolean;
	TickCount: Cardinal;

	GlobalMyPos: string;
	RequestParameters, EpisodeURLs, SeasonURLs: TStringList;
	LatinTitle, ExTitle, ExYear, ExBarcode, ExSiteCode, ExOrigTitle, BasicAgent: String;
	AgentIndex: Integer;
	
function ParseTitleFormat(title, format: String): String;
const
	TITLE_VAR = '%T';
	YEAR_VAR = '%Y';
	BARCODE_VAR = '%B';
	SITE_CODE_VAR = '%C';
	ORIG_TITLE_VAR = '%O';
var
	i, j, k: Integer;
	s, extracted, temp: String;
begin
	exTitle := title;
	result := title;
	if Pos(TITLE_VAR, format) > 0 then begin
		i := Pos('%', format);
		while (i > 0) and (title <> '') do begin
			extracted := '';
			//copy the complete format to temp
			temp := format;
			//extract any characters before %
			if i > 1 then begin
				s := copy(format, 1, i-1);
				delete(format, 1, i-1);
				//update temp
				temp := format;
				k := Pos(s, title);
				if k > 0 then
					delete(title, 1, k+length(s)-1);
			end;
			// delete %
			delete(format, 1, 1);
			s := '';
			j := Pos('%', format);
			if j > 0 then
				s := copy(format, 2, j-2)
			else if length(format) > 1 then
				s := copy(format, 2, length(format)-1);
			if s <> '' then begin
				k := Pos(s, title);
				if k > 0 then begin
					extracted := copy(title, 1, k - 1);
					delete(title, 1, k + length(s) - 1);
				end;
			end;
			if extracted = '' then begin
				extracted := title;
				title := '';
			end;
			if Pos(TITLE_VAR, temp) = 1 then
				result := extracted
			else if Pos(YEAR_VAR, temp) = 1 then
				ExYear := extracted
			else if Pos(BARCODE_VAR, temp) = 1 then
				ExBarcode := extracted
			else if Pos(SITE_CODE_VAR, temp) = 1 then
				ExSiteCode := extracted;
			//delete the variable
			delete(format, 1, 1+length(s));
			i := Pos('%', format);
		end;
	end;
	exTitle := result;
end;

function MyPosGlobal(const SubStr: string; Offset: Cardinal = 1): Integer;
var
  I,X: Integer;
  Len, LenSubStr: Integer;
begin
  if Offset = 1 then
    Result := Pos(SubStr, GlobalMyPos)
  else
  begin
    I := Offset;
    LenSubStr := Length(SubStr);
    Len := Length(GlobalMyPos) - LenSubStr + 1;
    while I <= Len do
    begin
      if GlobalMyPos[I] = SubStr[1] then
      begin
        X := 1;
        while (X < LenSubStr) and (GlobalMyPos[I + X] = SubStr[X + 1]) do
          Inc(X);
        if (X = LenSubStr) then
        begin
          Result := I;
          exit;
        end;
      end;
      Inc(I);
    end;
    Result := 0;
  end;
end;


function RemoveAllBadChars(text: String): String;
var
	i: Integer;
begin
	i := 0;
	while i<=Length(text) do begin
		if ord(text[i]) in [1..20] then
			delete(text, i, 1)
		else
			i := i + 1;
	end;
	result := text;
end;

function MovieSearch: integer;
var
	i, j, ii, jj, k, l: integer;
	title, code, year, description, small_cover, original_title, s, s2: string;
begin
  TickCount := 0;//GetTickCount();
	titles_count:=0;
	//один результат, загружается страница фильма
	if not(pos('<title>Результаты поиска', all)>0) then begin
		code:=ParseString(all, 'id_film = (\d+); </script>', 1);
		title := 'title';
		if code = '' then begin
			s := GetStr(all, 'property="og:url" content="', '"');
			code := ParseString(s, '(\d+)/$', 1);
			title := GetStr(all, 'property="title" content="', '"');
		end;
		if code <> '' then begin
			SetSearchResult(title, code);
			titles_count:=1;
		end;
	end
	else begin

		i:=pos('К сожалению, по вашему запросу ничего не найдено', all);
		if (all='') or (i>0) then
			//Фильм не найден!
		else 
		begin
			i:=pos('<title>Результаты поиска',all);
			if i>0 then
			begin
				s:='';
				i:=pos('<p class="pic"><a href="', all);
				while (i>0) do begin
					j := MyPos('</div>', all, i+1);
					s := copy(all, i, j-i);
					code:=ParseString(s, '<p class="pic"><a href="/level/1/film/(\d+)/', 1);
					if code = '' then
						code:=ParseString(s, '<p class="pic"><a href="/film/.*?(\d+)/', 1);
					title:=ParseString(s, '<p class="name">(.*?)</a> <span', 1);
					if title = '' then
						title := ParseString(s, '<p class="name">(.*?)</a>', 1);
					title:=RemoveTags(title);
					title:=DecodeHTML(title);
					title:=ClearExtraSpaces(title);

					year := ParseString(s, '<span class="year">(\d+)</span></p>', 1);
					
					original_title := '';
					k := Pos('<span class="gray">', s);
					if k>0 then begin
						l := MyPos('</span>', s, k+1);
						s2 := copy(s, k, l-k);
						original_title := ParseString(s2, '"gray">(.*?), \d+ мин', 1);
						original_title := DecodeHTML(original_title);
					end;
					
					
					small_cover := ParseString(s, 'title="/images/(.*?)" alt="', 1);
					if (small_cover <> '') and (Pos('no-poster', small_cover)=0) then
						small_cover := 'http://st.kp.yandex.net/images/' + small_cover;
					description := '';
					if l>0 then begin
						delete(s, 1, l-1);
						description := RemoveTags(s);
						description := DecodeHTML(description);
						description:=ReplaceStr(description, #10, ' ', -1);
						description := ClearExtraSpaces(description);
						description := RemoveAllBadChars(description);
					end;

					titles_count:=titles_count+1;
					SetSearchResult2(title, code, year, original_title, description, small_cover);
					delete(all, 1, j);
					if MovieYear = '' then
						i:=pos('<p class="pic"><a href="', all)
					else
						i:=0;
				end;
			end
			else
			begin
				i:=pos('<title>',all);
				j:=pos('</title>',all);
				if (i>0)and(j>0) then
				begin
					i:=i+7;
					title := copy(all,i,j-i);
					title := DecodeHTML(title);
					title := RemoveTags(title);
					title := ClearExtraSpaces(title);
					i := Pos('/level/111/film/',all);
					if i>0 then
					begin
						i := i + 16;
						j := MyPos('/',all,i+1);
						code := copy(all,i,j-i);
					end;
					
					titles_count := titles_count + 1;
					SetSearchResult(title, code);
				end;
			end;
			{}
		end;
	end;
	result:=titles_count;
end;


function GetPersonURL(code: string; images_only: boolean): string;
begin
	if images_only then
		result:=format('https://www.kinopoisk.ru/level/1/film/%s/', [code])
	else
		result:=format('https://www.kinopoisk.ru/level/1/film/%s/', [code])
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url, s: string;
begin
	exSiteCode := '';
	exYear := '';
	exTitle := '';
	if RegReadInteger('KinopoiskParseTitles', 0) = 1 then begin
		s := RegReadString('KinopoiskParseFormat', '%T');
		MovieName := ClearExtraBlankCharacters(ParseTitleFormat(MovieName, s));
		exYear := ParseString(exYear, '(\d+)', 1);
		if (exYear <> '') and (AYear = '') then
			AYear := exYear;
	end;
	MovieYear := AYear;
	MovieName := ClearExtraBlankCharacters(MovieName);
	MovieName := ReplaceStr(MovieName, '+', '%2B', -1);
	MovieName := ReplaceStr(MovieName, '#', '%23', -1);
	//MovieName:=ReplaceStr(MovieName, ' ', '+', -1);	
	MovieName := EncodeURL(MovieName, 'WINDOWS-1251');
	url:=format('https://www.kinopoisk.ru/index.php?level=7&from=forma&result=adv&m_act%%5Bfrom%%5D=forma&m_act%%5Bwhat%%5D=content&m_act%%5Bfind%%5D=%s&m_act%%5Bcountry%%5D=&m_act%%5Byear%%5D=%s&m_act%%5Bgenre%%5D=&m_act%%5Bcontent_find%%5D=&m_act%%5Bfilm%%5D=&m_act%%5Bsex%%5D=', [MovieName, AYear]);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
var
	s: String;
begin
	//all:=DownloadURL(url);
	//all:=DownloadURLWithReferer(url, 'http://s.kinopoisk.ru');
	exSiteCode := ClearExtraBlankCharacters(exSiteCode);
	if exSiteCode <> '' then begin
		if exTitle <> '' then
			s := exTitle
		else
			s := exSiteCode;
		SetSearchResult(s, exSiteCode);
		result := 1;
	end
	else begin
		TickCount := 0;//GetTickCount();
		RenewParameters;
		//all := DownloadURLWithReferer(url, 'https://s.kinopoisk.ru/index.php', True,
			//RequestParameters, 'windows-1251');

    all := DownloadURL(url, True, RequestParameters);
		// AddRequestForHTMLPageContent(url, True, 'http://s.kinopoisk.ru/index.php', '', RequestParameters);
		// all:=GetHTMLPageContentFromRequest(url); //DownloadURLWithReferer(url, 'http://s.kinopoisk.ru/index.php', True, RequestParameters);
		//SaveLog(all);
		if pos('Если вы видите эту страницу', all)>0 then begin
			RenewParameters;
			all:=DownloadURL(url, True, RequestParameters);
		end;

		//если требуется авторизация
		if GetResponseCode=403 then begin
			SiteLogin;
			RenewParameters;
			all:=DownloadURL(url, True, RequestParameters);
		end;

		if all='-1' then
			result:=-1
		else
			result:=MovieSearch;
	end;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
	result := format('https://www.kinopoisk.ru/film/%s/', [code]);
end;

function ClearBrackets(name: string): string;
var
	i: integer;
begin
	// clear word in brackets at the end of name
	i := pos(' (', name);
	if i>0 then
		name := copy(name, 1, i-1);
	i := pos(' [', name);
	if i>0 then
		name := copy(name, 1, i-1);
	Result := name;
end;

function GetTextBetween(fromStr, str1, str2: string): string;
var
	i, j: integer;
begin
	Result := '';
	if str1 = '' then
		i := 1
	else
		i := pos(str1, fromStr);
	if str2 = '' then
		j := Length(fromStr) + 1
	else
		j := MyPos(str2, fromStr, i+length(str1));
	if (i>0)and(j>0) then begin
		i := i + length(str1);
		Result := copy(fromStr, i, j-i);
	end;
end;


function GetFrontCoverURL2: string;
var
	res, all, url, s, s2, s3, amazon_url: string;
	i, j, frames_count, k: integer;
	item_url: string;
	image_data, image_height, image_width, image_url: string;
	frame_urls: array [1..100] of string;
	int_year: Word;
	year_prew, year_next, title: string;
	valid_year: boolean;
begin
	title:=original_title;
	res:=front_cover_url;
	amazon_url:='';


	if DownloadMovieBigCover then begin
  	s:=title;
  	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [title]);
  	url:=ReplaceStr(url, ' ', '+', -1);
  	//all:=DownloadURL(url);
    all := GetHTMLPageContentFromRequest(url);
    TickCount := 0;//GetTickCount();
  	//search image by title
  	frames_count := 0;
  	i:=pos('<Item>', all);
  	if year<>'' then begin
  		while (i>0) and (amazon_url='') do 
  		begin
  			j := MyPos('</Item>', all, i+1);
  			if j>0 then 
  			begin
  				s2 := copy(all, i, j-i);
  				s3 := GetTextBetween(s2, '<Title>', '</Title>');
  				s3 := ClearBrackets(s3);
  				s3 := DecodeHTML(s3);
  				if s3<>'' then 
  				begin
  					if (UpperCase(title) = UpperCase(s3)) or (flEpisodes) then
  					begin
  						valid_year := true;
  						if (pos('ReleaseDate>', s2) > 0) and (not flEpisodes) then
  						begin
  							int_year := StrToInt(year);
  							year_prew := IntToStr(int_year - 1);
  							year_next := IntToStr(int_year + 1);
  							valid_year := false;
  							valid_year := pos('ReleaseDate>'+year, s2) > 0;
  							valid_year := valid_year or (pos('ReleaseDate>'+year_prew, s2) > 0);
  							valid_year := valid_year or (pos('ReleaseDate>'+year_next, s2) > 0);						
  							year_prew := IntToStr(int_year - 2);
  							year_next := IntToStr(int_year + 2);
  							valid_year := valid_year or (pos('ReleaseDate>'+year_prew, s2) > 0);
  							valid_year := valid_year or (pos('ReleaseDate>'+year_next, s2) > 0);						
  						end;
  						if valid_year then
  						begin
  							s := '';
  							frames_count := 0;
  							repeat
  								image_data := GetTextBetween(s2, '<LargeImage>', '</LargeImage>');
  								image_url := GetTextBetween(image_data, '<URL>', '</URL>');
  								image_height := GetTextBetween(image_data, '<Height','</Height>');
  								image_height := GetTextBetween(image_height, '>','');
  								image_width := GetTextBetween(image_data, '<Width','</Width>');
  								image_width := GetTextBetween(image_width, '>','');
  								try
  									if (image_height <> '0') and ((StrToInt(image_width) / StrToInt(image_height)) > 1.2) then 
  									begin
  										for k := 1 to frames_count do
  											if frame_urls[k] = image_url then break;
  										if (frames_count = 0) or (frame_urls[k] <> image_url) then begin
  											frames_count := frames_count + 1;
  											frame_urls[frames_count] := image_url;
  										end;
  									end
  									else if amazon_url = '' then
  										amazon_url := image_url;
  								except
  									//Wrong XML format!
  								end;
  								delete(s2, 1, 25 + length(image_data));
  							until (image_data = '') or (frames_count = MaxShotsCount);
  						end;
  					end; //if
  				end; //if
  			end; //if
  			delete(all, 1, j);
  			i := Pos('<Item>', all);
  		end; //while
  	end; //if year<>''
	end;
	if amazon_url<>'' then   // front-cover from amazon
		SetImageName('', amazon_url, '', 1);
	Result:=amazon_url;
end;

//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
	fs: TFileStream;
	s, referer: string;
	i: integer;
begin
	i := length(url);
	repeat dec(i) until (i=0)or(url[i] = '/');
	if i=0 then 
		exit;
	referer := copy(url, 1, i);

	//referer:='post';

	s := DownloadURLWithReferer(url, referer, False, RequestParameters);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;


function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;

function RemoveCharacter(text: string; char_code: integer): string;
var
	i: integer;
begin
	i:=length(text);
	while i>0 do begin
		if (ord(text[i])=char_code) then
			delete(text, i, 1);
		i:=i-1;
	end;
	Result:=text;
end;

function ReplaceTagWithChar(text, html_tag: string; char_code: integer): string;
var
	i, j: integer;
begin
	j:=0;
	i:=Pos(html_tag, text);
	while i>j do begin
		text[i]:= Chr(char_code);
		text[i+1]:='<';
		j:=i;
		i:=MyPos(html_tag, text, i+1);
	end;
	Result:=text;
end;

function GetPersonImageURL(ACode: string): string;
begin
	if RegReadInteger('KinopoiskDlBiggerPhoto', 1) = 1 then
		Result := Format('https://www.kinopoisk.ru/images/actor_iphone/iphone360_%s.jpg', [ACode])
	else
		Result := Format('https://www.kinopoisk.ru/images/actor/%s.jpg', [ACode]);
end;

procedure ExtractPeopleFull(text: string; mode: integer);
var
	i, j, k, pic_cnt, added_persons_cnt: Integer;
	s2, name, code, character, picture_url: string;
begin
	pic_cnt := 0;
	added_persons_cnt := 0;
	i := Pos('<div class="actorInfo"', text);
	while (i>0) and (added_persons_cnt < MaxPersonsCount) do begin
		j:=MyPos('<div class="clear"></div>', text, i+1);
		s2:=copy(text, i, j-i);
		code := ParseString(s2, '<a href="/level/4/people/(\d+)/', 1);
		if code = '' then
			code := ParseString(s2, '<a href="/name/(\d+)/', 1);
		name := GetStr(s2, '<div class="name">', '</a>');
		name := DecodeHTML(RemoveTags(name));
		if (mode <> 3) and (pic_cnt > 0) or (Pos('/images/no-poster.gif', s2) > 0) then
			picture_url := ''
		else begin
			picture_url := GetPersonImageURL(code);
			pic_cnt := pic_cnt + 1;
		end;
		character := '';
		if mode = 3 then begin
			character := GetStr(s2, '>... ', '<');
			character := RemoveTags(character);
			character := DecodeHTML(character);
			character := ClearExtraSpaces(character);
			k := Pos(' (', character);
			if k>0 then
				delete(character, k, length(character)-k+1);
			if character<>'' then
				if character[length(character)] = ',' then
					delete(character,length(character),1);
		end;
		if name<>'' then begin
			SetPersonName(name, character, mode, code, picture_url);
			Inc(added_persons_cnt);
		end;
		delete(text, 1, i);
		i := Pos('<div class="actorInfo"', text);
	end;
end;

procedure ExtractPeople(text: string; mode: integer);
var
	i, j, pic_cnt, added_persons_cnt: Integer;
	s2, name, code, picture_url: string;
begin
	pic_cnt := 0;
	added_persons_cnt := 0;
	i := Pos('<a href="/level/4/people/', text);
	if i = 0 then
		i := Pos('<a href="/name/', text);
	while (i>0) and (added_persons_cnt < MaxPersonsCount) do begin
		j:=MyPos('</a>', text, i+1);
		s2:=copy(text, i, j-i);
		code := ParseString(s2, '<a href="/level/4/people/(\d+)/', 1);
		if code = '' then
			code := ParseString(s2, '<a href="/name/(\d+)/', 1);
		name := DecodeHTML(RemoveTags(s2));
		if (mode <> 3) and (pic_cnt > 0) then
			picture_url := ''
		else begin
			picture_url := GetPersonImageURL(code);
			pic_cnt := pic_cnt + 1;
		end;
		if name<>'' then begin
			SetPersonName(name, '', mode, code, picture_url);
			Inc(added_persons_cnt);
		end;
		delete(text, 1, j);
		i := Pos('<a href="/level/4/people/', text);
		if i = 0 then
			i := Pos('<a href="/name/', text);
	end;
end;

procedure ShowTickCount(ADesc: string);
begin
  TickCount := 0;//GetTickCount();
end;

function GetRating(movie_code: String): Double;
var
	i: Integer;
	s, url, temp: String;
begin
	rating := 0;
	imdb_rating := 0;
	url := 'https://rating.kinopoisk.ru/'+movie_code+'.xml';
	RenewParameters;
	//AddRequestForHTMLPageContent(url, True, GetMovieSiteURL(movie_code), '', RequestParameters, 'windows-1251');
	//temp := GetHTMLPageContentFromRequest(url);
	temp := DownloadURL(url, True, RequestParameters);
	s := GetStr(temp, '<kp_rating', '</kp_rating>');
	if s <> '' then begin
		s := RemoveTags('<' + s);
		i:=pos('.', s);
		if i>0 then
			s[i]:=DecimalSeparator;
		try
			rating := StrToFloat(s);
		except
		end;
	end;
	s := GetStr(temp, '<imdb_rating', '</imdb_rating>');
	if s <> '' then begin
		s := RemoveTags('<' + s);
		i:=pos('.', s);
		if i>0 then
			s[i]:=DecimalSeparator;
		try
			imdb_rating := StrToFloat(s);
		except
		end;
	end;
	result := rating;
end;


function ParsePersonImageURLFromPersonInfo(APersonInfo: string): string;
const
  NOCOVER_TEMPLATE = 'no-poster';
  TITLE_TEMPLATE_SEARCH = 'title="';
  IMAGE_TEMPLATE_SEARCH = TITLE_TEMPLATE_SEARCH + '/images/';
var
  PosStart: integer;
  PosEnd: integer;
begin
  Result := '';
  PosStart := Pos(IMAGE_TEMPLATE_SEARCH, APersonInfo);
  PosEnd := MyPos('"', APersonInfo, PosStart + Length(IMAGE_TEMPLATE_SEARCH));
  if ((PosStart > 0) and
      (PosEnd > 0)) then
  begin
    PosStart := PosStart + Length(TITLE_TEMPLATE_SEARCH);
    Result := Copy(APersonInfo, PosStart, PosEnd - PosStart);
    if (Pos('no-poster', Result) > 0) then
      Result := '';
  end;
  // recieve real URL to image
  if (Result <> '') then
    Result := Format('https://www.kinopoisk.ru%s', [Result]);
end;

function ExtractAwards(text: String): String;
var
	i, j: Integer;
	s, temp, name, status, subj: String;
begin
	name := GetStr(text, '<b><a href="/awards/', '</b>');
	name := GetStr(name, '>', '<');
	name := DecodeHTML(name);
	Result := name;
	i := Pos('<tr><td class="news" style="padding: 10px; color:', text);
	while i>0 do begin
		s := GetStr(text, '<tr><td class="news" style="padding: 10px; color:', '</tr>');
		delete(text, 1, i);
		i := Pos('<tr><td class="news" style="padding: 10px; color:', text);
		status := RemoveTags(DecodeHTML(GetStr(s, '<b>', '</td>')));
		Result := Result + '<br>' + status;
		j := Pos('<li class="trivia">', text);
		subj := '';
		while (j > 0) and ((j < i) or (i = 0)) do begin
			temp := GetStr(text, '<li class="trivia">', '</li>');
			temp := ClearExtraBlankCharacters(DecodeHTML(RemoveSpacesInText(RemoveTags(temp))));
			temp := ReplaceStr(temp, #10, '', -1);
			if (temp <> '') and (subj <> '') then
				subj := subj + '<br>';
			subj := subj + temp;
			delete(text, 1, j);
			j := Pos('<li class="trivia">', text);
			i := Pos('<tr><td class="news" style="padding: 10px; color:', text);
		end;
		if subj <> '' then
			Result := Result + '<br>' + subj;
	end;
end;

procedure RenewParameters;
begin
	AgentIndex := Round(Random * 100000);
	// RequestParameters.Values['useragent'] := BasicAgent; // + IntToStr(AgentIndex);
end;

procedure UpdateScriptsUserAgent();
var
  UserAgent: string;
begin
  UserAgent := GetScriptUserAgent();
  if (UserAgent <> '') then
  begin
    BasicAgent := UserAgent;
    RequestParameters.Values['User-Agent'] := BasicAgent;
  end;
end;

function IsCapchaPage(AContent: string): Boolean;
begin
  Result := (Pos('action="/checkcaptcha"', AContent) > 0);
end;

function ParseTextInTags(AText: string; AOpenTag: string;
  ACloseTag: string; APos: Integer = -1): string;
var
  TagEndPosition: Integer;
  TagStartPosition: Integer;
begin
  Result := '';
  TagStartPosition := MyPos(AOpenTag, AText, APos);
  if (TagStartPosition > 0) then
  begin
    TagEndPosition := MyPos(ACloseTag, AText, TagStartPosition + 1);
    if (TagEndPosition > 0) then
    begin
      Result := Copy(AText, TagStartPosition, TagEndPosition + Length(ACloseTag) - TagStartPosition);
      Result := RemoveTags(Result);
    end;
  end;
end;

function ParseInfoContent(AText: string; AContentCaption: string; APos: Integer = -1): string;
var
  SearchStr: string;
  ContentPos: Integer;
begin
  Result := '';
  SearchStr := '<div class="film-info-table__title">' + AContentCaption + '</div>';
  ContentPos := MyPos(SearchStr, AText, APos);
  if (ContentPos > 0) then
  begin
    ContentPos := ContentPos + Length(SearchStr);
    Result := ParseTagTakingIntoAccountNestingLevel(AText, '<div', '<div', '</div>', ContentPos);
    if (Result <> '') then
      Result := '<div' + Result;
  end;
end;

function ParseInfoContentManuals(AText: string; AContentCaption: string;
  AManualRef: Integer; APos: Integer = -1): string;
var
  ManualContent: string;
begin
  Result := ParseInfoContent(AText, AContentCaption, APos);
  if (Result <> '') then
  begin
    Result := ParseTag(Result, '<div class="table-col-basic-link-list', '</div>');
    repeat
      ManualContent := ParseTagWithCutting(Result, '<a', '</a>');
      if (ManualContent <> '') then
      begin
        ManualContent := RemoveTags('<a' + ManualContent);
        if (ManualContent <> '...') then
        begin
          case AManualRef of
            MANUAL_REF_GENRE: SetGenre(ManualContent);
            MANUAL_REF_COUNTRY: SetCountry(ManualContent);
          end;
        end;
      end;
    until (ManualContent = '');
  end;
end;

function ParseInfoContentText(AText: string; AContentCaption: string; APos: Integer = -1): string;
begin
  Result := ParseInfoContent(AText, AContentCaption, APos);
  Result := RemoveTags(Result);
end;

function GetInfo(url: string; images_only: boolean): string;
var
	s, s2, s3, keyword, money: string;
	i, j, kol, season, episode, k, k2, pic_cnt: integer;
	AirDate, EpisodeTitle, EpisodeIMDB, EpisodeDescription, day, month, ayear, picture_url, temp: string;
	awards_exist, backdrops_exist: boolean;
  TrailerURL: string;
  RefererURL: string;
  ImageURL, TempURL, TriviaURL: string;
  ActorsURL, studios_url, awards_url, video_url, links_url: string;
  sl: TStringList;
const
	MyQuotes = ['»', '«', '"'];
begin

	if (RegReadInteger('KinopoiskDlUnknown', 1) = 1) then
		DlUnknown := True
	else
		DlUnknown := False;
	TickCount := 0;//GetTickCount();
	LatinTitle := '';
	result:='';
	
	RefererURL := 'https://www.kinopoisk.ru/';
	
		//all:=DownloadURLWithReferer(url, 'http://s.kinopoisk.ru');
	RenewParameters;
	//all:=DownloadURLWithReferer(url, 'https://s.kinopoisk.ru/index.php', True, RequestParameters);
	//DownloadURLWithReferer(url, True, 'http://s.kinopoisk.ru/index.php', '', RequestParameters, 'windows-1251');
	{AddRequestForHTMLPageContent(url, True, RefererURL, '', RequestParameters);
	all:=GetHTMLPageContentFromRequest(url);}
  all := DownloadURLUsingScripts(url);
  if (IsCapchaPage(all)) then
    all := ShowCapchaPageToUser(url);
  UpdateScriptsUserAgent();
	//SaveLog(all);

	if (pos('Если вы видите эту страницу', all)>0) then
  begin
		RenewParameters;
		all:=DownloadURL(url+'sr/1/', True, RequestParameters);
	end;

	//если требуется авторизация
	if GetResponseCode=403 then begin
		SiteLogin;
		RenewParameters;
		all:=DownloadURL(url, True, RequestParameters);
	end;
	if (all='-1') or (pos('Если вы&nbsp;видите эту страницу', all) > 0) then
  begin
		result:='-1';
		exit;
	end
	else
		result:=all;
	imdb_code := '';
	
	//movie title
	//title:=ParseString(all, '<title>(.*)</title>', 1);
	title := GetStr(all, '<h1', '</h1>');
	{if title <> '' then
		title := GetStr(title, '>', '<');}
  if (title <> '') then
  	title:=RemoveTags('<' + title);
	title:=DecodeHTML(title);
	title:=ClearExtraSpaces(title);
	title:=Trim(ClearExtraQuotes(title));

	if (pos('КиноПоиск.Ru', title)>0) or (pos('Все фильмы планеты', title)>0) then
  begin
		title:='';
		exit;
	end;

  // сериалы
  if (Pos('(сериал', Title) > 0) then
    Title := Trim(Copy(Title, 1, Pos('(сериал', Title) - 1));
	
	
	TVDBNothingFound := False;
	if DownloadTVDBEpisodes = 1 then
		TVDBSearchEnded := False
	else
		TVDBSearchEnded := True;

  SeasonURLs := TStringList.Create;
	EpisodeURLs := TStringList.Create;
	UseTMDBSnapshots:=RegReadInteger('KinopoiskUseTmdbBackdrops', DL_TMDB_BACKDROPS);
	UseTVDBFanart:=RegReadInteger('KinopoiskTVDBFanart', DL_TVDB_FANART);

	flEpisodesTitle:=false;
	EpisodesDownloading := False;
	movie_code := ParseString(url, '/film/(\d+)/', 1);
	movie_site_url:=GetMovieSiteURL(movie_code);
	// Fade - add requests for multi-thread downloading
	RefererURL := 'https://www.kinopoisk.ru/film/' + movie_code + '/';

	TriviaURL := 'https://www.kinopoisk.ru/handler_info.php?obj_type=film&obj_id=' + movie_code;

  if (DownloadMovieFullCast) then
  begin
    ActorsURL := 'https://www.kinopoisk.ru/film/'+movie_code+'/cast/?start_list=30000';
	  RenewParameters;
    AddRequestForHTMLPageContent(ActorsURL, True, RefererURL, '', RequestParameters, 'UTF-8');
  end;

	if DownloadMovieStudios then begin
		RenewParameters;
		studios_url := 'https://www.kinopoisk.ru/film/'+movie_code+'/studio/';
		AddRequestForHTMLPageContent(studios_url, True, RefererURL, '', RequestParameters);
	end;
	if DownloadMovieAwards then begin
		RenewParameters;
		awards_url := 'https://www.kinopoisk.ru/film/'+movie_code+'/awards/';
		AddRequestForHTMLPageContent(awards_url, True, RefererURL, '', RequestParameters);
	end;
	if (MaxTrailersCount > 0) then begin
		RenewParameters;
		video_url := 'https://www.kinopoisk.ru/film/'+movie_code+'/video/';
		AddRequestForHTMLPageContent(video_url, True, RefererURL, '', RequestParameters);
	end;

	//SiteLogin;
	//all:=DownloadURL(url);

  // movies links
	links_url := '';
	if (DownloadMovieLinks) and (Pos(movie_code + '/other', all) > 0) then begin
		RenewParameters;
		links_url := 'https://www.kinopoisk.ru/film/'+movie_code+'/other/';
		AddRequestForHTMLPageContent(links_url, True, RefererURL, '', RequestParameters);
	end;
 
	//if (DownloadMovieAdditionalInfo) and (pos('Знаете ли вы, что...</td>', all)>0) then
		//AddRequestForHTMLPageContent(TriviaURL, True, RefererURL, '', RequestParameters);

	is_frames_present := false;
	if (pos('level/13/film/' + movie_code, all) > 0) or (Pos(movie_code + '/stills/', all) > 0) then
		is_frames_present := true;

	//16.05.10
	is_posters_present := false;
	if (pos('level/17/film/' + movie_code, all) > 0) or (Pos(movie_code + '/posters/', all) > 0) then
		is_posters_present := true;
		
	//backdrops kinopoisk
	backdrops_exist := false;
	if (pos('level/12/film/' + movie_code, all) > 0) or (pos(movie_code + '/wall/', all) > 0) then
		backdrops_exist := True;
	if not backdrops_exist then begin
		//UseTMDBSnapshots := 1;
		//UseTVDBFanart := 1;
	end;

	//movie year
	if RegReadInteger('KinopoiskDlYear', 1) = 1 then
  begin
		i := Pos('>год</b>',all);
		if i=0 then
			i := Pos('>год</td>',all);
		if i>0 then
		begin
			i := i + 4;
			k := MyPos('</a>', all, i+1);
			j := MyPos('</li>',all,i+1);
			if (k>0) and (k<j) then
				j:=k;
			s := copy(all,i,j-i);
			i:=pos('&nbsp;', s);
			if i>0 then
				s:=copy(s, 1, i-1);
			year := RemoveTags(s);
			year:=ClearExtraSpaces(year);
			year:=ClearExtraBlankCharacters(year);
			year := ParseString(year, '(\d+)', 1);
		end;
    if (year = '') then
      year := ParseTextInTags(all, '<a class="table-col-years__years"', '</a>');
	end;
	
	//Определяем, есть ли страница наград
	if (pos('href="/level/94/film/', all)>0) or (Pos(movie_code + '/awards/', all) > 0) then
		awards_exist := true;
	

	original_title := '';
	if (RegReadInteger('KinopoiskDlOriginalTitle', 1) = 1) then begin
		i:=pos('<span style="color: #666; font-size: 13px"', all);
		if i>0 then begin
			j:=MyPos('</span>', all, i+1);
			if j>0 then begin
				original_title:=copy(all, i+43, j-i-43);
				original_title := '<' + original_title;
				original_title:=RemoveTags(original_title);
				original_title:=DecodeHTML(original_title);
				original_title:=ClearExtraSpaces(original_title);
				if original_title <> '' then
					if original_title[length(original_title)]='.' then
						delete(original_title,length(original_title),1);
			end;
		end;
		if original_title = '' then
			original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(all, 'itemprop="alternativeHeadline">', '</'))));
    if (original_title = '') then
    begin
      s := ParseTag(all, '<meta property="title" content="', '"');
      s := ParseTag(s, '(', ')');
      if (Pos(', ' + year, s) > 0) then
        Delete(s, Pos(', ' + year, s), Length(s));
      original_title := s;
    end;
	end;

  // 08.01.2013. Add condition to avoid AV from FastScript
	if (Length(title) > 0) and (title[1]='"') and (title[length(title)]='"') then
		title := copy(title,2,length(title)-2);
	if title='' then
  begin
    // ShowMessage('3');
		exit;
  end;

	s := GetStr(all, '<h1 ', '</h1>');
	// тип фильма
	media_type := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(s, '<span>', '</span>'))));
  if (media_type = title) then
    media_type := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(s, '</span>', '</span>'))));

  if (media_type = '') then
  begin
    media_type := GetStr(all, 'function getObjTitle(upFirst)', '}');
    if (media_type <> '') then
      media_type := GetStr(media_type, 'return ''', '''');
  end;
	if media_type <> ''
  then begin
		s2 := GetStr(media_type, '(', ')');
		if s2 = '' then begin
			if Pos('(', media_type) = 1 then
				delete(media_type, 1, 1);
		end
		else
			media_type := s2;
	end;
  if (Pos('мини-сериал', media_type) > 0) then
     media_type := 'Мини-Сериал'
  else if (Pos('сериал', media_type) > 0) then
    media_type := 'Сериал';


	if (pos('(сериал', s)>0) or (pos('(мини-сериал', all)>0) then
		flEpisodesTitle:=true;

	if (pos('/level/44/film/', all)>0) or (Pos(movie_code + '/episodes/', all) > 0) then
		flEpisodes:=true
	else
		flEpisodes:=false;
		
	(*if (flEpisodes or flEpisodesTitle) and DownloadMovieFullCast then begin
		if (RegReadInteger('KinopoiskDlDirectors', 1) = 1) then begin
			RenewParameters;
			AddRequestForHTMLPageContent('https://www.kinopoisk.ru/level/19/film/'+movie_code+'/who_is/director/', True, ActorsURL, '', RequestParameters);
		end;
		if (RegReadInteger('KinopoiskDlComposers', 1) = 1) then begin
			RenewParameters;
			AddRequestForHTMLPageContent('https://www.kinopoisk.ru/level/19/film/'+movie_code+'/who_is/composer/', True, ActorsURL, '', RequestParameters);
		end;
		if (RegReadInteger('KinopoiskDlWriters', 1) = 1) then begin
			RenewParameters;
			AddRequestForHTMLPageContent('https://www.kinopoisk.ru/level/19/film/'+movie_code+'/who_is/writer/', True, ActorsURL, '', RequestParameters);
		end;
		if (RegReadInteger('KinopoiskDlProducers', 1) = 1) then begin
			RenewParameters;
			AddRequestForHTMLPageContent('https://www.kinopoisk.ru/level/19/film/'+movie_code+'/who_is/producer/', True, ActorsURL, '', RequestParameters);
		end;
		if (RegReadInteger('KinopoiskDlCameraman', 1) = 1) then begin
			RenewParameters;
			AddRequestForHTMLPageContent('https://www.kinopoisk.ru/level/19/film/'+movie_code+'/who_is/operator/', True, ActorsURL, '', RequestParameters);
		end;
	end;*)
		
  if DownloadMovieSeasonsList and flEpisodes then begin
	RenewParameters;
    AddRequestForHTMLPageContent('https://www.kinopoisk.ru/film/'+movie_code+'/episodes/', True, RefererURL, '', RequestParameters);
  end;
	
	if (MaxPostersCount > 0) and (is_posters_present or ((UseTVDBPosters=1) and (flEpisodes or flEpisodesTitle)) or ((UseTMDBPosters=1) and not (flEpisodes or flEpisodesTitle))) then
		PostersDownloading := True;
	if (MaxShotsCount > 0) and is_frames_present then
		ShotsDownloading := True;
	if (MaxBackdropsCount > 0) and (backdrops_exist or ((UseTVDBFanart=1) and (flEpisodes or flEpisodesTitle)) or ((UseTMDBSnapshots=1) and not (flEpisodes or flEpisodesTitle))) then
		BackdropsDownloading := True;
 
	//если сериал, и одна из опций для сериала выбрана для thetvdb, ищем на thetvdb
	if (flEpisodesTitle or flEpisodes) and ((DownloadTVDBEpisodes = 1) or ((UseTVDBPosters=1) and (MaxPostersCount>0)) 
	or ((UseTVDBFanart=1) and (MaxBackdropsCount>0))) then begin
		if DownloadTVDBEpisodes = 1 then
			EpisodesDownloading := True;
//		if original_title <> '' then
//			s := original_title
//		else
			s := EncodeURL(title, 'utf-8');
		TempURL := format('https://www.thetvdb.com/search?q=%s&l=ru', [s]);
		TempURL := ReplaceStr(TempURL, ' ', '+', -1);
		AddRequestForHTMLPageContent(TempURL, False, '', 'OnTVDBMainPageLoaded');
	end;

  // TMDB images
	if ((UseTMDBPosters=1) and (MaxPostersCount > 0)) or ((UseTMDBSnapshots=1) and (MaxBackdropsCount > 0)) then begin
		if (original_title<>'') and (not flEpisodes) then begin
			TempURL := format('http://www.themoviedb.org/search/movie?query=%s&movie_page=&movie_collection_page=&person_page=&company_page=&keyword_page=&active=0', [original_title]);
			TempURL := ReplaceStr(TempURL, ' ', '+', -1);
			AddRequestForHTMLPageContent(TempURL, False, '', 'OnITDBLoaded');
		end
		else begin
			if (UseTMDBPosters = 1) then
				PostersDownloading := False;
			if (UseTMDBSnapshots = 1) then
				BackdropsDownloading := False;
		end;
	end;

  // Amazon image content
	if ((RegReadInteger('KinopoiskNeverAmazon', NEVER_USE_AMAZON) = 0) and
      (DownloadMovieBigCover)) then begin
		ImageURL := format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes,ItemIds,EditorialReview,BrowseNodes', [original_title]);
		ImageURL:=ReplaceStr(ImageURL, ' ', '+', -1);
		AddRequestForHTMLPageContent(ImageURL, False);
	end;

  // kinopoisk posters
  if (is_posters_present) then begin
  
	//если сериал и загрузка постеров с thetvdb выключена, или не сериал и загрузка постеров с themoviedb выключена
	if ((flEpisodes or flEpisodesTitle) and (UseTVDBPosters = 0)) or ((not (flEpisodes or flEpisodesTitle)) and (UseTMDBPosters=0)) then begin
		TempUrl := 'https://www.kinopoisk.ru/film/' + movie_code + '/posters';
		RenewParameters;
		AddRequestForHTMLPageContent(TempUrl, True, RefererURL, 'ParseKinopoiskPosters', RequestParameters);
	end;
  end;

  // kinopoisk frames
	if (is_frames_present) and (MaxShotsCount>0) then begin
		//ImageUrl := 'http://www.kinopoisk.ru/level/13/film/' + movie_code + '/';
		ImageUrl := 'https://www.kinopoisk.ru/film/' + movie_code + '/stills/';
		RenewParameters;
		AddRequestForHTMLPageContent(ImageUrl, True, RefererURL, 'ParseKinopoiskShots', RequestParameters);
	end;

	//kinopoisk backdrops
	if (backdrops_exist) and (MaxBackdropsCount>0) then begin
		if ((flEpisodes or flEpisodesTitle) and (UseTVDBFanart = 0)) or ((not (flEpisodes or flEpisodesTitle)) and (UseTMDBSnapshots=0)) then begin
			// TempURL := 'http://www.kinopoisk.ru/level/12/film/' + movie_code + '/';
			TempURL := 'https://www.kinopoisk.ru/wall/film/' + movie_code + '/';
			RenewParameters;
			AddRequestForHTMLPageContent(TempURL, True, RefererURL, 'ParseKinopoiskBackdrops', RequestParameters);
		end;
	end;


	//imdb rating
	imdb_rating:=0;
	i:=pos('IMDb: ', all);
	if i>0 then
  begin
		j:=MyPos(' ', all, i+7);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			delete(s2, 1, 6);
			s2:=copy(s2, 1, 3);
			if s2<>'' then begin
				i:=pos('.', s2);
				if i>0 then
					s2[i]:=DecimalSeparator;
				try
					imdb_rating:=StrToFloat(s2);
				except
				end;
			end;
		end;
	end
  else
  begin
    s := ParseTag(all, '>IMDb', '</span>');
    s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
    s := ReplaceStr(s, ':', '', -1);
    s := Trim(s);
    i:=pos('.', s);
    if i>0 then
      s[i]:=DecimalSeparator;
    try
      imdb_rating:=StrToFloat(s);
    except
    end;
  end;

	//kinopoisk rating
	rating:=0;
	s2 := '<span class="rating_ball">';
	i := pos(s2, all);
	if i>0 then begin
		j := MyPos('</span>', all, i+1);		
		if j>0 then begin
				s2:=copy(all, i+length(s2), j-i-length(s2));
				s2 := RemoveTags(s2);
				s2 := DecodeHTML(s2);
				s2 := ClearExtraBlankCharacters(s2);
				if length(s2)>0 then begin
					i:=pos('.', s2);
					if i>0 then
						s2[i]:=DecimalSeparator;
					try
						rating:=StrToFloat(s2);
					except
					end;
				end;
		end;
	end
  else
  begin
    s := ParseTag(all, '<a class="film-rating-value', '</a>');
    if (s <> '') then
      s := RemoveTags('<' + s);
    if length(s)>0 then
    begin
      i:=pos('.', s);
      if i>0 then
        s[i]:=DecimalSeparator;
      try
        rating:=StrToFloat(s);
      except
      end;
    end;
  end;

	//mpaa
	mpaa:='';
	mpaa_rating:='';
	i:=pos('рейтинг MPAA', all);
	if i>0 then begin
		j:=MyPos('</a>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i+12, j-i-12);
			i:=pos('ейтинг ', s2);
			if i>0 then begin
				j:=MyPos('"', s2, i+1);
				if j<=0 then
					j:=MyPos('''', s2, i+1);
				if j>0 then begin
					s2:=copy(s2, i+7, j-i-7);
					if s2<>'' then
						mpaa:=s2;
				end;
			end;

		end;
	end;

	//movie image
	front_cover_url := '';
	FoundBigKinopoiskPoster := False;
	i := pos('/images/film_big/'+movie_code+'.', all);
	if (i>0) and (RegReadInteger('KinopoiskBigCover', 1) = 1) then begin
		FoundBigKinopoiskPoster := True;
	end;
	i := Pos('/images/film/'+movie_code+'.', all);
	if i = 0 then
		i := Pos('/images/film_iphone/iphone360_' + movie_code, all);
	if i > 0 then
	begin
		j := MyPos('"',all,i+1);
		s2 := copy(all,i,j-i);
		i := Pos('''', s2);
		if i>0 then
			delete(s2, i, length(s2)-i+1);
		front_cover_url := 'https://www.kinopoisk.ru' + s2;
	end;

	//movie duration (minutes)
	duration:=0;
	if (RegReadInteger('KinopoiskDlDuration', 1) = 1) then begin
		s2 := ParseString(all, '<td class="time" id="runtime">(\d+) мин.', 1);
		if s2 = '' then
			s2:=ParseString(all, 'время</b>.*?(\d+?) мин', 1);
		if s2<>'' then
    begin
			try
				duration:=StrToInt(s2);
			except
			end;
    end
    else
    begin
      s2 := ParseInfoContentText(all, 'Время');
      s2 := Trim(ParseString(s2, '(\d+?) мин', 1));
      if (not TryStrToInt(s2, duration)) then
        duration := 0;
    end;
	end;

	//movie genres
	if (RegReadInteger('KinopoiskDlGenres', 1) = 1) then begin
		s2:=ParseString(all, 'жанр</b>(.*?)</li>', 1);
		if s2='' then
			s2:=ParseString(all, 'жанр</td>(.*?)</tr>', 1);
		if s2='' then
			s2:=ParseString(all, '<td class="type">жанр</td><td>(.*?)</td>', 1);
		if length(s2)>0 then
    begin
			i:=pos('</a>', s2);
			while i>0 do begin
				s3:=copy(s2, 1, i+3);
				name:=ParseString(s3, '/m_act%5Bgenre%5D.*?>(.*?)</a>', 1);
        if (name = '') then
          name:=ParseString(s3, '="/lists/navigator/.*?>(.*?)</a>', 1);
				if name<>'' then begin
					genres_count:=genres_count+1;
					SetGenre(name);
				end;
				delete(s2, 1, i+3);
				i:=pos('</a>', s2);
			end;
		end
    else
      ParseInfoContentManuals(all, 'Жанр', MANUAL_REF_GENRE);
	end;

	//movie countries
	if (RegReadInteger('KinopoiskDlCountries', 1) = 1) then begin
		s2:=ParseString(all, 'страна</b>(.*?)</li>', 1);
		if s2='' then
			s2:=ParseString(all, 'страна</td>(.*?)</tr>', 1);
		if length(s2)>0 then
    begin
			i:=pos('</a>', s2);
			while i>0 do begin
				s3:=copy(s2, 1, i+3);
				name:=ParseString(s3, '/m_act%5Bcountry%5D.*?>(.*?)</a>', 1);
        if (name = '') then
          name:=ParseString(s3, '="/lists/navigator/.*?>(.*?)</a>', 1);
				if name<>'' then begin
					SetCountry(name);
				end;
				delete(s2, 1, i+3);
				i:=pos('</a>', s2);
			end;
		end
    else
      ParseInfoContentManuals(all, 'Страна', MANUAL_REF_COUNTRY);
	end;
	

  // Fade - parse tagline for movie 
  s2 := ParseString(all, 'слоган</td>(.*?)</td></tr>', 1);
  if (s2 = '') then
    s2 := ParseInfoContentText(all, 'Слоган');
  TagLine := '';
	if length(s2)>0 then
  begin
    // remove tags and extra characters from tagline
    TagLine := DecodeHTML(s2);
    TagLine := ClearExtraSpaces(TagLine);
    TagLine := RemoveTags(TagLine);
    TagLine := ClearExtraCharacters(TagLine);
    TagLine := ClearExtraSpaces(TagLine);
    TagLine := ClearExtraQuotes(TagLine);
    //remove quotes
    for i := 0 to length(MyQuotes) - 1 do begin
      j := Pos(MyQuotes[i], TagLine);
      if j > 0 then
        delete(TagLine, j, 1);
	end;
	//too few characters
	if Length(TagLine) < 3 then
		TagLine := '';
  end;

	if (pos('href="/level/17/film/'+movie_code+'/"', all)>0) or (Pos(movie_code + '/posters/', all) > 0) then
		posters_exists:=true
	else
		posters_exists:=false;		
	comments := '';
	if not images_only then
	begin
	//movie plot
		//s2 := '<tr><td colspan=3 style="padding:10px;padding-left:20px;" class="news">';
		description := GetStr(all, 'class="brand_words" itemprop="description">', '</div>');
		if description = '' then
			description := GetStr(all, 'itemprop="description">', '</div>');
		if description <> '' then begin
			description := ReplaceStr(description, #13#10, '', -1);
 			description := ReplaceStr(description, '<br />', #13#10, -1);
 			description := ReplaceStr(description, '<br>', #13#10, -1);
			description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));
		end
		else begin
			s2:='<tr><td colspan=3 style="padding: 10px 10px 20px 20px" class="news">';
			i := pos(s2, all);
			if i>0 then
			begin
				i := i + length(s2);
				j := MyPos('</td></tr>',all,i+1);
				if (i>0)and(j>0) then
				begin
					description:=copy(all,i,j-i);


					//description:=ReplaceStr(description, #10, '<br>', -1);
				end;
			end;
		end;
    if (description = '') then
      description := ParseTextInTags(all, '<p class="film-synopsis__paragraph', '</p>');
  	description:=DecodeHTML(description);
    description:=ClearExtraSpaces(description);
    description:=ReplaceStr(description, '</p>', #13#10, -1);
    description:=ReplaceStr(description, '<br>', #13#10, -1);
    description:=RemoveTags(description);
    description:=ClearExtraCharacters(description);
    description:=ClearExtraSpaces(description);

    // Comments
    if (DownloadMovieComments) then
    begin
      comments := GetStr(all, '<div class="brand_words"', '</div>');
      if (comments <> '') then
      begin
        comments := GetStr(comments, 'itemprop="reviewBody">', '</span>');
        if (comments <> '') then
        begin
          comments:=DecodeHTML(comments);
          comments:=ClearExtraSpaces(comments);
          comments:=ReplaceStr(comments, '</p>', #13#10, -1);
          comments:=ReplaceStr(comments, '<br>', #13#10, -1);
          comments:=RemoveTags(comments);
          comments:=ClearExtraCharacters(comments);
          comments:=ClearExtraSpaces(comments);
        end;
      end;
    end;
	end;


	// Знаете ли Вы, что...
	if (RegReadInteger('KinopoiskDlTrivia', 1) = 1) then begin
		i:=pos('Знаете ли вы, что...</', all);
		if i>0 then begin
			s := GetStr(all, '<ul class="trivia', '</ul>'#10);
			if s = '' then
				s := GetStr(all, '<ul class="trivia', '</ul>');
			temp := '';
			j := Pos('<li class="trivia', s);
			while j > 0 do begin
				s2 := GetStr(s, '<li class="trivia', '</li>'#10);
				if s2 = '' then
					s2 := GetStr(s, '<li class="trivia', '</li>');
				if s2 <> '' then
					s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)));
				if (temp <> '') and (s2 <> '') then
					temp := temp + #13#10#13#10;
				temp := temp + s2;
				delete(s, 1, j);
				j := Pos('<li class="trivia', s);
			end;
			description := description +ReplaceStr('t', 't', #13#10#13#10, -1) +'Знаете ли Вы, что... :'+ReplaceStr('t', 't', #13#10, -1) + temp;
		end;
	end;
	
	if (RegReadInteger('KinopoiskDlErrors', 0) = 1) then begin
		i:=pos('Ошибки в фильме</', all);
		if i>0 then begin
			j := MyPos('</ul>', all, i+1);
			s := copy(all, i, j-i);
			temp := '';
			j := Pos('<li class="trivia', s);
			while j > 0 do begin
				s2 := GetStr(s, '<li class="trivia', '</li>');
				if s2 <> '' then
					s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)));
				if (temp <> '') and (s2 <> '') then
					temp := temp + #13#10#13#10;
				temp := temp + s2;
				delete(s, 1, j);
				j := Pos('<li class="trivia', s);
			end;
			description := description +ReplaceStr('t', 't', #13#10#13#10, -1) +'Ошибки в фильме:'+ReplaceStr('t', 't', #13#10, -1) + temp;
		end;
	end;


	//budget and box office
	money := '';
	s := '';
	if DownloadMovieEarnings then begin
		i := Pos('>бюджет</b>',all);
		if i=0 then
			i := Pos('>бюджет</td>',all);
		if i>0 then
		begin
			i := i + 7;
			k := MyPos('</td>', all, i+1);
			j := MyPos('</li>',all,i+1);
			if (k>0) and (k<j) then
				j:=k;
			s := copy(all,i,j-i);
			i := Pos('<s ', s);
			if i > 0 then
				delete(s, i, length(s)-i+1);
			s := DecodeHTML(s);
			s := RemoveTags(s);
			s := ClearExtraSpaces(s);
			s := ClearExtraXCharacters(s);
			s := 'Бюджет: ' + s + '<br>';

			money := money + s;
		end;
		i := Pos('>сборы в России</td>',all);
		if i=0 then
			i := Pos('>сборы в России</b>',all);
		if i>0 then
		begin
			i := i + 15;
			k := MyPos('</a>', all, i+1);
			j := MyPos('</div>',all,i+1);
			if (k>0) and (k<j) then
				j:=k;
			s := copy(all,i,j-i);
			i := Pos('<s ', s);
			if i > 0 then
				delete(s, i, length(s)-i+1);
			s := DecodeHTML(s);
			s := RemoveTags(s);
			s := ClearExtraSpaces(s);
			s := ClearExtraXCharacters(s);
			s := 'Cборы в России: ' + s + '<br>';
			money := money + s;
		end;
		i := Pos('>сборы в США</b>',all);
		if i=0 then
			i := Pos('>сборы в США</td>',all);
		if i>0 then
		begin
			i := i + 12;
			k := MyPos('</a>', all, i+1);
			j := MyPos('</div>',all,i+1);
			if (k>0) and (k<j) then
				j:=k;
			s := copy(all,i,j-i);
			i := Pos('<s ', s);
			if i > 0 then
				delete(s, i, length(s)-i+1);
			s := DecodeHTML(s);
			s := RemoveTags(s);
			s := ClearExtraSpaces(s);
			s := ClearExtraXCharacters(s);
			s := 'Cборы в США: ' + s + '<br>';
			money := money + s;
		end;
		i := Pos('>сборы в мире</b>',all);
		if i=0 then
			i := Pos('>сборы в мире</td>',all);
		if i>0 then
		begin
			i := i + 13;
			k := MyPos('</a>', all, i+1);
			j := MyPos('</div>',all,i+1);
			if (k>0) and (k<j) then
				j:=k;
			s := copy(all,i,j-i);
			i := Pos('<s ', s);
			if i > 0 then
				delete(s, i, length(s)-i+1);
			s := DecodeHTML(s);
			s := RemoveTags(s);
			s := ClearExtraSpaces(s);
			s := ClearExtraXCharacters(s);
			s := 'Cборы в мире: ' + s; // + '<br>';
			money := money + s;
		end;
		
		if length(money)>4 then
			salary:=money;
	end;

	// New page for getting full information about creators
	if DownloadMovieFullCast then begin

		//5.03.11
		//all:=DownloadURL(url);

		//all:=DownloadURLWithReferer(url, 'http://www.kinopoisk.ru/level/1/film/'+movie_code+'/');}
		//url := 'http://www.kinopoisk.ru/level/19/film/'+movie_code+'/who_is/director/';
		all := GetHTMLPageContentFromRequest(ActorsURL);
		//movie directors
		if (RegReadInteger('KinopoiskDlDirectors', 1) = 1) then begin
			i:=pos('Режиссеры</div>', all);
			if i<=0 then
				i:=pos('Режиссер</div>', all);
			if i>0 then	begin
				kol:=0;
				//i:=MyPos('<tr><td colspan=3><br /></td></tr>', all, i+1);
				j:=MyPos('<a name="', all, i+1);
				if j = 0 then
					 j := MyPos('<table', all, i+1);
				if j = 0 then
					j := Length(all);
				if (i>0)and(j>0) then begin
					s2 := copy(all, i, j-i);
					//ShowMessage(s2);
					ExtractPeopleFull(s2, 1);
				end;
			end
			else begin
				s2 := DownloadURLWithReferer('https://www.kinopoisk.ru/film/'+movie_code+'/cast/who_is/director/', url, true, RequestParameters);
				ExtractPeopleFull(s2, 1);
			end;
		end;

		//url := 'http://www.kinopoisk.ru/level/19/film/'+movie_code+'/';
		//all := GetHTMLPageContentFromRequest(url);
		//movie cast
		if (RegReadInteger('KinopoiskDlActors', 1) = 1) then begin
			i:=pos('Актеры</div>', all);
			if i = 0 then
				i := Pos('Актер</div>', all);
			if i = 0 then
				i := Pos('Актриса</div>', all);
			if i>0 then
			begin
				//i:=MyPos('<tr><td colspan=3><br /></td></tr>', all, i+1);
				j:=MyPos('<a name="', all, i+1);
				if j = 0 then
					 j := MyPos('<table', all, i+1);
				if j = 0 then
					j := Length(all);
				if (i>0)and(j>0) then begin
					s2 := copy(all, i, j-i);
					ExtractPeopleFull(s2, 3);
				end;
			end;
		end;

		//url := 'http://www.kinopoisk.ru/level/19/film/'+movie_code+'/who_is/writer/';
		//all := GetHTMLPageContentFromRequest(url);
		//movie writers
		if (RegReadInteger('KinopoiskDlWriters', 1) = 1) then begin
			i:=pos('Сценаристы</div>', all);
			if i = 0 then
				i:=pos('Сценарист</div>', all);
			if i>0 then begin
				kol:=0;
				//i:=MyPos('<tr><td colspan=3><br /></td></tr>', all, i+1);
				j:=MyPos('<a name="', all, i+1);
				if j = 0 then
					 j := MyPos('<table', all, i+1);
				if j = 0 then
					j := Length(all);
				if (i>0)and(j>0) then begin
					s2 := copy(all, i, j-i);
					ExtractPeopleFull(s2, 2);
				end;
			end
			else begin
				s2 := DownloadURLWithReferer('https://www.kinopoisk.ru/level/'+movie_code+'/cast/who_is/writer/', url, true, RequestParameters);
				ExtractPeopleFull(s2, 2);
			end;
		end;

		//movie composers
		//url := 'http://www.kinopoisk.ru/level/19/film/'+movie_code+'/who_is/composer/';
		//all := GetHTMLPageContentFromRequest(url);
		if (RegReadInteger('KinopoiskDlComposers', 1) = 1) then begin
			i:=pos('Композиторы</div>', all);
			if i = 0 then
				i:=pos('Композитор</div>', all);
			if i>0 then begin
				kol:=0;
				//i:=MyPos('<tr><td colspan=3><br /></td></tr>', all, i+1);
				j:=MyPos('<a name="', all, i+1);
				if j = 0 then
					 j := MyPos('<table', all, i+1);
				if j = 0 then
					j := Length(all);
				if (i>0)and(j>0) then begin
					s2 := copy(all, i, j-i);
					ExtractPeopleFull(s2, 4);
				end;
			end
			else begin
				s2 := DownloadURLWithReferer('https://www.kinopoisk.ru/film/'+movie_code+'/cast/who_is/composer/', url, true, RequestParameters);
				ExtractPeopleFull(s2, 4);
			end;
		end;

		//movie producers
		if (RegReadInteger('KinopoiskDlProducers', 1) = 1) then begin
			i:=pos('Продюсеры</div>', all);
			if i = 0 then
				i:=pos('Продюсер</div>', all);
			if i>0 then begin
				kol:=0;
				//i:=MyPos('<tr><td colspan=3><br /></td></tr>', all, i+1);
				j:=MyPos('<a name="', all, i+1);
				if j = 0 then
					 j := MyPos('<table', all, i+1);
				if j = 0 then
					j := Length(all);
				if (i>0)and(j>0) then begin
					s2 := copy(all, i, j-i);
					ExtractPeopleFull(s2, 5);
				end;
			end
			else begin
				s2 := DownloadURLWithReferer('https://www.kinopoisk.ru/film/'+movie_code+'/cast/who_is/producer/', url, true, RequestParameters);
				ExtractPeopleFull(s2, 5);
			end;
		end;
		
		//movie cameraman
		if (RegReadInteger('KinopoiskDlCameraman', 1) = 1) then begin
			i:=pos('Операторы</div>', all);
			if i = 0 then
				i:=pos('Оператор</div>', all);
			if i>0 then begin
				kol:=0;
				//i:=MyPos('<tr><td colspan=3><br /></td></tr>', all, i+1);
				j:=MyPos('<a name="', all, i+1);
				if j = 0 then
					 j := MyPos('<table', all, i+1);
				if j = 0 then
					j := Length(all);
				if (i>0)and(j>0) then begin
					s2 := copy(all, i, j-i);
					ExtractPeopleFull(s2, 6);
				end;
			end
			else begin
				s2 := DownloadURLWithReferer('https://www.kinopoisk.ru/film/'+movie_code+'/cast/who_is/operator/', url, true, RequestParameters);
				ExtractPeopleFull(s2, 6);
			end;
		end;

	end
	//if Download full cast/crew is not selected
	else begin
		if (RegReadInteger('KinopoiskDlActors', 1) = 1) then begin
			i := Pos('В главных ролях:', all);
			if i>0 then begin
				k := MyPos('Роли дублировали:', all, i+1);
				if k = 0 then
					k := MyPos('<tr><td align="right" class="desc-title"', all, i+1);
				j := MyPos('</table>', all, i+1);
				if (k>0) and (j>k) then
					j:=k;
				s2 := copy(all, i, j-i);
				ExtractPeople(s2, 3);
			end;
		end;
		//режиссеры
		if (RegReadInteger('KinopoiskDlDirectors', 1) = 1) then begin
			i := Pos('<tr><td class="type">режиссер', all);
			if i>0 then begin
				j:=MyPos('</tr>', all, i+1);
				s := copy(all, i, j-i);
				ExtractPeople(s, 1);
			end;
		end;
		//сценаристы
		if (RegReadInteger('KinopoiskDlWriters', 1) = 1) then begin
			i := Pos('<tr><td class="type">сценарий', all);
			if i>0 then begin
				j:=MyPos('</tr>', all, i+1);
				s := copy(all, i, j-i);
				ExtractPeople(s, 2);
			end;
		end;
		//композиторы
		if (RegReadInteger('KinopoiskDlComposers', 1) = 1) then begin
			i := Pos('<tr><td class="type">композитор', all);
			if i>0 then begin
				j:=MyPos('</tr>', all, i+1);
				s := copy(all, i, j-i);
				ExtractPeople(s, 4);
			end;
		end;
		//продюсеры
		if (RegReadInteger('KinopoiskDlProducers', 1) = 1) then begin
			i := Pos('<tr><td class="type">продюсер', all);
			if i>0 then begin
				j:=MyPos('</tr>', all, i+1);
				s := copy(all, i, j-i);
				ExtractPeople(s, 5);
			end;
		end;
		//операторы
		if (RegReadInteger('KinopoiskDlCameraman', 1) = 1) then begin
			i := Pos('<tr><td class="type">оператор', all);
			if i>0 then begin
				j:=MyPos('</tr>', all, i+1);
				s := copy(all, i, j-i);
				ExtractPeople(s, 6);
			end;
		end;
	end;
	

	//Награды
	if awards_exist and DownloadMovieAwards and (RegReadInteger('KinopoiskDlAwards', 1) = 1) then begin
		url:=awards_url;
		//5.03.11
		//all:=DownloadURL(url);
		// all:=DownloadURLWithReferer(url, 'http://www.kinopoisk.ru/level/1/film/'+movie_code+'/');
		all := GetHTMLPageContentFromRequest(url);

		if all<>'-1' then begin
			i:=Pos('<h1 class="level2"><a href="/awards/" class="continue">Награды</a></h1>', all);
			if i = 0 then
				i := Pos('<a href="/awards/" class="breadcrumbs__link">Награды</a>', all);
			if i>0 then begin
				//На Кинопоиске перед таблицей наград бывает текст, там описываются доп. награды
				k:=Pos('<div style="background-color:#f2f2f2;padding:15px">', all);
				if k>0 then begin
					j:=MyPos('</div>', all, k+1);
					s:=copy(all, k, j-k);
					awards:=DecodeHTML(RemoveTags(s));
				end;
				//Теперь беремся за таблицу наград
				i:=MyPos('<b><a href="/level/94/award/', all, i+1);
				if i=0 then
					i:=MyPos('<b><a href="/awards/', all, i+1);
				if i>0 then begin
					j:=MyPos('<table cellspacing=0 cellpadding=4 width=100% border=0', all, i+1);
					s:=copy(all, i, j-i);
					j := Pos('<b><a href="/awards/', s);
					while j > 0 do begin
						k := MyPos('</table>', s, j + 1);
						s2 := copy(s, j, k-j);
						if awards <> '' then
							awards := awards + '<br> <br>';
						awards := awards + ExtractAwards(s2);
						delete(s, 1, j);
						j := Pos('<b><a href="/awards/', s);
					end;
					//showMessage(awards);
				end;
			end;
		end;
	end;

	//студии
	if DownloadMovieStudios and (RegReadInteger('KinopoiskDlStudios', 1) = 1) then
  begin
		url:=studios_url;
		//5.03.11
		//all:=DownloadURL(url);
		// all:=DownloadURLWithReferer(url, 'http://www.kinopoisk.ru/level/1/film/'+movie_code+'/');
    all := GetHTMLPageContentFromRequest(url);
		if all<>'-1' then begin
			i:=Pos('<h1 class="breadcrumbs__head">Компании</h1>', all);
			if i>0 then begin
				i := MyPos('<b>Производство:</b>', all, i + 1);
				if i>0 then begin
					j := MyPos('</table>', all, i+1);
					s2 := copy(all, i, j-i);
					i := Pos('/m_act[studio]/', s2);
					if i=0 then
						i := Pos('/m_act%5Bstudio%5D/', s2);
					while i>0 do begin
						j := MyPos('</a>', s2, i+1);
						s := copy(s2, i, j-i);
						name := '';
						if s <> '' then
							name := RemoveTags('<' + s);
						name := DecodeHTML(name);
						if name<>'' then
							SetStudio(name);
						delete(s2, 1, j);
						i := Pos('/m_act[studio]/', s2);
						if i=0 then
							i := Pos('/m_act%5Bstudio%5D/', s2);
					end;
				end;
			end;
		end;
	end;
  // Fade. Movies links
  if (DownloadMovieLinks) then
  begin
	url:=links_url;
    all := GetHTMLPageContentFromRequest(url);
    if ((all <> '-1') and
        (all <> '')) then
    begin
      // Status enumeration:
      // 1 - Серия (Начало/Продолжение)
      // 2 - Пародия на
      // 3 - Спародирован в
      // 4 - Отсылки к
      // 5 - Упоминается в
      AddMoviesLinksForStatus(1, 'Начало');
      AddMoviesLinksForStatus(1, 'Продолжение');
      AddMoviesLinksForStatus(2);
      AddMoviesLinksForStatus(3);
      AddMoviesLinksForStatus(4);
      AddMoviesLinksForStatus(5);
    end;
  end;

  // 10.11.2010 Parse trailers from trailer page
  GetAllTrailers();
  //ShowTickCount('End of the GetInfo');
  
	//episodes
	if DownloadMovieSeasonsList and (flEpisodes or flEpisodesTitle) and (RegReadInteger('KinopoiskDlEpisodes', 1) = 1) then begin
		while not TVDBSearchEnded do
			Application.ProcessMessages;
		if ((DownloadTVDBEpisodes=0) or TVDBNothingFound) and flEpisodes then begin
			url:='https://www.kinopoisk.ru/film/'+movie_code+'/episodes/';

			//5.03.11
			//all:=DownloadURL(url);
			// all:=DownloadURLWithReferer(url, 'http://www.kinopoisk.ru/level/1/film/'+movie_code+'/');
      all := GetHTMLPageContentFromRequest(url);
			if all<>'-1' then begin
				i:=pos('<a name="s1"></a>', all);
				if i>0 then begin
					j:=MyPos('<br /><br /><br /><br /><br />', all, i+1);
					if j>0 then begin
						temp:=copy(all, i, j-i);
						i := Pos('<a name="s', temp);
						while i > 0 do begin
							s := GetStr(temp, '<a name="s', '</table>');
							delete(temp, 1, i);
							s3 := ParseString(s, '^(\d+)', 1);
							season:=0;
							try
								season := StrToInt(s3);
							except
							end;
							if DlUnknown and (s3 = '0') then
								season := 99;
							i:=pos('<span style="color:#777">Эпизод ', s);
							while i>0 do begin
								j:=MyPos('</tr>', s, i+1);
								if j>0 then begin
								s2:='<span style="color:#777">Эпизод ';
								s3:=copy(s, i+length(s2), j-i-length(s2));
								delete(s, 1, j+4);
								k:=pos('</span>', s3);
								episode := -1;
								try
									if k>0 then
										episode:=StrToInt(copy(s3, 1, k-1))
									else
										episode:=-1;
								except
								end;
								if episode>=0 then begin
									delete(s3, 1, k+6);
									EpisodeTitle:='';
									k:=pos('<b>', s3);
									if k>0 then begin
										k2:=MyPos('</b>', s3, k+1);
										if k2>0 then begin
											EpisodeTitle:=copy(s3, k+3, k2-k-3);
											EpisodeTitle:=DecodeHTML(EpisodeTitle);
										end;
									end;

										AirDate:='';
									s2:='<td width=20% class="news" align=right valign=bottom style="border-bottom:1px solid #ccc;padding:15px 0px;font-size:12px" align=left>';
									k:=pos(s2, s3);
									if k>0 then begin
										k2:=MyPos('</td>', s3, k+1);
										if k2>0 then
											AirDate:=copy(s3, k+length(s2), k2-k-length(s2));
										end;
								end;

								EpisodeIMDB:='';
								EpisodeDescription:='';
								
								s3:=AirDate;
								AirDate:='';
								k:=pos('&nbsp;', s3);
								if k>0 then begin
									day:=copy(s3, 1, k-1);
									delete(s3, 1, k+5);
									k:=pos('&nbsp;', s3);
									if k>0 then begin
										month:=copy(s3, 1, k-1);
										delete(s3, 1, k+5);
										ayear:=s3;

									k:=1;
									while (k<=12) and (monthes[k]<>month) do begin	
										k:=k+1;
									end;
									if (k<=12) and (month<>'') then begin
										AirDate:=IntToStr(k)+format('/%s/%s', [day, ayear])
									end
									end;
								end;
									
									if (season>0) and (episode>=0) and (episode<=100) then
									SetEpisode(season, episode, EpisodeTitle, EpisodeDescription, EpisodeIMDB, AirDate);

									i:=pos('<span style="color:#777">Эпизод ', s);
								end
								else
									i:=0;
							end;
							i := Pos('<a name="s', temp);
						end;
					end;
				end;
			end;
		end;
	end;
	
	if RegReadInteger('KinopoiskDlType', 1) = 0 then
		media_type := '';
  
end;

function GetMovieLinkKinopoiskDescriptionByStatus(AStatus: Integer): string;
begin
  // Status enumeration:
  // 1 - Серия (Начало/Продолжение)
  // 2 - Пародия на
  // 3 - Спародирован в
  // 4 - Отсылки к
  // 5 - Упоминается в
  Result := '';
  case AStatus of
    2: Result := 'Пародия на';
    3: Result := 'Спародирован в';
    4: Result := 'Отсылки к';
    5: Result := 'Упоминается в';
  end;
end;

procedure AddMoviesLinksForStatus(AStatus: Integer; AStatusStr: string = '');
var
  I: Integer;
  J: Integer;
  K: Integer;
  SearchStr: string;
  MoviesList: string;
  SingleMovie: string;
  // Movie info
  MovieTitle: string;
  MovieYear: string;
  MovieOriginalTitle: string;
  MovieSiteCode: string;
  MovieSiteURL: string;
  s: String;

  function ProcessSingleString(AString: string): string;
  begin
    Result := RemoveTags(AString);
    Result := DecodeHTML(Result);
    Result := ClearExtraSpaces(Result);
  end;

begin
  SearchStr := AStatusStr;
  if (SearchStr = '') then
    SearchStr := GetMovieLinkKinopoiskDescriptionByStatus(AStatus);
  if (SearchStr <> '') then
  begin
	SearchStr := SearchStr + '</td';
    I := Pos(SearchStr, all);
    if (I > 0) then
    begin
      J := MyPos('   </table>', all, I);
      if (J > 0) then
      begin
        MoviesList := Copy(all, I, J - I);
        K := Pos('<span class="name"', MoviesList);
        while (K > 0) do
        begin
          J := MyPos('</table>', MoviesList, K);
          if (J > 0) then
          begin
            SingleMovie := Copy(MoviesList, K, J - K);
            MovieTitle := '';
            MovieYear := '';
            MovieOriginalTitle := '';
            MovieSiteCode := '';
            I := Pos('<a href="/film/', SingleMovie);
            if (I > 0) then
            begin
              I := I + Length('<a href="/film/');
              // movie code
              MovieSiteCode := Copy(SingleMovie, I, MyPos('/', SingleMovie, I + 1) - I);
			  MovieSiteCode := ParseString(MovieSiteCode, '(\d+)', 1);
              // movie title
              J := MyPos('</a>', SingleMovie, I);
              I := MyPos('>', SingleMovie, I);
              if ((I > 0) and
                  (J > 0)) then
              begin
                MovieTitle := Copy(SingleMovie, I + 1, J - I - 1);
                MovieTitle := ProcessSingleString(MovieTitle);
                if (Pos('(сериал)', MovieTitle) > 0) then
                  MovieTitle := Trim(Copy(MovieTitle, 1, Pos('(сериал)', MovieTitle) - 1));
                if (Pos('(ТВ)', MovieTitle) > 0) then
                  MovieTitle := Trim(Copy(MovieTitle, 1, Pos('(ТВ)', MovieTitle) - 1));
                if (Pos('(видео)', MovieTitle) > 0) then
                  MovieTitle := Trim(Copy(MovieTitle, 1, Pos('(видео)', MovieTitle) - 1));
                if (Pos('(мини-сериал)', MovieTitle) > 0) then
                  MovieTitle := Trim(Copy(MovieTitle, 1, Pos('(мини-сериал)', MovieTitle) - 1));
              end;
              // movie Year
              (*I := Pos('/m_act%5Byear%5D/', SingleMovie);
              if (I > 0) then
              begin
                I := I + Length('/m_act%5Byear%5D/');
                MovieYear := Copy(SingleMovie, I, MyPos('/', SingleMovie, I) - I);
                MovieYear := ProcessSingleString(MovieYear);
                if (Length(MovieYear) <> 4) then
                  MovieYear := '';
              end;*)
			  i := Pos(' (', MovieTitle);
			  if i > 0 then begin
				s := GetStr(MovieTitle, '(', ')');
				if NoVideosInSeries and (Pos('видео', s) > 0) and (AStatus = 1) then
					MovieTitle := '';
				delete(MovieTitle, i, length(MovieTitle) - i + 1);
				MovieYear := ParseString(s, '(\d+)', 1);
			  end;
              // movie original title
			  MovieOriginalTitle := GetStr(SingleMovie, '<span class="role"', '</span');
			  if MovieOriginalTitle <> '' then
				MovieOriginalTitle := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + MovieOriginalTitle)));
              (*I := Pos('<font color="#999999">', SingleMovie);
              if (I > 0) then
              begin
                I := I + Length('<font color="#999999">');
                MovieOriginalTitle := Copy(SingleMovie, I, MyPos('</font>', SingleMovie, I) - I);
                MovieOriginalTitle := ProcessSingleString(MovieOriginalTitle);
              end;*)
              // set Movie link if available
              if (Trim(MovieTitle) <> '') then
              begin
                MovieSiteURL := '';
                if (MovieSiteCode <> '') then
                  MovieSiteURL := GetMovieURL(MovieSiteCode, False);
                // update movie link
                SetMovieLink(MovieTitle, MovieSiteCode,
                  ProcessSingleString(MovieYear), MovieOriginalTitle, AStatus,
                  MovieSiteURL);
              end;
            end;
          end;
          K := MyPos('<span class="name"', MoviesList, K + 1);
        end;
      end;
    end;
  end;
end;

function GetTrailerCodeByURL(AURL: string): string;
var
  EndPos: Integer;
  StartPos: Integer;
begin
  Result := '';
  StartPos := Pos('/t/', AURL);
  if (StartPos > 0) then
  begin
    StartPos := StartPos + Length('/t/');
    EndPos := MyPos('/', AURL, StartPos);
    if (EndPos > 0) then
      Result := Copy(AURL, StartPos, EndPos - StartPos);
  end;
end;

procedure GetAllTrailers;
var
  ImageURL: string;
  TrailerCode: string;
  URL: string;
  S: String;
  I: Integer;
  J: Integer;
  K: Integer;
  TrailerDescription: string;
  TrailersCount: Integer;
begin
  TrailersCount := 0;
  // 10.11.2010 trailer
  if (MaxTrailersCount > 0) then
  begin
    url := 'https://www.kinopoisk.ru/film/'+movie_code+'/video/';
    s := GetHTMLPageContentFromRequest(url);
    I := Pos('<table cellspacing=0 cellpadding=0 width=100% border=0>', s);
    if (I > 0) then
      s := Copy(s, I, Length(S) - I);
    if (s <> '')and(s <> '-1') then
    begin
      // Parse trailers from trailer page if necessary
      if (TrailersCount < MaxTrailersCount) then
      begin
        // parse all trailers
        I := Pos(movie_code + '/video/', S);
        while ((I > 0) and
               (TrailersCount < MaxTrailersCount)) do
        begin
          // search trailer URL
          K := MyPos('"', S, I + 1);
          if (K > I) then
          begin
            URL := Copy(S, I, K - I);
            if (Pos('#comm', LowerCase(URL)) = 0) then
            begin
              // search Trailer description
              K := MyPos('>', S, I + 1);
              if (K > I) then
              begin
                J := MyPos('</a>', S, K + 1);
                if (J > K) then
                  TrailerDescription := Copy(S, K + 1, J - K - 1);
              end;
              ImageURL := '';
              J := PosBack('''previewFile'': ''', s, I);
              if (J > 0) then
              begin
                J := J + Length('''previewFile'': ''');
                K := MyPos('''', s, J);
                if (K > 0) then
                begin
                  TrailerCode := Trim(Copy(s, J, K - J));
                  if (TrailerCode <> '') then
                    ImageURL := Format('http://kp.cdn.yandex.net/%s' , [TrailerCode]);
                end;
              end
              else
              begin
                J := MyPos('"previewFile": "', s, I);
                if (J > 0) then
                begin
                  J := J + Length('"previewFile": "');
                  K := MyPos('"', s, J);
                  if (K > 0) then
                  begin
                    TrailerCode := Trim(Copy(s, J, K - J));
                    if (TrailerCode <> '') then
                      ImageURL := Format('http://kp.cdn.yandex.net/%s' , [TrailerCode]);
                  end;
                end;
              end;
              SetTrailer('https://www.kinopoisk.ru/film/' + URL, TrailerDescription, ImageURL);
              Inc(TrailersCount);
            end;
          end;
          Delete(S, 1, I + Length('/film/' + movie_code + '/video/t/'));
		  I := Pos('<!-- /ролик -->', S);
		  delete(S, 1, i);
          I := Pos(movie_code + '/video/', S);
        end;
      end;
    end;
  end;
end;

// get movie frames
procedure ParseKinopoiskShots(s: String);
var
	url, s2, frame_url, frame_page, img_code, temp: string;
	i, j, k, il, l: Integer;
	frames_count: Integer;
begin
	if (s <> '')and(s <> '-1') then begin
		(*frames_count := 0;
		temp := GetStr(s, 'class="fotos"', '</table>');
		i := Pos(' href="/picture/', temp);
		while (i > 0) and (frames_count < MaxShotsCount) do begin
			frame_url := GetStr(temp, ' src="', '"');
			frame_url := ReplaceStr(frame_url, '/sm_', '/', -1);
			if frame_url <> '' then begin
				inc(frames_count);
				SetImageName('', frame_url, '', 3);
			end;
			delete(temp, 1, i);
			i := Pos(' href="/picture/', temp);
		end;*)
		frames_count := 0;
		l := pos('href="/picture/', s);
		if (LatinTitle = '') and (l>0) then begin
			i := MyPos('"', s, l+1);
			j := MyPos('"', s, i+1);
			s2 := copy(s, i+1, j-i-1);
			img_code := ParseString(s2, '\/picture\/(\d+)\/', 1);
			if s2<>'' then begin
				url := 'https://www.kinopoisk.ru' + s2;
				RenewParameters;
				AddRequestForHTMLPageContent(url, True, 'https://www.kinopoisk.ru/level/1/film/'+movie_code+'/', '', RequestParameters);
				s2 := GetHTMLPageContentFromRequest(url);


				if (s2 <> '')and(s2 <> '-1') then begin
					il := pos('logo.gif', s2);
					i := MyPos('/im/kadr/', s2, il);
					if i=0 then
						i := MyPos('src="https://st.kinopoisk.ru/', s2, il);
					if (i > 0) then begin
						//i := MyPos('"', s2, i) + 1;
						j := MyPos('"', s2, i);
						frame_url := copy(s2, i, j-i);
					end;
				end;
			end;
			i := Pos(img_code, frame_url);
			if i>0 then
				delete(frame_url, i - 1, length(frame_url) - i + 2);
			LatinTitle := ParseString(frame_url, 'kinopoisk.ru-(.*?)$', 1);
  		LatinTitle := ReplaceStr(LatinTitle, ' ', '-', -1);
  		LatinTitle := EncodeURL(LatinTitle, 'WINDOWS-1251');
	  	LatinTitle := ReplaceStr(LatinTitle, '%', '_', -1);
		end;
			
		while (l > 0) and (frames_count < MaxShotsCount) do
		begin
			img_code := '';
			frame_url := '';
			i := MyPos('"', s, l) + 1;
			j := MyPos('"', s, i);
			s2 := copy(s, i, j-i);
			img_code := ParseString(s2, '\/picture\/(\d+)\/', 1);
			frame_url := 'https://st-im.kinopoisk.ru/im/kadr/'+ copy(img_code, 1, 1) + '/' + copy(img_code, 2, 1) + '/' + copy(img_code, 3, 1) + '/kinopoisk.ru-' + LatinTitle + '-' + img_code + '.jpg';

			//29.12.12
			{frame_url := 'http://st.kinopoisk.ru/images/kadr/' + img_code + '.jpg';}
			if (img_code <> '') and (frame_url <> '') then
			begin
				SetImageName('', frame_url, '', 3);
				frames_count := frames_count + 1;
			end;
			l := MyPos('</td>', s, j+1); 
			delete(s, 1, l);
			l := pos('href="/picture/', s); 
		end; 
	end;
	ShotsDownloading := False;
end;

// get movie posters
procedure ParseKinopoiskPosters(s: string);
var
	url, ReferenceURL, s2, frame_url, frame_page, img_code, temp: string;
	i, j, k, il, l: Integer;
	frames_count: Integer;
begin
	if MaxPostersCount > 0 then begin
		if (s <> '')and(s <> '-1') then begin
			(*frames_count := 0;
			temp := GetStr(s, 'class="fotos"', '</table>');
			i := Pos(' href="/picture/', temp);
			while (i > 0) and (frames_count < MaxPostersCount) do begin
				frame_url := GetStr(temp, ' src="', '"');
				frame_url := ReplaceStr(frame_url, '/sm_', '/', -1);
				if frame_url <> '' then begin
					inc(frames_count);
					SetImageName('', frame_url, '', 4);
				end;
				delete(temp, 1, i);
				i := Pos(' href="/picture/', temp);
			end;*)
		
			frames_count := 0;
			l := pos('href="/picture/', s);
			if (LatinTitle = '') and (l>0) then begin
				i := MyPos('"', s, l+1);
				j := MyPos('"', s, i+1);
				s2 := copy(s, i+1, j-i-1);
				img_code := ParseString(s2, '\/picture\/(\d+)\/', 1);
				if s2<>'' then begin
					url := 'https://www.kinopoisk.ru' + s2;
					ReferenceURL := 'https://www.kinopoisk.ru/level/1/film/'+movie_code+'/';
					RenewParameters;
					AddRequestForHTMLPageContent(url, True, ReferenceURL, '', RequestParameters);
					s2 := GetHTMLPageContentFromRequest(url);

					if (s2 <> '')and(s2 <> '-1') then begin
						il := pos('logo.gif', s2);
						i := MyPos('/im/poster/', s2, il);
						if i=0 then
							i := MyPos('src="https://st.kinopoisk.ru/', s2, il);
						if (i > 0) then begin
							//i := MyPos('"', s2, i) + 1;
							j := MyPos('"', s2, i);
							frame_url := copy(s2, i, j-i);
						end;
					end;
				end;
				i := Pos(img_code, frame_url);
				if i>0 then
					delete(frame_url, i - 1, length(frame_url) - i + 2);
				LatinTitle := ParseString(frame_url, 'kinopoisk.ru-(.*?)$', 1);
    		LatinTitle := ReplaceStr(LatinTitle, ' ', '-', -1);
    		LatinTitle := EncodeURL(LatinTitle, 'WINDOWS-1251');
	    	LatinTitle := ReplaceStr(LatinTitle, '%', '_', -1);
			end;
				
			while (l > 0) and (frames_count < MaxPostersCount) do
			begin
				img_code := '';
				frame_url := '';
				i := MyPos('"', s, l) + 1;
				j := MyPos('"', s, i);
				s2 := copy(s, i, j-i);
				img_code := ParseString(s2, '\/picture\/(\d+)\/', 1);
				frame_url := 'https://st-im.kinopoisk.ru/im/poster/'+ copy(img_code, 1, 1) + '/' + copy(img_code, 2, 1) + '/' + copy(img_code, 3, 1) + '/kinopoisk.ru-' + LatinTitle + '-' + img_code + '.jpg';
				if img_code <> '' then
				begin
					SetImageName('', frame_url, '', 4);
					frames_count := frames_count + 1;
				end;
				l := MyPos('</td>', s, j+1); 
				delete(s, 1, l);
				l := pos('href="/picture/', s); 
			end;
		end;
	end;
	PostersDownloading := False;
end;

// get movie backdrops
procedure ParseKinopoiskBackdrops(s: string);
var
	url, ReferenceURL, s2, frame_url, frame_page, img_code, my_ext: string;
	i, j, k, il, l, m: Integer;
	frames_count: Integer;
begin
	if MaxBackdropsCount > 0 then begin
		if (s <> '')and(s <> '-1') then begin
			frames_count := 0;
			m := pos('href="/picture/', s);
			if (LatinTitle = '') and (m>0) then begin
				i := MyPos('"', s, m+1);
				j := MyPos('"', s, i+1);
				s2 := copy(s, i+1, j-i-1);
				img_code := ParseString(s2, '\/picture\/(\d+)\/', 1);
				if s2<>'' then begin
					url := 'https://www.kinopoisk.ru' + s2;
					ReferenceURL := 'https://www.kinopoisk.ru/level/1/film/'+movie_code+'/';
					AddRequestForHTMLPageContent(url, True, ReferenceURL, '', RequestParameters);
					s2 := GetHTMLPageContentFromRequest(url);

					if (s2 <> '')and(s2 <> '-1') then begin
						il := pos('logo.gif', s2);
						l := MyPos('/im/wallpaper/', s2, il);
						if l=0 then
							l := MyPos('src="https://st.kinopoisk.ru/', s2, il);
						if (l > 0) then begin
							//l := MyPos('"', s2, l) + 1;
							j := MyPos('"', s2, l);
							frame_url := copy(s2, l, j-l);
						end;
					end;
				end;
				l := Pos(img_code, frame_url);
				if l>0 then
					delete(frame_url, l - 1, length(frame_url) - l + 2);
				LatinTitle := ParseString(frame_url, 'kinopoisk.ru-(.*?)$', 1);
    		LatinTitle := ReplaceStr(LatinTitle, ' ', '-', -1);
    		LatinTitle := EncodeURL(LatinTitle, 'WINDOWS-1251');
	    	LatinTitle := ReplaceStr(LatinTitle, '%', '_', -1);
			end;
				
			while (m > 0) and (frames_count < MaxBackdropsCount) do begin
				img_code := '';
				frame_url := '';
				j := MyPos('</td>', s, m);
				s2 := copy(s, m, j-m);
				img_code := ParseString(s2, '\/picture\/(\d+)\/', 1);
				if (Pos('/w_size/1280/', s2)>0) then
					my_ext := '--w--1280.jpg'
				else if (Pos('/w_size/800/', s2)>0) then
					my_ext := '--w--800.jpg'
				else
					my_ext := '.jpg';
				frame_url := 'https://www.kinopoisk.ru/im/wallpaper/'+ copy(img_code, 1, 1) + '/' + copy(img_code, 2, 1) + '/' + copy(img_code, 3, 1) + '/kinopoisk.ru-' + LatinTitle + '-' + img_code + my_ext;
				if img_code <> '' then
				begin
					SetImageName('', frame_url, '', 7);
					frames_count := frames_count + 1;
				end;
				//i := MyPos('</td>', s, j+1); 
				delete(s, 1, j);
				m := pos('href="/picture/', s); 
			end; 
		end;
	end;
	BackdropsDownloading := False;
end;

//returned images links
procedure GetImages;
var
	kol, i: integer;
	amazon_url: String;
begin
	//fron cover
	amazon_url := '';
	if FoundBigKinopoiskPoster then
		SetImageName('', 'https://www.kinopoisk.ru/images/film_big/' + movie_code + '.jpg', '', 1);
	if (RegReadInteger('KinopoiskAlwaysAmazon', ALWAYS_USE_AMAZON) = 1) or 
	((RegReadInteger('KinopoiskNoAmazonIfBigCoverAvailable', NO_AMAZON_COVER_IF_BIG_AVAILABLE) = 1) and not FoundBigKinopoiskPoster) then
		amazon_url := GetFrontCoverURL2;
	if (not FoundBigKinopoiskPoster) and (front_cover_url<>'') and ((RegReadInteger('KinopoiskNoSmallCover', NO_SMALL_COVER) = 0) or (amazon_url = '')) then begin// front-cover from movie site
		SetImageName('', front_cover_url, '', 1);
	end;
	ShowTickCount('Amazon');

	while EpisodesDownloading do 
		Application.ProcessMessages;
	while PostersDownloading do
		Application.ProcessMessages;
	while ShotsDownloading do
		Application.ProcessMessages;
	while BackdropsDownloading do
		Application.ProcessMessages;
  if (EpisodeURLs <> nil) then
  begin
    for i := 0 to EpisodeURLs.Count - 1 do
    	GetHTMLPageContentFromRequest(EpisodeURLs[i]);
  end;
	if (RegReadInteger('KinopoiskDlTitle', 1) = 0) then
		title := '';
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.kinopoisk.ru/film/'+code+'/';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:=format('https://www.kinopoisk.ru/level/4/people/%s/', [code])
end;

//иногда требуется логин на сайт
procedure SiteLogin;
var
	url, all: string;
begin
	if UserName='' then begin
		ShowLoginForm;
	end;
	url:=format('https://www.kinopoisk.ru/level/30/?shop_user[login]=%s&shop_user[pass]=%s&shop_user[mem]=on', [UserName, UserPassword]);
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURLWithReferer(url, 'post');
	if (GetResponseCode=403) then begin
		ShowLoginForm;
	end;
end;


procedure ButtonClick(Sender: TButton);
begin
	UserName:=edUserName.Text;
	UserPassword:=edPassword.Text;
	SaveLoginInfo(UserName, UserPassword, script_name);

	f.ModalResult := mrOk;
end;

procedure ShowLoginForm;
begin
	f := TForm.Create(nil);
	f.Caption := 'Требуется авторизация';
	f.BorderStyle := bsDialog;
	f.Position := poScreenCenter;
	f.Width:=400;


	labCaption := TLabel.Create(f);
	labCaption.Name := 'labCaption';
	labCaption.Parent := f;
	labCaption.SetBounds(10, 10, 380, 25);
	labCaption.Caption := 'Для получения информации с этого сайта необходима авторизация.';

	labUserName := TLabel.Create(f);
	labUserName.Name := 'labUserName';
	labUserName.Parent := f;
	labUserName.SetBounds(10, 40, 100, 25);
	labUserName.Caption := 'Имя пользователя:';

	edUserName := TEdit.Create(f);
	edUserName.Name := 'Name';
	edUserName.Parent := f;
	edUserName.SetBounds(120, 40, 175, 25);
	edUserName.Text := UserName;

	labPassword := TLabel.Create(f);
	labPassword.Name := 'labPassword';
	labPassword.Parent := f;
	labPassword.SetBounds(10, 70, 380, 25);
	labPassword.Caption := 'Пароль:';

  edPassword := TEdit.Create(f);
	edPassword.Name := 'edPassword';
	edPassword.Parent := f;
	edPassword.SetBounds(120, 70, 175, 25);
	edPassword.Text := UserPassword;

	b := TButton.Create(f);
	b.Name := 'btnOK';
	b.Parent := f;
	b.SetBounds(300, 70, 75, 25);
	b.Caption := '&Вход';
	b.OnClick := @ButtonClick;


	labCaption2 := TLabel.Create(f);
	labCaption2.Name := 'labCaption2';
	labCaption2.Parent := f;
	labCaption2.SetBounds(10, 100, 275, 25);
	labCaption2.Caption := 'Если у вас нет имени и пароля, получите их по этому адресу:';

	edURL := TEdit.Create(f);
	edURL.Name := 'URL';
	edURL.Parent := f;
	edURL.SetBounds(10, 125, 370, 25);
	edURL.Text := 'https://www.kinopoisk.ru/level/30/';

	f.ShowModal;
	f.Free;
end;

//download posters from themoviesdb.org
procedure ParseTMDBPosters(all: String);
var
	url, s, s2: string;
	i, j, k, kol: integer;
begin
	if (MaxPostersCount<=0) or (tmdb_code='') or (all='-1') then begin
		PostersDownloading := False;
		exit;
	end;

	i:=pos('class="images posters', all);
	if i<=0 then begin
		PostersDownloading := False;
		exit;
	end;

	kol:=0;
	i:=pos('<a class="image" href="', all);
	while (i>0) and (kol<MaxPostersCount) do begin
		url:=GetStr(all, '<a class="image" href="', '"');
		//always use the first server
		//k := Pos('.', url);
		//delete(url, 1, k-1);
		//url := 'http://cf2' + url;
		SetImageName('', url, '', 4);
		kol:=kol+1;
		delete(all, 1, i);
		//delete(all, 1, j);
		i:=pos('<a class="image" href="', all);
	end;
	PostersDownloading := False;
end;


procedure ParseTMDBBackdrops(all: String);
var
	url, s, s2: string;
	i, j, k, kol: integer;
begin
	if MaxBackdropsCount<=0 then begin
		BackdropsDownloading := False;
		exit;
	end;

	if tmdb_code='' then
		exit;
	if all='-1' then
		exit;
	i:=pos('class="images backdrops', all);
	if i<=0 then begin
		BackdropsDownloading := False;
		exit;
	end;

	kol:=0;
	i:=pos('<a class="image" href="', all);
	while (i>0) and (kol<MaxBackdropsCount) do begin
		url := GetStr(all, '<a class="image" href="', '"');
		//url := GetStr(s, ' href="', '"');
		//always download from the first server
		//k := Pos('.', url);
		//delete(url, 1, k-1);
		//url := 'http://cf2' + url;
		SetImageName('', url, '', 7);
		kol:=kol+1;
		delete(all, 1, i);
		i:=pos('<a class="image" href="', all);
	end;
	BackdropsDownloading := False;
end;

procedure OnITDBLoaded(AContent: string);
var
	url, all, s, s2, nocaps, movie_link, temp, movie_year, movie_title, temp_code: string;
	i, j, k, kol, year_int: integer;
	found: Boolean;
begin
	all := AContent;
	if (all='-1') or (pos('Nothing found', all)>0) then begin
		if (UseTMDBPosters = 1) then
			PostersDownloading := False;
		if (UseTMDBSnapshots = 1) then
			BackdropsDownloading := False;
		exit;
	end;

	if (tmdb_code = '') then begin
		//загрузилась страница фильма
		if pos('search_results movie', all)=0 then begin
		  s2:='<link rel="canonical" href="http://www.themoviedb.org/movie/';
		  i:=pos(s2, all);
		  if i>0 then begin
			j:=MyPos('"', all, i+length(s2));
			if j>0 then
			  tmdb_code:=copy(all, i+length(s2), j-i-length(s2));
		  end;
		end;
		i := Pos('<div class="search_results', all);
		if i > 0 then begin
			delete(all, 1, i);
			found := False;
			year_int := 0;
			try
				year_int := StrToInt(year);
			except
			end;
			i := Pos('<div class="item', all);
			while (i > 0) and (not found) do begin
				temp := GetStr(all, '<div class="item', ' class="view_more"');
				delete(all, 1, i);
				movie_title := GetStr(temp, '<a id="movie', '</a>');
				temp_code := GetStr(movie_title, '_', '"');
				if movie_title <> '' then
					movie_title := ClearExtraBlankCharacters(DecodeHTML(GetStr(movie_title, 'title="', '"')));
				s := GetStr(temp, '<span>', '</span>'#10);
				s := ClearExtraBlankCharacters(s);
				movie_year := ParseString(s, '(\d+)$', 1);
				if length(movie_year) < 4 then
					movie_year := ParseString(s, '^(\d+)', 1);
				if (LowerCase(movie_title) = LowerCase(original_title)) and ((movie_year = year) or (movie_year = IntToStr(year_int - 1)) or (movie_year = IntToStr(year_int + 1))) then begin
					found := True;
					tmdb_code := temp_code;
				end;
				i := Pos('<div class="item', all);
			end;
		end;
	end;
	if tmdb_code='' then begin
		if (UseTMDBPosters = 1) then
			PostersDownloading := False;
		if (UseTMDBSnapshots = 1) then
			BackdropsDownloading := False;
		exit;
	end;
	if (UseTMDBPosters = 1) then begin
		url:=format('https://www.themoviedb.org/movie/%s/images/posters', [tmdb_code]);
		AddRequestForHTMLPageContent(url, False, '', 'ParseTMDBPosters');
	end;
	if (UseTMDBSnapshots = 1) then begin
		url:=format('https://www.themoviedb.org/movie/%s/images/backdrops', [tmdb_code]);
		AddRequestForHTMLPageContent(url, False, '', 'ParseTMDBBackdrops');
	end;
end;

//search for the title and grab the first search result
//returns the tvdb code of the first search result
function SearchTVDB(tv_name: String; lang: Integer; tv_year: String = ''): string;
var
	i, j: Integer;
	s, url, all: String;
begin
	Result := '-1';
	if (tv_name <> '') then begin
		url := format('http://www.thetvdb.com/index.php?seriesname=%s&fieldlocation=1&language=%d&genre=&year=%s&network=&zap2it_id=&tvcom_id=&imdb_id=&order=translation&searching=Search&tab=advancedsearch', [EncodeURL(tv_name, 'utf-8'), lang, tv_year]);
		url:=ReplaceStr(url, ' ', '+', -1);
	  // all := DownloadURL(url);
	  AddRequestForHTMLPageContent(url, False);
	  All := GetHTMLPageContentFromRequest(url); 
	  //all := GetHTMLPageContentFromRequest(url);
		if (all<>'-1') and (Pos('No series found', all)=0) then
	  begin
		if (tvdb_code = '') then
		begin
		  tvdb_code := '';
		  i := Pos('<h1>Results', all);
		  if i>0 then begin
			j := MyPos('</table>', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('<a href="/index.php?tab=series&amp;id=', s);
			if i>0 then begin
			  j := MyPos('&amp;lid', s, i+38);
			  tvdb_code := copy(s, i+38, j-i-38);
			  tvdb_code := ClearExtraBlankCharacters(tvdb_code);
			end;
		  end;
		end;
			result := tvdb_code;
		end
		else
			result := '-1';
	end;
end;

procedure OnTVDBMainPageLoaded(AContent: string);
var
	i, j: Integer;
	s, url, all, temp: String;
	found: boolean;
begin
  all := AContent;
  tvdb_code := '';
  found := false;
	if (all<>'-1') and (Pos('No series found', all)=0) then begin
		i := Pos('<h2>Search Results', all);
		if i>0 then begin
			j := MyPos('</table>', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('<tr>', s);
			while (i > 0) and (not found) do begin
				temp := GetStr(s, '<tr>', '</tr>');
				if (Pos(title, temp) > 0) then begin
					tvdb_code := GetStr(temp, '<a href="', '"');
					found := true;
				end;
				delete(s, 1, i);
				i := Pos('<tr>', s);
			end;
		end;
		//if (tvdb_code = '-1') or (tvdb_code = '') then 
			//tvdb_code := SearchTVDB(title, 7);
		if (tvdb_code <> '-1') and (tvdb_code <> '') then begin
			if (DownloadTVDBEpisodes=1) then begin
				url := 'https://www.thetvdb.com' + tvdb_code;
				AddRequestForHTMLPageContent(url, False, '', 'OnTVDBHomePageLoaded');
			end
			else
				EpisodesDownloading := False;
			if (UseTVDBPosters=1) then begin
				url := 'https://www.thetvdb.com' + tvdb_code + '/artwork/poster';
				AddRequestForHTMLPageContent(url, False, '', 'ParseTVDBPosters');
			end;
			if (UseTVDBFanart=1) then begin
				url := 'https://www.thetvdb.com' + tvdb_code + '/artwork/fanart';
				AddRequestForHTMLPageContent(url, False, '', 'ParseTVDBFanart');
			end;
		end
		else begin
			if (DownloadTVDBEpisodes = 1) then
				EpisodesDownloading := False;
			if (UseTVDBPosters = 1) then
				PostersDownloading := False;
			if (UseTVDBFanart = 1) then
				BackdropsDownloading := False;
			TVDBNothingFound := True;
		end;
	end;
	TVDBSearchEnded := True;
end;

procedure OnTVDBHomePageLoaded(AContent: string);
var
	i, j, seasonNr: Integer;
	temp, s, s2, marker, url: String;
begin
	marker := '<h2>Seasons</h2>';
	i := Pos(marker, AContent);
	if (i > 0) then begin
		temp := GetStr(AContent, marker, '</ul>');
		i := Pos('<li', temp);
		while i > 0 do begin
			seasonNr := 0;
			s := GetStr(temp, ' href="/series/', '"');
			s := ParseString(s, 'seasons/(\d+)', 1);
			if s <> '' then begin
				try
					seasonNr := StrToInt(s);
				except
				end;
			end;
			if (seasonNr > 0) then begin
				url := 'https://www.thetvdb.com' + tvdb_code + '/seasons/' + IntToStr(seasonNr);
				SeasonURLs.add(url);
				AddRequestForHTMLPageContent(url, False, '', 'ParseTVDBSeasonPage');
			end;
			delete(temp, 1, i);
			i := Pos('<li', temp);
		end;
	end;
end;

procedure ParseTVDBSeasonPage(AContent: string);
var
	i, j, k, l, season, episode, episodes_count, special_episode: Integer;
	s, s2, s3, s4, url, all, EpisodeTitle, AirDate, EpisodeDescription, EpisodeIMDB, year, month, day, NotConvertedTitle, SeasonImage, EpisodeImage, season_id, series_id, episode_id, last_season_id, temp: String;
begin
	episodes_count := 0;
	EpisodeIMDB := '';
	EpisodeDescription := '';
	if (tvdb_code <> '-1') and (tvdb_code <> '') then begin
		season := -1;
		s := GetStr(AContent, '<h2', '</h2>');
		if (s <> '') then
			s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s)));
		s2 := ParseString(s, '(\d+)$', 1);
		if (s2 <> '') then begin
			try
				season := StrToInt(s2);
			except
			end;
		end;
		if (season >= 0) then begin
			
			// download season covers
			if (DownloadSeasonsCovers) and (not ExistSeasonImage(season)) then begin
				i := Pos('<h2>Posters</h2>', AContent);
				s := 'https://www.thetvdb.com/banners/seasons/';
				if (i > 0) then begin
					temp := GetStr(AContent, s, '.jpg');
					if (temp <> '') then begin
						SeasonImage := s + temp + '.jpg';
						SetImageName('', SeasonImage, '', 9, False, '', season, 0);
					end;
				end;
			end;
			
			// download episode names
			episodes_count := 0;
			temp := GetStr(AContent, '<tbody>', '</tbody>');
			i := Pos('<tr>', temp);
			while i > 0 do begin
				episode := -1;
				EpisodeDescription := '';
				EpisodeIMDB := '';
				s := GetStr(temp, '<tr>', '</tr>');
				
				// Episode number and ID
				s2 := GetStr(s, '<td>', '</td>');
				url := GetStr(s2, 'href="', '"');
				if (url <> '') then
					url := 'https://www.thetvdb.com' + url;
				episode_id := ParseString(s2, '/episodes/(\d+)', 1);
				s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
				s3 := ParseString(s3, '(\d+)', 1);
				if (s3 <> '') then begin
					try
						episode := StrToInt(s3);
					except
					end;
				end;
				delete(s, 1, Pos('</td>', s));
				
				// Episode title
				s2 := GetStr(s, '<td>', '</td>');
				EpisodeTitle := GetStr(s2, 'data-language="ru"', '</');
				if (EpisodeTitle <> '') then begin
					EpisodeTitle := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + EpisodeTitle)));
				end;
				delete(s, 1, Pos('</td>', s));
				
				// Episode air date
				s2 := GetStr(s, '<td>', '</td>');
				AirDate := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
				delete(s, 1, Pos('</td>', s));
				
				// Episode cover
				s2 := GetStr(s, '<td>', '</td>');
				EpisodeImage := GetStr(s2, ' href="', '"');
				if (EpisodeImage <> '') and (DownloadEpisodesCovers) and (not ExistEpisodeImage(season, episode)) then begin
					SetImageName('', EpisodeImage, '', 10, False, '', season, episode);
				end;
				
				// download episode descriptions
				if DownloadMovieSeasonsList and (DownloadTVDBEpisodeDescriptions = 1) then begin
					AddRequestForHTMLPageContent(url, False, '', 'GetTVDBEpisodeDescription');
					EpisodeURLs.Add(url);
					episodes_count := episodes_count + 1;
				end
				// or save information about the episode
				else begin
					episodes_count := episodes_count + 1;
					SetEpisode(season, episode, EpisodeTitle, EpisodeDescription, EpisodeIMDB, AirDate);
				end;
				delete(temp, 1, i);
				i := Pos('<tr>', temp);
			end;
		end;
	end;
	EpisodesDownloading := False;
end;

//download page with episode description and extract the description
procedure GetTVDBEpisodeDescription(all: string);
var
	i, j, k : Integer;
	s, s2, s3, desc: String;
	not_done: boolean;
	EpisodeTitle, EpisodeDescription, AirDate, day, month, year: String;
	season, episode: Integer;
begin
	desc := '';
	if all<>'-1' then begin
		s := GetStr(all, 'id="translations"', 'class="footer"');
		AirDate := '';
		
		// season number
		season := 0;
		s3 := ParseString(all, '/seasons/(\d+)', 1);
		if (s3 <> '') then
			try
				season := StrToInt(s3);
			except
			end;
		episode := 0;
		
		// episode title and description
		EpisodeDescription := GetStr(s, 'data-language="ru"', '</p>');
		EpisodeTitle := GetStr(EpisodeDescription, 'data-title="', '"');
		EpisodeTitle := DecodeHTML(EpisodeTitle);
		if (EpisodeDescription <> '') then
			EpisodeDescription := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + EpisodeDescription)));
		
		// episode number
		s3 := GetStr(s, 'Episode Number</strong>', '</li');
		s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s3)));
		s3 := ParseString(s3, '(\d+)', 1);
		if (s3 <> '') then
			try
				episode := StrToInt(s3);
			except
			end;
			
		// air date
		s3 := GetStr(s, 'Originally Aired</strong>', '</li');
		s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s3)));
		if s3 <> '' then begin
			i := Pos(',', s3);
			delete(s3, 1, i + 1);
			month := ParseString(s3, '^(.*?) \d+,', 1);
			day := ParseString(s3, '(\d+),', 1);
			year := ParseString(s3, '(\d+)$', 1);
			k := 1;
            while (k <= 12) and (Pos(month, monthes[k]) = 0) do
				k := k + 1;
			if (k <= 12) and (month <> '') then
				AirDate := IntToStr(k) + format('/%s/%s', [day, year]);
		end;
		if (season > 0) and (episode > 0) then begin
			SetEpisode(season, episode, EpisodeTitle, EpisodeDescription, '', AirDate);			
		end;
	end;
end;


procedure ParseTVDBPosters(all: String);
var
	i, j, posters_count: Integer;
	s, poster_code, poster_url, url: String;
begin
	posters_count := 0;
	if all <> '-1' then begin
		i := Pos('Poster', all);
		if i>0 then begin
			j := MyPos('class="footer">', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('banners/posters/', s);
			while (i>0) and (posters_count < MaxPostersCount) do begin
				posters_count := posters_count + 1;
				j := MyPos('.jpg"', s, i+1);
				poster_code := copy(s, i+16, j-i-16);
				poster_url := 'http://www.thetvdb.com/banners/posters/'+poster_code+'.jpg';
				SetImageName('', poster_url, '', 4);
				delete(s, 1, j);
				i := Pos('banners/posters/', s);
			end;
		end;
	end;
	PostersDownloading := False;
end;

procedure ParseTVDBFanart(all: String);
var
	i, j, posters_count: Integer;
	s, poster_code, poster_url, url: String;
begin
	posters_count := 0;
	if all <> '-1' then begin
		i := Pos('Fanart', all);
		if i>0 then begin
			j := MyPos('class="footer">', all, i+1);
			s := copy(all, i, j-i);
			i := Pos('banners/fanart/', s);
			while (i>0) and (posters_count < MaxPostersCount) do begin
				posters_count := posters_count + 1;
				j := MyPos('.jpg"', s, i+1);
				poster_code := copy(s, i+15, j-i-15);
				poster_url := 'http://www.thetvdb.com/banners/fanart/'+poster_code+'.jpg';
				SetImageName('', poster_url, '', 7);
				delete(s, 1, j);
				i := Pos('banners/fanart/', s);
			end;
		end;
	end;
	BackdropsDownloading := False;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(s1, str);
	if I > 0 then
	begin
		J := MyPos(s2, str, I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

//show available settings for the script
function ShowScriptOptions: integer;
var
	s: string;
	f: TForm;
	b: TButton;
	cbUseTmdbPosters, cbUseTmdbSnapshots, cbDownloadTvdbEpisodes, cbDownloadTvdbEpisodeDesc, cbTvdbEnglishDesc, cbNoSmallCover, cbNoAmazon, cbUseTvdbPosters, cbUseTvdbFanart, cbKinopoiskBigCover, cbNoVideosInSeries, cbDlBiggerPhoto, cbDlErrors, cbDlUnknownEpisodes, cbParseTitles: TCheckBox;
	TMDBGroup, TVDBGroup, gbDlOptions: TGroupBox;
	AmazonGroup: TGroupBox;
	rbNoAmazonIfKinopoiskBigCover, rbAlwaysAmazon, rbNeverAmazon: TRadioButton;
	cbDlOriginalTitle, cbDlDuration, cbDlYear, cbDlGenres, cbDlCountries, cbDlStudios, cbDlType, cbDlAwards, cbDlEpisodes, cbDlDirectors, cbDlActors, cbDlWriters, cbDlComposers, cbDlProducers, cbDlCameraman, cbDlTitle, cbDlTrivia: TCheckBox;
	my_value: integer;
	edFormat: TEdit;
	labParse: TLabel;
	posx, posy: Integer;
	
procedure EpisodeTitlesClick(Sender: TCheckBox);
begin
	if cbDownloadTvdbEpisodes.Checked then begin
		cbDownloadTvdbEpisodeDesc.Enabled := True;
		cbTvdbEnglishDesc.Enabled := True;
	end
	else begin
		cbDownloadTvdbEpisodeDesc.Enabled := False;
		cbTvdbEnglishDesc.Enabled := False;
	end;	
end;

procedure AmazonClick(Sender: TRadioButton);
begin
	if rbNeverAmazon.Checked then begin
		cbNoSmallCover.Enabled := False;
		cbNoSmallCover.Checked := False;
	end
	else begin
		cbNoSmallCover.Enabled := True;
	end;
end;

procedure ParseClick(Sender: TCheckBox);
begin
	if cbParseTitles.Checked then
		edFormat.Enabled := True
	else
		edFormat.Enabled := False;
end;


procedure ButtonClick(Sender: TButton);
var
	zn: integer;
begin
	try
		if cbUseTmdbPosters.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskUseTmdbPosters', zn);	
		if cbUseTmdbSnapshots.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskUseTmdbBackdrops', zn);
		if cbDownloadTvdbEpisodes.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskTVDBEpisodes', zn);
		if cbDownloadTvdbEpisodeDesc.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskTVDBDescriptions', zn);	
		if cbTvdbEnglishDesc.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskTVDBEngDesc', zn);
		if cbNoSmallCover.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskNoSmallCover', zn);
		if cbKinopoiskBigCover.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskBigCover', zn);
		if cbUseTvdbPosters.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskTVDBPosters', zn);
		if cbUseTvdbFanart.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskTVDBFanart', zn);
		if rbAlwaysAmazon.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskAlwaysAmazon', zn);
		if rbNeverAmazon.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskNeverAmazon', zn);
		if rbNoAmazonIfKinopoiskBigCover.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskNoAmazonIfBigCoverAvailable', zn);
		if cbDlType.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskDlType', zn);
		if cbNoVideosInSeries.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskNoVideosInSeries', zn);
		if cbDlBiggerPhoto.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskDlBiggerPhoto', zn);
		if cbDlErrors.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskDlErrors', zn);
		if cbDlUnknownEpisodes.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskDlUnknown', zn);
		if cbParseTitles.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinopoiskParseTitles', zn);
		RegWriteString('KinopoiskParseFormat', edFormat.Text);
		RegWriteInteger('KinopoiskDlOriginalTitle' , BoolToInt(cbDlOriginalTitle.Checked));
		RegWriteInteger('KinopoiskDlYear'          , BoolToInt(cbDlYear.Checked));
		RegWriteInteger('KinopoiskDlGenres'        , BoolToInt(cbDlGenres.Checked));
		RegWriteInteger('KinopoiskDlCountries'     , BoolToInt(cbDlCountries.Checked));
		RegWriteInteger('KinopoiskDlDuration'      , BoolToInt(cbDlDuration.Checked));
		RegWriteInteger('KinopoiskDlStudios'       , BoolToInt(cbDlStudios.Checked));
		RegWriteInteger('KinopoiskDlType'          , BoolToInt(cbDlType.Checked));
		RegWriteInteger('KinopoiskDlEpisodes'      , BoolToInt(cbDlEpisodes.Checked));
		RegWriteInteger('KinopoiskDlDirectors'     , BoolToInt(cbDlDirectors.Checked));
		RegWriteInteger('KinopoiskDlActors'        , BoolToInt(cbDlActors.Checked));
		RegWriteInteger('KinopoiskDlWriters'       , BoolToInt(cbDlWriters.Checked));
		RegWriteInteger('KinopoiskDlComposers'     , BoolToInt(cbDlComposers.Checked));
		RegWriteInteger('KinopoiskDlProducers'     , BoolToInt(cbDlProducers.Checked));
		RegWriteInteger('KinopoiskDlCameraman'     , BoolToInt(cbDlCameraman.Checked));
		RegWriteInteger('KinopoiskDlAwards'        , BoolToInt(cbDlAwards.Checked));
		RegWriteInteger('KinopoiskDlTitle'         , BoolToInt(cbDlTitle.Checked));
		RegWriteInteger('KinopoiskDlTrivia'        , BoolToInt(cbDlTrivia.Checked));
	except
	end;

	f.ModalResult := mrOk;
end;

begin
	result:=0;
	f := TForm.Create(nil);
	f.Caption := GetLangStr(1924);
	f.BorderStyle := bsDialog;
	f.Position := poScreenCenter;
	f.Width:=600;
	f.Height:=500;
	f.AutoSize:=false;

	TMDBGroup := TGroupBox.Create(f);
	TMDBGroup.Name := 'TMDBGroup';
	TMDBGroup.Parent := f;
	TMDBGroup.SetBounds(10, 10, 390, 40);
	TMDBGroup.Caption := 'Для фильмов скачивать с themoviedb, а не с Кинопоиска:';
	s := GetLangStr(7022);
	if s <> '' then
		TMDBGroup.Caption := s;
	
	cbUseTmdbPosters := TCheckBox.Create(f);
	cbUseTmdbPosters.Name := 'cbUseTmdbPosters';
	cbUseTmdbPosters.Parent := f;
	cbUseTmdbPosters.SetBounds(20, 25, 100, 20);
	cbUseTmdbPosters.Caption := GetLangStr(1425);
	my_value := RegReadInteger('KinopoiskUseTmdbPosters', DL_TMDB_POSTERS);
	if my_value=1 then
		cbUseTmdbPosters.Checked := True;

	cbUseTmdbSnapshots := TCheckBox.Create(f);
	cbUseTmdbSnapshots.Name := 'cbUseTmdbSnapshots';
	cbUseTmdbSnapshots.Parent := f;
	cbUseTmdbSnapshots.SetBounds(120, 25, 100, 20);
	cbUseTmdbSnapshots.Caption := 'Обои';
	s := GetLangStr(3215);
	if s <> '' then
		cbUseTmdbSnapshots.Caption := s;
	my_value := RegReadInteger('KinopoiskUseTmdbBackdrops', DL_TMDB_BACKDROPS);
	if my_value=1 then
		cbUseTmdbSnapshots.Checked := True;
		
	TVDBGroup := TGroupBox.Create(f);
	TVDBGroup.Name := 'TVDBGroup';
	TVDBGroup.Parent := f;
	TVDBGroup.SetBounds(10, 60, 390, 90);
	TVDBGroup.Caption := 'Для сериалов скачивать с thetvdb, а не с Кинопоиска:';
	s := GetLangStr(7023);
	if s <> '' then
		TVDBGroup.Caption := s;
		
	cbDownloadTvdbEpisodes := TCheckBox.Create(f);
	cbDownloadTvdbEpisodes.Name := 'cbDownloadTvdbEpisodes';
	cbDownloadTvdbEpisodes.Parent := f;
	cbDownloadTvdbEpisodes.SetBounds(20, 75, 150, 20);
	cbDownloadTvdbEpisodes.Caption := 'Названия эпизодов';
	s := GetLangStr(7024);
	if s <> '' then
		cbDownloadTvdbEpisodes.Caption := s;
	my_value := RegReadInteger('KinopoiskTVDBEpisodes', DL_TVDB_EPISODES);
	if my_value=1 then
		cbDownloadTvdbEpisodes.Checked := True;
		
	cbDownloadTvdbEpisodeDesc := TCheckBox.Create(f);
	cbDownloadTvdbEpisodeDesc.Name := 'cbDownloadTvdbEpisodeDesc';
	cbDownloadTvdbEpisodeDesc.Parent := f;
	cbDownloadTvdbEpisodeDesc.SetBounds(30, 95, 150, 20);
	cbDownloadTvdbEpisodeDesc.Caption := 'Описания эпизодов';
	s := GetLangStr(7025);
	if s <> '' then
		cbDownloadTvdbEpisodeDesc.Caption := s;
	my_value := RegReadInteger('KinopoiskTVDBDescriptions', DL_TVDB_DESCRIPTIONS);
	if my_value=1 then
		cbDownloadTvdbEpisodeDesc.Checked := True;
		
	cbTvdbEnglishDesc := TCheckBox.Create(f);
	cbTvdbEnglishDesc.Name := 'cbTvdbEnglishDesc';
	cbTvdbEnglishDesc.Parent := f;
	cbTvdbEnglishDesc.SetBounds(30, 115, 350, 20);
	cbTvdbEnglishDesc.Caption := 'Описания на английском, если нет русских';
	s := GetLangStr(7026);
	if s <> '' then
		cbTvdbEnglishDesc.Caption := s;
	my_value := RegReadInteger('KinopoiskTVDBEngDesc', DL_TVDB_ENG_DESC);
	if my_value=1 then
		cbTvdbEnglishDesc.Checked := True;
		
	cbUseTvdbPosters := TCheckBox.Create(f);
	cbUseTvdbPosters.Name := 'cbUseTvdbPosters';
	cbUseTvdbPosters.Parent := f;
	cbUseTvdbPosters.SetBounds(290, 75, 100, 20);
	cbUseTvdbPosters.Caption := GetLangStr(1425);
	my_value := RegReadInteger('KinopoiskTVDBPosters', DL_TVDB_POSTERS);
	if my_value=1 then
		cbUseTvdbPosters.Checked := True;
		
	cbUseTvdbFanart := TCheckBox.Create(f);
	cbUseTvdbFanart.Name := 'cbUseTvdbFanart';
	cbUseTvdbFanart.Parent := f;
	cbUseTvdbFanart.SetBounds(290, 95, 100, 20);
	cbUseTvdbFanart.Caption := 'Обои';
	s := GetLangStr(3215);
	if s <> '' then
		cbUseTvdbFanart.Caption := s;
	my_value := RegReadInteger('KinopoiskTVDBFanart', DL_TVDB_FANART);
	if my_value=1 then
		cbUseTvdbFanart.Checked := True;
		
	cbKinopoiskBigCover := TCheckBox.Create(f);
	cbKinopoiskBigCover.Name := 'cbKinopoiskBigCover';
	cbKinopoiskBigCover.Parent := f;
	cbKinopoiskBigCover.SetBounds(10, 155, 380, 20);
	cbKinopoiskBigCover.Caption := 'Загружать большую обложку с Кинопоиска, если она есть';
	s := GetLangStr(7027);
	if s <> '' then
		cbKinopoiskBigCover.Caption := s;
	my_value := RegReadInteger('KinopoiskBigCover', DL_BIG_KINOPOISK_COVER);
	if my_value=1 then
		cbKinopoiskBigCover.Checked := True;
		
	AmazonGroup := TGroupBox.Create(f);
	AmazonGroup.Name := 'AmazonGroup';
	AmazonGroup.Parent := f;
	AmazonGroup.SetBounds(10, 175, 390, 80);
	AmazonGroup.Caption := 'Загружать обложку с Амазона';
	s := GetLangStr(7028);
	if s <> '' then
		AmazonGroup.Caption := s;
	
	rbAlwaysAmazon := TRadioButton.Create(f);
	rbAlwaysAmazon.Name := 'rbAlwaysAmazon';
	rbAlwaysAmazon.Parent := f;
	rbAlwaysAmazon.SetBounds(20, 190, 350, 20);
	rbAlwaysAmazon.Caption := 'Всегда';
	s := GetLangStr(7029);
	if s <> '' then
		rbAlwaysAmazon.Caption := s;
	my_value := RegReadInteger('KinopoiskAlwaysAmazon', ALWAYS_USE_AMAZON);
	if my_value=1 then
		rbAlwaysAmazon.Checked := True;
	
	rbNoAmazonIfKinopoiskBigCover := TRadioButton.Create(f);
	rbNoAmazonIfKinopoiskBigCover.Name := 'rbNoAmazonIfKinopoiskBigCover';
	rbNoAmazonIfKinopoiskBigCover.Parent := f;
	rbNoAmazonIfKinopoiskBigCover.SetBounds(20, 210, 350, 20);
	rbNoAmazonIfKinopoiskBigCover.Caption := 'Только если большая не загружена с Кинопоиска';
	s := GetLangStr(7030);
	if s <> '' then
		rbNoAmazonIfKinopoiskBigCover.Caption := s;
	my_value := RegReadInteger('KinopoiskNoAmazonIfBigCoverAvailable', NO_AMAZON_COVER_IF_BIG_AVAILABLE);
	if my_value=1 then
		rbNoAmazonIfKinopoiskBigCover.Checked := True;
	
	rbNeverAmazon := TRadioButton.Create(f);
	rbNeverAmazon.Name := 'rbNeverAmazon';
	rbNeverAmazon.Parent := f;
	rbNeverAmazon.SetBounds(20, 230, 350, 20);
	rbNeverAmazon.Caption := 'Никогда';
	s := GetLangStr(7031);
	if s <> '' then
		rbNeverAmazon.Caption := s;
	my_value := RegReadInteger('KinopoiskNeverAmazon', NEVER_USE_AMAZON);
	if my_value=1 then
		rbNeverAmazon.Checked := True;
	
		
	cbNoSmallCover := TCheckBox.Create(f);
	cbNoSmallCover.Name := 'cbNoSmallCover';
	cbNoSmallCover.Parent := f;
	cbNoSmallCover.SetBounds(20, 260, 380, 20);
	s := GetLangStr(1953);
	if s<>'' then
		cbNoSmallCover.Caption := s
	else
		cbNoSmallCover.Caption := 'Не загружать маленькую обложку, если найдена большая на Амазоне';
	my_value := RegReadInteger('KinopoiskNoSmallCover', NO_SMALL_COVER);
	if my_value=1 then
		cbNoSmallCover.Checked := True;
		
		
	(*cbDlType := TCheckBox.Create(f);
	cbDlType.Name := 'cbDlType';
	cbDlType.Parent := f;
	cbDlType.SetBounds(20, 280, 380, 20);
	cbDlType.Caption := 'Загружать тип фильма (сериал, ТВ и т.п.)';
	my_value := RegReadInteger('KinopoiskDlType', 1);
	if my_value = 1 then
		cbDlType.Checked := True;*)
		
	cbNoVideosInSeries := TCheckBox.Create(f);
	cbNoVideosInSeries.Name := 'cbNoVideosInSeries';
	cbNoVideosInSeries.Parent := f;
	cbNoVideosInSeries.SetBounds(20, 280, 380, 20);
	cbNoVideosInSeries.Caption := 'Не загружать фильмы типа "видео" для начала/продолжения серии';
	s := GetLangStr(7032);
	if s <> '' then
		cbNoVideosInSeries.Caption := s;
	my_value := RegReadInteger('KinopoiskNoVideosInSeries', 1);
	if my_value = 1 then
		cbNoVideosInSeries.Checked := True;
		
	cbDlBiggerPhoto := TCheckBox.Create(f);
	cbDlBiggerPhoto.Name := 'cbDlBiggerPhoto';
	cbDlBiggerPhoto.Parent := f;
	cbDlBiggerPhoto.SetBounds(20, 300, 380, 20);
	cbDlBiggerPhoto.Caption := 'Загружать большие фотографии';
	s := GetLangStr(7033);
	if s <> '' then
		cbDlBiggerPhoto.Caption := s;
	my_value := RegReadInteger('KinopoiskDlBiggerPhoto', 1);
	if my_value = 1 then
		cbDlBiggerPhoto.Checked := True;		

	rbNeverAmazon.OnClick := @AmazonClick;
	rbAlwaysAmazon.OnClick := @AmazonClick;
	rbNoAmazonIfKinopoiskBigCover.OnClick := @AmazonClick;
	AmazonClick(rbNeverAmazon);
	
	cbDlErrors := TCheckBox.Create(f);
	cbDlErrors.Name := 'cbDlErrors';
	cbDlErrors.Parent := f;
	cbDlErrors.SetBounds(20, 320, 380, 20);
	cbDlErrors.Caption := 'Загружать ошибки в фильме';
	s := GetLangStr(7034);
	if s <> '' then
		cbDlErrors.Caption := s;
	my_value := RegReadInteger('KinopoiskDlErrors', 0);
	if my_value = 1 then
		cbDlErrors.Checked := True;		
		
	cbDlUnknownEpisodes := TCheckBox.Create(f);
	cbDlUnknownEpisodes.Name := 'cbDlUnknownEpisodes';
	cbDlUnknownEpisodes.Parent := f;
	cbDlUnknownEpisodes.SetBounds(20, 340, 380, 20);
	cbDlUnknownEpisodes.Caption := 'Загружать информацию о дополнительных эпизодах';
	s := GetLangStr(7035);
	if s <> '' then
		cbDlUnknownEpisodes.Caption := s;
	my_value := RegReadInteger('KinopoiskDlUnknown', 1);
	if my_value = 1 then
		cbDlUnknownEpisodes.Checked := True;	
	
	cbParseTitles := TCheckBox.Create(f);
	cbParseTitles.Name := 'cbParseTitles';
	cbParseTitles.Parent := f;
	cbParseTitles.SetBounds(20, 360, 380, 20);
	cbParseTitles.Caption := 'Извлекать данные из названий, используя следующий формат';
	s := GetLangStr(7020);
	if s <> '' then
		cbParseTitles.Caption := s;
	my_value := RegReadInteger('KinopoiskParseTitles', 0);
	if my_value = 1 then
		cbParseTitles.Checked := True;
		
	edFormat := TEdit.Create(f);
	edFormat.Name := 'edFormat';
	edFormat.Parent := f;
	edFormat.SetBounds(20, 380, 380, 25);
	edFormat.Text := RegReadString('KinopoiskParseFormat', '%T');
	cbParseTitles.Onclick := @ParseClick;
	ParseClick(cbParseTitles);
	
	labParse := TLabel.Create(f);
	labParse.Name := 'labParse';
	labParse.Parent := f;
	labParse.SetBounds(20, 405, 380, 20);
	labParse.Caption := 'Подсказка: %Т - название фильма, %Y - год, %C - код фильма на сайте';
	s := GetLangStr(7021);
	if s <> '' then
		labParse.Caption := s;
	
	{-----------------}
	{--- Main Data ---}
	{-----------------}
	posx :=  410;
	posy := 10;

	gbDlOptions:=TGroupBox.Create(f);
	gbDlOptions.Name:='gbDlOptions';
	gbDlOptions.Parent:=f;
	gbDlOptions.SetBounds(posx, posy, 180, 30);
	if GetLangStr(2746) = '' 
		then gbDlOptions.Caption := ' Main Data '
	else gbDlOptions.Caption := ' ' + GetLangStr(2746) + ' ';
	gbDlOptions.Hint := gbDlOptions.Caption;
	posx := 10;
	posy := 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlOriginalTitle := TCheckBox.Create(f);
	cbDlOriginalTitle.Name := 'cbDlOriginalTitle';
	cbDlOriginalTitle.Parent := gbDlOptions;
	cbDlOriginalTitle.SetBounds(posx, posy, 140, 20);
	cbDlOriginalTitle.Caption := GetLangStr(167);
	cbDlOriginalTitle.Checked := IntToBool(RegReadInteger('KinopoiskDlOriginalTitle', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlDuration := TCheckBox.Create(f);
	cbDlDuration.Name := 'cbDlDuration';
	cbDlDuration.Parent := gbDlOptions;
	cbDlDuration.SetBounds(posx, posy, 140, 20);
	cbDlDuration.Caption := GetLangStr(147);
	cbDlDuration.Checked := IntToBool(RegReadInteger('KinopoiskDlDuration', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlYear := TCheckBox.Create(f);
	cbDlYear.Name := 'cbDlYear';
	cbDlYear.Parent := gbDlOptions;
	cbDlYear.SetBounds(posx, posy, 200, 20);
	cbDlYear.Caption := GetLangStr(169);
	cbDlYear.Checked := IntToBool(RegReadInteger('KinopoiskDlYear', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlGenres := TCheckBox.Create(f);
	cbDlGenres.Name := 'cbDlGenres';
	cbDlGenres.Parent := gbDlOptions;
	cbDlGenres.SetBounds(posx, posy, 200, 20);
	cbDlGenres.Caption := GetLangStr(179);
	cbDlGenres.Checked := IntToBool(RegReadInteger('KinopoiskDlGenres', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlCountries := TCheckBox.Create(f);
	cbDlCountries.Name := 'cbDlCountries';
	cbDlCountries.Parent := gbDlOptions;
	cbDlCountries.SetBounds(posx, posy, 200, 20);
	cbDlCountries.Caption := GetLangStr(180);
	cbDlCountries.Checked := IntToBool(RegReadInteger('KinopoiskDlCountries', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlStudios := TCheckBox.Create(f);
	cbDlStudios.Name := 'cbDlStudios';
	cbDlStudios.Parent := gbDlOptions;
	cbDlStudios.SetBounds(posx, posy, 200, 20);
	cbDlStudios.Caption := GetLangStr(493);
	cbDlStudios.Checked := IntToBool(RegReadInteger('KinopoiskDlStudios', 1));
	
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlType := TCheckBox.Create(f);
	cbDlType.Name := 'cbDlType';
	cbDlType.Parent := gbDlOptions;
	cbDlType.SetBounds(posx, posy, 200, 20);
	cbDlType.Caption := GetLangStr(173);
	cbDlType.Checked := IntToBool(RegReadInteger('KinopoiskDlType', 1));

	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlAwards := TCheckBox.Create(f);
	cbDlAwards.Name := 'cbDlAwards';
	cbDlAwards.Parent := gbDlOptions;
	cbDlAwards.SetBounds(posx, posy, 200, 20);
	cbDlAwards.Caption := GetLangStr(574);
	cbDlAwards.Checked := IntToBool(RegReadInteger('KinopoiskDlAwards', 1));	
	
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlEpisodes := TCheckBox.Create(f);
	cbDlEpisodes.Name := 'cbDlEpisodes';
	cbDlEpisodes.Parent := gbDlOptions;
	cbDlEpisodes.SetBounds(posx, posy, 200, 20);
	cbDlEpisodes.Caption := GetLangStr(525);
	cbDlEpisodes.Hint := GetLangStr(1285);
	cbDlEpisodes.Checked := IntToBool(RegReadInteger('KinopoiskDlEpisodes', 1));

	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlDirectors := TCheckBox.Create(f);
	cbDlDirectors.Name := 'cbDlDirectors';
	cbDlDirectors.Parent := gbDlOptions;
	cbDlDirectors.SetBounds(posx, posy, 200, 20);
	cbDlDirectors.Caption := GetLangStr(181);
	cbDlDirectors.Checked := IntToBool(RegReadInteger('KinopoiskDlDirectors', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlActors := TCheckBox.Create(f);
	cbDlActors.Name := 'cbDlActors';
	cbDlActors.Parent := gbDlOptions;
	cbDlActors.SetBounds(posx, posy, 200, 20);
	cbDlActors.Caption := GetLangStr(164);
	cbDlActors.Checked := IntToBool(RegReadInteger('KinopoiskDlActors', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlWriters := TCheckBox.Create(f);
	cbDlWriters.Name := 'cbDlWriters';
	cbDlWriters.Parent := gbDlOptions;
	cbDlWriters.SetBounds(posx, posy, 200, 20);
	cbDlWriters.Caption := GetLangStr(182);
	cbDlWriters.Checked := IntToBool(RegReadInteger('KinopoiskDlWriters', 1));
		
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlComposers := TCheckBox.Create(f);
	cbDlComposers.Name := 'cbDlComposers';
	cbDlComposers.Parent := gbDlOptions;
	cbDlComposers.SetBounds(posx, posy, 200, 20);
	cbDlComposers.Caption := GetLangStr(491);
	cbDlComposers.Checked := IntToBool(RegReadInteger('KinopoiskDlComposers', 1));
	
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlProducers := TCheckBox.Create(f);
	cbDlProducers.Name := 'cbDlProducers';
	cbDlProducers.Parent := gbDlOptions;
	cbDlProducers.SetBounds(posx, posy, 200, 20);
	cbDlProducers.Caption := GetLangStr(71);
	cbDlProducers.Checked := IntToBool(RegReadInteger('KinopoiskDlProducers', 1));
	
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlCameraman := TCheckBox.Create(f);
	cbDlCameraman.Name := 'cbDlCameraman';
	cbDlCameraman.Parent := gbDlOptions;
	cbDlCameraman.SetBounds(posx, posy, 200, 20);
	cbDlCameraman.Caption := GetLangStr(4576);
	cbDlCameraman.Checked := IntToBool(RegReadInteger('KinopoiskDlCameraman', 1));
		
	
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlTitle := TCheckBox.Create(f);
	cbDlTitle.Name := 'cbDlTitle';
	cbDlTitle.Parent := gbDlOptions;
	cbDlTitle.SetBounds(posx, posy, 200, 20);
	cbDlTitle.Caption := GetLangStr(48);
	cbDlTitle.Checked := IntToBool(RegReadInteger('KinopoiskDlTitle', 1));
	
	posy := posy + 20;
	gbDlOptions.Height := gbDlOptions.Height + 20;
	cbDlTrivia := TCheckBox.Create(f);
	cbDlTrivia.Name := 'cbDlTrivia';
	cbDlTrivia.Parent := gbDlOptions;
	cbDlTrivia.SetBounds(posx, posy, 200, 20);
	cbDlTrivia.Caption := 'Знаете ли вы...';
	s := GetLangStr(7039);
	if s <> '' then
		cbDlTrivia.Caption := s;
	cbDlTrivia.Checked := IntToBool(RegReadInteger('KinopoiskDlTrivia', 1));
	

	b := TButton.Create(f);
	b.Name := 'btnOK';
	b.Parent := f;
	b.SetBounds(260, 440, 80, 25);
	b.Caption := '&OK';
	b.OnClick := @ButtonClick;
	
	cbDownloadTvdbEpisodes.OnClick := @EpisodeTitlesClick;
	EpisodeTitlesClick(cbDownloadTvdbEpisodes);

	f.ShowModal;
	f.Free;
end;

function BoolToInt(b: boolean): integer;
begin
  if b then result:=1
  else result:=0;
end;

function IntToBool(intval: integer): boolean;
begin
  if intval < 1 then result := false
  else result := true;
end;

procedure SaveLog(s: string);
var
	fs: TFileStream;
begin
		try
			fs:=TFileStream.Create('c:\data.htm', fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
		except
		end;
end;

function RemoveSpacesInText(text: String): String;
var
	i: Integer;
begin
	i := Pos('  ', text);
	while i>0 do begin
		delete(text, i, 1);
		i := Pos('  ', text);
	end;
	result := text;
end;

function GetUserMoviesURLByUserID(AUserID: string; APageNumber: Integer = 1): string;
begin
  Result := '';
  if ((AUserID <> '') and
      (APageNumber >= 0)) then
  begin
    if (APageNumber = 0) then
      APageNumber := 1;
    Result := Format(USER_MOVIES_URL_TEMPLATE, [AUserID, APageNumber]);
  end;
end;

function ParseAndAddUserMovies(APageIndex: Integer; AContent: string;
  var WasCanceled: Boolean): integer;
var
  s: string;
  DateAddStr: string;
  MovieYear: string;
  MovieCode: string;
  MovieTitle: string;
  MovieOriginalTitle: string;
  UserRating: Double;
  MovieContent: string;
begin
  Result := 0;
  AContent := ParseTag(AContent, '<div class="profileFilmsList">', '');
  if (AContent <> '') then
  begin
    repeat
      MovieContent := ParseTagTakingIntoAccountNestingLevelWithCutting(
        AContent, '<div class="item', '<div', '</div>');
      if (MovieContent <> '') then
      begin
        MovieCode := ParseTag(MovieContent, '<a href="/film/', '/');
        if (MovieCode <> '') then
        begin
          MovieTitle := ParseTag(MovieContent, '<a href="/film/', '</div>');
          MovieTitle := ParseTag(MovieTitle, '">', '</a>');
          MovieTitle := DecodeHTML(MovieTitle);
          MovieTitle := ReverseString(MovieTitle);
          MovieYear := Trim(ReverseString(ParseTagWithCutting(MovieTitle, ')', '(')));
          if (Pos('сериал, ', MovieYear) > 0) then
            MovieYear := ParseTag(MovieYear, 'сериал, ', ' ');
          DateAddStr := ParseTag(MovieContent, '<div class="date">', '</div>');
          DateAddStr := ReplaceStr(DateAddStr, ',', '', -1);
          MovieTitle := ReverseString(Trim(MovieTitle));
          MovieOriginalTitle := ParseTag(MovieContent, '<div class="nameEng">', '</div>');
          MovieOriginalTitle := DecodeHTML(MovieOriginalTitle);
          S := ParseTag(MovieContent, '<div class="vote" >', '</div>');
          if (not TryStrToFloat(S, UserRating)) then
            UserRating := 0;
          SetUserMovie(APageIndex, MovieCode, MovieTitle, MovieOriginalTitle,
            MovieYear, UserRating, DateAddStr, WasCanceled);
          if (WasCanceled) then
            Break;
          Inc(Result);
        end;
      end;
    until (MovieContent = '');
  end;
end;

function ParseUserMoviesCount(AContent: string; var AMoviesCount: Integer;
  var APagesCount: Integer): Boolean;
var
  s: string;
begin
  Result := False;
  APagesCount := 0;
  AMoviesCount := 0;  
  if (AContent <> '') then
  begin
    // Parse and calculate Total Movies/Total Pages count
    s := ParseTag(AContent, '<div class="pagesFromTo', '</div>');
    s := ParseTag(s, 'из ', '');
    Result := TryStrToInt(s, AMoviesCount);
    if (Result) then
    begin
      APagesCount := (AMoviesCount div USER_MOVIES_PER_PAGE);
      if ((AMoviesCount mod USER_MOVIES_PER_PAGE) > 0) then
        Inc(APagesCount);
      SetUserMoviesCount(AMoviesCount, APagesCount);
    end;
  end;
end;

// AMode - reserved
function GetUserMoviesByID(AUserID: string; AMode: Integer = 0): Integer;
var
  URL: string;
  Content: string;
  PageIndex: Integer;
  TotalPagesCount: Integer;
  TotalMoviesCount: Integer;
  WasCanceled: Boolean;
begin
  Result := 0;
  if (AUserID <> '') then
  begin
    PageIndex := 1;
    TotalPagesCount := 0;
    TotalMoviesCount := 0;
    repeat
      URL := GetUserMoviesURLByUserID(AUserID, PageIndex);
      Content := DownloadURL(URL, True, RequestParameters);
      if (Content <> '') then
      begin        
        // Parse user movies count (and pages for paraing)
        if ((TotalMoviesCount = 0) and
            (not ParseUserMoviesCount(Content, TotalMoviesCount, TotalPagesCount))) then
        begin
          Break;
        end;
        Result := Result + ParseAndAddUserMovies(PageIndex, Content, WasCanceled);
        if (WasCanceled) then
          Break;
        Inc(PageIndex);
      end;
    until ((Content = '') or
           (PageIndex > TotalPagesCount));
  end;
end;

begin
	DownloadMovieBigCover:=true;
	DownloadMovieShortCast:=true;
	DownloadMovieBigDescription:=true;
	DownloadMovieComments:=true;
	DownloadMovieStudios:=true;
	DownloadMovieAwards:=true;
	DownloadMovieEarnings:=true;
	DownloadMovieAdditionalInfo:=true;
	DownloadMovieSeasonsList:=true;
	MaxShotsCount:=3;
	MaxPostersCount:=0;

	monthes[1]:='января';
	monthes[2]:='февраля';
	monthes[3]:='марта';
	monthes[4]:='апреля';
	monthes[5]:='мая';
	monthes[6]:='июня';
	monthes[7]:='июля';
	monthes[8]:='августа';
	monthes[9]:='сентября';
	monthes[10]:='октября';
	monthes[11]:='ноября';
	monthes[12]:='декабря';


	prefixes[1]:='The';
	prefixes[2]:='A';
	prefixes[3]:='An';
	prefixes[4]:='La';
	prefixes[5]:='Les';
	prefixes[6]:='Des';
	prefixes[7]:='L''';
	prefixes[8]:='Un';
	prefixes[9]:='El';
	prefixes[10]:='Il';
	prefixes[11]:='Le';
	prefixes[12]:='Uno';

	//download posters and backdrops from themoviesdb.org
	tmdb_code:='';
	UseTMDBPosters:=RegReadInteger('KinopoiskUseTmdbPosters', DL_TMDB_POSTERS);
	UseTMDBSnapshots:=RegReadInteger('KinopoiskUseTmdbBackdrops', DL_TMDB_BACKDROPS);
	DownloadTVDBEpisodeDescriptions:=RegReadInteger('KinopoiskTVDBDescriptions', DL_TVDB_DESCRIPTIONS);
	DownloadTVDBEpisodes:=RegReadInteger('KinopoiskTVDBEpisodes', DL_TVDB_EPISODES);
	DownloadTVDBEnglishDesc:=RegReadInteger('KinopoiskTVDBEngDesc', DL_TVDB_ENG_DESC);
	UseTVDBPosters:=RegReadInteger('KinopoiskTVDBPosters', DL_TVDB_POSTERS);
	UseTVDBFanart:=RegReadInteger('KinopoiskTVDBFanart', DL_TVDB_FANART);
	flUseTMDB:=false;
	NoVideosInSeries := RegReadInteger('KinopoiskNoVideosInSeries', 1) = 1;


	AgentIndex := 1;
  BasicAgent := 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko';
	//SiteLogin;
  RequestParameters := TStringList.Create();
  RequestParameters.Add('Host=www.kinopoisk.ru');
  RequestParameters.Add('Accept=text/html, application/xhtml+xml, */*');
  RequestParameters.Add('Accept-Encoding=gzip, deflate');
  RequestParameters.Add('Accept-Language=ru-RU');
  RequestParameters.Add('Connection=close');
  RequestParameters.Add('User-Agent=' + BasicAgent);
end.
