﻿const
	script_name='kino-teatr';
	language='Russian';
	version=30;
	author='BlackStream';
	MinProgramBuild=8000;
	Dbg = false;
	PCount = 12;
var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments, 
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList, DownloadMovieTechnicalInfo: boolean;
	MaxShotsCount, MaxPostersCount: integer;
	TitlesCount: integer;
	
	title, MovieName, year, director, name, character, BasicURL, country, description, salary: string;
	movie_code, movie_site_url, title_code, imdb_code: string;
	t_code, my_code, code: string;
	duration: integer;
	imdb_rating: single;
	rating: string;
	back_cover_url, front_cover_url: string;
	posters_exists, boxes_exists, screenshots_exists: boolean;
	original_title, mpaa, mpaa_rating: string;
	awards: string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	duration_min: integer;
	SubtitlesCount, AudioTracksCount: integer;
	prefixes: array [1..PCount] of string;
	shots_url, posters_url, MyMovieName : string;
	RequestParameters: TStringList;
	
	
//debug function
function DbgMsg(msg: string): boolean;
begin
	result := true;
	if Dbg then ShowMessage('='+msg+'=') 
	else result := false;
end;

function MovieSearch: integer;
var
	jj, i, j, k, l, TitlesCount: integer;
	s, s2, temp: string;
	original_title, year, description, small_cover, code: string;
begin
	i := Pos('<h3>результат поиска</h3>', all);
	if i>0 then
	begin
		j := MyPos('<div class="right_col', all, i+1);
		if j>0 then
		begin
			s := copy(all, i, j-i);
			j := 0;
			i := Pos('class="list_item"', s);
			if i = 0 then
				i := Pos('<div itemscope', s);
			while i>0 do begin
				j := MyPos('</div></div>', s, i+1);
				if j = 0 then
					j := MyPos('<div class="separator">', s, i+1);
				if j = 0 then
					j := length(s) + 1;
				s2 := copy(s, i, j-i);
				//title
				title := GetStr(s2, '<strong itemprop="name">', '</strong>');
				//title_code
				temp := GetStr(s2, '<a href="', '>');
				code := ParseString(temp, '/movie/.*?(\d+)/annot/" title', 1);
				//again title
				title := RemoveTags(title);
				title := DecodeHTML(title);	
				
				//year
				year := GetStr(s2, '>Год:', '</div>');
				year := ClearExtraBlankCharacters(RemoveTags(year));
				//original title
				original_title := '';
				k := Pos(' | ', s2);
				if k>0 then begin
					l := MyPos('</a>', s2, k+1);
					original_title := copy(s2, k+3, l-k-3);
					original_title := RemoveTags(original_title);
					original_title := DecodeHTML(original_title);
					original_title := MovePrefixLeft(original_title);
				end;
				//description
				description := GetStr(s2, '<div itemprop="description">', '<a href=');
				description := RemoveTags(description);
				description := DecodeHTML(description);
				//small cover
				small_cover := GetStr(s2, ' src="', '"');
				if (small_cover <> '') and (small_cover <> '/img/poster.gif') then
					small_cover := 'http://www.kino-teatr.ru' + small_cover
				else
					small_cover := '';
				if title <> '' then begin
					Inc(TitlesCount);
					SetSearchResult2(title, code, year, original_title, description, small_cover);
				end;
				delete(s, 1, j);
				i := Pos('class="list_item"', s);
				if i = 0 then
					i := Pos('<div itemscope', s);
			end;
		end;
	end;
	result := TitlesCount;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var 
	url: string;
	i, j: integer;
begin
	MyMovieName := EncodeURL(MovieName, 'windows-1251');
	url := 'https://www.kino-teatr.ru/search/';
(*	all := DownloadURLWithReferer(url, 'post');
	i := Pos('По вашему запросу ничего не обнаружено...', all);
	if not(i>0) then
	begin
		i := Pos('<a href="/search/', all);
		if i>0 then
		begin
			j := MyPos('/">', all, i+1);
			if j>0 then
				result := 'http://www.kino-teatr.ru'+copy(all, i+9, j-i-9);
		end;
	end
	else
	result := '-1';
*)
	result := url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	//all:=DownloadURLWithRefererThroughHTTPS(url, 'http://www.kino-teatr.ru', '', ['text=' + MyMovieName, 'movie=1', 'acter=0', 'submit=submit']);
	all:=DownloadURLWithRefererThroughHTTPS(url, 'https://www.kino-teatr.ru', '', ['text=' + MyMovieName, 'submit.x=0', 'submit.y=0']);
	//all := DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

//url to selected movie page
function GetMovieURL(code: string; images_only: boolean): string;
begin
	result:='https://www.kino-teatr.ru/kino/movie/'+code+'/annot/';
	//title_code := code;
	movie_site_url := result;
end;

//parse function
function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.kino-teatr.ru/kino/movie/'+code+'/annot/';
end;

//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s := DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then 
	begin
		try
			fs := TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result := true;
		except
			result := false;
		end;
	end
	else
		result:=false;
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	result:='https://www.kino-teatr.ru/kino/acter/'+code+'/';
end;

//modify original title to standart
function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;

//get movie info
function GetInfo(url: string; images_only: boolean): string;
var
	temp, x, s, s3, url2, s2, roll, descr, p_name, p_code: string;
	i, j, ii, jj, cl, season, episode: integer;	
	flTitr: boolean;
	EpisodeDescription, EpisodeTitle, seasonnr, episodenr, CastURL, small_photo, cast_page, EpisodeURL, episode_page: String;

	procedure GetPeople(text: string; role: integer);
	var
		s, p_name, p_code, small_photo: string;
		i, j, k: integer;
	begin
		repeat
			i := Pos(',', text);
			if i > 0 then begin
				s := copy(text, 1, i-1);
				delete(text, 1, i);
			end
			else
				s := text;
			p_name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
			p_code := GetStr(s, 'href="/kino/', '"');
			p_code := ParseString(p_code, '(\d+)/', 1);
			small_photo := GetStr(s, 'src="', '"');
			if (small_photo <> '') and (Pos('no_photo', small_photo) = 0) then
				small_photo := 'http://www.kino-teatr.ru' + ReplaceStr(small_photo, 'pv_', '', -1)
			else
				small_photo := '';
			if (p_name <> '') then
				SetPersonName(p_name, '', role, p_code, small_photo);
		until i = 0;
	end;
begin
	CastURL := '';
	EpisodeURL := '';
	shots_url := '';
	posters_url := '';
	result := '';
	BasicURL := url; 
	i := Pos('/annot', BasicURL);
	if i>0 then
		delete(BasicURL, i, length(BasicURL) - i + 1);
	all := DownloadURL(url);
	if all='-1' then
		result := '-1'
	else
		result := all;
	imdb_code := '';
	movie_code := ParseString(url, '\/(\d+)\/', 1);
	movie_site_url := GetMovieSiteURL(movie_code);
	
	if DownloadMovieFullCast and (Pos(movie_code + '/titr', all)>0) then begin
		CastURL := ReplaceStr(url, 'annot', 'titr', -1);
		AddRequestForHTMLPageContent(CastURL, False);
	end;
	if DownloadMovieSeasonsList and (Pos(movie_code + '/series', all)>0) then begin
		EpisodeURL := ReplaceStr(url, 'annot', 'series', -1);
		AddRequestForHTMLPageContent(EpisodeURL, False);
	end;
	if (MaxShotsCount > 0) and (Pos(movie_code + '/foto', all)>0) then begin
		shots_url := ReplaceStr(url, 'annot', 'foto', -1);
		AddRequestForHTMLPageContent(shots_url, False);
	end;
	if (MaxPostersCount > 0) and (Pos(movie_code + '/poster', all)>0) then begin
		posters_url := ReplaceStr(url, 'annot', 'poster', -1);
		AddRequestForHTMLPageContent(posters_url, False);
	end;
	
	title := GetStr(all, '<h1', '</h1>');
	if title <> '' then
		title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + title)));
	year := ParseString(title, '\((\d+)\)', 1);
	i := Pos('(', title);
	if i > 0 then
		delete(title, i, length(title)-i+1);
	title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(title)));
	temp := GetStr(all, '<div id="main_photo_block">', '</div>');
	// front cover
	front_cover_url := GetStr(temp, 'src="', '"');
	if front_cover_url <> '' then
		front_cover_url := 'http://www.kino-teatr.ru' + front_cover_url;
		
	// original_title
	temp := GetStr(all, 'Оригинальное название</div>', '</div>');
	if (temp = '') then
		temp := GetStr(all, 'Оригинальные названия</div>', '<br>');
	original_title := DecodeHTML(RemoveTags(temp));
	original_title := MovePrefixLeft(original_title);
	original_title := ClearExtraBlankCharacters(original_title);
	
		
	// countries
	temp := GetStr(all, 'Страна</div>', '</div>');
	temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	repeat
		i := Pos(',', temp);
		if i > 0 then begin
			s := copy(temp, 1, i-1);
			delete(temp, 1, i + 1);
		end
		else
			s := temp;
		s := ClearExtraBlankCharacters(s);
		if s <> '' then
			SetCountry(s);
	until i = 0;
	
	// description
	description := GetStr(all, '<div itemprop="description">', '</div>');
	description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));
	
	// awards
	awards := GetStr(all, 'itemprop="awards">', '</');
	awards := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(awards)));
	
	//genre
	temp := GetStr(all, 'itemprop="genre">', '</');
	temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	repeat
		i := Pos(',', temp);
		if i > 0 then begin
			s := copy(temp, 1, i-1);
			delete(temp, 1, i+1);
		end
		else
			s := temp;
		s := ClearExtraBlankCharacters(s);
		if s <> '' then
			SetGenre(s);
	until i = 0;
	
	//актеры	
	if DownloadMovieFullCast then begin
		cast_page := GetHTMLPageContentFromRequest(CastURL);
		i := Pos('<h3>актеры и роли</h3>', cast_page);
		delete(cast_page, 1, i);
		i := Pos('<b>озвучивание</b>', cast_page);
		if i > 0 then
			delete(cast_page, i, length(cast_page)-i+1);
		i := Pos('itemprop="actors"', cast_page);
		while i > 0 do begin
			temp := GetStr(cast_page, 'itemprop="actors"', '</div>'#13#10#13#10'</div>');
			p_name := GetStr(temp, 'itemprop="name">', '</strong');
			p_code := GetStr(temp, 'href="/kino/acter', '"');
			p_code := ParseString(p_code, '(\d+)/', 1);
			roll := GetStr(temp, 'class="film_role">', '</div>');
			j := Pos('&mdash;', roll);
			if j > 0 then
				delete(roll, j, length(roll)-j+1);
			roll := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(roll)));
			small_photo := GetStr(temp, 'src="', '"');
			if (small_photo <> '') and (Pos('no_photo', small_photo) = 0) then
				small_photo := 'http://www.kino-teatr.ru' + small_photo
			else
				small_photo := '';
			if (p_name <> '') and ((p_code <> '') or (Pos('href', temp) = 0)) then
				SetPersonName(p_name, roll, 3, p_code, small_photo);
			delete(cast_page, 1, i);
			i := Pos('itemprop="actors"', cast_page);
		end;
	end
	else begin
		temp := GetStr(all, 'Актеры</div>', '</div>');
		i := Pos('itemprop="actors"', temp);
		while i > 0 do begin
			s := GetStr(temp, 'itemprop="actors"', '</span>,');
			p_name := GetStr(s, 'itemprop="name">', '</span>');
			p_code := GetStr(s, 'href="/kino/acter', '"');
			p_code := ParseString(p_code, '(\d+)/', 1);
			small_photo := GetStr(s, ' src="', '"');
			if (small_photo <> '') and (Pos('no_photo', small_photo) = 0) then
				small_photo := 'http://www.kino-teatr.ru' + ReplaceStr(small_photo, 'pv_', '', -1)
			else
				small_photo := '';
			if (p_name <> '') then
				SetPersonName(p_name, '', 3, p_code, small_photo);
			delete(temp, 1, i);
			i := Pos('itemprop="actors"', temp);
		end;
	end;
	
	// режиссеры
	temp := GetStr(all, 'Режиссеры</div>', '</div>');
	if temp = '' then
		temp := GetStr(all, 'Режиссер</div>', '</div>');
	GetPeople(temp, 1);
	
	// сценаристы
	temp := GetStr(all, 'Сценаристы</div>', '</div>');
	if temp = '' then
		temp := GetStr(all, 'Сценарист</div>', '</div>');
	GetPeople(temp, 2);	
	
	// композиторы
	temp := GetStr(all, 'Композиторы</div>', '</div>');
	if temp = '' then
		temp := GetStr(all, 'Композитор</div>', '</div>');
	GetPeople(temp, 4);	
	
	// продюсеры
	temp := GetStr(all, 'Продюсеры</div>', '</div>');
	if temp = '' then
		temp := GetStr(all, 'Продюсер</div>', '</div>');
	GetPeople(temp, 5);	
	
	// операторы
	temp := GetStr(all, 'Операторы</div>', '</div>');
	if temp = '' then
		temp := GetStr(all, 'Оператор</div>', '</div>');
	GetPeople(temp, 6);	
	
	// студии
	temp := GetStr(all, 'Производство</div>', '</div>');
	temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	repeat
		i := Pos(',', temp);
		if i > 0 then begin
			s := copy(temp, 1, i-1);
			delete(temp, 1, i+1);
		end
		else
			s := temp;
		s := ClearExtraBlankCharacters(s);
		if s <> '' then
			SetStudio(s);
	until i = 0;
	
	//Бюджет
	temp := GetStr(all, 'Бюджет</div>', '</div>');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	if s <> '' then
		salary := 'Бюджет: ' + s;
	
	//Сборы
	temp := GetStr(all, 'Сборы в России</div>', '</div>');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	if s <> '' then begin
		if salary <> '' then
			salary := salary + #13#10;
		salary := salary + 'Сборы в России: ' + s;
	end;
	
	temp := GetStr(all, 'Сборы в США</div>', '</div>');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	if s <> '' then begin
		if salary <> '' then
			salary := salary + #13#10;
		salary := salary + 'Сборы в США: ' + s;
	end;
	
	temp := GetStr(all, 'Сборы всего</div>', '</div>');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	if s <> '' then begin
		if salary <> '' then
			salary := salary + #13#10;
		salary := salary + 'Сборы всего: ' + s;
	end;

		
	//серии
	if DownloadMovieSeasonsList then begin
		episode_page := GetHTMLPageContentFromRequest(EpisodeURL);
		i := Pos(' itemprop="episodes"', episode_page);
		while i>0 do begin
			delete(episode_page, 1, i);
			i := Pos('</div></div>', episode_page);
			temp := copy(episode_page, 1, i-1);
			s := GetStr(temp, '<strong itemprop="episodeNumber">', '</strong>');
			s2 := ParseString(s, '(\d+)', 1);
			episode := 1;
			try
				episode := StrToInt(s2);
			except
			end;
			s := GetStr(temp, 'itemprop="name">Сезон', '</');
			s2 := ParseString(s, '(\d+)', 1);
			season := 1;
			try
				season := StrToInt(s2);
			except
			end;		
			EpisodeTitle := GetStr(temp, '<h4>', '</h4>');
			EpisodeTitle := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(EpisodeTitle)));
			ii := Pos('<div itemprop="description">', temp);
			EpisodeDescription := copy(temp, ii, length(temp)-ii+1);
			j := Pos('<a ', EpisodeDescription);
			if j>0 then
				delete(EpisodeDescription, j, length(EpisodeDescription)-j+1);
			EpisodeDescription := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(EpisodeDescription)));
			if EpisodeTitle <> '' then
				SetEpisode(season, episode, EpisodeTitle, EpisodeDescription, '', '');
			delete(episode_page, 1, i);
			i := Pos(' itemprop="episodes"', episode_page);
		end;
	end;

end;

function GetTextBetween(fromStr, str1, str2: string): string;
var
	i, j: integer;
begin
	Result := '';
	if str1 = '' then
		i := 1
	else
		i := pos(str1, fromStr);
	if str2 = '' then
		j := Length(fromStr) + 1
	else
		j := MyPos(str2, fromStr, i+length(str1));
	if (i>0)and(j>0) then begin
		i := i + length(str1);
		Result := copy(fromStr, i, j-i);
	end;
end;

function ClearBrackets(name: string): string;
var
	i: integer;
begin
	// clear word in brackets at the end of name
	i := pos(' (', name);
	if i>0 then
		name := copy(name, 1, i-1);
	i := pos(' [', name);
	if i>0 then
		name := copy(name, 1, i-1);
	Result := name;
end;

function GetFrontCoverURL2: string;
var
	res, all, url, s, s2, s3, amazon_url: string;
	i, j, frames_count, k: integer;
	item_url: string;
	image_data, image_height, image_width, image_url: string;
	frame_urls: array [1..100] of string;
	int_year: Word;
	year_prew, year_next, title: string;
	valid_year: boolean;
begin
	title:=original_title;
	res:=front_cover_url;
	amazon_url:='';
	if DownloadMovieBigCover then begin
  	s:=title;
  	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [title]);
  	url:=ReplaceStr(url, ' ', '+', -1);
  	all:=DownloadURL(url);
  	//search image by title
  	frames_count := 0;
  	i:=pos('<Item>', all);
  	if year<>'' then begin
  		while (i>0) and (amazon_url='') do 
  		begin
  			j := MyPos('</Item>', all, i+1);
  			if j>0 then 
  			begin
  				s2 := copy(all, i, j-i);
  				s3 := GetTextBetween(s2, '<Title>', '</Title>');
  				s3 := ClearBrackets(s3);
  				s3 := DecodeHTML(s3);
  				if s3<>'' then 
  				begin
  					if (UpperCase(title) = UpperCase(s3)) then
  					begin
  						valid_year := true;
  						if pos('<TheatricalReleaseDate>', s2) > 0 then
  						begin
  							int_year := StrToInt(year);
  							year_prew := IntToStr(int_year - 1);
  							year_next := IntToStr(int_year + 1);
  							valid_year := false;
  							valid_year := pos('<TheatricalReleaseDate>'+year, s2) > 0;
  							valid_year := valid_year or (pos('<TheatricalReleaseDate>'+year_prew, s2) > 0);
  							valid_year := valid_year or (pos('<TheatricalReleaseDate>'+year_next, s2) > 0);						
  							year_prew := IntToStr(int_year - 2);
  							year_next := IntToStr(int_year + 2);
  							valid_year := valid_year or (pos('<TheatricalReleaseDate>'+year_prew, s2) > 0);
  							valid_year := valid_year or (pos('<TheatricalReleaseDate>'+year_next, s2) > 0);						
  						end;
  						if valid_year then
  						begin
  							s := '';
  							frames_count := 0;
  							repeat
  								image_data := GetTextBetween(s2, '<LargeImage>', '</LargeImage>');
  								image_url := GetTextBetween(image_data, '<URL>', '</URL>');
  								image_height := GetTextBetween(image_data, '<Height','</Height>');
  								image_height := GetTextBetween(image_height, '>','');
  								image_width := GetTextBetween(image_data, '<Width','</Width>');
  								image_width := GetTextBetween(image_width, '>','');
  								try
  									if (image_height <> '0') and ((StrToInt(image_width) / StrToInt(image_height)) > 1.2) then 
  									begin
  										for k := 1 to frames_count do
  											if frame_urls[k] = image_url then break;
  										if (frames_count = 0) or (frame_urls[k] <> image_url) then begin
  											frames_count := frames_count + 1;
  											frame_urls[frames_count] := image_url;
  										end;
  									end
  									else if amazon_url = '' then
  										amazon_url := image_url;
  								except
  									//Wrong XML format!
  								end;
  								delete(s2, 1, 25 + length(image_data));
  							until (image_data = '') or (frames_count = MaxShotsCount);
  						end;
  					end; //if
  				end; //if
  			end; //if
  			delete(all, 1, j);
  			i := Pos('<Item>', all);
  		end; //while
  	end; //if year<>''
	end;

	if amazon_url<>'' then   // front-cover from amazon
		SetImageName('', amazon_url, '', 1);
	if front_cover_url<>'' then // front-cover from movie site
		SetImageName('', front_cover_url, '', 1);
	Result:=amazon_url;
	//Showmessage(title);
end;

procedure GetPosters;
var
	i, j, img_cnt: Integer;
	temp, s: String;
begin
	img_cnt := 0;
	temp := GetHTMLPageContentFromRequest(posters_url);
	i := Pos('<h3>постеры фильма</h3>', temp);
	if i>0 then
		delete(temp, 1, i);
	i := Pos(' src="/movie/poster/', temp);
	while (i>0) and (img_cnt < MaxPostersCount) do begin
		delete(temp, 1, i-1);
		s := GetStr(temp, 'src="', '"');
		s := ReplaceStr(s, '/pv_', '/', -1);
		s := 'http://www.kino-teatr.ru'+s;
		SetImageName('', s, '', 4);
		delete(temp, 1, i);
		img_cnt := img_cnt + 1;
		i := Pos(' src="/movie/poster/', temp);		
	end;
end;

//returned images links
procedure GetImages;
var
	url, temp, s, front_cover_url_back: string;
	c, i, j, img_cnt, page: integer;
begin
	GetFrontCoverURL2;
	if MaxPostersCount > 0 then
		GetPosters;
	img_cnt := 0;
	if MaxShotsCount > 0 then begin
		temp := GetHTMLPageContentFromRequest(shots_url);
		i := Pos(' src="/movie/kadr/', temp);
		while (i>0) and (img_cnt < MaxShotsCount) do begin
			delete(temp, 1, i);
			s := GetStr(temp, 'src="', '"');
			if s <> '' then begin
				s := ReplaceStr(s, '/pv_', '/', -1);
				s := 'http://www.kino-teatr.ru'+s;
				SetImageName('', s, '', 3);
				img_cnt := img_cnt + 1;
			end;
			i := Pos(' src="/movie/kadr/', temp);
		end;
	end;
end;

function ShowScriptOptions: integer;
var
	s: string;
	f: TForm;
	b: TButton;
	cbRemoveNr: TCheckBox;
	my_value: integer;
	
procedure ButtonClick(Sender: TButton);
var
	zn: integer;
begin
	try
		if cbRemoveNr.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('KinoteatrRemoveNr', zn);	
	except
	end;

	f.ModalResult := mrOk;
end;

begin
	result:=0;
	f := TForm.Create(nil);
	f.Caption := GetLangStr(1924);
	f.BorderStyle := bsDialog;
	f.Position := poScreenCenter;
	f.Width:=400;
	f.Height:=190;
	f.AutoSize:=false;

	
	cbRemoveNr := TCheckBox.Create(f);
	cbRemoveNr.Name := 'cbRemoveNr';
	cbRemoveNr.Parent := f;
	cbRemoveNr.SetBounds(10, 10, 350, 20);
	cbRemoveNr.Caption := 'Удалять идентификатор человека в скобках';
	my_value := RegReadInteger('KinoteatrRemoveNr', 1);
	if my_value=1 then
		cbRemoveNr.Checked := True;
		
		

	b := TButton.Create(f);
	b.Name := 'btnOK';
	b.Parent := f;
	b.SetBounds(160, 130, 80, 25);
	b.Caption := '&OK';
	b.OnClick := @ButtonClick;

	f.ShowModal;
	f.Free;
end;

begin
prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

  RequestParameters := TStringList.Create();
  RequestParameters.Add('Host=www.kino-teatr.ru');
  RequestParameters.Add('AcceptLanguage=ru-RU,ru;q=0.8,en-US,en');
  RequestParameters.Add('Connection=close');
  RequestParameters.Add('cashcontrol=no-cache');
  RequestParameters.Add('useragent=Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko)');

end.