program modern_program;

uses 'modern_program_variables.pas',  'modern_program_global.pas',
  'modern_program_part1.pas', 'modern_program_part2.pas', 'modern_program_part3.pas',
  'modern_program_part4.pas', 'modern_program_part5.pas', 'modern_program_part6.pas',
  'modern_program_part7.pas', 'modern_program_part8.pas',
  'modern_program_part9.pas', 'modern_program_part10.pas', 'modern_program_part11.pas',
  'modern_program_part12.pas', 'modern_program_part13.pas', 'modern_program_part14.pas';

const
	script_name='Modern';
	language='';
	version=123;
	author='medianizer.com';

function GetMovieProgramType(ACode: Integer): Integer;
begin
  ExecuteSQL('SELECT item_type FROM movies WHERE code = ' + IntToStr(ACode));
  Result := GetIntegerField('item_type');
end;

function GetPersonProgramType(ACode: Integer): Integer;
begin
  ExecuteSQL('SELECT item_type FROM persons WHERE code = ' + IntToStr(ACode));
  Result := GetIntegerField('item_type');
end;

function GetManualProgramType(ACode: Integer): Integer;
begin
  ExecuteSQL('SELECT item_type FROM manuals WHERE code = ' + IntToStr(ACode));
  Result := GetIntegerField('item_type');
end;

function GetMovieByProgramType(MovieCode: Integer; AProgramType: Integer; season: integer;
  FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetMoviePage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
    MUSICNIZER_PROGRAM: Result := GetAlbumPage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
    BOOKNIZER_PROGRAM: Result := GetBookPage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
    GAMENIZER_PROGRAM: Result := GetGamePage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
  end;
end;

function GetMovie(MovieCode: Integer; season: integer;
  FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
begin
  Result := GetMovieByProgramType(MovieCode, GetMovieProgramType(MovieCode), season,
    FullDesc, FullComments, FullPersons, FullAwards);
end;

function GetPersonByProgramType(PersonCode: integer; AProgramType: Integer;
  FullBio, FullDesc: boolean): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetPersonMoviePage(PersonCode, FullBio, FullDesc);
    MUSICNIZER_PROGRAM: Result := GetPersonAlbumPage(PersonCode, FullBio, FullDesc);
    BOOKNIZER_PROGRAM: Result := GetPersonBookPage(PersonCode, FullBio, FullDesc);
    GAMENIZER_PROGRAM: Result := GetPersonGamePage(PersonCode, FullBio, FullDesc);
  end;
end;

function GetPerson(PersonCode: integer; FullBio, FullDesc: boolean): string;
begin
  Result := GetPersonByProgramType(PersonCode, GetPersonProgramType(PersonCode),
    FullBio, FullDesc);
end;

//   
function GetThumbMovieByProgramType(code, mode: integer; AProgramType: Integer;
  title, year: string; InCollection, rating: integer;
  AFullDescription: string = ''; ASearchDescription: string = ''): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetThumbnailMovie(code, mode, title, year, InCollection, rating, AFullDescription, ASearchDescription);
    MUSICNIZER_PROGRAM: Result := GetThumbnailAlbum(code, mode, title, year, InCollection, rating, AFullDescription, ASearchDescription);
    BOOKNIZER_PROGRAM: Result := GetThumbnailBook(code, mode, title, year, InCollection, rating, AFullDescription, ASearchDescription);
    GAMENIZER_PROGRAM: Result := GetThumbnailGame(code, mode, title, year, InCollection, rating, AFullDescription, ASearchDescription);
  end;
end;

//   
function GetThumbMovie(code, mode: integer; title, year: string; InCollection, rating: integer;
  AFullDescription: string = ''; ASearchDescription: string = ''): string;
begin
  Result := GetThumbMovieByProgramType(code, mode, GetMovieProgramType(code),
    title, year, InCollection, rating, AFullDescription, ASearchDescription);
end;

//   
function GetThumbMovieExtendedByProgramType(code, mode: integer; AProgramType: Integer;
  Title: string): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetThumbnailMovieExtended(code, mode, title);
    MUSICNIZER_PROGRAM: Result := GetThumbnailAlbumExtended(code, mode, title);
    BOOKNIZER_PROGRAM: Result := GetThumbnailBookExtended(code, mode, title);
    GAMENIZER_PROGRAM: Result := GetThumbnailGameExtended(code, mode, title);
  end;
end;

//   
function GetThumbMovieExtended(code, mode: integer; title: string): string;
begin
  Result := GetThumbMovieExtendedByProgramType(code, mode, GetMovieProgramType(code), title);
end;

function GetThumbPersonByProgramType(ACode, AMode: integer; AName: string;
  AProgramType: Integer): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetThumbnailPersonMovie(ACode, AMode, AName);
    MUSICNIZER_PROGRAM: Result := GetThumbnailPersonAlbum(ACode, AMode, AName);
    BOOKNIZER_PROGRAM: Result := GetThumbnailPersonBook(ACode, AMode, AName);
    GAMENIZER_PROGRAM: Result := GetThumbnailPersonGame(ACode, AMode, AName);
  end;
end;

function GetThumbPerson(ACode, AMode: integer; AName: string = ''): string;
begin
  Result := GetThumbPersonByProgramType(ACode, AMode, AName, GetPersonProgramType(ACode));
end;

function GetThumbPersonExtendedByProgramType(ACode, AMode: integer; AName: string;
  AProgramType: Integer): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetThumbnailPersonMovieExtended(ACode, AMode, AName);
    MUSICNIZER_PROGRAM: Result := GetThumbnailPersonAlbumExtended(ACode, AMode, AName);
    BOOKNIZER_PROGRAM: Result := GetThumbnailPersonBookExtended(ACode, AMode, AName);
    GAMENIZER_PROGRAM: Result := GetThumbnailPersonGameExtended(ACode, AMode, AName);
  end;
end;

function GetThumbPersonExtended(ACode, AMode: integer; AName: string = ''): string;
begin
  Result := GetThumbPersonExtendedByProgramType(ACode, AMode, AName,
    GetPersonProgramType(ACode));
end;

function GetReferenceByProgramType(ReferenceCode: Integer; AProgramType: Integer;
  reference: integer; Page: Integer = 0): string;
var
  sl: TStringList;
  RecordCount, i: integer;
  s, all: string;
  current_site: string;
  MovieSortFields: string;
  AudioEditionMediaType: Integer;
begin
	result:='';
	TempReferenceCode:=ReferenceCode;
	TempReference:=reference;

	ProgramReference:='';
	sl:=TStringList.Create;

	all:='';
  if ReferenceCode>0 then
  begin
    //LastMode:=4;
      with sl do begin
        Clear;
        Add('select name from manuals');
        if ((Reference = 6) or (Reference = 7)) then
          Add(format('where code=%d and reference=%d', [ReferenceCode, 23]))
        else
          Add(format('where code=%d and reference=%d', [ReferenceCode, reference]));
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount<=0 then
        exit;
      ProgramReference:=GetStringField('name');
      MovieSortFields := ' m.title_sort, i.sort_order';
      if (AProgramType <> MOVIENIZER_PROGRAM) then
        MovieSortFields := ' m.title, i.sort_order';
      //    
      with sl do
      begin
        Clear;
        if (IsPersonReference(reference)) then
        begin
      		Add('select p.name as name, p.code as code, p.rating as rating, ');
          Add('p.in_collection as in_collection, ');
          Add('i.path as path, i.height as Height, i.width as Width');
          Add('from persons p');
        end
        else
        begin
      		Add('select m.title as title, m.code as code, m.year as year, ');
          Add('m.in_collection as in_collection, m.rating as rating,');
          Add('m.imdb_rating as imdb_rating, m.series_nom as series_nom,');
          Add('i.path as path, i.height as Height, i.width as Width');
          Add('from movies m');
        end;
        //custom fields
        if (reference>=13) and (reference<=16) then
        begin
        	i:=reference-12;
		    	Add('left outer join images i on i.movie=m.code and i.mode=1');
			    Add(format('where m.custom%d=%d', [i, ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        else if (reference>=24) and (reference<=27) then
        begin
        	i:=reference-23;
		    	Add('left outer join images i on i.person=p.code and i.mode=6');
			    Add(format('where p.custom%d=%d', [i, ReferenceCode]));
	        Add('order by p.name, i.sort_order');
        end
        //video standard
        else if (reference=1) then begin
        	Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
  	      Add(format('where e.video_standard=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
        //media format
        else if (reference=2) then begin
        	Add('left outer join editions e on e.movie=m.code');
			    Add('left outer join images i on i.movie=m.code and i.mode=1');
  	      Add(format('where e.media_format=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end

        // media types
        else if (reference = 3) then
        begin
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where m.media_type=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
        //aspect ratio
        else if (reference=4) then begin
			Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where e.screen_ratio=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        //resolution
        else if (reference=5) then begin
			Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where e.resolution=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        else if (reference=6) or (reference=7) then
        begin
          AudioEditionMediaType := 7 - reference;
        	Add('left outer join editions e on e.movie=m.code');
    		Add(format('inner join audio_manuals em on em.edition=e.code and em.media_type=%d', [AudioEditionMediaType]));
    	    Add('inner join manuals mg on mg.code=em.reference');
		    Add('left outer join images i on i.movie=m.code and i.mode=1');
    		Add(format('where mg.code=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        //location
        else if (reference=10) then begin
			Add('left outer join editions e on e.movie=m.code');
        	Add('inner join loans l on l.edition=e.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where l.location=%d', [ReferenceCode]));
			Add('and (l.return_date='''' or l.return_date is null) and m.in_collection=1');
	        Add('order by ' + MovieSortFields);
        end
        // MPAA
        else if (reference = 11) then
        begin
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where m.mpaa=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
        // video codec
        else if (reference = 19) then
        begin
        	Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where e.video_codec=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
        //disc label
        else if (reference=20) then begin
			Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where e.disc_label=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        // book language
        else if (reference=23) then begin
        	Add('left outer join editions e on e.movie=m.code');
			    Add('left outer join images i on i.movie=m.code and i.mode=1');
  	      Add(format('where e.book_language=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
		//sequence
		else if (reference=22) then begin
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where m.series=%d', [ReferenceCode]));
	        Add('order by m.series_nom, i.sort_order');
        end
        else
        begin
          if (IsPersonReference(reference)) then
          begin
            Add(format('inner join persons_manuals pm on pm.person=p.code and pm.reference=%d', [reference]));
            Add('inner join manuals mg on mg.code=pm.ref_code');
            Add('left outer join images i on i.person=p.code and i.mode=6');
            Add(format('where mg.code=%d and p.in_collection=1', [ReferenceCode]));
            Add('order by p.name, i.sort_order');
          end
          else
          begin
            Add(format('inner join movies_manuals mm on mm.movie=m.code and mm.reference=%d', [reference]));
            Add('inner join manuals mg on mg.code=mm.ref_code');
            Add('left outer join images i on i.movie=m.code and i.mode=1');
            Add(format('where mg.code=%d and m.in_collection=1', [ReferenceCode]));
            Add('order by m.title');
          end;
        end;
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then
      begin
        //movie:=format('<h1>Movies by genre %s</h1><ol>', [genre]);
        case reference of
			    //video standard
    			1: s:=format(GetLangStr(1134), [ProgramReference]);
        	//media format
        	2: s:=format(GetLangStrMulti(AProgramType, 1526, 10163, 20163, 35257), [ProgramReference]);
		    	// media type
    			3: s := GetLangStr(3279) + ': ' + ProgramReference;
        	//aspect ratio
        	4: s:=format(GetLangStrMulti(AProgramType, 645, 10164, 20164), [ProgramReference]);
        	//resolution
        	5: s:=format(GetLangStrMulti(AProgramType, 633, 10166, 20166), [ProgramReference]);
        	//subtitles
        	6: s:=format(GetLangStrMulti(AProgramType, 634, 10167, 20167), [ProgramReference]);
        	//audio track
        	7: s:=format(GetLangStrMulti(AProgramType, 632, 10165, 20416), [ProgramReference]);
        	//genre
        	8: s:=format(GetLangStrMulti(AProgramType, 313, 10168, 20168, 35007), [ProgramReference]);
        	//country
        	9: s:=format(GetLangStrMulti(AProgramType, 314, 10169, 20169, 35006), [ProgramReference]);
        	//location
        	10: s:=format(GetLangStrMulti(AProgramType, 569, 10170, 20170, 35231), [ProgramReference]);
			    //mpaa
    			11: s:=GetLangStrMulti(AProgramType, 3277, 3277, 3277, 35075) + ': ' + ProgramReference;
    			//studios
    			12: s:=format(GetLangStrMulti(AProgramType, 1527, 10171, 20171, 35005), [ProgramReference]);
        	//custom 1-4
        	13: s:=GetLangStr(540)+': '+ProgramReference;
        	14: s:=GetLangStr(541)+': '+ProgramReference;
        	15: s:=GetLangStr(542)+': '+ProgramReference;
        	16: s:=GetLangStr(543)+': '+ProgramReference;
        	//custom list 1-2
        	17: s:=GetLangStr(544)+': '+ProgramReference;
        	18: s:=GetLangStr(545)+': '+ProgramReference;
    			// video codec
		    	19: s := GetLangStr(3280) + ': ' + ProgramReference;
        	//disc label
        	20: s:=format(GetLangStrMulti(AProgramType, 1001, 10172, 20172, 35232), [ProgramReference]);
    			//sequence
		    	22: s:=GetLangStrMulti(AProgramType, 3327, 3327, 2966, 35004) + ': ' + ProgramReference;
          // book langauge
          23: s :=Format(GetLangStrMulti(AProgramType, 20416, 20416, 20416, 35258), [ProgramReference]);
          // custom persons 1-4
        	24: s:=GetLangStr(4540)+': '+ProgramReference;
        	25: s:=GetLangStr(4541)+': '+ProgramReference;
        	26: s:=GetLangStr(4542)+': '+ProgramReference;
        	27: s:=GetLangStr(4543)+': '+ProgramReference;
        	//custom person list 1-2
        	28: s:=GetLangStr(4544)+': '+ProgramReference;
        	29: s:=GetLangStr(4545)+': '+ProgramReference;
			    else
				    s:='';
        end;
        if (IsPersonReference(reference)) then
          all := ProcessPersonReference(AProgramType, s, page)
        else
  	      all := ProcessMovieReference(AProgramType, s, page);
    	end; //if
    end;
  sl.Free;
  result:=all;
end;


//
// Fade.    "userref" ,     ,
//  User_ref   ,    .  :
//
// 1..99:         /.      
//           1..5:      
//           6..9:      
//
// 100..199: c,    , ..      
//           (      ,     ...).
//                    (userref: 150,movie_code;...)
//            ";"   ,    .
//                        "movie;10237"
//
//           109..129: Movie Tabs
//           150..151: Episodes seen
//           152: episode rating
//           153: mark season as seen
//           154: mark season as unseen
//           160: set track rating
//           161: all tracks by rating
//
// 200..299: ,    , ..      
//           (           )
//                    (userref: 150,person_code;...)
//            ";"   ,    .
//                        "person;10237"
//
//           201..205: Person Tabs
//           210: Location of birth
//           211: Date of death
//           231..236:   
//
// 300..399:  .     /
//             
//           300:   
//           301:    
//           302:   
//           303:   
//           304: albums by edition type
//           305: albums by disc release year
//
//       / (//).
//      .    ,   ,
//         HTML. :
//
// 300:   
// 1300:   
// 2300:   

function GetUserReferenceByProgramType(code: integer; AProgramType: Integer;
  text: string; Page: Integer = 1): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetUserReferenceForMovie(code, Text, Page);
    MUSICNIZER_PROGRAM: Result := GetUserReferenceForAlbum(code, Text, Page);
    BOOKNIZER_PROGRAM: Result := GetUserReferenceForBook(code, Text, Page);
    GAMENIZER_PROGRAM: Result := GetUserReferenceForGame(code, Text, Page);
  end;
end;

function GetUserReference(code: integer; text: string; Page: Integer = 1): string;
var
  ProgramType: Integer;
begin
  ProgramType := GetUserReferenceProgramType(code);
	result := GetUserReferenceByProgramType(code, ProgramType, text, Page);
end;

//show movies by selected manual
function GetReference(ReferenceCode, reference: integer; Page: Integer = 0): string;
begin
	result := GetReferenceByProgramType(ReferenceCode, GetManualProgramType(ReferenceCode),
    reference, Page);
end;

//show movies by selected year
function GetYear(ProgramType: Integer; YearCode: Integer; page: integer = 1): string;
var
  sl: TStringList;
  all: string;
begin
	TempReference:=300;
	TempReferenceCode:=YearCode;
	result:='';
	sl:=TStringList.Create;

	all:='';
  if YearCode>0 then
  begin
    with sl do begin
      Clear;
      Add('select m.title as Title, m.code as code, m.year as year,');
      Add('m.in_collection as in_collection, m.imdb_rating as imdb_rating,');
      Add('m.rating as rating, i.path as path');
      Add('from movies m');
      Add('left outer join images i on i.movie=m.code and i.mode=1');
      Add(format('where m.year=%d and m.in_collection=1', [YearCode]));
      Add('AND m.item_type = ' + IntToStr(ProgramType));
      Add('order by m.year desc, m.title, i.sort_order');
    end;
    ExecuteSQL(sl.text);
  	all := ProcessMovieReference(ProgramType, Format(GetLangStrMulti(ProgramType,
      315, 10341, 20341, 35008), [YearCode]), page);
  end;
  sl.Free;
  result:=all;
end;

//show movies by selected year
function GetMyRating(ProgramType: Integer; rating: Integer; page: integer = 1): string;
var
  sl: TStringList;
  all: string;
  rating_s: string;
begin
	TempReference:=301;
	TempReferenceCode:=rating;
	result:='';
	sl:=TStringList.Create;

  with sl do
  begin
    Clear;
    Add('select m.title as title, m.code as code, m.rating as rating, ');
    Add('m.in_collection as in_collection, m.imdb_rating as imdb_rating, ');
    Add('m.rating as rating, i.path as path');
    Add('from movies m');
    Add('left outer join images i on i.movie=m.code and i.mode=1');
    Add(format('where m.rating=%d and m.in_collection=1', [rating]));
    Add('AND m.item_type = ' + IntToStr(ProgramType));
    Add('order by m.rating desc, m.title, i.sort_order');
  end;
  if (Rating > 0) then
    rating_s := IntToStr(rating)
  else
    rating_s := GetLangStr(3885);
  rating_s := '"' + rating_s + '"';
  ExecuteSQL(sl.text);
	all := ProcessMovieReference(ProgramType, format(GetLangStrMulti(
    ProgramType, 3884, 30201, 30202, 35009), [rating_s]), page);
  sl.Free;
  result:=all;
end;


//  
function GetHome: string;
begin
	result:=GetHomeModern(HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab);
end;

//  

function GetSearchTop(RecMin, RecMax, RecCount: integer): string;
begin
	result:=GetPatternTop + '<p class="title">'+GetLangStr(1293)+format(': %d-%d %s %d', [RecMin, RecMax, GetLangStr(1461), RecCount])+'</p></td>'+ClosePatternTop+'<tr><td>';
end;

function GetSearchBottom(RecMin, RecMax, RecCount: integer): string;
var
	s: string;
	RecPage, i, kol: integer;
begin
	//s:=format('Results from %d to %d. Total records %d', [RecMin, RecMax, RecCount]);
	s:='';
	RecPage:=GetNumberSearchResults;
	if RecPage>0 then begin
		kol:=RecCount div RecPage;
		if kol*RecPage<>RecCount then
			kol:=kol+1;
		s:=s+'<tr><td><center><table class="navi"><td class="navi-border">'+format('<img src="%snavi-left.gif"></td><td style="background:url(%s) repeat-x;"><p>', [ImgPath, WhiteBarFile]);
		for i:=1 to kol do begin
			if (RecMin-1) div RecPage=i-1 then
				s:=s+format('<a href="search:%d-%d"><b>%d</b></a> ', [(i-1)*RecPage+1, i*RecPage, i])
			else
				s:=s+format('<a href="search:%d-%d">%d</a> ', [(i-1)*RecPage+1, i*RecPage, i]);
		end;
		s:=s+format('</p></td><td class="navi-border"><img src="%snavi-right.gif"></td></table></center></td></tr>', [ImgPath]);
		
	end;
	result:='</td></tr>' + s + GetPatternBottom;
end;

//remove all thumbs files
procedure DeleteThumbs(FileName: string);
begin
	DeleteFile(ImagesPath+'Thumbs\'+FileName);
	DeleteFile(ImagesPath+'Thumbs2\'+FileName);
	DeleteFile(ImagesPath+'ThumbsCovers\'+FileName);
	DeleteFile(ImagesPath+'ThumbsHomeMovies\'+FileName);
	DeleteFile(ImagesPath+'ThumbsMainPhoto\'+FileName);
	DeleteFile(ImagesPath+'ThumbsMoviePhotos\'+FileName);
	DeleteFile(ImagesPath+'ThumbsPersonMovies\'+FileName);
	DeleteFile(ImagesPath+'ThumbsPhotos\'+FileName);
	DeleteFile(ImagesPath+'ThumbsScreenshots\'+FileName);
end;

function ShowScriptOptions(): string;
begin
  Result := ShowScriptOptionsInternal();
end;

function IsPersonReference(AReference: Integer): Boolean;
begin
  Result := (AReference >= 24) and (Areference <= 29);
end;

procedure ReadCellsSizes();
var
  I: Integer;
begin
  for I := LOW_PROGRAM_TYPE to HIGH_PROGRAM_TYPE do
  begin
  	MultiShowRowHeight[I] := RegReadInteger(REGISTRY_SUB_KEYS[I] + 'ThumbCellHeight', DefaultMultiCellHeight[I]);
  	MultiShowImageWidth[I] := RegReadInteger(REGISTRY_SUB_KEYS[I] + 'ThumbCellWidth', DefaultMultiCellWidth[I]);
  end;
end;

begin
	ImgPath := PicturesPath + 'Themes\Modern\';
	WhiteBarFile := ImgPath + 'white-bar.gif';
	WhiteBarFile := ReplaceStr(WhiteBarFile, '(', '%28');
	WhiteBarFile := ReplaceStr(WhiteBarFile, ')', '%29');
	WhiteBarFile := ReplaceStr(WhiteBarFile, ' ', '%20');
	BackgroundMovies := ImgPath + 'background-movies.gif';
	BackgroundMovies := ReplaceStr(BackgroundMovies, '(', '%28');
	BackgroundMovies := ReplaceStr(BackgroundMovies, ')', '%29');
	BackgroundMovies := ReplaceStr(BackgroundMovies, ' ', '%20');
	BackgroundPeople := ImgPath + 'background-people.gif';
	BackgroundPeople := ReplaceStr(BackgroundPeople, '(', '%28');
	BackgroundPeople := ReplaceStr(BackgroundPeople, ')', '%29');
	BackgroundPeople := ReplaceStr(BackgroundPeople, ' ', '%20');
	ActiveTab := 1;
	PersonActiveTab := 1;
  // 22.04.2011 - default sizes for multi image showing
  ReadCellsSizes();
  MiltiShowDistanceBetweenCovers := 12;
  SetHintWindowSize(290, 130);
	HomeMovieTab := 1;
  HomeAlbumTab := 1;
  HomeGameTab := 1;
  HomeBookTab := 1;
	HomePersonTab := 1;

	DeleteFile(ImagesPath+'Thumbs2\no-cover.jpg');
end.
