program modern_program_part1;

uses 'modern_program_variables.pas, modern_program_part9.pas',
  'modern_program_part10.pas', 'modern_program_part11.pas',
  'modern_program_part14.pas';


function ShowScriptOptionsInternal(): string;
var
	s: string;
  form: TForm;
  pageOptions: TPageControl;
  btnSaveMoviesCallback: Pointer;
  btnSaveAlbumsCallback: Pointer;
  btnSaveBooksCallback: Pointer;
  btnSaveGamesCallback: Pointer;
  btnDefaultMoviesCallback: Pointer;
  btnDefaultAlbumsCallback: Pointer;
  btnDefaultBooksCallback: Pointer;
  btnDefaultGamesCallback: Pointer;

  procedure FillScriptOptionsGeneral();
  var
    I: Integer;
    f: TTabSheet;
    btnSave: TButton;
    btnDefault: TButton;
    labLogo: TLabel;
    comboLogo: TComboBox;
    cbxMovies: TCheckBox;
    cbxAlbums: TCheckBox;
    cbxBooks: TCheckBox;
    cbxGames: TCheckBox;
    cbxPersons: TCheckBox;
    cbxLitres: TCheckBox;
    cbxSupport: TCheckBox;
    gbShowOnMainPage: TGroupBox;
    GroupBoxDeltaOy: Integer;

  procedure SetCheckBoxChecked(ACheckBox: TCheckBox; AChecked: Boolean);
  begin
    if (ACheckBox <> nil) then
      ACheckBox.Checked := AChecked;
  end;

  procedure SaveCheckBoxState(ARegSection: string; ACheckBox: TCheckBox);
  begin
    if (ACheckBox <> nil) then
      RegWriteBoolean(ARegSection, ACheckBox.Checked);
  end;

  procedure btnDefaultClick(Sender: TButton);
  begin
    if (MessageDlg(GetLangStr(30148), mtConfirmation, mbYes + mbNo, -1) = mrYes) then
    begin
      SetCheckBoxChecked(cbxMovies, DefaultHomePageShowMovies);
      SetCheckBoxChecked(cbxAlbums, DefaultHomePageShowAlbums);
      SetCheckBoxChecked(cbxBooks, DefaultHomePageShowBooks);
      SetCheckBoxChecked(cbxGames, DefaultHomePageShowGames);
      SetCheckBoxChecked(cbxPersons, DefaultHomePageShowPersons);
      SetCheckBoxChecked(cbxSupport, DefaultHomePageShowSupport);
      comboLogo.ItemIndex := DefaultHomeLogo;
      SetCheckBoxChecked(cbxLitres, DefaultLitresBlockVisible);
      // clear defaults for all other pages
      if (IsProgramUsed(MOVIENIZER_PROGRAM)) then
        ExecuteChildrenProcByName('FillScriptOptionsMovies', btnDefaultMoviesCallback, [nil]);
      if (IsProgramUsed(MUSICNIZER_PROGRAM)) then
        ExecuteChildrenProcByName('FillScriptOptionsMusic', btnDefaultAlbumsCallback, [nil]);
      if (IsProgramUsed(BOOKNIZER_PROGRAM)) then
        ExecuteChildrenProcByName('FillScriptOptionsBooks', btnDefaultBooksCallback, [nil]);
      if (IsProgramUsed(GAMENIZER_PROGRAM)) then
        ExecuteChildrenProcByName('FillScriptOptionsGames', btnDefaultGamesCallback, [nil]);
    end;
  end;

  procedure btnSaveClick(Sender: TButton);
  begin
    SaveCheckBoxState('HomePageShowMovies', cbxMovies);
    SaveCheckBoxState('HomePageShowAlbums', cbxAlbums);
    SaveCheckBoxState('HomePageShowBooks', cbxBooks);
    SaveCheckBoxState('HomePageShowGames', cbxGames);
    SaveCheckBoxState('HomePageShowPersons', cbxPersons);
    SaveCheckBoxState('HomePageShowSupport', cbxSupport);
    SaveCheckBoxState('HomePageShowLitres', cbxLitres);
    RegWriteInteger('HomeLogo', comboLogo.ItemIndex);
    // save all other pages
    if (IsProgramUsed(MOVIENIZER_PROGRAM)) then
      ExecuteChildrenProcByName('FillScriptOptionsMovies', btnSaveMoviesCallback, [nil]);
    if (IsProgramUsed(MUSICNIZER_PROGRAM)) then
      ExecuteChildrenProcByName('FillScriptOptionsMusic', btnSaveAlbumsCallback, [nil]);
    if (IsProgramUsed(BOOKNIZER_PROGRAM)) then
      ExecuteChildrenProcByName('FillScriptOptionsBooks', btnSaveBooksCallback, [nil]);
    if (IsProgramUsed(GAMENIZER_PROGRAM)) then
      ExecuteChildrenProcByName('FillScriptOptionsGames', btnSaveGamesCallback, [nil]);
    // close form
    form.ModalResult := mrYes;
  end;

    function AddCheckBoxToGroupBox(ACaption: string; ARegKey: string;
      ADefault: Boolean = False): TCheckBox;
    begin
      Result := TCheckBox.Create(f);
      Result.Caption := ACaption;
      Result.Parent := gbShowOnMainPage;
      Result.Checked := RegReadBoolean(ARegKey, ADefault);
      Result.SetBounds(10, GroupBoxDeltaOy, 300, 20);
      GroupBoxDeltaOy := GroupBoxDeltaOy + 21;
    end;

    function AddCheckBoxToGroupBoxForProgram(AProgramType: Integer; ACaption: string;
      ARegKey: string; ADefault: Boolean = False): TCheckBox;
    begin
      Result := nil;
      if (IsProgramUsed(AProgramType)) then
        Result := AddCheckBoxToGroupBox(ACaption, ARegKey, ADefault);
    end;

  begin
    f := TTabSheet.Create(pageOptions);
    f.Caption := GetLangStr(475);
    f.Parent := pageOptions;
    f.PageControl := pageOptions;

    gbShowOnMainPage := TGroupBox.Create(f);
    gbShowOnMainPage.Name := 'MoviePageGroup';
    gbShowOnMainPage.Parent := f;
    gbShowOnMainPage.Caption := GetLangStr(30145);
    GroupBoxDeltaOy := 15;


    cbxMovies := AddCheckBoxToGroupBoxForProgram(MOVIENIZER_PROGRAM, GetLangStr(42), 'HomePageShowMovies', DefaultHomePageShowMovies);
    cbxAlbums := AddCheckBoxToGroupBoxForProgram(MUSICNIZER_PROGRAM, GetLangStr(10009), 'HomePageShowAlbums', DefaultHomePageShowAlbums);
    cbxBooks := AddCheckBoxToGroupBoxForProgram(BOOKNIZER_PROGRAM, GetLangStr(20009), 'HomePageShowBooks', DefaultHomePageShowBooks);
    cbxGames := AddCheckBoxToGroupBoxForProgram(GAMENIZER_PROGRAM, GetLangStr(35000), 'HomePageShowGames', DefaultHomePageShowGames);
    cbxPersons := AddCheckBoxToGroupBox(GetLangStr(43), 'HomePageShowPersons', DefaultHomePageShowPersons);
    cbxLitres := AddCheckBoxToGroupBoxForProgram(BOOKNIZER_PROGRAM, GetLangStr(30151), 'HomePageShowLitres', DefaultLitresBlockVisible);
    cbxSupport := AddCheckBoxToGroupBox(GetLangStr(30146), 'HomePageShowSupport', DefaultHomePageShowSupport);
    GroupBoxDeltaOy := GroupBoxDeltaOy + 3;

    labLogo := TLabel.Create(f);
    labLogo.Name := 'labLogo';
    labLogo.Parent := gbShowOnMainPage;
    labLogo.SetBounds(10, GroupBoxDeltaOy + 2, 110, 25);
    labLogo.Caption := GetLangStr(7042);

    comboLogo := TComboBox.Create(f);
    comboLogo.Name := 'comboLogo';
    comboLogo.Parent := gbShowOnMainPage;
    comboLogo.SetBounds(150, GroupBoxDeltaOy, 120, 25);
    comboLogo.Style := csDropDownList;
    comboLogo.Items.Add(GetLangStr(7040));
    comboLogo.Items.Add(GetLangStr(7029));
    comboLogo.Items.Add(GetLangStr(7031));
    comboLogo.ItemIndex := RegReadInteger('HomeLogo', DefaultHomeLogo);
    GroupBoxDeltaOy := GroupBoxDeltaOy + 30;
    gbShowOnMainPage.SetBounds(10, 10, 675, GroupBoxDeltaOy);
    GroupBoxDeltaOy := GroupBoxDeltaOy + 15;

    // buttons
    btnDefault := TButton.Create(form);
    btnDefault.Name := 'btnDefault';
    btnDefault.Parent := form;
    btnDefault.SetBounds(20, {660}form.Height - 56, 160, 25);
    btnDefault.Caption := GetLangStr(1475);
    btnDefault.OnClick := @btnDefaultClick;

    btnSave := TButton.Create(form);
    btnSave.Name := 'btnOK';
    btnSave.Parent := form;
    btnSave.SetBounds(300, {660}form.Height - 56, 80, 25);
    btnSave.Caption := '&OK';
    btnSave.OnClick := @btnSaveClick;
  end;


begin
	s:=GetLangStr(1335);
	form := TForm.Create(nil);
	form.Caption := GetLangStr(1333);
	form.BorderStyle := bsDialog;
	form.Position := poScreenCenter;
	form.Width:=710;
	form.Height:=715;
	form.AutoSize:=false;
  pageOptions := TPageControl.Create(form);
  pageOptions.Parent := form;
  pageOptions.Align := alTop;
  pageOptions.Height := form.Height - 58;
  // Fill general page
  FillScriptOptionsGeneral();
  // Fill movies page
  if (IsProgramUsed(MOVIENIZER_PROGRAM)) then
    FillScriptOptionsMovies(form, pageOptions, btnSaveMoviesCallback, btnDefaultMoviesCallback);
  // Music page
  if (IsProgramUsed(MUSICNIZER_PROGRAM)) then
    FillScriptOptionsMusic(form, pageOptions, btnSaveAlbumsCallback, btnDefaultAlbumsCallback);
  // Books page
  if (IsProgramUsed(BOOKNIZER_PROGRAM)) then
    FillScriptOptionsBooks(form, pageOptions, btnSaveBooksCallback, btnDefaultBooksCallback);
  // Games page
  if (IsProgramUsed(GAMENIZER_PROGRAM)) then
    FillScriptOptionsGames(form, pageOptions, btnSaveGamesCallback, btnDefaultGamesCallback);
	form.ShowModal;
	form.Free;
	result:=s;
end;

begin

end.

