﻿program modern_program_part10;

uses 'modern_program_variables.pas';

procedure FillScriptOptionsMusic(AForm: TForm; APageControl: TPageControl;
  var ASaveButtonCallback: Pointer; var ADefaultButtonCallback: Pointer);
var
	s: string;
	sl: TStringList;
	b: TButton;
	edPopularGenres: TEdit;
	labPopularGenres: TLabel;
	edLinesMovies: TEdit;
	labLinesMovies: TLabel;
	edLinesPeople: TEdit;
	labLinesPeople: TLabel;
	boxUseRating: TCheckBox;
	boxUseSiteRating: TCheckBox;
	boxUseLastUpdated: TCheckBox;
	boxDummyCovers: TCheckBox;
	boxShowCoversInList: TCheckBox;
	boxShowOnlyMoviesInCollection, boxHidePhotosCovers: TCheckBox;
	boxPersonStatsInCollection, boxUseThumbs: TCheckBox;
	my_value: Integer;
	multiThumbGroup: TGroupBox;
	labMaxCoverSize, labCoverX, labThumbCellSize, labThumbCellX, labMaxPhotoSize, labThPhotoCellSize, labPhotoX, labThPhotoCellX, labThumbSize: TLabel;
	edThCoverWidth, edThCoverHeight, edThumbCellWidth, edThumbCellHeight, edThPhotoWidth, edThPhotoHeight, edThPhotoCellWidth, edThPhotoCellHeight, edThumbSize: TEdit;
	boxCutThumb, boxCutPhotoThumb, boxShowPlayBtn: TCheckBox;

  f: TTabSheet;
  pageOptions: TPageControl;
  ThumbsSizeChanged, Thumbs2SizeChanged: Boolean;

function ProgramType(): Integer;
begin
  Result := MUSICNIZER_PROGRAM;
end;

procedure BtnDefaultClick(Sender: TButton);
begin
	ThumbsSizeChanged := True;
	Thumbs2SizeChanged := True;
  edPopularGenres.Text := IntToStr(DEFAULT_GENRES);
  edLinesMovies.Text := IntToStr(DefaultLinesMovies);
  edLinesPeople.Text := IntToStr(DefaultLinesPeople);
  boxUseRating.Checked := True;
  boxUseSiteRating.Checked := True;
  boxUseLastUpdated.Checked := False;
  boxDummyCovers.Checked := True;
  boxShowOnlyMoviesInCollection.Checked := False;
  boxHidePhotosCovers.Checked := False;
  boxPersonStatsInCollection.Checked := False;
  boxUseThumbs.Checked := True;
  boxShowPlayBtn.Checked := False;
  edThCoverWidth.Text := IntToStr(DefaultMultiCoverWidth[ProgramType]);
  edThCoverHeight.Text := IntToStr(DefaultMultiCoverHeight[ProgramType]);
  edThumbCellWidth.Text := IntToStr(DefaultMultiCellWidth[ProgramType]);
  edThumbCellHeight.Text := IntToStr(DefaultMultiCellHeight[ProgramType]);
  boxCutThumb.Checked := True;
  edThPhotoWidth.Text := IntToStr(DefaultMultiCoverWidth[ProgramType]);
  edThPhotoHeight.Text := IntToStr(DefaultMultiCoverHeight[ProgramType]);
  boxCutPhotoThumb.Checked := True;
  edThumbSize.Text := IntToStr(DefaultThumbWidth);
end;

procedure ThumbsChanged(Sender: TObject; var Key: Word);
begin
	ThumbsSizeChanged := True;
end;

procedure Thumbs2Changed(Sender: TObject; var Key: Word);
begin
	Thumbs2SizeChanged := True;
end;

procedure ButtonClick(Sender: TButton);
var
	zn: integer;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    try
      zn:=StrToInt(edPopularGenres.Text);
      RegWriteInteger('PopularGenresAmount', zn);
      zn:=StrToInt(edLinesMovies.Text);
      RegWriteInteger('LinesMovies', zn);
      zn:=StrToInt(edLinesPeople.Text);
      RegWriteInteger('LinesPeople', zn);

      zn:=StrToInt(edThCoverWidth.Text);
      RegWriteInteger('ThCoverWidth', zn);
      zn:=StrToInt(edThCoverHeight.Text);
      RegWriteInteger('ThCoverHeight', zn);
      zn:=StrToInt(edThumbCellWidth.Text);
      RegWriteInteger('ThumbCellWidth', zn);
      zn:=StrToInt(edThumbCellHeight.Text);
      RegWriteInteger('ThumbCellHeight', zn);
      zn:=StrToInt(edThPhotoWidth.Text);
      RegWriteInteger('ThPhotoWidth', zn);
      zn:=StrToInt(edThPhotoHeight.Text);
      RegWriteInteger('ThPhotoHeight', zn);
      zn:=StrToInt(edThumbSize.Text);
      RegWriteInteger('ThumbWidth', zn);
      if boxUseRating.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowRating', zn);
      if boxUseSiteRating.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowSiteRating', zn);
      if boxUseLastUpdated.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowLastUpdated', zn);

      if boxDummyCovers.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowDummyCoversNew', zn);

      if boxShowOnlyMoviesInCollection.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowOnlyMoviesInCollection', zn);

      if boxHidePhotosCovers.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HidePhotosCovers', zn);
      if boxPersonStatsInCollection.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('PersonStatsInCollection', zn);
      if boxUseThumbs.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('UseThumbs', zn);

      if boxCutThumb.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('CutThumb', zn);
      if boxCutPhotoThumb.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('CutPhotoThumb', zn);
      if boxShowPlayBtn.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowPlayBtn4Tracks', zn);
      s:=GetLangStr(1334);
    except
    end;

    MultiShowRowHeight[ProgramType] := RegReadInteger('ThumbCellHeight',
      DefaultMultiCellHeight[ProgramType]);
    MultiShowImageWidth[ProgramType] := RegReadInteger('ThumbCellWidth',
      DefaultMultiCellWidth[ProgramType]);

    if Thumbs2SizeChanged then
    begin
      if ThumbsSizeChanged then
        ClearThumb(Thumbs2)
      else
        ClearThumb(Thumbs2, True);
    end;
    if ThumbsSizeChanged then begin
      ClearThumb(Thumbs, True);
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    pageOptions := APageControl;

    f := TTabSheet.Create(pageOptions);
    f.Caption := GetLangStr(10349);
    f.Parent := pageOptions;
    f.PageControl := pageOptions;

    ThumbsSizeChanged := False;
    Thumbs2SizeChanged := False;

    labPopularGenres := TLabel.Create(f);
    labPopularGenres.Name := 'labPopularGenres';
    labPopularGenres.Parent := f;
    labPopularGenres.SetBounds(10, 20, 110, 25);
    labPopularGenres.Caption := GetLangStr(1300);

    edPopularGenres := TEdit.Create(f);
    edPopularGenres.Name := 'edPopularGenres';
    edPopularGenres.Parent := f;
    edPopularGenres.SetBounds(480, 20, 20, 25);
    edPopularGenres.Text := IntToStr(RegReadInteger('PopularGenresAmount', DEFAULT_GENRES));

    labLinesMovies:=TLabel.Create(f);
    labLinesMovies.Name := 'labLinesMovies';
    labLinesMovies.Parent := f;
    labLinesMovies.SetBounds(10, 45, 110, 25);
    labLinesMovies.Caption := GetLangStr(1414);

    edLinesMovies := TEdit.Create(f);
    edLinesMovies.Name := 'edLinesMovies';
    edLinesMovies.Parent := f;
    edLinesMovies.SetBounds(480, 45, 20, 25);
    edLinesMovies.Text := IntToStr(RegReadInteger('LinesMovies', DefaultLinesMovies));

    labLinesPeople:=TLabel.Create(f);
    labLinesPeople.Name := 'labLinesPeople';
    labLinesPeople.Parent := f;
    labLinesPeople.SetBounds(10, 70, 110, 25);
    labLinesPeople.Caption := GetLangStr(1415);

    edLinesPeople := TEdit.Create(f);
    edLinesPeople.Name := 'edLinesPeople';
    edLinesPeople.Parent := f;
    edLinesPeople.SetBounds(480, 70, 20, 25);
    edLinesPeople.Text := IntToStr(RegReadInteger('LinesPeople', DefaultLinesPeople));

    boxUseRating := TCheckBox.Create(f);
    boxUseRating.Name := 'boxUseRating';
    boxUseRating.Parent := f;
    boxUseRating.SetBounds(10, 90, 350, 20);
    boxUseRating.Caption := GetLangStr(1420);
    my_value := RegReadInteger('ShowRating', 1);
    if my_value=1 then
      boxUseRating.Checked := True;

    boxUseSiteRating := TCheckBox.Create(f);
    boxUseSiteRating.Name := 'boxUseSiteRating';
    boxUseSiteRating.Parent := f;
    boxUseSiteRating.SetBounds(10, 110, 350, 20);
    boxUseSiteRating.Caption := GetLangStr(1533);
    my_value := RegReadInteger('ShowSiteRating', 1);
    if my_value=1 then
      boxUseSiteRating.Checked := True;

    boxUseLastUpdated := TCheckBox.Create(f);
    boxUseLastUpdated.Name := 'boxUseLastUpdated';
    boxUseLastUpdated.Parent := f;
    boxUseLastUpdated.SetBounds(10, 130, 350, 20);
    boxUseLastUpdated.Caption := GetLangStr(1423);
    my_value := RegReadInteger('ShowLastUpdated', 0);
    if my_value=1 then
      boxUseLastUpdated.Checked := True;

    boxDummyCovers := TCheckBox.Create(f);
    boxDummyCovers.Name := 'boxDummyCovers';
    boxDummyCovers.Parent := f;
    boxDummyCovers.SetBounds(10, 150, 350, 20);
    boxDummyCovers.Caption := GetLangStr(10400);
    my_value := RegReadInteger('ShowDummyCoversNew', 1);
    if my_value=1 then
      boxDummyCovers.Checked := True;

    boxShowOnlyMoviesInCollection := TCheckBox.Create(f);
    boxShowOnlyMoviesInCollection.Name := 'boxShowOnlyMoviesInCollection';
    boxShowOnlyMoviesInCollection.Parent := f;
    boxShowOnlyMoviesInCollection.SetBounds(10, 170, 350, 20);
    boxShowOnlyMoviesInCollection.Caption := GetLangStr(10401);
    my_value := RegReadInteger('ShowOnlyMoviesInCollection', 0);
    if my_value=1 then
      boxShowOnlyMoviesInCollection.Checked := True;


    boxHidePhotosCovers := TCheckBox.Create(f);
    boxHidePhotosCovers.Name := 'boxHidePhotosCovers';
    boxHidePhotosCovers.Parent := f;
    boxHidePhotosCovers.SetBounds(10, 190, 420, 20);
    boxHidePhotosCovers.Caption := GetLangStr(10402);
    my_value := RegReadInteger('HidePhotosCovers', 0);
    if my_value=1 then
      boxHidePhotosCovers.Checked := True;

    boxPersonStatsInCollection := TCheckBox.Create(f);
    boxPersonStatsInCollection.Name := 'boxPersonStatsInCollection';
    boxPersonStatsInCollection.Parent := f;
    boxPersonStatsInCollection.SetBounds(10, 210, 350, 20);
    boxPersonStatsInCollection.Caption := GetLangStr(10403);
    my_value := RegReadInteger('PersonStatsInCollection', 0);
    if my_value=1 then
      boxPersonStatsInCollection.Checked := True;

    boxUseThumbs := TCheckBox.Create(f);
    boxUseThumbs.Name := 'boxUseThumbs';
    boxUseThumbs.Parent := f;
    boxUseThumbs.SetBounds(10, 230, 350, 20);
    boxUseThumbs.Caption := GetLangStr(1476);
    my_value := RegReadInteger('UseThumbs', 1);
    if my_value = 1 then
      boxUseThumbs.Checked := True;

    boxShowPlayBtn := TCheckBox.Create(f);
    boxShowPlayBtn.Name := 'boxShowPlayBtn';
    boxShowPlayBtn.Parent := f;
    boxShowPlayBtn.SetBounds(10, 250, 350, 20);
    boxShowPlayBtn.Caption := GetLangStr(2952);
    my_value := RegReadInteger('ShowPlayBtn4Tracks', 0);
    if my_value = 1 then
      boxShowPlayBtn.Checked := True;

    multiThumbGroup := TGroupBox.Create(f);
    multiThumbGroup.Name := 'multiThumbGroup';
    multiThumbGroup.Parent := f;
    multiThumbGroup.SetBounds(10, 270, 490, 130);
    multiThumbGroup.Caption := GetLangStr(1467);

    labMaxCoverSize := TLabel.Create(f);
    labMaxCoverSize.Name := 'labMaxCoverSize';
    labMaxCoverSize.Parent := f;
    labMaxCoverSize.SetBounds(20, 290, 100, 25);
    labMaxCoverSize.Caption := GetLangStr(1468);

    edThCoverWidth := TEdit.Create(f);
    edThCoverWidth.Name := 'edThCoverWidth';
    edThCoverWidth.Parent := f;
    edThCoverWidth.SetBounds(400, 285, 30, 25);
    edThCoverWidth.Text := IntToStr(RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[ProgramType]));

    labCoverX := TLabel.Create(f);
    labCoverX.Name := 'labCoverX';
    labCoverX.Parent := f;
    labCoverX.SetBounds(435, 290, 10, 20);
    labCoverX.Caption := 'X';

    edThCoverHeight := TEdit.Create(f);
    edThCoverHeight.Name := 'edThCoverHeight';
    edThCoverHeight.Parent := f;
    edThCoverHeight.SetBounds(450, 285, 30, 25);
    edThCoverHeight.Text := IntToStr(RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[ProgramType]));

    labThumbCellSize := TLabel.Create(f);
    labThumbCellSize.Name := 'labThumbCellSize';
    labThumbCellSize.Parent := f;
    labThumbCellSize.SetBounds(20, 310, 100, 25);
    labThumbCellSize.Caption := GetLangStr(1469);

    edThumbCellWidth := TEdit.Create(f);
    edThumbCellWidth.Name := 'edThumbCellWidth';
    edThumbCellWidth.Parent := f;
    edThumbCellWidth.SetBounds(400, 310, 30, 25);
    edThumbCellWidth.Text := IntToStr(RegReadInteger('ThumbCellWidth', DefaultMultiCellWidth[ProgramType]));

    labThumbCellX := TLabel.Create(f);
    labThumbCellX.Name := 'labThumbCellX';
    labThumbCellX.Parent := f;
    labThumbCellX.SetBounds(435, 315, 10, 20);
    labThumbCellX.Caption := 'X';

    edThumbCellHeight := TEdit.Create(f);
    edThumbCellHeight.Name := 'edThumbCellHeight';
    edThumbCellHeight.Parent := f;
    edThumbCellHeight.SetBounds(450, 310, 30, 25);
    edThumbCellHeight.Text := IntToStr(RegReadInteger('ThumbCellHeight', DefaultMultiCellHeight[ProgramType]));

    boxCutThumb := TCheckBox.Create(f);
    boxCutThumb.Name := 'boxCutThumb';
    boxCutThumb.Parent := f;
    boxCutThumb.SetBounds(20, 330, 300, 20);
    boxCutThumb.Caption := GetLangStr(1471);
    my_value := RegReadInteger('CutThumb', 1);
    if my_value = 1 then
      boxCutThumb.Checked := True;

    labMaxPhotoSize := TLabel.Create(f);
    labMaxPhotoSize.Name := 'labMaxPhotoSize';
    labMaxPhotoSize.Parent := f;
    labMaxPhotoSize.SetBounds(20, 355, 100, 20);
    labMaxPhotoSize.Caption := GetLangStr(1472);

    edThPhotoWidth := TEdit.Create(f);
    edThPhotoWidth.Name := 'edThPhotoWidth';
    edThPhotoWidth.Parent := f;
    edThPhotoWidth.SetBounds(400, 350, 30, 25);
    edThPhotoWidth.Text := IntToStr(RegReadInteger('ThPhotoWidth', DefaultMultiCoverWidth[ProgramType]));

    labPhotoX := TLabel.Create(f);
    labPhotoX.Name := 'labPhotoX';
    labPhotoX.Parent := f;
    labPhotoX.SetBounds(435, 355, 10, 20);
    labPhotoX.Caption := 'X';

    edThPhotoHeight := TEdit.Create(f);
    edThPhotoHeight.Name := 'edThPhotoHeight';
    edThPhotoHeight.Parent := f;
    edThPhotoHeight.SetBounds(450, 350, 30, 25);
    edThPhotoHeight.Text := IntToStr(RegReadInteger('ThPhotoHeight', DefaultMultiCoverHeight[ProgramType]));

    boxCutPhotoThumb := TCheckBox.Create(f);
    boxCutPhotoThumb.Name := 'boxCutPhotoThumb';
    boxCutPhotoThumb.Parent := f;
    boxCutPhotoThumb.SetBounds(20, 375, 300, 20);
    boxCutPhotoThumb.Caption := GetLangStr(1474);
    my_value := RegReadInteger('CutPhotoThumb', 1);
    if my_value = 1 then
      boxCutPhotoThumb.Checked := True;

    labThumbSize := TLabel.Create(f);
    labThumbSize.Name := 'labThumbSize';
    labThumbSize.Parent := f;
    labThumbSize.SetBounds(20, 410, 300, 20);
    labThumbSize.Caption := GetLangStr(1497);

    edThumbSize := TEdit.Create(f);
    edThumbSize.Name := 'edThumbSize';
    edThumbSize.Parent := f;
    edThumbSize.SetBounds(450, 405, 30, 25);
    edThumbSize.Text := IntToStr(RegReadInteger('ThumbWidth', DefaultThumbWidth));


    ASaveButtonCallback := @ButtonClick;
    ADefaultButtonCallback := @BtnDefaultClick;
  finally
    ResetRegistrySubKey();
  end;
end;

begin

end.