﻿program modern_program_part11;

uses 'modern_program_variables.pas';

procedure FillScriptOptionsBooks(AForm: TForm; APageControl: TPageControl;
  var ASaveButtonCallback: Pointer; var ADefaultButtonCallback: Pointer);
var
	s: string;
	sl: TStringList;
	b, btnDefault: TButton;
	edPopularGenres: TEdit;
	labPopularGenres: TLabel;
	edLinesMovies: TEdit;
	labLinesMovies: TLabel;
	edLinesPeople: TEdit;
	labLinesPeople: TLabel;
	edShots: TEdit;
	labShots: TLabel;
	edPhotos: TEdit;
	labPhotos, labRemoveAdult: TLabel;
	boxUseRating: TCheckBox;
	boxUseSiteRating: TCheckBox;
	boxShowEditions: TCheckBox;
	boxDummyCovers: TCheckBox;
	boxShowCoversInList: TCheckBox;
	boxShowOnlyMoviesInCollection, boxHideNavi, boxHidePhotosCovers, boxShowFileNames: TCheckBox;
	boxShowAwards, boxShowSeasons, boxMinimaList, boxPersonStatsInCollection: TCheckBox;
	boxShotTab, boxPosterTab, boxAwardsTab, boxActorTab, boxParameterTab, boxLoanTab, boxSeasonTab, boxDescriptionTab, boxTrailerTab: TCheckBox;
	tabGroup, multiThumbGroup, homeTabGroup: TGroupBox;
	labMaxCoverSize, labCoverX, labThumbCellSize, labThumbCellX, labMaxPhotoSize, labThPhotoCellSize, labPhotoX, labThPhotoCellX, labThumbSize: TLabel;
	edThCoverWidth, edThCoverHeight, edThumbCellWidth, edThumbCellHeight, edThPhotoWidth, edThPhotoHeight, edThPhotoCellWidth, edThPhotoCellHeight, edThumbSize: TEdit;
	boxCutThumb, boxCutPhotoThumb, boxUseThumbs, boxShowLogos: TCheckBox;
	boxHomeLastAdded, boxHomeLastUpdated, boxHomeBestRated, boxHomeUnread, boxShowAgePublished, boxSortBiblioBySeries: TCheckBox;
	my_value: Integer;

  f: TTabSheet;
  pageOptions: TPageControl;
  ThumbsSizeChanged, Thumbs2SizeChanged: Boolean;

function ProgramType(): Integer;
begin
  Result := BOOKNIZER_PROGRAM;
end;

procedure BtnDefaultClick(Sender: TButton);
begin
	ThumbsSizeChanged := True;
	Thumbs2SizeChanged := True;
	edPopularGenres.Text := IntToStr(DEFAULT_GENRES);
	edLinesMovies.Text := IntToStr(DefaultLinesMovies);
	edLinesPeople.Text := IntToStr(DefaultLinesPeople);
	edThCoverWidth.Text := IntToStr(DefaultMultiCoverWidth[ProgramType]);
	edThCoverHeight.Text := IntToStr(DefaultMultiCoverHeight[ProgramType]);
	edThumbCellWidth.Text := IntToStr(DefaultMultiCellWidth[ProgramType]);
	edThumbCellHeight.Text := IntToStr(DefaultMultiCellHeight[ProgramType]);
	boxCutThumb.Checked := True;
	edThPhotoWidth.Text := IntToStr(DefaultMultiCoverWidth[ProgramType]);
	edThPhotoHeight.Text := IntToStr(DefaultMultiCoverHeight[ProgramType]);
	edThumbSize.Text := IntToStr(DefaultThumbWidth);
	boxCutPhotoThumb.Checked := True;
	boxUseRating.Checked := True;
	boxUseSiteRating.Checked := True;
	boxShowEditions.Checked := True;
	boxDummyCovers.Checked := True;
	boxShowOnlyMoviesInCollection.Checked := False;
	boxHidePhotosCovers.Checked := False;
	boxShowCoversInList.Checked := True;
	boxMinimaList.Checked := False;
	boxPersonStatsInCollection.Checked := False;
	boxUseThumbs.Checked := True;
	boxShowFileNames.Checked := False;
	boxShowLogos.Checked := True;
	boxHomeLastAdded.Checked := True;
	boxHomeLastUpdated.Checked := True;
	boxHomeBestRated.Checked := True;
	boxHomeUnread.Checked := True;
	boxShowAgePublished.Checked := True;
	boxSortBiblioBySeries.Checked := True;
end;

procedure ThumbsChanged(Sender: TObject; var Key: Word);
begin
	ThumbsSizeChanged := True;
end;

procedure Thumbs2Changed(Sender: TObject; var Key: Word);
begin
	Thumbs2SizeChanged := True;
end;

procedure ButtonClick(Sender: TButton);
var
	zn: integer;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    try
      zn:=StrToInt(edPopularGenres.Text);
      RegWriteInteger('PopularGenresAmount', zn);
      zn:=StrToInt(edLinesMovies.Text);
      RegWriteInteger('LinesMovies', zn);
      zn:=StrToInt(edLinesPeople.Text);
      RegWriteInteger('LinesPeople', zn);
      zn:=StrToInt(edThCoverWidth.Text);
      RegWriteInteger('ThCoverWidth', zn);
      zn:=StrToInt(edThCoverHeight.Text);
      RegWriteInteger('ThCoverHeight', zn);
      zn:=StrToInt(edThumbCellWidth.Text);
      RegWriteInteger('ThumbCellWidth', zn);
      zn:=StrToInt(edThumbCellHeight.Text);
      RegWriteInteger('ThumbCellHeight', zn);
      zn:=StrToInt(edThPhotoWidth.Text);
      RegWriteInteger('ThPhotoWidth', zn);
      zn:=StrToInt(edThPhotoHeight.Text);
      RegWriteInteger('ThPhotoHeight', zn);
      zn:=StrToInt(edThumbSize.Text);
      RegWriteInteger('ThumbWidth', zn);
      if boxUseRating.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowRating', zn);
      if boxUseSiteRating.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowSiteRating', zn);
      if boxShowEditions.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowEditions', zn);
      if boxDummyCovers.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowDummyCoversNew', zn);
      if boxShowCoversInList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowCoversInList', zn);
      if boxShowOnlyMoviesInCollection.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowOnlyMoviesInCollection', zn);
      if boxHidePhotosCovers.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HidePhotosCovers', zn);
      if boxMinimaList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('MinimaList', zn);
      if boxPersonStatsInCollection.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('PersonStatsInCollection', zn);
      if boxCutThumb.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('CutThumb', zn);
      if boxCutPhotoThumb.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('CutPhotoThumb', zn);
      if boxUseThumbs.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('UseThumbs', zn);
      if boxShowFileNames.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowFileNames', zn);
      if boxShowLogos.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowFormatLogos', zn);

      if boxHomeLastAdded.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HomeLastAdded', zn);
      if boxHomeLastUpdated.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HomeLastUpdated', zn);
      if boxHomeBestRated.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HomeBestRated', zn);
      if boxHomeUnread.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HomeUnread', zn);
      if boxShowAgePublished.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowAgePublished', zn);
      if boxSortBiblioBySeries.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('SortBiblioBySeries', zn);
      s:=GetLangStr(1334);
    except
    end;

    MultiShowRowHeight[ProgramType] := RegReadInteger('ThumbCellHeight',
      DefaultMultiCellHeight[ProgramType]);
    MultiShowImageWidth[ProgramType] := RegReadInteger('ThumbCellWidth',
      DefaultMultiCellWidth[ProgramType]);

    if Thumbs2SizeChanged then
    begin
      if ThumbsSizeChanged then
        ClearThumb(Thumbs2)
      else
        ClearThumb(Thumbs2, True);
    end;
    if ThumbsSizeChanged then begin
      ClearThumb(Thumbs, True);
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    pageOptions := APageControl;

    f := TTabSheet.Create(pageOptions);
    f.Caption := GetLangStr(20009);
    f.Parent := pageOptions;
    f.PageControl := pageOptions;

    ThumbsSizeChanged := False;
    Thumbs2SizeChanged := False;

    multiThumbGroup := TGroupBox.Create(f);
    multiThumbGroup.Name := 'multiThumbGroup';
    multiThumbGroup.Parent := f;
    multiThumbGroup.SetBounds(10, 10, 360, 140);
    multiThumbGroup.Caption := GetLangStr(1467);

    labMaxCoverSize := TLabel.Create(f);
    labMaxCoverSize.Name := 'labMaxCoverSize';
    labMaxCoverSize.Parent := f;
    labMaxCoverSize.SetBounds(20, 35, 100, 25);
    labMaxCoverSize.Caption := GetLangStr(1468);

    edThCoverWidth := TEdit.Create(f);
    edThCoverWidth.Name := 'edThCoverWidth';
    edThCoverWidth.Parent := f;
    edThCoverWidth.SetBounds(280, 30, 30, 25);
    edThCoverWidth.Text := IntToStr(RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[ProgramType]));

    labCoverX := TLabel.Create(f);
    labCoverX.Name := 'labCoverX';
    labCoverX.Parent := f;
    labCoverX.SetBounds(315, 35, 10, 20);
    labCoverX.Caption := 'X';

    edThCoverHeight := TEdit.Create(f);
    edThCoverHeight.Name := 'edThCoverHeight';
    edThCoverHeight.Parent := f;
    edThCoverHeight.SetBounds(330, 30, 30, 25);
    edThCoverHeight.Text := IntToStr(RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[ProgramType]));

    labThumbCellSize := TLabel.Create(f);
    labThumbCellSize.Name := 'labThumbCellSize';
    labThumbCellSize.Parent := f;
    labThumbCellSize.SetBounds(20, 60, 100, 25);
    labThumbCellSize.Caption := GetLangStr(1469);

    edThumbCellWidth := TEdit.Create(f);
    edThumbCellWidth.Name := 'edThumbCellWidth';
    edThumbCellWidth.Parent := f;
    edThumbCellWidth.SetBounds(280, 55, 30, 25);
    edThumbCellWidth.Text := IntToStr(RegReadInteger('ThumbCellWidth', DefaultMultiCellWidth[ProgramType]));

    labThumbCellX := TLabel.Create(f);
    labThumbCellX.Name := 'labThumbCellX';
    labThumbCellX.Parent := f;
    labThumbCellX.SetBounds(315, 60, 10, 20);
    labThumbCellX.Caption := 'X';

    edThumbCellHeight := TEdit.Create(f);
    edThumbCellHeight.Name := 'edThumbCellHeight';
    edThumbCellHeight.Parent := f;
    edThumbCellHeight.SetBounds(330, 55, 30, 25);
    edThumbCellHeight.Text := IntToStr(RegReadInteger('ThumbCellHeight', DefaultMultiCellHeight[ProgramType]));

    boxCutThumb := TCheckBox.Create(f);
    boxCutThumb.Name := 'boxCutThumb';
    boxCutThumb.Parent := f;
    boxCutThumb.SetBounds(20, 80, 300, 20);
    boxCutThumb.Caption := GetLangStr(1471);
    my_value := RegReadInteger('CutThumb', 1);
    if my_value = 1 then
      boxCutThumb.Checked := True;

    labMaxPhotoSize := TLabel.Create(f);
    labMaxPhotoSize.Name := 'labMaxPhotoSize';
    labMaxPhotoSize.Parent := f;
    labMaxPhotoSize.SetBounds(20, 105, 100, 20);
    labMaxPhotoSize.Caption := GetLangStr(1472);

    edThPhotoWidth := TEdit.Create(f);
    edThPhotoWidth.Name := 'edThPhotoWidth';
    edThPhotoWidth.Parent := f;
    edThPhotoWidth.SetBounds(280, 100, 30, 25);
    edThPhotoWidth.Text := IntToStr(RegReadInteger('ThPhotoWidth', DefaultMultiCoverWidth[ProgramType]));

    labPhotoX := TLabel.Create(f);
    labPhotoX.Name := 'labPhotoX';
    labPhotoX.Parent := f;
    labPhotoX.SetBounds(315, 105, 10, 20);
    labPhotoX.Caption := 'X';

    edThPhotoHeight := TEdit.Create(f);
    edThPhotoHeight.Name := 'edThPhotoHeight';
    edThPhotoHeight.Parent := f;
    edThPhotoHeight.SetBounds(330, 100, 30, 25);
    edThPhotoHeight.Text := IntToStr(RegReadInteger('ThPhotoHeight', DefaultMultiCoverHeight[ProgramType]));

    boxCutPhotoThumb := TCheckBox.Create(f);
    boxCutPhotoThumb.Name := 'boxCutPhotoThumb';
    boxCutPhotoThumb.Parent := f;
    boxCutPhotoThumb.SetBounds(20, 125, 300, 20);
    boxCutPhotoThumb.Caption := GetLangStr(1474);
    my_value := RegReadInteger('CutPhotoThumb', 1);
    if my_value = 1 then
      boxCutPhotoThumb.Checked := True;

    homeTabGroup := TGroupBox.Create(f);
    homeTabGroup.Name := 'homeTabGroup';
    homeTabGroup.Parent := f;
    homeTabGroup.SetBounds(10, 150, 360, 60);
    homeTabGroup.Caption := GetLangStr(2971);

    boxHomeLastAdded := TCheckBox.Create(f);
    boxHomeLastAdded.Name := 'boxHomeLastAdded';
    boxHomeLastAdded.Parent := f;
    boxHomeLastAdded.SetBounds(20, 165, 150, 20);
    boxHomeLastAdded.Caption := GetLangStr(2960);
    my_value := RegReadInteger('HomeLastAdded', 1);
    if my_value = 1 then
      boxHomeLastAdded.Checked := True;

    boxHomeLastUpdated := TCheckBox.Create(f);
    boxHomeLastUpdated.Name := 'boxHomeLastUpdated';
    boxHomeLastUpdated.Parent := f;
    boxHomeLastUpdated.SetBounds(20, 185, 150, 20);
    boxHomeLastUpdated.Caption := GetLangStr(2961);
    my_value := RegReadInteger('HomeLastUpdated', 1);
    if my_value = 1 then
      boxHomeLastUpdated.Checked := True;

    boxHomeBestRated := TCheckBox.Create(f);
    boxHomeBestRated.Name := 'boxHomeBestRated';
    boxHomeBestRated.Parent := f;
    boxHomeBestRated.SetBounds(200, 165, 150, 20);
    boxHomeBestRated.Caption := GetLangStr(2962);
    my_value := RegReadInteger('HomeBestRated', 1);
    if my_value = 1 then
      boxHomeBestRated.Checked := True;

    boxHomeUnread := TCheckBox.Create(f);
    boxHomeUnread.Name := 'boxHomeUnread';
    boxHomeUnread.Parent := f;
    boxHomeUnread.SetBounds(200, 185, 150, 20);
    boxHomeUnread.Caption := GetLangStr(2963);
    my_value := RegReadInteger('HomeUnread', 1);
    if my_value = 1 then
      boxHomeUnread.Checked := True;

    boxUseThumbs := TCheckBox.Create(f);
    boxUseThumbs.Name := 'boxUseThumbs';
    boxUseThumbs.Parent := f;
    boxUseThumbs.SetBounds(10, 210, 300, 20);
    boxUseThumbs.Caption := GetLangStr(1476);
    my_value := RegReadInteger('UseThumbs', 1);
    if my_value = 1 then
      boxUseThumbs.Checked := True;

    boxUseRating := TCheckBox.Create(f);
    boxUseRating.Name := 'boxUseRating';
    boxUseRating.Parent := f;
    boxUseRating.SetBounds(10, 230, 300, 20);
    boxUseRating.Caption := GetLangStr(1420);
    my_value := RegReadInteger('ShowRating', 1);
    if my_value=1 then
      boxUseRating.Checked := True;

    boxUseSiteRating := TCheckBox.Create(f);
    boxUseSiteRating.Name := 'boxUseSiteRating';
    boxUseSiteRating.Parent := f;
    boxUseSiteRating.SetBounds(10, 250, 300, 20);
    boxUseSiteRating.Caption := GetLangStr(1533);
    my_value := RegReadInteger('ShowSiteRating', 1);
    if my_value=1 then
      boxUseSiteRating.Checked := True;


    boxShowEditions := TCheckBox.Create(f);
    boxShowEditions.Name := 'boxShowEditions';
    boxShowEditions.Parent := f;
    boxShowEditions.SetBounds(10, 270, 350, 20);
    boxShowEditions.Caption := GetLangStr(1424);
    my_value := RegReadInteger('ShowEditions', 1);
    if my_value=1 then
      boxShowEditions.Checked := True;

    boxDummyCovers := TCheckBox.Create(f);
    boxDummyCovers.Name := 'boxDummyCovers';
    boxDummyCovers.Parent := f;
    boxDummyCovers.SetBounds(10, 290, 350, 20);
    boxDummyCovers.Caption := GetLangStr(2957);
    my_value := RegReadInteger('ShowDummyCoversNew', 1);
    if my_value=1 then
      boxDummyCovers.Checked := True;

    boxShowOnlyMoviesInCollection := TCheckBox.Create(f);
    boxShowOnlyMoviesInCollection.Name := 'boxShowOnlyMoviesInCollection';
    boxShowOnlyMoviesInCollection.Parent := f;
    boxShowOnlyMoviesInCollection.SetBounds(10, 310, 350, 20);
    boxShowOnlyMoviesInCollection.Caption := GetLangStr(2954);
    my_value := RegReadInteger('ShowOnlyMoviesInCollection', 0);
    if my_value=1 then
      boxShowOnlyMoviesInCollection.Checked := True;


    boxHidePhotosCovers := TCheckBox.Create(f);
    boxHidePhotosCovers.Name := 'boxHidePhotosCovers';
    boxHidePhotosCovers.Parent := f;
    boxHidePhotosCovers.SetBounds(10, 330, 380, 20);
    boxHidePhotosCovers.Caption := GetLangStr(2955);
    my_value := RegReadInteger('HidePhotosCovers', 0);
    if my_value=1 then
      boxHidePhotosCovers.Checked := True;


    boxShowCoversInList := TCheckBox.Create(f);
    boxShowCoversInList.Name := 'boxShowCoversInList';
    boxShowCoversInList.Parent := f;
    boxShowCoversInList.SetBounds(10, 350, 350, 20);
    boxShowCoversInList.Caption := GetLangStr(2956);
    my_value := RegReadInteger('ShowCoversInList', 1);
    if my_value=1 then
      boxShowCoversInList.Checked := True;

    boxMinimaList := TCheckBox.Create(f);
    boxMinimaList.Name := 'boxMinimaList';
    boxMinimaList.Parent := f;
    boxMinimaList.SetBounds(10, 370, 350, 20);
    boxMinimaList.Caption := GetLangStr(1436);
    my_value := RegReadInteger('MinimaList', 0);
    if my_value=1 then
      boxMinimaList.Checked := True;

    boxPersonStatsInCollection := TCheckBox.Create(f);
    boxPersonStatsInCollection.Name := 'boxPersonStatsInCollection';
    boxPersonStatsInCollection.Parent := f;
    boxPersonStatsInCollection.SetBounds(10, 390, 350, 20);
    boxPersonStatsInCollection.Caption := GetLangStr(1451);
    my_value := RegReadInteger('PersonStatsInCollection', 0);
    if my_value=1 then
      boxPersonStatsInCollection.Checked := True;

    boxShowFileNames := TCheckBox.Create(f);
    boxShowFileNames.Name := 'boxShowFileNames';
    boxShowFileNames.Parent := f;
    boxShowFileNames.SetBounds(10, 410, 350, 20);
    boxShowFileNames.Caption := GetLangStr(2965);
    my_value := RegReadInteger('ShowFileNames', 0);
    if my_value=1 then
      boxShowFileNames.Checked := True;

    boxShowLogos := TCheckBox.Create(f);
    boxShowLogos.Name := 'boxShowLogos';
    boxShowLogos.Parent := f;
    boxShowLogos.SetBounds(10, 430, 350, 20);
    boxShowLogos.Caption := GetLangStr(1494);
    my_value := RegReadInteger('ShowFormatLogos', 1);
    if my_value=1 then
      boxShowLogos.Checked := True;

    boxShowAgePublished := TCheckBox.Create(f);
    boxShowAgePublished.Name := 'boxShowAgePublished';
    boxShowAgePublished.Parent := f;
    boxShowAgePublished.SetBounds(10, 450, 380, 20);
    boxShowAgePublished.Caption := GetLangStr(7016);
    my_value := RegReadInteger('ShowAgePublished', 1);
    if my_value=1 then
      boxShowAgePublished.Checked := True;

    boxSortBiblioBySeries := TCheckBox.Create(f);
    boxSortBiblioBySeries.Name := 'boxSortBiblioBySeries';
    boxSortBiblioBySeries.Parent := f;
    boxSortBiblioBySeries.SetBounds(10, 470, 380, 20);
    boxSortBiblioBySeries.Caption := GetLangStr(7017);
    my_value := RegReadInteger('SortBiblioBySeries', 1);
    if my_value=1 then
      boxSortBiblioBySeries.Checked := True;

    labLinesMovies:=TLabel.Create(f);
    labLinesMovies.Name := 'labLinesMovies';
    labLinesMovies.Parent := f;
    labLinesMovies.SetBounds(10, 495, 110, 25);
    labLinesMovies.Caption := GetLangStr(1414);

    edLinesMovies := TEdit.Create(f);
    edLinesMovies.Name := 'edLinesMovies';
    edLinesMovies.Parent := f;
    edLinesMovies.SetBounds(300, 495, 20, 25);
    edLinesMovies.Text := IntToStr(RegReadInteger('LinesMovies', DefaultLinesMovies));

    labLinesPeople:=TLabel.Create(f);
    labLinesPeople.Name := 'labLinesPeople';
    labLinesPeople.Parent := f;
    labLinesPeople.SetBounds(10, 520, 110, 25);
    labLinesPeople.Caption := GetLangStr(1415);

    edLinesPeople := TEdit.Create(f);
    edLinesPeople.Name := 'edLinesPeople';
    edLinesPeople.Parent := f;
    edLinesPeople.SetBounds(300, 520, 20, 25);
    edLinesPeople.Text := IntToStr(RegReadInteger('LinesPeople', DefaultLinesPeople));

    labPopularGenres := TLabel.Create(f);
    labPopularGenres.Name := 'labPopularGenres';
    labPopularGenres.Parent := f;
    labPopularGenres.SetBounds(10, 545, 110, 25);
    labPopularGenres.Caption := GetLangStr(1300);

    edPopularGenres := TEdit.Create(f);
    edPopularGenres.Name := 'edPopularGenres';
    edPopularGenres.Parent := f;
    edPopularGenres.SetBounds(300, 545, 20, 25);
    edPopularGenres.Text := IntToStr(RegReadInteger('PopularGenresAmount', DEFAULT_GENRES));

    labThumbSize := TLabel.Create(f);
    labThumbSize.Name := 'labThumbSize';
    labThumbSize.Parent := f;
    labThumbSize.SetBounds(10, 570, 280, 20);
    labThumbSize.Caption := GetLangStr(1497);

    edThumbSize := TEdit.Create(f);
    edThumbSize.Name := 'edThumbSize';
    edThumbSize.Parent := f;
    edThumbSize.SetBounds(300, 570, 30, 25);
    edThumbSize.Text := IntToStr(RegReadInteger('ThumbWidth', DefaultThumbWidth));

    ASaveButtonCallback := @ButtonClick;
    ADefaultButtonCallback := @BtnDefaultClick;
  finally
    ResetRegistrySubKey();
  end;
end;

begin

end.
