﻿program modern_program_part13;

uses 'modern_program_variables.pas', 'modern_program_global.pas';

//показ уменьшенной карточки человека
function GetThumbnailPersonGame(code, mode: integer; Name: string): string;
var
  sl: TStringList;
  s, rate, FileName, img, PersonName, BirthDate: string;
  fl, PersonStatsInCollection: boolean;
  j, kol, amount, RecordCount, DirectorCount, ActorCount, years: integer;
  InCollection, rating: integer;
  ThumbsPath, FileIn, FileOut: string;
  BigOpen, BigClose, SmallOpen, SmallClose, CheckMode: string;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[GAMENIZER_PROGRAM]);
  try
    sl:=TStringList.Create;

    if mode=1 then
      amount:=3
    else
      amount:=7;
    s:='';

    ThumbsPath:=ImagesPath+Thumbs+'\';

      fl:=false;

      with sl do begin
        Clear;
        Add('select p.code, p.name, p.in_collection, p.birth_date, p.rating, i.path from persons p');
        Add('left outer join images i on i.person=p.code and i.mode=6');
        Add(format('where p.code=%d', [code]));
        Add('order by i.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      PersonName:=GetStringField('p.name');
      InCollection:=GetIntegerField('p.in_collection');
      rating:=GetIntegerField('p.rating');

      if rating>0 then
        rate:=format(' <img src="%sstar.gif" width=16 height=16 border=0 align="absmiddle">%d', [ImgPath, rating])
      else
        rate:='';

      BirthDate:=GetStringField('p.birth_date');
      if BirthDate<>'' then
        BirthDate:=Date2Str(BirthDate);

      //получаем дополнительную информацию о фильме, если он из коллекции
      if InCollection=1 then begin
        //обложка
        if GetStringField('i.path')<>'' then begin
  //      	FileName:=ImagesPath+GetStringField('i.path');

          FileIn:=ImagesPath+GetStringField('i.path');
          FileName:=ThumbsPath+GetStringField('i.path');
          if MyFileExists(FileIn) then begin
            if not MyFileExists(FileName) then begin
              //ShowMessage('Convert '+FileIn+' to '+FileName);
              ConvertThumb3(FileIn, FileName, Thumbs, RegReadInteger('ThumbWidth', DefaultThumbWidth), 0, False);
            end;
            if not MyFileExists(FileName) then
              FileName:=FileIn;
          end
          else
            FileName:=FileIn;

          if MyFileExists(FileName) then
            fl:=true;
        end;
        if not fl then begin
          FileIn:=ImgPath + NO_PHOTO_FILE[GAMENIZER_PROGRAM];
      FileName:=ThumbsPath + NO_PHOTO_FILE[GAMENIZER_PROGRAM];
          if MyFileExists(FileIn) then begin
            if not MyFileExists(FileName) then begin
          ConvertThumb3(FileIn, FileName, Thumbs, RegReadInteger('ThumbWidth', DefaultThumbWidth), 0, False);
        end;
      end;
          fl:=true;
        end;
        if RegReadInteger('PersonStatsInCollection', 0) = 1 then
      PersonStatsInCollection := True
      else
      PersonStatsInCollection := False;
        //кол-во фильмов, как актер
      with sl do begin
          Clear;
          Add('select distinct d.movie as amount from data d');
      Add('join movies m on d.movie=m.code');
          Add(format('where d.person=%d and d.mode=3', [code]));
      if PersonStatsInCollection then
        Add('and m.in_collection=1');
        end;
        ActorCount:=ExecuteSQL(sl.text);
      //number of movies as director
      with sl do begin
          Clear;
          Add('select distinct d.movie as amount from data d');
      Add('join movies m on d.movie=m.code');
          Add(format('where d.person=%d and d.mode=1', [code]));
      if PersonStatsInCollection then
        Add('and m.in_collection=1');
        end;
        DirectorCount:=ExecuteSQL(sl.text);

      if ((Mode <> 2) and
          (GroupOperation)) then
      begin
        if (IsPersonChecked(code)) then
          CheckMode:=format('<a href="group_person_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a href="group_person_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
        CheckMode := '<div id="group_overlay_image">' + CheckMode + '</div>';
      end
      else
        CheckMode:='';

    BigOpen:='';
    BigClose:='';
    SmallOpen:='<small>';
    SmallClose:='</small>';
    if GetCutePreview or (mode=7) then begin
      BigOpen:='<big>';
      BigClose:='</big>';
      SmallOpen:='';
      SmallClose:='';
    end;
        s:=format(CheckMode + '<div><div class="thumb-cover-border"><a href="person:%d"><img class="thumb-cover" src="%s"', [code, FileName]);
      if not GetCutePreview and (mode<>7) then
      s:=s+' width=50 border="0" align=left';
      s:=s+format('></a></div><div class="thumb-text"><a href="person:%d">%s<b>%s</b>%s</a>%s%s<br>', [code, BigOpen, PersonName, BigClose, SmallOpen, rate]);
        if BirthDate<>'' then begin
          //ShowMessage(BirthDate);
          s:=s+BirthDate;
          try
            //years:=StrToDate(BirthDate);
          except
          end;
          s:=s+'<br>';
      end;
      if ActorCount > 0 then
      s:=s+format('%s: %d; ', [GetLangStr(35011), ActorCount]);
      if DirectorCount>0 then
      s:=s+format('%s: %d; ', [GetLangStr(35027), DirectorCount]);
      if (ActorCount>0) or (DirectorCount>0) then
      delete(s, length(s) - 1, 2);

        s:=s+SmallClose;
      end
      else begin
        s:=format('<a href="person:%d"><b>%s</b></a>', [code, PersonName]);
      end;

    s := s+'</div></div>';
    s:='<tr><td class="thumb">'+s+'</td></tr>';


    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetThumbnailPersonGameExtended(code, mode: integer; Name: string): string;
var
  sl: TStringList;
  CheckMode: string;
  s, rate, FileName, img, PersonName, BirthDate: string;
  fl, CutThumb: boolean;
  i, j, kol, amount, RecordCount, DirectorCount, ActorCount, years: integer;
  InCollection, rating, PhotoWidth, PhotoHeight: integer;
  ThumbsPath, FileIn, FileOut: string;
  ProgramType: Integer;
begin
	result:='';
  ProgramType := GAMENIZER_PROGRAM;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    sl:=TStringList.Create;

    if mode=1 then
      amount:=3
    else
      amount:=7;
    s:='';

    ThumbsPath:=ImagesPath+Thumbs2+'\';

      fl:=false;

      with sl do begin
        Clear;
        Add('select p.code, p.name, p.in_collection, p.birth_date, p.rating, i.path from persons p');
        Add('left outer join images i on i.person=p.code and i.mode=6');
        Add(format('where p.code=%d', [code]));
        Add('order by i.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      PersonName:=GetStringField('p.name');

      InCollection:=GetIntegerField('p.in_collection');
      //получаем дополнительную информацию о фильме, если он из коллекции
      if InCollection=1 then
      begin
        //обложка
      PhotoWidth := RegReadInteger('ThPhotoWidth', DefaultMultiCoverWidth[ProgramType]);
      PhotoHeight := RegReadInteger('ThPhotoHeight', DefaultMultiCoverHeight[ProgramType]);

      if (PhotoWidth <= 0) and (PhotoHeight <= 0) then begin
        PhotoWidth := DefaultMultiCoverWidth[ProgramType];
        PhotoHeight := DefaultMultiCoverHeight[ProgramType];
      end;


      if GetStringField('i.path')<>'' then
      begin
        i := RegReadInteger('CutPhotoThumb', 1);
          if i = 1 then
            CutThumb := True
          else
            CutThumb := False;
  //      	FileName:=ImagesPath+GetStringField('i.path');
          FileIn:=ImagesPath+GetStringField('i.path');
          FileName:=ThumbsPath+GetStringField('i.path');
          if MyFileExists(FileName) then
            fl:=true
          else if MyFileExists(FileIn) then
            ConvertThumb2(FileIn, FileName, PhotoWidth, PhotoHeight, CutThumb);
          if MyFileExists(FileName) then
            fl:=true;
      end;

      if GroupOperation then
      begin
        if (IsPersonChecked(code)) then
          CheckMode:=format('<a href="group_person_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a href="group_person_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
        CheckMode := '<div id="group_overlay_image_multi">' + CheckMode + '</div>';
      end
      else
        CheckMode:='';

        if not fl then begin
          FileIn:=ImgPath + NO_PHOTO_FILE[ProgramType];
          //FileName:=ThumbsPath+'no-cover.jpeg';
          FileName:=ThumbsPath + NO_PHOTO_FILE[ProgramType];
          if ((not MyFileExists(FileName)) and
              (MyFileExists(FileIn))) then
          begin
            ConvertThumb2(FileIn, FileName, PhotoWidth, PhotoHeight, CutThumb);
          end;
          fl:=true;
        end;

        s:=format(CheckMode + '<table><tr><td align="center"><div class="thumb-big-cover-border"><a href="person:%d"><img class="thumb-big-cover" src="%s"></a></div></td></tr><tr><td><a href="person:%d"><b>%s</b></a></td></tr></table>', [code, FileName, code, PersonName]);
      end
      else
        s:=format(CheckMode + '<a href="person:%d"><b>%s</b></a>', [code, PersonName]);

    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;


function GetPersonGamePage(PersonCode: integer; FullBio, FullDesc: boolean): string;
var
  sl: TStringList;
  s, all, cust, OriginalName, collection, bio, description, BirthDateStr, DeathDateStr, birthplace, date_start, date_end: string;
  rate, FileName, movie, year, character, img, title, comment, down: string;
  rating, flCollection, i, j, my_i: integer;
  RecordCount, height, LastCode: integer;
	site, url, postfix: string;
	tmp, age, CurrentDateStr: String;
	kol, PhotoCnt, MaxPhotos, page_width, page_width_copy, PicHeight, PicWidth: integer;
	flUseThumbs, IsUnique: boolean;
	CodesList: TStringList;
	custom: array[1..6] of integer;
	PrevBlockCnt, AlbumCode, person_type: Integer;
	border: string;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[GAMENIZER_PROGRAM]);
  try

    i := RegReadInteger('UseThumbs', 1);
    if i = 1 then
      flUseThumbs := True
    else
      flUseThumbs := False;

    sl:=TStringList.Create;
    CodesList := TStringList.Create();

    with sl do begin
      Clear;
      Add('select code from images');
      Add(format('where person=%d and mode=6', [PersonCode]));
      Add('order by sort_order');
    end;
    PhotoCnt:=ExecuteSQL(sl.text);

    all:='';
    CurrentDateStr := FormatDateTimeEx('mm/dd/yyyy', Now());
        with sl do begin
          Clear;
          Add('select * from persons');
          Add(format('where code=%d', [PersonCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount=0 then
          exit;
        s:='person:'+IntToStr(PersonCode);
        person:=GetStringField('name');
        OriginalName:=GetStringField('original_name');
        rating:=GetIntegerField('rating');

        flCollection:=GetIntegerField('in_collection');

        bio:=GetStringField('biography');
        description:=GetStringField('description');
        comment:=GetStringField('comment');
        BirthDateStr:=GetStringField('birth_date');
        birthplace:=GetStringField('birthplace');
        DeathDateStr:=GetStringField('death_date');
        height:=GetIntegerField('height');
      person_type := GetIntegerField('person_type');
      // custom fields
        custom[1]:=GetIntegerField('custom1');
        custom[2]:=GetIntegerField('custom2');
        custom[3]:=GetIntegerField('custom3');
        custom[4]:=GetIntegerField('custom4');


        if flCollection=0 then
          collection:=format('<a href="collection_person:%d"><img src="%snot_collection.gif" border="0" alt="Person is not in collection"></a>',  [PersonCode, ImgPath])
        else
          collection:=format('<a href="collection_person:%d"><img src="%scollection.gif" border="0" alt="Person in collection"></a>',  [PersonCode, ImgPath]);

        rate:='';
        for i:=1 to 10 do begin
          if i mod 2=1 then begin
            if i<=rating then
              rate:=rate+format('<a href="rating_person:%d"><img src="%sstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
            else
              rate:=rate+format('<a href="rating_person:%d"><img src="%snot-star-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
          end
          else begin
            if i<=rating then
              rate:=rate+format('<a href="rating_person:%d"><img src="%sstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
            else
              rate:=rate+format('<a href="rating_person:%d"><img src="%snot-star-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
          end;
        end;

        if (description='') and (BirthDateStr='') then
          down:='<br>'+format('<a href="DownloadPerson:%d">', [PersonCode])+GetLangStr(324)+'</a>'
        else
          down:='';

        //ShowMessage(rate);
    //check if there are no other artists with the same name
    with sl do begin
      Clear;
      Add(Format('select * from persons where name=''%s''', [person]));
    end;
    RecordCount := ExecuteSQL(sl.text);
    if RecordCount = 1 then
      IsUnique := True
    else
      IsUnique := False;

    all:=GetPatternTop;
    all:=all + '<p class="title">' + person;
    while (Pos(' ', OriginalName) = 1) do
      delete(OriginalName, 1, 1);
    if (OriginalName <> '') and (OriginalName <> person) then
      all:=all+' <font size="3"><b>(' + OriginalName + ')</b></font>';
    all:=all+Format('</p></td><td class="icons"><table class="icons-container"><tr><td class="icons-border"><img src="%sicons-left.gif"></td><td class="icons-place">%s&nbsp;&nbsp;</td><td class="edit-link"><p><a href="UpdatePerson:%d">%s</a></p></td><td class="icons-border"><img src="%sicons-right.gif"></td></tr></table>', [ImgPath, collection, PersonCode, GetLangStr(304), ImgPath])+ClosePatternTop;


    all:=all+'<tr><td class="left"><table class="left-pane">';
      //поиск картинок
      with sl do begin
      Clear;
      Add('select * from images');
      Add(format('where person=%d and mode=6', [PersonCode]));
      Add('order by sort_order')
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
      FileName:=ImagesPath+GetStringField('path');
      if (MyFileExists(FileName)) then begin
        //use thumb instead of the full picture, if active
          if flUseThumbs then
          FileName := GetImageFileName(GetStringField('path'), ThumbsMainPhoto, '', 140, 0);
        all:=all+format('<tr><td><div class="cover"><a href="ShowImage:%d"><img class="cover-image" src="%s"></a></div></td></tr><tr><td class="free-space"></td></tr>', [GetIntegerField('code'), FileName]);
      end;
      end
      else begin
      FileName:=ImgPath + NO_PHOTO_FILE[GAMENIZER_PROGRAM];
      if (MyFileExists(FileName)) then
        all:=all+format('<tr><td><div class="cover"><img class="cover-image" src="%s"></div></td></tr><tr><td class="free-space"></td></tr>', [FileName]);
      end;


      //links
      with sl do begin
      Clear;
      Add('select * from persons_codes pc');
      Add('left outer join partners p on pc.script=p.site');
      Add('AND pc.item_type = p.item_type');
      Add(format('where person=%d', [PersonCode]));
      Add('order by p.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
      for i:=1 to RecordCount do begin
        site:=GetStringField('pc.script');
        url:=GetStringField('pc.site');
        if url<>'' then begin
          postfix:=GetStringField('p.postfix');
          if postfix<>'' then
            url:=url+postfix;
          s:=GetPartnerImageFile(site, GetStringField('p.picture'));
          if s='' then
            all:=all+'<tr><td class="site-link"><a href="link:http://www.medianizer.com/redirect/'+url+format('">%s</a></td></tr>', [site])
          else
            all:=all+'<tr><td class="site-link"><a class="picture" href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%s%s" border="0" align="absmiddle"></a></td></tr>', [PicturesPath, s]);
        end;
        GetNextRecord;
        end;
        all:=all+'<tr><td class="free-space"></td></tr>';
      end;
    //My rating
    i := RegReadInteger('ShowRating', 1);
    if i=1 then
      all:=all+'<tr><td class="my-rating-cell-name">'+GetLangStr(298)+'</td></tr><tr><td class="my-rating-cell-value">'+rate+'</td></tr><tr><td class="free-space"></td></tr>';
    all := all + '</table>';

      //фотки человека
      MaxPhotos := RegReadInteger('PhotosCnt', 3);
      with sl do begin
      Clear;
      Add('select i.path, i.code from images i');
      Add('left join images_modes im on im.code = i.mode');
      Add(format('where i.person=%d', [PersonCode]));
      Add('order by im.sort_order, i.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>1 then begin
      all:=all+'<table class="shots">';
      if RecordCount <= MaxPhotos then
        MaxPhotos := RecordCount-1;
      GetNextRecord;
      PhotoCnt := 0;
      for i:=1 to MaxPhotos do begin
        PhotoCnt := PhotoCnt + 1;
        FileName:=ImagesPath+GetStringField('i.path');
        if (MyFileExists(FileName)) then begin
          //use a thumb instead of the full picture, if active
            if flUseThumbs then
            FileName := GetImageFileName(GetStringField('i.path'), ThumbsPhotos, '', 150, 0);
          all:=all+format('<tr><td class="shots-cell"><a class="picture" href="ShowImage:%d"><img class="shot-image" src="%s"></a></td></tr>',
                [GetIntegerField('i.code'), FileName]);
        end;
        GetNextRecord;
      end;
      if PhotoCnt < RecordCount - 1 then
        all:=all+format('<tr><td class="shots-cell"><a href="userref:3102,%d"><img src="%sshots-more.gif" border="0"></a></td></tr>', [PersonCode, ImgPath]);
      all:=all+'</table>'
      end;
    //end left pane
    all := all + '</td>';

    //right pane
    all:=all+'<td width="100%"><table class="contents">';



    tmp := '';
    if BirthDateStr<>'' then begin
      //Date of birth
      tmp:=tmp+'<tr><td class="field-names"><p class="border">'+GetLangStr(3805)+'</p></td><td class="field-values"><p class="border">'+GetSmartDate(BirthDateStr);
      if DeathDateStr='' then
        tmp := tmp + Format(GetLangStr(35029), [GetAge(CurrentDateStr, BirthDateStr)]);
      tmp := tmp + '</p></td></tr>';
    end;

    if birthplace<>'' then
      //Location of birth
      tmp:=tmp+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(35030), birthplace]);

    age := '';
    if DeathDateStr<>'' then begin
      //Date of death
      tmp:=tmp+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s ', [GetLangStr(35031), GetSmartDate(DeathDateStr)]);
      tmp:=tmp+format(GetLangStr(35032), [GetAge(DeathDateStr, BirthDateStr)]);
      tmp:=tmp+'</p></td></tr>';
    end;


    //height
    if height>0 then begin
      if height<100 then
        s:='0.'+IntToStr(height)
      else begin
        s:=IntToStr(height);
        s:=copy(s, 1, 1)+DecimalSeparator+copy(s, 2, length(s)-1);
      end;
      tmp:=tmp+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(372), s]);
    end;

    if tmp<>'' then
      all := all + '<tr><td><table class="names-values"><tr style="background:url('+WhiteBarFile+') repeat-x;"><td colspan="2">&nbsp;&nbsp;</td></tr>' + tmp + '</table></td></tr><tr><td class="free-space"></td></tr>';

     all := all + '<tr><td><table class="full-content">';

    //group - members
      with sl do begin
        Clear;
        Add('select *, (select name from persons');
        Add(Format('where code = case when persons_links.person_main=%d', [PersonCode]));
        Add('then persons_links.person_secondary');
        Add('else persons_links.person_main');
        Add('end) as PersonName, ');
        Add('(select code from persons');
        Add(Format('where code = case when persons_links.person_main=%d', [PersonCode]));
        Add('then persons_links.person_secondary');
        Add('else persons_links.person_main');
        Add('end) as PersonID, manuals.name as role from persons_links');
        Add('join manuals on persons_links.link_type=manuals.code');
        Add(Format('where (person_main=%d) or (person_secondary=%d)', [PersonCode, PersonCode]));
        Add('order by PersonID');
      end;
      RecordCount := ExecuteSQL(sl.text);
      if RecordCount > 0 then begin
        all := all + '<tr><td><table class="description"><tr><td>';
        if person_type = 1 then
          s := GetLangStr(10736)
        else
          s := GetLangStr(10735);
        all := all + '<tr><td><p class="header">'+s+':</td></tr>';
        s := '';
        tmp := '';
        LastCode := 0;
        for i := 1 to RecordCount do begin
          j := GetIntegerField('PersonID');
          if j <> LastCode then
            s := s + Format('<tr><td><a href="person:%d">', [j]) + GetStringField('PersonName') + '</a>';
          date_start := GetSmartDate(GetStringField('persons_links.date_start'));
          date_end := GetSmartDate(GetStringField('persons_links.date_end'));
          character := GetStringField('role');
          if (character <> '') then begin
            if (j <> LastCode) then
              s := s + ': '
            else begin
              delete(s, length(s)-9, 10);
              s := s + ', ';
            end;
            s := s + character;
          end;
          if (date_start <> '') or (date_end <> '') then begin
            s := s + ' (';
            if date_start <> '' then
              s := s + date_start
            else
              s := s + GetSmartDate(BirthDateStr);
            s := s + ' - ';
            if date_end <> '' then
              s := s + date_end
            else if DeathDateStr <> '' then
              s := s + GetSmartDate(DeathDateStr)
            else
              s := s + GetLangStr(7015);
            s := s + ')';
          end;
          s := s + '</td></tr>';
          tmp := character;
          LastCode := j;
          GetNextRecord;
        end;
        all:=all+s+'</table></td></tr>';
      end;

        //custom fields
        cust:='';
      PrevBlockCnt:=0;
        for i:=1 to 4 do begin
          if custom[i]>0 then begin
            with sl do begin
              Clear;
              Add('select name from manuals');
              Add(format('where code=%d', [custom[i]]));
            end;
            RecordCount:=ExecuteSQL(sl.text);
            if RecordCount>0 then begin
          PrevBlockCnt:=PrevBlockCnt+1;
              cust:=cust+'<tr><td class="field-names"><p class="border">'+format(GetLangStr(4539+i), [s])+'</p></td><td class="field-values"><p class="border">'+format('<a href="custom_person%d:%d">', [i, custom[i]])+GetStringField('name')+'</a></p></td></tr>';
            end;
          end;
    end;

    //custom list1
    border := '';
        with sl do begin
          Clear;
      Add('select m.code, m.name from persons_manuals pm');
      Add('join manuals m on m.code=pm.ref_code');
      Add(format('where pm.person=%d and m.reference=28', [PersonCode]));
      Add('order by m.name');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
      PrevBlockCnt:=PrevBlockCnt+1;
      if (PrevBlockCnt > 2) then
        border := 'without-';
          cust:=cust+Format('<tr><td class="field-names"><p class="%sborder">%s</p></td><td class="field-values"><p class="%sborder">', [border, GetLangStr(4544), border]);
          for i:=1 to RecordCount do begin
            cust:=cust+format('<a href="custom_person5:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          cust:=copy(cust, 1, length(cust)-2);
          cust:=cust+'</p></td></tr>';
        end;

    //custom list2
        with sl do begin
          Clear;
      Add('select m.code, m.name from persons_manuals pm');
      Add('join manuals m on m.code=pm.ref_code');
      Add(format('where pm.person=%d and m.reference=29', [PersonCode]));
      Add('order by m.name');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
      PrevBlockCnt:=PrevBlockCnt+1;
      if PrevBlockCnt>2 then
        border := 'without-';
          cust:=cust+Format('<tr><td class="field-names"><p class="%sborder">%s</p></td><td class="field-values"><p class="%sborder">', [border, GetLangStr(4545), border]);
          for i:=1 to RecordCount do begin
            cust:=cust+format('<a href="custom_person6:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          cust:=copy(cust, 1, length(cust)-2);
          cust:=cust+'</p></td></tr>';
        end;
    if cust <> '' then
      all:=all+Format('<tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile])+cust + '</table></td></tr>';

    if (cust<>'') or (s<>'') then
      all := all + '<tr><td class="free-space"></td></tr>';
      //all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);

    //biography
      if (bio<>'') then begin
      if not FullBio and (length(bio)>700) then begin
        bio:=copy(bio, 1, 700);
        bio:=RemoveUnclosedTags(bio);
        bio:=bio+format(GetLangStr(369), [PersonCode]);
      end;
         all:=all+'<tr style="background:url('+WhiteBarFile+') repeat-x;"><td>&nbsp;&nbsp;</td></tr><tr><td><p class="description">'+bio+'</p></td></tr><tr><td class="free-space"></td></tr>';
    end;

        //обложки фильмов
    if (RegReadInteger('HidePhotosCovers', 0) = 0) then begin
      LastCode:=0;
      with sl do begin
        Clear;
        Add('select distinct i.path as path, i.width, i.height, i.movie as code, m.year, m.in_collection, m.title, c.name');
        Add('from data d');
        Add('inner join images i on i.movie=d.movie');
        Add('inner join movies m on m.code=d.movie');
        Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
        Add(format('where d.person=%d', [PersonCode]));
        Add('and i.mode=1');
        Add('order by i.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      page_width := GetHTMLWidth - LeftColumnWidth;
      page_width_copy := page_width;
      tmp := '';
      if RecordCount>0 then begin
        all:=all+Format('<tr><td><p class="header">%s:</p></td></tr><tr><td><table class="boxes">', [GetLangStr(35277)]);
        j := 0;
        all := all + '<tr>';
        for i:=1 to RecordCount do
        begin
          if (LastCode=0) or (CodesList.IndexOf(IntToStr(GetIntegerField('code'))) < 0) then
          begin
            LastCode:=GetIntegerField('code');
            CodesList.Add(GetStringField('code'));
            PicHeight:=GetIntegerField('i.height');
            if PicHeight > 0 then
              PicWidth := Round(GetIntegerField('i.width') * (SmallCoverHeight / PicHeight)) + SmallImageBorder
            else
              PicWidth := CoverCellWidth;
            if PicWidth < CoverCellWidth then
              PicWidth := CoverCellWidth;
            FileName:=ImagesPath+GetStringField('path');
            if (MyFileExists(FileName)) and (GetStringField('m.in_collection') = '1') then
            begin
              age := '';
              if BirthDateStr <> '' then begin
                age := BirthDateStr;
                while Pos('/', age) > 0 do
                  delete(age, 1, Pos('/', age));
                try
                  age := IntToStr(StrToInt(GetStringField('m.year')) - StrToInt(age));
                except
                end;
              end;

              j := j + 1;

              //if thumbs are used, replace filename with thumbfilename
              if flUseThumbs then
                FileName := GetImageFileName(GetStringField('path'), ThumbsArtistAlbums, '', 0, 120);

              tmp:=tmp+format('<td class="small-cover"><a class="picture" href="movie:%d"><img src="%s"></a><p><a href="movie:%d">%s</a>', [GetIntegerField('code'), FileName, GetIntegerField('code'), GetStringField('m.title')]);
              (*if age <>'' then
                tmp := tmp +'<br>'+ format(GetLangStr(1410), [age]);
              if GetStringField('c.name') <> '' then
                tmp := tmp + format(' (%s)', [GetStringField('c.name')]);*)
              tmp := tmp + ('</p></td>');
              page_width_copy := page_width_copy - PicWidth;
              if page_width_copy >= 0 then begin
                all := all + tmp;
                tmp := '';
              end
              else begin
                all := all + '</tr></table></td></tr><tr><td><table class="boxes"><tr>' + tmp;
                tmp := '';
                page_width_copy := page_width - PicWidth;
              end;
            end;
          end;
          GetNextRecord;
        end;
        all := all + '</tr></table></td></tr><tr><td class="free-space"></td></tr>';
      end;
    end;

    //description
      if (description<>'') then begin
      if not FullDesc and (length(description)>1000) then begin
        description:=copy(description, 1, 1000);
        description:=RemoveUnclosedTags(description);
        description:=description+format(GetLangStr(370), [PersonCode]);
      end;
      all:=all+'<tr style="background:url('+WhiteBarFile+') repeat-x;"><td>&nbsp;&nbsp;</td></tr><tr><td><p class="description">'+description+'</p></td></tr><tr><td class="free-space"></td></tr>';
    end;

    //comments
    if comment<>'' then
      all:=all+'<tr style="background:url('+WhiteBarFile+') repeat-x;"><td>&nbsp;&nbsp;</td></tr><tr><td><p class="description">'+comment+'</p></td></tr><tr><td class="free-space"></td></tr>';

    //movies by actor
        CodesList.Clear();
        with sl do begin
          Clear;
          Add('select distinct m.title, m.code, m.year, c.name, m.in_collection, m.rating from data d');
          Add('inner join movies m on m.code=d.movie');
          Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
          Add(format('where d.person=%d', [PersonCode]));
          Add('and d.mode=3');
      if (RegReadInteger('ShowOnlyMoviesInCollection', 0) = 1) then
        Add('and m.in_collection=1');
          //17.03.09
          //Add('order by d.movies_sort_order');
          Add('order by m.year desc, d.movies_sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);

        if RecordCount>0 then begin
          //Actor - filmography
          movie:='<tr><td><p class="header">'+GetLangStr(35033)+':</p><ol>';
          for i:=1 to RecordCount do begin
        AlbumCode := GetIntegerField('m.code');
        if CodesList.IndexOf(IntToStr(AlbumCode)) < 0 then begin
          CodesList.Add(IntToStr(AlbumCode));
          rate := '';
          rating := GetIntegerField('m.rating');
          if rating > 0 then begin
            for my_i:=1 to 10 do begin
              if my_i mod 2=1 then begin
                if my_i<=rating then
              rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                else
              rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
              end
              else begin
                if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                else
                  rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
              end;
            end;
          end;
          year:=GetStringField('m.year');
          character:=GetStringField('c.name');
          if GetIntegerField('m.in_collection')=1 then
          img:=format('<img src="%sin-collection-small.gif" align="absmiddle">&nbsp;', [ImgPath])
          else
          img:='';
              title:=GetStringField('m.title');
          if year='' then
          movie:=movie+format('<li>%s<a href="movie:%d">',
            [img, AlbumCode])+title+'</a>'
          else
          movie:=movie+format('<li>%s<a href="movie:%d">%s</a> (%s)',
            [img, AlbumCode, title, year]);
          if character<>'' then
          movie:=movie+format(' ... <i>%s</i>', [character]);
          if rate <> '' then
          movie:=movie+' '+rate;
          movie := movie + '</li>';
        end;
            GetNextRecord;
          end;
          movie:=movie+'</ol></td></tr><tr><td class="free-space"></td></tr>';
          all:=all+movie;
        end;
      CodesList.Clear;

        //movies by director
        with sl do begin
          Clear;
          Add('select distinct m.title, m.code, m.year, m.in_collection, e.filename, m.rating from data d');
          Add('inner join movies m on m.code=d.movie');
      Add('left outer join editions e on e.movie=m.code');
          //Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
          Add(format('where d.person=%d', [PersonCode]));
          Add('and d.mode=1');
      if (RegReadInteger('ShowOnlyMoviesInCollection', 0) = 1) then
        Add('and m.in_collection=1');
          //17.03.09
          //Add('order by d.movies_sort_order');
          Add('order by m.year desc, d.movies_sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);

        if RecordCount>0 then begin
          //Director - filmography
          movie:='<tr><td><p class="header">'+GetLangStr(35034)+':</p><ol>';
          for i:=1 to RecordCount do begin
        AlbumCode := GetIntegerField('m.code');
        if CodesList.IndexOf(IntToStr(AlbumCode)) < 0 then begin
          CodesList.Add(IntToStr(AlbumCode));
          rate := '';
          rating := GetIntegerField('m.rating');
          if rating > 0 then begin
            for my_i:=1 to 10 do begin
              if my_i mod 2=1 then begin
                if my_i<=rating then
              rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                else
              rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
              end
              else begin
                if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                else
                  rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
              end;
            end;
          end;
          year:=GetStringField('m.year');
          //character:=GetStringField('c.name');
          if GetIntegerField('m.in_collection')=1 then
          img:=format('<img src="%sin-collection-small.gif" align="absmiddle">&nbsp;', [ImgPath])
          else
          img:='';
              title:=GetStringField('m.title');
          if year='' then
          movie:=movie+format('<li>%s<a href="movie:%d">',
            [img, AlbumCode])+title+'</a>'
          else
          movie:=movie+format('<li>%s<a href="movie:%d">%s</a> (%s)',
            [img, AlbumCode, title, year]);
          //if character<>'' then
          //movie:=movie+format(' ... <i>%s</i>', [character]);
          // Fade 23.03.2011 - add play album button for person albums list
          if rate <> '' then
          movie:=movie+' '+rate;
          if GetStringField('e.filename') <> '' then
          movie:=movie+format('  <a href="playAlbum:%d">', [AlbumCode])+format('<img src="%splay.png" align="absmiddle" border="0"></a>', [ImgPath]);
          movie := movie + '</li>';
        end;
        GetNextRecord;
          end;
          movie:=movie+'</ol></td></tr><tr><td class="free-space"></td></tr>';
          all:=all+movie;
        end;
      CodesList.Clear;

      if IsUnique then begin
        //collections
          with sl do begin
          Clear;
          Add('select distinct m.title, m.code, m.year, e.filename, m.in_collection, m.seen, m.wanted, m.for_sale, m.rating from data d');
          Add('inner join movies m on m.code=d.movie');
          Add('join tracks t on t.movie=m.code');
          Add('left outer join editions e on e.movie=m.code');
          Add(format('where d.person<>%d', [PersonCode]));
          Add(format('and t.artist=''%s''', [person]));
          if (RegReadInteger('ShowOnlyMoviesInCollection', 0) = 1) then
            Add('and m.in_collection=1');
          //17.03.09
          //Add('order by d.movies_sort_order');
          Add('order by m.year desc, d.movies_sort_order');
          end;
          RecordCount:=ExecuteSQL(sl.text);

          if RecordCount>0 then begin
          //collections
          movie:='<tr><td><p class="header">'+GetLangStr(10657)+':</p><ol>';
          for i:=1 to RecordCount do begin
            AlbumCode := GetIntegerField('m.code');
            if (CodesList.IndexOf(IntToStr(AlbumCode)) < 0) then begin
              CodesList.Add(IntToStr(AlbumCode));
              rate := '';
              rating := GetIntegerField('m.rating');
              if rating > 0 then begin
                for my_i:=1 to 10 do begin
                  if my_i mod 2=1 then begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  end
                  else begin
                    if my_i<=rating then
                      rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                      rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  end;
                end;
              end;
              year:=GetStringField('m.year');
              //character:=GetStringField('c.name');
              if GetIntegerField('m.in_collection')=1 then
              img:=format('<img src="%sin-collection-small.gif" align="absmiddle">&nbsp;', [ImgPath])
              else
              img:='';
                  title:=GetStringField('m.title');
              if year='' then
              movie:=movie+format('<li>%s<a href="movie:%d">',
                [img, AlbumCode])+title+'</a>'
              else
              movie:=movie+format('<li>%s<a href="movie:%d">%s</a> (%s)',
                [img, AlbumCode, title, year]);
              //if character<>'' then
              //movie:=movie+format(' ... <i>%s</i>', [character]);
              // Fade 23.03.2011 - add play album button for person albums list
              if rate <> '' then
              movie:=movie+' '+rate;
              if GetStringField('e.filename') <> '' then
              movie:=movie+format('  <a href="playAlbum:%d">', [AlbumCode])+format('<img src="%splay.png" align="absmiddle" border="0"></a>', [ImgPath]);
              movie := movie + '</li>';
            end;
            GetNextRecord;
          end;
          movie:=movie+'</ol></td></tr><tr><td class="free-space"></td></tr>';
          all:=all+movie;
          end;
      end;

    all := all + '</table></td></tr></table>' + GetPatternBottom;

    sl.Free;
    CodesList.Free();
    result:=all;
  finally
    ResetRegistrySubKey();
  end;
end;

begin

end.