﻿program modern_program_part2;

uses 'modern_program_variables.pas', 'modern_program_global.pas';

function GenerateMoviesBlock(AProgramType: Integer; var AItemsCount: Integer): string;
var
  sl, PreviousCodes: TStringList;
  PersonCode, i, j, kol, kol2, page_width, code, my_i: integer;
  description, genre, year, director, writer, actor, bio, character, movie, LastAdd: string;
  FileName, site, url, postfix, s, rate: string;
  RecordCount, rating, LastCode, ShowLastUpdated: integer;
  IMDBRating: double;
  MyTabs, TabNameMode, TabName1, TabName2, TabName3, TabName4, Tab1Mode, Tab2Mode, Tab3Mode, Tab4Mode, MoviesMore, PersonsMore, LastUpdatedTab, BirthdayTab: String;
  myDate: TDateTime;
  full_date, tmp, dbfilename: String;
  PicWidth, PicHeight, page_width_copy, loaned_movies, NumberOfBirthdays, AllPicWidth: Integer;
begin
  Result := '';
  ExecuteSQL('SELECT Count(*) as amount FROM movies WHERE in_collection=1 AND item_type=' + IntToStr(AProgramType));
  AItemsCount := GetIntegerField('amount');
  if (RegReadBoolean('HomePageShowMovies', DefaultHomePageShowMovies)) then
  begin
    SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
    sl:=TStringList.Create;
    AItemsCount := 0;
    PreviousCodes := TStringList.Create;
    try
      GenerateSQLForMoviesPages(sl, AProgramType, HomeMovieTab, -1);
      AItemsCount:=ExecuteSQL(sl.text);
      RecordCount := AItemsCount;
      MyTabs := '';
      LastAdd := '';
      AllPicWidth := 0;
      page_width:=GetHTMLWidth - WholePageBorder;
      page_width_copy := page_width;
      if RecordCount>0 then begin
        i:=1;
        j:=0;
        LastCode:=0;
        PreviousCodes.Clear;
        while (page_width_copy >= 0) and (i<=RecordCount) do begin
          code:=GetIntegerField('code');
          if PreviousCodes.IndexOf(IntToStr(code)) < 0 then begin
            PreviousCodes.Add(IntToStr(code));
            if j=0 then
              LastAdd:=LastAdd+'<tr><td><table class="boxes"><tr style="background:url('+BackgroundMovies+') repeat-x;">';
            j:=j+1;
            LastCode:=code;
            PicHeight := GetIntegerField('height');
            if PicHeight > 0 then
              PicWidth := Round(GetIntegerField('width') * (CoverHeight / PicHeight)) + NormalImageBorders
            else
              PicWidth := StandardCoverWidth[AProgramType];
            page_width_copy := page_width_copy - PicWidth;
            AllPicWidth := AllPicWidth + PicWidth;
            if page_width_copy >= 0 then begin
              year:=GetStringField('year');

              rating:=GetIntegerField('rating');
              rate:='';
              if rating>0 then begin
                for my_i:=1 to 10 do begin
                  if my_i mod 2=1 then begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  end
                  else begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  end;
                end;
              end;
              IMDBRating := GetFloatField('imdb_rating');
              if year<>'' then
                s:=GetLangStr(169)+': '+year+'. '+rate
              else
                s:=rate;

              FileName := GetImageFileName(GetStringField('path'), 'ThumbsHomeMovies', NO_COVER_FILE[AProgramType], 0, CoverHeight);
              LastAdd:=LastAdd+'<td class="box-movies">'+format('<a href="movie:%d"><img class="movie-cover" src="%s"></a>', [code, FileName]);

              if (rate<>'') and (RegReadInteger('ShowRating', 1) = 1) then
                LastAdd := LastAdd+'<br>'+rate;
              LastAdd := LastAdd + '<p>';
              if IMDBRating <> 0 then
                LastAdd:=LastAdd+format('IMDB: %0.1f<br>', [IMDBRating]);

              LastAdd := LastAdd+format('<a href="movie:%d">%s</a></p></td>', [code, GetStringField('title')]);
            end;

          end;

          GetNextRecord;
          i:=i+1;
        end;
        if (page_width > 450) and (AllPicWidth < 450) then
          LastAdd := LastAdd + Format('<td style="width: %dpx;"></td>', [450 - AllPicWidth]);

        //full tab names
        if (page_width > 650) and (AllPicWidth > 650) then begin
          TabNameMode := '';
          if ShowLastUpdated = 0 then
            TabName1 := GetLangStr(1402)
          else
            TabName1 := GetLangStr(1421);
          TabName2 := GetLangStr(1403);
          TabName3 := GetLangStr(1404);
          TabName4 := GetLangStr(1421);
        end
        //short tab names
        else if (page_width >= 400) then begin
          TabNameMode := '-short';
          TabName1 := GetLangStr(1407);
          TabName2 := GetLangStr(1408);
          TabName3 := GetLangStr(1409);
          TabName4 := '';
        end
        //no tabs
        else
          TabNameMode := 'none';

        //creating hyperlinks and defining tab types (active, inactive)
        Tab1Mode := 'in';
        Tab2Mode := 'in';
        Tab3Mode := 'in';
        Tab4Mode := 'in';
        MoviesMore := '';
        if HomeMovieTab=1 then begin
          Tab1Mode := '';
          TabName2 := Format('<a href="modern_home:2,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:3,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:4,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName4]);
          if ShowLastUpdated = 0 then
            MoviesMore := Format('<a href="userref:1,%s">', [GetLangStr(1402)])
          else
            MoviesMore := Format('<a href="userref:1,%s">', [GetLangStr(1421)]);
        end;
        if HomeMovieTab=2 then begin
          Tab2Mode := '';
          TabName1 := Format('<a href="modern_home:1,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName3 := Format('<a href="modern_home:3,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:4,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:2,%s">', [GetLangStr(1403)]);
        end;
        if HomeMovieTab=3 then begin
          Tab3Mode := '';
          TabName1 := Format('<a href="modern_home:1,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:2,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName4 := Format('<a href="modern_home:4,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:3,%s">', [GetLangStr(1404)]);
        end;
        if HomeMovieTab=4 then begin
          Tab4Mode := '';
          TabName1 := Format('<a href="modern_home:1,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:2,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:3,%d,%d,%d,%d">%s</a>', [HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName3]);
          MoviesMore := Format('<a href="userref:4,%s">', [GetLangStr(1421)]);
        end;

        //create tabs
        LastUpdatedTab := '';
        if (TabNameMode = '') and (page_width > 810) and (j*130 > 810) and (ShowLastUpdated = 0) then
          LastUpdatedTab := format('<td class="tab-space"></td><td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab4Mode, Tab4Mode, TabNameMode, TabName4, ImgPath, Tab4Mode]);


        if TabNameMode <> 'none' then
          MyTabs:=format('<tr><td><table class="tabs"><tr><td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab1Mode, Tab1Mode, TabNameMode, TabName1, ImgPath, Tab1Mode]) + LastUpdatedTab + format('<td class="tab-space"></td><td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab2Mode, Tab2Mode, TabNameMode, TabName2, ImgPath, Tab2Mode]) + format('<td class="tab-space"></td><td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td><td></td></tr></table></td></tr>', [ImgPath, Tab3Mode, Tab3Mode, TabNameMode, TabName3, ImgPath, Tab3Mode]);
          if j>0 then
          LastAdd:=LastAdd+Format('<td class="more">%s<img src="%smovies-more.gif" border="0"></a></td><td><td></tr></table></td></tr>', [MoviesMore, ImgPath]);

          Result := MyTabs+LastAdd;
        end;
    finally
      ResetRegistrySubKey();
      sl.Free();
      PreviousCodes.Free();
    end;
  end;
end;


function GenerateGamesBlock(AProgramType: Integer; var AItemsCount: Integer): string;
var
  sl: TStringList;
  PersonCode, i, j, kol, kol2, page_width, code, my_i: integer;
  all, description, genre, year, director, writer, actor, bio, character, movie, LastAdd: string;
  FileName, site, url, postfix, s, rate, ThumbsPath: string;
  RecordCount, rating, LastCode, ShowLastUpdated: integer;
  IMDBRating: double;
  MyTabs, TabNameMode, TabName1, TabName2, TabName3, TabName4, Tab1Mode, Tab2Mode, Tab3Mode, Tab4Mode, MoviesMore, PersonsMore, LastUpdatedTab: String;
  myDate: TDateTime;
  full_date, tmp: String;
  PicWidth, PicHeight, page_width_copy, loaned_movies: Integer;
  CodesList: TStringList;
begin
  Result := '';
  ExecuteSQL('SELECT Count(*) as amount FROM movies WHERE in_collection=1 AND item_type=' + IntToStr(AProgramType));
  AItemsCount := GetIntegerField('amount');
  if (RegReadBoolean('HomePageShowGames', DefaultHomePageShowGames)) then
  begin
    SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
    sl:=TStringList.Create;
    AItemsCount := 0;
    try
      GenerateSQLForMoviesPages(sl, AProgramType, HomeGameTab, -1);
      AItemsCount:=ExecuteSQL(sl.text);
      RecordCount := AItemsCount;

      MyTabs := '';
      LastAdd := '';
      page_width:=GetHTMLWidth - WholePageBorder;
      page_width_copy := page_width;
      if RecordCount>0 then
      begin
        i:=1;
        j:=0;
        LastCode:=0;
        CodesList := TStringList.Create();
        while (page_width_copy >= 0) and (i<=RecordCount) do
        begin
          code:=GetIntegerField('code');
          if (CodesList.IndexOf(IntToStr(code)) < 0) then
          begin
            CodesList.Add(IntToStr(code));
            if j=0 then
              LastAdd:=LastAdd+'<tr><td><table class="boxes"><tr>';
            j:=j+1;
            LastCode:=code;
            PicHeight := GetIntegerField('height');
            if PicHeight > 0 then
              PicWidth := Round(GetIntegerField('width') * (CoverHeight / PicHeight)) + NormalImageBorders
            else
              PicWidth := StandardCoverWidth[AProgramType];
            page_width_copy := page_width_copy - PicWidth;
            if page_width_copy >= 0 then begin
              year:=GetStringField('year');

              rating:=GetIntegerField('rating');
              rate:='';
              if rating>0 then begin
                for my_i:=1 to 10 do begin
                  if my_i mod 2=1 then begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  end
                  else begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  end;
                end;
              end;
              IMDBRating := GetFloatField('imdb_rating');
              if year<>'' then
                s:=GetLangStr(169)+': '+year+'. '+rate
              else
                s:=rate;

              FileName := GetImageFileName(GetStringField('path'), 'ThumbsHomeGames', NO_COVER_FILE[AProgramType], 0, 140);

              LastAdd:=LastAdd+'<td class="box-movies" style="background:url('+BackgroundMovies+') repeat-x;">'+format('<a href="movie:%d"><img class="movie-cover" src="%s"></a>', [code, FileName]);
              if (rate<>'') and (RegReadInteger('ShowRating', 1) = 1) then
                LastAdd := LastAdd+'<br>'+rate;
              LastAdd := LastAdd + '<p>';
              if IMDBRating <> 0 then
                LastAdd:=LastAdd+format('IMDB: %0.1f<br>', [IMDBRating]);

              LastAdd := LastAdd+format('<a href="movie:%d">%s</a></p></td>', [code, GetStringField('title')]);
            end;

          end;

          GetNextRecord;
          i:=i+1;
        end;
        CodesList.Free();
        //full tab names
        if ((page_width - page_width_copy) > 410) then
        begin
          TabNameMode := '';
          if ShowLastUpdated = 0 then
            TabName1 := GetLangStr(10404)
          else
            TabName1 := GetLangStr(10408);
          TabName2 := GetLangStr(10405);
          TabName3 := GetLangStr(35144);
          TabName4 := GetLangStr(10408);
        end
        //short tab names
        else if ((page_width - page_width_copy) >= 270) then
        begin
          TabNameMode := '-short';
          TabName1 := GetLangStr(1407);
          TabName2 := GetLangStr(1408);
          TabName3 := GetLangStr(35144);
          TabName4 := '';
        end
        //no tabs
        else
          TabNameMode := 'none';

        //creating hyperlinks and defining tab types (active, inactive)
        Tab1Mode := 'in';
        Tab2Mode := 'in';
        Tab3Mode := 'in';
        Tab4Mode := 'in';
        MoviesMore := '';
        if HomeGameTab=1 then
        begin
          Tab1Mode := '';
          TabName2 := Format('<a href="modern_home:%d,%d,%d,2,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:%d,%d,%d,3,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:%d,%d,%d,4,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName4]);
          if ShowLastUpdated = 0 then
            MoviesMore := Format('<a href="userref:3001,%s">', [GetLangStr(10404)])
          else
            MoviesMore := Format('<a href="userref:3001,%s">', [GetLangStr(10408)]);
        end;
        if HomeGameTab=2 then
        begin
          Tab2Mode := '';
          TabName1 := Format('<a href="modern_home:%d,%d,%d,1,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName1]);
          TabName3 := Format('<a href="modern_home:%d,%d,%d,3,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:%d,%d,%d,4,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:3002,%s">', [GetLangStr(10405)]);
        end;
        if HomeGameTab=3 then
        begin
          Tab3Mode := '';
          TabName1 := Format('<a href="modern_home:%d,%d,%d,1,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:%d,%d,%d,2,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName2]);
          TabName4 := Format('<a href="modern_home:%d,%d,%d,4,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:3003,%s">', [GetLangStr(35144)]);
        end;
        if HomeGameTab=4 then
        begin
          Tab4Mode := '';
          TabName1 := Format('<a href="modern_home:%d,%d,%d,1,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:%d,%d,%d,2,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:%d,%d,%d,3,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomePersonTab, TabName3]);
          MoviesMore := Format('<a href="userref:3004,%s">', [GetLangStr(10408)]);
        end;

        //create tabs
        LastUpdatedTab := '';
        if (TabNameMode = '') and ((page_width - page_width_copy) > 610) and (ShowLastUpdated = 0) then
          LastUpdatedTab := format('<td class="tab-space"></td><td class="tab-border"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab4Mode, Tab4Mode, TabNameMode, TabName4, ImgPath, Tab4Mode]);


        if TabNameMode <> 'none' then
          MyTabs:=format('<tr><td><table class="tabs"><tr><td class="tab-border"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab1Mode, Tab1Mode, TabNameMode, TabName1, ImgPath, Tab1Mode]) + LastUpdatedTab + format('<td class="tab-space"></td><td class="tab-border"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab2Mode, Tab2Mode, TabNameMode, TabName2, ImgPath, Tab2Mode]) + '<td></td></tr></table></td></tr>';
        if j>0 then
          LastAdd:=LastAdd+Format('<td class="more">%s<img src="%smovies-more.gif" border="0"></a></td><td><td></tr></table></td></tr>', [MoviesMore, ImgPath]);

        Result := MyTabs + LastAdd;
      end;
    finally
      ResetRegistrySubKey();
      sl.Free();
    end;
  end;
end;


function GenerateBooksBlock(AProgramType: Integer; var AItemsCount: Integer): string;
var
  sl: TStringList;
  PersonCode, i, j, kol, kol2, page_width, code, my_i: integer;
  all, description, genre, year, director, writer, actor, bio, character, movie, LastAdd: string;
  FileName, site, url, postfix, s, s2, rate, ThumbsPath: string;
  RecordCount, rating, LastCode: integer;
  IMDBRating: double;
  MyTabs, TabNameMode, TabName1, TabName2, TabName3, TabName4, TabNameLitres, TabLitresMode, Tab1Mode, Tab2Mode, Tab3Mode, Tab4Mode, MoviesMore, PersonsMore, LastUpdatedTab, LastAddedTab, BestRatedTab, UnreadTab, LitresTab: String;
  myDate: TDateTime;
  full_date, tmp, dbfilename: String;
  PicWidth, PicHeight, page_width_copy, loaned_movies, last_page_width, AllPicWidth, NumberOfBirthdays: Integer;
  fl, showLastAdded, showLastUpdated, showBestRated, showUnread: boolean;
  ThumbsFileName, BirthdayTab: string;

  // Litres books variables
  LitresBooksCount: Integer;
  LitresID: integer;
  LitresBookTitle: string;
  LitresBookAuthor: string;
  LitresBookCover: string;
  LitresBookYear: string;
  LitresGenres: string;
  LitresImagesWidth: integer;
  LitresImagesHeight: integer;
  CodesList: TStringList;
  flShowLitres: Boolean;
begin
  Result := '';
  ExecuteSQL('SELECT Count(*) as amount FROM movies WHERE in_collection=1 AND item_type=' + IntToStr(AProgramType));
  AItemsCount := GetIntegerField('amount');
  if (RegReadBoolean('HomePageShowBooks', DefaultHomePageShowBooks)) then
  begin
    SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
    sl:=TStringList.Create;
    try
      GenerateSQLForMoviesPages(sl, AProgramType, HomeBookTab, -1);
      AItemsCount:=ExecuteSQL(sl.text);
      RecordCount := AItemsCount;

      MyTabs := '';
      LastAdd := '';
      page_width:=GetHTMLWidth - WholePageBorder;
      page_width_copy := page_width;
      last_page_width := 0;
      AllPicWidth := 0;
      if ((RecordCount>0) and (HomeBookTab > 0)) or (flShowLitres and (HomeBookTab=0)) then
      begin
        i:=1;
        j:=0;
        LastCode:=0;
        CodesList := TStringList.Create();
        if (HomeBookTab > 0) then
        begin
          while (page_width_copy >= 0) and (i<=RecordCount) do
          begin
            code:=GetIntegerField('code');
            if (CodesList.IndexOf(IntToStr(code)) < 0) then
            begin
              LastCode:=code;
              CodesList.Add(IntToStr(code));
              PicHeight := GetIntegerField('height');
              if PicHeight > 0 then
                PicWidth := Round(GetIntegerField('width') * (CoverHeight / PicHeight)) + NormalImageBorders
              else
                PicWidth := StandardCoverWidth[AProgramType];
              page_width_copy := page_width_copy - PicWidth;
              AllPicWidth := AllPicWidth + PicWidth;
              if page_width_copy >= 0 then begin
                last_page_width := page_width - page_width_copy;
                if j=0 then
                  LastAdd:=LastAdd+'<tr><td><table class="boxes"><tr>';
                j:=j+1;
                year:=GetStringField('year');

                rating:=GetIntegerField('rating');
                rate:='';
                if rating>0 then begin
                  for my_i:=1 to 10 do begin
                    if my_i mod 2=1 then begin
                      if my_i<=rating then
                    rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                      else
                    rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
                    end
                    else begin
                      if my_i<=rating then
                    rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                      else
                    rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
                    end;
                  end;
                end;
                IMDBRating := GetFloatField('imdb_rating');
                if year<>'' then
                  s:=GetLangStr(169)+': '+year+'. '+rate
                else
                  s:=rate;

                  //2.05,11
                fl:=false;
                ThumbsFileName := GetImageFileName(GetStringField('path'), 'ThumbsHomeBooks', NO_COVER_FILE[AProgramType], 0, 140);
                LastAdd:=LastAdd+'<td class="box-movies" style="background:url('+BackgroundMovies+') repeat-x;">'+format('<a href="movie:%d"><img class="movie-cover" src="%s" alt="%s"></a>', [code, ThumbsFileName, GetStringField('title')]);
                //end 2.05.11
                if (rate<>'') and (RegReadInteger('ShowRating', 1) = 1) then
                  LastAdd := LastAdd+'<br>'+rate;
                LastAdd := LastAdd + '<p>';
                if IMDBRating <> 0 then
                  LastAdd:=LastAdd+format('IMDB: %0.1f<br>', [IMDBRating]);
                s := GetStringField('title');
                if Length(s) > MaxTitleLength then
                  s := copy(s, 1, MaxTitleLength - 3) + '...';

                LastAdd := LastAdd+format('<a href="movie:%d">%s</a></p></td>', [code, s]);
              end;

            end;

            GetNextRecord;
            i:=i+1;
          end;
        end;
        CodesList.Free();
        if (flShowLitres and (HomeBookTab=0)) then
        begin
          // 09.08.2012. Fade here is an example of recieving litres books
          page_width_copy := page_width_copy - ArrowRight;
          LitresBooksCount := GetLitresBooksCount();
          for I := 0 to (LitresBooksCount - 1) do
          begin
            if (page_width_copy < 0) then
            Break;
            FillLitresBookInfo(I, LitresID, LitresBookTitle, LitresBookAuthor,
            LitresBookCover, LitresBookYear, LitresGenres, LitresImagesWidth, LitresImagesHeight);
            if not MyFileExists(LitresBookCover) then
            LitresBookCover:=ImgPath+'nocoverbooks.png';

            PicHeight := LitresImagesHeight;
            if PicHeight > 0 then
            PicWidth := LitresImagesWidth + NormalImageBorders
            else
            PicWidth := StandardCoverWidth[AProgramType];
            page_width_copy := page_width_copy - PicWidth;
            AllPicWidth := AllPicWidth + PicWidth;
            if page_width_copy >= 0 then
            begin
            last_page_width := page_width - page_width_copy;
            if j=0 then
              LastAdd:=LastAdd+'<tr><td><table class="boxes"><tr>';
            j:=j+1;
            end;

            LastAdd:=LastAdd+'<td class="box-movies" style="background:url('+BackgroundMovies+') repeat-x;">'+format('<a href="LitresBook:%d"><img class="movie-cover" src="%s" alt="%s"></a>', [LitresID, LitresBookCover, LitresBookTitle]);
            LastAdd := LastAdd + '<p>';
            if Length(LitresBookTitle) > MaxTitleLength then
            LitresBookTitle := copy(LitresBookTitle, 1, MaxTitleLength - 3) + '...';
            LastAdd := LastAdd+format('<a href="LitresBook:%d">%s</a></p></td>', [LitresID, LitresBookTitle]);
          end;
        end;
        // End - "Fade here is the example of recieving litres books"


        if RegReadInteger('HomeLastAdded', 1) = 1 then
          showLastAdded := True
        else
          showLastAdded := False;
        if RegReadInteger('HomeLastUpdated', 1) = 1 then
          showLastUpdated := True
        else
          showLastUpdated := False;
        if RegReadInteger('HomeBestRated', 1) = 1 then
          showBestRated := True
        else
          showBestRated := False;
        if RegReadInteger('HomeUnread', 1) = 1 then
          showUnread := True
        else
          showUnread := False;

        if (page_width > 300) and (AllPicWidth < 300) then begin
          LastAdd := LastAdd + Format('<td class="box-movies" style="width: %dpx;', [300 - AllPicWidth]) + ' background:url('+BackgroundMovies+') repeat-x;"></td>';
        end;

        //full tab names
        if (last_page_width > 610) then begin
          //200 is the full tab's width
          my_i := 200;
          TabNameMode := '';
          TabName1 := GetLangStr(2960);
          TabName2 := GetLangStr(2962);
          TabNameLitres := GetLangStr(20777);
          TabName3 := GetLangStr(2959);
          TabName4 := GetLangStr(2961);
        end
        //short tab names
        else begin
          //150 is the short tab's width
          my_i := 150;
          TabNameMode := '-short';
          TabName1 := GetLangStr(1407);
          TabNameLitres := 'Litres';
          TabName2 := GetLangStr(1408);
          TabName3 := GetLangStr(2963);
          TabName4 := '';
        end;

        //creating hyperlinks and defining tab types (active, inactive)
        Tab1Mode := 'in';
        Tab2Mode := 'in';
        Tab3Mode := 'in';
        Tab4Mode := 'in';
        TabLitresMode := 'in';
        MoviesMore := '';
        if HomeBookTab=0 then begin
          TabLitresMode := '';
          TabName1 := Format('<a href="modern_home:%d,%d,1,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:%d,%d,2,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:%d,%d,3,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:%d,%d,4,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName4]);
          MoviesMore := '<a href="litres">';
        end;
        if HomeBookTab=1 then begin
          Tab1Mode := '';
          TabNameLitres := Format('<a href="modern_home:%d,%d,0,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabNameLitres]);
          TabName2 := Format('<a href="modern_home:%d,%d,2,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:%d,%d,3,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:%d,%d,4,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:2001,%s">', [GetLangStr(2960)]);
        end;
        if HomeBookTab=2 then begin
          Tab2Mode := '';
          TabNameLitres := Format('<a href="modern_home:%d,%d,0,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabNameLitres]);
          TabName1 := Format('<a href="modern_home:%d,%d,1,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName3 := Format('<a href="modern_home:%d,%d,3,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:%d,%d,4,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:2002,%s">', [GetLangStr(2962)]);
        end;
        if HomeBookTab=3 then begin
          Tab3Mode := '';
          TabNameLitres := Format('<a href="modern_home:%d,%d,0,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabNameLitres]);
          TabName1 := Format('<a href="modern_home:%d,%d,1,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:%d,%d,2,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName4 := Format('<a href="modern_home:%d,%d,4,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:2003,%s">', [GetLangStr(2963)]);
        end;
        if HomeBookTab=4 then begin
          Tab4Mode := '';
          TabNameLitres := Format('<a href="modern_home:%d,%d,0,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabNameLitres]);
          TabName1 := Format('<a href="modern_home:%d,%d,1,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:%d,%d,2,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:%d,%d,3,%d,%d">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeGameTab, HomePersonTab, TabName3]);
          MoviesMore := Format('<a href="userref:2004,%s">', [GetLangStr(2961)]);
        end;

        //create tabs
        //Litres tab
        LitresTab := '';
        if flShowLitres then
          LitresTab := format('<td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td><td class="tab-space"></td>', [ImgPath, TabLitresMode, TabLitresMode, TabNameMode, TabNameLitres, ImgPath, TabLitresMode]);
        //last updated
        LastUpdatedTab := '';
        if (TabNameMode = '') and (showLastUpdated) then
          LastUpdatedTab := format('<td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td><td class="tab-space"></td>', [ImgPath, Tab4Mode, Tab4Mode, TabNameMode, TabName4, ImgPath, Tab4Mode]);
        //last added
        LastAddedTab := '';
        if showLastAdded then
          LastAddedTab := format('<td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td><td class="tab-space"></td>', [ImgPath, Tab1Mode, Tab1Mode, TabNameMode, TabName1, ImgPath, Tab1Mode]);

        //best rated
        BestRatedTab := '';
        if showBestRated then
          BestRatedTab := format('<td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td><td class="tab-space"></td>', [ImgPath, Tab2Mode, Tab2Mode, TabNameMode, TabName2, ImgPath, Tab2Mode]);

        //unread
        UnreadTab := '';
        if showUnread then
          UnreadTab := format('<td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td><td class="tab-space"></td>', [ImgPath, Tab3Mode, Tab3Mode, TabNameMode, TabName3, ImgPath, Tab3Mode]);

        i := last_page_width;
        if ((AllPicWidth + i) < 300) then
          i := 310;
        if TabNameMode <> 'none' then begin
          MyTabs:= '<tr><td><table class="tabs"><tr>';
          //check if there is enough space for the tab
          i := i - my_i;
          if flShowLitres and (i>0) then begin
            MyTabs := MyTabs + LitresTab;
            i := i - my_i;
          end;
          if showLastAdded and (i>0) then begin
            MyTabs := MyTabs + LastAddedTab;
            i := i - my_i;
          end;
          if showLastUpdated and (i>0) then begin
            MyTabs := MyTabs + LastUpdatedTab;
            i := i - my_i;
          end;
          if showUnread and (i>0) then begin
            MyTabs := MyTabs + UnreadTab;
            i := i - my_i;
          end;
          if showBestRated and (i>0) then
            MyTabs := MyTabs + BestRatedTab;
          MyTabs := MyTabs + '<td></td></tr></table></td></tr>';
        end;
        if j>0 then
          LastAdd:=LastAdd+Format('<td class="more">%s<img src="%smovies-more.gif" border="0"></a></td><td><td></tr></table></td></tr>', [MoviesMore, ImgPath]);

          Result := MyTabs+LastAdd;
      end;
    finally
      ResetRegistrySubKey();
      sl.Free();
    end;
  end;
end;

function GenerateAlbumsBlock(AProgramType: Integer; var AItemsCount: Integer): string;
var
  sl: TStringList;
  PersonCode, i, j, kol, kol2, page_width, code, my_i: integer;
  all, description, genre, year, director, writer, actor, bio, character, movie, LastAdd: string;
  FileName, site, url, postfix, s, rate, ThumbsPath: string;
  RecordCount, rating, LastCode, ShowLastUpdated: integer;
  IMDBRating: double;
  MyTabs, TabNameMode, TabName1, TabName2, TabName3, TabName4, Tab1Mode, Tab2Mode, Tab3Mode, Tab4Mode, MoviesMore, PersonsMore, LastUpdatedTab: String;
  myDate: TDateTime;
  full_date, tmp: String;
  PicWidth, PicHeight, page_width_copy, loaned_movies: Integer;
  CodesList: TStringList;
begin
  Result := '';
  ExecuteSQL('SELECT Count(*) as amount FROM movies WHERE in_collection=1 AND item_type=' + IntToStr(AProgramType));
  AItemsCount := GetIntegerField('amount');
  if (RegReadBoolean('HomePageShowAlbums', DefaultHomePageShowAlbums)) then
  begin
    SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
    sl:=TStringList.Create;
    AItemsCount := 0;
    try
      GenerateSQLForMoviesPages(sl, AProgramType, HomeAlbumTab, -1);
      AItemsCount:=ExecuteSQL(sl.text);
      RecordCount := AItemsCount;

      MyTabs := '';
      LastAdd := '';
      page_width:=GetHTMLWidth - WholePageBorder;
      page_width_copy := page_width;
      if RecordCount>0 then
      begin
        i:=1;
        j:=0;
        LastCode:=0;
        CodesList := TStringList.Create();
        while (page_width_copy >= 0) and (i<=RecordCount) do
        begin
          code:=GetIntegerField('code');
          if (CodesList.IndexOf(IntToStr(code)) < 0) then
          begin
            CodesList.Add(IntToStr(code));
            if j=0 then
              LastAdd:=LastAdd+'<tr><td><table class="boxes"><tr>';
            j:=j+1;
            LastCode:=code;
            PicHeight := GetIntegerField('height');
            if PicHeight > 0 then
              PicWidth := Round(GetIntegerField('width') * (CoverHeight / PicHeight)) + NormalImageBorders
            else
              PicWidth := StandardCoverWidth[AProgramType];
            page_width_copy := page_width_copy - PicWidth;
            if page_width_copy >= 0 then begin
              year:=GetStringField('year');

              rating:=GetIntegerField('rating');
              rate:='';
              if rating>0 then begin
                for my_i:=1 to 10 do begin
                  if my_i mod 2=1 then begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  end
                  else begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  end;
                end;
              end;
              IMDBRating := GetFloatField('imdb_rating');
              if year<>'' then
                s:=GetLangStr(169)+': '+year+'. '+rate
              else
                s:=rate;

              FileName := GetImageFileName(GetStringField('path'), 'ThumbsHomeAlbums', NO_COVER_FILE[AProgramType], 0, 140);

              LastAdd:=LastAdd+'<td class="box-movies" style="background:url('+BackgroundMovies+') repeat-x;">'+format('<a href="movie:%d"><img class="movie-cover" src="%s"></a>', [code, FileName]);
              if (rate<>'') and (RegReadInteger('ShowRating', 1) = 1) then
                LastAdd := LastAdd+'<br>'+rate;
              LastAdd := LastAdd + '<p>';
              if IMDBRating <> 0 then
                LastAdd:=LastAdd+format('IMDB: %0.1f<br>', [IMDBRating]);

              LastAdd := LastAdd+format('<a href="movie:%d">%s</a></p></td>', [code, GetStringField('title')]);
            end;

          end;

          GetNextRecord;
          i:=i+1;
        end;
        CodesList.Free();
        //full tab names
        if ((page_width - page_width_copy) > 410) then
        begin
          TabNameMode := '';
          if ShowLastUpdated = 0 then
            TabName1 := GetLangStr(10404)
          else
            TabName1 := GetLangStr(10408);
          TabName2 := GetLangStr(10405);
          TabName3 := GetLangStr(1404);
          TabName4 := GetLangStr(10408);
        end
        //short tab names
        else if ((page_width - page_width_copy) >= 270) then
        begin
          TabNameMode := '-short';
          TabName1 := GetLangStr(1407);
          TabName2 := GetLangStr(1408);
          TabName3 := GetLangStr(1409);
          TabName4 := '';
        end
        //no tabs
        else
          TabNameMode := 'none';

        //creating hyperlinks and defining tab types (active, inactive)
        Tab1Mode := 'in';
        Tab2Mode := 'in';
        Tab3Mode := 'in';
        Tab4Mode := 'in';
        MoviesMore := '';
        if HomeAlbumTab=1 then
        begin
          Tab1Mode := '';
          TabName2 := Format('<a href="modern_home:%d,2,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:%d,3,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:%d,4,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName4]);
          if ShowLastUpdated = 0 then
            MoviesMore := Format('<a href="userref:1001,%s">', [GetLangStr(10404)])
          else
            MoviesMore := Format('<a href="userref:1001,%s">', [GetLangStr(10408)]);
        end;
        if HomeAlbumTab=2 then
        begin
          Tab2Mode := '';
          TabName1 := Format('<a href="modern_home:%d,1,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName3 := Format('<a href="modern_home:%d,3,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName3]);
          TabName4 := Format('<a href="modern_home:%d,4,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:1002,%s">', [GetLangStr(10405)]);
        end;
        if HomeAlbumTab=3 then
        begin
          Tab3Mode := '';
          TabName1 := Format('<a href="modern_home:%d,1,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:%d,2,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName4 := Format('<a href="modern_home:%d,4,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName4]);
          MoviesMore := Format('<a href="userref:1003,%s">', [GetLangStr(1404)]);
        end;
        if HomeAlbumTab=4 then
        begin
          Tab4Mode := '';
          TabName1 := Format('<a href="modern_home:%d,1,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName1]);
          TabName2 := Format('<a href="modern_home:%d,2,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName2]);
          TabName3 := Format('<a href="modern_home:%d,3,%d,%d,%d">%s</a>', [HomeMovieTab, HomeBookTab, HomeGameTab, HomePersonTab, TabName3]);
          MoviesMore := Format('<a href="userref:1004,%s">', [GetLangStr(10408)]);
        end;

        //create tabs
        LastUpdatedTab := '';
        if (TabNameMode = '') and ((page_width - page_width_copy) > 610) and (ShowLastUpdated = 0) then
          LastUpdatedTab := format('<td class="tab-space"></td><td class="tab-border"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab4Mode, Tab4Mode, TabNameMode, TabName4, ImgPath, Tab4Mode]);


        if TabNameMode <> 'none' then
          MyTabs:=format('<tr><td><table class="tabs"><tr><td class="tab-border"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab1Mode, Tab1Mode, TabNameMode, TabName1, ImgPath, Tab1Mode]) + LastUpdatedTab + format('<td class="tab-space"></td><td class="tab-border"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab2Mode, Tab2Mode, TabNameMode, TabName2, ImgPath, Tab2Mode]) + '<td></td></tr></table></td></tr>';
        if j>0 then
          LastAdd:=LastAdd+Format('<td class="more">%s<img src="%smovies-more.gif" border="0"></a></td><td><td></tr></table></td></tr>', [MoviesMore, ImgPath]);

        Result := MyTabs + LastAdd;
      end;
    finally
      ResetRegistrySubKey();
      sl.Free();
    end;
  end;
end;

function GenerateMediaBlock(AProgramType: Integer; var AItemsCount: Integer): string;
begin
  Result := '';
  AItemsCount := 0;
  if (IsProgramUsed(AProgramType)) then
  begin
    case AProgramType of
      MOVIENIZER_PROGRAM: Result := GenerateMoviesBlock(AProgramType, AItemsCount);
      MUSICNIZER_PROGRAM: Result := GenerateAlbumsBlock(AProgramType, AItemsCount);
      BOOKNIZER_PROGRAM: Result := GenerateBooksBlock(AProgramType, AItemsCount);
      GAMENIZER_PROGRAM: Result := GenerateGamesBlock(AProgramType, AItemsCount);
    end;
  end;
end;

function GeneratePersonsBlock(var AItemsCount: Integer): string;
var
  sl, PreviousCodes: TStringList;
  PersonCode, i, j, kol, kol2, page_width, code, my_i: integer;
  description, genre, year, director, writer, actor, bio, character, movie, LastAdd: string;
  FileName, site, url, postfix, s, rate: string;
  RecordCount, rating, LastCode, ShowLastUpdated: integer;
  IMDBRating: double;
  MyTabs, TabNameMode, TabName1, TabName2, TabName3, TabName4, Tab1Mode, Tab2Mode, Tab3Mode, Tab4Mode, MoviesMore, PersonsMore, LastUpdatedTab, BirthdayTab: String;
  myDate: TDateTime;
  full_date, tmp, dbfilename: String;
  PicWidth, PicHeight, page_width_copy, loaned_movies, NumberOfBirthdays, AllPicWidth: Integer;
  NoPhotoFile: string;
begin
  Result := '';
  ExecuteSQL('SELECT Count(*) as amount FROM persons WHERE in_collection=1');
  AItemsCount := GetIntegerField('amount');
  if (RegReadBoolean('HomePageShowPersons', DefaultHomePageShowPersons)) then
  begin
    sl:=TStringList.Create;
    AItemsCount := 0;
    PreviousCodes := TStringList.Create;
    try
      //last added persons
      MyTabs := '';
      LastAdd := '';
      AllPicWidth := 0;

      with sl do begin
        Clear;
        Add('select count(code) as amount from persons where birth_date like ''%' + Format('%s', [GetTodaysDate]) + '%''');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      NumberOfBirthdays:=GetIntegerField('amount');
        GenerateSQLForPersonPages(sl, HomePersonTab, -1);
        AItemsCount:=ExecuteSQL(sl.text);
        RecordCount:=AItemsCount;
        page_width:=GetHTMLWidth - WholePageBorder;
        page_width_copy := page_width;
        if RecordCount>0 then begin
        i:=1;
        j:=0;
        LastCode:=0;
        PreviousCodes.Clear;
        while (page_width_copy >= 0) and (i<=RecordCount) do begin
          code:=GetIntegerField('code');
          if PreviousCodes.IndexOf(IntToStr(code)) < 0 then begin
            PreviousCodes.Add(IntToStr(code));
            if j=0 then
              LastAdd:=LastAdd+'<tr><td><table class="boxes"><tr style="background:url('+BackgroundPeople+') repeat-x;">'+format('<td class="more"><img src="%sadditional-people-block.gif"></td>', [ImgPath]);
            j:=j+1;
            LastCode:=code;
            PicHeight := GetIntegerField('height');
            if PicHeight > 0 then
              PicWidth := Round(GetIntegerField('width') * (PhotoHeight / PicHeight)) + NormalImageBorders
            else
              PicWidth := CoverCellWidth;
            if PicWidth < CoverCellWidth then
              PicWidth := CoverCellWidth;
            AllPicWidth := AllPicWidth + PicWidth;
            page_width_copy := page_width_copy - PicWidth;
            if page_width_copy >= 0 then begin
              rating:=GetIntegerField('rating');
              if rating>0 then
                rate:=GetLangStr(298)+': '+IntToStr(rating)
              else
                rate:='';

                s:=rate;

              NoPhotoFile := NO_PHOTO_FILE[GetIntegerField('item_type')];
              FileName := GetImageFileName(GetStringField('path'), 'ThumbsMoviePhotos', NoPhotoFile, 0, PhotoHeight);
              LastAdd:=LastAdd+format('<td class="box-photos"><a href="person:%d"><img class="person-photo" src="%s" alt="%s"><p>%s</a></p></td>',
                    [code, FileName, s, GetStringField('name')]);
            end;

          end;

          GetNextRecord;
          i:=i+1;
        end;
        if (page_width > 400) and (AllPicWidth < 400) then
          LastAdd := LastAdd + Format('<td style="width: %dpx;"></td>', [300 - AllPicWidth]);

      //long tab names
      if (page_width >= 650) and (AllPicWidth >=650) then begin
        TabNameMode := '';
        if ShowLastUpdated = 0 then
          TabName1 := GetLangStr(1405)
        else
          TabName1 := GetLangStr(1422);
        TabName2 := GetLangStr(1406);
        TabName3 := GetLangStr(1422);
        if NumberOfBirthdays > 0 then
          TabName4 := GetLangStr(2974)
        else
          TabName4 := '';
      end
      //short tab names
      else if (page_width >= 400) then begin
        TabNameMode := '-short';
        TabName1 := GetLangStr(1407);
        TabName2 := GetLangStr(1408);
        TabName3 := '';
        TabName4 := '';
      end
      //no tabs
      else
        TabNameMode := 'none';
      Tab1Mode := 'in';
      Tab2Mode := 'in';
      Tab3Mode := 'in';
      Tab4Mode := 'in';
      PersonsMore := '';
      if HomePersonTab = 1 then begin
        Tab1Mode := '';
        TabName2 := Format('<a href="modern_home:%d,%d,%d,%d,2">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName2]);
        TabName3 := Format('<a href="modern_home:%d,%d,%d,%d,3">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName3]);
        if TabName4 <> '' then
          TabName4 := Format('<a href="modern_home:%d,%d,%d,%d,4">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName4]);
        if ShowLastUpdated = 0 then
          PersonsMore := Format('<a href="userref:6,%s">', [GetLangStr(1405)])
        else
          PersonsMore := Format('<a href="userref:6,%s">', [GetLangStr(1422)]);
      end;
      if HomePersonTab = 2 then begin
        Tab2Mode := '';
        TabName1 := Format('<a href="modern_home:%d,%d,%d,%d,1">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName1]);
        TabName3 := Format('<a href="modern_home:%d,%d,%d,%d,3">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName3]);
        if TabName4 <> '' then
          TabName4 := Format('<a href="modern_home:%d,%d,%d,%d,4">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName4]);
        PersonsMore := Format('<a href="userref:7,%s">', [GetLangStr(1406)]);
      end;
      if HomePersonTab = 3 then begin
        Tab3Mode := '';
        TabName1 := Format('<a href="modern_home:%d,%d,%d,%d,1">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName1]);
        TabName2 := Format('<a href="modern_home:%d,%d,%d,%d,2">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName2]);
        if TabName4 <> '' then
          TabName4 := Format('<a href="modern_home:%d,%d,%d,%d,4">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName4]);
        PersonsMore := Format('<a href="userref:8,%s">', [GetLangStr(1422)]);
      end;
      if HomePersonTab = 4 then begin
        Tab4Mode := '';
        TabName1 := Format('<a href="modern_home:%d,%d,%d,%d,1">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName1]);
        TabName2 := Format('<a href="modern_home:%d,%d,%d,%d,2">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName2]);
        TabName3 := Format('<a href="modern_home:%d,%d,%d,%d,3">%s</a>', [HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, TabName3]);
        PersonsMore := Format('<a href="userref:9,%s">', [GetLangStr(2974)]);
      end;

      LastUpdatedTab := '';
      if (TabNameMode = '') and (page_width > 810) and (j*90 > 810) and (ShowLastUpdated = 0) then
        LastUpdatedTab := format('<td class="tab-space"></td><td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab3Mode, Tab3Mode, TabNameMode, TabName3, ImgPath, Tab3Mode]);

      if (TabName4 <> '') then
        BirthdayTab := format('<td class="tab-space"></td><td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab4Mode, Tab4Mode, TabNameMode, TabName4, ImgPath, Tab4Mode])
      else
        BirthdayTab := '';

      if TabNameMode <> 'none' then
          MyTabs:=format('<tr><td><table class="tabs"><tr><td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab1Mode, Tab1Mode, TabNameMode, TabName1, ImgPath, Tab1Mode]) + LastUpdatedTab + format('<td class="tab-space"></td><td class="tab-border-left"><img src="%s%sactive-tab-left.gif"></td><td class="%sactive-tab%s">%s</td><td class="tab-border"><img src="%s%sactive-tab-right.gif"></td>', [ImgPath, Tab2Mode, Tab2Mode, TabNameMode, TabName2, ImgPath, Tab2Mode]) + BirthdayTab + '<td></td></tr></table></td></tr>';
          if j>0 then
            LastAdd:=LastAdd+Format('<td class="more">%s<img src="%speople-more.gif" border="0"></a></td><td></td></tr></table></td></tr>', [PersonsMore, ImgPath]);

          Result := MyTabs+LastAdd;
        end;
    finally
      sl.Free();
      PreviousCodes.Free();
    end;
  end;
end;


function GeneratePartnersBlock(): string;
var
  I: Integer;
  s: string;
  site: string;
  url: string;
  postfix: string;
  sl: TStringList;
  RecordCount: Integer;
  ProgramTypesSQL: string;
begin
  Result := '';
  //links to partners
  if (RegReadBoolean('HomePageShowSupport', DefaultHomePageShowSupport)) then
  begin
    sl := TStringList.Create();
    ProgramTypesSQL := '';
    for I := LOW_PROGRAM_TYPE to HIGH_PROGRAM_TYPE do
    begin
      if (IsProgramUsed(I)) then
      begin
        if (ProgramTypesSQL <> '') then
          ProgramTypesSQL := ProgramTypesSQL + ' OR ';
        ProgramTypesSQL := ProgramTypesSQL + '(item_type = ' + IntToStr(I) + ')';
      end;
    end;

    with sl do begin
      Clear;
      Add('select distinct site, url, postfix, picture from partners');
      Add(format('where language like ''%s''', [ProgramLanguage]));
      Add(Format('AND (%s)', [ProgramTypesSQL]));
      Add('order by sort_order');
    end;

    RecordCount:=ExecuteSQL(sl.text);
    if RecordCount>0 then
    begin
      Result:=Result+'<tr><td class="free-space"></td></tr><tr><td><p class="usual-text">'+GetLangStr(438)+'</p></td></tr><tr><td>';

      for i:=1 to RecordCount do
      begin
        site:=GetStringField('site');
        url := AddPostfixToURL(GetStringField('url'), GetStringField('postfix'));
        s:=GetPartnerImageFile(site, GetStringField('picture'));
        if s='' then
          Result:=Result+'<a href="link:http://www.medianizer.com/redirect/'+url+format('">%s</a> ', [site])
        else
          Result:=Result+'<a href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%s%s" border="0" align="absmiddle"></a> ', [PicturesPath, s]);
        GetNextRecord;
      end;
      sl.Free();
      Result := Result + '</td></tr>';
    end;
  end;
end;

function NeedShowLogo(ANumberOfMovies: Integer; ANumberOfAlbums: Integer;
  ANumberOfBooks: Integer; ANumberOfGames: Integer; ANumberOfPersons: Integer): Boolean;
var
  LogoIdx: Integer;
begin
  Result := False;
  LogoIdx := RegReadInteger('HomeLogo', DefaultHomeLogo);
  case LogoIdx of
    0: Result := (ANumberOfMovies < 1) or (ANumberOfPersons < 1) or (ANumberOfAlbums < 1) or (ANumberOfBooks < 1) or (ANumberOfGames < 1);
    1: Result := True;
  end;
end;


function GetHomeModern(HomeMovieMode, HomeAlbumMode, HomeBookMode, HomeGameMode, HomePersonMode: Integer): string;
var
  sl, PreviousCodes: TStringList;
  PersonCode, i, j, kol, kol2, page_width, code, my_i: integer;
  all, description, genre, year, director, writer, actor, bio, character, movie, LastAdd: string;
  FileName, site, url, postfix, s, rate: string;
  RecordCount, rating, LastCode, ShowLastUpdated: integer;
  IMDBRating: double;
  MyTabs, TabNameMode, TabName1, TabName2, TabName3, TabName4, Tab1Mode, Tab2Mode, Tab3Mode, Tab4Mode, MoviesMore, PersonsMore, LastUpdatedTab, BirthdayTab: String;
  myDate: TDateTime;
  full_date, tmp, dbfilename: String;
  PicWidth, PicHeight, page_width_copy, loaned_movies, NumberOfBirthdays, AllPicWidth: Integer;
  NumberOfMovies, NumberOfAlbums, NumberOfBooks, NumberOfGames, NumberOfPeople: Integer;
  ProgramType: Integer;
  MoviesBlock: string;
  AlbumsBlock: string;
  BooksBlock: string;
  GamesBlock: string;
  PersonsBlock: string;
  ProgramTypesSQL: string;
begin
  result:='';
  all := '';
	ShowLastUpdated := RegReadInteger('ShowLastUpdated', 0);
  page_width:=GetHTMLWidth - WholePageBorder;
	sl:=TStringList.Create;
	PreviousCodes := TStringList.Create;
	HomeMovieTab := HomeMovieMode;
  HomeAlbumTab := HomeAlbumMode;
  HomeBookTab := HomeBookMode;
  HomeGameTab := HomeGameMode;
	HomePersonTab := HomePersonMode;
  NumberOfBooks := 0;
  NumberOfGames := 0;
  NumberOfMovies := 0;
  NumberOfAlbums := 0;
  NumberOfPeople := 0;
  MoviesBlock := GenerateMediaBlock(MOVIENIZER_PROGRAM, NumberOfMovies);
  AlbumsBlock := GenerateMediaBlock(MUSICNIZER_PROGRAM, NumberOfAlbums);
  BooksBlock := GenerateMediaBlock(BOOKNIZER_PROGRAM, NumberOfBooks);
  GamesBlock := GenerateMediaBlock(GAMENIZER_PROGRAM, NumberOfGames);
  PersonsBlock := GeneratePersonsBlock(NumberOfPeople);

  all:=GetPatternTop;
	all:= all + '<p class="title">' + GetProgramLimitedString('Medianizer',
    GetLangStr(91), GetLangStr(10087), GetLangStr(20087));
  all:=all+'</p></td>'+ClosePatternTop;
  all := all + Format('<tr><td><table class="content"><tr><td style="background:url(%s) repeat-x;">&nbsp;</td></tr><tr><td><table class="text-links"><tr><td class="controls">', [WhiteBarFile]);

  if (NeedShowLogo(NumberOfMovies, NumberOfAlbums, NumberOfBooks, NumberOfGames, NumberOfPeople)) then
  begin
    kol2 := NumberOfMovies + NumberOfAlbums + NumberOfBooks + NumberOfGames;
    s := GetProgramLimitedLangStr(30092, 700, 10159, 20159, 35274);
    if (Pos(':', ReverseString(s)) <> 1) then
      s := s + ':';
    all:=all+'<p class="usual-text">'+format('%s %d', [s, kol2])+'</p>';
    all:=all+'<p class="usual-text">'+format('%s %d', [GetProgramLimitedLangStr(702, 702, 10160, 20160, 35275), NumberOfPeople])+'</p>';
    all := all + '<p class="usual-text">&nbsp;</p>';

    //'Tasks:<ul><li><a href="add_movie">Add movie to collection</a><li><a href="add_person">Add person to collection</a><li><a href="search">Search movie or person</a></ul>';
    all:=all+'<p class="usual-text">'+GetLangStr(94)+'</p>';
    // header with task
    if (IsLimitedSingleProgram()) then
    begin
      if (IsProgramUsed(MUSICNIZER_PROGRAM)) then
        all:=all+'<p class="text-link"><a href="add_mp3_from_folder">'+GetLangStr(10606)+'</a></p>';
      all:=all+'<p class="text-link"><a href="add_movie">'+GetProgramLimitedLangStr(95, 95, 10090, 20090, 35013)+'</a></p>';
      all:=all+'<p class="text-link"><a href="add_person">'+GetProgramLimitedLangStr(96, 96, 10091, 20091, 35276)+'</a></p>';
      if (IsProgramUsed(MOVIENIZER_PROGRAM)) then
      	all := all + format('<p class="text-link"><a href="userref:5,%s">%s</a></p>', [GetLangStr(1452), GetLangStr(1453)])
      else if (IsProgramUsed(BOOKNIZER_PROGRAM)) then
      begin
        all:=all+'<p class="text-link"><a href="add_mp3_from_folder">'+GetLangStr(20015)+'</a></p>';
        all:=all+'<p class="text-link"><a href="add_movie_from_file">'+GetLangStr(2958)+'</a></p>';
      end;
    end
    else
    begin
      all := all + '<p class="text-link"><a href="add_media">'+GetLangStr(30045)+'</a></p>';
      all := all + '<p class="text-link"><a href="add_person">'+GetLangStr(96)+'</a></p>';
    end;
    all:=all+'</td>';
    // popular generes
    // if (IsLimitedSingleProgram()) then
    begin
      all:=all+'<td class="recommended">';
      if (not IsLimitedSingleProgram()) then
        SetRegistrySubKey(REGISTRY_SUB_KEYS[ActiveProgramType]);
      try
        with sl do
        begin
          Clear;
          // 26.01.11 - Fade: speed is increased 90 - 100 times for database with 200 000 movies
          Add('select mn.code as code, mn.name as name, count(mn.code) as amount');
          Add('from manuals mn');
          Add('left join movies_manuals mm ON mn.code=mm.ref_code');
          Add('left join movies m on m.Code = mm.Movie');
          Add('Where mm.reference=8');
          Add('AND m.in_collection=1');
          if (not IsLimitedSingleProgram()) then
             Add('AND m.item_type=' + IntToStr(ActiveProgramType));
          Add('group by mn.code, mn.name');
          Add('order by 3 desc');
          // End - 26.01.11
        end;
        kol:=ExecuteSQL(sl.text);
        kol2:=RegReadInteger('PopularGenresAmount', 6);
        if kol>kol2 then
          kol:=kol2;
        if kol>0 then
          s:='<p class="usual-text">'+GetLangStr(1300)+'</p>'
        else
          s:='';
        for i:=1 to kol do begin
          s:=s+format('<p class="text-link"><a href="genre:%d">%s (%d)</a></p>', [GetIntegerField('code'), GetStringField('name'), GetIntegerField('amount')]);
          GetNextRecord;
        end;
        all:=all+s;

        all:=all+'</td>';
      finally
        if (not IsLimitedSingleProgram()) then
          ResetRegistrySubKey();
      end;
    end;
    all:=all+Format('<td class="logo"><p><img src="%s"></p><p></td>', [GetProperPath(ImgPath + GetLogoFileName())]);
  end;
  all := all + '</tr></table></td></tr>';


  all := all + MoviesBlock;
  all := all + AlbumsBlock;
  all := all + BooksBlock;
  all := all + GamesBlock;
  all := all + PersonsBlock;

  //script setup link
  // all := all + '<tr><td class="free-space"></td></tr><tr><td><p class="text-link"><a href="userref:100,Options">'+GetLangStr(1333)+'</a></p></td></tr>';
  // partners
  all := all + GeneratePartnersBlock();

	//all:=all+'<a href="userref:666,Sex">test</a>';

	all := all + '</table>' + GetPatternBottom;

  result:=all;
  sl.Free;
  PreviousCodes.Free;
end;

begin

end.