﻿program modern_program_part3;

uses 'modern_program_variables.pas', 'modern_program_global.pas';

function GetThumbnailMovie(code, mode: integer; title, year: string; InCollection, rating: integer;
  AFullDescription: string = ''; ASearchDescription: string = ''): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img, seasons: string;
  fl, showCoversInList, FullList, ThisChecked, ShowCurrent, ShowDiscNr: boolean;
  i, j, kol, dir, amount, RecordCount: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
	BigOpen, BigClose, SmallOpen, SmallClose: string;
	kinopoisk_rating, imdb_rating, current_rating, current_site, disc_number: String;
	imdb_rating_number, kinopoisk_rating_number, current_rating_number: double;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
  try
    sl:=TStringList.Create;
    amount:=mode;
    s:='';
    ThumbsPath:=ImagesPath+Thumbs+'\';
    i := RegReadInteger('ShowCoversInList', 1);
    if i = 1 then
      showCoversInList := True
    else
      showCoversInList := False;
    i := RegReadInteger('MinimaList', 0);
    if i = 1 then
      FullList := False
    else
      FullList := True;
    if (RegReadInteger('ShowDiscNrInList', 0) = 1) then
      ShowDiscNr := True
    else
      ShowDiscNr := False;
      fl:=false;
      genres:='';
      directors:='';
      actors:='';
    ThisChecked := False;
    imdb_rating := '';
    kinopoisk_rating := '';
    current_rating := '';
    current_site := '';
    imdb_rating_number := 0;
    kinopoisk_rating_number := 0;
    current_rating_number := 0;
    disc_number := '';

    if RegReadInteger('ShowCurrentRatingInList', 1) = 1 then
      ShowCurrent := True
    else
      ShowCurrent := False;

    if GroupOperation then
      ThisChecked := IsMovieChecked(code);

      // Fade 16.08.2011 - For Search Thumbs do not add CheckBox picture
      if ((mode <> 7) and (GroupOperation)) then
      begin
        if ThisChecked then
          CheckMode:=format('<a href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
        CheckMode := '<div id="group_overlay_image">' + CheckMode + '</div>';
      end
      else
        CheckMode:='';

      //получаем дополнительную информацию о фильме, если он из коллекции
      if (InCollection=1) then begin
      if showCoversInList then begin
        //обложка
        with sl do begin
          Clear;
          Add('select path from images');
          Add(format('where movie=%d and mode=1', [code]));
          Add('order by sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          FileIn:=ImagesPath+GetStringField('path');
          FileName:=ThumbsPath+GetStringField('path');

          if MyFileExists(FileIn) then begin
            if not MyFileExists(FileName) then begin
              ConvertThumb3(FileIn, FileName, Thumbs, RegReadInteger('ThumbWidth', DefaultThumbWidth), 0, False);
            end;
            if not MyFileExists(FileName) then
              FileName:=FileIn;
          end
          else
            FileName:=FileIn;
          if MyFileExists(FileName) then
            fl:=true;
        end;
        if not fl then begin
          FileIn:=ImgPath + NO_COVER_FILE[MOVIENIZER_PROGRAM];
          FileName := ThumbsPath + NO_COVER_FILE[MOVIENIZER_PROGRAM];
          if MyFileExists(FileIn) then begin
            if not MyFileExists(FileName) then
              ConvertThumb3(FileIn, FileName, Thumbs, RegReadInteger('ThumbWidth', DefaultThumbWidth), 0, False);
            if not MyFileExists(FileName) then
              FileName := FileIn;
          end;
          fl:=true;
        end;
      end;

      if ShowCurrent then begin
        current_site := RegReadString('MovieScript', '');
        i := Pos(' (', current_site);
        if i>0 then
          delete(current_site, i, length(current_site)-i+1);
        if (current_site <> '') and (current_site <> 'kinopoisk') and (current_site <> 'imdb') then begin
          with sl do begin
            Clear;
            Add('select rating from movies_codes');
            Add(format('where movie=%d and script=''%s''', [code, current_site]));
          end;
          RecordCount := ExecuteSQL(sl.text);
          if RecordCount > 0 then begin
            current_rating_number := GetFloatField('rating');
            if current_rating_number > 0 then
              current_rating := '<NOBR>' + current_site + ': ' + FloatToStr(current_rating_number) + '</NOBR>; ';
          end;
        end;
      end;

      if (RegReadInteger('ShowIMDBRatingInList', 0) = 1) or ((current_site = 'imdb') and ShowCurrent) then begin
        with sl do begin
          Clear;
          Add('select imdb_rating from movies');
          Add(format('where code=%d', [code]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          imdb_rating_number := GetFloatField('imdb_rating');
          if (imdb_rating_number > 0) then
            imdb_rating := Format('<NOBR><img align="absmiddle" src="%simdb-ico.png"> ', [PicturesPath]) + FloatToStr(imdb_rating_number) + '</NOBR>; ';
        end;
      end;

      if (RegReadInteger('ShowKinopoiskRatingInList', 0) = 1) or ((current_site = 'kinopoisk') and ShowCurrent) then begin
        with sl do begin
          Clear;
          Add('select rating from movies_codes');
          Add(format('where movie=%d and script=''kinopoisk''', [code]));
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          kinopoisk_rating_number := GetFloatField('rating');
          if (kinopoisk_rating_number > 0) then
            kinopoisk_rating := Format('<NOBR><img align="absmiddle" src="%skinopoisk-ico.png"> ', [PicturesPath]) + Format('%.1f', [kinopoisk_rating_number]) + '</NOBR>; ';
        end;
      end;

      //disc number (only first edition)
      if ShowDiscNr then begin
        with sl do begin
          Clear;
          Add('select disc_nom from editions');
          Add(format('where movie=%d', [code]));
          Add('order by sort_order');
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          s := GetStringField('disc_nom');
          if (s <> '') and (s <> '0') then
            disc_number := Format('<NOBR>%s: %s</NOBR>', [GetLangStr(391), s]);
        end;
      end;

        if amount>0 then begin
        //жанры
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=8', [code]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        for j:=1 to RecordCount do begin
          genres:=genres+format('<a href="genre:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        if genres<>'' then
          genres:=copy(genres, 1, length(genres)-2);

        //режиссеры и актеры
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection, d.mode from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode in (1,3)', [code]));
          //Add('and d.sort_order<10');//27.07.07
          Add('order by d.mode, d.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        i:=0;
        j:=0;
        dir:=0;
        while (i<RecordCount) and (j<amount) do begin
          if GetIntegerField('p.in_collection')=1 then
            img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
          else
            img:='';
          if GetIntegerField('d.mode')=1 then begin
            if dir<=3 then begin
              directors:=directors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), GetStringField('p.name')]);
              dir:=dir+1;
            end;
          end
          else begin
            actors:=actors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), GetStringField('p.name'), j]);
            j:=j+1;
          end;
          i:=i+1;
          GetNextRecord;
        end;
      end;
      if directors<>'' then
        directors:=copy(directors, 1, length(directors)-2);

      if actors<>'' then
        actors:=copy(actors, 1, length(actors)-2);

      if year<>'' then
        year:=format(' (%s)', [year]);

      if rating>0 then
        rate:=format(' <img src="%sstar.gif" width=16 height=16 border=0 align="absmiddle">%d', [ImgPath, rating])
      else
        rate:='';
      BigOpen:='';
      BigClose:='';
      SmallOpen:='<small>';
      SmallClose:='</small>';
      if GetCutePreview or (mode=7) then begin
        BigOpen:='<big>';
        BigClose:='</big>';
        SmallOpen:='';
        SmallClose:='';
      end;
      if showCoversInList then begin
        s:=format(CheckMode + '<div><div class="thumb-cover-border"><a href="movie:%d"><img class="thumb-cover"  style="width: %dpx;" src="%s"', [code, RegReadInteger('ThumbWidth', DefaultThumbWidth), FileName]);
        if not GetCutePreview and (mode<>7) then
          s:=s+' width="50" border="0" align="left"';
        s:=s+'></a></div>';
      end;
      s := s+format('<div class="thumb-text"><a href="movie:%d">%s<b>%s</b>%s</a>%s%s%s<br>', [code, BigOpen, title, BigClose, SmallOpen, year, rate]);

      //site ratings
      if FullList and ((imdb_rating <> '') or (kinopoisk_rating <> '') or (current_rating <> '')) then begin
        s := s + current_rating + imdb_rating + kinopoisk_rating;
        s := copy(s, 1, length(s)-2) + '<br>';
      end;

      //disc number
      if (disc_number <> '') then
        s := s + disc_number + '<br>';

      //Genres
      if (genres<>'') and FullList then begin
        if mode<>1 then
          genres:=GetLangStr(179)+': '+genres;
        s:=s+genres+'<br>';
      end;
      //Directors
      if FullList and (mode<>1) and (directors<>'') then
        s:=s+GetLangStr(181)+': '+directors+'<br>';
      //Actors
      if FullList and (actors<>'') then begin
        if mode<>1 then
          actors:=GetLangStr(164)+': '+actors;
        s:=s+actors+'<br>';
      end;
      s := s+SmallClose;
      end
      else begin
      if year<>'' then
        year:=format(' (%s)', [year]);
      s:=CheckMode+format('<a href="movie:%d"><b>%s</b>%s</a>', [code, title, year]);
      end;

    //seasons
    seasons:='';
    with sl do begin
      Clear;
      Add('select distinct season from episodes');
      Add(format('where movie=%d', [code]));
      Add('order by season');
    end;
    RecordCount:=ExecuteSQL(sl.text);
    for i:=1 to RecordCount do begin
      j := GetIntegerField('season');
      if j = 99 then
         j := 0;
      seasons:=seasons+format('<a href="userref:114,%d;%d">%d</a> ', [code, GetIntegerField('season'), j]);
      GetNextRecord;
    end;
    if FullList and (seasons<>'') then begin
      seasons:=GetLangStr(517)+' '+seasons;
      delete(seasons, length(seasons), 1);
      s:=s+seasons;
    end;

    s := s + GenerateHTMLForDescriptionSearching(AFullDescription, ASearchDescription);
    s := s+'</div></div>';
    if mode=7 then
      s:='<tr><td class="thumb">'+s+'</td></tr>';
    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetThumbnailMovieExtended(code, mode: integer; title: string): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img, seasons: string;
  fl, CutThumb: boolean;
  i, j, kol, dir, amount, RecordCount, CoverWidth, CoverHeight: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
  ProgramType: Integer;
begin
	result:='';
  ProgramType := MOVIENIZER_PROGRAM;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try

    sl:=TStringList.Create;
    amount:=mode;
    s:='';

    ThumbsPath:=ImagesPath+'Thumbs2\';

    fl:=false;
    genres:='';
    directors:='';
    actors:='';
      //обложка
      with sl do begin
        Clear;
        Add('select * from images');
        Add(format('where movie=%d and mode=1', [code]));
      Add('order by sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);

      CoverWidth := RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[ProgramType]);
      CoverHeight := RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[ProgramType]);

      if (CoverWidth <= 0) and (CoverHeight <= 0) then begin
        CoverWidth := DefaultMultiCoverWidth[ProgramType];
        CoverHeight := DefaultMultiCoverHeight[ProgramType];
      end;

      {i := RegReadInteger('CutThumb', 1);
      CutThumb := (I = 1);
      FileName := GetImageFileName(GetStringField('path'), ThumbsPath,
        NO_COVER_FILE[MOVIENIZER_PROGRAM], CoverWidth, CoverHeight, CutThumb);
      fl := True;}

      if RecordCount>0 then
      begin
        i := RegReadInteger('CutThumb', 1);
        if i = 1 then
          CutThumb := True
        else
          CutThumb := False;
        FileIn:=ImagesPath+GetStringField('path');
        FileName:=ThumbsPath+GetStringField('path');
        if MyFileExists(FileName) then
          fl:=true
        else if MyFileExists(FileIn) then
          ConvertThumb2(FileIn, FileName, CoverWidth, CoverHeight, CutThumb);
        if MyFileExists(FileName) then
          fl:=true;
      end;
      if not fl then
      begin
        FileIn:=ImgPath + NO_COVER_FILE[MOVIENIZER_PROGRAM];
        FileName:=ThumbsPath + NO_COVER_FILE[MOVIENIZER_PROGRAM];
        if ((not MyFileExists(FileName)) and
            (MyFileExists(FileIn))) then
        begin
          ConvertThumb2(FileIn, FileName, CoverWidth, CoverHeight, CutThumb);
        end;
        fl:=true;
      end;

      if GroupOperation then
      begin
        if (IsMovieChecked(code)) then
          CheckMode:=format('<a href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
        CheckMode := '<div id="group_overlay_image_multi">' + CheckMode + '</div>';
      end
      else
        CheckMode:='';

      s:=format(CheckMode + '<table><tr><td align="center"><div class="thumb-big-cover-border"><a href="movie:%d"><img class="thumb-big-cover" src="%s"></a></div></td></tr><tr><td>', [code, FileName])+format('<a href="movie:%d"><b>%s</b></a></td></tr></table>', [code, title]);


    if mode=7 then
      s:='<tr><td>'+s+'</td></tr>';

    if amount=3 then
      s:='<div class="preview">'+s+'</div>';
    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;


function GetMovieTabs(MovieCode, SeasonNr, SeasonCnt: Integer; Awards, Shots, Params, Posters, Trailers, Desc, Connections: Boolean;
  SeasonNumbers: TStringList): String;
var
	s, s2, media_format, prev_media_format : String;
	i, k, my_tabs, PageWidth, SeasonTabs, PageTabs, RecordCount: Integer;
	sl: TStringList;
begin
	RemainingTabs := '';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
  try
    PageWidth := GetHTMLWidth - TabBorders;
    SeasonTabs := PageWidth div SeasonTabWidth;
    PageTabs := PageWidth div TabWidth;
    s := '<tr><td colspan="2"><table';
    if (ActiveTab <> 2) and (ActiveTab <> 7) then
      s := s + ' width="100%"';
    s := s + '><tr>';
    if (ActiveTab = 2) or (ActiveTab = 7) then
      s := s + '<td width="205"></td>';
    //general info tab
    if ActiveTab = 1 then
      s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(161)])
    else
      s := s + Format('<td class="movie-inactive-tab"><a href="userref:109,%d">%s</a></td>', [MovieCode, GetLangStr(161)]);
    PageTabs := PageTabs - 1;
    //screenshots
    if (Shots) and (PageTabs > 0) and (RegReadInteger('ShowShotTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 2 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(1429)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:110,%d">%s</a></td>', [MovieCode, GetLangStr(1429)]);
    end;
    //posters
    if (Posters) and (PageTabs > 0) and (RegReadInteger('ShowPosterTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 7 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(1425)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:115,%d">%s</a></td>', [MovieCode, GetLangStr(1425)]);
    end;
    //trailers
    if (Trailers) and (PageTabs > 0) and (RegReadInteger('ShowTrailerTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 9 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(1458)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:117,%d">%s</a></td>', [MovieCode, GetLangStr(1458)]);

    end;

    //awards
    if (Awards) and (PageTabs > 0) and (RegReadInteger('ShowAwardsTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 3 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(574)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:111,%d">%s</a></td>', [MovieCode, GetLangStr(574)]);
    end;

    //actors
    if (PageTabs > 0) and (RegReadInteger('ShowActorTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 4 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(68)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:112,%d">%s</a></td>', [MovieCode, GetLangStr(68)]);
    end;
    //parameters
    if (Params) and (PageTabs > 0) and (RegReadInteger('ShowParameterTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 5 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(1254)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:113,%d">%s</a></td>', [MovieCode, GetLangStr(1254)]);
    end;

    //description
    if (Desc) and (PageTabs > 0) and (RegReadInteger('ShowDescriptionTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 10 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(162)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:118,%d">%s</a></td>', [MovieCode, GetLangStr(162)]);
    end;

    //loans
    if (PageTabs > 0) and (RegReadInteger('ShowLoanTab', 0) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 8 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(1440)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:116,%d">%s</a></td>', [MovieCode, GetLangStr(1440)]);
    end;

    //Connections
    if (Connections) and (PageTabs > 0) and (RegReadInteger('ShowConnectionsTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 11 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(4155)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:119,%d">%s</a></td>', [MovieCode, GetLangStr(4155)]);
    end;

    //seasons
    if (SeasonCnt > 0) and (PageTabs > 0) and (RegReadInteger('ShowSeasonTab', 1) = 1) then begin
      if ActiveTab = 6 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(521)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:114,%d;%d">%s</a></td>', [MovieCode, SeasonNr, GetLangStr(521)]);
    end;

    //media format logo
    if (ActiveTab <> 2) and (ActiveTab <> 7) then begin
      s := s + '<td width="100%"></td>';
      sl := TStringList.Create;
      with sl do begin
        Clear;
        Add('select m.name from editions e');
        Add('left outer join manuals m on m.code=e.media_format');
        Add(format('where e.movie=%d', [MovieCode]));
        Add('order by e.media_format');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      prev_media_format := '';
      k := 0;
      for i:=1 to RecordCount do begin
        media_format := LowerCase(GetStringField('m.name'));
        if (prev_media_format <> media_format) and (PageTabs > 0) then begin
          if (media_format = 'blu-ray') then begin
            s := s + format('<td align="right"><img alt="Blu-Ray" src="%sbd-logo-medium.gif"></td>', [ImgPath]);
            k := k + 1;
          end;
          if (media_format = 'dvd') then begin
            s := s + format('<td align="right"><img alt="DVD" src="%sdvd-logo-medium.gif"></td>', [ImgPath]);
            k := k + 1;
          end;
          if (media_format = 'hd dvd') then begin
            s := s + format('<td align="right"><img alt="HD DVD" src="%shddvd-logo-medium.gif"></td>', [ImgPath]);
            k := k + 1;
          end;
          if (Pos('mkv', media_format)>0) then begin
            if (PageTabs >= 1) and (k=0) then begin
              s := s + format('<td align="right"><img alt="MKV Matroska" src="%smkv-logo-medium.gif"></td>', [ImgPath]);
              k := k + 2;
            end
            else begin
              s := s + format('<td align="right"><img alt="MKV Matroska" src="%smkv-logo-cut-medium.gif"></td>', [ImgPath]);
              k := k + 1;
            end;
          end;
          prev_media_format := media_format;
          if k >= 2 then begin
            k := 0;
            PageTabs := PageTabs - 1;
          end;
        end;
        GetNextRecord;
      end;
      //video codec logo (divx, xvid)
      with sl do begin
        Clear;
        Add('select m.name from editions e');
        Add('left outer join manuals m on m.code=e.video_codec');
        Add(format('where e.movie=%d', [MovieCode]));
        Add('order by e.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      prev_media_format := '';
      for i:=1 to RecordCount do begin
        media_format := LowerCase(GetStringField('m.name'));
        if (media_format <> prev_media_format) and (PageTabs > 0) then begin
          if (Pos('divx', media_format)>0) then begin
            s := s + format('<td align="right"><img alt="DivX" src="%sdivx-logo-medium.gif"></td>', [ImgPath]);
            k := k + 2;
          end;
          if (Pos('xvid', media_format)>0) then begin
            s := s + format('<td align="right"><img alt="XviD" src="%sxvid-logo-medium.gif"></td>', [ImgPath]);
            k := k + 2;
          end;
          prev_media_format := media_format;
          if k >= 2 then begin
            k := 0;
            PageTabs := PageTabs - 1;
          end;
        end;
        GetNextRecord;
      end;
      sl.Free;
    end;

    //filter by seasons
    if (ActiveTab = 6) then begin
      //tabs for seasons
      if SeasonCnt > 1 then begin
        s := s + '</tr></table></td></tr><tr><td colspan="2"><table><tr>';
        my_tabs := 1;
        if SeasonNr = 0 then
          s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(40)])
        else
          s := s + Format('<td class="movie-inactive-tab"><a href="userref:114,%d;%d">%s</a></td>', [MovieCode, 0, GetLangStr(40)]);
        for i := 1 to SeasonNumbers.Count do begin
          //depending on the page's width show season numbers in several rows
          if my_tabs > SeasonTabs then begin
            s := s + '</tr><tr>';
            my_tabs := 0;
          end;
          if SeasonNumbers[i-1] = '99' then begin
            s2 := GetLangStr(1606);
          end
          else
            s2 := SeasonNumbers[i-1];
          if IntToStr(SeasonNr) = SeasonNumbers[i-1] then
            s := s + Format('<td class="movie-active-tab">%s</td>', [s2])
          else
            s := s + Format('<td class="movie-inactive-tab"><a href="userref:114,%d;%s">%s</a></td>', [MovieCode, SeasonNumbers[i-1], s2]);
          my_tabs := my_tabs + 1;
        end;
      end;
    end;
    s := s + '</tr></table></td></tr>';
    Result := s;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetMoviePage(MovieCode, season: integer; FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
var
  sl, PreviousCodes, SeasonNumbers, UnseenList: TStringList;
  duration, i, j, k, l, kol, rmax, RecordCount: integer;
  all, s, s2, s3, country, description, comment, genre, year, director, writer, composer, actor, character, down, salary, awards, studios: string;
  rating: integer;
  IMDBRating, SiteRating, EditionCost: double;
  FileName, img, OriginalTitle, site, url, postfix: string;
  flCollection, flSeen, flWanted, flForSale, LastCode: integer;
  collection, seen, wanted, sale, rate, mpaa, mpaa_desc, disc_nom, seasons: string;
  VideoStandard, ScreenRatio, resolution, mpaa_code, VideoBitrate, VideoCodec, filesize: integer;
  DiscLabel: integer;
  custom: array[1..6] of integer;
  cust: string;
  DateAdd, DateUpdate, DateSeen, loan_date, return_date: string;
  age, border: string;
  editions: array [1..1000] of integer;
  EditionsCount, EditionCode, MediaFormat, ie: integer;
  ed, temp, barcode, OtherRating, EditionFeatures, EditionComment, VideoFileFolder, VideoFileName, TagLine: string;
  PrevBlockCnt, ThisBlockCnt, ShotCnt, MaxShots, hours, minutes, SeasonCnt, PosterCnt, MediaType: Integer;
  page_width, PicWidth, PicHeight, TrailerCnt, MovieSeries, MovieSeriesNumber, ConnectionsCnt: Integer;
  NoTrailerAdded, TVSeriesSpecials: Boolean;
  trunc_name, trunc_character, front_cover_url: String;
  temp_name, new_name, name: string;
  OldLinkStatus: Integer;
  LinkYearStr: string;
  LinkMovieStr: string;
  LinkMovieStatusTitle: string;
  FullAwardsText, ends_with, status: string;
begin
	result:='';
	sl:=TStringList.Create;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
  try
    all:='';
    OtherRating := '';
    TVSeriesSpecials := False;
    PreviousCodes := TStringList.Create;


    with sl do begin
    Clear;
      Add('select code from images');
      Add(format('where movie=%d and mode=3', [MovieCode]));
    end;
    ShotCnt:=ExecuteSQL(sl.text);

    with sl do begin
    Clear;
      Add('select count(code) as amount from movies_codes');
      Add(format('where movie=%d and script=''trailer''', [MovieCode]));
    end;
    RecordCount:=ExecuteSQL(sl.text);
    TrailerCnt := GetIntegerField('amount');

    // count movie connections
    with sl do begin
      Clear;
      Add('select count(code) as amount from movies_links');
      Add(Format('where movie_primary=%d', [MovieCode]));
    end;
    RecordCount := ExecuteSQL(sl.text);
    ConnectionsCnt := GetIntegerField('amount');


        with sl do begin
          Clear;
          Add('select * from movies');
          Add(format('where code=%d', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount=0 then
          exit;
        s:='movie:'+IntToStr(MovieCode);
        movie:=GetStringField('title');

        OriginalTitle:=GetStringField('original_title');
        rating:=GetIntegerField('rating');
        IMDBRating:=GetFloatField('imdb_rating');

      flCollection:=GetIntegerField('in_collection');
      flSeen:=GetIntegerField('seen');
      flWanted:=GetIntegerField('wanted');
      flForSale:=GetIntegerField('for_sale');
      mpaa_code:=GetIntegerField('mpaa');
      mpaa_desc:=GetStringField('mpaa_rating');
      MediaType := GetIntegerField('media_type');

      DateAdd:=GetStringField('date_add');
      DateUpdate:=GetStringField('date_update');
      DateSeen:=GetStringField('date_seen');
      TagLine := GetStringField('tagline');
    MovieSeriesNumber := GetIntegerField('series_nom');
    MovieSeries := GetIntegerField('series');

    if (ConnectionsCnt <= 0) and (MovieSeries > 0) then
      ConnectionsCnt := 1;

        //GoForward(s, GetStringField('m.title'), ChangeHistory);

        description:=GetStringField('description');
        salary:=GetStringField('salary');
        awards:=GetStringField('awards');
        comment:=GetStringField('comment');

      FullAwardsText := awards;

        custom[1]:=GetIntegerField('custom1');
        custom[2]:=GetIntegerField('custom2');
        custom[3]:=GetIntegerField('custom3');
        custom[4]:=GetIntegerField('custom4');

        if GetStringField('duration')='' then
          duration:=0
        else
          duration:=GetIntegerField('duration');
        year:=GetStringField('year');

        disc_nom:=GetStringField('disc_nom');

        if flCollection=0 then
          collection:=format('<a href="collection:%d"><img src="%snot_collection.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(326)])
        else
          collection:=format('<a href="collection:%d"><img src="%scollection.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(325)]);


        if flSeen=0 then
          seen:=format('<a href="seen:%d"><img src="%snot_seen.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(328)])
        else
          seen:=format('<a href="seen:%d"><img src="%sseen.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(327)]);

        if flWanted=0 then
          wanted:=format('<a href="wanted:%d"><img src="%snot_wanted.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(330)])
        else
          wanted:=format('<a href="wanted:%d"><img src="%swanted.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(329)]);

        if flForSale=0 then
          sale:=format('<a href="sale:%d"><img src="%snot_sale.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(332)])
        else
          sale:=format('<a href="sale:%d"><img src="%ssale.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(331)]);

        rate:='';
        for i:=1 to 10 do begin
          if i mod 2=1 then begin
            if i<=rating then
              rate:=rate+format('<a href="rating:%d"><img src="%sstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
            else
              rate:=rate+format('<a href="rating:%d"><img src="%snot-star-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
          end
          else begin
            if i<=rating then
              rate:=rate+format('<a href="rating:%d"><img src="%sstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
            else
              rate:=rate+format('<a href="rating:%d"><img src="%snot-star-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
          end;
        end;

        //description
        if description<>'' then begin
          if (ActiveTab <> 10) and (not FullDesc) and (length(description)>DescriptionLength) then begin
            description:=copy(description, 1, DescriptionLength);
            description:=RemoveUnclosedTags(description);
            description:=description+format(GetLangStr(566), [MovieCode]);
          end;
        end;

        if description='' then
          down:='<br>'+format('<a href="DownloadMovie:%d">', [MovieCode])+GetLangStr(324)+'</a>'
        else
          down:='';

    // Count seasons
    SeasonNumbers := TStringList.Create;
    with sl do begin
      Clear;
      Add('select distinct e.season from episodes e');
      Add(format('where e.movie=%d', [MovieCode]));
      Add(' order by e.season');
     end;
    SeasonCnt:=ExecuteSQL(sl.text);
    for i := 1 to SeasonCnt do begin
      if GetIntegerField('e.season') = 99 then
        TVSeriesSpecials := True;
      SeasonNumbers.Add(IntToStr(GetIntegerField('e.season')));
      GetNextRecord;
    end;

    VideoFileName := '';
      with sl do begin
          Clear;
          Add('select e.filename from editions e');
          Add('left outer join manuals m on m.code=e.edition and m.reference=21');
          Add(format('where e.movie=%d', [MovieCode]));
          Add('order by e.sort_order');
      end;
      EditionsCount:=ExecuteSQL(sl.text);
    VideoFileName := GetStringField('e.filename');

    with sl do begin
      Clear;
          Add('select code from images');
          Add(format('where movie=%d and mode=4', [MovieCode]));
        end;
      PosterCnt:=ExecuteSQL(sl.text);

    if (ActiveTab <> 3) and (not FullAwards) and (length(awards)>DescriptionLength) then begin
      awards:=copy(awards, 1, DescriptionLength);
      awards:=RemoveUnclosedTags(awards);
      awards:=awards+format(GetLangStr(1331), [MovieCode]);
    end;

        all:=GetPatternTop;
      all:= all + '<p class="title">' + movie;
      if (OriginalTitle <> '') and (OriginalTitle <> movie) then
        all := all + '<font size="3"> <b>('+OriginalTitle+')</b></font>';
      all:= all + Format('</p></td><td class="icons"><table class="icons-container"><tr><td class="icons-border"><img src="%sicons-left.gif"></td><td class="icons-place">%s%s%s%s&nbsp;</td><td class="edit-link"><p><a href="UpdateMovie:%d">%s</a></p></td><td class="icons-border"><img src="%sicons-right.gif"></td></tr></table>', [ImgPath, collection, seen, wanted, sale, MovieCode, GetLangStr(304), ImgPath]) + ClosePatternTop;

    if (ActiveTab <> 2) and (ActiveTab <> 7) then begin

        //pictures
      front_cover_url := '';
      all := all + '<tr><td class="left"><table class="left-pane">';
        with sl do begin
          Clear;
          Add('select path, code from images');
          Add(format('where movie=%d and mode=1', [MovieCode]));
      Add('order by sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
      all:=all+'<tr><td>';
        if RecordCount>0 then
        begin
          front_cover_url := GetStringField('path');
          if (MyFileExists(ImagesPath+GetStringField('path'))) then
          begin
            FileName := GetImageFileName(GetStringField('path'), 'ThumbsCovers',
              NO_COVER_FILE[MOVIENIZER_PROGRAM], MainCoverWidth, 0);

            all:=all+format('<div class="cover"><a href="ShowImage:%d"><img class="cover-image" src="%s"></a></div>',
              [GetIntegerField('code'), FileName]);
          end;
      end
      else
      begin
        FileName := GetImageFileName(GetStringField('path'), 'ThumbsCovers', NO_COVER_FILE[MOVIENIZER_PROGRAM], MainCoverWidth, 0);
        if (MyFileExists(FileName)) then
          all:=all+format('<div class="cover"><img class="cover-image" src="%s"></div>', [FileName]);
      end;

      all:=all+'</td></tr><tr><td class="free-space"></td></tr>';

      //site links
        with sl do begin
          Clear;
          Add('select distinct mc.code, mc.site, mc.script, mc.rating, p.* from movies_codes mc');
          Add('left outer join partners p on mc.script=p.site');
          Add('AND mc.item_type = p.item_type');
          Add(format('where movie=%d', [MovieCode]));
          Add('order by p.sort_order, mc.script');
        end;
        RecordCount:=ExecuteSQL(sl.text);

      for i:=1 to RecordCount do begin
        site:=GetStringField('mc.script');
        url:=GetStringField('mc.site');
        if (site <> 'trailer') and (url <> '') then begin
          postfix:=GetStringField('p.postfix');
          all := all+'<tr><td class="site-link">';
          if postfix<>'' then
            url:=url+postfix;
          if site='buy' then begin
            if Pos('amazon', url)>0 then
              all:=all+'<a class="picture" alt="Buy at Amazon"  href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%samazon.gif"></a> ', [PicturesPath])
            else
              all:=all+format(GetLangStr(375), ['http://www.medianizer.com/redirect/'+url, movie])+' ';
          end
          else begin
            s:=GetStringField('p.picture');
            if s='' then
            all:=all+'<a href="link:http://www.medianizer.com/redirect/'+url+format('">%s</a> ', [site])
            else
              all:=all+'<a class="picture" href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%s%s"></a> ', [PicturesPath, s]);
          end;
          i := RegReadInteger('ShowSiteRating', 1);
          if i=1 then begin
            SiteRating:=GetFloatField('mc.rating');
            if (SiteRating>0) and (site<>'imdb') then
              all := all + format('<p class="simple-text">%s: %f</p>', [GetLangStr(75),SiteRating]);
          end;
          all := all + '</td></tr>';
        end;
        GetNextRecord;
      end; //for

      //my rating
      i := RegReadInteger('ShowRating', 1);
      if i=1 then begin
        all := all + '<tr><td class="free-space"></td></tr>';
        all := all + Format('<tr><td class="my-rating-cell-name">%s</td></tr>', [GetLangStr(298)]);
        all := all + '<tr><td class="my-rating-cell-value">'+rate+'</td></tr>';
      end;

      //imdb rating
      if IMDBRating <> 0 then begin
        if i<>1 then
          all := all + '<tr><td class="free-space"></td></tr>'
        else
          all := all + '<tr class="small-free-space"><td></td></tr>';
        all := all + Format('<tr><td class="imdb-rating-cell-name">%s</td></tr>', [GetLangStr(707)]) + Format ('<tr><td class="imdb-rating-cell-value">%0.1f</td></tr>', [IMDBRating]);
      end;

    all := all + '<tr><td class="free-space"></td></tr></table>';

      //pictures from movie
    MaxShots := RegReadInteger('ShotsCnt', 3);
    with sl do begin
      Clear;
          Add('select i.path, i.code, i.mode from images i');
      Add('left join images_modes im on im.code = i.mode');
          Add(format('where i.movie=%d', [MovieCode]));
      if (RegReadInteger('OnlyShots', 1) = 1) then
        Add('and mode=3');
      Add('order by im.sort_order, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        kol:=0;
      j := 0;
      if ((front_cover_url = '') and (RecordCount>0)) or (RecordCount > 1) then begin
        all:=all+'<table class="shots">';
        if RecordCount < MaxShots then
          MaxShots := RecordCount;
        for i:=1 to MaxShots do begin
          //skip the cover
          if (front_cover_url <> '') and (GetIntegerField('i.mode') = 1) and (j = 0) then
            j := j + 1
          else begin
            if (MyFileExists(ImagesPath+GetStringField('i.path'))) then begin
              FileName := GetImageFileName(GetStringField('i.path'), 'ThumbsScreenshots',
                NO_COVER_FILE[MOVIENIZER_PROGRAM], ScreenshotWidth, 0);
              all:=all+format('<tr><td class="shots-cell"><a class="picture" href="ShowImage:%d"><img class="shot-image" src="%s"></a></td></tr>', [GetIntegerField('i.code'), FileName]);
            end;
          end;
          GetNextRecord;
        end;
        if RecordCount > MaxShots then
          all:=all+format('<tr><td class="shots-cell"><a href="userref:110,%d"><img alt="%s" src="%sshots-more.gif" border="0"></a></td></tr>', [MovieCode, GetLangStr(1411), ImgPath]);
        all:=all+'</table>';
      end; //if

    //end left pane
    all := all + '</td>';


      //right pane
      all := all + '<td width="100%"><table class="contents">';
    end; //if ActiveTab <> 2

    //Check if the active tab exists
    //no seasons
    if ((ActiveTab = 6) and (SeasonCnt = 0)) or
    //no parameters
    ((ActiveTab = 5) and (EditionsCount = 1) and (VideoFileName = '')) or
    //no shots
    ((ActiveTab = 2) and (shotCnt = 0)) or
    //no posters
    ((ActiveTab = 7) and (PosterCnt = 0)) or
    //no trailers
    ((ActiveTab = 9) and (TrailerCnt = 0)) or
    //no connections
    ((ActiveTab = 11) and (ConnectionsCnt = 0)) then begin
      ActiveTab := 1;
      Result := GetMoviePage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
      exit;
    end;


    //tabs
    if RegReadInteger('HideNavigationMenu', 0) = 0 then
      all := all + GetMovieTabs(MovieCode, season, SeasonCnt, awards<>'', shotCnt>0, (EditionsCount > 1) or (VideoFileName <>''), PosterCnt>0, TrailerCnt>0, description <> '', ConnectionsCnt > 0, SeasonNumbers);

    //shots from the movie
    if ActiveTab = 2 then begin
      all := all + '<tr><td><table class="contents">';
      all := all + GetShots(MovieCode, 3, 'movie', 5, 7);
    end;

    //posters from the movie
    if ActiveTab = 7 then begin
      all := all + '<tr><td><table class="contents">';
      all := all + GetShots(MovieCode, 4, 'movie');
    end;

    //actors
    if ActiveTab = 4 then begin
      all := all + GetCast(MovieCode);
    end;

    if ActiveTab = 1 then begin
      all := all + '<tr><td><table class="names-values"><tr style="background:url('+WhiteBarFile+') repeat-x;"><td colspan="2">&nbsp;&nbsp;</td></tr>';

      //tagline
      if TagLine <> '' then begin
      all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">"', [GetLangStr(3406)]);
      all := all + TagLine + '"</p></td></tr>';
      end;

      //sequence
      with sl do begin
      Clear;
      Add('select m.code, m.name, mov.series_nom from movies mov');
          Add('join manuals m on m.code=mov.series');
      Add(format('where mov.code=%d', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
      all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(20271)]);
      all := all + Format('<a href="sequence:%d">%s</a> %s%d', [GetIntegerField('m.code'), GetStringField('m.name'), GetLangStr(529), GetIntegerField('mov.series_nom')]);
      all:=all+'</p></td></tr>';
        end;

      //media type
      if MediaType > 0 then begin
        with sl do begin
          Clear;
          Add('select * from manuals');
          Add(Format('where code=%d', [MediaType]));
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(173)]);
          all := all + Format('<a href="media_type:%d">%s</a></p></td></tr>', [GetIntegerField('code'), GetStringField('name')]);
        end;
      end;

        //genres
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference надо ли???
          Add(format('where mm.movie=%d and m.reference=8', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Genres: '
          all:=all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(72)]);
          for i:=1 to RecordCount do begin
        if i>1 then
          all := all + ' / ';
        all:=all+format('<a href="genre:%d">%s</a>', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          all:=all+'</p></td></tr>';
        end;

      //year
        if year<>'' then
          all:=all+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="year:%s,%d">%s</a></p></td></tr>', [GetLangStr(169), year, MOVIENIZER_PROGRAM, year]);

        //countries
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference надо ли???
          Add(format('where mm.movie=%d and m.reference=9', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Countries: '
      all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(73)]);
      country := '';
          for i:=1 to RecordCount do begin
            country:=country+format('<a href="country:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          country:=copy(country, 1, length(country)-3);
          all:=all+format('%s</p></td></tr>', [country]);
        end;


    //duration
    hours := duration div 60;
    minutes := duration mod 60;
    s := '';
    if hours>0 then
      s:=format(' (%d:%.2d)', [hours, minutes]);
      if duration>0 then
          all:=all+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%d %s%s</p></td></tr>', [GetLangStr(705), duration, GetLangStr(706), s]);

      //mpaa
      mpaa:='';
      if mpaa_code>0 then begin
      with sl do begin
            Clear;
          Add('select name from manuals');
            Add(format('where code=%d', [mpaa_code]));
        end;
          RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
        s:=Format('<a href="mpaa:%d">%s</a>', [mpaa_code, GetStringField('name')]);
            mpaa:=s;
            if mpaa_desc<>'' then
              mpaa:=mpaa+' '+mpaa_desc;
        all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(708), mpaa]);
        end;
    end;

        //studios
      studios:='';
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=12', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          studios := format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(493)]);
          for i:=1 to RecordCount do begin
            studios := studios + format('<a href="studio:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          studios := copy(studios, 1, length(studios)-3);
      all := all + studios + '</p></td></tr>';
        end;

        //directors
      s := '';
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode=1', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Directors: ';
          all:=all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(66)]);
          i:=1;
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
            if (i=5) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end; //while
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=6) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end; //if

        //writers
      s := '';
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode=2', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Writers: '
          all:=all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(67)]);
          i:=1;
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
            if (i=5) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end;
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=6) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end;

        //producers
      s := '';
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode=5', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          all:=all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(71)]);
          i:=1;
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
            if (i=5) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end;
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=6) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end;

        //cinematography
      s := '';
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode=6', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          all:=all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(4576)]);
          i:=1;
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
            if (i=5) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end;
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=6) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end;

        //composers
      s := '';
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode=4', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Composers: '
          all:=all+Format('<tr><td class="field-names"><p class="without-border">%s</p></td><td class="field-values"><p class="without-border">', [GetLangStr(491)]);
          i:=1;
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
            if (i=5) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end;
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=6) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end;
      all := all + '</table></td></tr>';


      //awards
      if FullAwardsText <> '' then begin
        s2 := '';
        temp := LowerCase(FullAwardsText);
        i := Pos('<br>', temp);
        //remove the general description for awards received from kinopoisk
        s := copy(temp, 1, i-1);
        if (Pos('.', s) > 5) then
          delete(temp, 1, i+3);
        sl.LoadFromFile(PicturesPath + 'awards\awards.txt');
        for i := 0 to sl.Count - 1 do begin
          name := sl.Names[i];
          j := Pos(':', name);
          status := '';
          ends_with := '';
          if j > 0 then begin
            status := LowerCase(copy(name, j+1, length(name)-j));
            delete(name, j, length(name)-j+1);
            j := Pos(':', status);
            if j > 0 then begin
              ends_with := copy(status, j+1, length(status)-j);
              delete(status, j, length(status)-j+1);
            end;
          end;
          j := Pos(LowerCase(name), temp);
          s := '';
          if j > 0 then begin
            k := MyPos(ends_with, temp, j+1);
            if k = 0 then
              k := Length(temp);
            s := copy(temp, j, k-j);
          end;
          if Pos('<br>'+ status, s) > 0 then
            s2 := s2 + '<div style="margin: 0 5; float: left;"><a class="pic" href="userref:135,' + name + '"><img border="0" alt="'+ name + '" src="' + PicturesPath + 'awards\' + sl.Values[sl.Names[i]] + '"></a></div>';
        end;
        if s2 <> '' then
          all := all + '<tr><td><p class="description">' + s2 + '</p></td></tr><tr class="small-free-space"><td></td></tr>';
      end;

      if RegReadInteger('ShowAllActors', 0) = 1 then
      FullPersons := True;
        //actors
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection, c.name from data d');
          Add('inner join persons p on p.code=d.person');
          Add('left outer join characters c on c.person=p.code and c.movie=d.movie');
          Add(format('where d.movie=%d and d.mode=3', [MovieCode]));
          Add('order by d.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Actors: '
          all := all + Format('<tr><td><p class="header">%s (%d):</p></td></tr><tr><td><p class="description">', [GetLangStr(68), RecordCount]);
          i:=1;
      s:='';
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            character:=GetStringField('c.name');
            if character='' then
              s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, '
            else
              s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+format('</a> (%s), ', [character]);
            if (i=10) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end;
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=11) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end;

    //photos of people
    temp := '';
    if (RegReadInteger('HidePhotosCovers', 0) = 0) then begin
      LastCode:=0;
        with sl do begin
        Clear;
        Add('select distinct i.path as path, i.width, i.height, i.person as code, p.name, p.birth_date, c.name');
        Add('from data d');
        Add('inner join images i on i.person=d.person');
        Add('inner join persons p on p.code=d.person');
        Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
        Add(format('where d.movie=%d', [MovieCode]));
        Add('order by d.mode, d.sort_order, i.person, i.mode desc, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        PreviousCodes.Clear;
        page_width := GetHTMLWidth - LeftColumnWidth;
        if RecordCount>0 then begin
          all:=all+'<tr><td><table class="boxes">';
          j := 0;
          all := all + '<tr>';
          for i:=1 to RecordCount do begin
            if (PreviousCodes.IndexOf(IntToStr(GetIntegerField('code'))) < 0) then begin
              LastCode:=GetIntegerField('code');
              PreviousCodes.Add(IntToStr(GetIntegerField('code')));
              PicHeight := GetIntegerField('i.height');
              if PicHeight > 0 then
                PicWidth := Round(GetIntegerField('i.width') * (PhotoHeight / PicHeight)) + 5
              else
                PicWidth := StandardPhotoWidth;
              if PicWidth < StandardPhotoWidth then
                PicWidth := StandardPhotoWidth;
              {
              //to do: count page width, next line
              age := GetStringField('p.birth_date');
              while (Pos('/', age)> 1) do
                delete(age, 1, Pos('/', age));
              try
                if (StrToInt(age)>0) then
                  age := IntToStr(StrToInt(year) - StrToInt(age));
              except
              end;
              }
              age := '';
              if (YearsBetween(GetStringField('p.birth_date'), year) > 0) then
                age := IntToStr(YearsBetween(GetStringField('p.birth_date'), year));

              if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
                trunc_name := TruncateName(GetStringField('p.name'), MaxNameLength);
                trunc_character := TruncateName(GetStringField('c.name'), MaxCharacterNameLength);

                FileName := GetImageFileName(GetStringField('path'), 'ThumbsMoviePhotos', NO_PHOTO_FILE[MOVIENIZER_PROGRAM], 0, PhotoHeight);
                temp:=temp+format('<td class="photo"><a class="picture" href="person:%d"><img src="%s"></a><p><a href="person:%d">%s', [GetIntegerField('code'), FileName, GetIntegerField('code'), trunc_name]);
                //end 2.05.11


                if age <> '' then
                  temp := temp + format(' (%s)', [age]);
                temp := temp + '</a>';
                if trunc_character <> '' then
                  temp := temp + '<br>(' + trunc_character + ')';
                temp := temp + '</p></td>';
                page_width := page_width - PicWidth;
                if (page_width >= 0) then begin
                  all := all + temp;
                  temp := '';
                end
                else begin
                  all := all + '</tr></table></td></tr><tr><td><table class="boxes"><tr>' + temp;
                  page_width := GetHTMLWidth - LeftColumnWidth - PicWidth;
                  temp := '';
                end;
              end;//if MyFileExists
            end;
            GetNextRecord;
          end;//for
          //all := all + '<td colspan="' + IntToStr(kol-j) + '">';
          all := all + temp + '</tr></table></td></tr>';
        end;//if recordcount
      end;
    end; //activeTab = 1

    if (ActiveTab = 1) or (ActiveTab = 10) then begin
      //description
      if description<>'' then
        all:=all+Format('<tr style="background:url(%s) repeat-x;"><td>&nbsp;</td></tr>', [WhiteBarFile])+'<tr><td><p class="description">'+description+'</p></td></tr>';
    end;

    if ActiveTab = 1 then begin
     all := all + '<tr><td><table class="full-content">';

        //custom fields
        cust:='';
      PrevBlockCnt:=0;
        for i:=1 to 4 do begin
          if custom[i]>0 then begin
            with sl do begin
              Clear;
              Add('select name from manuals');
              Add(format('where code=%d', [custom[i]]));
            end;
            RecordCount:=ExecuteSQL(sl.text);
            if RecordCount>0 then begin
          PrevBlockCnt:=PrevBlockCnt+1;
              cust:=cust+'<tr><td class="field-names"><p class="border">'+format(GetLangStr(539+i), [s])+'</p></td><td class="field-values"><p class="border">'+format('<a href="custom%d:%d">', [i, custom[i]])+GetStringField('name')+'</a></p></td></tr>';
            end;
          end;
    end;

    //custom list1
    border := '';
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=17', [MovieCode]));
          Add('order by m.name');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
      PrevBlockCnt:=PrevBlockCnt+1;
      if (PrevBlockCnt > 2) then
        border := 'without-';
          cust:=cust+Format('<tr><td class="field-names"><p class="%sborder">%s</p></td><td class="field-values"><p class="%sborder">', [border, GetLangStr(544), border]);
          for i:=1 to RecordCount do begin
            cust:=cust+format('<a href="custom5:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          cust:=copy(cust, 1, length(cust)-2);
          cust:=cust+'</p></td></tr>';
        end;

    //custom list2
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=18', [MovieCode]));
          Add('order by m.name');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
      PrevBlockCnt:=PrevBlockCnt+1;
      if PrevBlockCnt>2 then
        border := 'without-';
          cust:=cust+Format('<tr><td class="field-names"><p class="%sborder">%s</p></td><td class="field-values"><p class="%sborder">', [border, GetLangStr(545), border]);
          for i:=1 to RecordCount do begin
            cust:=cust+format('<a href="custom6:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          cust:=copy(cust, 1, length(cust)-2);
          cust:=cust+'</p></td></tr>';
        end;
    if cust <> '' then
      all:=all+Format('<tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile])+cust;

  //	if (cust<>'') or (s<>'') then
  //		all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
    end; //if ActiveTab = 1

    //Trailers
    if (ActiveTab = 9) then begin
      with sl do begin
        Clear;
        Add('select i.path, i.width, i.height, mc.site from movies_codes mc');
        Add('left join images i');
        Add('on i.code=mc.code');
        Add(format('where mc.movie=%d and mc.script=''trailer''', [MovieCode]));
      end;
      RecordCount := ExecuteSQL(sl.text);
      page_width := GetHTMLWidth - 300;
      all := all + Format('<tr style="background:url(%s) repeat-x;"><td>&nbsp;</td></tr>', [WhiteBarFile]) + '<tr><td><table class="trailers"><tr>';
      temp := '';
      for i := 1 to RecordCount do begin
        PicWidth := GetIntegerField('i.width');
        if PicWidth = 0 then
          PicWidth := 200;
        PicWidth := PicWidth + 10;
        FileName := ImagesPath + GetStringField('i.path');
        if not (MyFileExists(FileName)) then
          FileName := ImgPath + 'trailer.gif';
        url := GetStringField('mc.site');
        page_width := page_width - PicWidth;
        if page_width < 0 then begin
          temp := temp + '</tr><tr>';
          page_width := GetHTMLWidth - 300 - PicWidth;
        end;
        if (Pos('http://', url) > 0) or (Pos('https://', url) > 0) then
          url := '<a class="pic" href="link:http://www.medianizer.com/redirect/'+url+'">'
        else
          url := '<a class="pic" href="play:' + url + '">';
        temp := temp + '<td>'+url+format('<img class="trailer" src="%s"></a></td>', [FileName]);
        GetNextRecord;
      end;
      if temp <> '' then
        all := all + temp + '</tr></table></td></tr>';
    end;

    //movie connections
    if (ActiveTab = 11) then begin
      //movie series
      if MovieSeriesNumber > 0 then begin
        temp := '<tr><td class="free-space"></td></tr>';
        //previous movies
        with sl do begin
          Clear;
          Add('SELECT m.title, m.code, m.year, m.in_collection FROM Movies m');
          Add(Format('WHERE m.series=%d AND m.series_nom<%d', [MovieSeries, MovieSeriesNumber]));
          Add('ORDER BY m.series_nom');
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          temp := temp + '<tr><td><p class="header">'+GetLangStr(3907)+':';
          temp := temp + '</p><ol>';
          i := 1;
          while i <= RecordCount do begin
            LinkYearStr := GetStringField('m.year');
            if (LinkYearStr <> '') then
              LinkYearStr := ' (' + LinkYearStr + ')';
            if (GetIntegerField('m.in_collection')=1) then
              img:=format('<img src="%smovie.gif" align="absmiddle">&nbsp;', [ImgPath])
            else
              img := '';
            temp := temp + '<li>' + img + Format('<a href="movie:%d">', [GetIntegerField('m.code')]) + GetStringField('m.title')+ Format('</a>%s</li>', [LinkYearStr]);
            i := i + 1;
            GetNextRecord;
          end;
          temp := temp + '</ol></td></tr><tr><td class="free-space"></td></tr>';
        end;
        //following movies
        with sl do begin
          Clear;
          Add('SELECT m.title, m.code, m.year, m.in_collection FROM Movies m');
          Add(Format('WHERE m.series=%d AND m.series_nom>%d', [MovieSeries, MovieSeriesNumber]));
          Add('ORDER BY m.series_nom');
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          temp := temp + '<tr><td><p class="header">'+GetLangStr(3908)+':';
          temp := temp + '</p><ol>';
          i := 1;
          while i <= RecordCount do begin
            LinkYearStr := GetStringField('m.year');
            if (LinkYearStr <> '') then
              LinkYearStr := ' (' + LinkYearStr + ')';
            if (GetIntegerField('m.in_collection')=1) then
              img:=format('<img src="%smovie.gif" align="absmiddle">&nbsp;', [ImgPath])
            else
              img := '';
            temp := temp + '<li>' + img + Format('<a href="movie:%d">', [GetIntegerField('m.code')]) + GetStringField('m.title')+ Format('</a>%s</li>', [LinkYearStr]);
            i := i + 1;
            GetNextRecord;
          end;
          temp := temp + '</ol></td></tr><tr><td class="free-space"></td></tr>';
        end;
        all := all + temp;
      end;
      //other connections
      with sl do begin
        Clear;
        Add('SELECT ml.*, m.Code, m.title, m.year, m.in_collection FROM Movies_links ml');
        Add('LEFT JOIN Movies m ON m.code = ml.movie_secondary');
        Add(format('where ml.movie_primary=%d', [MovieCode]));
        Add('order by ml.link_status, m.Year');
      end;
      RecordCount:=ExecuteSQL(sl.text);
      temp := '';
      if RecordCount > 0 then begin
        OldLinkStatus := -1;
        i := 1;
        while i<=RecordCount do begin
          if (OldLinkStatus <> GetIntegerField('ml.link_status')) then begin
            if OldLinkStatus > -1 then
              temp := temp + '</ol></td></tr><tr><td class="free-space"></td></tr>';
            OldLinkStatus := GetIntegerField('ml.link_status');
            case OldLinkStatus of
              2: LinkMovieStatusTitle := GetLangStr(3915);
              3: LinkMovieStatusTitle := GetLangStr(3916);
              4: LinkMovieStatusTitle := GetLangStr(3917);
              5: LinkMovieStatusTitle := GetLangStr(3918);
            end;
            temp := temp + '<tr><td><p class="header">'+LinkMovieStatusTitle+':';
            temp := temp + '</p><ol>';
          end;
          LinkYearStr := GetStringField('m.year');
          if (LinkYearStr <> '') then
            LinkYearStr := ' (' + LinkYearStr + ')';
          if (GetIntegerField('m.in_collection')=1) then
            img:=format('<img src="%smovie.gif" align="absmiddle">&nbsp;', [ImgPath])
          else
            img := '';
          temp := temp + '<li>' + img + format('<a href="movie:%d">', [GetIntegerField('m.code')]) + GetStringField('m.Title') + Format('</a>%s</li>', [LinkYearStr]);
          i:=i+1;
          GetNextRecord;
        end;
        if temp <> '' then
          all := all + '<tr><td class="free-space"></td></tr>' + temp + '</ol></td></tr><tr><td class="free-space"></td></tr>';
      end;
    end; // end movie connections

        //editions
    if (ActiveTab = 1) or (ActiveTab = 5) or (ActiveTab = 8) then begin
        with sl do begin
          Clear;
          Add('select e.code from editions e');
          Add('left outer join manuals m on m.code=e.edition and m.reference=21');
          Add(format('where e.movie=%d', [MovieCode]));
          Add('order by e.sort_order');
        end;
        EditionsCount:=ExecuteSQL(sl.text);

        for ie:=1 to EditionsCount do begin
          editions[ie]:=GetIntegerField('e.code');
          GetNextRecord;
        end;

        for ie:=1 to EditionsCount do begin
          EditionCode:=editions[ie];
          //editions
          with sl do begin
            Clear;
            Add('select * from editions e');
            Add('left outer join manuals m on m.code=e.edition and m.reference=21');
            Add(format('where e.code=%d', [EditionCode]));
          end;
          ExecuteSQL(sl.text);

          ed:='';

        //video parameters
          VideoBitrate:=GetIntegerField('e.video_bitrate');
          filesize:=GetIntegerField('e.filesize');
          DiscLabel:=GetIntegerField('e.disc_label');
          disc_nom:=GetStringField('e.disc_nom');
          duration:=GetIntegerField('e.duration');
          barcode:=GetStringField('e.barcode');

          VideoStandard:=GetIntegerField('e.video_standard');
          ScreenRatio:=GetIntegerField('e.screen_ratio');
          resolution:=GetIntegerField('e.resolution');
          VideoCodec:=GetIntegerField('e.video_codec');
          MediaFormat:=GetIntegerField('e.media_format');

          EditionFeatures:=GetStringField('e.features');
          EditionComment:=GetStringField('e.comment');
      EditionCost := GetFloatField('e.cost');

      if ((EditionsCount > 1) or (RegReadInteger('ShowEditions', 0) = 1) or (ActiveTab = 5) or (ActiveTab=8)) then begin
        PrevBlockCnt:=-1;
        VideoFileName := GetStringField('e.filename');
        VideoFileFolder := VideoFileName;
        while (length(VideoFileFolder)>0) and (pos(VideoFileFolder[length(VideoFileFolder)],'/\')=0) do delete(VideoFileFolder,length(VideoFileFolder),1);
        ed:=ed+Format('<tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]) + '<tr><td colspan="2"><p class="header">';
        if VideoFileFolder<>'' then
          ed:=ed+format('<a href="explore:%s">', [VideoFileName])+format('<img src="%sfolder.png" align="absmiddle" border="0" alt="%s"></a> ', [ImgPath, VideoFileName])+'&nbsp;';
        i := GetIntegerField('e.season');
        j := GetIntegerField('e.episode');
        if (i=0) then
          ed:=ed+format(GetLangStr(1260), [ie])+'. ';
        if GetStringField('m.name')<>'' then
          ed:=ed+GetStringField('m.name')+'. ';
        barcode := GetStringField('e.barcode');
        if not ((i=0) and (j=0)) then begin
          ed:=ed+format(GetLangStr(1252), [i, j])+'. ';
          with sl do begin
            Clear;
            Add('SELECT title FROM episodes');
            Add(format('where movie=%d and season=%d and episode=%d', [MovieCode, i, j]));
          end;
          ExecuteSQL(sl.text);
          ed := ed+GetStringField('title')+'. ';
        end;
        if VideoFileName<>'' then
          ed:=ed+format('<a href="play:%s">', [VideoFileName])+format('<img src="%splay.png" align="absmiddle" border="0" alt="%s"></a> ', [ImgPath, VideoFileName]);


        if duration>0 then begin
          ed:=ed+Format('<font size="2">(%d:%0.2d)</font> ', [duration div 60, duration mod 60]);
        end;
        //ed:=ed+'<br>';
        if barcode<>'' then
          ed:=ed+GetLangStr(1259)+': '+barcode;

        (*******************Loans **********************)
        if (ActiveTab = 8) then begin
          //media format
          ThisBlockCnt := 0;
          if MediaFormat > 0 then begin
            with sl do begin
              Clear;
              Add('select name from manuals');
              Add(format('where code=%d', [MediaFormat]));
            end;
            RecordCount := ExecuteSQL(sl.text);
            ed := ed + '  ';
            ThisBlockCnt := 1;
            if RecordCount > 0 then
              ed := ed + GetStringField('name');
          end;

          //disc number
          if disc_nom <> '' then begin
            if ThisBlockCnt = 1 then
              ed := ed + ', ';
            ed := ed + format('%s %s', [GetLangStr(391), disc_nom]);
            ThisBlockCnt := 1;
          end;
          //disc label
          if DiscLabel>0 then begin
              with sl do begin
              Clear;
              Add('select name from manuals');
              Add(format('where code=%d', [DiscLabel]));
              end;
              RecordCount:=ExecuteSQL(sl.text);
              if RecordCount>0 then begin
              if ThisBlockCnt = 1 then
                ed := ed + ', ';
              ed := ed + format('%s: %s', [GetLangStr(1000), GetStringField('name')]);
              end;
          end;
        (*************************End loans***************)
        end;
        ed := ed + '</p></td></tr>';

        all:=all+ed;
      end;

      //loan tab
      if (ActiveTab = 8) then begin
        with sl do begin
          Clear;
          Add('select l.loan_date, l.return_date, l.due_date, l.comment, ');
          Add('l.code, m.name from loans l');
          Add('join manuals m on m.code=l.location');
          Add(format('where edition=%d', [EditionCode]));
          Add('order by loan_date');
        end;
        RecordCount := ExecuteSQL(sl.text);
        loan_date := '';
        return_date := '';
        if RecordCount > 0 then begin
          ed := '<tr><td><table class="loans">';
          ed := ed + format('<tr><td><b>%s</b></td><td><b>%s</b></td><td><b>%s</b></td><td><b>%s</b></td><td><b>%s</b></td><td><b>%s</b></td></tr>', [GetLangStr(239), GetLangStr(240), GetLangStr(241), GetLangStr(245), GetLangStr(163), GetLangStr(1446)]);
          for j:=1 to RecordCount do begin
            ed := ed + '<tr>';
            loan_date := GetSmartDate(GetStringField('l.loan_date'));
            return_date := GetSmartDate(GetStringField('l.return_date'));
            if return_date = '' then
              return_date := Format('<a href="userref:11,%d;%d;%d">%s</a>', [EditionCode, MovieCode, GetIntegerField('l.code'), GetLangStr(1445)]);
            ed := ed + format('<td class="loan-date">%s</td>', [loan_date]);
            ed := ed + format('<td class="loan-date">%s</td>', [GetSmartDate(GetStringField('l.due_date'))]);
            ed := ed + format('<td class="loan-date">%s</td>', [return_date]);
            ed := ed + format('<td>%s</td>', [GetStringField('m.name')]);
            ed := ed + format('<td>%s</td>', [GetStringField('l.comment')]);
            ed := ed + format('<td><a class="picture" href="userref:14,%d;%d;%d"><img src="%sdelete.png"></a></td>', [EditionCode, MovieCode, GetIntegerField('l.code'), ImgPath]);
            ed := ed + '</tr>';
            GetNextRecord;
          end;
          ed := ed + '</table></td></tr>';
          all := all + ed;
        end
        else
          all := all + format('<tr><td><p class="description">%s</p></td></tr>', [GetLangStr(1441)]);
        if (loan_date = '') or (Pos('<a href', return_date) = 0) then
          all := all + format('<tr><td><p class="description"><a href="userref:10,%d;%d">%s</a></p></td></tr>', [EditionCode, MovieCode, GetLangStr(1442)]);
      end;

    //editions
    if (ActiveTab = 1) or (ActiveTab = 5) then begin

          ed:='';
      ThisBlockCnt := 0;

      if (ActiveTab = 1) then begin
        //disc #
        if disc_nom<>'' then begin
          ed:=ed+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(391), disc_nom]);
          ThisBlockCnt := ThisBlockCnt + 1;
        end;
        //disc label
        if DiscLabel>0 then begin
          with sl do begin
          Clear;
          Add('select name from manuals');
          Add(format('where code=%d', [DiscLabel]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if RecordCount>0 then begin
          ThisBlockCnt := ThisBlockCnt + 1;
          ed:=ed+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="disc_label:%d">%s</a></p></td></tr>', [GetLangStr(1000), DiscLabel, GetStringField('name')]);
          end;
        end;
        //Cost
        if EditionCost>0 then begin
          ed:=ed+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%f</p></td></tr>', [GetLangStr(3350), EditionCost]);
          ThisBlockCnt := ThisBlockCnt + 1;
        end;

        //loans
        border:='';
        with sl do begin
          Clear;
          Add('select l.location, m.name from loans l');
          Add('inner join manuals m on m.code=l.location');
          Add(format('where edition=%d', [EditionCode]));
          Add('and (return_date='''' or return_date is null)');
          Add('order by loan_date desc');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          ThisBlockCnt := ThisBlockCnt + 1;
          if ThisBlockCnt>2 then
            border := 'without-';
          ed:=ed+Format('<tr><td class="field-names"><p class="%sborder">', [border])+GetLangStr(333)+format('</p></td><td class="field-values"><p class="%sborder"><a href="location:%d">%s</a></p></td></tr>', [border, GetIntegerField('l.location'), GetStringField('m.name')]);
        end;

        if (ed<>'') then begin
          if (PrevBlockCnt=0) or (PrevBlockCnt>2) then
            all:=all+Format('<tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
          PrevBlockCnt := PrevBlockCnt + ThisBlockCnt;
          all := all + ed;
        end;
      end;

          //parameters
      ThisBlockCnt := 0;
          with sl do begin
            Clear;
            Add('select name, reference from manuals');
            Add(format('where code in (%d, %d, %d, %d, %d)', [VideoStandard, ScreenRatio, resolution, VideoCodec, MediaFormat]));
            Add('order by reference');
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if (RecordCount>0) and (EditionsCount = 1) then begin
        if (PrevBlockCnt=0) or (PrevBlockCnt>2) then
          all:=all+Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
          end;
          for i:=1 to RecordCount do begin
            if GetIntegerField('reference')=1 then begin
              //Video standard
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(201), GetStringField('name')]);
          ThisBlockCnt := ThisBlockCnt + 1;
        end
            else if GetIntegerField('reference')=2 then begin
              //media format
              //all:=all+GetLangStr(249)+': '+format('<a href="aspect_ratio:%d">%s</a>, ', [ScreenRatio, GetStringField('name')])
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="media_format:%d">%s</a></p></td></tr>', [GetLangStr(249), MediaFormat, GetStringField('name')]);
        ThisBlockCnt := ThisBlockCnt + 1;
        end
            else if GetIntegerField('reference')=4 then begin
              //screen ratio
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="aspect_ratio:%d">%s</a></p></td></tr>', [GetLangStr(202), ScreenRatio, GetStringField('name')]);
        ThisBlockCnt := ThisBlockCnt + 1;
        end

            else if GetIntegerField('reference')=5 then begin
              //resolution
              //all:=all+GetLangStr(203)+': '+GetStringField('name')+', '
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="resolution:%d">%s</a></p></td></tr>', [GetLangStr(203), resolution, GetStringField('name')]);
        ThisBlockCnt := ThisBlockCnt + 1;
        end

            else if GetIntegerField('reference')=19 then begin
              //video codec
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="video_codec:%d">%s</a></p></td></tr>', [GetLangStr(571), VideoCodec, GetStringField('name')]);
          ThisBlockCnt := ThisBlockCnt + 1;
        end;
            GetNextRecord;
          end;

          s2:='';
          //video bitrate
          if VideoBitrate>0 then begin
            s2:=format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%d</p></td></tr>', [GetLangStr(630), VideoBitrate]);
        ThisBlockCnt := ThisBlockCnt + 1;
      end;
          //filesize
          if filesize>0 then begin
            s2:=s2+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%d</p></td></tr>', [GetLangStr(631), filesize]);
        ThisBlockCnt := ThisBlockCnt + 1;
      end;

      //duration
      if (duration>0) and (EditionsCount=1) then begin
        s2:=s2+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%d %s', [GetLangStr(147), duration, GetLangStr(706)]);
        s2:=s2+format(' (%d:%.2d)</p></td></tr>', [duration div 60, duration mod 60]);
        ThisBlockCnt := ThisBlockCnt + 1;
      end;

      all:=all+s2;

      //audio tracks
      with sl do begin
        Clear;
        Add('select m.code, m.name, am.Bitrate, am.Codec, am.Channel, am.Short_Comment from audio_manuals am');
        Add('left join manuals m on m.code=am.reference');
        Add(format('where am.edition=%d and am.media_type=0', [EditionCode]));

      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then
      begin
        //Audio tracks
        ThisBlockCnt := ThisBlockCnt + 1;
        all:=all+Format('<tr><td class="field-names"><p class="without-border">%s</p></td><td class="field-values"><p class="without-border">', [GetLangStr(254)]);
        for i:=1 to RecordCount do

        begin
          s2 := ' ' + GetStringField('am.codec');
          if (s2 <> '') then
            S2 := s2 + ' ';
          if (GetIntegerField('am.channel') > 0) then
            s2 := s2 + GetStringField('am.channel') + ' ch ';
          if (GetIntegerField('am.Bitrate') > 0) then
            s2 := s2 + GetStringField('am.Bitrate') + ' kbps ';
          if (GetStringField('am.Short_Comment') <> '') then
            s2 := s2 + GetStringField('am.Short_Comment') + ' ';

      if (s2<>'') then
        s2 := copy(s2, 1, length(s2) - 1);

          all:=all+format('<a href="audio_track:%d">%s</a>%s, ', [GetIntegerField('m.code'),
            GetStringField('m.name'), s2]);
          GetNextRecord;

        end;
        all:=copy(all, 1, length(all)-2);
        all := all + '</p></td></tr>';

      end;

      //subtitles
      with sl do begin
        Clear;
        Add('select m.code, m.name, am.Short_Comment from audio_manuals am');
        Add('join manuals m on m.code=am.reference');
        Add(format('where am.edition=%d and am.media_type=1', [EditionCode]));

      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then
      begin
        //Subtitles
        ThisBlockCnt := ThisBlockCnt + 1;
        all:=all+Format('<tr><td class="field-names"><p class="without-border">%s</p></td><td class="field-values"><p class="without-border">', [GetLangStr(253)]);
        for i:=1 to RecordCount do
        begin
          s2 := '';
          if (GetStringField('am.Short_Comment') <> '') then
            s2 := ' ' + Trim(GetStringField('am.Short_Comment'));
          //all:=all+GetStringField('m.name')+', ';
          all:=all+format('<a href="subtitle:%d">%s</a>%s, ', [GetIntegerField('m.code'),
            GetStringField('m.name'), s2]);
          GetNextRecord;

        end;
        all:=copy(all, 1, length(all)-2);
        all := all + '</p></td></tr>';

      end;

      //show filename
      if (RegReadInteger('ShowFileNames', 1) = 1) and (VideoFileName<>'') then begin
        all := all + Format('<tr><td class="field-names"><p class="without-border">%s</p></td><td class="field-values"><p class="without-border">', [GetLangStr(195)]);
        all := all + Format('<a href="play:%s">%s</a></p></td></tr>', [VideoFileName, VideoFileName]);
      end;
      // DVD Features
      if EditionFeatures<>'' then begin
        all := all + Format('<tr><td class="free-space" colspan="2"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
        all := all + '<tr><td colspan="2"><p class="header">' + GetLangStr(1537) + '</p></td></tr>';
        all := all + '<tr><td colspan="2"><p class="description">' + EditionFeatures + '</p></td></tr>';
        PrevBlockCnt := 0;
      end;

      //Edition comments
      if EditionComment<>'' then begin
        all := all + Format('<tr><td class="free-space" colspan="2"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
        all := all + '<tr><td colspan="2"><p class="description">' + EditionComment + '</p></td></tr>';
        PrevBlockCnt := 0;
      end;

      end;
    end; //editions
    end;
    if (ActiveTab = 1) then begin
      //dates
      s:='';
      PrevBlockCnt := PrevBlockCnt + ThisBlockCnt;
      if DateAdd<>'' then
        s:=s+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(670), SQLDate2Str(DateAdd)]);
      if DateUpdate<>'' then
        s:=s+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(671), SQLDate2Str(DateUpdate)]);
      if DateSeen<>'' then
        s:=s+format('<tr><td class="field-names"><p class="without-border">%s</p></td><td class="field-values"><p class="without-border">%s</p></td></tr>', [GetLangStr(672), SQLDate2Str(DateSeen)]);
      if (s<>'') then begin
        if (PrevBlockCnt = 0) or (PrevBlockCnt > 2) then
          all := all + Format('<tr><td class="free-space" colspan="2"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
        all:=all+copy(s, 1, length(s)+1);
      end;

      all := all + '</table></td></tr>';



      //salary
      cust := '';
      if salary<>'' then
        cust:=cust+'<tr><td><p class="description">'+salary+'</p></td></tr>';

      if cust<>'' then
        all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td>&nbsp;</td></tr>', [WhiteBarFile]);
      all := all + cust;

      //comments
      cust := '';
      if comment<>'' then begin
        if not FullComments and (length(comment)>DescriptionLength) then begin
          comment:=copy(comment, 1, DescriptionLength);
          comment:=comment+format(GetLangStr(1250), [MovieCode]);
        end;
        cust:=cust+'<tr><td><p class="description">'+comment+'</p></td></tr>';
      end;

      if cust<>'' then
        all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td>&nbsp;</td></tr>', [WhiteBarFile]);
      all := all + cust;
    end;

    cust := '';

    //awards
    if (ActiveTab = 3) then begin
      if awards<>'' then begin
        sl.Clear;
        sl.LoadFromFile(PicturesPath + 'awards\awards.txt');
        //the general description from kinopoisk
        i := Pos('<br>', awards);
        temp := copy(awards, 1, i-1);
        if Pos('.', temp) > 5 then begin
          cust := temp + '<br>';
          delete(awards, 1, i+3);
        end;
        temp := '';
        while awards <> '' do begin
          i := Pos('<br><br>', awards) + 8;
          if i = 8 then
            i := Pos('<br> <br>', awards) + 9;
          if i = 9 then
            i := length(awards) + 1;
          //process each award separately
          s := copy(awards, 1, i-1);
          j := Pos(',', s);
          k := Pos('<br>', s);
          if (k < j) or (j = 0) then
            j := k;
          temp_name := copy(s, 1, j-1);
          j := Pos('"', temp_name);
          if j > 0 then
            temp_name := GetStr(temp_name, '"', '"');
          new_name := '<a href="userref:135,' + temp_name + '">' + temp_name + '</a>';
          s := ReplaceStr(s, temp_name, new_name);
          for k := 0 to sl.Count - 1 do begin
            name := sl.Names[k];
            s3 := sl.Values[sl.Names[k]];
            s3 := ReplaceStr(s3, '-mid.', '.');
            j := Pos(':', name);
            if j > 0 then
              delete(name, j, length(name)-j+1);
            j := Pos('">' + LowerCase(name), LowerCase(new_name));
            if (j > 0) then
              l := Pos(LowerCase(new_name), LowerCase(s))
            else
              l := Pos(LowerCase(name), LowerCase(s));
            if (l = 1) or ((l > 0) and (s[l-1] = '>')) then begin
              s2 := '<div style="clear:both"><div style="float: left; margin: 5px;"><a class="pic" href="userref:135,'+ name + '"><img border="0" alt="' + name + '" src="' + PicturesPath + 'awards\' + s3 + '"></a></div>';
              insert(s2, s, l);
            end;
          end;
          temp := temp + s;
          delete(awards, 1, i - 1);
        end;
        cust:='<tr><td><p class="description">'+cust+temp+'</p></td></tr>';
      end;

      if cust<>'' then
        all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
      all := all + cust;
    end;

    if ((ActiveTab = 1) and (RegReadInteger('ShowAwardsOnGeneralTab', 0) = 1)) then begin
      if awards <> '' then begin
        cust := '<tr><td><p class="description">'+awards+'</p></td></tr>';
        all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]) + cust;
      end;
    end;


    //seasons
    if (ActiveTab = 6) or ((RegReadInteger('ShowSeasonsOnGeneralTab', 0) = 1) and (ActiveTab = 1)) then begin

      seasons:='';
      kol:=0;
        with sl do begin
        Clear;
        Add('select e.season, e.episode, e.title, e.description, e.original_air_date, ed.filename, e.seen, e.code, e.rating from episodes e');
        Add('left outer join editions ed on ed.movie=e.movie and e.season=ed.season and e.episode=ed.episode');
        if season = 0 then begin
          Add(format('where e.movie=%d', [MovieCode]));
          Add(' order by e.season, e.episode');
        end
        else begin
          Add(format('where e.movie=%d and e.season=%d', [MovieCode, season]));
          Add(' order by e.episode');
        end;
        end;
        RecordCount:=ExecuteSQL(sl.text);
        UnseenList := TStringList.Create;
        UnseenEpisodes := '';
        for i:=1 to RecordCount do begin
        if GetIntegerField('e.season')>kol then begin
          kol:=GetIntegerField('e.season');
          s2 := format(GetLangStr(514), [kol]);
          if kol = 99 then
            s2 := GetLangStr(4441);
          s3 := format('&nbsp;<a class="picture" href="userref:153,%d;%d">', [kol, MovieCode]) + '<img alt="' + GetLangStr(7011) + Format('" src="%sseen.gif" border="0"></a> ', [ImgPath]) + format('<a class="picture" href="userref:154,%d;%d">', [kol, MovieCode]) + '<img alt="' + GetLangStr(7012) + Format('" src="%snot_seen.gif" border="0"></a>', [ImgPath]);
          seasons:=seasons+'<p class="header">'+s2+s3+'</p>';
        end;
        temp := '';
        if (GetIntegerField('e.seen')=1) then begin
          temp := format('<a class="picture" href="userref:150,%d;%d"><img src="%sseen.gif"></a> ', [GetIntegerField('e.code'), MovieCode, ImgPath]);
        end
        else begin
          UnseenList.Add('#' + IntToStr(GetIntegerField('e.code')) + '#');
          UnseenEpisodes := UnseenList.CommaText;
          temp := format('<a class="picture" href="userref:151,%d;%d"><img src="%snot_seen.gif"></a> ', [GetIntegerField('e.code'), MovieCode, ImgPath]);
        end;
        rating := GetIntegerField('e.rating');
        rate:='';
        for j:=1 to 10 do begin
          if j mod 2=1 then begin
            if j<=rating then
              rate:=rate+format('<a class="picture" href="userref:152,%d;%d;%d"><img src="%sstar-left.gif" align="absmiddle" border="0"></a>',  [GetIntegerField('e.code'), MovieCode, j, ImgPath])
            else
              rate:=rate+format('<a class="picture" href="userref:152,%d;%d;%d"><img src="%snot-star-left.gif" align="absmiddle" border="0"></a>',  [GetIntegerField('e.code'), MovieCode, j, ImgPath])
          end
          else begin
            if j<=rating then
              rate:=rate+format('<a class="picture" href="userref:152,%d;%d;%d"><img src="%sstar-right.gif" align="absmiddle" border="0"></a>',  [GetIntegerField('e.code'), MovieCode, j, ImgPath])
            else
              rate:=rate+format('<a class="picture" href="userref:152,%d;%d;%d"><img src="%snot-star-right.gif" align="absmiddle" border="0"></a>',  [GetIntegerField('e.code'), MovieCode, j, ImgPath])
          end;
        end;
          seasons:=seasons+'<p class="header">'+ temp +format(GetLangStr(518), [GetIntegerField('e.episode')])+'. '+GetStringField('e.title');
          s:=GetStringField('e.original_air_date');
          s:=SQLDate2Str(s);
          if s<>'' then
            seasons:=seasons+'. '+s;
          if rate <> '' then
          seasons := seasons + ' ' + rate;

          if GetStringField('ed.filename')<>'' then
          seasons:=seasons+format('&nbsp;<a href="play:%s">', [GetStringField('ed.filename')])+format('<img src="%splay.png" align="absmiddle" border="0"></a>', [ImgPath]);

          seasons:=seasons+'</p>';
          seasons:=seasons+'<p class="description">'+GetStringField('e.description')+'</p>';
            GetNextRecord;
        end;
        UnseenList.Free;
      if seasons<>'' then
        all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
      all := all + '<tr><td>' + seasons + '</td></tr>';
    end;
    if (ActiveTab = 1) and (SeasonCnt > 0) and (RegReadInteger('ShowSeasonsOnGeneralTab', 0) = 0) then begin
      all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
      all := all + Format('<tr><td><p class="header"><a href="userref:114,%d;0">%s %d</a></p></td></tr>',[MovieCode, GetLangStr(517), SeasonCnt]);
    end;


      all := all + '</table>' + GetPatternBottom;

    sl.Free;
    SeasonNumbers.Free;
    PreviousCodes.Free;
    result:=all;
  finally
    ResetRegistrySubKey();
  end;
end;


//show movies by selected user reference
//links like <a href='userref:Code,Text'>link</a>
//links like <a href='userref:Code,Text,Page'>link</a>
function GetUserReferenceForMovie(code: integer; text: string; Page: Integer = 1): string;
var
  sl, TempList, PreviousCodes: TStringList;
  i, j, kol, RecordCount, rating, page_width, LastCode, my_i, my_code, movie_code: integer;
  s, s2, description, year, director, writer, actor, bio, character, movie, movie_top: string;
  all, FileName, img, rate: string;
  IMDBRating: double;
  StartItem, EndItem, MoviesPage, ii, TotalItems, lines, SeasonNr, PageItems: integer;
  fl, ShowLastUpdated, loan_page: boolean;
  dd, mm, yy, loan_code, page_width_copy, PicWidth, PicHeight: integer;
  header_img, temp: String;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
  try
    ProgramReference:='';
    TempReferenceCode:=code;
    code := GetOldReferenceCodeForNewCode(code);
    TempReference:=666;
    TempText:=text;

    if code=100 then
      result := GetPatternTop+format('<p class="title">%s</p></td>', [GetLangStr(1333)])+ClosePatternTop+'<tr><td><table class="content"><tr><td><p class="header">'+ShowScriptOptions+'</p></td></tr></table></td></tr>'+GetPatternBottom
    //Movie tabs
    else if code in [109..129]	then begin
      my_code := 0;
      SeasonNr := 0;
      i := Pos(';', text);
      if i>0 then begin
        s := copy(text, i+1, length(text) - i);
        delete(text, i, length(text) - i + 1);
        try
          SeasonNr := StrToInt(s);
        except
        end;
      end;
      try
        my_code := StrToInt(text);
      except
      end;

      //18.11.10
      SetMode(1, my_code);

      ActiveTab := code - 108;
      if my_code > 0 then
        result := GetMoviePage(my_code, SeasonNr, false, false, false, false);
    end
    //episodes seen
    else if code in [150..151] then begin
      i := Pos(';', text);
      movie_code := 0;
      my_code := 0;
      if i>0 then begin
        TempList := TStringList.Create;
        s := copy(text, i+1, Length(text)-i);
        s2 := copy(text, 1, i-1);
        try
          movie_code := StrToInt(s);
          my_code := StrToInt(s2);
        except
        end;
        i := Pos('#' + s2 + '#', UnseenEpisodes);
        if i>1 then
          delete(UnseenEpisodes, i-1, length(UnseenEpisodes)-i+2)
        else if i=1 then
          UnseenEpisodes := '';
        UnseenEpisodes := ReplaceStr(UnseenEpisodes, '#', '');
        if code=151 then begin
          TempList.CommaText := UnseenEpisodes;
        end;
        my_i := code - 150;
        if my_code <> 0 then begin
          s := Format('UPDATE episodes SET seen=%d WHERE code=%d', [my_i, my_code]);
          ExecuteSQL(s);
          if (TempList.Count > 0) and MarkPreviousAsSeen then begin
            ExecuteSQL('BEGIN TRANSACTION');
            for i := 0 to TempList.Count - 1 do begin
              s := Format('UPDATE episodes SET seen=1 WHERE code=%s', [TempList[i]]);
              ExecuteSQL(s);
            end;
            ExecuteSQL('COMMIT');
          end;
        end;
        if movie_code > 0 then begin
          SetMode(1, movie_code);
          result := GetMoviePage(movie_code, 0, false, false, false, false);
        end;
        TempList.Free;
      end;
    end
    //episode rating
    else if code = 152 then begin
      my_code := 0;
      i := Pos(';', text);
      if i>0 then begin
        s := copy(text, 1, i-1);
        delete(text, 1, i);
      end;
      i := Pos(';', text);
      if i>0 then begin
        s2 := copy(text, 1, i-1);
        delete(text, 1, i);
      end;
      i := 0;
      try
        i := StrToInt(text);
        my_code := StrToInt(s);
        movie_code := StrToInt(s2);
      except
      end;
      if i>0 then begin
        s := Format('UPDATE episodes SET seen=1 WHERE code=%d', [my_code]);
        ExecuteSQL(s);
        s := Format('UPDATE episodes SET rating=%d WHERE code=%d', [i, my_code]);
        ExecuteSQL(s);
      end;
      if movie_code > 0 then begin
        SetMode(1, movie_code);
        result := GetMoviePage(movie_code, 0, false, false, false, false);
      end;
    end
    //mark season as seen
    else if code = 153 then begin
      my_code := 0;
      i := Pos(';', text);
      if i>0 then begin
        s := copy(text, 1, i-1);
        delete(text, 1, i);
      end;
      try
        my_code := StrToInt(s);
        movie_code := StrToInt(text);
      except
      end;
      if i>0 then begin
        s := Format('UPDATE episodes SET seen=1 WHERE season=%d and movie=%d', [my_code, movie_code]);
        ExecuteSQL(s);
      end;
      if movie_code > 0 then begin
        SetMode(1, movie_code);
        result := GetMoviePage(movie_code, 0, false, false, false, false);
      end;
    end
    //mark season as unseen
    else if code = 154 then begin
      my_code := 0;
      i := Pos(';', text);
      if i>0 then begin
        s := copy(text, 1, i-1);
        delete(text, 1, i);
      end;
      try
        my_code := StrToInt(s);
        movie_code := StrToInt(text);
      except
      end;
      if i>0 then begin
        s := Format('UPDATE episodes SET seen=0 WHERE season=%d and movie=%d', [my_code, movie_code]);
        ExecuteSQL(s);
      end;
      if movie_code > 0 then begin
        SetMode(1, movie_code);
        result := GetMoviePage(movie_code, 0, false, false, false, false);
      end;
    end

    //person tabs
    else if code in [140..149] then begin
      my_code := 0;
      try
        my_code := StrToInt(text);
      except
      end;
      PersonActiveTab := code - 139;
      SetMode(2, my_code);
      if my_code > 0 then
        result := GetPerson(my_code, false, false);
    end
    else begin

      sl:=TStringList.Create;
      all:='';

      // movies by studio
      if code = 12 then begin
        with sl do begin
          Clear;
          Add('select m.title as Title, m.code as code, m.in_collection as in_collection,');
          Add('m.rating as rating, m.imdb_rating as imdb_rating, i.path as path,');
          Add('i.width as Width, i.height as height');
          Add('from movies m');
          Add('inner join movies_manuals mm on mm.movie=m.code and mm.reference=12');
          Add('inner join manuals mg on mg.code=mm.ref_code');
          Add('left outer join images i on i.movie=m.code and i.mode=1');
          Add(format('where mg.name=%s and m.in_collection=1', [TempText]));
          Add('AND m.item_type=' + IntToStr(MOVIENIZER_PROGRAM));
          Add('order by m.title_sort');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        all := ProcessMovieReference(MOVIENIZER_PROGRAM, text, page);
      end;

      // movies by award
      if code = 135 then begin
        //detect award winners
        with sl do begin
          Clear;
          Add('select code, awards from movies');
          Add('where awards like ''%' + TempText + '%'' and in_collection=1');
          Add('AND item_type=' + IntToStr(MOVIENIZER_PROGRAM));
        end;
        RecordCount := ExecuteSQL(sl.text);
        TempList := TStringList.Create;
        header_img := '';
        i := 0;
        while i < RecordCount do begin
          s := LowerCase(GetStringField('awards'));
          s2 := '';
          j := Pos(LowerCase(TempText), s);
          if j > 0 then begin
            my_i := MyPos('<br><br>', s, j + 1);
            if my_i = 0 then
              my_i := MyPos('<br> <br>', s, j + 1);
            if my_i = 0 then
              my_i := Length(s);
            s2 := copy(s, j, my_i - j);
          end;
          if (Pos('won<br>', s2) > 0) or (Pos('победитель', s2) > 0) or (Pos('премия "' + LowerCase(TempText), s) > 0) then begin
            TempList.Add(IntToStr(GetIntegerField('code')));
          end;
          GetNextRecord;
          i := i + 1;
        end;
        //select award winners
        with sl do begin
          Clear;
          Add('select m.title as title, m.code as code, m.in_collection as in_collection, m.rating as rating,');
          Add('m.imdb_rating as ImdbRating, i.path as Path, i.width as Width, ');
          Add('i.height as Height, m.series_nom as series_nom');
          Add('from movies m');
          Add('left outer join images i on i.movie=m.code and i.mode=1');
          Add(Format('where m.code in (%s)', [TempList.CommaText]));
          Add('order by m.title_sort, i.sort_order');
        end;
        (*TempList.LoadFromFile(PicturesPath + 'awards\awards.txt');
        for i := 0 to TempList.Count - 1 do
          if Pos(LowerCase(TempText), LowerCase(TempList[i])) = 1 then
            header_img := TempList.Values[TempList.Names[i]];
        if header_img <> '' then
          header_img := PicturesPath + 'awards/' + header_img;*)
        TempList.Free;
        RecordCount:=ExecuteSQL(sl.text);
        all := ProcessMovieReference(MOVIENIZER_PROGRAM, TempText, page);
      end;

      //filmography sorting
      if code in [231..236] then begin
        my_code := 0;
        s := '';
        i := Pos(';', text);
        s := copy(text, 1, i-1);
        s := s+'FilmSort';
        delete(text, 1, i);
        try
          my_code := StrToInt(text);
        except
        end;
        if code = 231 then
          RegWriteString(s, 'title asc');
        if code = 232 then
          RegWriteString(s, 'title desc');
        if code = 233 then
          RegWriteString(s, 'year asc');
        if code = 234 then
          RegWriteString(s, 'year desc');
        if code = 235 then
          RegWriteString(s, 'rating asc');
        if code = 236 then
          RegWriteString(s, 'rating desc');
        SetMode(2, my_code);
        all := GetPerson(my_code, false, false);
      end;

      //movies from the home page
      if (RegReadInteger('ShowLastUpdated', 0) = 1) then
        ShowLastUpdated := True
      else
        ShowLastUpdated := False;
      if ((code > 0) and (code < 6)) then
      begin
        GenerateSQLForMoviesPages(sl, MOVIENIZER_PROGRAM, code);
        ExecuteSQL(sl.text);
        all := ProcessMovieReference(MOVIENIZER_PROGRAM, text, page);
      end;

      // people by award
      if code = 136 then begin
        header_img := '';
        //detect award winners
        with sl do begin
          Clear;
          Add('select code, awards from persons');
          Add('where awards like ''%' + TempText + '%'' and in_collection=1');
          Add('AND item_type=' + IntToStr(MOVIENIZER_PROGRAM));
        end;
        RecordCount := ExecuteSQL(sl.text);
        TempList := TStringList.Create;
        i := 0;
        while i < RecordCount do begin
          s := LowerCase(GetStringField('awards'));
          s2 := '';
          temp := s;
          j := Pos(LowerCase(TempText), temp);
          while j > 0 do begin
            my_i := MyPos('<br><br>', temp, j + 1);
            if my_i = 0 then
              my_i := MyPos('<br> <br>', temp, j + 1);
            if my_i = 0 then
              my_i := Length(temp);
            s2 := copy(temp, j, my_i - j);
            if (Pos('won<br>', s2) > 0) or (Pos('победитель', s2) > 0) then
              TempList.Add(IntToStr(GetIntegerField('code')));
            delete(temp, 1, j);
            j := Pos(LowerCase(TempText), temp);
          end;
          GetNextRecord;
          i := i + 1;
        end;
        //select award winners
        with sl do begin
          Clear;
          Add('select p.code as code, p.name, p.rating, p.birth_date, i.path, i.width, i.height, p.in_collection');
          Add('from persons p');
          Add('left outer join images i on i.person=p.code');
          Add(Format('where p.code in (%s)', [TempList.CommaText]));
          Add('order by p.name, i.sort_order');
        end;
        (*TempList.LoadFromFile(PicturesPath + 'awards\awards.txt');
        for i := 0 to TempList.Count - 1 do
          if Pos(LowerCase(TempText), LowerCase(TempList[i])) = 1 then
            header_img := TempList.Values[TempList.Names[i]];
        if header_img <> '' then
          header_img := PicturesPath + 'awards/' + header_img;*)
        TempList.Free;
        RecordCount:=ExecuteSQL(sl.text);
      end;

      //people from the homepage
      if (code > 5) and (code < 10) or (code = 136) then begin
        if code <> 136 then begin
          header_img := '';
          with sl do begin
            Clear;

            Add('select p.code as code, p.name, p.rating, i.path, i.width, i.height, p.in_collection');
            Add('from persons p');
            Add('left outer join images i on i.person=p.code');
            case code of
              7: Add('where 1=1');
              8: Add('where p.date_update is not null');
              9: Add('where p.birth_date like ''%' + Format('%s', [GetTodaysDate]) + '%''');
              else
                if ShowLastUpdated then
                  Add('where p.date_update is not null')
                else
                  Add('where p.date_add is not null');
            end;
            Add('and p.in_collection=1');
            case code of
              7: Add('order by p.rating desc, p.date_add desc, p.code, i.mode desc, i.sort_order');
              8: Add('order by p.date_update desc, p.code, i.mode desc, i.sort_order');
              9: Add('order by p.date_add desc, p.code, i.sort_order');
              else
                if ShowLastUpdated then
                  Add('order by p.date_update desc, p.code, i.mode desc, i.sort_order')
                else
                  Add('order by p.date_add desc, p.code, i.mode desc, i.sort_order');
            end;
          end;
          RecordCount:=ExecuteSQL(sl.text);
        end;
        PreviousCodes := TStringList.Create;
        lines := RegReadInteger('LinesPeople', DefaultLinesPeople);
        page_width := GetHTMLWidth - WholePageBorder;
        CountedPages := 0;
        TotalItems := CountItemsForPages(page_width, page, RecordCount, 1, lines, PhotoHeight, StandardPhotoWidth);
        i := ProcessedRecords;
        movie := '';
        all := '';
        fl:=true;
        PageItems := 0;
        LastCode := 0;
        page_width_copy := page_width;
        while (i<=RecordCount) and fl do begin
          my_code:=GetIntegerField('code');
          if PreviousCodes.IndexOf(IntToStr(my_code)) < 0 then begin
            PreviousCodes.Add(IntToStr(my_code));
            LastCode:=my_code;
            PicHeight := GetIntegerField('i.height');
            if PicHeight > 0 then
              PicWidth := Round(GetIntegerField('i.width') * (PhotoHeight / PicHeight)) + NormalImageBorders
            else
              PicWidth := CoverCellWidth;
            if PicWidth < CoverCellWidth then
              PicWidth := CoverCellWidth;
            page_width_copy := page_width_copy - PicWidth;
            if (page_width_copy < 0) then begin
              all := all + movie + '</tr></table></tr></td><tr><td align="center"><table class="ref-boxes"><tr>';
              movie := '';
              lines := lines - 1;
              page_width_copy := page_width - PicWidth;
            end;
            if (page<>0) and (lines <= 0) then
              fl:=false
            else begin

              rating := GetIntegerField('p.rating');
              rate:='';
              if rating > 0 then begin
                for my_i:=1 to 10 do begin
                  if my_i mod 2=1 then begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  end
                  else begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  end;
                end;
              end;
              FileName := GetImageFileName(GetStringField('i.path'), 'ThumbsMoviePhotos', NO_PHOTO_FILE[MOVIENIZER_PROGRAM], 0, PhotoHeight);
              movie:=movie+'<td class="box-photos" style="background:url('+BackgroundPeople+') repeat-x;">'+format('<a href="person:%d"><img class="person-photo" src="%s"></a>', [my_code, Filename]);
              if rate<>'' then
                movie := movie + '<br>' + rate;
              movie:=movie + format('<p><a href="person:%d">%s</a></p></td>', [my_code, GetStringField('p.name')]);

              PageItems:=PageItems+1;
            end;
          end
          else begin
            GetNextRecord;
            i:=i+1;
          end;
        end;
        PreviousCodes.Free;
        TotalItems := TotalItems + PageItems;

        all:=all+movie+'</tr></table></td></tr>';
        all := all + '</table>';

        kol := 0;
        lines := RegReadInteger('LinesPeople', DefaultLinesPeople);
        if (page > 0) and (i < RecordCount) then begin
          //set the maximum number of pages to 2000
          TotalItems := TotalItems + CountItemsForPages(page_width, 2000, RecordCount, i, lines, PhotoHeight, StandardPhotoWidth);
          kol := CountedPages;
        end;
        movie_top:=GetPatternTop;
        movie_top:= movie_top + '<p class="title">' + text + format(' (%d)', [TotalItems]);
        movie_top:=movie_top+'</p></td>'+ClosePatternTop;
        movie_top := movie_top + Format('<tr><td><table class="content"><tr><td style="background:url(%s) repeat-x;">&nbsp;</td></tr>', [WhiteBarFile]);
        movie_top:=movie_top+'<tr><td align="center"><table class="ref-boxes"><tr>';

        all := movie_top + all;

        s:='userref:'+IntToStr(TempReferenceCode)+','+TempText;
        if (kol > 0) or (page > 1) then begin
          all:=all+'<center><table class="navi"><td class="navi-border">'+format('<img src="%snavi-left.gif"></td><td style="background:url(%s) repeat-x;"><p>', [ImgPath, WhiteBarFile]);
          if (kol>0) or (page > 1) then
            all:=all+format('<a href="%s,%d">%s</a>   ', [s, 0, GetLangStr(1330)]);
          if page>1 then
            all:=all+format('<a href="%s,%d">%s</a>   ', [s, page-1, GetLangStr(1328)]);
          for i:=1 to page do begin
            if page=i then
              all:=all+format(' <b>%d</b> ', [i])
            else
              all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
          end;
          for i:=(page+1) to (page+kol) do
            all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
          if kol>0 then
            all:=all+format('   <a href="%s,%d">%s</a> ', [s, page+1, GetLangStr(1329)]);
          all:=all+format('</p></td><td class="navi-border"><img src="%snavi-right.gif"></td></table></center>', [ImgPath]);
        end;
        all := all + GetPatternBottom;
      end;

      sl.Free;
      result := all;
    end;


  finally
    ResetRegistrySubKey();
  end;
end;

function MarkPreviousAsSeen: Boolean;
var
	btnSelected: Integer;
begin
	btnSelected := MessageDlg(GetLangStr(2953), mtConfirmation, mbYes + mbNo, 0);
	if btnSelected = mrYes then
		Result := True
	else
		Result := False;
end;

begin

end.