program modern_program_part5;

uses 'modern_program_variables.pas', 'modern_program_global.pas';

function GetThumbnailBook(code, mode: integer; title, year: string; InCollection, rating: integer;
  AFullDescription: string = ''; ASearchDescription: string = ''): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img, seasons: string;
  fl, showCoversInList, FullList: boolean;
  i, j, kol, dir, amount, RecordCount: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
	BigOpen, BigClose, SmallOpen, SmallClose: string;
begin
	result:='';
	sl:=TStringList.Create;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[BOOKNIZER_PROGRAM]);
  try
    amount:=mode;
    s:='';
    ThumbsPath:=ImagesPath+Thumbs+'\';
    i := RegReadInteger('ShowCoversInList', 1);
    if i = 1 then
      showCoversInList := True
    else
      showCoversInList := False;
    i := RegReadInteger('MinimaList', 0);
    if i = 1 then
      FullList := False
    else
      FullList := True;
      fl:=false;
      genres:='';
      directors:='';
      actors:='';

      //    ,    
      if (InCollection=1) then begin
      if showCoversInList then begin
        //
        with sl do begin
          Clear;
          Add('select i.path from images i');
          Add('left join images_modes im on im.code = i.mode');
          Add(format('where i.movie=%d and i.mode=1', [code]));
          Add('order by im.sort_order, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          FileIn:=ImagesPath+GetStringField('i.path');
          FileName:=ThumbsPath+GetStringField('i.path');

          if MyFileExists(FileIn) then begin
            if not MyFileExists(FileName) then begin
              ConvertThumb3(FileIn, FileName, Thumbs, RegReadInteger('ThumbWidth', DefaultThumbWidth), 0, False);
            end;
            if not MyFileExists(FileName) then
              FileName:=FileIn;
          end
          else
            FileName:=FileIn;
          if MyFileExists(FileName) then
            fl:=true;
        end;
        if not fl then begin
          FileIn:=ImgPath + NO_COVER_FILE[BOOKNIZER_PROGRAM];
          FileName := ThumbsPath + NO_COVER_FILE[BOOKNIZER_PROGRAM];
          if MyFileExists(FileIn) then begin
            if not MyFileExists(FileName) then
              ConvertThumb3(FileIn, FileName, Thumbs, RegReadInteger('ThumbWidth', DefaultThumbWidth), 0, False);
            if not MyFileExists(FileName) then
              FileName := FileIn;
          end;
          fl:=true;
        end;
      end;

        if amount>0 then begin
        //
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=8', [code]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        for j:=1 to RecordCount do begin
          genres:=genres+format('<a href="genre:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
          GetNextRecord;
        end;
        if genres<>'' then
          genres:=copy(genres, 1, length(genres)-2);

        //  
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection, d.mode from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode in (1,3)', [code]));
          //Add('and d.sort_order<10');//27.07.07
          Add('order by d.mode, d.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        i:=0;
        j:=0;
        dir:=0;
        while (i<RecordCount) and (j<amount) do begin
          if GetIntegerField('p.in_collection')=1 then
            img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
          else
            img:='';
          if GetIntegerField('d.mode')=1 then begin
            if dir<=3 then begin
              directors:=directors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), GetStringField('p.name')]);
              dir:=dir+1;
            end;
          end
          else begin
            actors:=actors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), GetStringField('p.name'), j]);
            j:=j+1;
          end;
          i:=i+1;
          GetNextRecord;
        end;
      end;
      if directors<>'' then
        directors:=copy(directors, 1, length(directors)-2);

      if actors<>'' then
        actors:=copy(actors, 1, length(actors)-2);

      if GroupOperation then
      begin
        if (IsMovieChecked(code)) then        
          CheckMode:=format('<a href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
        CheckMode := '<div id="group_overlay_image">' + CheckMode + '</div>';
      end
      else
        CheckMode:='';

      if year<>'' then
        year:=format(' (%s)', [year]);

      if rating>0 then
        rate:=format(' <img src="%sstar.gif" width=16 height=16 border=0 align="absmiddle">%d', [ImgPath, rating])
      else
        rate:='';
      BigOpen:='';
      BigClose:='';
      SmallOpen:='<small>';
      SmallClose:='</small>';
      if GetCutePreview or (mode=7) then begin
        BigOpen:='<big>';
        BigClose:='</big>';
        SmallOpen:='';
        SmallClose:='';
      end;
        if showCoversInList then begin
          s:=format(CheckMode + '<div><div class="thumb-cover-border"><a href="movie:%d"><img class="thumb-cover" src="%s"', [code, FileName]);
          if not GetCutePreview and (mode<>7) then
            s:=s+' width="50" border="0" align="left"';
          s:=s+'></a></div>';
        end;
        s := s+format('<div class="thumb-text"><a href="movie:%d">%s<b>%s</b>%s</a>%s%s%s<br>', [code, BigOpen, title, BigClose, SmallOpen, year, rate]);
        //Genres
        if (genres<>'') and FullList then begin
          if mode<>1 then
            genres:=GetLangStr(179)+': '+genres;
          s:=s+genres+'<br>';
        end;
        //Directors
        if FullList and (mode<>1) and (directors<>'') then
          s:=s+GetLangStr(20067)+': '+directors+'<br>';
          //s:=s+directors+'<br>';
        //Actors
        if FullList and (actors<>'') then begin
          if mode<>1 then
            actors:=GetLangStr(20158)+': '+actors;
          s:=s+actors+'<br>';
        end;
        s := s+SmallClose;
      end
      else begin
      if year<>'' then
        year:=format(' (%s)', [year]);
      s:=format('<a href="movie:%d"><b>%s</b>%s</a>', [code, title, year]);
      end;

      s := s+'</div></div>';
      if mode=7 then
        s:='<tr><td class="thumb">'+s+'</td></tr>';



    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;

//show movies by selected user reference
//links like <a href='userref:Code,Text'>link</a>
//links like <a href='userref:Code,Text,Page'>link</a>
function GetUserReferenceForBook(code: integer; text: string; Page: Integer = 1): string;
var
  sl: TStringList;
  i, j, kol, kol2, RecordCount, rating, page_width, LastCode, my_i, my_code, movie_code: integer;
  s, description, year, director, writer, actor, bio, character, movie, movie_top: string;
  all, FileName, img, rate: string;
  IMDBRating: double;
  StartItem, EndItem, MoviesPage, ii, TotalItems, lines, SeasonNr, PageItems: integer;
  fl, ShowLastUpdated, loan_page: boolean;
  dd, mm, yy, loan_code, page_width_copy, PicWidth, PicHeight: integer;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[BOOKNIZER_PROGRAM]);
  try
    ProgramReference:='';
    TempReferenceCode:=code;
    code := GetOldReferenceCodeForNewCode(code);
    TempReference:=666;
    TempText:=text;
    if code=100 then
      result := GetPatternTop+format('<p class="title">%s</p></td>', [GetLangStr(1333)])+ClosePatternTop+'<tr><td><table class="content"><tr><td><p class="header">'+ShowScriptOptions+'</p></td></tr></table></td></tr>'+GetPatternBottom
    //Movie tabs
    else if code in [109..119]	then begin
      my_code := 0;
      SeasonNr := 0;
      i := Pos(';', text);
      if i>0 then begin
        s := copy(text, i+1, length(text) - i);
        delete(text, i, length(text) - i + 1);
        try
          SeasonNr := StrToInt(s);
        except
        end;
      end;
      try
        my_code := StrToInt(text);
      except
      end;

      //18.11.10
      SetMode(1, my_code);

      ActiveTab := code - 108;
      if my_code > 0 then
        result := GetBookPage(my_code, SeasonNr, false, false, false, false);
    end
    //person tabs
    else if code in [120..130] then begin
      my_code := 0;
      try
        my_code := StrToInt(text);
      except
      end;
      PersonActiveTab := code - 119;
      SetMode(2, my_code);
      if my_code > 0 then
        result := GetPerson(my_code, false, false);
    end
    else begin

      sl:=TStringList.Create;
      all:='';

      //return loan
      if code = 9 then begin
        my_code := 0;
        try
          my_code := StrToInt(text);
        except
        end;
        DecodeDate(Date, yy, mm, dd);
        s := format('%d/%d/%d', [mm, dd, yy]);
        if my_code > 0 then begin
          with sl do begin
            Clear;
            Add(format('UPDATE loans SET return_date=''%s''', [s]));
            Add(format('WHERE code=%d', [my_code]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          all := GetHome;
        end;
      end;

      //new loan
      if code = 10 then begin
        my_code := 0;
        i := Pos(';', text);
        if i>0 then begin
          movie := copy(text, i+1, length(text) - i);
          delete(text, i, length(text)-i+1);
        end;
        try
          my_code := StrToInt(text);
          movie_code := StrToInt(movie);
        except
        end;
        ShowLoanManagerMicro(my_code, movie_code);
        SetMode(1, movie_code);
        all := GetBookPage(movie_code, 0, false, false, false, false);
      end;

      //return loan from movie page
      if code = 11 then begin
        my_code := 0;
        loan_page := false;
        i := Pos('loan-page', text);
        if i>0 then begin
          loan_page := true;
          delete(text, i-1, length(text)-i+2);
        end;
        i := Pos(';', text);
        if i>0 then begin
          movie := copy(text, i+1, length(text) - i);
          delete(text, i, length(text)-i+1);
        end;
        i := Pos(';', movie);
        if i>0 then begin
          s := copy(movie, i+1, length(movie) - i);
          delete(movie, i, length(movie)-i+1);
        end;
        try
          my_code := StrToInt(text);
          movie_code := StrToInt(movie);
          loan_code := StrToInt(s);
        except
        end;
        DecodeDate(Date, yy, mm, dd);
        s := format('%d/%d/%d', [mm, dd, yy]);
        if my_code > 0 then begin
          with sl do begin
            Clear;
            Add(format('UPDATE loans SET return_date=''%s''', [s]));
            Add(format('WHERE edition=%d and code=%d', [my_code, loan_code]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
        end;
        if loan_page then
          all := GetLoans
        else begin
          SetMode(1, movie_code);
          all := GetBookPage(movie_code, 0, false, false, false, false);
        end;
      end;

      // movies by studio
      if code = 12 then begin
        with sl do begin
          Clear;
          Add('select m.title as Title, m.code as code, m.in_collection as in_collection,');
          Add('m.rating as rating, m.imdb_rating as imdb_rating, i.path as path, ');
          Add('i.width as width, i.height as height');
          Add('from movies m');
          Add('inner join movies_manuals mm on mm.movie=m.code and mm.reference=12');
          Add('inner join manuals mg on mg.code=mm.ref_code');
          Add('left join images_modes im on im.code = i.mode');
          Add(format('where mg.name=%s and m.in_collection=1', [TempText]));
          Add('AND m.item_type=' + IntToStr(BOOKNIZER_PROGRAM));
          Add('order by m.title, im.sort_order, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        all := ProcessMovieReference(BOOKNIZER_PROGRAM, text, page);
      end;

      //delete loan
      if code = 14 then begin
        my_code := 0;
        loan_page := false;
        i := Pos('loan-page', text);
        if i>0 then begin
          loan_page := true;
          delete(text, i-1, length(text)-i+2);
        end;
        i := Pos(';', text);
        if i>0 then begin
          movie := copy(text, i+1, length(text) - i);
          delete(text, i, length(text)-i+1);
        end;
        i := Pos(';', movie);
        if i>0 then begin
          s := copy(movie, i+1, length(movie) - i);
          delete(movie, i, length(movie)-i+1);
        end;
        try
          my_code := StrToInt(text);
          movie_code := StrToInt(movie);
          loan_code := StrToInt(s);
        except
        end;
        DecodeDate(Date, yy, mm, dd);
        s := format('%d/%d/%d', [mm, dd, yy]);
        if my_code > 0 then begin
          with sl do begin
            Clear;
            Add('DELETE FROM loans');
            Add(format('WHERE edition=%d and code=%d', [my_code, loan_code]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
        end;
        if loan_page then
          all := GetLoans
        else begin
          SetMode(1, movie_code);
          all := GetBookPage(movie_code, 0, false, false, false, false);
        end;
      end;

      //page of loans
      if code = 15 then
        all := GetLoans;

      //movies from the home page
      if (RegReadInteger('ShowLastUpdated', 0) = 1) then
        ShowLastUpdated := True
      else
        ShowLastUpdated := False;
      if ((code > 0) and (code < 6)) then
      begin
        GenerateSQLForMoviesPages(sl, BOOKNIZER_PROGRAM, code);
        ExecuteSQL(sl.text);
        all := ProcessMovieReference(BOOKNIZER_PROGRAM, text, page);
      end;

      //people from the homepage
      if (code > 5) and (code < 10) then begin
        with sl do begin
          Clear;

          Add('select p.code as code, p.name, p.rating, p.birth_date, i.path, i.width, i.height, p.in_collection');
          Add('from persons p');
          Add('left outer join images i on i.person=p.code');
          Add('left join images_modes im on im.code = i.mode');
          case code of
            7: Add('where 1=1');
            8: Add('where p.date_update is not null');
            9: Add('where p.birth_date like ''%' + Format('%s', [GetTodaysDate]) + '%''');
            else
              if ShowLastUpdated then
                Add('where p.date_update is not null')
              else
                Add('where p.date_add is not null');
          end;
          Add('and p.in_collection=1');
          case code of
            7: Add('order by p.rating desc, p.date_add desc, p.code, im.sort_order, i.sort_order');
            8: Add('order by p.date_update desc, p.code, im.sort_order, i.sort_order');
            9: Add('order by p.date_add desc, p.code, i.sort_order');
            else
              if ShowLastUpdated then
                Add('order by p.date_update desc, p.code, im.sort_order, i.sort_order')
              else
                Add('order by p.date_add desc, p.code, im.sort_order, i.sort_order');
          end;
        end;
        RecordCount:=ExecuteSQL(sl.text);

        lines := RegReadInteger('LinesPeople', DefaultLinesPeople);
        page_width := GetHTMLWidth - WholePageBorder;
        CountedPages := 0;
        TotalItems := CountItemsForPages(page_width, page, RecordCount, 1, lines, PhotoHeight, StandardPhotoWidth);
        i := ProcessedRecords;
        movie := '';
        all := '';
        fl:=true;
        PageItems := 0;
        LastCode := 0;
        page_width_copy := page_width;
        while (i<=RecordCount) and fl do begin
          my_code:=GetIntegerField('code');
          if LastCode<>my_code then begin
            LastCode:=my_code;
            PicHeight := GetIntegerField('i.height');
            if PicHeight > 0 then
              PicWidth := Round(GetIntegerField('i.width') * (PhotoHeight / PicHeight)) + NormalImageBorders
            else
              PicWidth := CoverCellWidth;
            if PicWidth < CoverCellWidth then
              PicWidth := CoverCellWidth;
            page_width_copy := page_width_copy - PicWidth;
            if (page_width_copy < 0) then begin
              all := all + movie + '</tr></table></tr></td><tr><td align="center"><table class="ref-boxes"><tr>';
              movie := '';
              lines := lines - 1;
              page_width_copy := page_width - PicWidth;
            end;
            if (page<>0) and (lines <= 0) then
              fl:=false
            else begin

              FileName:=ImagesPath+GetStringField('i.path');
              if not MyFileExists(FileName) then
                FileName:=ImgPath + NO_PHOTO_FILE[BOOKNIZER_PROGRAM];
              rating := GetIntegerField('p.rating');
              rate:='';
              if rating > 0 then begin
                for my_i:=1 to 10 do begin
                  if my_i mod 2=1 then begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-left.gif" align="absmiddle" border="0">',  [ImgPath])
                  end
                  else begin
                    if my_i<=rating then
                  rate:=rate+format('<img src="%sstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
                    else
                  rate:=rate+format('<img src="%snot-star-right.gif" align="absmiddle" border="0">',  [ImgPath])
                  end;
                end;
              end;
              movie:=movie+'<td class="box-photos" style="background:url('+BackgroundPeople+') repeat-x;">'+format('<a href="person:%d"><img class="person-photo" src="%s"></a>', [my_code, FileName]);
              if rate<>'' then
                movie := movie + '<br>' + rate;
              if code = 9 then begin
                DecodeDate(Date, kol, kol2, my_i);
                s := ' (' + IntToStr(YearsBetween(GetStringField('p.birth_date'), IntToStr(kol))) + ')';
              end
              else
                s := '';
              movie:=movie + format('<p><a href="person:%d">%s%s</a></p></td>', [my_code, GetStringField('p.name'), s]);

              PageItems:=PageItems+1;
            end;
          end
          else begin
            GetNextRecord;
            i:=i+1;
          end;
        end;
        TotalItems := TotalItems + PageItems;

        all:=all+movie+'</tr></table></td></tr>';
        all := all + '</table>';

        kol := 0;
        lines := RegReadInteger('LinesPeople', DefaultLinesPeople);
        if (page > 0) and (i < RecordCount) then begin
          //set the maximum number of pages to 2000
          TotalItems := TotalItems + CountItemsForPages(page_width, 2000, RecordCount, i, lines, PhotoHeight, StandardPhotoWidth);
          kol := CountedPages;
        end;
        movie_top:=GetPatternTop;
        movie_top:= movie_top + '<p class="title">' + text + format(' (%d)', [TotalItems]);
        movie_top:=movie_top+'</p></td>'+ClosePatternTop;
        movie_top := movie_top + Format('<tr><td><table class="content"><tr><td style="background:url(%s) repeat-x;">&nbsp;</td></tr>', [WhiteBarFile]);
        movie_top:=movie_top+'<tr><td align="center"><table class="ref-boxes"><tr>';

        all := movie_top + all;

        s:='userref:'+IntToStr(TempReferenceCode)+','+TempText;
        if (kol > 0) or (page > 1) then begin
          all:=all+'<center><table class="navi"><td class="navi-border">'+format('<img src="%snavi-left.gif"></td><td style="background:url(%s) repeat-x;"><p>', [ImgPath, WhiteBarFile]);
          if (kol>0) or (page > 1) then
            all:=all+format('<a href="%s,%d">%s</a>   ', [s, 0, GetLangStr(1330)]);
          if page>1 then
            all:=all+format('<a href="%s,%d">%s</a>   ', [s, page-1, GetLangStr(1328)]);
          for i:=1 to page do begin
            if page=i then
              all:=all+format(' <b>%d</b> ', [i])
            else
              all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
          end;
          for i:=(page+1) to (page+kol) do
            all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
          if kol>0 then
            all:=all+format('   <a href="%s,%d">%s</a> ', [s, page+1, GetLangStr(1329)]);
          all:=all+format('</p></td><td class="navi-border"><img src="%snavi-right.gif"></td></table></center>', [ImgPath]);
        end;
        all := all + GetPatternBottom;
      end;

      sl.Free;
      result := all;
    end;

  finally
    ResetRegistrySubKey();
  end;
end;


function GetThumbnailBookExtended(code, mode: integer; title: string): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img: string;
  fl, CutThumb: boolean;
  i, j, kol, dir, amount, RecordCount, CoverWidth, CoverHeight: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
  ProgramType: Integer;
begin
	result:='';
  ProgramType := BOOKNIZER_PROGRAM;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    sl:=TStringList.Create;

    amount:=mode;
    s:='';
    ThumbsPath:=ImagesPath+'Thumbs2\';
    fl:=false;

      //
      with sl do begin
        Clear;
        Add('select * from images i ');
        Add('left join images_modes im on im.code = i.mode');
        Add(format('where i.movie=%d and i.mode=1', [code]));
        Add('order by im.sort_order, i.sort_order');
      end;
      RecordCount:=ExecuteSQL(sl.text);

    //    
    CoverWidth := RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[BOOKNIZER_PROGRAM]);
    CoverHeight := RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[BOOKNIZER_PROGRAM]);

    //    ,  
    if (CoverWidth <= 0) or (CoverHeight <= 0) then begin
      CoverWidth := DefaultMultiCoverWidth[BOOKNIZER_PROGRAM];
      CoverHeight := DefaultMultiCoverHeight[BOOKNIZER_PROGRAM];
    end;

    //  
      if RecordCount>0 then begin
      i := RegReadInteger('CutThumb', 1);
      if i = 1 then
        CutThumb := True
      else
        CutThumb := False;
      FileIn:=ImagesPath+GetStringField('i.path');
      FileName:=ThumbsPath+GetStringField('i.path');
      //    ,   
      if MyFileExists(FileName) then
        fl:=true
      //   
      else if MyFileExists(FileIn) then
        ConvertThumb2(FileIn, FileName, CoverWidth, CoverHeight, CutThumb);
      //,     
      if MyFileExists(FileName) then
        fl:=true;
      end;
    //       thumb,  
      if not fl then begin
      FileIn:=ImgPath + NO_COVER_FILE[BOOKNIZER_PROGRAM];
      FileName:=ThumbsPath + NO_COVER_FILE[BOOKNIZER_PROGRAM];
      if (CoverWidth = DefaultMultiCoverWidth[BOOKNIZER_PROGRAM]) and (CoverHeight = DefaultMultiCoverHeight[BOOKNIZER_PROGRAM]) then
        FileName := ImgPath + 'nocoverbooksmall.jpg';
      if ((not MyFileExists(FileName)) and (MyFileExists(FileIn))) then begin
        ConvertThumb2(FileIn, FileName, CoverWidth, CoverHeight, CutThumb);
      end;
      fl:=true;
      end;

    //     
      if GroupOperation then
      begin
        if (IsMovieChecked(code)) then
          CheckMode:=format('<a href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
        else
          CheckMode:=format('<a href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
        CheckMode := '<div id="group_overlay_image_multi">' + CheckMode + '</div>';
      end
    else
      CheckMode:='';

    // 
      s:=format(CheckMode + '<table><tr><td align="center"><div class="thumb-big-cover-border"><a href="movie:%d"><img class="thumb-big-cover" src="%s"></a></div></td></tr><tr><td>', [code, FileName])+format('<a href="movie:%d"><b>%s</b></a></td></tr></table>', [code, title]);


    if mode=7 then
      s:='<tr><td>'+s+'</td></tr>';

    if amount=3 then
      s:='<div class="preview">'+s+'</div>';

    result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetBooksTabs(BookCode: Integer): String;
var
	s, media_format, prev_media_format : String;
	i, k, my_tabs, PageWidth, SeasonTabs, PageTabs, RecordCount: Integer;
	sl: TStringList;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[BOOKNIZER_PROGRAM]);
  try
    PageWidth := GetHTMLWidth - TabBorders;
    SeasonTabs := PageWidth div SeasonTabWidth;
    PageTabs := PageWidth div TabWidth;
    s := '<tr><td colspan="2"><table';
    //if (ActiveTab <> 2) then
      //s := s + ' width="100%"';
    s := s + '><tr>';
    if (ActiveTab = 2) then
      s := s + '<td width="205"></td>';
    //general info tab
    if ActiveTab = 1 then
      s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(161)])
    else
      s := s + Format('<td class="movie-inactive-tab"><a href="userref:2109,%d">%s</a></td>', [BookCode, GetLangStr(161)]);
    PageTabs := PageTabs - 1;
    //screenshots
    if (PageTabs > 0) and (RegReadInteger('ShowShotTab', 1) = 1) then begin
      PageTabs := PageTabs - 1;
      if ActiveTab = 2 then
        s := s + Format('<td class="movie-active-tab">%s</td>', [GetLangStr(199)])
      else
        s := s + Format('<td class="movie-inactive-tab"><a href="userref:2110,%d">%s</a></td>', [BookCode, GetLangStr(199)]);
    end;

    s := s + '</tr></table></td></tr>';
    Result := s;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetBookPage(MovieCode, season: integer; FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
var
  sl, TempList: TStringList;
  duration, i, j, kol, rmax, RecordCount: integer;
  all, s, s2, country, description, comment, genre, year, director, writer, composer, actor, character, down, salary, awards, studios: string;
  rating: integer;
  IMDBRating, SiteRating: double;
  FileName, img, OriginalTitle, site, url, postfix: string;
  flCollection, flSeen, flWanted, flForSale, LastCode: integer;
  collection, seen, wanted, sale, rate, mpaa, mpaa_desc, disc_nom, seasons: string;
  VideoStandard, ScreenRatio, resolution, mpaa_code, VideoBitrate, VideoCodec, filesize, k: integer;
  DiscLabel: integer;
  custom: array[1..6] of integer;
  cust: string;
  DateAdd, DateUpdate, DateSeen, loan_date, return_date: string;
  age, border: string;
  editions: array [1..1000] of integer;
  EditionsCount, EditionCode, MediaFormat, ie: integer;
  ed, temp, barcode, OtherRating, EditionFeatures, EditionComment, VideoFileFolder, VideoFileName: string;
  PrevBlockCnt, ThisBlockCnt, ShotCnt, MaxShots, hours, minutes, seconds, SeasonCnt, PosterCnt: Integer;
  page_width, PicWidth, PicHeight, TrailerCnt, Circulation, RemainingShots: Integer;
  NoTrailerAdded: Boolean;
  trunc_name, trunc_character: String;
  fl, flUseThumbs: boolean;
  ThumbsFileName, ThumbsPath, TagLine, TrackNumberStr, DurationStr: string;
  VideoFileCode, front_cover_url: string;
  EditionCost: double;
  CodesList: TStringList;
begin
	result:='';
	sl:=TStringList.Create;
	all:='';
	OtherRating := '';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[BOOKNIZER_PROGRAM]);
  try
    i := RegReadInteger('UseThumbs', 1);
    if i = 1 then
      flUseThumbs := True
    else
      flUseThumbs := False;

    with sl do begin
    Clear;
      Add('select i.code from images i');
      Add('left join images_modes im on im.code = i.mode');
      Add(format('where i.movie=%d', [MovieCode]));
      Add('order by im.sort_order, i.sort_order');
    end;
    ShotCnt:=ExecuteSQL(sl.text);


        with sl do begin
          Clear;
          Add('select * from movies');
          Add(format('where code=%d', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount=0 then
          exit;
        s:='movie:'+IntToStr(MovieCode);
        movie:=GetStringField('title');

        OriginalTitle:=GetStringField('original_title');
        rating:=GetIntegerField('rating');
        IMDBRating:=GetFloatField('imdb_rating');

        flCollection:=GetIntegerField('in_collection');
        flSeen:=GetIntegerField('seen');
        flWanted:=GetIntegerField('wanted');
        flForSale:=GetIntegerField('for_sale');

        mpaa_code:=GetIntegerField('mpaa');
        mpaa_desc:=GetStringField('mpaa_rating');

        DateAdd:=GetStringField('date_add');
        DateUpdate:=GetStringField('date_update');
        DateSeen:=GetStringField('date_seen');
        TagLine := GetStringField('tagline');

        //GoForward(s, GetStringField('m.title'), ChangeHistory);

        description:=GetStringField('description');
        salary:=GetStringField('salary');
        awards:=GetStringField('awards');
        comment:=GetStringField('comment');

        custom[1]:=GetIntegerField('custom1');
        custom[2]:=GetIntegerField('custom2');
        custom[3]:=GetIntegerField('custom3');
        custom[4]:=GetIntegerField('custom4');

        if GetStringField('duration')='' then
          duration:=0
        else
          duration:=GetIntegerField('duration');
        year:=GetStringField('year');

        disc_nom:=GetStringField('disc_nom');

        if flCollection=0 then
          collection:=format('<a href="collection:%d"><img src="%snot_collection.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(326)])
        else
          collection:=format('<a href="collection:%d"><img src="%scollection.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(20157)]);


        if flSeen=0 then
          seen:=format('<a href="seen:%d"><img src="%snot_seen.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(20154)])
        else
          seen:=format('<a href="seen:%d"><img src="%sseen.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(20461)]);

        if flWanted=0 then
          wanted:=format('<a href="wanted:%d"><img src="%snot_wanted.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(20155)])
        else
          wanted:=format('<a href="wanted:%d"><img src="%swanted.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(20462)]);

        if flForSale=0 then
          sale:=format('<a href="sale:%d"><img src="%snot_sale.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(20156)])
        else
          sale:=format('<a href="sale:%d"><img src="%ssale.gif" border="0" alt="%s"></a>',  [MovieCode, ImgPath, GetLangStr(20463)]);

        rate:='';
        for i:=1 to 10 do begin
          if i mod 2=1 then begin
            if i<=rating then
              rate:=rate+format('<a href="rating:%d"><img src="%sstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
            else
              rate:=rate+format('<a href="rating:%d"><img src="%snot-star-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
          end
          else begin
            if i<=rating then
              rate:=rate+format('<a href="rating:%d"><img src="%sstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
            else
              rate:=rate+format('<a href="rating:%d"><img src="%snot-star-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
          end;
        end;

        //description
        if description<>'' then begin
          if (ActiveTab <> 10) and (not FullDesc) and (length(description)>DescriptionLength) then begin
            description:=copy(description, 1, DescriptionLength);
            description:=RemoveUnclosedTags(description);
            description:=description+format(GetLangStr(566), [MovieCode]);
          end;
        end;

        if description='' then
          down:='<br>'+format('<a href="DownloadMovie:%d">', [MovieCode])+GetLangStr(324)+'</a>'
        else
          down:='';

    // Count seasons
    with sl do begin
      Clear;
      Add('select distinct e.season from episodes e');
      Add(format('where e.movie=%d', [MovieCode]));
      Add(' order by e.season');
     end;
    SeasonCnt:=ExecuteSQL(sl.text);

    VideoFileName := '';
    VideoFileCode := '';
      with sl do begin
          Clear;
          Add('select e.filename, e.code from editions e');
          Add('left outer join manuals m on m.code=e.edition and m.reference=21');
          Add(format('where e.movie=%d', [MovieCode]));
          Add('order by e.sort_order');
      end;
      EditionsCount:=ExecuteSQL(sl.text);
    VideoFileName := GetStringField('e.filename');
    VideoFileCode := GetStringField('e.code');


    if (not FullAwards) and (length(awards)>DescriptionLength) then begin
      awards:=copy(awards, 1, DescriptionLength);
      awards:=RemoveUnclosedTags(awards);
      awards:=awards+format(GetLangStr(1331), [MovieCode]);
    end;

        all:=GetPatternTop;
      all:= all + '<p class="title">' + movie;
      if (OriginalTitle <> '') and (OriginalTitle <> movie) then
        all := all + '<font size="3"> <b>('+OriginalTitle+')</b></font>';
      all:= all + Format('</p></td><td class="icons"><table class="icons-container"><tr><td class="icons-border"><img src="%sicons-left.gif"></td><td class="icons-place">%s%s%s%s&nbsp;</td><td class="edit-link"><p><a href="UpdateMovie:%d">%s</a></p></td><td class="icons-border"><img src="%sicons-right.gif"></td></tr></table>', [ImgPath, collection, seen, wanted, sale, MovieCode, GetLangStr(304), ImgPath]) + ClosePatternTop;

    if (ActiveTab <> 2) and (ActiveTab <> 7) then begin

        //pictures
      front_cover_url := '';
      all := all + '<tr><td class="left"><table class="left-pane">';
        with sl do begin
          Clear;
          Add('select i.path, i.code from images i ');
          Add('left join images_modes im on im.code = i.mode');
          Add(format('where i.movie=%d and i.mode=1', [MovieCode]));
          Add('order by im.sort_order, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
      all:=all+'<tr><td>';
      ThumbsPath:=ImagesPath+'ThumbsCovers\';
        if RecordCount>0 then begin
      front_cover_url := GetStringField('i.path');
          FileName:=ImagesPath+GetStringField('i.path');
          if (MyFileExists(FileName)) then begin
            //2.05,11
            fl:=false;
          if flUseThumbs then begin
          ThumbsFileName:=ThumbsPath+GetStringField('i.path');

              if GetFileDateTime(ThumbsFileName)<GetFileDateTime(FileName) then
                DeleteFile(ThumbsFileName);

              if not MyFileExists(ThumbsFileName) then
                ConvertThumb3(FileName, ThumbsFileName, 'ThumbsCovers', 140, 0, false);
              if MyFileExists(ThumbsFileName) then
                fl:=true;
            end;

            if fl then
              all:=all+format('<div class="cover"><a href="ShowImage:%d"><img class="cover-image" src="%s"></a></div>',
                [GetIntegerField('i.code'), ThumbsFileName])
            else
              all:=all+format('<div class="cover"><a href="ShowImage:%d"><img class="cover-image" src="%s"></a></div>',
                [GetIntegerField('i.code'), FileName]);
            //end 2.05.11
          end;
      end
      else begin
      FileName:=ImgPath + NO_COVER_FILE[BOOKNIZER_PROGRAM];
      if (MyFileExists(FileName)) then begin
        ThumbsFileName:=ThumbsPath + NO_COVER_FILE[BOOKNIZER_PROGRAM];
        if GetFileDateTime(ThumbsFileName)<GetFileDateTime(FileName) then
                DeleteFile(ThumbsFileName);
        if not MyFileExists(ThumbsFileName) then
                ConvertThumb3(FileName, ThumbsFileName, 'ThumbsCovers', 140, 0, false);
        if MyFileExists(ThumbsFileName) then
          s := ThumbsFileName
        else
          s := FileName;
        all:=all+format('<div class="cover"><img class="cover-image" src="%s"></div>', [s]);
      end;
      end;

      all:=all+'</td></tr><tr><td class="free-space"></td></tr>';

      //site links
        with sl do begin
          Clear;
          Add('select distinct mc.code, mc.site, mc.script, mc.rating, p.* from movies_codes mc');
          Add('left outer join partners p on mc.script=p.site');
          Add('AND mc.item_type = p.item_type');
          Add(format('where movie=%d', [MovieCode]));
          Add('order by p.sort_order, mc.script');
        end;
        RecordCount:=ExecuteSQL(sl.text);

      for i:=1 to RecordCount do begin
        site:=GetStringField('mc.script');
        url:=GetStringField('mc.site');
        if (site <> 'trailer') then begin
          postfix:=GetStringField('p.postfix');
          all := all+'<tr><td class="site-link">';
          if postfix<>'' then
            url:=url+postfix;
          if site='buy' then begin
            if Pos('amazon', url)>0 then
              all:=all+'<a class="picture" alt="Buy at Amazon"  href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%samazon.gif"></a> ', [PicturesPath])
            else
              all:=all+format(GetLangStr(375), ['http://www.medianizer.com/redirect/'+url, movie])+' ';
          end
          else begin
            s:=GetStringField('p.picture');
            if s='' then begin
              if site='ozon' then
                all := all + '<a class="picture" alt="   "  href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%sozon.gif"></a> ', [PicturesPath])
              else
                all:=all+'<a href="link:http://www.medianizer.com/redirect/'+url+format('">%s</a> ', [site]);
            end
            else
              all:=all+'<a class="picture" href="link:http://www.medianizer.com/redirect/'+url+'">'+format('<img src="%s%s"></a> ', [PicturesPath, s]);
          end;
          i := RegReadInteger('ShowSiteRating', 1);
          if i=1 then begin
            SiteRating:=GetFloatField('mc.rating');
            if (SiteRating>0) and (site<>'imdb') then
              all := all + format('<p class="simple-text">%s: %f</p>', [GetLangStr(75),SiteRating]);
          end;
          all := all + '</td></tr>';
        end;
        GetNextRecord;
      end; //for

      //my rating
      i := RegReadInteger('ShowRating', 1);
      if i=1 then begin
        all := all + '<tr><td class="free-space"></td></tr>';
        all := all + Format('<tr><td class="my-rating-cell-name">%s</td></tr>', [GetLangStr(298)]);
        all := all + '<tr><td class="my-rating-cell-value">'+rate+'</td></tr>';
      end;

      //imdb rating
      if IMDBRating <> 0 then begin
        if i<>1 then
          all := all + '<tr><td class="free-space"></td></tr>'
        else
          all := all + '<tr class="small-free-space"><td></td></tr>';
        all := all + Format('<tr><td class="imdb-rating-cell-name">%s</td></tr>', [GetLangStr(707)]) + Format ('<tr><td class="imdb-rating-cell-value">%0.1f</td></tr>', [IMDBRating]);
      end;

    all := all + '<tr><td class="free-space"></td></tr></table>';

    //format logos
    if (RegReadInteger('ShowFormatLogos', 1) = 1) then begin
      with sl do begin
        Clear;
        Add('select filename from editions');
        Add(Format('where movie=%d', [MovieCode]));
      end;
      RecordCount := ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        all := all + '<table class="shots">';
        TempList := TStringList.Create;
        for i := 1 to RecordCount do begin
          s := GetStringField('filename');
          j := Pos('.', s);
          while j>0 do begin
            delete(s, 1, j);
            j := Pos('.', s);
          end;
          if (s<>'') and (TempList.IndexOf(s)<0) then begin
            TempList.Add(s);
            for j := 0 to Length(SupportedFormatImageExtensions) - 1 do begin
              s2 := ImgPath + FormatImages + s + '.' + SupportedFormatImageExtensions[j];
              if MyFileExists(s2) then begin
                all := all + '<tr><td>' + Format('<img src="%s"/>', [s2]) + '</td></tr><tr><td class="free-space"></td></tr>';
                Break;
              end;
            end;
          end;
          GetNextRecord;
        end;
        TempList.Free;
        all := all + '</table>';
      end;
    end;

      //pictures from movie
    RemainingShots := 0;
    MaxShots := RegReadInteger('ShotsCnt', 3);
    with sl do begin
      Clear;
          Add('select i.path, i.code, i.mode from images i');
          Add('left join images_modes im on im.code = i.mode');
          Add(format('where i.movie=%d', [MovieCode]));
          Add('order by im.sort_order, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        kol:=0;
      j := 0;
      if ((front_cover_url = '') and (RecordCount>0)) or (RecordCount>1) then begin
        all:=all+'<table class="shots">';
        if RecordCount < MaxShots then
          MaxShots := RecordCount;
        for i:=1 to MaxShots do begin
          if (front_cover_url <> '') and (GetIntegerField('i.mode') = 1) and (j = 0) then begin
            j := j + 1;
          end
          else begin
            FileName:=ImagesPath+GetStringField('i.path');
            if (MyFileExists(FileName)) then begin
              //2.05,11
            fl:=false;
            if flUseThumbs then begin
              ThumbsPath:=ImagesPath+'ThumbsScreenshots\';
          ThumbsFileName:=ThumbsPath+GetStringField('i.path');

            if GetFileDateTime(ThumbsFileName)<GetFileDateTime(FileName) then
            DeleteFile(ThumbsFileName);

                if not MyFileExists(ThumbsFileName) then
            ConvertThumb3(FileName, ThumbsFileName, 'ThumbsScreenshots', 150, 0, false);
            if MyFileExists(ThumbsFileName) then
            fl:=true;
              end;
            if fl then
                all:=all+format('<tr><td class="shots-cell"><a class="picture" href="ShowImage:%d"><img class="shot-image" src="%s"></a></td></tr>', [GetIntegerField('i.code'), ThumbsFileName])
              else
                all:=all+format('<tr><td class="shots-cell"><a class="picture" href="ShowImage:%d"><img class="shot-image" src="%s"></a></td></tr>', [GetIntegerField('i.code'), FileName]);
              //end 2.05.11
            end;
          end;
          GetNextRecord;
        end;
        RemainingShots := RecordCount - MaxShots;
        if RecordCount > MaxShots then
          all:=all+format('<tr><td class="shots-cell"><a href="userref:2110,%d"><img alt="%s" src="%sshots-more.gif" border="0"></a></td></tr>', [MovieCode, GetLangStr(1411), ImgPath]);
        all:=all+'</table>';
      end; //if

    //end left pane
    all := all + '</td>';


      //right pane
      all := all + '<td width="100%"><table class="contents">';
    end; //if ActiveTab <> 2

    //Check if the active tab exists
    if 	//no shots
    ((ActiveTab = 2) and (shotCnt = 0)) then begin
      ActiveTab := 1;
      Result := GetBookPage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
      exit;
    end;

    if (RemainingShots > 0) then
      all := all + GetBooksTabs(MovieCode);

    //shots from the movie
    if ActiveTab = 2 then begin
      all := all + '<tr><td><table class="contents">';
      all := all + GetShots(MovieCode, 0, 'movie');
    end;

    if ActiveTab = 1 then begin
      all := all + '<tr><td><table class="names-values"><tr style="background:url('+WhiteBarFile+') repeat-x;"><td colspan="2">&nbsp;&nbsp;</td></tr>';

        //author
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode=3', [MovieCode]));
          Add('order by d.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Actors: '
          all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(20010), RecordCount]);
          i:=1;
      s:='';
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
            if (i=10) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end;
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=11) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end;

      //tagline
      if TagLine <> '' then begin
      all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">"', [GetLangStr(3406)]);
      all := all + TagLine + '"</p></td></tr>';
      end;

      //sequence
      with sl do begin
      Clear;
      Add('select m.code, m.name, mov.series_nom from movies mov');
          Add('join manuals m on m.code=mov.series');
      Add(format('where mov.code=%d', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then begin
      all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(20271)]);
      all := all + Format('<a href="sequence:%d">%s</a>', [GetIntegerField('m.code'), GetStringField('m.name')]);
      if GetIntegerFIeld('mov.series_nom') > 0 then
        all := all + Format(' %s%d', [GetLangStr(529), GetIntegerField('mov.series_nom')]);
      all:=all+'</p></td></tr>';
        end;

        //genres
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference  ???
          Add(format('where mm.movie=%d and m.reference=8', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Genres: '
          all:=all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(72)]);
          for i:=1 to RecordCount do begin
        if i>1 then
          all := all + ' / ';
        all:=all+format('<a href="genre:%d">%s</a>', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          all:=all+'</p></td></tr>';
        end;

      //year
        if year<>'' then
          all:=all+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="year:%s,%d">%s</a></p></td></tr>', [GetLangStr(169), year, BOOKNIZER_PROGRAM, year]);

        //countries
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference  ???
          Add(format('where mm.movie=%d and m.reference=9', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Countries: '
      all := all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(20242)]);
      country := '';
          for i:=1 to RecordCount do begin
            country:=country+format('<a href="country:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          country:=copy(country, 1, length(country)-3);
          all:=all+format('%s</p></td></tr>', [country]);
        end;


        //Publishers
      studios:='';
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=12', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          studios := format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(20227)]);
          for i:=1 to RecordCount do begin
            studios := studios + format('<a href="studio:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          studios := copy(studios, 1, length(studios)-3);
      all := all + studios + '</p></td></tr>';
        end;

        //editors
      s := '';
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode=1', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Directors: ';
          all:=all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(20067)]);
          i:=1;
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
            if (i=5) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end; //while
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=6) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end; //if

        //translators
      s := '';
        with sl do begin
          Clear;
          Add('select distinct p.code, p.name, p.in_collection from data d');
          Add('inner join persons p on p.code=d.person');
          Add(format('where d.movie=%d and d.mode=4', [MovieCode]));
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          //'Writers: '
          all:=all + Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(20228)]);
          i:=1;
          while i<=RecordCount do begin
            if GetIntegerField('p.in_collection')=1 then
              img:=format('<img src="%sperson.gif" align="absmiddle">', [ImgPath])
            else
              img:='';
            s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
            if (i=5) and (i<RecordCount) and not FullPersons then
              i:=RecordCount;
            i:=i+1;
            GetNextRecord;
          end;
          s:=copy(s, 1, length(s)-2);
          if (RecordCount>=6) and not FullPersons then
            s:=s+format(GetLangStr(1251), [MovieCode]);
          all:=all+s+'</p></td></tr>';
        end;

      all := all + '</table></td></tr>';

    //photos of people
    temp := '';
    if (RegReadInteger('HidePhotosCovers', 0) = 0) then
    begin
      LastCode:=0;
        with sl do begin
        Clear;
        Add('select distinct i.path as path, i.width, i.height, i.person as code, p.name, p.birth_date');
        Add('from data d');
        Add('inner join images i on i.person=d.person');
        Add('left join images_modes im on im.code = i.mode');
        Add('inner join persons p on p.code=d.person');
        Add(format('where d.movie=%d', [MovieCode]));
        Add('order by im.sort_order, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        page_width := GetHTMLWidth - LeftColumnWidth;
        if RecordCount>0 then
        begin
          all:=all+'<tr><td><table class="boxes">';
          j := 0;
          all := all + '<tr>';
          CodesList := TStringList.Create();
          for i:=1 to RecordCount do
          begin
            if (LastCode=0) or (CodesList.IndexOf(GetStringField('code')) < 0) then
            begin
              LastCode:=GetIntegerField('code');
              CodesList.Add(IntToStr(LastCode));
              PicHeight := GetIntegerField('i.height');
              if PicHeight > 0 then
                PicWidth := Round(GetIntegerField('i.width') * (PhotoHeight / PicHeight)) + 5
              else
                PicWidth := StandardPhotoWidth;
              if PicWidth < StandardPhotoWidth then
                PicWidth := StandardPhotoWidth;
              //to do: count page width, next line
              age := GetStringField('p.birth_date');
              {while (Pos('/', age)> 1) do
                delete(age, 1, Pos('/', age));
              try
                age := IntToStr(StrToInt(year) - StrToInt(age));
              except
              end;}
              if (age <> '') then
                age := GetAge(year, age);

              FileName:=ImagesPath+GetStringField('path');
              if (MyFileExists(FileName)) then begin
                trunc_name := TruncateName(GetStringField('p.name'), MaxNameLength);

                //2.05,11
                fl:=false;
                if flUseThumbs then begin
                  ThumbsPath:=ImagesPath+'ThumbsMoviePhotos\';
                  ThumbsFileName:=ThumbsPath+GetStringField('path');

                  if GetFileDateTime(ThumbsFileName)<GetFileDateTime(FileName) then
                    DeleteFile(ThumbsFileName);

                  if not MyFileExists(ThumbsFileName) then
                    ConvertThumb3(FileName, ThumbsFileName, 'ThumbsMoviePhotos', 0, 100, false);
                  if MyFileExists(ThumbsFileName) then
                    fl:=true;
                end;

                if fl then
                  temp:=temp+format('<td class="photo"><a class="picture" href="person:%d"><img src="%s"></a><p><a href="person:%d">%s', [GetIntegerField('code'), ThumbsFileName, GetIntegerField('code'), trunc_name])
                else
                  temp:=temp+format('<td class="photo"><a class="picture" href="person:%d"><img src="%s"></a><p><a href="person:%d">%s', [GetIntegerField('code'), FileName, GetIntegerField('code'), trunc_name]);
                //end 2.05.11


                if age <> '' then
                  temp := temp + format(' (%s)', [age]);
                temp := temp + '</a>';
                temp := temp + '</p></td>';
                page_width := page_width - PicWidth;
                if (page_width >= 0) then begin
                  all := all + temp;
                  temp := '';
                end
                else begin
                  all := all + '</tr></table></td></tr><tr><td><table class="boxes"><tr>' + temp;
                  page_width := GetHTMLWidth - LeftColumnWidth - PicWidth;
                  temp := '';
                end;
              end;//if MyFileExists
            end;
            GetNextRecord;
          end;//for
          //all := all + '<td colspan="' + IntToStr(kol-j) + '">';
          all := all + temp + '</tr></table></td></tr>';
          CodesList.Free();
        end;//if recordcount
      end;
    end; //activeTab = 1

    if (ActiveTab = 1) or (ActiveTab = 10) then begin
      //description
      if description<>'' then
        all:=all+Format('<tr style="background:url(%s) repeat-x;"><td>&nbsp;</td></tr>', [WhiteBarFile])+'<tr><td><p class="description">'+description+'</p></td></tr>';
    end;

    if ActiveTab = 1 then begin
     all := all + '<tr><td><table class="full-content">';

        //custom fields
        cust:='';
      PrevBlockCnt:=0;
        for i:=1 to 4 do begin
          if custom[i]>0 then begin
            with sl do begin
              Clear;
              Add('select name from manuals');
              Add(format('where code=%d', [custom[i]]));
            end;
            RecordCount:=ExecuteSQL(sl.text);
            if RecordCount>0 then begin
          PrevBlockCnt:=PrevBlockCnt+1;
              cust:=cust+'<tr><td class="field-names"><p class="border">'+format(GetLangStr(539+i), [s])+'</p></td><td class="field-values"><p class="border">'+format('<a href="custom%d:%d">', [i, custom[i]])+GetStringField('name')+'</a></p></td></tr>';
            end;
          end;
    end;

    //custom list1
    border := '';
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=17', [MovieCode]));
          Add('order by m.name');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
      PrevBlockCnt:=PrevBlockCnt+1;
      if (PrevBlockCnt > 2) then
        border := 'without-';
          cust:=cust+Format('<tr><td class="field-names"><p class="%sborder">%s</p></td><td class="field-values"><p class="%sborder">', [border, GetLangStr(544), border]);
          for i:=1 to RecordCount do begin
            cust:=cust+format('<a href="custom5:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          cust:=copy(cust, 1, length(cust)-2);
          cust:=cust+'</p></td></tr>';
        end;

    //custom list2
        with sl do begin
          Clear;
          Add('select m.code, m.name from movies_manuals mm');
          Add('join manuals m on m.code=mm.ref_code');
          Add(format('where mm.movie=%d and m.reference=18', [MovieCode]));
          Add('order by m.name');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
      PrevBlockCnt:=PrevBlockCnt+1;
      if PrevBlockCnt>2 then
        border := 'without-';
          cust:=cust+Format('<tr><td class="field-names"><p class="%sborder">%s</p></td><td class="field-values"><p class="%sborder">', [border, GetLangStr(545), border]);
          for i:=1 to RecordCount do begin
            cust:=cust+format('<a href="custom6:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
            GetNextRecord;
          end;
          cust:=copy(cust, 1, length(cust)-2);
          cust:=cust+'</p></td></tr>';
        end;
    if cust <> '' then
      all:=all+Format('<tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile])+cust;

  //	if (cust<>'') or (s<>'') then
  //		all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
    end; //if ActiveTab = 1


        //editions
    if (ActiveTab = 1) or (ActiveTab = 5) or (ActiveTab = 8) then begin
        with sl do begin
          Clear;
          Add('select e.code from editions e');
          Add('left outer join manuals m on m.code=e.edition and m.reference=21');
          Add(format('where e.movie=%d', [MovieCode]));
          Add('order by e.sort_order');
        end;
        EditionsCount:=ExecuteSQL(sl.text);

        for ie:=1 to EditionsCount do begin
          editions[ie]:=GetIntegerField('e.code');
          GetNextRecord;
        end;

        for ie:=1 to EditionsCount do begin
          EditionCode:=editions[ie];
          //editions
          with sl do begin
            Clear;
            Add('select * from editions e');
            Add('left outer join manuals m on m.code=e.edition and m.reference=21');
            Add(format('where e.code=%d', [EditionCode]));
          end;
          ExecuteSQL(sl.text);

          ed:='';

        //video parameters
          VideoBitrate:=GetIntegerField('e.video_bitrate');
          filesize:=GetIntegerField('e.filesize');
          DiscLabel:=GetIntegerField('e.disc_label');
          disc_nom:=GetStringField('e.disc_nom');
          duration:=GetIntegerField('e.duration');
          barcode:=GetStringField('e.barcode');
      Circulation := GetIntegerField('e.circulation');

          VideoStandard:=GetIntegerField('e.video_standard');
          ScreenRatio:=GetIntegerField('e.screen_ratio');
          resolution:=GetIntegerField('e.resolution');
          VideoCodec:=GetIntegerField('e.video_codec');
          MediaFormat:=GetIntegerField('e.media_format');

          EditionFeatures:=GetStringField('e.features');
          EditionComment:=GetStringField('e.comment');
      EditionCost := GetFloatField('e.cost');

      if ((EditionsCount > 1) or (RegReadInteger('ShowEditions', 1) = 1) or (ActiveTab = 5) or (ActiveTab=8)) then begin
        PrevBlockCnt:=-1;
        VideoFileName := GetStringField('e.filename');
        VideoFileCode := GetStringField('e.code');
        VideoFileFolder := VideoFileName;
        while (length(VideoFileFolder)>0) and (pos(VideoFileFolder[length(VideoFileFolder)],'/\')=0) do delete(VideoFileFolder,length(VideoFileFolder),1);
        ed:=ed+Format('<tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]) + '<tr><td colspan="2"><p class="header">';
        if VideoFileName<>'' then
          ed:=ed+'<a href="explore:'+VideoFileName+'">'+format('<img src="%sfolder.png" align="absmiddle"', [ImgPath])+' alt="'+VideoFileName+'" border=0></a>&nbsp;';
        i := GetIntegerField('e.season');
        j := GetIntegerField('e.episode');
        if (i=0) and (GetStringField('m.name') = '') then
          ed:=ed+format(GetLangStr(1260), [ie])+'. ';
        if GetStringField('m.name')<>'' then
          ed:=ed+GetStringField('m.name')+'. ';
        barcode := GetStringField('e.barcode');

        if VideoFileName <> '' then begin
          s := LowerCase(MyExtractFileExt(VideoFileName));
          s2 := PicturesPath + 'FormatIcons\' + s + '.png';
          if not MyFileExists(s2) then
            s2 := ImgPath + 'book32.png';
          ed := ed + format('&nbsp;<a href="playEdition:%s">', [VideoFileCode]) + format('<img src="%s" align="absmiddle"', [s2])+' alt="'+GetLangStr(2964)+'" border="0" width="32" height="32"></a>&nbsp;';
        end;

        //ed:=ed+'<br>';
        if barcode<>'' then
          ed:=ed+GetLangStr(1259)+': '+barcode;

        (*******************Loans **********************)
        if (ActiveTab = 8) then begin
          //media format
          ThisBlockCnt := 0;
          if MediaFormat > 0 then begin
            with sl do begin
              Clear;
              Add('select name from manuals');
              Add(format('where code=%d', [MediaFormat]));
            end;
            RecordCount := ExecuteSQL(sl.text);
            ed := ed + '  ';
            ThisBlockCnt := 1;
            if RecordCount > 0 then
              ed := ed + GetStringField('name');
          end;

          //disc number
          if disc_nom <> '' then begin
            if ThisBlockCnt = 1 then
              ed := ed + ', ';
            ed := ed + format('%s %s', [GetLangStr(20226), disc_nom]);
            ThisBlockCnt := 1;
          end;
          //disc label
          if DiscLabel>0 then begin
              with sl do begin
              Clear;
              Add('select name from manuals');
              Add(format('where code=%d', [DiscLabel]));
              end;
              RecordCount:=ExecuteSQL(sl.text);
              if RecordCount>0 then begin
              if ThisBlockCnt = 1 then
                ed := ed + ', ';
              ed := ed + format('%s: %s', [GetLangStr(1000), GetStringField('name')]);
              end;
          end;
        (*************************End loans***************)
        end;
        ed := ed + '</p></td></tr>';

        all:=all+ed;
      end;


    //editions
    if (ActiveTab = 1) or (ActiveTab = 5) then begin

          ed:='';
      ThisBlockCnt := 0;

      //Tracks
      with sl do begin
        Clear;
        Add('SELECT * FROM tracks');
        Add(Format('WHERE edition=%d AND movie=%d', [EditionCode, MovieCode]));
        Add('ORDER BY sort_order, track_number_int');
      end;
      RecordCount := ExecuteSQL(sl.text);
      if RecordCount>0 then begin
        ed := ed + '<tr><td colspan="2"><p class="header">' + GetLangStr(10337) + '</p></td></tr>';
        ed := ed + '<tr><td colspan="2"><table class="tracks">';
        for i:=1 to RecordCount do begin
          TrackNumberStr := '';
          DurationStr := '';
          if (GetIntegerField('duration') > 0) then begin
            // 29.03.2011 - Fade correct tom Musicnizer format ()
            Seconds := (GetIntegerField('duration') mod 60);
            Hours := GetIntegerField('duration') div 60 div 60;
            Minutes := (GetIntegerField('duration') - Hours * 60 * 60) div 60;
            if (Hours > 0) then
              DurationStr := Format('%d:%0.2d:%.2d', [Hours, Minutes, Seconds])
            else
              DurationStr := Format('%.2d:%.2d', [Minutes, Seconds]);
          end;
          if (GetIntegerField('track_number') > 0) then
            TrackNumberStr := GetStringField('track_number');
          //create a line containing information about the track
          ed := ed + Format('<tr><td style="text-align: right;">%s', [TrackNumberStr]);
          //don't put points if there are not track numbers
          if TrackNumberStr<>'' then
            ed := ed + '.';
          ed := ed + '</td><td>';
          s := GetStringField('title');
          if s = '' then begin
            s :=GetStringField('filename');
            k := Pos('\', s);
            while k>0 do begin
              delete(s, 1, k);
              k := Pos('\', s);
            end;
            k := length(s);
            // 28.02.2012 Fade: AV for empty string
            // while (s[k] <> '.') and (k > 0) do
            while (k > 0) and (s[k] <> '.') do
              k := k - 1;
            if (K > 0) and (s[k] = '.') then
              delete(s, k, length(s) - k + 1);
          end;
          if (GetStringField('filename') <> '') and (RegReadInteger('ShowPlayBtn4Tracks', 0) = 0) then
            ed := ed + Format('<b><a href="playByCode:%s">%s</a></b>', [GetStringField('Code'), s])
          else
            ed := ed + Format('<b>%s</b>', [s]);

          //close
          ed := ed + ' </td>';

          //add duration
          ed := ed + Format('<td>%s</td>', [DurationStr]);

          //track rating
          s := '';
          if (GetIntegerField('rating') > 0) then begin
            s := Format('<img src="%sstar.gif"/>%d', [ImgPath, GetIntegerField('rating')]);
          end;
          ed := ed + Format('<td>%s</td>', [s]);

          //link to audio file
          if RegReadInteger('ShowPlayBtn4Tracks', 0) = 1 then begin
            s := GetStringField('filename');
            if s<>'' then
              ed:=ed+format('<td><a href="playByCode:%s">', [GetStringField('Code')])+format('<img src="%splay.png" align="absmiddle" border="0" alt="%s"></a></td>', [ImgPath, s]);
          end;
          ed := ed + '</tr>';
          GetNextRecord;
        end;
        ed := ed + '</table></td></tr>';
        //ed := ed + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
      end;

          //audio tracks
          with sl do begin
            Clear;
            Add('select m.code, m.name from editions_manuals em');
            Add('join manuals m on m.code=em.ref_code');
            Add(format('where em.edition=%d and m.reference=7', [EditionCode]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if RecordCount>0 then begin
            //Audio tracks
        ThisBlockCnt := ThisBlockCnt + 1;
            all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">', [GetLangStr(20225)]);
            for i:=1 to RecordCount do begin
              all:=all+format('<a href="audio_track:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);

              GetNextRecord;
            end;
            all:=copy(all, 1, length(all)-2);
        all := all + '</p></td></tr>';
          end;

          //parameters
      ThisBlockCnt := 0;
          with sl do begin
            Clear;
            Add('select name, reference from manuals');
            Add(format('where code in (%d, %d, %d, %d, %d)', [VideoStandard, ScreenRatio, resolution, VideoCodec, MediaFormat]));
            Add('order by reference');
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if (RecordCount>0) and (EditionsCount = 1) then begin
  //			if (PrevBlockCnt=0) or (PrevBlockCnt>2) then
  //				all:=all+Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
          end;
          for i:=1 to RecordCount do begin
            if GetIntegerField('reference')=1 then begin
              //Video standard
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(201), GetStringField('name')]);
          ThisBlockCnt := ThisBlockCnt + 1;
        end
            else if GetIntegerField('reference')=2 then begin
              //media format
              //all:=all+GetLangStr(249)+': '+format('<a href="aspect_ratio:%d">%s</a>, ', [ScreenRatio, GetStringField('name')])
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="media_format:%d">%s</a></p></td></tr>', [GetLangStr(20220), MediaFormat, GetStringField('name')]);
        ThisBlockCnt := ThisBlockCnt + 1;
        end
            else if GetIntegerField('reference')=4 then begin
              //screen ratio
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="aspect_ratio:%d">%s</a></p></td></tr>', [GetLangStr(20222), ScreenRatio, GetStringField('name')]);
        ThisBlockCnt := ThisBlockCnt + 1;
        end

            else if GetIntegerField('reference')=5 then begin
              //resolution
              //all:=all+GetLangStr(203)+': '+GetStringField('name')+', '
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="resolution:%d">%s</a></p></td></tr>', [GetLangStr(20223), resolution, GetStringField('name')]);
        ThisBlockCnt := ThisBlockCnt + 1;
        end

            else if GetIntegerField('reference')=19 then begin
              //video codec
              all:=all+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="video_codec:%d">%s</a></p></td></tr>', [GetLangStr(571), VideoCodec, GetStringField('name')]);
          ThisBlockCnt := ThisBlockCnt + 1;
        end;
            GetNextRecord;
          end;

          s2:='';
          //video bitrate
          if VideoBitrate>0 then begin
            s2:=format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%d</p></td></tr>', [GetLangStr(630), VideoBitrate]);
        ThisBlockCnt := ThisBlockCnt + 1;
      end;
          //filesize
          if filesize>0 then begin
            s2:=s2+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%d</p></td></tr>', [GetLangStr(20249), filesize]);
        ThisBlockCnt := ThisBlockCnt + 1;
      end;

      //duration
      if (duration>0) then begin
        s2:=s2+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%d', [GetLangStr(20219), duration]);
        s2:=s2+'</p></td></tr>';
        ThisBlockCnt := ThisBlockCnt + 1;
      end;

      //Cost
      if EditionCost>0 then begin
        ed:=ed+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%f</p></td></tr>', [GetLangStr(3350), EditionCost]);
        ThisBlockCnt := ThisBlockCnt + 1;
      end;

      //circulation
      if (circulation>0) then begin
        s2 := s2 + format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%d', [GetLangStr(20248), Circulation]);
        s2:=s2+'</p></td></tr>';
        ThisBlockCnt := ThisBlockCnt + 1;
      end;

          all:=all+s2;

          //disc #
      if (ActiveTab = 1) then begin
        if disc_nom<>'' then begin
          ed:=ed+Format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(20226), disc_nom]);
          ThisBlockCnt := ThisBlockCnt + 1;
        end;
        //disc label
        if DiscLabel>0 then begin
          with sl do begin
          Clear;
          Add('select name from manuals');
          Add(format('where code=%d', [DiscLabel]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if RecordCount>0 then begin
          ThisBlockCnt := ThisBlockCnt + 1;
          ed:=ed+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border"><a href="disc_label:%d">%s</a></p></td></tr>', [GetLangStr(1000), DiscLabel, GetStringField('name')]);
          end;
        end;

        //loans
        border:='';
        with sl do begin
          Clear;
          Add('select l.location, m.name from loans l');
          Add('inner join manuals m on m.code=l.location');
          Add(format('where edition=%d', [EditionCode]));
          Add('and (return_date='''' or return_date is null)');
          Add('order by loan_date desc');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        if RecordCount>0 then begin
          ThisBlockCnt := ThisBlockCnt + 1;
          if ThisBlockCnt>2 then
            border := 'without-';
          ed:=ed+Format('<tr><td class="field-names"><p class="%sborder">', [border])+GetLangStr(178)+format('</p></td><td class="field-values"><p class="%sborder"><a href="location:%d">%s</a></p></td></tr>', [border, GetIntegerField('l.location'), GetStringField('m.name')]);
        end;

        if (ed<>'') then begin
          if (PrevBlockCnt=0) or (PrevBlockCnt>2) then
            all:=all+Format('<tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
          PrevBlockCnt := PrevBlockCnt + ThisBlockCnt;
          all := all + ed;
        end;
      end;

          //subtitles
          with sl do begin
            Clear;
            Add('select m.code, m.name from editions_manuals em');
            Add('join manuals m on m.code=em.ref_code');
            Add(format('where em.edition=%d and m.reference=6', [EditionCode]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
          if RecordCount>0 then begin
            //Subtitles
        ThisBlockCnt := ThisBlockCnt + 1;
            all:=all+Format('<tr><td class="field-names"><p class="without-border">%s</p></td><td class="field-values"><p class="without-border">', [GetLangStr(20225)]);
            for i:=1 to RecordCount do begin
              //all:=all+GetStringField('m.name')+', ';
              all:=all+format('<a href="subtitle:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
              GetNextRecord;
            end;
            all:=copy(all, 1, length(all)-2);
        all := all + '</p></td></tr>';
          end;
      //show filename
      if (RegReadInteger('ShowFileNames', 0) = 1) and (VideoFileName<>'') then begin
        all := all + Format('<tr><td class="field-names"><p class="without-border">%s</p></td><td class="field-values"><p class="without-border">', [GetLangStr(195)]);
        s := VideoFileName;
        if Length(s) > MaxFilenameLength then
          s := copy(s, 1, 3) + '[...]' + copy(s, length(s) - MaxFilenameLength + 8, MaxFilenameLength);
        all := all + Format('<a href="play:%s">%s</a></p></td></tr>', [VideoFileName, s]);
      end;
      // DVD Features
      if EditionFeatures<>'' then begin
  //			all := all + Format('<tr><td class="free-space" colspan="2"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
        all := all + '<tr><td colspan="2"><p class="header">' + GetLangStr(20229) + '</p></td></tr>';
        all := all + '<tr><td colspan="2"><p class="description">' + EditionFeatures + '</p></td></tr>';
        PrevBlockCnt := 0;
      end;

      //Edition comments
      if EditionComment<>'' then begin
  //			all := all + Format('<tr><td class="free-space" colspan="2"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
        all := all + '<tr><td colspan="2"><p class="description">' + EditionComment + '</p></td></tr>';
        PrevBlockCnt := 0;
      end;

      end;
    end; //editions
    end;
    if (ActiveTab = 1) then begin
      //dates
      s:='';
      PrevBlockCnt := PrevBlockCnt + ThisBlockCnt;
      if DateAdd<>'' then
        s:=s+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(670), SQLDate2Str(DateAdd)]);
      if DateUpdate<>'' then
        s:=s+format('<tr><td class="field-names"><p class="border">%s</p></td><td class="field-values"><p class="border">%s</p></td></tr>', [GetLangStr(671), SQLDate2Str(DateUpdate)]);
      if DateSeen<>'' then
        s:=s+format('<tr><td class="field-names"><p class="without-border">%s</p></td><td class="field-values"><p class="without-border">%s</p></td></tr>', [GetLangStr(20267), SQLDate2Str(DateSeen)]);
      if (s<>'') then begin
        if (PrevBlockCnt = 0) or (PrevBlockCnt > 2) then
          all := all + Format('<tr><td class="free-space" colspan="2"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
        all:=all+copy(s, 1, length(s)+1);
      end;

      all := all + '</table></td></tr>';


      //salary
      cust := '';
      if salary<>'' then
        cust:=cust+'<tr><td><p class="description">'+salary+'</p></td></tr>';

      if cust<>'' then
        all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td>&nbsp;</td></tr>', [WhiteBarFile]);
      all := all + cust;


      //comments
      cust := '';
      if comment<>'' then begin
        if not FullComments and (length(comment)>DescriptionLength) then begin
          comment:=copy(comment, 1, DescriptionLength);
          comment:=comment+format(GetLangStr(1250), [MovieCode]);
        end;
        cust:=cust+'<tr><td><p class="description">'+comment+'</p></td></tr>';
      end;

      if cust<>'' then
        all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td>&nbsp;</td></tr>', [WhiteBarFile]);
      all := all + cust;
    end;

    cust := '';

    //awards
    if (ActiveTab = 1) then begin
      if awards<>'' then
        cust:=cust+'<tr><td><p class="description">'+awards+'</p></td></tr>';

      if cust<>'' then
        all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
      all := all + cust;
    end;


    all := all + '</table>' + GetPatternBottom;

    sl.Free;
    result:=all;
  finally
    ResetRegistrySubKey();
  end;
end;


begin

end.
