﻿program modern_program_part9;

uses 'modern_program_variables.pas';

procedure FillScriptOptionsMovies(AForm: TForm; APageControl: TPageControl;
  var ASaveButtonCallback: Pointer; var ADefaultButtonCallback: Pointer);
var
	s: string;
	sl: TStringList;
	b, btnDefault: TButton;
	edPopularGenres: TEdit;
	labPopularGenres: TLabel;
	edLinesMovies: TEdit;
	labLinesMovies: TLabel;
	edLinesPeople: TEdit;
	labLinesPeople: TLabel;
	edShots: TEdit;
	labShots: TLabel;
	edPhotos: TEdit;
	labPhotos, labRemoveAdult: TLabel;
	boxUseRating: TCheckBox;
	boxUseSiteRating: TCheckBox;
	boxUseLastUpdated: TCheckBox;
	boxShowEditions: TCheckBox;
	boxDummyCovers: TCheckBox;
	boxShowCoversInList: TCheckBox;
	boxHideNavi, boxHidePhotosCovers, boxShowFileNames: TCheckBox;
	boxShowAwards, boxShowSeasons, boxMinimaList, boxPersonStatsInCollection: TCheckBox;
	boxShotTab, boxPosterTab, boxAwardsTab, boxActorTab, boxParameterTab, boxLoanTab, boxSeasonTab, boxDescriptionTab, boxTrailerTab: TCheckBox;
	tabGroup, multiThumbGroup, filmographyGroup, RatingInListGroup: TGroupBox;
	labMaxCoverSize, labCoverX, labThumbCellSize, labThumbCellX, labMaxPhotoSize, labThPhotoCellSize, labPhotoX, labThPhotoCellX, labThumbSize: TLabel;
	edThCoverWidth, edThCoverHeight, edThumbCellWidth, edThumbCellHeight, edThPhotoWidth, edThPhotoHeight, edThPhotoCellWidth, edThPhotoCellHeight, edThumbSize: TEdit;
	boxCutThumb, boxCutPhotoThumb, boxUseThumbs: TCheckBox;
	my_value: Integer;
	boxOnlyMoviesInCollection, boxShowInCollectionIcon, boxShowSeenIcon, boxShowWantedIcon, boxShowForSaleIcon, boxIconsOnTheRight, boxSortIcons, boxOnlyShots: TCheckBox;
	boxShowCurrentRatingInList, boxShowIMDBRatingInList, boxShowKinopoiskRatingInList, boxShowAllActors, boxShowDiscNrInList: TCheckBox;

  f: TTabSheet;
  pageOptions: TPageControl;
  ThumbsSizeChanged, Thumbs2SizeChanged: Boolean;

procedure RemoveAdultClick(Sender: TLabel);
begin
	sl := TStringList.Create;
	with sl do begin
		Clear;
		Add('DELETE FROM partners');
		Add('WHERE url=''http://www.adultdvdempire.com/''');
	end;
	ExecuteSQL(sl.text);
	sl.Free;
	TLabel(Sender).Caption := GetLangStr(1460);
end;

function ProgramType(): Integer;
begin
  Result := MOVIENIZER_PROGRAM;
end;

procedure BtnDefaultClick(Sender: TButton);
begin
	ThumbsSizeChanged := True;
	Thumbs2SizeChanged := True;
	edPopularGenres.Text := '6';
	edShots.Text := '3';
	edPhotos.Text := '3';
	edThCoverWidth.Text := IntToStr(DefaultMultiCoverWidth[ProgramType]);
	edThCoverHeight.Text := IntToStr(DefaultMultiCoverHeight[ProgramType]);
	edThumbCellWidth.Text := IntToStr(DefaultMultiCellWidth[ProgramType]);
	edThumbCellHeight.Text := IntToStr(DefaultMultiCellHeight[ProgramType]);
	boxCutThumb.Checked := True;
	edThPhotoWidth.Text := IntToStr(DefaultMultiCoverWidth[ProgramType]);
	edThPhotoHeight.Text := IntToStr(DefaultMultiCoverHeight[ProgramType]);
	edThumbSize.Text := IntToStr(DefaultThumbWidth);
	boxCutPhotoThumb.Checked := True;
	boxUseRating.Checked := True;
	boxUseSiteRating.Checked := True;
	boxUseLastUpdated.Checked := False;
	boxShowEditions.Checked := False;
	boxDummyCovers.Checked := True;
	boxOnlyMoviesInCollection.Checked := False;
	boxHidePhotosCovers.Checked := False;
	boxShowFileNames.Checked := True;
	boxShowAwards.Checked := False;
	boxShowSeasons.Checked := False;
	boxShowCoversInList.Checked := True;
	boxMinimaList.Checked := False;
	boxPersonStatsInCollection.Checked := False;
	boxHideNavi.Checked := False;
	boxShotTab.Checked := True;
	boxPosterTab.Checked := True;
	boxAwardsTab.Checked := True;
	boxActorTab.Checked := True;
	boxParameterTab.Checked := True;
	boxLoanTab.Checked := False;
	boxSeasonTab.Checked := True;
	boxTrailerTab.Checked := True;
	boxDescriptionTab.Checked := False;
	boxUseThumbs.Checked := True;
	boxIconsOnTheRight.Checked := False;
	boxShowInCollectionIcon.Checked := True;
	boxShowSeenIcon.Checked := False;
	boxShowWantedIcon.Checked := False;
	boxShowForSaleIcon.Checked := False;
	boxSortIcons.Checked := False;
	boxOnlyShots.Checked := True;
	boxShowCurrentRatingInList.Checked := True;
	boxShowIMDBRatingInList.Checked := False;
	boxShowKinopoiskRatingInList.Checked := False;
	boxShowAllActors.Checked := False;
	boxShowDiscNrInList.Checked := False;
end;

procedure ThumbsChanged(Sender: TObject; var Key: Word);
begin
	ThumbsSizeChanged := True;
end;

procedure Thumbs2Changed(Sender: TObject; var Key: Word);
begin
	Thumbs2SizeChanged := True;
end;

procedure ButtonClick(Sender: TButton);
var
	zn: integer;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    try
      zn:=StrToInt(edPopularGenres.Text);
      RegWriteInteger('PopularGenresAmount', zn);
      zn:=StrToInt(edLinesMovies.Text);
      RegWriteInteger('LinesMovies', zn);
      zn:=StrToInt(edLinesPeople.Text);
      RegWriteInteger('LinesPeople', zn);
      zn:=StrToInt(edShots.Text);
      RegWriteInteger('ShotsCnt', zn);
      zn:=StrToInt(edPhotos.Text);
      RegWriteInteger('PhotosCnt', zn);
      zn:=StrToInt(edThCoverWidth.Text);
      RegWriteInteger('ThCoverWidth', zn);
      zn:=StrToInt(edThCoverHeight.Text);
      RegWriteInteger('ThCoverHeight', zn);
      zn:=StrToInt(edThumbCellWidth.Text);
      RegWriteInteger('ThumbCellWidth', zn);
      zn:=StrToInt(edThumbCellHeight.Text);
      RegWriteInteger('ThumbCellHeight', zn);
      zn:=StrToInt(edThPhotoWidth.Text);
      RegWriteInteger('ThPhotoWidth', zn);
      zn:=StrToInt(edThPhotoHeight.Text);
      RegWriteInteger('ThPhotoHeight', zn);
      zn:=StrToInt(edThumbSize.Text);
      RegWriteInteger('ThumbWidth', zn);
      if boxUseRating.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowRating', zn);
      if boxUseSiteRating.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowSiteRating', zn);
      if boxUseLastUpdated.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowLastUpdated', zn);
      if boxShowEditions.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowEditions', zn);
      if boxDummyCovers.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowDummyCoversNew', zn);
      if boxShowCoversInList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowCoversInList', zn);
      if boxOnlyMoviesInCollection.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowOnlyMoviesInCollection', zn);
      if boxHideNavi.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HideNavigationMenu', zn);
      if boxHidePhotosCovers.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HidePhotosCovers', zn);
      if boxShowFileNames.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowFileNames', zn);
      if boxShowAwards.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowAwardsOnGeneralTab', zn);
      if boxShowSeasons.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowSeasonsOnGeneralTab', zn);
      if boxMinimaList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('MinimaList', zn);
      if boxPersonStatsInCollection.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('PersonStatsInCollection', zn);
      if boxShotTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowShotTab', zn);
      if boxPosterTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowPosterTab', zn);
      if boxAwardsTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowAwardsTab', zn);
      if boxActorTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowActorTab', zn);
      if boxDescriptionTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowDescriptionTab', zn);
      if boxParameterTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowParameterTab', zn);
      if boxLoanTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowLoanTab', zn);
      if boxSeasonTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowSeasonTab', zn);
      if boxTrailerTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowTrailerTab', zn);
      if boxCutThumb.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('CutThumb', zn);
      if boxCutPhotoThumb.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('CutPhotoThumb', zn);
      if boxUseThumbs.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('UseThumbs', zn);
      if boxIconsOnTheRight.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('IconsOnTheRight', zn);
      if boxShowInCollectionIcon.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowInCollectionIcon', zn);
      if boxShowSeenIcon.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowSeenIcon', zn);
      if boxShowWantedIcon.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowWantedIcon', zn);
      if boxShowForSaleIcon.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowForSaleIcon', zn);
      if boxSortIcons.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('SortIcons', zn);
      if boxOnlyShots.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('OnlyShots', zn);
      if boxShowCurrentRatingInList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowCurrentRatingInList', zn);
      if boxShowIMDBRatingInList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowIMDBRatingInList', zn);
      if boxShowKinopoiskRatingInList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowKinopoiskRatingInList', zn);
      if boxShowAllActors.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowAllActors', zn);
      if boxShowDiscNrInList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowDiscNrInList', zn);

      RegWriteString('OriginalVersion', IntToStr(56));
      s:=GetLangStr(1334);
    except
    end;

    MultiShowRowHeight[ProgramType] := RegReadInteger('ThumbCellHeight',
      DefaultMultiCellHeight[ProgramType]);
    MultiShowImageWidth[ProgramType] := RegReadInteger('ThumbCellWidth',
      DefaultMultiCellWidth[ProgramType]);


    if Thumbs2SizeChanged then begin
      if ThumbsSizeChanged then
        ClearThumb(Thumbs2)
      else
        ClearThumb(Thumbs2, True);
    end;
    if ThumbsSizeChanged then begin
      ClearThumb(Thumbs, True);
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    s:=GetLangStr(1335);
    pageOptions := APageControl;

    f := TTabSheet.Create(pageOptions);
    f.Caption := GetLangStr(42);
    f.Parent := pageOptions;
    f.PageControl := pageOptions;
    // f.Align := alClient;

    ThumbsSizeChanged := False;
    Thumbs2SizeChanged := False;

    labPopularGenres := TLabel.Create(f);
    labPopularGenres.Name := 'labPopularGenres';
    labPopularGenres.Parent := f;
    labPopularGenres.SetBounds(10, 20, 110, 25);
    labPopularGenres.Caption := GetLangStr(1300);

    edPopularGenres := TEdit.Create(f);
    edPopularGenres.Name := 'edPopularGenres';
    edPopularGenres.Parent := f;
    edPopularGenres.SetBounds(300, 20, 20, 25);
    edPopularGenres.Text := IntToStr(RegReadInteger('PopularGenresAmount', 6));

    labLinesMovies:=TLabel.Create(f);
    labLinesMovies.Name := 'labLinesMovies';
    labLinesMovies.Parent := f;
    labLinesMovies.SetBounds(10, 45, 110, 25);
    labLinesMovies.Caption := GetLangStr(1414);

    edLinesMovies := TEdit.Create(f);
    edLinesMovies.Name := 'edLinesMovies';
    edLinesMovies.Parent := f;
    edLinesMovies.SetBounds(300, 45, 20, 25);
    edLinesMovies.Text := IntToStr(RegReadInteger('LinesMovies', DefaultLinesMovies));

    labLinesPeople:=TLabel.Create(f);
    labLinesPeople.Name := 'labLinesPeople';
    labLinesPeople.Parent := f;
    labLinesPeople.SetBounds(10, 70, 110, 25);
    labLinesPeople.Caption := GetLangStr(1415);

    edLinesPeople := TEdit.Create(f);
    edLinesPeople.Name := 'edLinesPeople';
    edLinesPeople.Parent := f;
    edLinesPeople.SetBounds(300, 70, 20, 25);
    edLinesPeople.Text := IntToStr(RegReadInteger('LinesPeople', DefaultLinesPeople));

    labShots:=TLabel.Create(f);
    labShots.Name := 'labShots';
    labShots.Parent := f;
    labShots.SetBounds(10, 95, 110, 25);
    labShots.Caption := GetLangStr(1417);

    edShots := TEdit.Create(f);
    edShots.Name := 'edShots';
    edShots.Parent := f;
    edShots.SetBounds(300, 95, 20, 25);
    edShots.Text := IntToStr(RegReadInteger('ShotsCnt', 3));

    labPhotos:=TLabel.Create(f);
    labPhotos.Name := 'labPhotos';
    labPhotos.Parent := f;
    labPhotos.SetBounds(10, 120, 110, 25);
    labPhotos.Caption := GetLangStr(1418);

    edPhotos := TEdit.Create(f);
    edPhotos.Name := 'edPhotos';
    edPhotos.Parent := f;
    edPhotos.SetBounds(300, 120, 20, 25);
    edPhotos.Text := IntToStr(RegReadInteger('PhotosCnt', 3));

    multiThumbGroup := TGroupBox.Create(f);
    multiThumbGroup.Name := 'multiThumbGroup';
    multiThumbGroup.Parent := f;
    multiThumbGroup.SetBounds(330, 10, 360, 170);
    multiThumbGroup.Caption := GetLangStr(1467);

    labMaxCoverSize := TLabel.Create(f);
    labMaxCoverSize.Name := 'labMaxCoverSize';
    labMaxCoverSize.Parent := f;
    labMaxCoverSize.SetBounds(340, 35, 100, 25);
    labMaxCoverSize.Caption := GetLangStr(1468);

    edThCoverWidth := TEdit.Create(f);
    edThCoverWidth.Name := 'edThCoverWidth';
    edThCoverWidth.Parent := f;
    edThCoverWidth.SetBounds(600, 30, 30, 25);
    edThCoverWidth.Text := IntToStr(RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[ProgramType]));

    labCoverX := TLabel.Create(f);
    labCoverX.Name := 'labCoverX';
    labCoverX.Parent := f;
    labCoverX.SetBounds(635, 35, 10, 20);
    labCoverX.Caption := 'X';

    edThCoverHeight := TEdit.Create(f);
    edThCoverHeight.Name := 'edThCoverHeight';
    edThCoverHeight.Parent := f;
    edThCoverHeight.SetBounds(650, 30, 30, 25);
    edThCoverHeight.Text := IntToStr(RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[ProgramType]));

    labThumbCellSize := TLabel.Create(f);
    labThumbCellSize.Name := 'labThumbCellSize';
    labThumbCellSize.Parent := f;
    labThumbCellSize.SetBounds(340, 60, 100, 25);
    labThumbCellSize.Caption := GetLangStr(1469);

    edThumbCellWidth := TEdit.Create(f);
    edThumbCellWidth.Name := 'edThumbCellWidth';
    edThumbCellWidth.Parent := f;
    edThumbCellWidth.SetBounds(600, 55, 30, 25);
    edThumbCellWidth.Text := IntToStr(RegReadInteger('ThumbCellWidth', DefaultMultiCellWidth[ProgramType]));

    labThumbCellX := TLabel.Create(f);
    labThumbCellX.Name := 'labThumbCellX';
    labThumbCellX.Parent := f;
    labThumbCellX.SetBounds(635, 60, 10, 20);
    labThumbCellX.Caption := 'X';

    edThumbCellHeight := TEdit.Create(f);
    edThumbCellHeight.Name := 'edThumbCellHeight';
    edThumbCellHeight.Parent := f;
    edThumbCellHeight.SetBounds(650, 55, 30, 25);
    edThumbCellHeight.Text := IntToStr(RegReadInteger('ThumbCellHeight', DefaultMultiCellHeight[ProgramType]));

    boxCutThumb := TCheckBox.Create(f);
    boxCutThumb.Name := 'boxCutThumb';
    boxCutThumb.Parent := f;
    boxCutThumb.SetBounds(340, 80, 300, 20);
    boxCutThumb.Caption := GetLangStr(1471);
    my_value := RegReadInteger('CutThumb', 1);
    if my_value = 1 then
      boxCutThumb.Checked := True;

    labMaxPhotoSize := TLabel.Create(f);
    labMaxPhotoSize.Name := 'labMaxPhotoSize';
    labMaxPhotoSize.Parent := f;
    labMaxPhotoSize.SetBounds(340, 105, 100, 20);
    labMaxPhotoSize.Caption := GetLangStr(1472);

    edThPhotoWidth := TEdit.Create(f);
    edThPhotoWidth.Name := 'edThPhotoWidth';
    edThPhotoWidth.Parent := f;
    edThPhotoWidth.SetBounds(600, 100, 30, 25);
    edThPhotoWidth.Text := IntToStr(RegReadInteger('ThPhotoWidth', DefaultMultiCoverWidth[ProgramType]));

    labPhotoX := TLabel.Create(f);
    labPhotoX.Name := 'labPhotoX';
    labPhotoX.Parent := f;
    labPhotoX.SetBounds(635, 105, 10, 20);
    labPhotoX.Caption := 'X';

    edThPhotoHeight := TEdit.Create(f);
    edThPhotoHeight.Name := 'edThPhotoHeight';
    edThPhotoHeight.Parent := f;
    edThPhotoHeight.SetBounds(650, 100, 30, 25);
    edThPhotoHeight.Text := IntToStr(RegReadInteger('ThPhotoHeight', DefaultMultiCoverHeight[ProgramType]));

    boxCutPhotoThumb := TCheckBox.Create(f);
    boxCutPhotoThumb.Name := 'boxCutPhotoThumb';
    boxCutPhotoThumb.Parent := f;
    boxCutPhotoThumb.SetBounds(340, 125, 300, 20);
    boxCutPhotoThumb.Caption := GetLangStr(1474);
    my_value := RegReadInteger('CutPhotoThumb', 1);
    if my_value = 1 then
      boxCutPhotoThumb.Checked := True;

    filmographyGroup := TGroupBox.Create(f);
    filmographyGroup.Name := 'filmographyGroup';
    filmographyGroup.Parent := f;
    filmographyGroup.SetBounds(400, 190, 290, 170);
    filmographyGroup.Caption := GetLangStr(1481);

    boxOnlyMoviesInCollection := TCheckBox.Create(f);
    boxOnlyMoviesInCollection.Name := 'boxOnlyMoviesInCollection';
    boxOnlyMoviesInCollection.Parent := f;
    boxOnlyMoviesInCollection.SetBounds(410, 210, 250, 20);
    boxOnlyMoviesInCollection.Caption := GetLangStr(1482);
    my_value := RegReadInteger('ShowOnlyMoviesInCollection', 0);
    if my_value = 1 then
      boxOnlyMoviesInCollection.Checked := True;

    boxShowInCollectionIcon := TCheckBox.Create(f);
    boxShowInCollectionIcon.Name := 'boxShowInCollectionIcon';
    boxShowInCollectionIcon.Parent := f;
    boxShowInCollectionIcon.SetBounds(410, 230, 250, 20);
    boxShowInCollectionIcon.Caption := GetLangStr(1483);
    my_value := RegReadInteger('ShowInCollectionIcon', 1);
    if my_value = 1 then
      boxShowInCollectionIcon.Checked := True;

    boxShowSeenIcon := TCheckBox.Create(f);
    boxShowSeenIcon.Name := 'boxShowSeenIcon';
    boxShowSeenIcon.Parent := f;
    boxShowSeenIcon.SetBounds(410, 250, 250, 20);
    boxShowSeenIcon.Caption := GetLangStr(1484);
    my_value := RegReadInteger('ShowSeenIcon', 0);
    if my_value = 1 then
      boxShowSeenIcon.Checked := True;

    boxShowWantedIcon := TCheckBox.Create(f);
    boxShowWantedIcon.Name := 'boxShowWantedIcon';
    boxShowWantedIcon.Parent := f;
    boxShowWantedIcon.SetBounds(410, 270, 250, 20);
    boxShowWantedIcon.Caption := GetLangStr(1485);
    my_value := RegReadInteger('ShowWantedIcon', 0);
    if my_value = 1 then
      boxShowWantedIcon.Checked := True;

    boxShowForSaleIcon := TCheckBox.Create(f);
    boxShowForSaleIcon.Name := 'boxShowForSaleIcon';
    boxShowForSaleIcon.Parent := f;
    boxShowForSaleIcon.SetBounds(410, 290, 250, 20);
    boxShowForSaleIcon.Caption := GetLangStr(1486);
    my_value := RegReadInteger('ShowForSaleIcon', 0);
    if my_value = 1 then
      boxShowForSaleIcon.Checked := True;

    boxIconsOnTheRight := TCheckBox.Create(f);
    boxIconsOnTheRight.Name := 'boxIconsOnTheRight';
    boxIconsOnTheRight.Parent := f;
    boxIconsOnTheRight.SetBounds(410, 310, 250, 20);
    boxIconsOnTheRight.Caption := GetLangStr(1487);
    my_value := RegReadInteger('IconsOnTheRight', 0);
    if my_value = 1 then
      boxIconsOnTheRight.Checked := True;

    boxSortIcons := TCheckBox.Create(f);
    boxSortIcons.Name := 'boxSortIcons';
    boxSortIcons.Parent := f;
    boxSortIcons.SetBounds(410, 330, 250, 20);
    boxSortIcons.Caption := GetLangStr(1488);
    my_value := RegReadInteger('SortIcons', 0);
    if my_value = 1 then
      boxSortIcons.Checked := True;

    boxUseThumbs := TCheckBox.Create(f);
    boxUseThumbs.Name := 'boxUseThumbs';
    boxUseThumbs.Parent := f;
    boxUseThumbs.SetBounds(10, 530, 300, 20);
    boxUseThumbs.Caption := GetLangStr(1476);
    my_value := RegReadInteger('UseThumbs', 1);
    if my_value = 1 then
      boxUseThumbs.Checked := True;

    boxUseRating := TCheckBox.Create(f);
    boxUseRating.Name := 'boxUseRating';
    boxUseRating.Parent := f;
    boxUseRating.SetBounds(10, 140, 300, 20);
    boxUseRating.Caption := GetLangStr(1420);
    my_value := RegReadInteger('ShowRating', 1);
    if my_value=1 then
      boxUseRating.Checked := True;

    boxUseSiteRating := TCheckBox.Create(f);
    boxUseSiteRating.Name := 'boxUseSiteRating';
    boxUseSiteRating.Parent := f;
    boxUseSiteRating.SetBounds(10, 160, 300, 20);
    boxUseSiteRating.Caption := GetLangStr(1533);
    my_value := RegReadInteger('ShowSiteRating', 1);
    if my_value=1 then
      boxUseSiteRating.Checked := True;

    boxUseLastUpdated := TCheckBox.Create(f);
    boxUseLastUpdated.Name := 'boxUseLastUpdated';
    boxUseLastUpdated.Parent := f;
    boxUseLastUpdated.SetBounds(10, 180, 350, 20);
    boxUseLastUpdated.Caption := GetLangStr(1423);
    my_value := RegReadInteger('ShowLastUpdated', 0);
    if my_value=1 then
      boxUseLastUpdated.Checked := True;

    boxShowEditions := TCheckBox.Create(f);
    boxShowEditions.Name := 'boxShowEditions';
    boxShowEditions.Parent := f;
    boxShowEditions.SetBounds(10, 200, 350, 20);
    boxShowEditions.Caption := GetLangStr(1424);
    my_value := RegReadInteger('ShowEditions', 0);
    if my_value=1 then
      boxShowEditions.Checked := True;

    boxDummyCovers := TCheckBox.Create(f);
    boxDummyCovers.Name := 'boxDummyCovers';
    boxDummyCovers.Parent := f;
    boxDummyCovers.SetBounds(10, 220, 350, 20);
    boxDummyCovers.Caption := GetLangStr(1426);
    my_value := RegReadInteger('ShowDummyCoversNew', 1);
    if my_value=1 then
      boxDummyCovers.Checked := True;


    boxHidePhotosCovers := TCheckBox.Create(f);
    boxHidePhotosCovers.Name := 'boxHidePhotosCovers';
    boxHidePhotosCovers.Parent := f;
    boxHidePhotosCovers.SetBounds(10, 240, 380, 20);
    boxHidePhotosCovers.Caption := GetLangStr(1431);
    my_value := RegReadInteger('HidePhotosCovers', 0);
    if my_value=1 then
      boxHidePhotosCovers.Checked := True;

    boxShowFileNames := TCheckBox.Create(f);
    boxShowFileNames.Name := 'boxShowFileNames';
    boxShowFileNames.Parent := f;
    boxShowFileNames.SetBounds(10, 260, 350, 20);
    boxShowFileNames.Caption := GetLangStr(1432);
    my_value := RegReadInteger('ShowFileNames', 1);
    if my_value=1 then
      boxShowFileNames.Checked := True;

    boxShowAwards := TCheckBox.Create(f);
    boxShowAwards.Name := 'boxShowAwards';
    boxShowAwards.Parent := f;
    boxShowAwards.SetBounds(10, 280, 350, 20);
    boxShowAwards.Caption := GetLangStr(1433);
    my_value := RegReadInteger('ShowAwardsOnGeneralTab', 0);
    if my_value=1 then
      boxShowAwards.Checked := True;

    boxShowSeasons := TCheckBox.Create(f);
    boxShowSeasons.Name := 'boxShowSeasons';
    boxShowSeasons.Parent := f;
    boxShowSeasons.SetBounds(10, 300, 350, 20);
    boxShowSeasons.Caption := GetLangStr(1434);
    my_value := RegReadInteger('ShowSeasonsOnGeneralTab', 0);
    if my_value=1 then
      boxShowSeasons.Checked := True;

    boxShowCoversInList := TCheckBox.Create(f);
    boxShowCoversInList.Name := 'boxShowCoversInList';
    boxShowCoversInList.Parent := f;
    boxShowCoversInList.SetBounds(10, 320, 350, 20);
    boxShowCoversInList.Caption := GetLangStr(1427);
    my_value := RegReadInteger('ShowCoversInList', 1);
    if my_value=1 then
      boxShowCoversInList.Checked := True;

    boxMinimaList := TCheckBox.Create(f);
    boxMinimaList.Name := 'boxMinimaList';
    boxMinimaList.Parent := f;
    boxMinimaList.SetBounds(10, 340, 350, 20);
    boxMinimaList.Caption := GetLangStr(1436);
    my_value := RegReadInteger('MinimaList', 0);
    if my_value=1 then
      boxMinimaList.Checked := True;

    boxPersonStatsInCollection := TCheckBox.Create(f);
    boxPersonStatsInCollection.Name := 'boxPersonStatsInCollection';
    boxPersonStatsInCollection.Parent := f;
    boxPersonStatsInCollection.SetBounds(10, 360, 350, 20);
    boxPersonStatsInCollection.Caption := GetLangStr(1451);
    my_value := RegReadInteger('PersonStatsInCollection', 0);
    if my_value=1 then
      boxPersonStatsInCollection.Checked := True;

    boxShowAllActors := TCheckBox.Create(f);
    boxShowAllActors.Name := 'boxShowAllActors';
    boxShowAllActors.Parent := f;
    boxShowAllActors.SetBounds(10, 380, 350, 20);
    boxShowAllActors.Caption := GetLangStr(2999);
    my_value := RegReadInteger('ShowAllActors', 0);
    if my_value=1 then
      boxShowAllActors.Checked := True;

    boxHideNavi := TCheckBox.Create(f);
    boxHideNavi.Name := 'boxHideNavi';
    boxHideNavi.Parent := f;
    boxHideNavi.SetBounds(10, 400, 330, 20);
    boxHideNavi.Caption := GetLangStr(1430);
    my_value := RegReadInteger('HideNavigationMenu', 0);
    if my_value=1 then
      boxHideNavi.Checked := True;

    tabGroup := TGroupBox.Create(f);
    tabGroup.Name := 'tabGroup';
    tabGroup.Parent := f;
    tabGroup.SetBounds(10, 420, 500, 90);
    tabGroup.Caption := GetLangStr(1457);

    boxShotTab := TCheckBox.Create(f);
    boxShotTab.Name := 'boxShotTab';
    boxShotTab.Parent := f;
    boxShotTab.SetBounds(20, 440, 150, 20);
    boxShotTab.Caption := GetLangStr(1429);
    my_value := RegReadInteger('ShowShotTab', 1);
    if my_value=1 then
      boxShotTab.Checked := True;

    boxPosterTab := TCheckBox.Create(f);
    boxPosterTab.Name := 'boxPosterTab';
    boxPosterTab.Parent := f;
    boxPosterTab.SetBounds(20, 460, 150, 20);
    boxPosterTab.Caption := GetLangStr(1425);
    my_value := RegReadInteger('ShowPosterTab', 1);
    if my_value=1 then
      boxPosterTab.Checked := True;

    boxAwardsTab := TCheckBox.Create(f);
    boxAwardsTab.Name := 'boxAwardsTab';
    boxAwardsTab.Parent := f;
    boxAwardsTab.SetBounds(20, 480, 150, 20);
    boxAwardsTab.Caption := GetLangStr(574);
    my_value := RegReadInteger('ShowAwardsTab', 1);
    if my_value=1 then
      boxAwardsTab.Checked := True;

    boxActorTab := TCheckBox.Create(f);
    boxActorTab.Name := 'boxActorTab';
    boxActorTab.Parent := f;
    boxActorTab.SetBounds(180, 440, 150, 20);
    boxActorTab.Caption := GetLangStr(68);
    my_value := RegReadInteger('ShowActorTab', 1);
    if my_value=1 then
      boxActorTab.Checked := True;

    boxParameterTab := TCheckBox.Create(f);
    boxParameterTab.Name := 'boxParameterTab';
    boxParameterTab.Parent := f;
    boxParameterTab.SetBounds(180, 460, 150, 20);
    boxParameterTab.Caption := GetLangStr(447);
    my_value := RegReadInteger('ShowParameterTab', 1);
    if my_value=1 then
      boxParameterTab.Checked := True;

    boxLoanTab := TCheckBox.Create(f);
    boxLoanTab.Name := 'boxLoanTab';
    boxLoanTab.Parent := f;
    boxLoanTab.SetBounds(180, 480, 150, 20);
    boxLoanTab.Caption := GetLangStr(1440);
    my_value := RegReadInteger('ShowLoanTab', 0);
    if my_value=1 then
      boxLoanTab.Checked := True;

    boxSeasonTab := TCheckBox.Create(f);
    boxSeasonTab.Name := 'boxSeasonTab';
    boxSeasonTab.Parent := f;
    boxSeasonTab.SetBounds(340, 440, 150, 20);
    boxSeasonTab.Caption := GetLangStr(521);
    my_value := RegReadInteger('ShowSeasonTab', 1);
    if my_value=1 then
      boxSeasonTab.Checked := True;

    boxTrailerTab := TCheckBox.Create(f);
    boxTrailerTab.Name := 'boxTrailerTab';
    boxTrailerTab.Parent := f;
    boxTrailerTab.SetBounds(340, 460, 150, 20);
    boxTrailerTab.Caption := GetLangStr(1458);
    my_value := RegReadInteger('ShowTrailerTab', 1);
    if my_value=1 then
      boxTrailerTab.Checked := True;

    boxDescriptionTab := TCheckBox.Create(f);
    boxDescriptionTab.Name := 'boxDescriptionTab';
    boxDescriptionTab.Parent := f;
    boxDescriptionTab.SetBounds(340, 480, 150, 20);
    boxDescriptionTab.Caption := GetLangStr(162);
    my_value := RegReadInteger('ShowDescriptionTab', 0);
    if my_value=1 then
      boxDescriptionTab.Checked := True;

    sl := TStringList.Create;
    with sl do begin
      Clear;
      Add('SELECT * FROM partners');
      Add('WHERE url=''http://www.adultdvdempire.com/''');
    end;
    my_value := ExecuteSQL(sl.text);
    sl.Free;
    if my_value > 0 then begin
      labRemoveAdult := TLabel.Create(f);
      labRemoveAdult.Name := 'labRemoveAdult';
      labRemoveAdult.Parent := f;
      labRemoveAdult.SetBounds(10, 510, 350, 20);
      labRemoveAdult.Caption := GetLangStr(1459);
      labRemoveAdult.Cursor := crHandPoint;
      labRemoveAdult.Font.Color := clHotlight;
      labRemoveAdult.OnClick := @RemoveAdultClick;
    end;

    boxOnlyShots := TCheckBox.Create(f);
    boxOnlyShots.Name := 'boxOnlyShots';
    boxOnlyShots.Parent := f;
    boxOnlyShots.SetBounds(10, 550, 350, 20);
    boxOnlyShots.Caption := GetLangStr(1489);
    my_value := RegReadInteger('OnlyShots', 1);
    if my_value=1 then
      boxOnlyShots.Checked := True;

    labThumbSize := TLabel.Create(f);
    labThumbSize.Name := 'labThumbSize';
    labThumbSize.Parent := f;
    labThumbSize.SetBounds(360, 550, 280, 20);
    labThumbSize.Caption := GetLangStr(1497);

    edThumbSize := TEdit.Create(f);
    edThumbSize.Name := 'edThumbSize';
    edThumbSize.Parent := f;
    edThumbSize.SetBounds(600, 550, 30, 25);
    edThumbSize.Text := IntToStr(RegReadInteger('ThumbWidth', DefaultThumbWidth));

    RatingInListGroup := TGroupBox.Create(f);
    RatingInListGroup.Name := 'RatingInListGroup';
    RatingInListGroup.Parent := f;
    RatingInListGroup.SetBounds(10, 570, 500, 40);
    RatingInListGroup.Caption := GetLangStr(2996);

    boxShowCurrentRatingInList := TCheckBox.Create(f);
    boxShowCurrentRatingInList.Name := 'boxShowCurrentRatingInList';
    boxShowCurrentRatingInList.Parent := f;
    boxShowCurrentRatingInList.SetBounds(20, 585, 150, 20);
    boxShowCurrentRatingInList.Caption := GetLangStr(2997);
    my_value := RegReadInteger('ShowCurrentRatingInList', 1);
    if my_value=1 then
      boxShowCurrentRatingInList.Checked := True;

    boxShowIMDBRatingInList := TCheckBox.Create(f);
    boxShowIMDBRatingInList.Name := 'boxShowIMDBRatingInList';
    boxShowIMDBRatingInList.Parent := f;
    boxShowIMDBRatingInList.SetBounds(180, 585, 150, 20);
    boxShowIMDBRatingInList.Caption := 'IMDb';
    my_value := RegReadInteger('ShowIMDBRatingInList', 0);
    if my_value=1 then
      boxShowIMDBRatingInList.Checked := True;

    boxShowKinopoiskRatingInList := TCheckBox.Create(f);
    boxShowKinopoiskRatingInList.Name := 'boxShowKinopoiskRatingInList';
    boxShowKinopoiskRatingInList.Parent := f;
    boxShowKinopoiskRatingInList.SetBounds(340, 585, 150, 20);
    boxShowKinopoiskRatingInList.Caption := 'КиноПоиск';
    my_value := RegReadInteger('ShowKinopoiskRatingInList', 0);
    if my_value=1 then
      boxShowKinopoiskRatingInList.Checked := True;

    boxShowDiscNrInList := TCheckBox.Create(f);
    boxShowDiscNrInList.Name := 'boxShowDiscNrInList';
    boxShowDiscNrInList.Parent := f;
    boxShowDiscNrInList.SetBounds(10, 610, 300, 20);
    boxShowDiscNrInList.Caption := GetLangStr(4402);
    my_value := RegReadInteger('ShowDiscNrInList', 0);
    if my_value=1 then
      boxShowDiscNrInList.Checked := True;


    ASaveButtonCallback := @ButtonClick;
    ADefaultButtonCallback := @BtnDefaultClick;
  finally
    ResetRegistrySubKey();
  end;
end;

begin

end.