program modern_program_variables;

const
	DefaultLinesPeople=4;
	DefaultLinesMovies=3;
  DefaultBasicFontSize=11;
  DefaultLineSpacing=2;
  DefaultLitresBlockVisible = False;
  //
  DEFAULT_GENRES=6;

	WholePageBorder=100;
	CoverHeight=140;
	NormalImageBorders=10;

	TabWidth=80;
	SeasonTabWidth=40;
	TabBorders=300;
	ShotWidth=310;

	PhotoHeight=100;
	MainPhotoWidth=140;
	StandardPhotoWidth=74;

	MainCoverWidth=140;
	ScreenshotWidth=150;
	CoverCellWidth=80;
	SmallCoverHeight=120;
	SmallImageBorder=5;
	LeftColumnWidth=275;
	MaxNameLength=12;
	MaxCharacterNameLength=10;
	DefaultThumbWidth=50;
  MaxFilenameLength=80;
	Thumbs='ThumbsModern';
	Thumbs2='Thumbs2';
	ThumbsCovers='ThumbsCovers';
	ThumbsAlbumShots='ThumbsAlbumShots';
	ThumbsAlbumPhotos='ThumbsAlbumPhotos';
	ThumbsHomeAlbums='ThumbsHomeAlbums';
	ThumbsHomeArtists='ThumbsHomeArtists';
	ThumbsMainPhoto='ThumbsMainPhoto';
	ThumbsPhotos='ThumbsPhotos';
	ThumbsArtistAlbums='ThumbsArtistAlbums';
  MaxTitleLength=30;
  ArrowRight=120;
	SupportedFormatImageExtensions=['png', 'gif', 'jpg', 'jpeg'];
	FormatImages='FormatImages\';

  {    ,    .     }
  //   ,       (MOVIENIZER_PROGRAM, MUSICNIZER_PROGRAM, BOOKNIZER_PROGRAM)
	DefaultMultiCoverWidth = [90, 110, 90, 110]; //the width of cover for the coverflow view
	DefaultMultiCoverHeight = [120, 110, 140, 110]; //the height of cover for the coverflow view
	DefaultMultiCellWidth = [100, 120, 100, 120]; //width of the cell for cover in the coverflow mode
	DefaultMultiCellHeight = [165, 140, 185, 140]; //height of the cell for cover in the coverflow mode (cell contains the cover and some text, e.g. title of the movie)
  StandardCoverWidth = [110, 130, 110, 130];

  // New consts for Medianizer
  DefaultHomePageShowMovies = True;
  DefaultHomePageShowAlbums = True;
  DefaultHomePageShowBooks = True;
  DefaultHomePageShowGames = True;
  DefaultHomePageShowSupport = True;

// program dependent consts
var
  DefaultHomeLogo: Integer = 0;
  DefaultHomePageShowPersons: Boolean = False;
  DefaultHomePageShowSnapshots: Boolean = False;

var
  // 22.04.2011 - Fade variables for show images in some rows (multi show)
  MultiShowRowHeight: array [0..3] of Integer;
  // width of the image that will be displayed (with of the column will be MultiShowImageWidth + 2*MiltiShowDistanceBetweenCovers)
  MultiShowImageWidth: array [0..3] of Integer;

  // distance between images on the show area
  MiltiShowDistanceBetweenCovers: Integer;

  CountedPages: integer;
	genre, country, movie, person, title, year, studio, ProgramReference: string;
	InCollection: integer;
	ImgPath, WhiteBarFile, BackgroundMovies, BackgroundPeople: String;
	TempReferenceCode, TempReference, ActiveTab, PersonActiveTab, ProcessedRecords: integer;
	TempText, UnseenEpisodes: string;
	HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab: Integer;

const
  REGISTRY_SUB_KEYS = ['Movies\', 'Music\', 'Books\', 'Games\'];
  NO_COVER_FILE = ['no-cover.gif', 'no-cover-music.gif', 'nocoverbooks.png', 'no-cover-game.jpg'];
  NO_PHOTO_FILE = ['nophoto.gif', 'nophotoartist.gif', 'nophotoauthor.gif', 'nophotocompany.jpg'];

const
  MOVIENIZER_PROGRAM = 0;
  MUSICNIZER_PROGRAM = 1;
  BOOKNIZER_PROGRAM = 2;
  GAMENIZER_PROGRAM = 3;

  ALL_PROGRAM_TYPES = 15;

  // for loops
  LOW_PROGRAM_TYPE = MOVIENIZER_PROGRAM;
  HIGH_PROGRAM_TYPE = GAMENIZER_PROGRAM;

var
  RemainingTabs: string;
  BasicFontSize, ListFontSize, LineSpace: Integer;
  UsedProgramTypes: Integer = ALL_PROGRAM_TYPES;

function GetPatternTop: String;
begin
	Result := Format('<table class="meta"><tr><td class="meta-corner-up-left"><img src="%sug1.gif"></td><td class="meta-top"></td><td class="meta-corner-up-right"><img src="%sug2.gif"></td></tr><tr><td colspan="3"><table class="main"><tr><td class="title-bar" colspan="2"><table class="title-meta"><tr><td class="title-space" colspan="3"></td></tr><tr><td class="top-border" align="center"><img src="%stitle-top-left.gif"></td><td class="middle-border"></td><td class="top-border"><img src="%stitle-top-right.gif"></td></tr><tr><td colspan="3"><table class="top-content"><tr><td class="top-content-middle">', [ImgPath, ImgPath, ImgPath, ImgPath]);
end;

function ClosePatternTop: String;
begin
	result:=Format('</td><td class="title-right-border"></td></tr></table></td></tr><tr><td class="bottom-border" align="center"><img src="%stitle-bottom-left.gif"></td><td class="middle-border"></td><td class="bottom-border"><img src="%stitle-bottom-right.gif"></td></tr><tr><td class="title-space" colspan="3"></td></tr></table></td></tr>', [ImgPath, ImgPath]);
end;

function GetPatternBottom: String;
begin
	Result := Format('</td></tr></table></td></tr><tr><td class="meta-corner-down-left"><img src="%sug4.gif"></td><td class="meta-top"></td><td class="meta-corner-down-right"><img src="%sug3.gif"></td></tr><tr><td class="meta-bottom"></td><td class="meta-bottom-center"></td><td class="meta-bottom"></td></tr></table>', [ImgPath, ImgPath]);
end;

function GetProperPath(s: String): string;
begin
	s := ReplaceStr(s, '(', '%28');
	s := ReplaceStr(s, ')', '%29');
	s := ReplaceStr(s, ' ', '%20');
	result := s;
end;

//make sure that each word of Name is no longer than MaxLength
function TruncateName(Name: String; MaxLength: Integer): String;
var
	i: Integer;
	s: String;
begin
	Result := '';
	i := Pos(' ', Name);
	while i>0 do begin
		s := copy(Name, 1, i-1);
		if Length(s) > MaxLength then begin
			delete(s, MaxLength - 1, Length(s) - MaxLength + 2);
			s := s + '.';
		end;
		Result := Result + s + ' ';
		delete(Name, 1, i);
		i := Pos(' ', Name);
	end;
	if Length(name) > MaxLength then begin
		delete(name, MaxLength - 1, Length(name) - MaxLength + 2);
		name := name + '.';
	end;
	Result := Result + name;
end;

function GetAge(datenow, birthdate: string): string;
var
  YearsBetweenDate: Integer;
	//imanyear, inowyear, iage, imonthdaybirth, imonthdaynow: integer;
	//month, day : string;
begin
	result := '???';

  YearsBetweenDate := YearsBetween(dateNow, birthdate);
  if (YearsBetweenDate) then
    Result := IntToStr(YearsBetweenDate);
	{
	if (length(datenow) = 10) and (length(birthdate) = 10) then begin
		imanyear := StrToInt(copy(birthdate, 7, 4));
		inowyear := StrToInt(copy(datenow, 7, 4));
		iage := inowyear - imanyear;

		month := copy(birthdate, 1, 2);
		day := copy(birthdate, 4, 2);
		imonthdaybirth := StrToInt(month + day);
		month := copy(datenow, 1, 2);
		day := copy(datenow, 4, 2);
		imonthdaynow := StrToInt(month + day);
//ShowMessage(IntToStr(imonthdaybirth) + ' - ' + IntToStr(imonthdaynow));
		if imonthdaybirth > imonthdaynow then
			iage := iage - 1;

		result := IntToStr(iage);

		if iage > 111 then
			result := result + '(wtf?)';

	end;
	}
end;

function RemoveUnicodeCharacters(txt: string): string;
var
	i, txtlen, iPos, iLen, iHasDigit, iHasDotComma: integer;
	oneletter: string;
begin
	iPos := Pos('&#', txt);
//ShowMessage('has unicode = ' + IntToStr(iPos));
	while iPos > 0 do begin
		iHasDigit := 0;
		iHasDotComma := 0;
		iLen := 2;
		txtlen := length(txt);
		for i := (iPos + 2) to txtlen do begin
			oneletter := copy(txt, i, 1);
			if ((CompareText('0', oneletter) <= 0) and (CompareText('9', oneletter) >= 0)) then begin
				iHasDigit := 1;
				iLen := iLen + 1;
//ShowMessage('has digit = ' + oneletter);
			end
			else if oneletter = ';' then begin
				iHasDotComma := 1;
				iLen := iLen + 1;
				i := txtlen + 1;
//ShowMessage('has dotcomma = ' + oneletter);
			end
			else begin
				i := txtlen + 1;
			end;
		end;

		if (iHasDigit = 1) and (iHasDotComma = 1) then begin
			Delete(txt, iPos, iLen);
			Insert('%', txt, iPos);
//ShowMessage(txt);
		end;

		iPos := Pos('&#', txt);
	end;

	result := txt;
end;

function DateIsInThePast(some_date: String): Boolean;
var
	ddd1, ddd2, mmm1, mmm2, yyy1, yyy2: Integer;
	day, month, year: String;
begin
	if (some_date <> '') then begin
		DecodeDate(Date, yyy1, mmm1, ddd1);
		day := copy(some_date, 4, 2);
		month := copy(some_date, 1, 2);
		year := copy(some_date, 7, 4);
		try
			ddd2 := StrToInt(day);
			mmm2 := StrToInt(month);
			yyy2 := StrToInt(year);
		except
			result := False;
			exit;
		end;
		if (ddd2 - ddd1) < 0 then
			mmm2 := mmm2 - 1;
		if (mmm2 - mmm1) < 0 then
			yyy2 := yyy2 - 1;
		if (yyy2 - yyy1) < 0 then
			result := True
		else
			result := False;
	end
	else
		result := False;
end;

function MyPos(ssearch, shost: string; start: integer): integer;
var
	stemp: string;
	newpos: integer;
begin
	stemp:=copy(shost,start,length(shost)-start+1);
	newpos:=pos(ssearch, stemp);
	if (newpos>0) then newpos:=newpos+start-1;
	result:=newpos;
end;

function GetTodaysDate: String;
var
	ddd1, mmm1, yyy1: Integer;
begin
	DecodeDate(Date, yyy1, mmm1, ddd1);
	Result := Format('-%.2d-%.2d', [mmm1, ddd1]);
end;

//remove not closed html tags
function RemoveUnclosedTags(text: string): string;
var
	i, j, k: Integer;
begin
	i := Pos('<', text);
	if i>0 then
		k := i - 1
	else
		k := 0;
	while i > k do begin
		j := MyPos('>', text, i+1);
		if (j<i) then begin
			delete(text, i, length(text)-i+1);
			j := i;
		end;
		k := j;
		i := MyPos('<', text, k + 1);
	end;
	result := text;
end;

function ReplaceStr(SrcStr, SrcVal, DstVal: string): string;
var
	DstStr : string;
	i: integer;
begin
	DstStr:=SrcStr;
	i:=MyPos(SrcVal, SrcStr, 1);
	while (i>0) do begin
		delete(DstStr,i,length(SrcVal));
		insert(DstVal,DstStr,i);
		i:=MyPos(SrcVal, DstStr, i+length(DstVal));
	end;
	result:=DstStr;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  //     s1  s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

//gets the image filename as it is stored in the database
//returns the full path to the image file or to the image thumb
//depending on settings
function GetImageFileName(ImageFile, ThumbsDir, DefaultCover: String;
  ImageWidth, ImageHeight: Integer; ACutPicture: Boolean = False): String;
var
	Filename, ThumbsPath, ThumbsFileName: String;
begin
	Filename := ImagesPath + ImageFile;
	if not MyFileExists(Filename) then
		Filename:=ImgPath+DefaultCover;
	Result := Filename;
	if (RegReadInteger('UseThumbs', 1) = 1) then
  begin
		ThumbsPath := ImagesPath + ThumbsDir + '\';
		ThumbsFileName:=ThumbsPath+ImageFile;
		if not MyFileExists(ImagesPath + ImageFile) then
			ThumbsFileName := ThumbsPath+DefaultCover;
		if GetFileDateTime(ThumbsFileName)<GetFileDateTime(FileName) then
			DeleteFile(ThumbsFileName);
		if not MyFileExists(ThumbsFileName) then
			ConvertThumb3(FileName, ThumbsFileName, ThumbsDir, ImageWidth, ImageHeight, ACutPicture);
		if MyFileExists(ThumbsFileName) then
			result := ThumbsFileName;
	end;
end;


function AddPostfixToURL(AURL: string; APostfix: string): string;
begin
  Result := AURL;
  if (APostfix <> '') then
  begin
    if (Pos(Result, '?') > 0) then
      APostfix := ReplaceStr(APostfix, '?', '&');
    Result := Result + APostfix;
  end;
end;

function IsProgramUsed(AProgramType: Integer): Boolean;
var
  SettedBit: Integer;
begin
  SettedBit := 1 shl AProgramType;
  Result := ((UsedProgramTypes and SettedBit) > 0);
end;

procedure SetUsedProgramTypes(AProgramTypes: Integer);
begin
  // AProgramTypes is set of bits for each media type
  // 0 bit - is for movies
  // 1 bit - is for music
  // 2 bit - is for Books
  // For example value 5 means two media types: movies and books
  UsedProgramTypes := AProgramTypes;
end;

begin
  DefaultHomePageShowPersons := IsLimitedSingleProgram();
  DefaultHomePageShowSnapshots := IsLimitedSingleProgram();
  if (IsLimitedSingleProgram()) then
    DefaultHomeLogo := 1;
end.
