﻿const
	script_name='moviepilot';
	language='German';
	version=21;
	author='Vlad';
	MinProgramBuild=8000;
	PCount = 12;
	//MaxPicturesCount = 3;
var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments, 
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList: boolean;
	MaxShotsCount, MaxPostersCount, MaxTrailersCount, MaxBackdropsCount: integer;
	
	DownloadBigPhoto: Boolean;

	title, MovieName, s, s2, s3, s4, year, director, name, character, BasicURL, country, description, salary, awards: string;
	episodes, movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	i, j: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	rating, imdb_rating: double;
	front_cover_url: string;
	posters_exists, ask_amazon: boolean;
	EpisodesDownloading, PostersDownloading, BackdropsDownloading, ShotsDownloading: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	TrailersURL, ShotsURL, PostersURL, tvdb_code: string;
	DownloadTVDBEpisodeDescriptions, DownloadTVDBEpisodes, DownloadTVDBEnglishDesc, DownloadSeasonPosters, DownloadEpisodeImages, UseTVDBPosters, UseTVDBFanart: integer;
	RequestParameters, EpisodeURLs: TStringList;
	DownloadSeasonsCovers: Boolean;
	DownloadEpisodesCovers: Boolean;
	RefURL: String;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(s1, str);
	if I > 0 then
	begin
		J := MyPos(s2, str, I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;
	
function DeleteBadChars(text: String): String;
var
	i: Integer;
	s : String;
begin
	s := '';
	for i := 1 to Length(text) do begin
		if not (ord(text[i]) in [1..20]) then
			s := s + text[i];
	end;
	Result := s;
end;

function ExtractSearchResults(temp: String): Integer;
var
	i, j, k, l: integer;
	title, tempCode, small_cover, year, director, description, item_type, original_title, s, marker: string;
	isSeries: boolean;
begin
	k := 0;
	i := Pos('<li', temp);
	while i>0 do begin
		j := MyPos('</li>', temp, i + 1);
		tempCode := copy(temp, i, j-i);
		marker := '>Film</div>';
		l := Pos(marker, tempCode);
		if (l = 0) then begin
			marker := '>Serie</div>';
			l := Pos(marker, tempCode);
			isSeries := true;
		end;
		// title
		title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(tempCode, marker, '</div>'))));
		//movie code
		code := GetStr(tempCode, 'href="/movies/', '"');
		if code = '' then begin
			code := GetStr(tempCode, 'href="/serie/', '"');
			if code <> '' then
				code := 'serie/' + code;
		end
		else
			code := 'movies/' + code;
		//movie year
		s := GetStr(tempCode, '|', '|');
		year := ParseString(s, '(\d+)', 1);
		//short description
		description := GetStr(tempCode, '| ', '</div>');
		description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));

		//original title
		original_title := ''; //GetStr(s, '>', year);
		//original_title := ReplaceStr(original_title, #10, '', -1);
		//original_title := ClearExtraBlankCharacters(original_title);
		if (Pos(',', original_title) = length(original_title)) then
			delete(original_title, length(original_title), 1);

		//cover
		small_cover := GetStr(tempCode, ' src="', '"');
		if small_cover = '' then
			small_cover := GetStr(tempCode, 'background-image: url(', ')');
		if Pos('no_poster', small_cover) > 0 then
			small_cover := ''
		else begin
			if (small_cover <> '' ) and (Pos('http://', small_cover) = 0) and (Pos('https://', small_cover) = 0) then
				small_cover := 'http://www.moviepilot.de/' + small_cover;
		end;
		if Pos('trailer', LowerCase(title)) > 0 then
			title := '';
		if (title <> '') and (code <> '') then begin
			k := k + 1;
			
			SetSearchResult2(title, code, year, original_title, description, small_cover);
		end;
		delete(temp, 1, i);
		i := Pos('<li', temp);
	end;
	result := k;
end;

function MovieSearch: integer;
var
	i, j, k, l: integer;
	temp, remaining: string;
begin
	s:='';
	result:=0;
	//check what comes first - series or movies
	i := Pos('<h2>Filme', all);
	k := Pos('<h2>Serien', all);
	if (k < i) and (k > 0) then begin
		i := k;
		remaining := '<h2>Filme';
	end
	else
		remaining := '<h2>Serien';
	if (i = 0) then
		i := Pos('<h1', all);
	if i>0 then begin
		delete(all, 1, i);
		j := Pos('</ul>', all);
		temp := copy(all, 1, j-1);
		result := result + ExtractSearchResults(temp);
	end;
	k := Pos(remaining, all);
	if k>0 then begin
		delete(all, 1, k);
		j := Pos('</ul>', all);
		temp := copy(all, 1, j-1);
		result := result + ExtractSearchResults(temp);
	end;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
	MovieName := EncodeURL(MovieName, 'utf-8');
	url:= 'https://www.moviepilot.de/suche?utf8=%E2%9C%93&q=' + MovieName;
	//url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url, False, nil, 'utf-8');
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
	result:='https://www.moviepilot.de/'+code;
end;


//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
  fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

procedure ExtractPeople(text: String; start, mode: integer);
var
	i, j: Integer;
	temp, s, name, code, character, small_photo: String;
begin
	i := MyPos('<div class=''h3''>', text, start+1);
	if i = 0 then
		i := length(text);
	if i>0 then begin
		temp := copy(text, start, i - start);
		i := Pos('<li', temp);
		while i>0 do begin
			s := GetStr(temp, '<li', '</li>');
			//photo
			small_photo := GetStr(s, ' src="', '"');
			small_photo := ReplaceStr(small_photo, '/fill/48/67', '', -1);
			if DownloadBigPhoto then begin
				small_photo := ReplaceStr(small_photo, '_poster', '', -1);
				small_photo := ReplaceStr(small_photo, '_thumb_square', '', -1);
			end
			else begin
				small_photo := ReplaceStr(small_photo, '_poster', '_person', -1);
				small_photo := ReplaceStr(small_photo, '_thumb_square', '_person', -1);
			end;
			if small_photo <> '' then begin
				if Pos('http', small_photo) = 0 then
					small_photo := 'http://www.moviepilot.de' + small_photo;
			end;
			j := Pos('<strong', s);
			if j > 0 then
				delete(s, 1, j);
			character := '';
			if mode = 3 then begin
				character := GetStr(s, '<span class=''role''>', '</span>');
				character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(character)));
			end;
			//name
			name := GetStr(s, '<a ', '</a>');
			code := GetStr(name, ' href="/people/', '"');
			if name <> '' then
				name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + name)));
			if (name <> '') then
				SetPersonName(name, character, mode, code, small_photo);
			delete(temp, 1, i);
			i := Pos('<li', temp);
		end;
	end;
end;

procedure ExtractPeopleFromCastPage(text: String; start, mode: Integer);
var
	i, j: Integer;
	s, name, code: String;
begin
	delete(text, 1, start);
	text := ReplaceStr(text, '<th></th>', '', -1);
	i := Pos('<th>', text);
	delete(text, i, length(text)-i+1);
	i := Pos('<td', text);
	while i > 0 do begin
		s := GetStr(text, '<td', '</td>');
		code := GetStr(s, ' href="/people/', '"');
		name := '';
		j := Pos('<span class="job"', s);
		if j > 0 then
			delete(s, j, length(s) + 1);
		if s <> '' then
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s)));
		if (name <> '') and (Pos('(', name) = 0) then
			SetPersonName(name, '', mode, code);
		delete(text, 1, i);
		i := Pos('<td', text);
	end;
end;

function GetRating(movie_code: String): double;
var
	s, temp, url: string;
	i: Integer;
begin
	rating := 0;
	url := GetMovieSiteURL(movie_code);
	temp := DownloadURL(url, False, nil, 'utf-8');
	s := GetStr(temp, '<div class=''contentcount''>', '</div>');
	s := GetStr(s, 'itemprop=''ratingValue''>', '</');
	s := ClearExtraBlankCharacters(RemoveTags(s));
	i := Pos('.', s);
	if i > 0 then
		s[i] := DecimalSeparator;
	try
		rating := StrToFloat(s);
	except
	end;
	result := rating;
end;

function GetInfo(url: string; images_only: boolean): string;
var 
	keyword, s, s2, s3, s4, plot_outline, shot, shot_prefix, shot_ext, my_url, temp, small_photo, img_url: string;
	i, j, k, l, frames_count, hours, mins, season, episode: integer;
	actors, awards_exist, is_tv_series: boolean;
	cast_url, awards_url, desc_url, episodes_url: String;
	name, code, character, film_info, episodeName, episodeDescription: String;
begin
	result:='';
	is_tv_series := false;
	all := DownloadURL(url, False, nil, 'utf-8');
	if all='-1' then
		result:='-1'
	else
		result:=all;
		
	RefURL := url;
		
	
	movie_code := ParseString(url, 'pilot.de/(.*?)$', 1);
	movie_site_url:=GetMovieSiteURL(movie_code);
	
	title := GetStr(all, '<title>', ' |');
	title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(title)));
	if title='' then
		exit;
	
		
	cast_url := '';
	if (DownloadMovieFullCast) and (Pos('/besetzung', all)>0) then begin
		cast_url := movie_site_url + '/besetzung';
		AddRequestForHTMLPageContent(cast_url, False, '', '', nil, 'utf-8');
	end;
	
	if (DownloadMovieFullCast) and (Pos('/schauspieler', all) > 0) then begin
		cast_url := movie_site_url + '/schauspieler';
		AddRequestForHTMLPageContent(cast_url, False, '', '', nil, 'utf-8');
	end;
		
	ShotsURL := '';
	if (MaxShotsCount > 0) and ((Pos('id=''tab_images', all)>0) or (Pos(movie_code + '/bilder', all) > 0)) then begin
		if Pos('serie/', movie_code) > 0 then
			ShotsURL := movie_site_url + '/bilder'
		else
			ShotsURL := movie_site_url + '/images';
		AddRequestForHTMLPageContent(ShotsURL, False);
	end;
	
	episodes_url := '';
	if (DownloadMovieSeasonsList) and (Pos('/episodenguide', all)>0) then begin
		episodes_url := movie_site_url + '/episodenguide';
		AddRequestForHTMLPageContent(episodes_url, False, '', '', nil, 'utf-8');
		is_tv_series := true;
	end;
	
	PostersURL := '';
		
	TrailersURL := '';
		
	desc_url := '';
	
	//movie details
	film_info := GetStr(all, '<h2 class=''movie--data''>', '</h2>');
	if film_info = '' then
		film_info := GetStr(all, '<h2 class=''title-subline''>', '</h2>');
	
	//original title + year
	original_title := ClearExtraBlankCharacters(DecodeHTML(GetStr(film_info, '<span>', '</span>')));
	
	// tv series logic
	if (original_title = '') then begin
		s := GetStr(all, 'Originaltitel'#10'</dt>', '</dd>');
		original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	end;
	
	film_info := GetStr(all, '<div class=''movie--data', '</div>');
	if is_tv_series then
		film_info := GetStr(all, '<div class=''series--data''>', '</div>');
	year := GetStr(film_info, '/beste/jahr-', '"');
	year := ParseString(year, '(\d+)', 1);
	
	// tv series logic
	if (year = '') then begin
		s := GetStr(all, 'itemprop="copyrightYear">', '<');
		year := ParseString(s, '(\d+)', 1);
	end;
	
	//country
	s := film_info;
	if (s = '') then
		s := GetStr(all, 'Produktionsland', '</dd>');
	if (s <> '') then begin
		i := Pos('/beste/land', s);
		while i > 0 do begin
			s3 := GetStr(s, '/beste/land', '</a>');
			if s3 <> '' then
				SetCountry(ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s3))));
			delete(s, 1, i);
			i := Pos('/beste/land', s);
		end;
	end
	else begin
		s := GetStr(all, '"Produktionsland","content":[', ']');
		i := Pos('"name":"', s);
		while (i > 0) do begin
			s3 := GetStr(s, '"name":"', '"');
			s3 := ClearExtraBlankCharacters(DecodeHTML(s3));
			if (s3 <> '') then
				SetCountry(s3);
			delete(s, 1, i);
			i := Pos('"name":"', s);
		end;
	end;
	
	//duration
	s2 := ParseString(film_info, 'Laufzeit (\d+)', 1);
	if (s2 = '') then
		s2 := ParseString(all, '"runtime":(\d+)', 1);
	if s2 = '' then
		s2 := GetStr(film_info, 'itemprop=''duration''>', '</');
	hours := 0;
	mins := 0;
	try
		mins := StrToInt(s2);
	except;
	end;
	duration := mins;
	
	//MPAA (FSK)
	mpaa := '';
	s := film_info;
	if (s = '') then
		s := GetStr(all, 'Altersfreigabe'#10, '</dd>'); // series logic
	s2 := ParseString(s, 'FSK (\d+)', 1);
	if s2 = '' then
		s2 := GetStr(s, 'itemprop=''contentRating''>', '</');
	if s2 = '' then
		s2 := GetStr(all, 'itemprop="contentRating">FSK ', '</');
	if s2 <> '' then
		mpaa := (*'FSK ' +*) s2;
		
	//genres
	s := film_info;
	if (s = '') then
		s := GetStr(all, 'Genre'#10'</dt>', '</dd>');
	if (s <> '') then begin
		i := Pos('/beste/genre', s);
		while i>0 do begin
			s2 := GetStr(s, '/beste/genre', '</a>');
			if s2 <> '' then begin
				s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)));
				SetGenre(s2);
			end;
			delete(s, 1, i);
			i := Pos('/beste/genre', s);
		end;
	end
	else begin
		s := GetStr(all, '"Genre","content":[', ']');
		i := Pos('"name":"', s);
		while i > 0 do begin
			s2 := GetStr(s, '"name":"', '"');
			SetGenre(s2);
			delete(s, 1, i);
			i := Pos('"name":"', s);
		end;
	end;
	
	//site rating
	rating := 0;
	s := GetStr(all, '<div class=''contentcount''>', '</div>');
	s := GetStr(s, 'itemprop=''ratingValue''>', '</');
	if s = '' then
		s := GetStr(all, 'itemprop="ratingValue">', '</');
	s := ClearExtraBlankCharacters(RemoveTags(s));
	if (s = '') then begin
		s := GetStr(all, 'ratingCount', 'ratingValue');
		s := GetStr(s, 'content=''', '''');
	end;
	i := Pos('.', s);
	if i > 0 then
		s[i] := DecimalSeparator;
	try
		rating := StrToFloat(s);
	except
	end;

	//movie plot
	s := '<b>Handlung von';
	s2 := '</b>';
	if (Pos(s, all) = 0) then begin
		s := '<strong>Handlung von';
		s2 := '</strong>';
	end;
	description := GetStr(all, s, '<div>');
	i := Pos(s2, description);
	if (i > 0) then
		delete(description, 1, i - 1);
	description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));
	if description = '' then begin
		s := GetStr(all, '"description":"', '","');
		s := ReplaceStr(s, '\"', '"', -1);
		s := ReplaceStr(s, '\n', '', -1);
		i := Pos('Handlung von ' + title, s);
		if (i > 0) then
			delete(s, 1, i + length('Handlung von ' + title) - 1);
		description := ClearExtraBlankCharacters(RemoveTags(DecodeHTML(s)));
	end;
	if description = '' then
		description := ClearExtraBlankCharacters(GetStr(all, ' itemprop=''description''>', '</div>'));
	if (description = '') then begin
		description := GetStr(all, 'long-body''>', '</div>');
	end;
	description := ReplaceStr(description, '</p>', #13#10#13#10, -1);
	description := ReplaceStr(description, '<br />', #13#10, -1);
	description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));
	
	//front cover
	front_cover_url := '';
	s := GetStr(all, '<link href="http://www.moviepilot.de/files/images/', '" rel="image_src"');
	if (Pos('no_poster', s) = 0) and (s <> '') then
		front_cover_url := 'http://www.moviepilot.de/files/images/' + s;
	if s = '' then
		front_cover_url := GetStr(all, '<link rel="image_src" href="', '"');
	if front_cover_url = '' then begin
		s := GetStr(all, '<div class=''poster''>', '</div>');
		front_cover_url := GetStr(s, 'src=''', '''');
		front_cover_url := ReplaceStr(front_cover_url, '/limit/160/2000', '', -1);
	end;
	
	//cast and crew
	s := GetStr(all, 'Cast & Crew', 'Filmdetails ');
	if s = '' then
		s := GetStr(all, 'Cast & Crew', '<div class=''forum''>');
	if s = '' then
		s := GetStr(all, 'Cast & Crew', '<hr>');
		
	// TV Series logic
	if (s = '') or (DownloadMovieFullCast) then begin
		temp := GetHTMLPageContentFromRequest(cast_url);
		s := GetStr(temp, '<section>', '</section>');
		i := Pos('Schauspiel'#10'</h2>', s);
		if i > 0 then
			ExtractPeopleForTVSeries(s, i, 3);
		i := Pos('Regie'#10'</h2>', s);
		if i > 0 then
			ExtractPeopleForTVSeries(s, i, 1);
		i := Pos('Drehbuch'#10'</h2>', s);
		if i > 0 then
			ExtractPeopleForTVSeries(s, i, 2);
		i := Pos('Produktion'#10'</h2>', s);
		if i > 0 then
			ExtractPeopleForTVSeries(s, i, 5);
		i := Pos('Musik'#10'</h2>', s);
		if i > 0 then
			ExtractPeopleForTVSeries(s, i, 4);
		i := Pos('Kamera'#10'</h2>', s);
		if i > 0 then
			ExtractPeopleForTVSeries(s, i, 6);
	end
	// end TV Series logic
	// movie cast logic
	else begin
		//directors
		i := Pos('<div class=''h3''>'#10'Regie', s);
		if i = 0 then
			i := Pos('<div class=''h3''>Regie', s);
		if i>0 then
			ExtractPeople(s, i, 1);
		//actors
		i := Pos('<div class=''h3''>'#10'Schauspieler', s);
		if i = 0 then
			i := Pos('<div class=''h3''>Schauspieler', s);
		if i>0 then
			ExtractPeople(s, i, 3);
		//writers
		i := Pos('<div class=''h3''>'#10'Drehbuch', s);
		if i = 0 then
			i := Pos('<div class=''h3''>Drehbuch', s);
		if i>0 then
			ExtractPeople(s, i, 2);
			
		//music
		i := Pos('<div class=''h3''>Musik', s);
		if i >0 then
			ExtractPeople(s, i, 4);
			
		//producers, composers, cinematographers
		temp := GetHTMLPageContentFromRequest(cast_url);
		s := GetStr(temp, '<table class=''casts''>', '</table>');
		//producers
		i := Pos('<th>Produktion</th>', s);
		if i > 0 then begin
			ExtractPeopleFromCastPage(s, i, 5);
		end;
		//composers
		//i := Pos('<th>Komponist</th>', s);
		//if i > 0 then begin
			//ExtractPeopleFromCastPage(s, i, 4);
		//end;
		//cinematographers
		i := Pos('<th>Kamera</th>', s);
		if i > 0 then begin
			ExtractPeopleFromCastPage(s, i, 6);
		end;
	end;
		
	//episodes
	temp := GetHTMLPageContentFromRequest(episodes_url);
	if temp <> '' then begin
		i := Pos('"seasons":[{', temp);
		delete(temp, 1, i);
		//extract seasons
		i := Pos('"title":"Staffel ', temp);
		while i > 0 do begin
			s := GetStr(temp, '"title":"Staffel ', '}]}]');
			//season cover
			img_url := '';
			s2 := GetStr(s, '"poster":', '}');
			if (s2 <> '') then begin
				img_url := 'https://assets.cdn.moviepilot.de/files/' + GetStr(s2, '"id":"', '"') + '/' + GetStr(s2, '"filename":"', '"');
			end;
			
			// season number
			s3 := ParseString(s, '^(\d+)', 1);
			season := 0;
			try
				season := StrToInt(s3);
			except
			end;
			if (img_url <> '') and (season > 0) then begin
				if Pos('http', img_url) = 0 then
					img_url := 'http://www.moviepilot.de' + img_url;
				img_url := ReplaceStr(img_url, '/limit/100/150', '', -1);
				SetImageName('', img_url, '', 9, False, '', season, 0);
			end;
			
			//extract episodes for the season
			k := Pos('"episodes":[{', s);
			s2 := copy(s, k, length(s) - k + 1);
			k := Pos('"number":', s2);
			while k > 0 do begin
				s3 := GetStr(s2, '"number":', '}]}');
				episodeName := GetStr(s3, '"title":"', '"');
				episode := 0;
				s4 := ParseString(s3, '^(\d+)', 1);
				try
					episode := StrToInt(s4);
				except
				end;
				episodeName := ClearExtraBlankCharacters(DecodeHTML(episodeName));
				episodeDescription := ClearExtraBlankCharacters(DecodeHTML(GetStr(s3, ',"teaser":"', '",')));
				episodeDescription := ReplaceStr(episodeDescription, '\', '', -1);
				if (episode > 0) then
					SetEpisode(season, episode, EpisodeName, EpisodeDescription, '', '');
				delete(s2, 1, k);
				k := Pos('"number":', s2);
			end;
			delete(temp, 1, i);
			i := Pos('"title":"Staffel ', temp);
		end;
	end;
	
end;

procedure ExtractPeopleForTVSeries(text: string; start, mode: integer);
var
	s, temp, code, name, photo, character: string;
	i, j: integer;
begin
	i := MyPos('<h2', text, start + 1);
	if i = 0 then
		i := length(text);
	temp := copy(text, start, i - start);
	i := Pos('<li', temp);
	while i > 0 do begin
		s := GetStr(temp, '<li', '</li');
		code := GetStr(s, 'href="/people/', '"');
		photo := GetStr(s, 'src="', '"');
		photo := ReplaceStr(photo, '/fill/225/225', '', -1);
		name := GetStr(s, 'alt="', '"');
		if (name = '') then begin
			name := GetStr(s, 'item--title''>', '</div>');
			name := ReplaceStr(name, '<br />', ' ', -1);
			name := RemoveTags(name);
		end;
		name := ClearExtraBlankCharacters(DecodeHTML(name));
		character := GetStr(s, 'item--details''>', '</div>');
		if (character = '') then
			character := GetStr(s, 'subtitle''>', '|');
		character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(character)));
		if (name <> '') then
			SetPersonName(name, character, mode, code, photo);
		delete(temp, 1, i);
		i := Pos('<li', temp);
	end;
end;

procedure GetPictures;
var
	img_cnt, poster_cnt, i, img_mode: Integer;
	s, temp, img_url: String;
begin
	img_cnt := 0;
	poster_cnt := 0;
	temp := GetHTMLPageContentFromRequest(ShotsURL);
	//temp := GetStr(temp, ' id=''images''', '</div>'#10'</div>');
	i := Pos('<li class=''gallery', temp);
	while i>0 do begin
		s := GetStr(temp, '<li class=''gallery', '</li>');
		img_url := GetStr(s, 'src="', '"');
		if (img_url = '') then
			img_url := GetStr(s, 'src=''', '''');
		if img_url <> '' then begin
			img_url := ReplaceStr(img_url, '_thumb_square', '', -1);
			img_url := ReplaceStr(img_url, '/fill/280/170', '', -1);
			img_url := ReplaceStr(img_url, '/fill/390/234', '', -1);
			if (Pos('http', img_url) = 0) then
				img_url := 'http://www.moviepilot.de' + img_url;
			if (Pos('affiche', img_url) > 0) or (Pos('id=''poster', s)>0) or (Pos('poster', img_url)>0) then begin
				if (poster_cnt < MaxPostersCount) then begin
					SetImageName('', img_url, '', 4, True, RefURL);
					Inc(poster_cnt);
				end;
			end
			else begin
				if (img_cnt < MaxShotsCount) then begin
					SetImageName('', img_url, '', 3, True, RefURL);
					Inc(img_cnt);
				end;
			end;
		end;
		delete(temp, 1, i);
		i := Pos('<li class=''gallery', temp);
	end;
end;

//returned images links
procedure GetImages;
var
	i, img_cnt: Integer;
	temp, img_url, trailer_url: String;
begin
	if front_cover_url<>'' then begin
		SetImageName('', front_cover_url, '', 1, True, RefURL);
	end;
	GetPictures;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.moviepilot.de/'+code;
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='https://www.moviepilot.de/people/'+code;
end;



begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';


DownloadBigPhoto := False;


end.