const
	script_name='Movieplayer.it';
	language='Italian';
	version=15;
	author='MF';
	MinProgramBuild=8000;
	PCount = 15;
  convertUTF=0;
	//MaxPicturesCount = 3;
var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments, 
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList: boolean;
	MaxShotsCount, MaxPostersCount, MaxBackdropsCount: integer;
  tmdb_code: String;
	
	searchTitle,title, MovieName, s, s2, s3, s4, year, tagline, director, name, character, BasicURL, country, description, salary, awards: string;
	episodes, movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	atitle, atitle_code, asmall_cover, ayear, aoriginal_title, adescription: array [1..100] of string; 
	i, j: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	rating, imdb_rating: double;
	TMDBURL, front_cover_url, picture_url: string;
	posters_exists, ask_amazon: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	
const
	SERIES_APPENDER = 'series_';
	SERIES_URL_PART = 'serietv';
	SITE_MAIN = 'https://movieplayer.it';
	SITE_MOVIE = SITE_MAIN + '/film/';
	SITE_SERIES = SITE_MAIN + '/' + SERIES_URL_PART + '/';
	SITE_PERSON = SITE_MAIN + '/personaggi/';
	SITE_SEARCH = SITE_MAIN + '/ricerca/?ct=&q=';

function convUTF(str :string): string;
begin
  result:= str;
  if ( convertUTF=1 ) then result:=ConvertUTF8toASCII(str);
end;

function MovieSearch: integer;
var
	i, j, k, l: integer;
	title, title_code, small_cover, year, original_title, description: string; 
  tipo: string;
begin
	s := '';
	result := 0;
	i := Pos('<ul class="search-results-list">', all);
 	if i > 0 then begin
		j := MyPos('</ul>', all, i+1);
 		s := copy(all, i, j-i);
	end;
	//No results
	if (s = '') then
	//otherwise check seach results
	else begin		
 		i:=pos('<li class="search-entry search-result-entry"', s);
		while i>0 do begin
			j:=MyPos('</li>', s, i+1);
			s2:=copy(s, i, j-i);
			// movie code
			title_code := GetStr(s2, 'data-link="/film/', '/');
			title_code := ParseString(title_code, '(\d+)$', 1);
			if (title_code = '') then begin
				title_code := GetStr(s2, 'data-link="/serietv/', '/');
				title_code := ParseString(title_code, '(\d+)$', 1);
				if (title_code <> '') then
					title_code := SERIES_APPENDER + title_code;
			end;
			// cover
			small_cover := GetStr(s2, 'src="', '"');
			if (Pos('placeholder', small_cover) > 0) then
				small_cover := '';
			// title
			title := GetStr(s2, 'search-result-title', '</h3>');
			if title <> '' then
				title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + title)));
			// year
			year := GetStr(s2, 'search-entry-date', ' </span>');
			if year <> '' then
				year := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + year)));
			year := ParseString(year, '(\d+)', 1);
			// additional info
			description := GetStr(s2, 'search-entry-abstract', '</');
			if description <> '' then
				description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + description)));
			if (title <> '') and (title_code <> '') then begin
				SetSearchResult2(title, title_code, year, '', description, small_cover);
				Inc(result);
			end;
			delete(s, 1, i);
			i := pos('<li class="search-entry search-result-entry"', s);
		end;
	end;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
  //showMessage('MovieName:'+MovieName+' AYear:'+AYear+' ABarcode:'+ABarcode);
	searchTitle:= EncodeURL(MovieName, 'utf-8'); //MovieName;
	url:=SITE_SEARCH + searchTitle;
	result:=url;

end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all := DownloadURL(url);
	result := MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
	if (Pos(SERIES_APPENDER, code) > 0) then begin
		code := copy(code, length(SERIES_APPENDER), length(code) - length(SERIES_APPENDER) + 1);
		result := SITE_SERIES + 's_' + code + '/';
	end
	else begin
		result := SITE_MOVIE + 's_' + code + '/';
	end;
end;



//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;
function MySavePage(s , FileName: string): boolean;
var
	fs: TFileStream;
begin
	if length(s)>0 then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
	I: Integer;
	J: Integer;
begin
	// -\xFB\xF0\xE5\xE7\xE0\xE5= \xEA\xF3\xF1\xEE\xEA \xF1=\xF0\xEE\xEA\xE8 \xEC\xE5\xE6\xE4\xF3 s1 \xE8 s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
			Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function SearchSchedaContent(AID: string): string;
var
  SearchPos: Integer;
  CloseSectionPos: Integer;
  SectionContent: string;
begin
  Result := '';
  SearchPos := 1;
  repeat
    SearchPos := MyPos('<h2 class="section-scheda__title', all, SearchPos);
    if (SearchPos > 0) then
    begin
      CloseSectionPos := MyPos('</section>', all, SearchPos);
      if (CloseSectionPos = 0) then
        Break;
      SectionContent := Copy(all, SearchPos, CloseSectionPos - SearchPos);
      if (ParseTag(SectionContent, 'id="', '"') = AID) then
      begin
        Result := ParseTag(SectionContent, '</h2>', '');
        Break;
      end;
      SearchPos := SearchPos + Length('<h2 class="section-scheda__title');
    end;
  until (SearchPos <= 0);
end;

function ParsePeolpeContent(ACastContent: string; ATitle: string;
  APeopleMode: Integer = -1): string;
begin
  Result := ParseTag(ACastContent, ATitle + '</h2>', '');
  Result := ParseTagTakingIntoAccountNestingLevel(Result, '<div', '<div', '</div>');
  if (Result <> '') then
  	ExtractPeopleWithPhotos(Result, APeopleMode);
end;


function GetInfo(url: string; images_only: boolean): string;
var 
	studio1, refer, keyword, s, s2, s3, s4, urla, urli, alli, name, code, character, mode,episodi,anni,urlImage, cast_url, temp, photo, info_url: string;
	i, j, k, l, t, imode, frames_count, pmode: integer;
	FilmmakersSection: Boolean;
	isFilm: integer;
	baseUrl: String;
  ItemsList: TStringList;
begin
	result := '';
	all := DownloadURL(url);

	movie_code := ParseString(url, '(\d+)/$', 1);
	if (Pos(SERIES_URL_PART, url) > 0) then
		movie_code := SERIES_APPENDER + movie_code;
	
	if all='-1' then
		result:='-1'
	else
		result:=all;
		
	baseUrl := GetStr(all, 'rel="canonical" href="', '"');
		
	if (Pos('/cast', all) > 0) and (baseUrl <> '') then begin
		cast_url := baseUrl + 'cast/';
		AddRequestForHTMLPageContent(cast_url, False, '');
	end;
	
	if (Pos('/galleria', all) > 0) and (baseUrl <> '') then begin
		picture_url := baseUrl + 'galleria/';
		AddRequestForHTMLPageContent(picture_url, False, '');
	end;
	
	if (Pos('/info', all) > 0) and (baseUrl <> '') then begin
		info_url := baseUrl + 'info/';
		AddRequestForHTMLPageContent(info_url, False, '');
	end;
 	
	movie_site_url:=GetMovieSiteURL(movie_code);
	
	// movie title
	title := GetStr(all, '<h1', '</h1>');
  if (title <> '') then
    title := '<' + title;
	// year
  year := Trim(ParseTagWithCutting(title, '<small class="year">', '</small>'));
	title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(title)));

	// genres
	i := Pos('Genere</dt>', all);
  s2 := ParseTag(all, 'Genere</dt>', '</dd>');
  s2 := ParseTag(s2, '<dd', '');
  if (s2 <> '') then
  begin
    s2 := RemoveTags('<' + s2);
    ItemsList := StringToStringList(s2, ',');
    try
      for I := 0 to Pred(ItemsList.Count) do
      begin
        s3 :=  ClearExtraBlankCharacters(DecodeHTML(RemoveTags(ItemsList[I])));
  			if (s3 <> '') then
	  			SetGenre(s3);
      end;
    finally
      ItemsList.Free();
    end;
  end;
	
	// duration
  s2 := ParseTag(all, 'Durata</dt>', '</dd>');
  s2 := Trim(ParseTag(s2, '>', 'Min'));
  if (s2 <> '') then
  begin
		s3 := ParseString(s2, '^(\d+)', 1);
		if (s3 <> '') then
			duration := StrToInt(s3);
  end;

	// cover
	front_cover_url := ParseTag(all, 'meta property="og:image" content="', '"');
	front_cover_url := ReplaceStr(front_cover_url, '_100x148_crop_q85', '_1200x2400_crop', 1);
  front_cover_url := ReplaceStr(front_cover_url, '_750x400_crop_q85', '_1200x2400_crop', 1);
	
	// description
  description := '';
  s2 := SearchSchedaContent('trama');
  if (s2 <> '') then
  begin
    description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
    description := ReplaceStr(description, #10, '<br>', -1);
  end;
	
	// cast & crew
	temp := GetHTMLPageContentFromRequest(cast_url);


  ParsePeolpeContent(temp, 'ATTORI E PERSONAGGI', 3);
  ParsePeolpeContent(temp, 'Autori', -1);
  ParsePeolpeContent(temp, 'Fotografia', 6);
  ParsePeolpeContent(temp, 'Musiche', 4);

	// studios
	s := GetStr(temp, '<h3>Case di Produzione</h3>', '</ul>');
	i := Pos('<li', s);
	while i > 0 do begin
		s2 := GetStr(s, '<li>', '</li>');
		s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
		if s2 <> '' then
			SetStudio(s2);
		delete(s, 1, i);
		i := Pos('<li', s);
	end;
	
	// info
	temp := GetHTMLPageContentFromRequest(info_url);
	// box office
	s := GetStr(temp, '<section class="section-scheda section-scheda--accoglienza">', '</dl>');
	salary := '';
	i := Pos('<dt', s);
	while i > 0 do
  begin
    j := i + Length('<dt');
		s2 := GetStr(s, '<dt class="', '</dt>');
    s2 := ParseTag(s2, '>', '');
		if s2 <> '' then
    begin
			s2 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
      if (Pos('<dd', s) > 0) then
      begin
        j := Pos('<dd', s);
        s3 := ParseTag(s, '<dd', '</dd>');
        s3 := ParseTag(s3, '>', '');
        if (s3 <> '') then
        begin
          s3 := s2 + ' ' + Trim(s3) + #13#10;
          salary := salary + s3;
        end;
      end;
		end;
		delete(s, 1, j);
		i := Pos('<dt', s);
	end;
  salary := Trim(salary);
	
	// country
	s := GetStr(temp, 'Nazione:</dt>', '</dd>');
  s := ParseTag(s, '>', '');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	if s <> '' then
		SetCountry(s);

  // original title
	s := GetStr(temp, 'Titolo originale:</dt>', '</dd>');
  s := ParseTag(s, '>', '');
	original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
end;

procedure ExtractPeopleWithPhotos(s: String; mode: Integer);
var
	i: Integer;
  SiteMode: Integer;
	s2, s3, photo, name, code, character: String;
begin
	i := Pos('<tr>', s);
  SiteMode := Mode;
  s3 := '';
	while i > 0 do
  begin
		s2 := GetStr(s, '<tr>', '</tr>');
    s3 := ParseTag(s2, '<th', '</th>');
    s3 := ParseTag(s3, '>', '');
    if (s3 = '') then
    begin
      photo := GetStr(s2, 'data-src="', '"');
      if (Pos('placeholder', photo) > 0) then
        photo := '';
      photo := ReplaceStr(photo, '_60x60_crop_q85', '_1200x2400_crop', -1);
      photo := ReplaceStr(photo, '_40x40_crop_q85', '_1200x2400_crop', -1);
      name := GetStr(s2, '<a href="/personaggi', '</a>');
      name := ParseTag(name, '>', '');
      code := GetStr(s2, '/personaggi/', '/');
      code := ParseString(code, '(\d+)$', 1);
      if (name <> '') then
        name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(name)));
      character := GetStr(s2, '<span class="character font-italic">', '</span>');
      if character <> '' then
        character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(character)));
      if (character = '-') then
        character := '';
      if ((name <> '') and (SiteMode > 0)) then
        SetPersonName(name, character, SiteMode, code, photo);
    end
    else if (mode = -1) then
    begin
      SiteMode := -1;
      if (s3 = 'Regia') then
        SiteMode := 1
      else if (s3 = 'Sceneggiatura') then
        SiteMode := 2
      else if (s3 = 'Produzione') then
        SiteMode := 5;
    end;
    delete(s, 1, i + Length('<tr>'));
		i := Pos('<tr>', s);
	end;
end;


//download other data from themoviesdb.org
function GetTMDBData: integer;
var
	url, all, s, tt,tot,ty: string;
	y, i, j, k, kol: integer;
begin
	result:=0;
 
 	//search movie	
	url:=format('http://api.themoviedb.org/2.1/Movie.search/it/xml/df26c33ba1e6b4940727aa15d777ab97/%s', [title]);
	url:=ReplaceStr(url, ' ', '%20', -1);
	url:=ReplaceStr(url, '''', '%20', -1);
	//showMessage(url);

	all:=DownloadURL(url);
  //showMessage(all);
	if ( all='-1' ) or (pos('<opensearch:totalResults>0<', all)>0) then begin
		url:=format('http://api.themoviedb.org/2.1/Movie.search/it/xml/df26c33ba1e6b4940727aa15d777ab97/%s', [original_title]);
		url:=ReplaceStr(url, ' ', '%20', -1);
  	url:=ReplaceStr(url, '''', '%20', -1);
		//showMessage(url);
		all:=DownloadURL(url);
    //showMessage(all);
  	if ( all='-1' ) or (pos('<opensearch:totalResults>0<', all)>0) then begin
  		exit;
  	end;
	end;
	
  i:=pos('<movie>',all);
  while (i>0) do begin
    delete(all, 1, i+7);
    j:=pos('</movie>',all);
    s:=copy(all,1,j);
    tt:=ParseString(s, '<name>(.*?)</name>', 1);
    tot:=ParseString(s, '<original_name>(.*?)</original_name>', 1);
    ty:=ParseString(s, '<released>(....)-..-..</released>', 1);
    y:=StrToInt(ty)-StrToInt(year);
    //showMessage('['+tt+'] - ['+title+'] --- ['+tot+'] - ['+original_title+']');
    if (((LowerCase(tt)=LowerCase(title)) or (LowerCase(tot)=LowerCase(original_title)) or (LowerCase(tt)=LowerCase(original_title))) and (abs(y)<2)) then begin
       i:=-999;
    end
    else begin
      i:=pos('<movie>',all);
    end;
  end;
  if (i<>-999) then exit;
  
  tmdb_code:=ParseString(s, '<id>(.*)</id>', 1);
  imdb_code:=ParseString(s, '<imdb_id>(.*)</imdb_id>', 1);

  //Get data from imdb.com
 	url:=format('http://www.imdb.com/title/%s/', [imdb_code]);
	url:=ReplaceStr(url, ' ', '%20', -1);
 	all:=DownloadURL(url);
  mpaa_rating:=ParseString(all, '<span itemprop="contentRating">(.*?)</span>', 1);
  mpaa:=ParseString(mpaa_rating,'Rated (.*?) ',1); 
  s:=ParseString(all, '<span itemprop="ratingValue">(.*?)</span>', 1);
  i:=pos('.', s);
	if i>0 then
		s[i]:=DecimalSeparator;
		try
			imdb_rating:=StrToFloat(s);
		except
	end;

  //Get Data from tmdb
 	url:=format('http://api.themoviedb.org/2.1/Movie.getInfo/it/xml/df26c33ba1e6b4940727aa15d777ab97/%s', [tmdb_code]);
	url:=ReplaceStr(url, ' ', '%20', -1);
	all:=DownloadURL(url);
  i:=pos('<image type="backdrop"',all)-2;
  //<image type="backdrop" url="http://cf2.imgobject.com/t/p/w1280/tg7UGXaUROpzY5ppPh7dnvy4l7P.jpg" size="w1280" width="1280" height="720" id="4ea61733a34d4b41fd000e13"/>  
  k:=0;
  while (i>0) and (k<4) do begin
    delete(all,1,i);
    i:=pos('"w1280"',all);
    if (i>0) then begin
     s:=copy(all,1,i+10);
     url:=ParseString(s,'<image type="backdrop" url="([^"]*)" size="w1280"',1);
     //ShowMessage(url);
     k:=k+1;
  	 SetImageName('', url, '', 3);
    end;
  end;       
end;

procedure ExtractShots;
var
	page, part, s, img_url, width, height: String;
	i, img_cnt: Integer;
begin
	img_cnt := 0;
	page := GetHTMLPageContentFromRequest(picture_url);
	part := ParseTag(page, 'Immagini</h2>', '</section>');
	i := Pos('<div class="gallery__cell', part);
	while (i > 0) and (img_cnt < MaxShotsCount) do
  begin
		s := GetStr(part, '<div class="gallery__cell', '</div>');
		img_url := GetStr(s, 'data-src="', '"');
		width := ParseString(img_url, '_(\d+)x', 1);
		height := ParseString(img_url, 'x(\d+)_crop', 1);
		img_url := ReplaceStr(img_url, '_' + width + 'x' + height + '_crop_q85', '_1600x1200_crop_q85', -1);
		if (img_url <> '') then
    begin
			SetImageName('', img_url, '', 3);
			Inc(img_cnt);
		end;
		delete(part, 1, i);
		i := Pos('<div class="gallery__cell', part);
	end;
end;

//returned images links
procedure GetImages;
begin
	if front_cover_url<>'' then
		SetImageName('', front_cover_url, '', 1);
	if (picture_url <> '') then
		ExtractShots;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if (code = '') then
		result := ''
	else begin
		if (Pos(SERIES_APPENDER, code) > 0) then begin
			code := copy(code, length(SERIES_APPENDER), length(code) - length(SERIES_APPENDER) + 1);
			result := SITE_SERIES + 's_' + code + '/';
		end
		else begin
			result := SITE_MOVIE + 's_' + code + '/';
		end;
	end;
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:=SITE_PERSON + 's_' + code + '/';
end;


begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';
prefixes[13]:='I';
prefixes[14]:='Gli';
prefixes[15]:='Lo';
end.
