﻿const
	script_name='Movieplayer.it';
	language='Italian';
	version=8;
	author='MF';
	MinProgramBuild=8000;
	PCount = 12;
  convertUTF=0;
	//MAX_PHOTOS_COUNT = 3;
var
	DownloadPersonBiography, DownloadPersonAdditionalInfo: boolean;
	MaxPhotosCount: integer;
	
	persons_count: integer;
	persons: array of string;
	imdb_codes: array of string;
	imdb_code, person_code: string;
	searchName,search_url,name, code, year, description: string;
	person, BasicURL, biography, trivia, character, birth_date, birthplace, birth_name, salary, height, original_name, death_date, person_site_url: string;
	photo_url: string;
	monthes: array [1..12] of string;
	prefixes: array [1..PCount] of string;
	movie_html: string;
	person_height: integer;
	photo_all: string;
	img_url: string;

const	
	SERIES_APPENDER = 'series_';
	SERIES_URL_PART = 'serietv';
	SITE_MAIN = 'https://movieplayer.it';
	SITE_MOVIE = SITE_MAIN + '/film/';
	SITE_SERIES = SITE_MAIN + '/' + SERIES_URL_PART + '/';
	SITE_PERSON = SITE_MAIN + '/personaggi/';
	SITE_SEARCH = SITE_MAIN + '/ricerca/?ct=people.people&q=';

function GetStr(str: String; s1: String; s2: String): String;
var
	I: Integer;
	J: Integer;
begin
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
			Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function convUTF(str :string): string;
begin
  result:= str;
  if ( convertUTF=1 ) then result:=ConvertUTF8toASCII(str);
end;

function GetSearchURLbyName(PersonName: string): string;
var
	url: string;
begin
	searchName := EncodeURL(PersonName, 'utf-8');
	url := SITE_SEARCH + SearchName;
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
var s: string;
begin
//showMessage(url);
	all:=DownloadURL(url);
	if all='-1' then begin
    //showMessage('-1');
		result:=-1;
	end
  else begin
  	//s:=copy(all,1,100);
    //showMessage(s);
		result:=PersonSearch;
  end;
end;

function PersonSearch: integer;
var
	url, s, s2, s3,Description,small_cover: string;
	i, j, k, next_page: integer;
begin
	persons_count := 0;
  	i := Pos('<ul class="search-results-list">', all);
 	if i > 0 then begin
  		j := MyPos('</ul>', all, i+1);
   		s := copy(all, i, j-i);
  		i := Pos('<li', s);
  		while i>0 do begin
            s2 := GetStr(s, '<li', '</li>');
  			original_name:='';
			name := GetStr(s2, '<h3', '</h3>');
			person_code := GetStr(name, '/personaggi/', '/');
			person_code := ParseString(person_code, '(\d+)', 1);
			if name <> '' then
				name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + name)));
			small_cover := GetStr(s2, 'src="', '"');
			if (Pos('placeholder', small_cover) > 0) then
				small_cover := '';
				
			description := GetStr(s2, 'search-entry-date', '    </span>');
			description := ParseString(description, '</span>(.*?)$', 1);
			description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));
		
			if (name <> '') and (person_code <> '') then begin
				Inc(persons_count);
				SetSearchResult2(name, person_code, description, '', '', small_cover);
			end;
			delete(s, 1, i);
			i := Pos('<li', s);
		end;
	end;
//  ShowMessage(persons_count);
	result:=persons_count;
end;

function GetPersonURL(code: string; images_only: boolean): string;
begin
	if code='' then
		result:=''
	else
		result:=SITE_PERSON + 's_' + code + '/';
end;


//returns images links
procedure GetImages;
var
	i, j, photo_cnt: Integer;
	s, s2, temp, url, width, height: String;
begin
	if photo_url<>'' then
		SetImageName('', photo_url, '', 6);

	if (MaxPhotosCount > 1) then begin
		temp := GetHTMLPageContentFromRequest(img_url);
		temp := GetStr(temp, '<h2>Immagini</h2>', '</ul>');
		photo_cnt := 1;
		i := Pos('<li', temp);
		while (i > 0) and (photo_cnt < MaxPhotosCount) do begin
			s := GetStr(temp, '<li', '</li>');
			url := GetStr(s, 'src="', '"');
			width := ParseString(url, 'jpg_(\d+)x', 1);
			height := ParseString(url, 'x(\d+)_crop', 1);
			url := ReplaceStr(url, width + 'x' + height, '2000x2000', -1);
			if (url <> '') then begin
				SetImageName('', url, '', 6);
				Inc(photo_cnt);
			end;
			delete(temp, 1, i);
			i := Pos('<li', temp);
		end;
	end;
end;


function SavePhoto(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function ClearBrackets(name: string): string;
var
	i: integer;
begin
	// clear word in brackets at the end of name
	i := pos(' (', name);
	if i>0 then
		name := copy(name, 1, i-1);
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"+
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

function MyRemoveTags(s: string): string;
var
	i, j: integer;
begin
	i:=pos('<', s);
	while i>0 do begin
		if i=MyPos('<br />', s, i) then begin
			delete(s, i+6, 1);
			i:=MyPos('<', s, i+1);
		end
		else begin
			j:=MyPos('>', s, i+1);
			delete(s, i, j-i+1);
			i:=MyPos('<', s, i);
		end;
	end;
	result:=s;

end;
function getMonthNum(month: string): string;
begin
  month := LowerCase(month);
  case month of
  'gennaio': begin
     result:='01';
  end;
  'febbraio': begin
     result:='02';
  end;
  'marzo': begin
     result:='03';
  end;
  'aprile': begin
     result:='04';
  end;
  'maggio': begin
     result:='05';
  end;
  'giugno': begin
     result:='06';
  end;
  'luglio': begin
     result:='07';
  end;
  'agosto': begin
     result:='08';
  end;
  'settembre': begin
     result:='09';
  end;
  'ottobre': begin
     result:='10';
  end;
  'novembre': begin
     result:='11';
  end;
  'dicembre': begin
     result:='12';
  end;
  end;
end;
function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;


function GetInfo(url: string; images_only: boolean): string;
var
	filmUrl,bioUrl, s, s2, s3, s4, all2  , day, refer,refer2, month, year, next_page, mov_title, mov_code,anni,episodi, temp, baseUrl: string;
	isSerie,isPhoto,isMovie,isBio,i, j, k, l, mode, page: integer;
begin
	result:='';
	BasicURL:=url;
	
	person_code:=ParseString(url, '(\d+)', 1);
	
	all:=DownloadURL(url);
	baseUrl := GetStr(all, 'rel="canonical" href="', '"');

	bioUrl := baseUrl + 'biografia/';
	filmUrl := baseUrl + 'filmografia/';
	img_url := baseUrl + 'galleria/';
	
	if (DownloadPersonBiography) and (Pos('/biografia', all) > 0) then begin
		AddRequestForHTMLPageContent(bioUrl, False, '');
	end;
	
	if (Pos('/filmografia', all) > 0) then
		AddRequestForHTMLPageContent(filmUrl, False, '');
		
	if (Pos('/galleria', all) > 0) then
		AddRequestForHTMLPageContent(img_url, False, '');
	
	person_site_url:=url;

	if all='-1' then
		result:='-1'
	else
		result:=all;

	//name
	person := GetStr(all, '<h1', '</h1>');
	if (person <> '') then
		person := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + person)));
	
	//original name
	original_name:= ParseString(all, '<meta name="nome_completo" content="(.*?)" />', 1);
	original_name:= DecodeHTML(original_name);
	original_name := convUTF(original_name);
	//showMessage(original_name);
	
	//Date of birth
	s := GetStr(all,'class="timeline-cake">','</div>');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
 	birth_date:='';
	if s <> '' then begin
		day := ParseString(s, 'anni, (\d+)', 1);
		year := ParseString(s, '(\d+)$', 1);
		month := ParseString(s, ', \d+ (.*?) \d+', 1);
		birth_date := getMonthNum(month) + '/' + day + '/' + year;
    end;

    //Place of birth
    s := GetStr(all, 'class="timeline-marker">', '</div>');
	birthplace := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));

  
	//Date of death
	s := GetStr(all, 'Morto - ', '</');
	s := ClearExtraBlankCharacters(RemoveTags(s));
	death_date := '';
	if (s <> '') then begin
		day := ParseString(s, '^(\d+)', 1);
		month := ParseString(s, ' (.*?) ', 1);
		year := ParseString(s, '(\d+)$', 1);
		death_date := getMonthNum(month) + '/' + day + '/' + year;
	end;
	
	// photo
	s := GetStr(all, 'class="timeline-header-portrait"', '</div>');
	photo_url := GetStr(s, 'url(', ')');
	photo_url := ReplaceStr(photo_url, '200x200_crop_q85', '2000x2000_crop_q85', -1);
  
	//biography
	if (DownloadPersonBiography) then begin
		temp := GetHTMLPageContentFromRequest(bioUrl);
		i := Pos('<p><p>', temp);
		biography := GetStr(temp, '<p><p>', '</section>');
		biography := ReplaceStr(biography, '<br>', #13#10, -1);
		biography := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(biography)));
	end;
	
	// filmography
	page := 1;
	while (filmUrl <> '') do begin
		temp := GetHTMLPageContentFromRequest(filmUrl);
		page := page + 1;
		if (Pos('null;">Mostra altro', temp) > 0) then begin
			filmUrl := baseUrl + 'filmografia/?pagina=' + IntToStr(page);
			AddRequestForHTMLPageContent(filmUrl, False, '');
		end
		else
			filmUrl := '';
		s := GetStr(temp, 'Filmografia'#10, '</section>');
		i := Pos('film-list-item-cover', s);
		while i > 0 do begin
			s2 := GetStr(s, 'film-list-item-cover', 'class="vote-stars"');
			// code
			mov_code := GetStr(s2, 'href="/film/', '/');
			mov_code := ParseString(mov_code, '(\d+)$', 1);
			if (mov_code = '') then begin
				mov_code := GetStr(s2, 'href="/serietv/', '/');
				mov_code := ParseString(mov_code, '(\d+)$', 1);
				if (mov_code <> '') then
					mov_code := SERIES_APPENDER + mov_code;
			end;
			// title
			mov_title := GetStr(s2, '<h3', '</h3>');
			if (mov_title <> '') then
				mov_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + mov_title)));
			// year
			s3 := GetStr(s2, 'date-genre', '</');
			if s3 <> '' then
				s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s3)));
			year := ParseString(s3, '(\d+)', 1);
			// role
			s3 := GetStr(s2, 'item-role">', '</');
			s3 := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s3)));
			character := GetStr(s3, 'Recitazione (', ')');
			if (mov_title <> '') then begin
				if (Pos('Regia', s3) > 0) then
					SetMovieName(mov_title, '', 1, mov_code, year);
				if (Pos('Sceneggiatura', s3) > 0) then
					SetMovieName(mov_title, '', 2, mov_code, year);
				if (Pos('Recitazione', s3) > 0) then
					SetMovieName(mov_title, character, 3, mov_code, year);
				if (Pos('Musiche', s3) > 0) then
					SetMovieName(mov_title, '', 4, mov_code, year);
				if (Pos('Produzione', s3) > 0) then
					SetMovieName(mov_title, '', 5, mov_code, year);
				if (Pos('Fotografia', s3) > 0) then
					SetMovieName(mov_title, '', 6, mov_code, year);
			end;
				
			delete(s, 1, i);
			i := Pos('film-list-item-cover', s);
		end;
	end;
end;
	
//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if (code = '') then
		result := ''
	else begin
		if (Pos(SERIES_APPENDER, code) > 0) then begin
			code := copy(code, length(SERIES_APPENDER), length(code) - length(SERIES_APPENDER) + 1);
			result := SITE_SERIES + 's_' + code + '/';
		end
		else begin
			result := SITE_MOVIE + 's_' + code + '/';
		end;
	end;
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:=SITE_PERSON + 's_' + code + '/';
end;

begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.