program orange_program;

uses 'orange_program_variables.pas', 'orange_program_part1.pas', 'orange_program_part2.pas',
  'orange_program_part3.pas', 'orange_program_part4.pas', 'orange_program_part5.pas',
  'orange_program_part6.pas', 'orange_program_part7.pas', 'orange_program_part8.pas',
  'orange_program_global.pas', 'orange_program_part12.pas', 'orange_program_part13.pas';

//userref: 109-129 - Movie page tabs
//userref: 140-149 - Person page tabs
//userref: 131-134 - filmography sort order (for person pages)
//userref: 135 - awards

const                 
	script_name='Orange';
	language='';
	version=83;
	author='medianizer.com';
	
	
function GetMovieProgramType(ACode: Integer): Integer;
begin
  ExecuteSQL('SELECT item_type FROM movies WHERE code = ' + IntToStr(ACode));
  Result := GetIntegerField('item_type');
end;

function GetPersonProgramType(ACode: Integer): Integer;
begin
  ExecuteSQL('SELECT item_type FROM persons WHERE code = ' + IntToStr(ACode));
  Result := GetIntegerField('item_type');
end;

function GetManualProgramType(ACode: Integer): Integer;
begin
  ExecuteSQL('SELECT item_type FROM manuals WHERE code = ' + IntToStr(ACode));
  Result := GetIntegerField('item_type');
end;

function GetMovieByProgramType(MovieCode: Integer; AProgramType: Integer; season: integer;
  FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetMoviePage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
    MUSICNIZER_PROGRAM: Result := GetAlbumPage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
    BOOKNIZER_PROGRAM: Result := GetBookPage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
    GAMENIZER_PROGRAM: Result := GetGamePage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
  end;
end;

function GetMovie(MovieCode: Integer; season: integer;
  FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
begin
  Result := GetMovieByProgramType(MovieCode, GetMovieProgramType(MovieCode), season,
    FullDesc, FullComments, FullPersons, FullAwards);
end;

function GetPersonByProgramType(PersonCode: integer; AProgramType: Integer;
  FullBio, FullDesc: boolean): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetPersonMoviePage(PersonCode, FullBio, FullDesc);
    MUSICNIZER_PROGRAM: Result := GetPersonAlbumPage(PersonCode, FullBio, FullDesc);
    BOOKNIZER_PROGRAM: Result := GetPersonBookPage(PersonCode, FullBio, FullDesc);
    GAMENIZER_PROGRAM: Result := GetPersonGamePage(PersonCode, FullBio, FullDesc);
  end;
end;

function GetPerson(PersonCode: integer; FullBio, FullDesc: boolean): string;
begin
  Result := GetPersonByProgramType(PersonCode, GetPersonProgramType(PersonCode),
    FullBio, FullDesc);
end;

//   
function GetThumbMovieByProgramType(code, mode: integer; AProgramType: Integer;
  title, year: string; InCollection, rating: integer;
  AFullDescription: string = ''; ASearchDescription: string = ''): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetThumbnailMovie(code, mode, title, year, InCollection, rating, AFullDescription, ASearchDescription);
    MUSICNIZER_PROGRAM: Result := GetThumbnailAlbum(code, mode, title, year, InCollection, rating, AFullDescription, ASearchDescription);
    BOOKNIZER_PROGRAM: Result := GetThumbnailBook(code, mode, title, year, InCollection, rating, AFullDescription, ASearchDescription);
    GAMENIZER_PROGRAM: Result := GetThumbnailGame(code, mode, title, year, InCollection, rating, AFullDescription, ASearchDescription);
  end;
end;

//   
function GetThumbMovie(code, mode: integer; title, year: string; InCollection, rating: integer;
  AFullDescription: string = ''; ASearchDescription: string = ''): string;
begin
  Result := GetThumbMovieByProgramType(code, mode, GetMovieProgramType(code),
    title, year, InCollection, rating, AFullDescription, ASearchDescription);
end;

//   
function GetThumbMovieExtendedByProgramType(code, mode: integer; AProgramType: Integer;
  Title: string): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetThumbnailMovieExtended(code, mode, title);
    MUSICNIZER_PROGRAM: Result := GetThumbnailAlbumExtended(code, mode, title);
    BOOKNIZER_PROGRAM: Result := GetThumbnailBookExtended(code, mode, title);
    GAMENIZER_PROGRAM: Result := GetThumbnailGameExtended(code, mode, title);
  end;
end;

//   
function GetThumbMovieExtended(code, mode: integer; title: string): string;
begin
  Result := GetThumbMovieExtendedByProgramType(code, mode, GetMovieProgramType(code), title);
end;

function GetThumbPersonByProgramType(code, mode: integer; Name: string;
  AProgramType: Integer): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetThumbnailPersonMovie(code, mode, Name);
    MUSICNIZER_PROGRAM: Result := GetThumbnailPersonAlbum(code, mode, Name);
    BOOKNIZER_PROGRAM: Result := GetThumbnailPersonBook(code, mode, Name);
    GAMENIZER_PROGRAM: Result := GetThumbnailPersonGame(code, mode, Name);
  end;
end;

function GetThumbPerson(code, mode: integer; Name: string = ''): string;
begin
  Result := GetThumbPersonByProgramType(code, mode, Name, GetPersonProgramType(code));
end;

function GetThumbPersonExtendedByProgramType(code, mode: integer; Name: string;
  AProgramType: Integer): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetThumbnailPersonMovieExtended(code, mode, Name);
    MUSICNIZER_PROGRAM: Result := GetThumbnailPersonAlbumExtended(code, mode, Name);
    BOOKNIZER_PROGRAM: Result := GetThumbnailPersonBookExtended(code, mode, Name);
    GAMENIZER_PROGRAM: Result := GetThumbnailPersonGameExtended(code, mode, Name);
  end;
end;


function GetThumbPersonExtended(code, mode: integer; Name: string = ''): string;
begin
  Result := GetThumbPersonExtendedByProgramType(code, mode, Name,
    GetPersonProgramType(code));
end;


function GetUserReferenceByProgramType(code: integer; AProgramType: Integer;
  text: string; Page: Integer = 1): string;
begin
  case AProgramType of
    MOVIENIZER_PROGRAM: Result := GetUserReferenceForMovie(code, Text, Page);
    MUSICNIZER_PROGRAM: Result := GetUserReferenceForAlbum(code, Text, Page);
    BOOKNIZER_PROGRAM: Result := GetUserReferenceForBook(code, Text, Page);
    GAMENIZER_PROGRAM: Result := GetUserReferenceForGame(code, Text, Page);
  end;
end;

function GetUserReference(code: integer; text: string; Page: Integer = 1): string;
var
  ProgramType: Integer;
begin
  ProgramType := GetUserReferenceProgramType(code);
	result := GetUserReferenceByProgramType(code, ProgramType, text, Page);
end;

function GenerateSubSQLForKinopoiskRating(AProgramType: Integer): string;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
  try
    if ((AProgramType = MOVIENIZER_PROGRAM) and
        (RegReadInteger('ShowKinopoiskRatingUnderCovers', 1) = 1)) then
    begin
      Result := ', (SELECT Rating FROM movies_codes WHERE movie=m.code' +
        ' AND script=''kinopoisk'' LIMIT 1) as KinopoiskRating ';
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetReferenceByProgramType(ReferenceCode: Integer; AProgramType: Integer;
  reference: integer; Page: Integer = 0): string;
var
  sl: TStringList;
  RecordCount, i: integer;
  s, all: string;
  current_site: string;
  MovieSortFields: string;
  AudioEditionMediaType: Integer;
begin
	result:='';
	TempReferenceCode:=ReferenceCode;
	TempReference:=reference;

	ProgramReference:='';
	sl:=TStringList.Create;

	all:='';
  if ReferenceCode>0 then
  begin
    //LastMode:=4;
      with sl do begin
        Clear;
        Add('select name from manuals');
        if ((Reference = 6) or (Reference = 7)) then
          Add(format('where code=%d and reference=%d', [ReferenceCode, 23]))
        else
          Add(format('where code=%d and reference=%d', [ReferenceCode, reference]));
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount<=0 then
        exit;
      ProgramReference:=GetStringField('name');
      MovieSortFields := ' m.title_sort, i.sort_order';
      if (AProgramType <> MOVIENIZER_PROGRAM) then
        MovieSortFields := ' m.title, i.sort_order';
      //    
      with sl do
      begin
        Clear;
        if (IsPersonReference(reference)) then
        begin
      		Add('select p.name as name, p.code as code, p.rating as rating, ');
          Add('p.in_collection as in_collection, ');
          Add('i.path as path');
          Add('from persons p');
        end
        else
        begin
      		Add('select m.title as title, m.code as code, m.year as year, ');
          Add('m.in_collection as in_collection, m.rating as rating,');
          Add('m.imdb_rating as imdb_rating, m.series_nom as series_nom,');
          Add('i.path as path');
          Add(GenerateSubSQLForKinopoiskRating(AProgramType));
          Add('from movies m');
        end;
        //custom fields
        if (reference>=13) and (reference<=16) then
        begin
        	i:=reference-12;
		    	Add('left outer join images i on i.movie=m.code and i.mode=1');
			    Add(format('where m.custom%d=%d', [i, ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        else if (reference>=24) and (reference<=27) then
        begin
        	i:=reference-23;
		    	Add('left outer join images i on i.person=p.code and i.mode=6');
			    Add(format('where p.custom%d=%d', [i, ReferenceCode]));
	        Add('order by p.name, i.sort_order');
        end
        //video standard
        else if (reference=1) then begin
        	Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
  	      Add(format('where e.video_standard=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
        //media format
        else if (reference=2) then begin
        	Add('left outer join editions e on e.movie=m.code');
			    Add('left outer join images i on i.movie=m.code and i.mode=1');
  	      Add(format('where e.media_format=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end

        // media types
        else if (reference = 3) then
        begin
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where m.media_type=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
        //aspect ratio
        else if (reference=4) then begin
			Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where e.screen_ratio=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        //resolution
        else if (reference=5) then begin
			Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where e.resolution=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        else if (reference=6) or (reference=7) then
        begin
          AudioEditionMediaType := 7 - reference;
        	Add('left outer join editions e on e.movie=m.code');
    		Add(format('inner join audio_manuals em on em.edition=e.code and em.media_type=%d', [AudioEditionMediaType]));
    	    Add('inner join manuals mg on mg.code=em.reference');
		    Add('left outer join images i on i.movie=m.code and i.mode=1');
    		Add(format('where mg.code=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        //location
        else if (reference=10) then begin
			Add('left outer join editions e on e.movie=m.code');
        	Add('inner join loans l on l.edition=e.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where l.location=%d', [ReferenceCode]));
			Add('and (l.return_date='''' or l.return_date is null) and m.in_collection=1');
	        Add('order by ' + MovieSortFields);
        end
        // MPAA
        else if (reference = 11) then
        begin
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where m.mpaa=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
        // video codec
        else if (reference = 19) then
        begin
        	Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where e.video_codec=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
        //disc label
        else if (reference=20) then begin
			Add('left outer join editions e on e.movie=m.code');
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where e.disc_label=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by ' + MovieSortFields);
        end
        // book language
        else if (reference=23) then begin
        	Add('left outer join editions e on e.movie=m.code');
			    Add('left outer join images i on i.movie=m.code and i.mode=1');
  	      Add(format('where e.book_language=%d and m.in_collection=1', [ReferenceCode]));
	        Add('order by m.year desc, ' + MovieSortFields);
        end
		//sequence
		else if (reference=22) then begin
			Add('left outer join images i on i.movie=m.code and i.mode=1');
			Add(format('where m.series=%d', [ReferenceCode]));
	        Add('order by m.series_nom, i.sort_order');
        end
        else
        begin
          if (IsPersonReference(reference)) then
          begin
            Add(format('inner join persons_manuals pm on pm.person=p.code and pm.reference=%d', [reference]));
            Add('inner join manuals mg on mg.code=pm.ref_code');
            Add('left outer join images i on i.person=p.code and i.mode=6');
            Add(format('where mg.code=%d and p.in_collection=1', [ReferenceCode]));
            Add('order by p.name, i.sort_order');
          end
          else
          begin
            Add(format('inner join movies_manuals mm on mm.movie=m.code and mm.reference=%d', [reference]));
            Add('inner join manuals mg on mg.code=mm.ref_code');
            Add('left outer join images i on i.movie=m.code and i.mode=1');
            Add(format('where mg.code=%d and m.in_collection=1', [ReferenceCode]));
            Add('order by ' + MovieSortFields);
          end;
        end;
      end;
      RecordCount:=ExecuteSQL(sl.text);
      if RecordCount>0 then
      begin
        //movie:=format('<h1>Movies by genre %s</h1><ol>', [genre]);
        case reference of
			    //video standard
    			1: s:=format(GetLangStr(1134), [ProgramReference]);
        	//media format
        	2: s:=format(GetLangStrMulti(AProgramType, 1526, 10163, 20163, 35257), [ProgramReference]);
		    	// media type
    			3: s := GetLangStr(3279) + ': ' + ProgramReference;
        	//aspect ratio
        	4: s:=format(GetLangStrMulti(AProgramType, 645, 10164, 20164), [ProgramReference]);
        	//resolution
        	5: s:=format(GetLangStrMulti(AProgramType, 633, 10166, 20166), [ProgramReference]);
        	//subtitles
        	6: s:=format(GetLangStrMulti(AProgramType, 634, 10167, 20167), [ProgramReference]);
        	//audio track
        	7: s:=format(GetLangStrMulti(AProgramType, 632, 10165, 20416), [ProgramReference]);
        	//genre
        	8: s:=format(GetLangStrMulti(AProgramType, 313, 10168, 20168, 35007), [ProgramReference]);
        	//country
        	9: s:=format(GetLangStrMulti(AProgramType, 314, 10169, 20169, 35006), [ProgramReference]);
        	//location
        	10: s:=format(GetLangStrMulti(AProgramType, 569, 10170, 20170, 35231), [ProgramReference]);
			    //mpaa
    			11: s:=GetLangStrMulti(AProgramType, 3277, 3277, 3277, 35075) + ': ' + ProgramReference;
    			//studios
    			12: s:=format(GetLangStrMulti(AProgramType, 1527, 10171, 20171, 35005), [ProgramReference]);
        	//custom 1-4
        	13: s:=GetLangStr(540)+': '+ProgramReference;
        	14: s:=GetLangStr(541)+': '+ProgramReference;
        	15: s:=GetLangStr(542)+': '+ProgramReference;
        	16: s:=GetLangStr(543)+': '+ProgramReference;
        	//custom list 1-2
        	17: s:=GetLangStr(544)+': '+ProgramReference;
        	18: s:=GetLangStr(545)+': '+ProgramReference;
    			// video codec
		    	19: s := GetLangStr(3280) + ': ' + ProgramReference;
        	//disc label
        	20: s:=format(GetLangStrMulti(AProgramType, 1001, 10172, 20172, 35232), [ProgramReference]);
    			//sequence
		    	22: s:=GetLangStrMulti(AProgramType, 3327, 3327, 2966, 35004) + ': ' + ProgramReference;
          // book langauge
          23: s :=Format(GetLangStrMulti(AProgramType, 20416, 20416, 20416, 35258), [ProgramReference]);
          // custom persons 1-4
        	24: s:=GetLangStr(4540)+': '+ProgramReference;
        	25: s:=GetLangStr(4541)+': '+ProgramReference;
        	26: s:=GetLangStr(4542)+': '+ProgramReference;
        	27: s:=GetLangStr(4543)+': '+ProgramReference;
        	//custom person list 1-2
        	28: s:=GetLangStr(4544)+': '+ProgramReference;
        	29: s:=GetLangStr(4545)+': '+ProgramReference;
			    else
				    s:='';
        end;
        if (IsPersonReference(reference)) then
          all := ProcessPersonReference(AProgramType, s, page)
        else
  	      all := ProcessMovieReference(AProgramType, s, page);
    	end; //if
    end;
  sl.Free;
  result:=all;
end;

//show movies by selected manual
function GetReference(ReferenceCode, reference: integer; Page: Integer = 0): string;
begin
	result := GetReferenceByProgramType(ReferenceCode, GetManualProgramType(ReferenceCode),
    reference, Page);
end;

function IsPersonReference(AReference: Integer): Boolean;
begin
  Result := (AReference >= 24) and (Areference <= 29);
end;

//show movies by selected year
function GetYear(ProgramType: Integer; YearCode: Integer; page: integer = 1): string;
var
  sl: TStringList;
  all: string;
begin
	TempReference:=300;
	TempReferenceCode:=YearCode;
	result:='';
	sl:=TStringList.Create;

	all:='';
  if YearCode>0 then
  begin
    with sl do begin
      Clear;
      Add('select m.title as Title, m.code as code, m.year as year,');
      Add('m.in_collection as in_collection, m.imdb_rating as imdb_rating,');
      Add('m.rating as rating, i.path as path');
      Add(GenerateSubSQLForKinopoiskRating(ProgramType));
      Add('from movies m');
      Add('left outer join images i on i.movie=m.code and i.mode=1');
      Add(format('where m.year=%d and m.in_collection=1', [YearCode]));
      Add('AND m.item_type = ' + IntToStr(ProgramType));
      Add('order by m.year desc, m.title, i.sort_order');
    end;
    ExecuteSQL(sl.text);
  	all := ProcessMovieReference(ProgramType, Format(GetLangStrMulti(ProgramType,
      315, 10341, 20341, 35008), [YearCode]), page);
  end;
  sl.Free;
  result:=all;
end;

//show movies by selected year
function GetMyRating(ProgramType: Integer; rating: Integer; page: integer = 1): string;
var
  sl: TStringList;
  all: string;
  rating_s: string;
begin
	TempReference:=301;
	TempReferenceCode:=rating;
	result:='';
	sl:=TStringList.Create;

  with sl do
  begin
    Clear;
    Add('select m.title as title, m.code as code, m.rating as rating, ');
    Add('m.in_collection as in_collection, m.imdb_rating as imdb_rating, ');
    Add('m.rating as rating, i.path as path');
    Add(GenerateSubSQLForKinopoiskRating(ProgramType));
    Add('from movies m');
    Add('left outer join images i on i.movie=m.code and i.mode=1');
    Add(format('where m.rating=%d and m.in_collection=1', [rating]));
    Add('AND m.item_type = ' + IntToStr(ProgramType));
    Add('order by m.rating desc, m.title, i.sort_order');
  end;
  if (Rating > 0) then
    rating_s := IntToStr(rating)
  else
    rating_s := GetLangStr(3885);
  rating_s := '"' + rating_s + '"';
  ExecuteSQL(sl.text);
	all := ProcessMovieReference(ProgramType, format(GetLangStrMulti(
    ProgramType, 3884, 30201, 30202, 35009), [rating_s]), page);
  sl.Free;
  result:=all;
end;


//============================================================================




function GetCast(MovieCode: Integer): String;
var
	sl, PreviousCodes: TStringList;
	RecordCount, i, person_code, prev_code, rating, page_width, page_width_copy, col, total_col: Integer;
	PicWidth, PicHeight: Integer;
	s, img, character, rate, BirthDate, FileName, temp: String;
begin
	sl := TStringList.Create;
	s := '';
    with sl do begin
		Clear;
        Add('select p.code, p.name, p.rating, p.birth_date, c.name, i.path, i.width, i.height from data d');
        Add('inner join persons p on p.code=d.person');
		Add('left outer join images i on i.person=d.person');
		Add('left outer join characters c on c.person=p.code and c.movie=d.movie');
        Add(format('where d.movie=%d and d.mode=3', [MovieCode]));
        Add('order by d.sort_order, i.mode desc, i.sort_order');
    end;
    RecordCount:=ExecuteSQL(sl.text);
	PreviousCodes := TStringList.Create;
    if RecordCount>0 then begin
		page_width := GetHTMLWidth - LeftColumnWidth - WholePageBorder;
        i:=1;
		prev_code := 0;
		col := 0;
		temp := '';
		s := s + '<table style="width: 100%;"><tr><td><table class="white-bck-block"><tr>';
		page_width_copy := page_width;
		while i<=RecordCount do begin
		  person_code := GetIntegerField('p.code');
		  rating:=GetIntegerField('p.rating');
		  if rating>0 then
			rate:=format('<br/><img src="%sfull-star.gif" width=16 height=15 border=0 align="absmiddle">%d', [ImgPath, rating])
		  else
			rate:='';
		  BirthDate:=GetStringField('p.birth_date');
		  if BirthDate<>'' then
			BirthDate:=Date2Str(BirthDate);
		  if PreviousCodes.IndexOf(IntToStr(person_code)) < 0 then begin
			  PreviousCodes.Add(IntToStr(person_code));
			  PicHeight := GetIntegerField('i.height');
			  if PicHeight > 0 then
				PicWidth := Round(GetIntegerField('i.width') * (SmallCoverHeight / PicHeight)) + BigImageBorders
			  else
				PicWidth := StandardCoverWidth + BigImageBorders;
			  page_width_copy := page_width_copy - PicWidth;
			  if (page_width_copy < 0) then begin
				s := s + temp + '</tr></table>';
				temp := '';
(*				if col=2 then begin
					s := s + '<div style="clear:both">';
					page_width := GetHTMLWidth - WholePageBorder;
				end;
*)				s := s + '<table class="white-bck-block"><tr>';
				page_width_copy := page_width - PicWidth;
			  end;
			  //photo
			  FileName := GetImageFileName(GetStringField('i.path'), ThumbsMoviePhotos, 'nophoto.jpg', 0, SmallCoverHeight);
			  temp:=temp+'<td style="vertical-align: top; text-align: center;"><div style="width: 3px;"><div class="photo-outer"><div class="photo-inner">'+format('<a class="pic" href="person:%d"><img style="height: %dpx;" src="%s" border="0"></a>', [person_code, SmallCoverHeight, FileName]);
			//name
			  temp := temp+format('</div></div><div class="image-text"><a href="person:%d"><b>%s</b></a>%s<br>', [person_code, GetStringField('p.name'), rate]);
			  //birth date
//			  if BirthDate <> '' then
//				s := s + BirthDate + '<br>';

			  //character
			  character:=GetStringField('c.name');
			  temp := temp + character + '</div></div></td>';
			  prev_code := person_code;
		  end;
		  i:=i+1;
          GetNextRecord;
        end;
		s := s + temp;
		if temp <> '' then begin
			s := s + Format('<td style="width: %dpx">&nbsp;</td>', [page_width_copy]);
		end;
		s := s + '</tr></table></td></tr></table>';
		//s := s + '</table></td></tr>';
	end;
	PreviousCodes.Free;
	sl.Free;
	Result := s;
end;

//14.03.13
function GenerateHTMLForDescriptionSearching(AFullDescription: string;
  ASearchDescription: string; AMaxLength: Integer = 350): string;
var
  StartPos: Integer;
  EndPos: Integer;
  SearchPos: Integer;
begin
  Result := '';
  if ((ASearchDescription <> '') and
      (AFullDescription <> '')) then
  begin
    SearchPos := Pos(LowerCase(ASearchDescription), LowerCase(AFullDescription));
    if (SearchPos > 0) then
    begin
      // calculate start pos
      StartPos := SearchPos - ((AMaxLength - Length(ASearchDescription)) div 2);
      if (StartPos <= 0) then
        StartPos := 1
      else
      begin
        // in other case search first space from StartPos position
        if (MyPos(' ', AFullDescription, StartPos) > 0) then
          StartPos := MyPos(' ', AFullDescription, StartPos) + 1;
      end;
      // find end pos of the text
      EndPos := StartPos + AMaxLength;
      if (EndPos > Length(AFullDescription)) then
        EndPos := Length(AFullDescription)
      else
      while ((Length(AFullDescription) > 0) and
             (AFullDescription[EndPos] <> ' ')) do
      begin
        Dec(EndPos);
      end;
      //
      Result := Copy(AFullDescription, StartPos, EndPos - StartPos);
      Result := StringReplaceIgnoreCase(Result, ASearchDescription,
        '<font style="background-color: yellow">' + ASearchDescription + '</font>');
      Result := Trim(StringReplaceIgnoreCase(Result, '<br>', ' '));
      if (StartPos <> 1) then
        Result := '...' + Result;
      if (EndPos <> Length(AFullDescription)) then
        Result := Result + '...';
    end;
  end;
  if (Result <> '') then
    Result := '<br>"' + Result + '"';
end;



//  
function GetHome: string;
begin
	result:=GetHomeModern(HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab);
end;

//  

function GetSearchTop(RecMin, RecMax, RecCount: integer): string;
begin
	result:=GetPatternTop + '<p class="title">'+GetLangStr(1293)+format(': %d-%d %s %d', [RecMin, RecMax, GetLangStr(1461), RecCount])+'</p><div class="icons">&nbsp;</div>'+ClosePatternTop;
end;

function GetSearchBottom(RecMin, RecMax, RecCount: integer): string;
var
	s: string;
	RecPage, i, kol, page_width: integer;
begin
	//s:=format('Results from %d to %d. Total records %d', [RecMin, RecMax, RecCount]);
	s:='';
	page_width:=GetHTMLWidth - WholePageBorder;
	RecPage:=GetNumberSearchResults;
	if RecPage>0 then begin
		kol:=RecCount div RecPage;
		if kol*RecPage<>RecCount then
			kol:=kol+1;
		s:=s+Format('<center><div class="orange-line" style="margin-left: %d; margin-right: %d; height: 10;"></div><p>', [page_width div 3, page_width div 3]);
		for i:=1 to kol do begin
			if (RecMin-1) div RecPage=i-1 then
				s:=s+format('<b class="search-active">%d</b> ', [i])
			else
				s:=s+format('<a href="search:%d-%d">%d</a> ', [(i-1)*RecPage+1, i*RecPage, i]);
		end;
		s:=s+'</p></center>';
		
	end;
	result:= s;
end;


//remove all thumbs files
procedure DeleteThumbs(FileName: string);
begin
	DeleteFile(ImagesPath+Thumbs+'\'+FileName);
	DeleteFile(ImagesPath+Thumbs2+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsCovers+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsHomeMovies+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsMainPhoto+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsMoviePhotos+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsPersonMovies+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsPhotos+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsScreenshots+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsHomePhotos+'\'+FileName);
	DeleteFile(ImagesPath+ThumbsEpisodeCovers+'\'+FileName);
end;

function ShowScriptOptions(): string;
begin
  Result := ShowScriptOptionsInternal();
end;

procedure ReadCellsSizes();
var
  I: Integer;
begin
  for I := LOW_PROGRAM_TYPE to HIGH_PROGRAM_TYPE do
  begin
  	MultiShowRowHeight[I] := RegReadInteger(REGISTRY_SUB_KEYS[I] + 'ThumbCellHeight', DefaultMultiCellHeight[I]);
  	MultiShowImageWidth[I] := RegReadInteger(REGISTRY_SUB_KEYS[I] + 'ThumbCellWidth', DefaultMultiCellWidth[I]);
  end;
end;

begin
	ImgPath := PicturesPath + 'Themes\Orange\';
	WhiteBarFile := GetProperPath(ImgPath + 'white-bar.gif');
	BackgroundImg := GetProperPath(ImgPath + 'background.png');
	BackgroundMovies := GetProperPath(ImgPath + 'background-movies.gif');
	BackgroundPeople := GetProperPath(ImgPath + 'background-people.gif');
	StandardCoverWidth := Round(NoCoverWidth * (SmallCoverHeight / NoCoverHeight));
  DefaultHomePageShowPersons := IsLimitedSingleProgram;
  // DefaultHomePageShowSnapshots := IsLimitedSingleProgram;
	ActiveTab := 1;
	PersonActiveTab := 1;
  // 22.04.2011 - default sizes for multi image showing
	ReadCellsSizes();
  MiltiShowDistanceBetweenCovers := 12;  
  SetHintWindowSize(305, 165);
	HomeMovieTab := 1;
	HomeAlbumTab := 1;
	HomeBookTab := 1;
  HomeGameTab := 1;
	HomePersonTab := 1;

end.
