﻿program orange_program_part14;

uses 'orange_program_variables.pas';

procedure FillScriptOptionsGames(AForm: TForm; APageControl: TPageControl;
  var ASaveButtonCallback: Pointer; var ADefaultButtonCallback: Pointer);
var
	s: string;
	i: integer;
	sl: TStringList;
	form1: TForm;
  f: TTabSheet;
  pageOptions: TPageControl;
	b, btnDefault: TButton;
	edPopularGenres: TEdit;
	edLinesMovies: TEdit;
	labLinesMovies: TLabel;
	edLinesPeople: TEdit;
	labLinesPeople: TLabel;
	edShots: TEdit;
	labShots, labCoverRows: TLabel;
	edPhotos, edCoverRows: TEdit;
	labPhotos, labRemoveAdult: TLabel;
	boxUseRating: TCheckBox;
	boxUseSiteRating: TCheckBox;
	boxUseLastUpdated: TCheckBox;
	boxShowEditions, boxShowEditionsOfTVSeries: TCheckBox;
	boxDummyCovers: TCheckBox;
  cbxShowPersonDummyCovers: TCheckBox;
	boxShowCoversInList: TCheckBox;
	boxHideNavi, boxHidePhotosCovers, boxShowFileNames: TCheckBox;
	boxShowSeasons, boxMinimaList, boxPersonStatsInCollection: TCheckBox;
	boxShotTab, boxPosterTab, boxAwardsTab, boxActorTab, boxParameterTab, boxLoanTab, boxSeasonTab, boxDescriptionTab, boxTrailerTab: TCheckBox;
	tabGroup, multiThumbGroup, filmographyGroup, MoviePageGroup, rightShotsGroup: TGroupBox;
	labMaxCoverSize, labCoverX, labThumbCellSize, labThumbCellX, labMaxPhotoSize, labThPhotoCellSize, labPhotoX, labThPhotoCellX, labCoverWidth: TLabel;
	edThCoverWidth, edThCoverHeight, edThumbCellWidth, edThumbCellHeight, edThPhotoWidth, edThPhotoHeight, edThPhotoCellWidth, edThPhotoCellHeight, edCoverWidth: TEdit;
	boxCutThumb, boxCutPhotoThumb, boxUseThumbs: TCheckBox;
	my_value: Integer;
	boxOnlyMoviesInCollection, boxShowInCollectionIcon, boxShowSeenIcon, boxShowWantedIcon, boxShowForSaleIcon, boxIconsOnTheRight, boxSortIcons, boxOnlyShots: TCheckBox;
	boxShowLinks, boxShowCodecLogos, boxShowEditionsOnMainTab, boxOnlyEditionName, boxFixedContentsWidth, boxSeenOnPlay, boxBackdropsOnTheRight, boxShotsOnTheRight, boxCoversOnTheRight, boxPostersOnTheRight, boxOnlyUnseenShots: TCheckBox;
	ThumbsSizeChanged, Thumbs2SizeChanged: Boolean;

function ProgramType(): Integer;
begin
  Result := GAMENIZER_PROGRAM;
end;

procedure BtnDefaultClick(Sender: TButton);
begin
	ThumbsSizeChanged := True;
	Thumbs2SizeChanged := True;
	edShots.Text := '5';
	edPhotos.Text := '5';
	edThCoverWidth.Text := IntToStr(DefaultMultiCoverWidth[ProgramType]);
	edThCoverHeight.Text := IntToStr(DefaultMultiCoverHeight[ProgramType]);
	edThumbCellWidth.Text := IntToStr(DefaultMultiCellWidth[ProgramType]);
	edThumbCellHeight.Text := IntToStr(DefaultMultiCellHeight[ProgramType]);
	edCoverRows.Text := IntToStr(DefaultCoverRows);
	boxCutThumb.Checked := True;
	edThPhotoWidth.Text := IntToStr(DefaultMultiCoverWidth[ProgramType]);
	edThPhotoHeight.Text := IntToStr(DefaultMultiCoverHeight[ProgramType]);
	boxCutPhotoThumb.Checked := True;
	boxUseRating.Checked := True;
	boxUseSiteRating.Checked := True;
	boxUseLastUpdated.Checked := False;
	boxShowEditions.Checked := False;
	boxDummyCovers.Checked := True;
  cbxShowPersonDummyCovers.Checked := True;
	boxOnlyMoviesInCollection.Checked := False;
	boxHidePhotosCovers.Checked := False;
	boxShowFileNames.Checked := True;
	boxShowCoversInList.Checked := True;
	boxMinimaList.Checked := False;
	boxPersonStatsInCollection.Checked := False;
	boxUseThumbs.Checked := True;
	boxIconsOnTheRight.Checked := False;
	boxShowInCollectionIcon.Checked := True;
	boxShowWantedIcon.Checked := False;
	boxShowForSaleIcon.Checked := False;
	boxSortIcons.Checked := False;
//	boxOnlyShots.Checked := True;
	boxShowEditionsOnMainTab.Checked := True;
	boxOnlyEditionName.Checked := False;
	boxFixedContentsWidth.Checked := False;
	edCoverWidth.Text := IntToStr(DefaultThumbWidth);
end;

procedure ThumbsChanged(Sender: TObject; var Key: Word);
begin
	ThumbsSizeChanged := True;
end;

procedure Thumbs2Changed(Sender: TObject; var Key: Word);
begin
	Thumbs2SizeChanged := True;
end;

procedure ButtonClick(Sender: TButton);
var
	zn: integer;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    try
      zn:=StrToInt(edLinesMovies.Text);
      RegWriteInteger('BreezeLinesMovies', zn);
      zn:=StrToInt(edLinesPeople.Text);
      RegWriteInteger('BreezeLinesPeople', zn);
      zn:=StrToInt(edShots.Text);
      RegWriteInteger('ShotsCnt', zn);
      zn:=StrToInt(edPhotos.Text);
      RegWriteInteger('PhotosCnt', zn);
      zn:=StrToInt(edThCoverWidth.Text);
      RegWriteInteger('ThCoverWidth', zn);
      zn:=StrToInt(edThCoverHeight.Text);
      RegWriteInteger('ThCoverHeight', zn);
      zn:=StrToInt(edThumbCellWidth.Text);
      RegWriteInteger('ThumbCellWidth', zn);
      zn:=StrToInt(edThumbCellHeight.Text);
      RegWriteInteger('ThumbCellHeight', zn);
      zn:=StrToInt(edThPhotoWidth.Text);
      RegWriteInteger('ThPhotoWidth', zn);
      zn:=StrToInt(edThPhotoHeight.Text);
      RegWriteInteger('ThPhotoHeight', zn);
      zn:=StrToInt(edCoverWidth.Text);
      RegWriteInteger('ListCoverWidth', zn);
      zn:=StrToInt(edCoverRows.Text);
      RegWriteInteger('CoverRows', zn);
      if boxUseRating.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowRating', zn);
      if boxUseSiteRating.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowSiteRating', zn);
      if boxUseLastUpdated.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowLastUpdated', zn);
      if boxShowEditions.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowEditions', zn);
      if boxDummyCovers.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowDummyCoversNew', zn);

      RegWriteBoolean('ShowPersonDummyCoversNew', cbxShowPersonDummyCovers.Checked);

      if boxShowCoversInList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowCoversInList', zn);
      if boxOnlyMoviesInCollection.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowOnlyMoviesInCollection', zn);
      if boxHidePhotosCovers.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('HidePhotosCovers', zn);
      if boxShowFileNames.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowFileNames', zn);
      if boxMinimaList.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('MinimaList', zn);
      if boxPersonStatsInCollection.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('PersonStatsInCollection', zn);
      if boxCutThumb.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('CutThumb', zn);
      if boxCutPhotoThumb.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('CutPhotoThumb', zn);
      if boxUseThumbs.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('UseThumbs', zn);
      if boxIconsOnTheRight.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('IconsOnTheRight', zn);
      if boxShowInCollectionIcon.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowInCollectionIcon', zn);
      if boxShowWantedIcon.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowWantedIcon', zn);
      if boxShowForSaleIcon.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowForSaleIcon', zn);
      if boxSortIcons.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('SortIcons', zn);
      if boxShowCodecLogos.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowCodecLogos', zn);
      if boxShowEditionsOnMainTab.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('ShowEditionsOnMainTab', zn);
      if boxOnlyEditionName.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('OnlyEditionName', zn);
      if boxFixedContentsWidth.Checked then
        zn := 1
      else
        zn := 0;
      RegWriteInteger('FixedContentsWidthOnMoviePage', zn);

      RegWriteString('OriginalVersion', IntToStr(56));
      s:=GetLangStr(1334);

    except
    end;

    MultiShowRowHeight[ProgramType] := RegReadInteger('ThumbCellHeight',
      DefaultMultiCellHeight[ProgramType]);
    MultiShowImageWidth[ProgramType] := RegReadInteger('ThumbCellWidth',
      DefaultMultiCellWidth[ProgramType]);

    if Thumbs2SizeChanged then
    begin
      if ThumbsSizeChanged then
        ClearThumb(Thumbs2)
      else
        ClearThumb(Thumbs2, True);
    end;
    if ThumbsSizeChanged then begin
      ClearThumb(Thumbs, True);
    end;
  finally
    ResetRegistrySubKey();
  end;
end;

begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
    form1 := AForm;
    pageOptions := APageControl;

    f := TTabSheet.Create(pageOptions);
    f.Caption := GetLangStr(35000);
    f.Parent := pageOptions;
    f.PageControl := pageOptions;

    ThumbsSizeChanged := False;
    Thumbs2SizeChanged := False;

    MoviePageGroup := TGroupBox.Create(f);
    MoviePageGroup.Name := 'MoviePageGroup';
    MoviePageGroup.Parent := f;
    MoviePageGroup.SetBounds(10, 10, 320, 220);
    MoviePageGroup.Caption := GetLangStr(35259);

    boxUseRating := TCheckBox.Create(f);
    boxUseRating.Name := 'boxUseRating';
    boxUseRating.Parent := f;
    boxUseRating.SetBounds(20, 25, 300, 20);
    boxUseRating.Caption := GetLangStr(1420);
    my_value := RegReadInteger('ShowRating', 1);
    if my_value=1 then
      boxUseRating.Checked := True;

    boxUseSiteRating := TCheckBox.Create(f);
    boxUseSiteRating.Name := 'boxUseSiteRating';
    boxUseSiteRating.Parent := f;
    boxUseSiteRating.SetBounds(20, 45, 300, 20);
    boxUseSiteRating.Caption := GetLangStr(1533);
    my_value := RegReadInteger('ShowSiteRating', 1);
    if my_value=1 then
      boxUseSiteRating.Checked := True;


    labShots:=TLabel.Create(f);
    labShots.Name := 'labShots';
    labShots.Parent := f;
    labShots.SetBounds(20, 210, 110, 25);
    labShots.Caption := GetLangStr(35260);

    edShots := TEdit.Create(f);
    edShots.Name := 'edShots';
    edShots.Parent := f;
    edShots.SetBounds(300, 205, 20, 25);
    edShots.Text := IntToStr(RegReadInteger('ShotsCnt', 5));

    boxShowCodecLogos := TCheckBox.Create(f);
    boxShowCodecLogos.Name := 'ShowCodecLogos';
    boxShowCodecLogos.Parent := f;
    boxShowCodecLogos.SetBounds(20, 65, 250, 20);
    boxShowCodecLogos.Caption := GetLangStr(1494);
    my_value := RegReadInteger('ShowCodecLogos', 1);
    if my_value = 1 then
      boxShowCodecLogos.Checked := True;

    boxShowFileNames := TCheckBox.Create(f);
    boxShowFileNames.Name := 'boxShowFileNames';
    boxShowFileNames.Parent := f;
    boxShowFileNames.SetBounds(20, 85, 300, 20);
    boxShowFileNames.Caption := GetLangStr(35261);
    my_value := RegReadInteger('ShowFileNames', 1);
    if my_value=1 then
      boxShowFileNames.Checked := True;


    boxShowEditions := TCheckBox.Create(f);
    boxShowEditions.Name := 'boxShowEditions';
    boxShowEditions.Parent := f;
    boxShowEditions.SetBounds(20, 105, 300, 20);
    boxShowEditions.Caption := GetLangStr(1424);
    my_value := RegReadInteger('ShowEditions', 0);
    if my_value=1 then
      boxShowEditions.Checked := True;


    boxShowEditionsOnMainTab := TCheckBox.Create(f);
    boxShowEditionsOnMainTab.Name := 'boxShowEditionsOnMainTab';
    boxShowEditionsOnMainTab.Parent := f;
    boxShowEditionsOnMainTab.SetBounds(20, 125, 300, 20);
    boxShowEditionsOnMainTab.Caption := GetLangStr(2950);
    my_value := RegReadInteger('ShowEditionsOnMainTab', 1);
    if my_value=1 then
      boxShowEditionsOnMainTab.Checked := True;


    boxOnlyEditionName := TCheckBox.Create(f);
    boxOnlyEditionName.Name := 'boxOnlyEditionName';
    boxOnlyEditionName.Parent := f;
    boxOnlyEditionName.SetBounds(20, 145, 300, 20);
    boxOnlyEditionName.Caption := GetLangStr(2951);
    my_value := RegReadInteger('OnlyEditionName',  0);
    if my_value=1 then
      boxOnlyEditionName.Checked := True;

    boxFixedContentsWidth := TCheckBox.Create(f);
    boxFixedContentsWidth.Name := 'boxFixedContentsWidth';
    boxFixedContentsWidth.Parent := f;
    boxFixedContentsWidth.SetBounds(20, 165, 300, 20);
    boxFixedContentsWidth.Caption := GetLangStr(2967);
    my_value := RegReadInteger('FixedContentsWidthOnMoviePage', 0);
    if my_value=1 then
      boxFixedContentsWidth.Checked := True;

    multiThumbGroup := TGroupBox.Create(f);
    multiThumbGroup.Name := 'multiThumbGroup';
    multiThumbGroup.Parent := f;
    multiThumbGroup.SetBounds(340, 10, 345, 150);
    multiThumbGroup.Caption := GetLangStr(1467);

    labMaxCoverSize := TLabel.Create(f);
    labMaxCoverSize.Name := 'labMaxCoverSize';
    labMaxCoverSize.Parent := f;
    labMaxCoverSize.SetBounds(350, 30, 100, 25);
    labMaxCoverSize.Caption := GetLangStr(1468);

    edThCoverWidth := TEdit.Create(f);
    edThCoverWidth.Name := 'edThCoverWidth';
    edThCoverWidth.Parent := f;
    edThCoverWidth.SetBounds(560, 25, 30, 25);
    edThCoverWidth.Text := IntToStr(RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[ProgramType]));
    edThCoverWidth.OnKeyDown := @Thumbs2Changed;

    labCoverX := TLabel.Create(f);
    labCoverX.Name := 'labCoverX';
    labCoverX.Parent := f;
    labCoverX.SetBounds(595, 30, 10, 20);
    labCoverX.Caption := 'X';

    edThCoverHeight := TEdit.Create(f);
    edThCoverHeight.Name := 'edThCoverHeight';
    edThCoverHeight.Parent := f;
    edThCoverHeight.SetBounds(605, 25, 30, 25);
    edThCoverHeight.Text := IntToStr(RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[ProgramType]));
    edThCoverHeight.OnKeyDown := @Thumbs2Changed;

    labThumbCellSize := TLabel.Create(f);
    labThumbCellSize.Name := 'labThumbCellSize';
    labThumbCellSize.Parent := f;
    labThumbCellSize.SetBounds(350, 55, 100, 25);
    labThumbCellSize.Caption := GetLangStr(1469);

    edThumbCellWidth := TEdit.Create(f);
    edThumbCellWidth.Name := 'edThumbCellWidth';
    edThumbCellWidth.Parent := f;
    edThumbCellWidth.SetBounds(560, 60, 30, 25);
    edThumbCellWidth.Text := IntToStr(RegReadInteger('ThumbCellWidth', DefaultMultiCellWidth[ProgramType]));
    edThumbCellWidth.OnKeyDown := @Thumbs2Changed;

    labThumbCellX := TLabel.Create(f);
    labThumbCellX.Name := 'labThumbCellX';
    labThumbCellX.Parent := f;
    labThumbCellX.SetBounds(595, 55, 10, 20);
    labThumbCellX.Caption := 'X';

    edThumbCellHeight := TEdit.Create(f);
    edThumbCellHeight.Name := 'edThumbCellHeight';
    edThumbCellHeight.Parent := f;
    edThumbCellHeight.SetBounds(605, 60, 30, 25);
    edThumbCellHeight.Text := IntToStr(RegReadInteger('ThumbCellHeight', DefaultMultiCellHeight[ProgramType]));
    edThumbCellHeight.OnKeyDown := @Thumbs2Changed;

    boxCutThumb := TCheckBox.Create(f);
    boxCutThumb.Name := 'boxCutThumb';
    boxCutThumb.Parent := f;
    boxCutThumb.SetBounds(350, 80, 280, 20);
    boxCutThumb.Caption := GetLangStr(1471);
    my_value := RegReadInteger('CutThumb', 1);
    if my_value = 1 then
      boxCutThumb.Checked := True;
    boxCutThumb.OnClick := @Thumbs2Changed;

    labMaxPhotoSize := TLabel.Create(f);
    labMaxPhotoSize.Name := 'labMaxPhotoSize';
    labMaxPhotoSize.Parent := f;
    labMaxPhotoSize.SetBounds(350, 105, 100, 20);
    labMaxPhotoSize.Caption := GetLangStr(1472);

    edThPhotoWidth := TEdit.Create(f);
    edThPhotoWidth.Name := 'edThPhotoWidth';
    edThPhotoWidth.Parent := f;
    edThPhotoWidth.SetBounds(560, 100, 30, 25);
    edThPhotoWidth.Text := IntToStr(RegReadInteger('ThPhotoWidth', DefaultMultiCoverWidth[ProgramType]));
    edThPhotoWidth.OnKeyDown := @Thumbs2Changed;

    labPhotoX := TLabel.Create(f);
    labPhotoX.Name := 'labPhotoX';
    labPhotoX.Parent := f;
    labPhotoX.SetBounds(595, 105, 10, 20);
    labPhotoX.Caption := 'X';

    edThPhotoHeight := TEdit.Create(f);
    edThPhotoHeight.Name := 'edThPhotoHeight';
    edThPhotoHeight.Parent := f;
    edThPhotoHeight.SetBounds(605, 100, 30, 25);
    edThPhotoHeight.Text := IntToStr(RegReadInteger('ThPhotoHeight', DefaultMultiCoverHeight[ProgramType]));
    edThPhotoHeight.OnKeyDown := @Thumbs2Changed;

    boxCutPhotoThumb := TCheckBox.Create(f);
    boxCutPhotoThumb.Name := 'boxCutPhotoThumb';
    boxCutPhotoThumb.Parent := f;
    boxCutPhotoThumb.SetBounds(350, 125, 280, 20);
    boxCutPhotoThumb.Caption := GetLangStr(1474);
    my_value := RegReadInteger('CutPhotoThumb', 1);
    if my_value = 1 then
      boxCutPhotoThumb.Checked := True;
    boxCutPhotoThumb.OnClick := @Thumbs2Changed;

    filmographyGroup := TGroupBox.Create(f);
    filmographyGroup.Name := 'filmographyGroup';
    filmographyGroup.Parent := f;
    filmographyGroup.SetBounds(340, 160, 345, 150);
    filmographyGroup.Caption := GetLangStr(35262);

    boxOnlyMoviesInCollection := TCheckBox.Create(f);
    boxOnlyMoviesInCollection.Name := 'boxOnlyMoviesInCollection';
    boxOnlyMoviesInCollection.Parent := f;
    boxOnlyMoviesInCollection.SetBounds(350, 180, 250, 20);
    boxOnlyMoviesInCollection.Caption := GetLangStr(35263);
    my_value := RegReadInteger('ShowOnlyMoviesInCollection', 0);
    if my_value = 1 then
      boxOnlyMoviesInCollection.Checked := True;

    boxShowInCollectionIcon := TCheckBox.Create(f);
    boxShowInCollectionIcon.Name := 'boxShowInCollectionIcon';
    boxShowInCollectionIcon.Parent := f;
    boxShowInCollectionIcon.SetBounds(350, 200, 250, 20);
    boxShowInCollectionIcon.Caption := GetLangStr(1483);
    my_value := RegReadInteger('ShowInCollectionIcon', 1);
    if my_value = 1 then
      boxShowInCollectionIcon.Checked := True;


    boxShowWantedIcon := TCheckBox.Create(f);
    boxShowWantedIcon.Name := 'boxShowWantedIcon';
    boxShowWantedIcon.Parent := f;
    boxShowWantedIcon.SetBounds(350, 220, 250, 20);
    boxShowWantedIcon.Caption := GetLangStr(1485);
    my_value := RegReadInteger('ShowWantedIcon', 0);
    if my_value = 1 then
      boxShowWantedIcon.Checked := True;

    boxShowForSaleIcon := TCheckBox.Create(f);
    boxShowForSaleIcon.Name := 'boxShowForSaleIcon';
    boxShowForSaleIcon.Parent := f;
    boxShowForSaleIcon.SetBounds(350, 240, 250, 20);
    boxShowForSaleIcon.Caption := GetLangStr(1486);
    my_value := RegReadInteger('ShowForSaleIcon', 0);
    if my_value = 1 then
      boxShowForSaleIcon.Checked := True;

    boxIconsOnTheRight := TCheckBox.Create(f);
    boxIconsOnTheRight.Name := 'boxIconsOnTheRight';
    boxIconsOnTheRight.Parent := f;
    boxIconsOnTheRight.SetBounds(350, 260, 250, 20);
    boxIconsOnTheRight.Caption := GetLangStr(1487);
    my_value := RegReadInteger('IconsOnTheRight', 0);
    if my_value = 1 then
      boxIconsOnTheRight.Checked := True;

    boxSortIcons := TCheckBox.Create(f);
    boxSortIcons.Name := 'boxSortIcons';
    boxSortIcons.Parent := f;
    boxSortIcons.SetBounds(350, 280, 250, 20);
    boxSortIcons.Caption := GetLangStr(1488);
    my_value := RegReadInteger('SortIcons', 0);
    if my_value = 1 then
      boxSortIcons.Checked := True;

    (* End filmography options *)

    labLinesMovies:=TLabel.Create(f);
    labLinesMovies.Name := 'labLinesMovies';
    labLinesMovies.Parent := f;
    labLinesMovies.SetBounds(340, 320, 110, 25);
    labLinesMovies.Caption := GetLangStr(1414);

    edLinesMovies := TEdit.Create(f);
    edLinesMovies.Name := 'edLinesMovies';
    edLinesMovies.Parent := f;
    edLinesMovies.SetBounds(660, 315, 20, 25);
    edLinesMovies.Text := IntToStr(RegReadInteger('BreezeLinesMovies', DefaultLinesMovies));

    labLinesPeople:=TLabel.Create(f);
    labLinesPeople.Name := 'labLinesPeople';
    labLinesPeople.Parent := f;
    labLinesPeople.SetBounds(340, 345, 110, 25);
    labLinesPeople.Caption := GetLangStr(1415);

    edLinesPeople := TEdit.Create(f);
    edLinesPeople.Name := 'edLinesPeople';
    edLinesPeople.Parent := f;
    edLinesPeople.SetBounds(660, 340, 20, 25);
    edLinesPeople.Text := IntToStr(RegReadInteger('BreezeLinesPeople', DefaultLinesPeople));

    labPhotos:=TLabel.Create(f);
    labPhotos.Name := 'labPhotos';
    labPhotos.Parent := f;
    labPhotos.SetBounds(340, 370, 110, 25);
    labPhotos.Caption := GetLangStr(35264);

    edPhotos := TEdit.Create(f);
    edPhotos.Name := 'edPhotos';
    edPhotos.Parent := f;
    edPhotos.SetBounds(660, 365, 20, 25);
    edPhotos.Text := IntToStr(RegReadInteger('PhotosCnt', 5));

    boxUseThumbs := TCheckBox.Create(f);
    boxUseThumbs.Name := 'boxUseThumbs';
    boxUseThumbs.Parent := f;
    boxUseThumbs.SetBounds(10, 335, 320, 20);
    boxUseThumbs.Caption := GetLangStr(1476);
    my_value := RegReadInteger('UseThumbs', 1);
    if my_value = 1 then
      boxUseThumbs.Checked := True;

    boxShowCoversInList := TCheckBox.Create(f);
    boxShowCoversInList.Name := 'boxShowCoversInList';
    boxShowCoversInList.Parent := f;
    boxShowCoversInList.SetBounds(10, 355, 320, 20);
    boxShowCoversInList.Caption := GetLangStr(35265);
    my_value := RegReadInteger('ShowCoversInList', 1);
    if my_value=1 then
      boxShowCoversInList.Checked := True;

    boxMinimaList := TCheckBox.Create(f);
    boxMinimaList.Name := 'boxMinimaList';
    boxMinimaList.Parent := f;
    boxMinimaList.SetBounds(10, 375, 320, 20);
    boxMinimaList.Caption := GetLangStr(35266);
    my_value := RegReadInteger('MinimaList', 0);
    if my_value=1 then
      boxMinimaList.Checked := True;


    boxUseLastUpdated := TCheckBox.Create(f);
    boxUseLastUpdated.Name := 'boxUseLastUpdated';
    boxUseLastUpdated.Parent := f;
    boxUseLastUpdated.SetBounds(10, 395, 320, 20);
    boxUseLastUpdated.Caption := GetLangStr(1423);
    my_value := RegReadInteger('ShowLastUpdated', 0);
    if my_value=1 then
      boxUseLastUpdated.Checked := True;

    boxPersonStatsInCollection := TCheckBox.Create(f);
    boxPersonStatsInCollection.Name := 'boxPersonStatsInCollection';
    boxPersonStatsInCollection.Parent := f;
    boxPersonStatsInCollection.SetBounds(10, 415, 320, 20);
    boxPersonStatsInCollection.Caption := GetLangStr(35267);
    my_value := RegReadInteger('PersonStatsInCollection', 0);
    if my_value=1 then
      boxPersonStatsInCollection.Checked := True;

    boxDummyCovers := TCheckBox.Create(f);
    boxDummyCovers.Name := 'boxDummyCovers';
    boxDummyCovers.Parent := f;
    boxDummyCovers.SetBounds(10, 435, 350, 20);
    boxDummyCovers.Caption := GetLangStr(35268);
    my_value := RegReadInteger('ShowDummyCoversNew', 1);
    if my_value=1 then
      boxDummyCovers.Checked := True;

    cbxShowPersonDummyCovers := TCheckBox.Create(f);
    cbxShowPersonDummyCovers.Name := 'cbxShowPersonDummyCovers';
    cbxShowPersonDummyCovers.Parent := f;
    cbxShowPersonDummyCovers.SetBounds(10, 455, 350, 20);
    cbxShowPersonDummyCovers.Caption := GetLangStr(35269);
    cbxShowPersonDummyCovers.Checked := RegReadBoolean('ShowPersonDummyCoversNew', True);

    boxHidePhotosCovers := TCheckBox.Create(f);
    boxHidePhotosCovers.Name := 'boxHidePhotosCovers';
    boxHidePhotosCovers.Parent := f;
    boxHidePhotosCovers.SetBounds(10, 475, 400, 20);
    boxHidePhotosCovers.Caption := GetLangStr(35270);
    my_value := RegReadInteger('HidePhotosCovers', 0);
    if my_value=1 then
      boxHidePhotosCovers.Checked := True;

    labCoverWidth:=TLabel.Create(f);
    labCoverWidth.Name := 'labCoverWidth';
    labCoverWidth.Parent := f;
    labCoverWidth.SetBounds(10, 240, 110, 25);
    labCoverWidth.Caption := GetLangStr(1497);

    edCoverWidth := TEdit.Create(f);
    edCoverWidth.Name := 'edCoverWidth';
    edCoverWidth.Parent := f;
    edCoverWidth.SetBounds(300, 235, 20, 25);
    edCoverWidth.Text := IntToStr(RegReadInteger('ListCoverWidth', DefaultThumbWidth));
    edCoverWidth.OnKeyDown := @ThumbsChanged;

    labCoverRows:=TLabel.Create(f);
    labCoverRows.Name := 'labCoverRows';
    labCoverRows.Parent := f;
    labCoverRows.SetBounds(10, 315, 110, 25);
    labCoverRows.Caption := GetLangStr(35271);

    edCoverRows := TEdit.Create(f);
    edCoverRows.Name := 'edCoverRows';
    edCoverRows.Parent := f;
    edCoverRows.SetBounds(300, 310, 20, 25);
    edCoverRows.Text := IntToStr(RegReadInteger('CoverRows', DefaultCoverRows));

    (*btnDefault := TButton.Create(f);
    btnDefault.Name := 'btnDefault';
    btnDefault.Parent := f;
    btnDefault.SetBounds(20, {480}f.Height - 30, 160, 25);
    btnDefault.Caption := GetLangStr(1475);
    btnDefault.OnClick := @BtnDefaultClick;

    b := TButton.Create(f);
    b.Name := 'btnOK';
    b.Parent := f;
    b.SetBounds(300, {480}f.Height - 30, 80, 25);
    b.Caption := '&OK';
    b.OnClick := @ButtonClick;*)
    ASaveButtonCallback := @ButtonClick;
    ADefaultButtonCallback := @BtnDefaultClick;
  finally
    ResetRegistrySubKey();
  end;
end;

begin

end.