﻿program orange_program_part2;

uses 'orange_program_variables.pas', 'orange_program_global.pas';

function GenerateItemsBlock(AProgramType: Integer; var AItemsCount: Integer): string;
var
  sl: TStringList;
  i, j, page_width, code: integer;
  year, LastAdd, current_site, FileName, NoCoverFile, s, rate, bckgrnd: string;
  RecordCount, rating, LastCode, ShowLastUpdated: integer;
  IMDBRating, SiteRating: double;
  PicWidth, PicHeight, page_width_copy, StandardHomeCoverWidth, RatingIndex: Integer;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[AProgramType]);
  sl:=TStringList.Create;
  try
	LastAdd := '';
	RatingIndex := RegReadInteger('MyRatingTabRating', 1);
	if RatingIndex = 2 then begin
		current_site := RegReadString('MovieScript', '');
		i := Pos(' (', current_site);
		if i>0 then
			delete(current_site, i, length(current_site)-i+1);
	end;
	bckgrnd := 'background-color: '+CellColor;
	ShowLastUpdated := RegReadInteger('ShowLastUpdated', 0);
	GenerateSQLForMoviesPages(sl, AProgramType, HomeTab[AProgramType], -1);
    AItemsCount:=ExecuteSQL(sl.text);
    RecordCount := AItemsCount;
	page_width:=GetHTMLWidth - WholePageBorder - ArrowWidth;
	page_width_copy := page_width;
	StandardHomeCoverWidth := Round(NoCoverWidthes[AProgramType] * (HomeCoverHeight[AProgramType] / NoCoverHeight));
    if RecordCount>0 then begin
		i:=1;
		j:=0;
		LastCode:=0;
		while (page_width_copy >= 0) and (i<=RecordCount) do
    begin
			code:=GetIntegerField('code');
			if sl.IndexOf(IntToStr(code)) < 0 then begin
				if j=0 then
					LastAdd:=LastAdd+'<table class="white-bck-block"><tr><td>';
				j:=j+1;
				LastCode:=code;
				sl.Add(IntToStr(code));
				PicHeight := GetIntegerField('height');
				if (PicHeight > 0) and (GetIntegerField('mode') = 1) then
					PicWidth := Round(GetIntegerField('width') * (HomeCoverHeight[AProgramType] / PicHeight)) + BigImageBorders
				else
					PicWidth := StandardHomeCoverWidth + BigImageBorders;
				page_width_copy := page_width_copy - PicWidth;
				if page_width_copy >= 0 then begin
					year:=GetStringField('year');

					rating:=GetIntegerField('rating');
					rate:=GetStarRatingWithoutLinks(rating);

					IMDBRating := GetFloatField('imdb_rating');
					NoCoverFile := NO_COVER_FILE[GetIntegerField('item_type')];
					if year<>'' then
						s:=GetLangStr(169)+': '+year+'. '+rate
					else
						s:=rate;
						
					if (GetIntegerField('mode') = 1) then
						FileName := GetImageFileName(GetStringField('path'), ThumbsHomeMovies, NoCoverFile, 0, HomeCoverHeight[AProgramType])
					else
						FileName := GetImageFileName('', ThumbsHomeMovies, NoCoverFile, 0, HomeCoverHeight[AProgramType]);
					LastAdd:=LastAdd+'<div class="home-image-place"><div class="img-outer"><div class="img-inner"><a class="pic"'+format(' href="movie:%d"><img style="height: %dpx" border="0" src="%s"></a></div></div>', [code, HomeCoverHeight[AProgramType], FileName]);
					LastAdd:=LastAdd + '<div class="image-text">';
					
					if (rate<>'') and (RegReadInteger('ShowRating', 1) = 1) then
						LastAdd := LastAdd+rate+'<br>';
					//LastAdd := LastAdd + '<p>';
					if (RatingIndex = 2) and (HomeMovieTab = 2) and (current_site <> 'imdb') then begin
						SiteRating := GetFloatField('SiteRating');
						if SiteRating <> 0 then
							LastAdd:=LastAdd+'<div style="vertical-align: middle; margin-top: 5;">' + format('%s: %0.1f</div>', [GetLangStr(3419), SiteRating]);
					end
					else if IMDBRating <> 0 then
						LastAdd:=LastAdd+format('IMDB: %0.1f<br>', [IMDBRating]);
					
					LastAdd := LastAdd+format('<a href="movie:%d">%s</a></div>', [code, GetStringField('title')]);
					LastAdd := LastAdd + '</div>';
				end;
			end;
			GetNextRecord;
			i:=i+1;
		end;
	end;
	sl.Clear;
	result := LastAdd;
  finally
    ResetRegistrySubKey();
    sl.Free();
  end;
end;

function GenerateTabsForBlock(AProgramType: Integer; var AItemsCount: Integer; EnclosedContent: String): String;
var
  i, j, page_width: integer;
  all, prefix: string;
  ShowLastUpdated: integer;
  TabNameMode, MoviesMore: String;
  FullTabsWidth, ShortTabsWidth: Integer;
  TabName: array [1..4] of string;
  TabIndexMatrix: array [0..3, 1..4] of Integer;
begin
	result := '';
	all := '';
	page_width:=GetHTMLWidth - WholePageBorder - ArrowWidth;
	ShowLastUpdated := RegReadInteger('ShowLastUpdated', 0);
	if ShowLastUpdated = 0 then begin
		FullTabsWidth := HomeTabWidth * 4;
		ShortTabsWidth := TabWidth * 4;
	end
	else begin
		FullTabsWidth := HomeTabWidth * 3;
		ShortTabsWidth := TabWidth * 3;
	end;
	//full tab names
	if (page_width > FullTabsWidth) then begin
		TabNameMode := '';
		if ShowLastUpdated = 0 then
			TabName[1] := GetLangStr(LangLastAdded[AProgramType])
		else
			TabName[1] := GetLangStr(LangLastUpdated[AProgramType]);
		TabName[2] := GetLangStr(LangLastUpdated[AProgramType]);
		TabName[3] := GetLangStr(LangBestRated[AProgramType]);
		TabName[4] := GetLangStr(LangUnseen[AProgramType]);
	end
	//short tab names
	else if (page_width >= ShortTabsWidth) then begin
		TabNameMode := '-short';
		TabName[1] := GetLangStr(LangLastAddedShort[AProgramType]);
		TabName[2] := GetLangStr(LangBestRatedShort[AProgramType]);
		TabName[3] := GetLangStr(LangUnseenShort[AProgramType]);
		TabName[4] := '';
	end
	//no tabs
	else
		TabNameMode := 'none';
		
	// Tab indexes
	for i := 0 to 3 do begin
		for j := 1 to 4 do begin
			if (i = AProgramType) then
				TabIndexMatrix[i, j] := j
			else
				TabIndexMatrix[i, j] := HomeTab[i];
		end;
	end;

	if TabNameMode <> 'none' then
  begin
		all := all + '<table class="tabs" style="margin: 10px 0px 10px 0px;"><tr><td>';
		all := all + GetTab(HomeTab[AProgramType]=1, -100, TabName[1], Format('modern_home:%d,%d,%d,%d,%d', [TabIndexMatrix[0, 1], TabIndexMatrix[1, 1], TabIndexMatrix[2, 1], TabIndexMatrix[3, 1], HomePersonTab]));
		i := HomeTab[AProgramType];
		all := all + GetTab(HomeTab[AProgramType]=2, i, TabName[2], Format('modern_home:%d,%d,%d,%d,%d', [TabIndexMatrix[0, 2], TabIndexMatrix[1, 2], TabIndexMatrix[2, 2], TabIndexMatrix[3, 2], HomePersonTab]));
		i := HomeTab[AProgramType] - 1;
		all := all + GetTab(HomeTab[AProgramType]=3, i, TabName[3], Format('modern_home:%d,%d,%d,%d,%d', [TabIndexMatrix[0, 3], TabIndexMatrix[1, 3], TabIndexMatrix[2, 3], TabIndexMatrix[3, 3], HomePersonTab]));
		i := HomeTab[AProgramType] - 2;
		if (TabName[4] <> '') and (ShowLastUpdated = 0) then
    begin
			all := all + GetTab(HomeTab[AProgramType]=4, i, TabName[4], Format('modern_home:%d,%d,%d,%d,%d', [TabIndexMatrix[0, 4], TabIndexMatrix[1, 4], TabIndexMatrix[2, 4], TabIndexMatrix[3, 4], HomePersonTab]));
			i := HomeTab[AProgramType] - 3;
		end;
		if i = 1 then
			prefix := ''
		else
			prefix := 'in';
		if HomeTab[AProgramType] = 1 then 
			MoviesMore := Format('userref:%d,%s', [UserrefAdjuster[AProgramType] + 1, GetLangStr(LangLastAdded[AProgramType])]);
		if HomeTab[AProgramType] = 2 then
			MoviesMore := Format('userref:%d,%s', [UserrefAdjuster[AProgramType] + 2, GetLangStr(LangLastUpdated[AProgramType])]);
		if HomeTab[AProgramType] = 3 then
			MoviesMore := Format('userref:%d,%s', [UserrefAdjuster[AProgramType] + 3, GetLangStr(LangBestRated[AProgramType])]);
		if (HomeTab[AProgramType] = 4) or (ShowLastUpdated = 1) then
			MoviesMore := Format('userref:%d,%s', [UserrefAdjuster[AProgramType] + 4, GetLangStr(LangUnseen[AProgramType])]);
		all := all + '<div class="tab-end" style="background-image: url('+ GetProperPath(Format('%s%sactive-tab-end.gif', [ImgPath, prefix])) + ');"></div>';
		all := all + '<div class="orange-line"></div></td></tr></table>';
	end
	else
		all := all + '<div class="free-space"></div>';
	
	all:=all+EnclosedContent+'</td>';
	all := all + '<td class="arrow-left-home"><a class="pic" href="'+MoviesMore+'">' + Format('<img border="0" src="%sarrow-left.gif"/>', [ImgPath])+'</a></td>';
	all:=all+'</tr></table>';
	result := all;
end; 

function GenerateLitresBlock(): string;
var
  I: Integer;
  PicWidth: Integer;
  PicHeight: Integer;
  AllPicWidth: Integer;
  page_width: Integer;
  page_width_copy: Integer;
   // Litres books variables
  LitresBooksCount: Integer;
  LitresID: integer;
  LitresBookTitle: string;
  LitresBookAuthor: string;
  LitresBookCover: string;
  LitresBookYear: string;
  LitresGenres: string;
  LitresImagesWidth: integer;
  LitresImagesHeight: integer;
begin
  Result := '';
  AllPicWidth := 0;
  page_width := GetHTMLWidth - WholePageBorder - ArrowWidth;
  page_width_copy := page_width;
	if ((RegReadBoolean('HomePageShowLitres', DefaultLitresBlockVisible)) and
      (GetLitresBooksCount() > 0)) then
  begin
		Result := '<table style="color: white; text-align: center; vertical-align: top; margin: 10px; border-collapse: collapse;"><tr>';
		page_width_copy := page_width;
		LitresBooksCount := GetLitresBooksCount();
		for I := 0 to (LitresBooksCount - 1) do
		begin
		  if (page_width_copy < 0) then
			  Break;
		  FillLitresBookInfo(I, LitresID, LitresBookTitle, LitresBookAuthor,
			LitresBookCover, LitresBookYear, LitresGenres, LitresImagesWidth, LitresImagesHeight);
		  if (not MyFileExists(LitresBookCover)) then
			  LitresBookCover:=ImgPath+'nocoverbooks.jpg';
		  PicHeight := LitresImagesHeight;
		  PicWidth := Round(LitresImagesWidth * (LitresImagesHeight / LitresCoverHeight)) + NormalImageBorders * 2;
		  page_width_copy := page_width_copy - PicWidth;
		  if page_width_copy > 0 then
      begin
        AllPicWidth := AllPicWidth + PicWidth;
        Result := Result + Format('<td style="background-color: #3e99c1; width: 30px; padding: %d;">', [SmallImageBorder]) + '<div style="background-color: white; border: 1px solid ' + WhiteAreaBorderColor + '; padding: 2px; margin: 5 ' + IntToStr(BigImageBorders div 2) + '">';
        Result:=Result+'<a class="pic"'+format(' href="LitresBook:%d"><img style="height: %dpx" border="0" src="%s" alt="%s"></a></div>', [LitresID, LitresCoverHeight, LitresBookCover, LitresBookTitle]);
        if Length(LitresBookTitle) > MaxTitleLength then
          LitresBookTitle := copy(LitresBookTitle, 1, MaxTitleLength - 3) + '...';
        Result := Result+'<p style="margin: 0 0;">'+format('<a class="litres" href="LitresBook:%d">%s</a></p></td>', [LitresID, LitresBookTitle]);
		  end;
		end;
		Result := Result + '<td style="vertical-align: middle; padding-left: 20;"><a class="pic" href="litres"><img border="0" ' + Format('src="%sarrow-right.gif"></td>', [ImgPath]);
		Result := Result + '</tr></table>';
	end;
end;


function GenerateMediaBlock(AProgramType: Integer; var AItemsCount: Integer): string;
var
	temp: String;
begin
  Result := '';
  AItemsCount := 0;
  if (IsProgramUsed(AProgramType)) then
  begin
    temp := GenerateItemsBlock(AProgramType, AItemsCount);
  	if temp <> '' then
		  result := GenerateTabsForBlock(AProgramType, AItemsCount, temp);
  end;
end;

function NeedShowLogo(ANumberOfMovies: Integer; ANumberOfAlbums: Integer;
  ANumberOfBooks: Integer; ANumberOfGames: Integer; ANumberOfPersons: Integer): Boolean;
var
  BreezeLogoIdx: Integer;
begin
  Result := False;
  BreezeLogoIdx := RegReadInteger('BreezeLogo', DefaultOrangeLogo);
  case BreezeLogoIdx of
    0: Result := (ANumberOfMovies < 1) or (ANumberOfPersons < 1) or (ANumberOfAlbums < 1) or (ANumberOfBooks < 1) or (ANumberOfGames < 1);
    1: Result := True;
  end;
end;

function GetHomeModern(HomeMovieMode, HomeAlbumMode, HomeBookMode, HomeGameMode: Integer;
  HomePersonMode: Integer): string;
var
  sl, PreviousCodes: TStringList;
  PersonCode, i, j, kol, kol2, page_width, code, my_i: integer;
  all, description, genre, year, director, writer, actor, bio, character, movie, LastAdd: string;
  FileName, site, url, postfix, s, rate: string;
  RecordCount, rating, LastCode, ShowLastUpdated: integer;
  IMDBRating, SiteRating: double;
  MyTabs, TabNameMode, Tab1Mode, Tab2Mode, Tab3Mode, Tab4Mode, MoviesMore, PersonsMore, LastUpdatedTab: String;
  myDate: TDateTime;
  full_date, tmp, dbfilename, mylogo, bckgrnd, prefix: String;
  PicWidth, PicHeight, page_width_copy, loaned_movies, FullTabsWidth, ShortTabsWidth, StandardHomeCoverWidth: Integer;
  ShowLinks, Birthdays: Boolean;
  RatingIndex: Integer;
  NumberOfMovies, NumberOfAlbums, NumberOfBooks, NumberOfGames, NumberOfPeople: Integer;
  current_site, sortby_string, mc_rating: String;
  TabName: array [1..4] of string;
  DateDay: Integer;
  DateYear: Integer;
  DateMonth: Integer;
  NoCoverFile: string;
  NoPhotoFile: string;
  ProgramType: Integer;
  GamesBlock: string;
  MoviesBlock: string;
  AlbumsBlock: string;
  BooksBlock: string;
  LitresBlock: string;
  ProgramTypesSQL: string;
begin
	result:='';
	current_site := '';
	ShowLinks := False;
	bckgrnd := 'background-color: '+CellColor;
	PreviousCodes := TStringList.Create;
	
	MoviesBlock := '';
	AlbumsBlock := '';
	BooksBlock := '';
  GamesBlock := '';
	
	NumberOfBooks := 0;
	NumberOfMovies := 0;
  NumberOfGames := 0;
	NumberOfAlbums := 0;
	NumberOfPeople := 0;
	
	HomeTab[0] := HomeMovieMode;
	HomeTab[1] := HomeAlbumMode;
	HomeTab[2] := HomeBookMode;
  HomeTab[3] := HomeGameMode;
	
	HomeMovieTab := HomeMovieMode;
	HomeAlbumTab := HomeAlbumMode;
	HomeBookTab := HomeBookMode;
  HomeGameTab := HomeGameMode;
	HomePersonTab := HomePersonMode;
	
  if (RegReadBoolean('HomePageShowMovies', DefaultHomePageShowMovies)) then
    MoviesBlock := GenerateMediaBlock(MOVIENIZER_PROGRAM, NumberOfMovies);
  if (RegReadBoolean('HomePageShowAlbums', DefaultHomePageShowAlbums)) then
    AlbumsBlock := GenerateMediaBlock(MUSICNIZER_PROGRAM, NumberOfAlbums);
  if (RegReadBoolean('HomePageShowBooks', DefaultHomePageShowBooks)) then
    BooksBlock := GenerateMediaBlock(BOOKNIZER_PROGRAM, NumberOfBooks);
  if (RegReadBoolean('HomePageShowGames', DefaultHomePageShowGames)) then
    GamesBlock := GenerateMediaBlock(GAMENIZER_PROGRAM, NumberOfGames);

	LitresBlock := GenerateLitresBlock();
	
	SetToolbarVisibility(true);
	SetMenuVisibility(true);
	SetNavigationVisibility(true);
	
	RatingIndex := RegReadInteger('MyRatingTabRating', 1);
	if RatingIndex = 2 then begin
		current_site := RegReadString('MovieScript', '');
		i := Pos(' (', current_site);
		if i>0 then
			delete(current_site, i, length(current_site)-i+1);
	end;
	
	ShowLastUpdated := RegReadInteger('ShowLastUpdated', 0);

  sl:=TStringList.Create;
  
  
	all:=GetPatternTop;
	if (NeedShowLogo(NumberOfMovies, NumberOfAlbums, NumberOfBooks, NumberOfGames, NumberOfPeople)) then begin
		mylogo := GetProperPath(Format('%smedianizer96.png', [PicturesPath]));
		all:= all + '<div style="float: left; margin-left: 15px; background-image: url('+mylogo+'); width: 96px; height: 96px;">&nbsp;</div>' + '<p class="gen-title">' + 'Medianizer';
	end;

    all:=all+'</p>'+ClosePatternTop;
	
	if (NeedShowLogo(NumberOfMovies, NumberOfAlbums, NumberOfBooks, NumberOfGames, NumberOfPeople)) then begin

		with sl do begin
			Clear;
			Add('select count(code) as amount from movies');
		end;
		RecordCount:=ExecuteSQL(sl.text);
		kol:=GetIntegerField('amount');

		with sl do begin
			Clear;
		Add('select count(code) as amount from movies where in_collection=1');
		end;

		RecordCount:=ExecuteSQL(sl.text);
		kol2:=GetIntegerField('amount');
		
		all := all + '<table class="db-stats"><tr>';
		//all:=all+format('Movies in collection: %d, in database: %d<br>', [kol2, kol]);
		all:=all+'<td class="left-indent">';
		if GetHTMLWidth > 820 then
			s := GetLangStr(30092) + ':'
		else
			s := '';
		all:= all + format('<div style="float: left;">%s %d</div>', [s, kol2]);
		//add button
		s := ReplaceStr(GetLangStr(30045), ' ', '&nbsp;');
		all := all + '<div class="add-btn">' + '<div style="float: right; width: 4px; height: 36px; background-image: url(' + GetProperPath(Format('%sadd-btn-end.gif', [ImgPath])) + ');"></div>' + '<div style="float: left; width: 23px; height: 36px; background-image: url(' + GetProperPath(Format('%sadd-plus.gif', [ImgPath])) + ');"></div>' + '<div class="add-btn-body" style="background-image: url(' + GetProperPath(Format('%sadd-btn-body.gif', [ImgPath])) + ');"><a class="pic" href="' + GetMediaAddURL() + '">' + s + '</a></div>';
		all := all + '</div>'; //end add button
		all:=all+'</td>';
		
		
		with sl do begin
			Clear;
			Add('select count(code) as amount from persons');
		end;
		RecordCount:=ExecuteSQL(sl.text);
		kol:=GetIntegerField('amount');

		with sl do begin
			Clear;
			Add('select count(code) as amount from persons where in_collection=1');
		end;
		RecordCount:=ExecuteSQL(sl.text);
		kol2:=GetIntegerField('amount');
		
		with sl do begin
		  Clear;
		  Add('select l.movie from loans l');
		  Add('inner join manuals m on m.code=l.location'); 
		  Add('where (return_date='''' or return_date is null)');
		end;
		loaned_movies:=ExecuteSQL(sl.text);
		if (loaned_movies = 1) and (GetIntegerField('l.movie') = 0) then
			loaned_movies := 0;

		all := all + '<td style="width: 20px; '+bckgrnd+'">&nbsp;</td>';
		if GetHTMLWidth > 820 then
			s := GetLangStr(702)
		else
			s := GetLangStr(1498);
		all:=all+'<td class="left-indent">'+format('<div style="float: left;">%s %d</div>', [s,kol2]);
		//add button
		s := ReplaceStr(GetLangStr(1493), ' ', '&nbsp;');
		all := all + '<div class="add-btn">' + '<div style="float: right; width: 4px; height: 36px; background-image: url(' + GetProperPath(Format('%sadd-btn-end.gif', [ImgPath])) + ');"></div>' + '<div style="float: left; width: 23px; height: 36px; background-image: url(' + GetProperPath(Format('%sadd-plus.gif', [ImgPath])) + ');"></div>' + '<div class="add-btn-body" style="background-image: url(' + GetProperPath(Format('%sadd-btn-body.gif', [ImgPath])) + ');"><a class="pic" href="add_person">' + s + '</a></div>';
		all := all + '</div>'; //end add button
		all:=all + '</td></tr>';

		if ShowLinks then begin
			//show as covers
			all := all + format('<tr><td class="left-indent" style="%s font-weight: normal;"><a href="userref:3005,%s">%s</a></td>', [bckgrnd, GetLangStr(35272), GetLangStr(35000)]);
			all := all + '<td style="width: 20px; '+ bckgrnd + '">&nbsp;</td>';
			//script setup link
			all := all + '<td class="left-indent" style="'+bckgrnd+' font-weight: normal;"><a href="userref:100,Options">'+GetLangStr(1333)+'</a></td></tr></table>';
		end
		else
			all := all + '</table><div class="small-space"></div>';

		kol2:=RegReadInteger('PopularGenresAmountOrange', 0);
		if kol2 > 0 then begin
		//Popular genres
			with sl do begin
			  Clear;
			  Add('select mn.code as code, mn.name as name, count(mn.code) as amount');
			  Add('from manuals mn');
			  Add('left join movies_manuals mm ON mn.code=mm.ref_code');
			  Add('left join movies m on m.Code = mm.Movie');
			  Add('Where mm.reference=8');
			  Add('AND m.in_collection=1');
			  Add('group by mn.code, mn.name');
			  Add('order by 3 desc');
			end;
			kol:=ExecuteSQL(sl.text);
			if kol>kol2 then
				kol:=kol2;
			if kol>0 then
				s:='<div class="header">&nbsp;'+GetLangStr(1300)+'</div><table class="genres"><tr>'
			else
				s:='';
			for i:=1 to kol do begin
				s:=s+format('<td class="left-indent"><a href="genre:%d">%s (%d)</a></td>', [GetIntegerField('code'), GetStringField('name'), GetIntegerField('amount')]);
				GetNextRecord;
			end;
			if s<>'' then
				s := s+'</tr></table>';
			all:=all+s;
		end;

		
		//test database warning
		s := RegReadString('Recent1', '');
		s := LowerCase(s);
		dbfilename := s;
		i := Pos('\', dbfilename);
		while i>0 do begin
			delete(dbfilename, 1, i);
			i := Pos('\', dbfilename);
		end;
		tmp := GetLangStr(1463);
		if (Pos('tes', dbfilename)=1) and (length(dbfilename) < 12) and
			((Pos(LowerCase(GetLangStr(1466)), s)>0) or (Pos('appdata', s) >0)) then
			all := all+''+GetLangStr(368)+format(' <a href="link:http://%s">%s</a>', [tmp, GetLangStr(1462)]);
		
		//program files folder warning
		if (Pos(LowerCase(GetLangStr(1464)), s)>0) then
			all := all + GetLangStr(1465)+format(' <a href="link:http://%s">%s</a>', [tmp, GetLangStr(1462)]);
	end;
	
  // movies
  if (MoviesBlock <> '') then
  	all := all + MoviesBlock;

  // albums
  if (AlbumsBlock <> '') then
  	all := all + AlbumsBlock;

  // books
  if (BooksBlock <> '') then
  	all := all + BooksBlock;

  // games
  if (GamesBlock <> '') then
  	all := all + GamesBlock;

    //last added persons
	with sl do begin
		Clear;
		Add('select count(code) as amount from persons where birth_date like ''%' + Format('%s', [GetTodaysDate]) + '%''');
	end;
	RecordCount:=ExecuteSQL(sl.text);
	kol2:=GetIntegerField('amount');
	if kol2 > 0 then
		Birthdays := True
	else
		Birthdays := False;
	
	page_width:=GetHTMLWidth - WholePageBorder - ArrowWidth;
	page_width_copy := page_width;
	if ShowLastUpdated = 0 then begin
		FullTabsWidth := HomeTabWidth * 3;
		ShortTabsWidth := TabWidth * 3;
	end
	else begin
		FullTabsWidth := HomeTabWidth * 2;
		ShortTabsWidth := TabWidth * 2;
	end;
	
	MyTabs := '';
	LastAdd := '';
  if (RegReadBoolean('HomePageShowPersons', DefaultHomePageShowPersons)) then
  begin
    GenerateSQLForPersonPages(sl, HomePersonMode, -1);
	  NumberOfPeople:=ExecuteSQL(sl.text);
    RecordCount:=NumberOfPeople;
    if RecordCount>0 then begin
		i:=1;
		j:=0;
		LastCode:=0;
		while (page_width_copy >= 0) and (i<=RecordCount) do begin
			code:=GetIntegerField('code');
			if PreviousCodes.IndexOf(IntToStr(code)) < 0 then begin
				PreviousCodes.Add(IntToStr(code));
				if j=0 then
					LastAdd:=LastAdd+'<table class="white-bck-block"><tr><td>';
				j:=j+1;
				LastCode:=code;
				PicHeight := GetIntegerField('height');
				if PicHeight > 0 then
					PicWidth := Round(GetIntegerField('width') * (HomePhotoHeight[ProgramType] / PicHeight)) + BigImageBorders
				else
					PicWidth := StandardHomeCoverWidth + BigImageBorders;
					
				page_width_copy := page_width_copy - PicWidth;
				if page_width_copy >= 0 then begin
					rating:=GetIntegerField('rating');
					rate:=GetStarRatingWithoutLinks(rating);
						
					s:=rate;
					NoPhotoFile := NO_PHOTO_FILE[GetIntegerField('item_type')];
					FileName := GetImageFileName(GetStringField('path'), ThumbsHomePhotos, NoPhotoFile, 0, HomePhotoHeight[ProgramType]);
					LastAdd:=LastAdd+'<div class="home-image-place"><div class="img-outer"><div class="img-inner">'+format('<a class="pic" href="person:%d"><img style="height: %dpx" border="0" src="%s" alt="%s">', [code, HomePhotoHeight[ProgramType], FileName, GetStringField('name')]) + '</a></div></div><div class="image-text">'+ Format('<a href="person:%d">%s</a>',[code, GetStringField('name')]);
					//if (rate <> '') then
						//LastAdd := LastAdd + '<br>' + rate;
					LastAdd := LastAdd + '</div></div>';
				end;

			end;

			GetNextRecord;
			i:=i+1;
		end;

	//long tab names
	//if (page_width >= FullTabsWidth) and (j*(StandardHomeCoverWidth + BigImageBorders) >=FullTabsWidth) then begin
	if (page_width >= FullTabsWidth) then begin
		TabNameMode := '';
		if ShowLastUpdated = 0 then
			TabName[1] := GetLangStr(1405)
		else
			TabName[1] := GetLangStr(1422);
		TabName[2] := GetLangStr(1422);
		TabName[3] := GetLangStr(1406);
		if Birthdays then
			TabName[4] := GetLangStr(2974)
		else
			TabName[4] := '';
	end
	//short tab names
	//else if (page_width >= ShortTabsWidth) and (j*StandardHomeCoverWidth >= ShortTabsWidth) then begin
	else if (page_width >= ShortTabsWidth) then begin
		TabNameMode := '-short';
		TabName[1] := GetLangStr(1407);
		TabName[2] := '';
		TabName[3] := GetLangStr(1408);
	end
	//no tabs
	else
		TabNameMode := 'none';
	
	if TabNameMode <> 'none' then begin
		all := all + '<table class="tabs" style="margin: 10px 0px 10px 0px;"><tr><td>';
		all := all + GetTab(HomePersonMode=1, -100, TabName[1], Format('modern_home:%d,%d,%d,%d,%d', [HomeMovieMode, HomeAlbumMode, HomeBookMode, HomeGameMode, 1]));
		i := HomePersonMode;
		if (TabName[2] <> '') and (ShowLastUpdated = 0) then begin
			all := all + GetTab(HomePersonMode=2, i, TabName[2], Format('modern_home:%d,%d,%d,%d,%d', [HomeMovieMode, HomeAlbumMode, HomeBookMode, HomeGameMode, 2]));
			i := HomePersonMode - 1;
		end;
		all := all + GetTab(HomePersonMode=3, i, TabName[3], Format('modern_home:%d,%d,%d,%d,%d', [HomeMovieMode, HomeAlbumMode, HomeBookMode, HomeGameMode, 3]));
		i := HomePersonMode - 2;
		if (TabName[4] <> '') then begin
			all := all + GetTab(HomePersonMode=4, i, TabName[4], Format('modern_home:%d,%d,%d,%d,%d', [HomeMovieMode, HomeAlbumMode, HomeBookMode, HomeGameMode, 4]));
			i := HomePersonMode - 3;
		end;
		if i = 1 then
			prefix := ''
		else
			prefix := 'in';
		all := all + '<div class="tab-end" style="background-image: url('+ GetProperPath(Format('%s%sactive-tab-end.gif', [ImgPath, prefix])) + ');"></div>';
		all := all + '<div class="orange-line"></div></td></tr></table>';
		
		if HomePersonMode = 1 then
			PersonsMore := Format('userref:6,%s', [GetLangStr(1405)]);
		if HomePersonMode = 2 then
			PersonsMore := Format('userref:8,%s', [GetLangStr(1422)]);
		if (HomePersonMode = 3) or (ShowLastUpdated = 1) then
			PersonsMore := Format('userref:7,%s', [GetLangStr(1406)]);
		if HomePersonMode = 4 then
			PersonsMore := Format('userref:9,%s', [GetLangStr(2974)]);
	end
	else
		all := all + '<div class="free-space"></div><div class="orange-line"></div>';

      all:=all+LastAdd+'</td>';
	  all := all + '<td class="arrow-left-home"><a class="pic" href="'+PersonsMore+'">' + Format('<img border="0" src="%sarrow-left.gif"/>', [ImgPath])+'</a></td>';
	  all := all + '</tr></table>';
    end;
  end;

    //links to partners
  if (RegReadBoolean('HomePageShowSupport', DefaultHomePageShowSupport)) then
  begin
    with sl do begin
      Clear;
      Add('select * from partners');
      Add(format('where language like ''%s''', [ProgramLanguage]));
      Add('order by sort_order');
    end;
    
    RecordCount:=ExecuteSQL(sl.text);
    if RecordCount>0 then begin
		all:=all+'<p>'+GetLangStr(438)+'</p>';

		for i:=1 to RecordCount do begin
			site:=GetStringField('site');
			url:=GetStringField('url');
			postfix:=GetStringField('postfix');
			if postfix<>'' then
				url:=url+postfix;
				s:=GetStringField('picture');
				if s='' then
					all:=all+'<a href="link:http://www.movienizer.com/redirect/'+url+format('">%s</a> ', [site])
				else
					all:=all+'<a href="link:http://www.movienizer.com/redirect/'+url+'">'+format('<img src="%s%s" border="0" align="absmiddle"></a> ', [PicturesPath, s]);
				GetNextRecord;
		end;
	end;
  end;
  all := all + '<div class="free-space"></div>';

	//all:=all+'<a href="userref:666,Sex">test</a>';

  result:=all;
  sl.Free;
  PreviousCodes.Free;
end;

begin
end.