program orange_program_part3;
                                                
uses 'orange_program_variables.pas', 'orange_program_global.pas';

//   
function GetThumbnailMovie(code, mode: integer; title, year: string; InCollection, rating: integer; AFullDescription: string = ''; ASearchDescription: string = ''): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img, seasons: string;
  fl, showCoversInList, FullList, ThisChecked, ShowCurrent, ShowDiscNr: boolean;
  i, j, kol, dir, amount, RecordCount, ThumbWidth: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
	BigOpen, BigClose, SmallOpen, SmallClose: string;
	kinopoisk_rating, imdb_rating, current_rating, current_site, disc_number: String;
	imdb_rating_number, kinopoisk_rating_number, current_rating_number: double;
begin
	result:='';
	SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
	try
		sl:=TStringList.Create;
		amount:=mode;
		s:='';
		ThumbWidth := RegReadInteger('ListCoverWidth', DefaultThumbWidth);
		ThumbsPath:=ImagesPath+Thumbs +'\';
		i := RegReadInteger('ShowCoversInList', 1);
		if i = 1 then
			showCoversInList := True
		else
			showCoversInList := False;
		i := RegReadInteger('MinimaList', 0);
		if i = 1 then
			FullList := False
		else
			FullList := True;
		if (RegReadInteger('ShowDiscNrInList', 0) = 1) then
			ShowDiscNr := True
		else
			ShowDiscNr := False;
		fl:=false;
		genres:='';
		directors:='';
		actors:='';
		ThisChecked := False;
		imdb_rating := '';
		kinopoisk_rating := '';
		current_rating := '';
		current_site := '';
		imdb_rating_number := 0;
		kinopoisk_rating_number := 0;
		current_rating_number := 0;
		disc_number := '';
		
		if RegReadInteger('ShowCurrentRatingInList', 1) = 1 then
			ShowCurrent := True
		else
			ShowCurrent := False;
			
			
			
		// Fade 16.08.2011 - For Search Thumbs do not add CheckBox picture
			if ((mode <> 7) and (GroupOperation) and (mode <> 5)) then begin
				if IsMovieChecked(code) then
					CheckMode:=format('<a href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
				else
					CheckMode:=format('<a href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
				if (showCoversInList) then
					CheckMode := '<div id="group_overlay_image">' + CheckMode + '</div>';
			end
			else
				CheckMode:='';

		//    ,    
		if (InCollection=1) then begin
			if showCoversInList then begin
				//
				with sl do begin
					Clear;
					Add('select path from images');
					Add(format('where movie=%d and mode=1', [code]));
					Add('order by sort_order');
				end;
				RecordCount:=ExecuteSQL(sl.text);
				if RecordCount>0 then begin
					FileIn:=ImagesPath+GetStringField('path');
					FileName:=ThumbsPath+GetStringField('path');

					if MyFileExists(FileIn) then begin
						if not MyFileExists(FileName) then begin
							ConvertThumb3(FileIn, FileName, Thumbs, ThumbWidth, 0, false);
						end;
						if not MyFileExists(FileName) then 
							FileName:=FileIn;
					end
					else
						FileName:=FileIn;
					if MyFileExists(FileName) then
						fl:=true;
				end;
				if not fl then begin
					FileName:=ImgPath + NO_COVER_FILE[MOVIENIZER_PROGRAM];
					fl:=true;
				end;
			end;
			
			if ShowCurrent then begin
				current_site := GetMovieCurrentScript(MOVIENIZER_PROGRAM);
				i := Pos(' (', current_site);
				if i>0 then
					delete(current_site, i, length(current_site)-i+1);
				if (current_site <> '') and (current_site <> 'kinopoisk') and (current_site <> 'imdb') then begin
					with sl do begin
						Clear;
						Add('select rating from movies_codes');
						Add(format('where movie=%d and script=''%s''', [code, current_site]));
					end;
					RecordCount := ExecuteSQL(sl.text);
					if RecordCount > 0 then begin
						current_rating_number := GetFloatField('rating');
						if current_rating_number > 0 then
							current_rating := '<NOBR>' + current_site + ': ' + FloatToStr(current_rating_number) + '</NOBR>; ';
					end;
				end;
			end;
			
			if (RegReadInteger('ShowIMDBRatingInList', 0) = 1) or ((current_site = 'imdb') and ShowCurrent) then begin
				with sl do begin
					Clear;
					Add('select checked, imdb_rating from movies');
					Add(format('where code=%d', [code]));
				end;
				RecordCount:=ExecuteSQL(sl.text);
				if RecordCount > 0 then begin
					imdb_rating_number := GetFloatField('imdb_rating');
					if (imdb_rating_number > 0) then
						imdb_rating := Format('<NOBR><img align="absmiddle" src="%simdb-ico.png"> ', [PicturesPath]) + FloatToStr(imdb_rating_number) + '</NOBR>; ';
				end;
			end;
			
			if (RegReadInteger('ShowKinopoiskRatingInList', 0) = 1) or ((current_site = 'kinopoisk') and ShowCurrent) then begin
				with sl do begin
					Clear;
					Add('select rating from movies_codes');
					Add(format('where movie=%d and script=''kinopoisk''', [code]));
				end;
				RecordCount := ExecuteSQL(sl.text);
				if RecordCount > 0 then begin
					kinopoisk_rating_number := GetFloatField('rating');
					if (kinopoisk_rating_number > 0) then
						kinopoisk_rating := Format('<NOBR><img align="absmiddle" src="%skinopoisk-ico.png"> ', [PicturesPath]) + Format('%.1f', [kinopoisk_rating_number]) + '</NOBR>; ';
				end;
			end;
			
			//disc number (only first edition)
			if ShowDiscNr then begin
				with sl do begin
					Clear;
					Add('select disc_nom from editions');
					Add(format('where movie=%d', [code]));
					Add('order by sort_order');
				end;
				RecordCount := ExecuteSQL(sl.text);
				if RecordCount > 0 then begin
					s := GetStringField('disc_nom');
					if (s <> '') and (s <> '0') then
						disc_number := Format('<NOBR>%s: %s</NOBR>', [GetLangStr(391), s]);
				end;
			end;

			if amount>0 then begin 
				//
				with sl do begin
					Clear;
					Add('select m.code, m.name from movies_manuals mm');
					Add('join manuals m on m.code=mm.ref_code');
					Add(format('where mm.movie=%d and m.reference=8', [code]));
				end;
				RecordCount:=ExecuteSQL(sl.text);
				for j:=1 to RecordCount do begin
					genres:=genres+format('<a href="genre:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
					GetNextRecord;
				end;
				if genres<>'' then
					genres:=copy(genres, 1, length(genres)-2);

				//  
				with sl do begin
					Clear;
					Add('select distinct p.code, p.name, p.in_collection, d.mode from data d');
					Add('inner join persons p on p.code=d.person');
					Add(format('where d.movie=%d and d.mode in (1,3)', [code]));
					//Add('and d.sort_order<10');//27.07.07
					Add('order by d.mode, d.sort_order');
				end;
				RecordCount:=ExecuteSQL(sl.text);
				i:=0;
				j:=0;
				dir:=0;
				while (i<RecordCount) and (j<amount) do begin
					if GetIntegerField('p.in_collection')=1 then
						img:=format('<img src="%sperson.gif" align="absmiddle" border="0" style="margin-right: 2px;">', [ImgPath])
					else
						img:='';
					if GetIntegerField('d.mode')=1 then begin
						if dir<=3 then begin
							directors:=directors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), GetStringField('p.name')]);
							dir:=dir+1;
						end;
					end
					else begin
						actors:=actors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), GetStringField('p.name'), j]);
						j:=j+1;
					end;
					i:=i+1;
					GetNextRecord;
				end;
			end;
			if directors<>'' then
				directors:=copy(directors, 1, length(directors)-2);

			if actors<>'' then
				actors:=copy(actors, 1, length(actors)-2);
		  
			if year<>'' then
				year:=format(' (%s)', [year]);

			if rating>0 then
				rate:=format(' <NOBR><img src="%sfull-star.gif" width="16" height="15" border="0" align="absmiddle">%d</NOBR>', [ImgPath, rating])
			else
				rate:='';
				
			if showCoversInList then begin
				s:='<div class="photo-outer" style="float: left; line-height: 0px;"><div class="photo-inner">' + CheckMode + '<a class="pic" ' + format('href="movie:%d"><img border="0" style="width: %dpx;" src="%s"', [code, ThumbWidth, FileName]);
				if not GetCutePreview and (mode<>7) then
					s:=s+' width="50" align="left"';
				s:=s+'></a></div></div>';
			end
			else
				s := s + CheckMode;
			s := s+format('<a href="movie:%d"><b>%s</b></a>%s%s<br>', [code, title, year, rate]);
			
			//site ratings
			if FullList and ((imdb_rating <> '') or (kinopoisk_rating <> '') or (current_rating <> '')) then begin
				s := s + current_rating + imdb_rating + kinopoisk_rating;
				s := copy(s, 1, length(s)-2) + '<br>';
			end;
			
			//disc number
			if (disc_number <> '') then
				s := s + disc_number + '<br>';
			
			//Genres
			if (genres<>'') and FullList then begin
				if mode<>1 then
					genres:=GetLangStr(179)+': '+genres;
				s:=s+genres+'<br>';
			end;
			//Directors
			if FullList and (mode<>1) and (directors<>'') then
				s:=s+GetLangStr(181)+': '+directors+'<br>';
			//Actors
			if FullList and (actors<>'') then begin
				if mode<>1 then
					actors:=GetLangStr(164)+': '+actors;
				s:=s+actors+'<br>';
			end;
			s := s+SmallClose;
		end
		else begin
			if year<>'' then
				year:=format(' (%s)', [year]);
			s:=CheckMode+format('<a href="movie:%d"><b>%s</b>%s</a>', [code, title, year]);
		end;

		//seasons
		seasons:='';
		with sl do begin
			Clear;
			Add('select distinct season from episodes');
			Add(format('where movie=%d', [code]));
			Add('order by season');
		end;
		RecordCount:=ExecuteSQL(sl.text);
		for i:=1 to RecordCount do begin
			j := GetIntegerField('season');
			if j = 99 then
				j := 0;
			seasons:=seasons+format('<a href="userref:114,%d;%d">%d</a> ', [code, GetIntegerField('season'), j]);
			GetNextRecord;
		end;
		if FullList and (seasons<>'') then begin
			seasons:=GetLangStr(517)+' '+seasons;
			delete(seasons, length(seasons), 1);
			s:=s+seasons;
		end;
		
		s := s + '<i>' + GenerateHTMLForDescriptionSearching(AFullDescription, ASearchDescription) + '</i>';
		
		//s := s+'</div>';
		if mode=7 then
			s:='<tr><td class="text-box">'+s+'</td></tr>';
		result:=s;
		sl.Free;
	finally
		ResetRegistrySubKey();
	end;
end;

function GetThumbnailMovieExtended(code, mode: integer; title: string): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img, seasons: string;
  fl, CutThumb: boolean;
  i, j, kol, dir, amount, RecordCount, CoverWidth, CoverHeight: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
	ProgramType: Integer;
begin
	result:='';
	ProgramType := MOVIENIZER_PROGRAM;
	SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
	try
	  sl:=TStringList.Create;
	  amount:=mode;
	  {
	  if mode=1 then
		amount:=3
	  else
		amount:=7;
		}
	  s:='';

	  ThumbsPath:=ImagesPath+Thumbs2+'\';

	  fl:=false;
	  genres:='';
	  directors:='';
	  actors:='';


		//
		with sl do begin
		  Clear;
		  Add('select * from images');
		  Add(format('where movie=%d and mode=1', [code]));
		  Add('order by sort_order');      
		end;
		RecordCount:=ExecuteSQL(sl.text);

		  CoverWidth := RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[ProgramType]);
		  CoverHeight := RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[ProgramType]);
	  
		  if (CoverWidth <= 0) and (CoverHeight <= 0) then begin
			  CoverWidth := DefaultMultiCoverWidth[ProgramType];
			  CoverHeight := DefaultMultiCoverHeight[ProgramType];
		  end;

		if RecordCount>0 then
		begin
			  i := RegReadInteger('CutThumb', 1);
			  if i = 1 then
					CutThumb := True
			  else
					CutThumb := False;
		  FileIn:=ImagesPath+GetStringField('path');
		  FileName:=ThumbsPath+GetStringField('path');
		  if MyFileExists(FileName) then
			fl:=true
		  else if MyFileExists(FileIn) then
			ConvertThumb3(FileIn, FileName, Thumbs2, CoverWidth, CoverHeight, CutThumb);
		  if MyFileExists(FileName) then
			fl:=true;
		end;
		if not fl then
		begin
		  FileIn:=ImgPath + NO_COVER_FILE[MOVIENIZER_PROGRAM];
		  FileName:=ThumbsPath + NO_COVER_FILE[MOVIENIZER_PROGRAM];
		  //ShowMessage('FileName='+FileName);
		  //ShowMessage('FileIn='+FileIn);
		  if ((not MyFileExists(FileName)) and
			  (MyFileExists(FileIn))) then
		  begin
			ConvertThumb3(FileIn, FileName, Thumbs2, CoverWidth, CoverHeight, CutThumb);
		  end;
		  fl:=true;
		end;

		if GroupOperation then
		begin
		  if IsMovieChecked(code) then
			CheckMode:=format('<a class="pic" href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
		  else
			CheckMode:=format('<a class="pic" href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
		  CheckMode := '<div id="group_overlay_image_multi">' + CheckMode + '</div>';
		end
		else
		  CheckMode:='';

		s:='<div class="img-outer" style="float: left;"><div class="img-inner">'+CheckMode+'<a class="pic" href="movie:' + format('%d"><img src="%s" border="0"></a></div></div>', [code, FileName])+'<div style="clear:both"></div><div class="cover-flow-text">' + format('<a href="movie:%d">%s</a></div>', [code, title]);


		if mode=7 then
		  s:='<tr><td>'+s+'</td></tr>';

		if amount=3 then
			s:='<div class="preview">'+s+'</div>';
	  result:=s;
	  sl.Free;
	finally
		ResetRegistrySubKey();
	end;
end;

function GetMovieTabs(MovieCode, SeasonNr, SeasonCnt: Integer; Awards, Shots, Params, Posters, Trailers, Desc, Connections: Boolean; AdditionalSpace: Integer = 0): String;
var
	s, media_format, prev_media_format, prefix: String;
	i, k, my_tabs, PageWidth, SeasonTabs, PageTabs, RecordCount: Integer;
	sl: TStringList;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
  try
	PageWidth := GetHTMLWidth - TabBorders - AdditionalSpace;
	SeasonTabs := PageWidth div SeasonTabWidth;
	PageTabs := PageWidth div TabWidth;
	s := '';
	if (ActiveTab in [2, 6, 7]) then
		s := '<div class="left-block-holder">&nbsp;</div>';
	s := s + '<table class="tabs"><tr><td>';
	
	//general info tab
	s := s + GetTab(ActiveTab = 1, -100, GetLangStr(161), Format('userref:%d,%d', [109, MovieCode]));
	PageTabs := PageTabs - 1;
	//i is assigned so that it should contain 1 if the previous tab is active
	i := ActiveTab;

	//screenshots	
	if (Shots) and (PageTabs > 0) and (RegReadInteger('ShowShotTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 2, i, GetLangStr(1429), Format('userref:%d,%d', [110, MovieCode]));
		i := ActiveTab - 1;
	end;
	//posters
	if (Posters) and (PageTabs > 0) and (RegReadInteger('ShowPosterTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 7, i, GetLangStr(1425), Format('userref:%d,%d', [115, MovieCode]));
		i := ActiveTab - 6;
	end;
	//trailers
	if (Trailers) and (PageTabs > 0) and (RegReadInteger('ShowTrailerTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 9, i, GetLangStr(1458), Format('userref:%d,%d', [117, MovieCode]));
		i := ActiveTab - 8;
			
	end;
	
	//awards
	if (Awards) and (PageTabs > 0) and (RegReadInteger('ShowAwardsTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 3, i, GetLangStr(574), Format('userref:%d,%d', [111, MovieCode]));
		i := ActiveTab - 2;
	end;
	
	//actors
	if (PageTabs > 0) and (RegReadInteger('ShowActorTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
			s := s + GetTab(ActiveTab = 4, i, GetLangStr(68), Format('userref:%d,%d', [112, MovieCode]));
		i := ActiveTab - 3;
	end;
	//parameters
	if (Params) and (PageTabs > 0) and (RegReadInteger('ShowParameterTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 5, i, GetLangStr(1254), Format('userref:%d,%d', [113, MovieCode]));
		i := ActiveTab - 4;
	end;
	
	//description
	if (Desc) and (PageTabs > 0) and (RegReadInteger('ShowDescriptionTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 10, i, GetLangStr(162), Format('userref:%d,%d', [118, MovieCode]));
		i := ActiveTab - 9;
	end;
	
	//connections
	if (Connections) and (PageTabs > 0) and (RegReadInteger('ShowConnectionsTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 11, i, GetLangStr(4155), Format('userref:%d,%d', [119, MovieCode]));
		i := ActiveTab - 10;
	end;

	//loans - not used
(*	if (PageTabs > 0) and (RegReadInteger('ShowLoanTab', 0) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 8, i, GetLangStr(1440), Format('userref:%d,%d', [116, MovieCode]));
		i := ActiveTab - 7;
	end;	
*)
	//seasons
	if (SeasonCnt > 0) and (PageTabs > 0) and (RegReadInteger('ShowSeasonTab', 1) = 1) then begin
		s := s + GetTab(ActiveTab = 6, i, GetLangStr(521), Format('userref:%d,%d', [114, MovieCode]));
		i := ActiveTab - 5;
	end;
	
	if i = 1 then
		prefix := ''
	else
		prefix := 'in';
	s := s + '<div class="tab-end" style="background-image: url('+ GetProperPath(Format('%s%sactive-tab-end.gif', [ImgPath, prefix])) + ');"></div>';
	s := s + '<div class="orange-line"></div></td></tr></table>';
	Result := s;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetMoviePage(MovieCode, season: integer; FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
var
  sl, TempList, SeenList, UnseenList, SeasonCovers, SeasonNumbers: TStringList;
  duration, i, j, k, l, kol, rmax, RecordCount: integer;
  all, s, s2, s3, country, description, comment, genre, year, director, writer, composer, actor, character, down, salary, awards, studios: string;
  rating: integer;
  IMDBRating, SiteRating, EditionCost: double;
  FileName, img, OriginalTitle, site, url, postfix, ShortFilename: string;
  flCollection, flSeen, flWanted, flForSale, LastCode: integer;
  collection, seen, wanted, sale, rate, mpaa, mpaa_desc, disc_nom, seasons: string;
  VideoStandard, ScreenRatio, resolution, mpaa_code, VideoBitrate, VideoCodec, filesize: integer;
  DiscLabel: integer;
  custom: array[1..6] of integer;
  cust: string;
  DateAdd, DateUpdate, DateSeen, loan_date, return_date: string;
  age, border, bckgrnd: string;                                              
  editions: array [1..1000] of integer;
  EditionsCount, EditionCode, MediaFormat, ie: integer;
  ed, temp, barcode, OtherRating, EditionFeatures, EditionComment, VideoFileFolder, VideoFileName, TagLine: string;
  PrevBlockCnt, ThisBlockCnt, ShotCnt, MaxShots, hours, minutes, SeasonCnt, PosterCnt, ConnectionsCnt: Integer;
  page_width, PicWidth, PicHeight, TrailerCnt, AdditionalSpace, ScreenshotTotalHeight, page_width_rest, page_width_copy, MediaType, PrevPicWidth, this_width, this_height, this_season, MovieSeries, MovieSeriesNumber: Integer;
  NoTrailerAdded, ShowScreenshots, fl, FixedContentsWidth: Boolean;
  trunc_name, trunc_character, media_format, prev_media_format: String;

  // movies liks variables
  OldLinkStatus: Integer;
  LinkYearStr: string;
  LinkMovieStr: string;
  LinkMovieStatusTitle: string;
  temp_name, new_name, name, FullAwardsText, status, ends_with: string;
begin
	result:='';
	SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
	try
		sl:=TStringList.Create;
		all:='';
		OtherRating := '';
		
		if (RegReadInteger('FixedContentsWidthOnMoviePage', 0) = 1) then
			FixedContentsWidth := True
		else
			FixedContentsWidth := False;

		bckgrnd := Format(' style="background-color: %s;" ', [CellColor]);
		with sl do begin
			Clear;
			Add('select code from images');
			Add(format('where movie=%d and mode in (3, 7)', [MovieCode]));
			Add('order by sort_order');    
		end;
		ShotCnt:=ExecuteSQL(sl.text);
	  
		with sl do begin
			Clear;
			Add('select count(code) as amount from movies_codes');
			Add(format('where movie=%d and script=''trailer''', [MovieCode]));
		end;
		RecordCount:=ExecuteSQL(sl.text);
		TrailerCnt := GetIntegerField('amount');
		
		// count movie connections
		with sl do begin
			Clear;
			Add('select count(code) as amount from movies_links');
			Add(Format('where movie_primary=%d', [MovieCode]));
		end;
		RecordCount := ExecuteSQL(sl.text);
		ConnectionsCnt := GetIntegerField('amount');
	  
		  
		with sl do begin
			Clear;
			Add('select * from movies');
			Add(format('where code=%d', [MovieCode]));
		end;
		RecordCount:=ExecuteSQL(sl.text);
		if RecordCount=0 then
			exit;
		s:='movie:'+IntToStr(MovieCode);
		movie:=GetStringField('title');

		OriginalTitle:=GetStringField('original_title');
		rating:=GetIntegerField('rating');
		IMDBRating:=GetFloatField('imdb_rating');

		flCollection:=GetIntegerField('in_collection');
		flSeen:=GetIntegerField('seen');
		flWanted:=GetIntegerField('wanted');
		flForSale:=GetIntegerField('for_sale');
		mpaa_code:=GetIntegerField('mpaa');
		mpaa_desc:=GetStringField('mpaa_rating');
		MediaType := GetIntegerField('media_type');

		DateAdd:=GetStringField('date_add');
		DateUpdate:=GetStringField('date_update');
		DateSeen:=GetStringField('date_seen');
		TagLine := GetStringField('tagline');
		MovieSeriesNumber := GetIntegerField('series_nom');
		MovieSeries := GetIntegerField('series');
		
		if (ConnectionsCnt <= 0) and (MovieSeries > 0) then
			ConnectionsCnt := 1;

		//GoForward(s, GetStringField('m.title'), ChangeHistory);

		description:=GetStringField('description');
		salary:=GetStringField('salary');
		awards:=GetStringField('awards');
		comment:=GetStringField('comment');
		
		FullAwardsText := awards;

		custom[1]:=GetIntegerField('custom1');
		custom[2]:=GetIntegerField('custom2');
		custom[3]:=GetIntegerField('custom3');
		custom[4]:=GetIntegerField('custom4');

		if GetStringField('duration')='' then
			duration:=0
		else
			duration:=GetIntegerField('duration');
		year:=GetStringField('year');

		disc_nom:=GetStringField('disc_nom');
		  
		if flCollection=0 then
			collection:=format('<a class="pic" href="collection:%d"><img src="%snot-in-collection.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(326)])
		else
			collection:=format('<a class="pic" href="collection:%d"><img src="%sin-collection.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(325)]);


		if flSeen=0 then
			seen:=format('<a class="pic" href="seen:%d"><img src="%snot-seen.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(328)])
		else
			seen:=format('<a class="pic" href="seen:%d"><img src="%sseen.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(327)]);

		if flWanted=0 then
			wanted:=format('<a class="pic" href="wanted:%d"><img src="%snot-wanted.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(330)])
		else
			wanted:=format('<a class="pic" href="wanted:%d"><img src="%swanted.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(329)]);

		if flForSale=0 then
			sale:=format('<a class="pic" href="sale:%d"><img src="%snot-for-sale.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(332)])
		else
			sale:=format('<a class="pic" href="sale:%d"><img src="%sfor-sale.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(331)]);

		rate:='';
		for i:=1 to 10 do begin
			if i mod 2=1 then begin
				if i<=rating then
					rate:=rate+format('<a class="pic" href="rating:%d"><img src="%shalfstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
				else
					rate:=rate+format('<a class="pic" href="rating:%d"><img src="%snot-halfstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
			end
			else begin
				if i<=rating then
					rate:=rate+format('<a class="pic" href="rating:%d"><img src="%shalfstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
				else
					rate:=rate+format('<a class="pic" href="rating:%d"><img src="%snot-halfstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
			end;
		end;

		//description
		if description<>'' then begin
			if (ActiveTab <> 10) and (not FullDesc) and (length(description)>DescriptionLength) then begin
				description:=copy(description, 1, DescriptionLength);
				description:=RemoveUnclosedTags(description);
				description:=description+format(GetLangStr(566), [MovieCode]);
			end;
		end;

		if description='' then
			down:='<br>'+format('<a href="DownloadMovie:%d">', [MovieCode])+GetLangStr(324)+'</a>'
		else
			down:='';

		// Count seasons
		SeasonNumbers := TStringList.Create;
		with sl do begin
			Clear;
			Add('select distinct e.season from episodes e');
			Add(format('where e.movie=%d', [MovieCode]));
			Add(' order by e.season');
		 end;
		SeasonCnt:=ExecuteSQL(sl.text);
		for i := 1 to SeasonCnt do begin
			SeasonNumbers.Add(IntToStr(GetIntegerField('e.season')));
			GetNextRecord;
		end;

		VideoFileName := '';
		with sl do begin
			Clear;
			Add('select e.filename from editions e');
			Add('left outer join manuals m on m.code=e.edition and m.reference=21');
			Add(format('where e.movie=%d', [MovieCode]));
			Add('order by e.sort_order');
		end;
		EditionsCount:=ExecuteSQL(sl.text);
		VideoFileName := GetStringField('e.filename');
		
		with sl do begin
			Clear;
			Add('select code from images');
			Add(format('where movie=%d and mode=4', [MovieCode]));
				Add('order by sort_order');        
		end;
		PosterCnt:=ExecuteSQL(sl.text);
		
		if (ActiveTab <> 3) and (not FullAwards) and (length(awards)>DescriptionLength) then begin
			awards:=copy(awards, 1, DescriptionLength);
			awards:=RemoveUnclosedTags(awards);
			awards:=awards+format(GetLangStr(1331), [MovieCode]);
		end;

		all:=GetPatternTop;
		all:= all + '<p class="title">' + movie;
		if (OriginalTitle <> '') and (OriginalTitle <> movie) then
			all := all + ' <span style="color: #999999; font-size: 16pt;">('+OriginalTitle+')</span>';
		all:= all + '</p>' + Format('<div class="icons">%s&nbsp;&nbsp;%s&nbsp;&nbsp;%s&nbsp;&nbsp;%s&nbsp;&nbsp;</div>', [ collection, seen, wanted, sale]) + ClosePatternTop;
			
		if  not (ActiveTab in [2, 6, 7]) then begin
			//pictures
			all := all + '<div class="left-block">';
			with sl do begin
				Clear;
				Add('select path, code from images');
				Add(format('where movie=%d and mode=1', [MovieCode]));
			Add('order by sort_order');      
			end;
			RecordCount:=ExecuteSQL(sl.text);
			all:=all+'<div class="cover-info">';
			fl := False;
			if RecordCount>0 then begin
				if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
					FileName := GetImageFileName(GetStringField('path'), ThumbsCovers, '', MainCoverWidth, 0);
					all:=all+'<div class="img-outer"><div class="img-inner"><a class="pic"'+format(' href="ShowImage:%d"><img style="width: %dpx;" border="0" src="%s"></a></div></div>',
				  [GetIntegerField('code'), MainCoverWidth, FileName]);
				  fl := True;
				end;
			end;
			if not fl then begin
				FileName:=ImgPath + NO_COVER_FILE[MOVIENIZER_PROGRAM];
				if (MyFileExists(FileName)) then
					all:=all+format('<div class="img-outer"><div class="img-inner"><img class="cover-image" border="0" src="%s"></div></div>', [FileName]);
			end;

			all:=all+'</div><div style="background-color: '+CellColor+'; height: 10px;"></div>';
		  
			//site links
			with sl do begin
				Clear;
				Add('select distinct mc.code, mc.site, mc.script, mc.rating, p.* from movies_codes mc');
				Add('left outer join partners p on mc.script=p.site');
        Add('AND mc.item_type = p.item_type');
				Add(format('where movie=%d', [MovieCode]));
				Add('order by p.sort_order, mc.script');
			end;
			RecordCount:=ExecuteSQL(sl.text);
				
			for i:=1 to RecordCount do begin
				site:=GetStringField('mc.script');
				url:=GetStringField('mc.site');
				if (site <> 'trailer') and (url <> '') then begin
					postfix:=GetStringField('p.postfix');
					all := all+'<div class="site-link">'; 
					if postfix<>'' then
						url:=url+postfix;
					if site='buy' then begin
						if Pos('amazon', url)>0 then
							all:=all+'<a class="pic" alt="Buy at Amazon"  href="link:http://www.movienizer.com/redirect/'+url+'">'+format('<img src="%samazon.gif" border="0"></a> ', [PicturesPath])
						else if Pos('ozon', url)> 0 then
							all := all + '<a class="pic" alt="  "  href="link:http://www.movienizer.com/redirect/'+url+'">'+format('<img src="%sozon.gif" border="0"></a> ', [PicturesPath])
						else
							all:=all+format(GetLangStr(375), ['http://www.movienizer.com/redirect/'+url, movie])+' ';
					end
					else begin
						s:=GetStringField('p.picture');
						if s='' then
						all:=all+'<a href="link:http://www.movienizer.com/redirect/'+url+format('">%s</a> ', [site])
						else
							all:=all+'<a class="pic" href="link:http://www.movienizer.com/redirect/'+url+'">'+format('<img src="%s%s" border="0"></a> ', [PicturesPath, s]);
					end;
					all := all + '</div>';
					i := RegReadInteger('ShowSiteRating', 1);
					if i=1 then begin
						SiteRating:=GetFloatField('mc.rating');
						if (SiteRating>0) and (site<>'imdb') then
							all := all + format('<div class="site-rating">%s: %f</div>', [GetLangStr(75),SiteRating]);
					end;
				end;
				GetNextRecord;
			end; //for
			
			all := all + '<div class="free-space"></div>';
			//my rating
			i := RegReadInteger('ShowRating', 1);
			if i=1 then begin
				all := all + '<div class="site-rating">';
				all := all + Format('%s:<br/>', [GetLangStr(298)]);
				all := all + rate + '</div>';
			end;
			
			//imdb rating
			if IMDBRating <> 0 then begin
				all := all + Format('<div class="site-rating">%s: ', [GetLangStr(707)]) + Format ('<strong>%0.1f</strong></div>', [IMDBRating]);
			end;
			
			//awards
			if FullAwardsText <> '' then begin
				s2 := '';
				temp := LowerCase(FullAwardsText);
				i := Pos('<br>', temp);
				//remove the general description for awards received from kinopoisk
				s := copy(temp, 1, i-1);
				if (Pos('.', s) > 5) then
					delete(temp, 1, i+3);
				sl.LoadFromFile(PicturesPath + 'awards\awards.txt');
				for i := 0 to sl.Count - 1 do begin
					name := sl.Names[i];
					j := Pos(':', name);
					status := '';
					ends_with := '';
					if j > 0 then begin
						status := LowerCase(copy(name, j+1, length(name)-j));
						delete(name, j, length(name)-j+1);
						j := Pos(':', status);
						if j > 0 then begin
							ends_with := copy(status, j+1, length(status)-j);
							delete(status, j, length(status)-j+1);
						end;
					end;
					j := Pos(LowerCase(name), temp);
					s := '';
					if j > 0 then begin
						k := MyPos(ends_with, temp, j+1);
						if k = 0 then
							k := Length(temp);
						s := copy(temp, j, k-j);
					end;
					if Pos('<br>'+ status, s) > 0 then
						s2 := s2 + '<a class="pic" href="userref:302,' + name + '"><img border="0" alt="'+ name + '" src="' + PicturesPath + 'awards\' + sl.Values[sl.Names[i]] + '"></a>';
				end;
				if s2 <> '' then
					all := all + '<div style="text-align: center; margin: 5 0;">' + s2 + '</div>';
			end;
			
			if RegReadInteger('ShowCodecLogos', 1) = 1 then begin
				//media format logo
				with sl do begin
					Clear;
					Add('select m.name, e.filename from editions e');
					Add('left outer join manuals m on m.code=e.media_format');
					Add(format('where e.movie=%d', [MovieCode]));
					Add('order by e.media_format');
				end;
				RecordCount:=ExecuteSQL(sl.text);
				prev_media_format := 'dummy';
				s := '';
				for i:=1 to RecordCount do begin
					media_format := LowerCase(GetStringField('m.name'));
					if (prev_media_format <> media_format) then begin
						if (media_format = 'blu-ray') then begin
							s := s + format('<div class="site-rating"><img alt="Blu-Ray" src="%sbd-logo-medium.gif"></div>', [ImgPath]);
						end;
						if (media_format = 'dvd') then begin
							s := s + format('<div class="site-rating"><img alt="DVD" src="%sdvd-logo-medium.gif"></div>', [ImgPath]);
						end;
						if (media_format = 'hd dvd') then begin
							s := s + format('<div class="site-rating"><img alt="HD DVD" src="%shddvd-logo-medium.gif"></div>', [ImgPath]);
						end;
						if (Pos('mkv', media_format)>0) or 
						(Pos('.mkv', LowerCase(GetStringField('e.filename')))>0) then begin
							s := s + format('<div class="site-rating"><img alt="MKV Matroska" src="%smkv-logo-medium.gif"></div>', [ImgPath]);
						end;
						prev_media_format := media_format;
					end;
					GetNextRecord;
				end;
				//video codec logo (divx, xvid)
				with sl do begin
					Clear;
					Add('select m.name from editions e');
					Add('left outer join manuals m on m.code=e.video_codec');
					Add(format('where e.movie=%d', [MovieCode]));
					Add('order by e.video_codec');
				end;
				RecordCount:=ExecuteSQL(sl.text);
				prev_media_format := '';
				for i:=1 to RecordCount do begin
					media_format := LowerCase(GetStringField('m.name'));
					if (media_format <> prev_media_format) then begin
						if (Pos('divx', media_format)>0) then begin
							s := s + format('<div class="site-rating"><img alt="DivX" src="%sdivx-logo-medium.gif"></div>', [ImgPath]);
						end;
						if (Pos('xvid', media_format)>0) then begin
							s := s + format('<div class="site-rating"><img alt="XviD" src="%sxvid-logo-medium.gif"></div>', [ImgPath]);
						end;
						prev_media_format := media_format;
					end;
					GetNextRecord;
				end;
				all := all + s;
			end;
			
			all := all + '</div>';
			
		end; //if ActiveTab <> 2
		
		//Check if the active tab exists
		//no seasons
		if ((ActiveTab = 6) and (SeasonCnt = 0)) or
		//no parameters
		((ActiveTab = 5) and (EditionsCount = 1) and (VideoFileName = '')) or 
		//no shots
		((ActiveTab = 2) and (shotCnt = 0)) or
		//no posters
		((ActiveTab = 7) and (PosterCnt = 0)) or
		//no trailers
		((ActiveTab = 9) and (TrailerCnt = 0)) or
		//no connections
		((ActiveTab = 11) and (ConnectionsCnt = 0)) then begin
			ActiveTab := 1;
			Result := GetMoviePage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
			exit;
		end;

		//shots from the movie
		AdditionalSpace := 0;
		ShowScreenshots := False;
		MaxShots := RegReadInteger('ShotsCnt', 5);
		if (ActiveTab = 1) and (MaxShots > 0) then begin
			showScreenshots := True;
			i := GetHTMLWidth - LeftColumnWidth - ScreenshotWidth;
			if (i < DataArea) then
				showScreenshots := False;
		end;
		
		ScreenshotTotalHeight := 0;
		if ShowScreenshots then begin
			AdditionalSpace := ScreenshotWidth + NormalImageBorders;
			s := '';
			if (RegReadInteger('ShowCoversOnTheRight', 1) = 1) then
				s := '2';
			if (RegReadInteger('ShowPostersOnTheRight', 0) = 1) then begin
				if s<>'' then
					s := s + ',';
				s := s + '4';			
			end;
			if (RegReadInteger('ShowBackdropsOnTheRight', 1) = 1) then begin
				if s<>'' then
					s := s + ',';
				s := s + '7';
			end;
			if (RegReadInteger('ShowShotsOnTheRight', 1) = 1) then begin
				if s<>'' then
					s := s + ',';
				s := s + '3';
			end;
			with sl do begin
				Clear;
				Add('select path, i.code as code, mode, width, height from images i');
				Add('inner join images_modes im on i.mode=im.code');
				Add(format('where movie=%d', [MovieCode]));
				Add(format('and mode in (%s)', [s]));
			Add('order by im.sort_order, i.sort_order');        
			end;
			RecordCount:=ExecuteSQL(sl.text);
			j := 0;
			//if there are other pictures than the main cover, show them according to the settings
			if ((fl or (GetIntegerField('mode') <> 1)) and (RecordCount>0)) or (RecordCount>1) then begin
				all := all + '<table class="right-block"><tr><td>';
				if RecordCount < MaxShots then
					MaxShots := RecordCount;
				ScreenshotTotalHeight := ScreenshotTotalHeight + ScreenshotPadding div 2;
				for i:=1 to MaxShots do begin
					//skip the main cover
					if (RegReadInteger('OnlyShots', 1) <> 1) and (GetIntegerField('mode') = 1) and (j = 0) then
						j := 1
					else
						if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
							FileName := GetImageFileName(GetStringField('path'), ThumbsScreenshots, '', ScreenshotWidth, 0);
							all:=all+'<div class="shot-place"><div class="img-outer"><div class="img-inner"><a class="pic" '+format('href="ShowImage:%d"><img style="width: %dpx" border="0" src="%s"></a></div></div></div>', [GetIntegerField('code'), ScreenshotWidth, FileName]);
							ScreenshotTotalHeight := ScreenshotTotalHeight + Round(GetIntegerField('height') * (ScreenshotWidth / GetIntegerField('width'))) + ScreenshotPadding div 2;
						end;
					GetNextRecord;
				end;
				if RecordCount > MaxShots then begin
					all:=all+format('<div class="arrow-down"><a class="pic" href="userref:110,%d"><img border="0" alt="%s" src="%sarrow-down.gif"></a></div>', [MovieCode, GetLangStr(1411), ImgPath]);
					ScreenshotTotalHeight := ScreenshotTotalHeight + 30; //arrow down width
				end;
				all := all + '</td></tr></table>';
			end; //if
		end;
		
		//tabs
		if RegReadInteger('HideNavigationMenu', 0) = 0 then
			all := all + GetMovieTabs(MovieCode, season, SeasonCnt, awards<>'', shotCnt>0, (EditionsCount > 1) or (VideoFileName <>''), PosterCnt>0, TrailerCnt>0, description <> '', ConnectionsCnt>0, AdditionalSpace);
		//actors
		if ActiveTab = 4 then begin
			all := all + GetCast(MovieCode);
		end;
		
		//Shots
		if ActiveTab = 2 then
			all := all + GetShots(MovieCode, 3, 'movie', 7, 5);
		//Posters
		if ActiveTab = 7 then
			all := all + GetShots(MovieCode, 4, 'movie');
		
		if ActiveTab = 1 then begin	
			if FixedContentsWidth then
				all := all + '<table style="width: 100%; border-collapse: collapse;"><tr><td>';
			all := all + '<table class="names-values">';
			ThisBlockCnt := -1;
			//Tagline
			if TagLine <> '' then begin
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all := all + '<tr><td class="small-table-name"' + border + Format('>%s</td><td class="middle-cell"></td><td class="small-table-value"', [GetLangStr(3406)])+ border + '>"' + TagLine + '"</td></tr>';
			end;
			
			//sequence
			with sl do begin
				Clear;
				Add('select m.code, m.name, mov.series_nom from movies mov');
				Add('join manuals m on m.code=mov.series'); 
				Add(format('where mov.code=%d', [MovieCode]));
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all := all + '<tr><td class="small-table-name"' + border + Format('>%s</td><td class="middle-cell"></td><td class="small-table-value"', [GetLangStr(20271)])+ border + '>';
				all := all + Format('<a href="sequence:%d">%s</a> %s%d', [GetIntegerField('m.code'), GetStringField('m.name'), GetLangStr(529), GetIntegerField('mov.series_nom')]);
				all:=all+'</td></tr>';
			end;
			
			//media type
			if MediaType > 0 then begin
				with sl do begin
					Clear;
					Add('select * from manuals');
					Add(Format('where code=%d', [MediaType]));
				end;
				RecordCount := ExecuteSQL(sl.text);
				if RecordCount > 0 then begin
					ThisBlockCnt := ThisBlockCnt + 1;
					if (ThisBlockCnt mod 2 = 1) then
						border := bckgrnd
					else
						border := '';
					all := all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(173), border]);
					all := all + Format('<a href="media_type:%d">%s</a></td></tr>', [GetIntegerField('code'), GetStringField('name')]);
				end;
			end;
			
			//genres
			with sl do begin
				Clear;
				Add('select m.code, m.name from movies_manuals mm');
				Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference  ???
				Add(format('where mm.movie=%d and m.reference=8', [MovieCode]));
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				//'Genres: '
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all:=all + '<tr><td class="small-table-name"' + border + Format('>%s</td><td class="middle-cell"></td><td class="small-table-value"', [GetLangStr(72)])+ border + '>';
				for i:=1 to RecordCount do begin
					if i>1 then
						all := all + ' / ';
					all:=all+format('<a href="genre:%d">%s</a>', [GetIntegerField('m.code'), GetStringField('m.name')]);
				GetNextRecord;
				end;
				all:=all+'</td></tr>';
			end;
		  
			//year
			if year<>'' then begin
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all:=all+format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s><a href="year:%s,%d">%s</a></td></tr>', [border, GetLangStr(169), border, year, MOVIENIZER_PROGRAM, year]);
			end;
			
			//countries
			with sl do begin
				Clear;
				Add('select m.code, m.name from movies_manuals mm');
				Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference  ???
				Add(format('where mm.movie=%d and m.reference=9', [MovieCode]));
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				//'Countries: '
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all := all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(73), border]);
				country := '';
				for i:=1 to RecordCount do begin
					country:=country+format('<a href="country:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
					GetNextRecord;
				end;
				country:=copy(country, 1, length(country)-3);
				all:=all + country + '</td></tr>';
			end;
		
		
			//duration
			hours := duration div 60;
			minutes := duration mod 60;
			s := '';
			if hours>0 then
				s:=format(' (%d:%.2d)', [hours, minutes]);
			if duration>0 then begin
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all:=all+format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>%d %s%s</td></tr>', [border, GetLangStr(705), border, duration, GetLangStr(706), s]);
			end;

			//mpaa
			mpaa:='';
			if mpaa_code>0 then begin
				with sl do begin
					Clear;
					Add('select name from manuals');
					Add(format('where code=%d', [mpaa_code]));
				end;
				RecordCount:=ExecuteSQL(sl.text);
				if RecordCount>0 then begin
					ThisBlockCnt := ThisBlockCnt + 1;
					if (ThisBlockCnt mod 2 = 1) then
						border := bckgrnd
					else
						border := '';
					s:=Format('<a href="mpaa:%d">%s</a>', [mpaa_code, GetStringField('name')]);
					mpaa:=s;
					if mpaa_desc<>'' then
						mpaa:=mpaa+' '+mpaa_desc;
					all := all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>%s</td></tr>', [border, GetLangStr(708), border, mpaa]);
				end;
			end;
		
			//studios
			studios:='';
			with sl do begin
				Clear;
				Add('select m.code, m.name from movies_manuals mm');
				Add('join manuals m on m.code=mm.ref_code');
				Add(format('where mm.movie=%d and m.reference=12', [MovieCode]));
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				studios := format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(493), border]);
				for i:=1 to RecordCount do begin
					studios := studios + format('<a href="studio:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
					GetNextRecord;
				end;
				studios := copy(studios, 1, length(studios)-3);
				all := all + studios + '</td></tr>';
			end;

			//directors
			s := '';
			with sl do begin
				Clear;
				Add('select distinct p.code, p.name, p.in_collection from data d');
				Add('inner join persons p on p.code=d.person');
				Add(format('where d.movie=%d and d.mode=1', [MovieCode]));
				Add('order by d.sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				//'Directors: ';
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all:=all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(66), border]);
				i:=1;
				while i<=RecordCount do begin
					if GetIntegerField('p.in_collection')=1 then
						img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
					else
						img:='';
					s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
					if (i=5) and (i<RecordCount) and not FullPersons then
						i:=RecordCount;
					i:=i+1;
					GetNextRecord;
				end; //while
				s:=copy(s, 1, length(s)-2);
				if (RecordCount>=6) and not FullPersons then
					s:=s+format(GetLangStr(1251), [MovieCode]);
				all:=all+s+'</td></tr>';
			end; //if

			//writers
			s := '';
			with sl do begin
				Clear;
				Add('select distinct p.code, p.name, p.in_collection from data d');
				Add('inner join persons p on p.code=d.person');
				Add(format('where d.movie=%d and d.mode=2', [MovieCode]));
				Add('order by d.sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				//'Writers: '
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all:=all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(3408), border]);
				i:=1;
				while i<=RecordCount do begin
					if GetIntegerField('p.in_collection')=1 then
						img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
					else
						img:='';
					s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
					if (i=5) and (i<RecordCount) and not FullPersons then
						i:=RecordCount;          	
					i:=i+1;
					GetNextRecord;
				end;
				s:=copy(s, 1, length(s)-2);
				if (RecordCount>=6) and not FullPersons then
					s:=s+format(GetLangStr(1251), [MovieCode]);
				all:=all+s+'</td></tr>';
			end;
			
			//producers
			s := '';
			with sl do begin
				Clear;
				Add('select distinct p.code, p.name, p.in_collection from data d');
				Add('inner join persons p on p.code=d.person');
				Add(format('where d.movie=%d and d.mode=5', [MovieCode]));
				Add('order by d.sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all:=all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(71), border]);
				i:=1;
				while i<=RecordCount do begin
					if GetIntegerField('p.in_collection')=1 then
						img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
					else
						img:='';
					s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
					if (i=5) and (i<RecordCount) and not FullPersons then
						i:=RecordCount;          	
					i:=i+1;
					GetNextRecord;
				end;
				s:=copy(s, 1, length(s)-2);
				if (RecordCount>=6) and not FullPersons then
					s:=s+format(GetLangStr(1251), [MovieCode]);
				all:=all+s+'</td></tr>';
			end;
			
			//cinematography
			s := '';
			with sl do begin
				Clear;
				Add('select distinct p.code, p.name, p.in_collection from data d');
				Add('inner join persons p on p.code=d.person');
				Add(format('where d.movie=%d and d.mode=6', [MovieCode]));
				Add('order by d.sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all:=all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(4576), border]);
				i:=1;
				while i<=RecordCount do begin
					if GetIntegerField('p.in_collection')=1 then
						img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
					else
						img:='';
					s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
					if (i=5) and (i<RecordCount) and not FullPersons then
						i:=RecordCount;          	
					i:=i+1;
					GetNextRecord;
				end;
				s:=copy(s, 1, length(s)-2);
				if (RecordCount>=6) and not FullPersons then
					s:=s+format(GetLangStr(1251), [MovieCode]);
				all:=all+s+'</td></tr>';
			end;

			//composers
			s := '';
			with sl do begin
				Clear;
				Add('select distinct p.code, p.name, p.in_collection from data d');
				Add('inner join persons p on p.code=d.person');
				Add(format('where d.movie=%d and d.mode=4', [MovieCode]));
				Add('order by d.sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				//'Composers: '
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all:=all+Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(491), border]);
				i:=1;
				while i<=RecordCount do begin
					if GetIntegerField('p.in_collection')=1 then
						img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
					else
						img:='';
					s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
					if (i=5) and (i<RecordCount) and not FullPersons then
						i:=RecordCount;          	
					i:=i+1;
					GetNextRecord;
				end;
				s:=copy(s, 1, length(s)-2);
				if (RecordCount>=6) and not FullPersons then
					s:=s+format(GetLangStr(1251), [MovieCode]);
				all:=all+s+'</td></tr>';
			end;
			all := all + '</table>';

			//actors
			with sl do begin
				Clear;
				Add('select distinct p.code, p.name, p.in_collection, c.name from data d');
				Add('inner join persons p on p.code=d.person');
				Add('left outer join characters c on c.person=p.code and c.movie=d.movie');
				Add(format('where d.movie=%d and d.mode=3', [MovieCode]));
				Add('order by d.sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				//'Actors: '
				all := all + '<table class="text-box"><tr><td>';
				i:=1;
				s:='';
				while i<=RecordCount do begin
					if GetIntegerField('p.in_collection')=1 then
						img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
					else
						img:='';
					character:=GetStringField('c.name');
					if character='' then
						s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, '
					else
						s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+format('</a> (%s), ', [character]);
					if (i=10) and (i<RecordCount) and not FullPersons then
						i:=RecordCount;
					i:=i+1;
					GetNextRecord;
				end;
				s:=copy(s, 1, length(s)-2);
				if (RecordCount>=11) and not FullPersons then
					s:=s+format(GetLangStr(1251), [MovieCode]);
				all:=all+s+'</td></tr></table>';
			end;
		end;

		if (ActiveTab = 1) or (ActiveTab = 10) then begin  
			//description
			if description<>'' then
				all:=all+'<table class="text-box"><tr><td>'+description+'</td></tr></table>';
		end;

		if (ActiveTab = 1) then begin
			if not FixedContentsWidth then
				all := all + '<table style="width: 100%; border-collapse: collapse;"><tr><td>';
			//photos of people
			temp := '';
			if (RegReadInteger('HidePhotosCovers', 0) = 0) then begin
				LastCode:=0;
				with sl do begin
					Clear;
					Add('select i.path as path, i.width, i.height, i.person as code, i.mode, p.name, p.birth_date, c.name');
					Add('from data d');
					Add('inner join images i on i.person=d.person');
					Add('inner join persons p on p.code=d.person');
					Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
					Add(format('where d.movie=%d', [MovieCode]));
					Add('order by d.mode, d.sort_order, i.person, i.sort_order');
				end;
				RecordCount:=ExecuteSQL(sl.text);
				page_width := GetHTMLWidth - WholePageBorder;
				if FixedContentsWidth then
					page_width := page_width - LeftColumnWidth;
				i := ScreenshotAreaHeight;
				if page_width > WidePage then
					i := i - 100;
				if ScreenshotTotalHeight > i then
					page_width := page_width - ScreenshotWidth - ScreenshotPadding;
				if RecordCount>0 then begin
					TempList := TStringList.Create;
					all:=all+'<table class="white-bck-block"><tr><td>';
					j := 0;
					kol := 0;
					i := 0;
					fl := True;
					while (i < RecordCount) and fl do begin
						//only photos! no custom images are allowed
						if (GetIntegerField('i.mode') = 6) then begin
							if (TempList.IndexOf(IntToStr(GetIntegerField('code'))) < 0) then begin
								kol := kol + 1;
								TempList.Add(IntToStr(GetIntegerField('code')));
								PicHeight := GetIntegerField('i.height');
								if PicHeight > 0 then
									PicWidth := Round(GetIntegerField('i.width') * (SmallCoverHeight / PicHeight)) + NormalImageBorders
								else
									PicWidth := StandardCoverWidth + NormalImageBorders;
								if PicWidth < StandardCoverWidth then
									PicWidth := StandardCoverWidth + NormalImageBorders;
								//to do: count page width, next line
								{age := GetStringField('p.birth_date');
								while (Pos('/', age)> 1) do
									delete(age, 1, Pos('/', age));
								try
									if (StrToInt(age) > 0) then
										age := IntToStr(StrToInt(year) - StrToInt(age));
								except
								end;}
				  age := '';
				  if (YearsBetween(GetStringField('p.birth_date'), year) > 0) then
					age := IntToStr(YearsBetween(GetStringField('p.birth_date'), year));
								if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
									temp := temp + '<div class="image-place"><div class="photo-outer"><div class="photo-inner">';
									trunc_name := TruncateName(GetStringField('p.name'), MaxNameLength);
									trunc_character := TruncateName(GetStringField('c.name'), MaxCharacterNameLength);

									FileName := GetImageFileName(GetStringField('path'), ThumbsMoviePhotos, NO_PHOTO_FILE[MOVIENIZER_PROGRAM], 0, SmallCoverHeight);
									temp:=temp+format('<a class="pic" href="person:%d"><img style="height: %dpx" src="%s" border="0"></a></div></div><div class="image-text"><a href="person:%d">%s', [GetIntegerField('code'), SmallCoverHeight, FileName, GetIntegerField('code'), trunc_name]);
								//end 2.05.11
									
									
									if age <> '' then
										temp := temp + format(' (%s)', [age]);
									temp := temp + '</a>';
									if trunc_character <> '' then
										temp := temp + '<br>(' + trunc_character + ')';
									temp := temp + '</div></div>';
									page_width := page_width - PicWidth;
									if (page_width >= 0) then begin
										all := all + temp;
										j := j + 1;
										temp := '';
										page_width_rest := page_width;
									end
									else
										fl := False;
								end;//if MyFileExists
							end;
						end;
						GetNextRecord;
						i := i + 1;
					end;//while
					//all := all + '<td colspan="' + IntToStr(kol-j) + '">';
					all := all + '</td>';
					//here comes a magic number :)
					if (kol > j) and (page_width_rest > 50) then
						all := all + '<td class="arrow-left-page"><a class="pic" href="userref:112,'+IntToStr(MovieCode)+'">' + Format('<img border="0" src="%sarrow-left.gif"/>', [ImgPath])+'</a></td>';
					all := all + '</tr></table>';
					TempList.Free;
				end;//if recordcount
			end;

			//custom fields
			cust:='';
			PrevBlockCnt:=-1;
			for i:=1 to 4 do begin
				if custom[i]>0 then begin
					with sl do begin
						Clear;
						Add('select name from manuals');
						Add(format('where code=%d', [custom[i]]));
					end;
					RecordCount:=ExecuteSQL(sl.text);
					if RecordCount>0 then begin
						PrevBlockCnt:=PrevBlockCnt+1;
						if (PrevBlockCnt mod 2 = 1) then
							border := bckgrnd
						else border := '';
						cust:=cust+Format('<tr><td class="big-table-name"%s>', [border])+format(GetLangStr(539+i), [s])+format('</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border])+format('<a href="custom%d:%d">', [i, custom[i]])+GetStringField('name')+'</a></td></tr>';
					end;
				end;
			end;
		
			//custom list1
			with sl do begin
				Clear;
				Add('select m.code, m.name from movies_manuals mm');
				Add('join manuals m on m.code=mm.ref_code');
				Add(format('where mm.movie=%d and m.reference=17', [MovieCode]));
				Add('order by m.name');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				PrevBlockCnt:=PrevBlockCnt+1;
				if (PrevBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				cust:=cust+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(544), border]);
				for i:=1 to RecordCount do begin
					cust:=cust+format('<a href="custom5:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
					GetNextRecord;
				end;
				cust:=copy(cust, 1, length(cust)-2);
				cust:=cust+'</td></tr>';
			end;

			//custom list2
			with sl do begin
				Clear;
				Add('select m.code, m.name from movies_manuals mm');
				Add('join manuals m on m.code=mm.ref_code');
				Add(format('where mm.movie=%d and m.reference=18', [MovieCode]));
				Add('order by m.name');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				PrevBlockCnt:=PrevBlockCnt+1;
				if (PrevBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				cust:=cust+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(545), border]);
				for i:=1 to RecordCount do begin
					cust:=cust+format('<a href="custom6:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
					GetNextRecord;
				end;
				cust:=copy(cust, 1, length(cust)-2);
				cust:=cust+'</td></tr>';
			end;
			if cust <> '' then
				all:=all+'<table class="names-values">'+cust+'</table>';
		end; //if ActiveTab = 1
		
		//Trailers
		if (ActiveTab = 9) then begin
			with sl do begin
				Clear;
				Add('select i.path, i.width, i.height, mc.site from movies_codes mc');
				Add('left join images i');
				Add('on i.code=mc.code');
				Add(format('where mc.movie=%d and mc.script=''trailer''', [MovieCode]));
		  Add('order by i.sort_order')
			end;
			RecordCount := ExecuteSQL(sl.text);
			page_width := GetHTMLWidth - LeftColumnWidth;
			all := all + '<table style="width: 100%;"><tr><td><table class="white-bck-block"><tr>';
			temp := '';
			for i := 1 to RecordCount do begin
				PicWidth := GetIntegerField('i.width');
				if PicWidth = 0 then
					PicWidth := DefaultTrailerWidth;
				PicWidth := PicWidth + NormalImageBorders;
				FileName := ImagesPath + GetStringField('i.path');
				if not (MyFileExists(FileName)) then
					FileName := ImgPath + 'trailer.gif';
				url := GetStringField('mc.site');
				page_width := page_width - PicWidth;
				if page_width < 0 then begin
					temp := temp + '</tr></table><table class="white-bck-block"><tr>';
					page_width := GetHTMLWidth - LeftColumnWidth - PicWidth;
				end;
				if (Pos('http://', url) > 0) or (Pos('https://', url) > 0) then
					url := '<a class="pic" href="link:http://www.movienizer.com/redirect/'+url+'">'
				else
					url := '<a class="pic" href="play:' + url + '">';
				temp := temp + '<td><div style="width: 5px; vertical-align: middle;"><div class="photo-outer"><div class="photo-inner">'+url+format('<img class="trailer" src="%s"></a></div></div></div></td>', [FileName]);	
				GetNextRecord;
			end;
			if temp <> '' then
				all := all + temp + '</tr></table></td></tr></table>';
		end;
		
		//movie connections
		if (ActiveTab = 11) then begin
			//movie series
			if MovieSeriesNumber > 0 then begin
				temp := '<table style="width: 100%;"><tr><td>';
				//previous movies
				with sl do begin
					Clear;
					Add('SELECT m.title, m.code, m.year, m.in_collection FROM Movies m');
					Add(Format('WHERE m.series=%d AND m.series_nom<%d', [MovieSeries, MovieSeriesNumber]));
					Add('ORDER BY m.series_nom');
				end;
				RecordCount := ExecuteSQL(sl.text);
				if RecordCount > 0 then begin
					temp := temp + '<tr><td><p class="header">'+GetLangStr(3907)+':';
					temp := temp + '</p><div class="filmography"><ol>';
					i := 1;
					while i <= RecordCount do begin
						LinkYearStr := GetStringField('m.year');
						if (LinkYearStr <> '') then
							LinkYearStr := ' (' + LinkYearStr + ')';
						if (GetIntegerField('m.in_collection')=1) then
							img:=format('<img src="%sin-collection-small.gif" align="absmiddle">&nbsp;', [ImgPath])
						else
							img := '';
						temp := temp + '<li>' + img + Format('<a href="movie:%d">', [GetIntegerField('m.code')]) + GetStringField('m.title')+ Format('</a>%s</li>', [LinkYearStr]);
						i := i + 1;
						GetNextRecord;
					end;
					temp := temp + '</ol></div>';
				end;
				//following movies
				with sl do begin
					Clear;
					Add('SELECT m.title, m.code, m.year, m.in_collection FROM Movies m');
					Add(Format('WHERE m.series=%d AND m.series_nom>%d', [MovieSeries, MovieSeriesNumber]));
					Add('ORDER BY m.series_nom');
				end;
				RecordCount := ExecuteSQL(sl.text);
				if RecordCount > 0 then begin
					temp := temp + '<tr><td><p class="header">'+GetLangStr(3908)+':';
					temp := temp + '</p><div class="filmography"><ol>';
					i := 1;
					while i <= RecordCount do begin
						LinkYearStr := GetStringField('m.year');
						if (LinkYearStr <> '') then
							LinkYearStr := ' (' + LinkYearStr + ')';
						if (GetIntegerField('m.in_collection')=1) then
							img:=format('<img src="%sin-collection-small.gif" align="absmiddle">&nbsp;', [ImgPath])
						else
							img := '';
						temp := temp + '<li>' + img + Format('<a href="movie:%d">', [GetIntegerField('m.code')]) + GetStringField('m.title')+ Format('</a>%s</li>', [LinkYearStr]);
						i := i + 1;
						GetNextRecord;
					end;
					temp := temp + '</ol></div>';
				end;
				temp := temp + '</td></tr></table>';
				all := all + temp;
			end;
			//other connections
			with sl do begin
				Clear;
				Add('SELECT ml.*, m.Code, m.title, m.year, m.in_collection FROM Movies_links ml');
				Add('LEFT JOIN Movies m ON m.code = ml.movie_secondary');
				Add(format('where ml.movie_primary=%d', [MovieCode]));
				Add('order by ml.link_status, m.Year');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			temp := '';
			if RecordCount > 0 then begin
				OldLinkStatus := -1;
				i := 1;
				while i<=RecordCount do begin
					if (OldLinkStatus <> GetIntegerField('ml.link_status')) then begin
						if OldLinkStatus > -1 then
							temp := temp + '</ol></div>';
						OldLinkStatus := GetIntegerField('ml.link_status');
						case OldLinkStatus of
							2: LinkMovieStatusTitle := GetLangStr(3915);
							3: LinkMovieStatusTitle := GetLangStr(3916);
							4: LinkMovieStatusTitle := GetLangStr(3917);
							5: LinkMovieStatusTitle := GetLangStr(3918);
						end;
						temp := temp + '<tr><td><p class="header">'+LinkMovieStatusTitle+':';
						temp := temp + '</p><div class="filmography"><ol>';
					end;
					LinkYearStr := GetStringField('m.year');
					if (LinkYearStr <> '') then
						LinkYearStr := ' (' + LinkYearStr + ')';
					if (GetIntegerField('m.in_collection')=1) then
						img:=format('<img src="%sin-collection-small.gif" align="absmiddle">&nbsp;', [ImgPath])
					else
						img := '';
					temp := temp + '<li>' + img + format('<a href="movie:%d">', [GetIntegerField('m.code')]) + GetStringField('m.Title') + Format('</a>%s</li>', [LinkYearStr]);
					i:=i+1;
					GetNextRecord;
				end;
				if temp <> '' then
					all := all + '<table style="width: 100%;"><tr><td>' + temp + '</ol></div></td></tr></table>';
			end;
		end; // end movie connections
			
		//editions
		if ((ActiveTab = 1) and 
		(((SeasonCnt = 0) and (RegReadInteger('ShowEditionsOnMainTab', 1) = 1)) or ((SeasonCnt > 0) and (RegReadInteger('ShowEditionsOfTVSeries', 0) = 1)))) 
		or (ActiveTab = 5) or (ActiveTab = 8) then begin
			with sl do begin
				Clear;
				Add('select e.code from editions e');
				Add('left outer join manuals m on m.code=e.edition and m.reference=21');
				Add(format('where e.movie=%d', [MovieCode]));
				Add('order by e.sort_order');
			end;
			EditionsCount:=ExecuteSQL(sl.text);

			for ie:=1 to EditionsCount do begin
				editions[ie]:=GetIntegerField('e.code');
				GetNextRecord;
			end;
			
			if EditionsCount > 0 then
				all := all + '<table class="envelope-table"><tr><td>';

			for ie:=1 to EditionsCount do begin
				EditionCode:=editions[ie];
				//editions
				with sl do begin
					Clear;
					Add('select * from editions e');
					Add('left outer join manuals m on m.code=e.edition and m.reference=21');
					Add(format('where e.code=%d', [EditionCode]));
				end;
				ExecuteSQL(sl.text);

				ed:='';
		
				//video parameters
				VideoBitrate:=GetIntegerField('e.video_bitrate');
				filesize:=GetIntegerField('e.filesize');
				DiscLabel:=GetIntegerField('e.disc_label');
				disc_nom:=GetStringField('e.disc_nom');
				duration:=GetIntegerField('e.duration');
				barcode:=GetStringField('e.barcode');

				VideoStandard:=GetIntegerField('e.video_standard');
				ScreenRatio:=GetIntegerField('e.screen_ratio');
				resolution:=GetIntegerField('e.resolution');
				VideoCodec:=GetIntegerField('e.video_codec');
				MediaFormat:=GetIntegerField('e.media_format');
			
				EditionFeatures:=GetStringField('e.features');
				EditionComment:=GetStringField('e.comment');
				EditionCost:=GetFloatField('e.cost');
			
				if ((EditionsCount > 1) or (RegReadInteger('ShowEditions', 0) = 1) or (ActiveTab = 5) or (ActiveTab=8)) then begin
					PrevBlockCnt:=-1;
					VideoFileName := GetStringField('e.filename');
					VideoFileFolder := VideoFileName;
					while (length(VideoFileFolder)>0) and (pos(VideoFileFolder[length(VideoFileFolder)],'/\')=0) do delete(VideoFileFolder,length(VideoFileFolder),1);
					ed:=ed + '<p class="header">';
					if VideoFileFolder<>'' then
						ed:=ed+format('<a class="pic" href="explore:%s">', [VideoFileName])+format('<img src="%sfolder.png" align="absmiddle" border="0" alt="%s"></a> ', [ImgPath, VideoFileName])+'&nbsp;';
					i := GetIntegerField('e.season');
					j := GetIntegerField('e.episode');
					if (i=0) and ((RegReadInteger('OnlyEditionName', 0) = 0) or (GetStringField('m.name') = '')) then
						ed:=ed+format(GetLangStr(1260), [ie])+'. ';
					if GetStringField('m.name')<>'' then
						ed:=ed+GetStringField('m.name')+'. ';
					barcode := GetStringField('e.barcode');
					if not ((i=0) and (j=0)) then begin
						ed:=ed+format(GetLangStr(1252), [i, j])+'. ';
						with sl do begin
							Clear;
							Add('SELECT title FROM episodes');
							Add(format('where movie=%d and season=%d and episode=%d', [MovieCode, i, j]));
						end;
						ExecuteSQL(sl.text);
						ed := ed+GetStringField('title')+'. ';
					end;
					if VideoFileName<>'' then
						ed:=ed+format('<a class="pic" href="play:%s">', [VideoFileName])+format('<img src="%splay.png" align="absmiddle" border="0" alt="%s"></a> ', [ImgPath, VideoFileName]);

				  
					if duration>0 then
						ed:=ed+Format('<font size="2">(%d:%0.2d)</font> ', [duration div 60, duration mod 60]);
					if barcode<>'' then
						ed:=ed+GetLangStr(1259)+': '+barcode;
					ed := ed + '</p>';
				end;

				all:=all+ed;
		
		
				//editions
				if (ActiveTab = 1) or (ActiveTab = 5) then begin
					ed:='<table class="names-values">';
					ThisBlockCnt := -1;
			
					if (ActiveTab = 1) then begin
						//disc #
						if disc_nom<>'' then begin
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							ed:=ed+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(391), border, disc_nom]);
						end;
						//disc label
						if DiscLabel>0 then begin
							with sl do begin
								Clear;
								Add('select name from manuals');
								Add(format('where code=%d', [DiscLabel]));
							end;
							RecordCount:=ExecuteSQL(sl.text);
							if RecordCount>0 then begin
								ThisBlockCnt := ThisBlockCnt + 1;
								if (ThisBlockCnt mod 2 = 1) then
									border := bckgrnd
								else
									border := '';
								ed:=ed+format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="disc_label:%d">%s</a></td></tr>', [border, GetLangStr(1000), border, DiscLabel, GetStringField('name')]);
							end;
						end;
						//edition cost
						if EditionCost > 0 then begin
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							ed:=ed+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%f</td></tr>', [border, GetLangStr(3350), border, EditionCost]);
						end;
			
						//loans
						border:='';
						with sl do begin
							Clear;
							Add('select l.location, m.name from loans l');
							Add('inner join manuals m on m.code=l.location');
							Add(format('where edition=%d', [EditionCode]));
							Add('and (return_date='''' or return_date is null)');
							Add('order by loan_date desc');
						end;
						RecordCount:=ExecuteSQL(sl.text);
						if RecordCount>0 then begin
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							ed:=ed+Format('<tr><td class="big-table-name"%s>', [border])+GetLangStr(333)+format('</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="location:%d">%s</a></td></tr>', [border, GetIntegerField('l.location'), GetStringField('m.name')]);
						end;
					end;
				
					if (ed<>'') then
						all := all + ed;
			
					//parameters
					with sl do begin
						Clear;
						Add('select name, reference from manuals');
						Add(format('where code in (%d, %d, %d, %d, %d)', [VideoStandard, ScreenRatio, resolution, VideoCodec, MediaFormat]));
						Add('order by reference');
					end;
					RecordCount:=ExecuteSQL(sl.text);
					for i:=1 to RecordCount do begin
						if GetIntegerField('reference')=1 then begin
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							//Video standard
							all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(201), border, GetStringField('name')]);
						end
						else if GetIntegerField('reference')=2 then begin
							//media format
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="media_format:%d">%s</a></td></tr>', [border, GetLangStr(249), border, MediaFormat, GetStringField('name')]);
						end
						else if GetIntegerField('reference')=4 then begin
							//screen ratio
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="aspect_ratio:%d">%s</a></td></tr>', [border, GetLangStr(202), border, ScreenRatio, GetStringField('name')]);
						end
				
						else if GetIntegerField('reference')=5 then begin
							//resolution
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="resolution:%d">%s</a></td></tr>', [border, GetLangStr(203), border, resolution, GetStringField('name')]);
						end

						else if GetIntegerField('reference')=19 then begin
							//video codec
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="video_codec:%d">%s</a></td></tr>', [border, GetLangStr(571), border, VideoCodec, GetStringField('name')]);
						end;
						GetNextRecord;
					end;
					s2:='';
					//video bitrate
					if VideoBitrate>0 then begin
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						s2:=format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%d</td></tr>', [border, GetLangStr(630), border, VideoBitrate]);
					end;
					//filesize
					if filesize>0 then begin
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						s2:=s2+format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%d</td></tr>', [border, GetLangStr(631), border, filesize]);
					end;
			
					//duration
					if (duration>0) and (EditionsCount=1) then begin
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						s2:=s2+format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%d %s', [border, GetLangStr(147), border, duration, GetLangStr(706)]);
						s2:=s2+format(' (%d:%.2d)</td></tr>', [duration div 60, duration mod 60]);
					end;
			
					all:=all+s2;

					//audio tracks
					with sl do begin
						Clear;
						Add('select m.code, m.name, am.Bitrate, am.Codec, am.Channel, am.Short_Comment from audio_manuals am');
						Add('left join manuals m on m.code=am.reference');
						Add(format('where am.edition=%d and am.media_type=0', [EditionCode]));
					end;
					RecordCount:=ExecuteSQL(sl.text);
					if RecordCount>0 then begin
						//Audio tracks
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(254), border]);
						for i:=1 to RecordCount do begin
							s2 := ' ' + GetStringField('am.codec');
							if (s2 <> '') then
							  S2 := s2 + ' ';
							if (GetIntegerField('am.channel') > 0) then
							  s2 := s2 + GetStringField('am.channel') + ' ch ';
							if (GetIntegerField('am.Bitrate') > 0) then
							  s2 := s2 + GetStringField('am.Bitrate') + ' kbps ';
							if (GetStringField('am.Short_Comment') <> '') then
							  s2 := s2 + GetStringField('am.Short_Comment') + ' ';
							if (s2<>'') then
								s2 := copy(s2, 1, length(s2) - 1);
							all:=all+format('<a href="audio_track:%d">%s</a>%s, ', [GetIntegerField('m.code'), GetStringField('m.name'), s2]);

							GetNextRecord;
						end;
						all:=copy(all, 1, length(all)-2);
						all := all + '</td></tr>';
					end;

					//subtitles
					with sl do begin
						Clear;
						Add('select m.code, m.name, am.Short_Comment from audio_manuals am');
						Add('join manuals m on m.code=am.reference');
						Add(format('where am.edition=%d and am.media_type=1', [EditionCode]));
					end;
					RecordCount:=ExecuteSQL(sl.text);
					if RecordCount>0 then begin
						//Subtitles
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(253), border]);
						for i:=1 to RecordCount do begin
							s2 := '';
							if (GetStringField('am.Short_Comment') <> '') then
								s2 := ' ' + Trim(GetStringField('am.Short_Comment'));
							all:=all+format('<a href="subtitle:%d">%s</a>%s, ', [GetIntegerField('m.code'), GetStringField('m.name'), s2]);
							GetNextRecord;
						end;
						all:=copy(all, 1, length(all)-2);
						all := all + '</td></tr>';
					end;
					//show filename
					if (RegReadInteger('ShowFileNames', 1) = 1) and (VideoFileName<>'') then begin
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						all := all + Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(195), border]);
						all := all + Format('<a href="play:%s">%s</a></td></tr>', [VideoFileName, VideoFileName]);
					end;
					all := all + '</table>';
					// DVD Features
					if EditionFeatures<>'' then begin
						all := all + '<p class="text-box">' + EditionFeatures + '</p>';
						PrevBlockCnt := 0;
					end;
			
					//Edition comments
					if EditionComment<>'' then begin
						all := all + '<p class="text-box">' + EditionComment + '</p>';
						PrevBlockCnt := 0;
					end;
			
				end;
			end; //editions 
			if EditionsCount > 0 then
				all := all + '</td></tr></table>';
		end;

		//get season covers, save them into a string list
		SeasonCovers := TStringList.Create;
		if (ActiveTab = 6) or ((ActiveTab = 1) and (SeasonCnt > 0) and (RegReadInteger('ShowSeasonsOnGeneralTab', 0) = 0)) then begin
			with sl do begin
				Clear;
				Add('SELECT e.code, e.season, i.path, i.code, i.width, i.height FROM episodes e');
				Add('JOIN images i ON i.movie=e.movie AND i.season=e.season');
				Add(format('WHERE e.movie=%d AND i.mode=9', [MovieCode]));
				Add('ORDER BY e.season');
			end;
			RecordCount := ExecuteSQL(sl.text);
			LastCode := 0;
			for i := 1 to RecordCount do begin
				if (LastCode <> GetIntegerField('i.code')) then begin
					SeasonCovers.Add(IntToStr(GetIntegerField('e.season')) + '=' + GetStringField('i.path') + ':' + IntToStr(GetIntegerField('i.width')) + '<' + IntToStr(GetIntegerField('i.height')) + '>' + IntToStr(GetIntegerField('i.code')) + '?');
					LastCode := GetIntegerField('i.code');
				end;
				GetNextRecord;
			end;
		end;
		
		//seasons
		if (ActiveTab = 6) or ((RegReadInteger('ShowSeasonsOnGeneralTab', 0) = 1) and (ActiveTab = 1)) then begin
			
			seasons:='';
			kol:=0;
			with sl do begin
				Clear;
				Add('select e.season, e.episode, e.title, e.description, e.original_air_date, e.seen, e.code, e.rating, ed.filename, i.path, i.code from episodes e');
				Add('left outer join editions ed on ed.movie=e.movie and e.season=ed.season and e.episode=ed.episode');
				Add('left outer join images i on i.movie=e.movie and i.season=e.season and i.episode=e.episode');
				if season = 0 then begin
					Add(format('where e.movie=%d', [MovieCode]));
					Add(' order by e.season, e.episode');
				end
				else begin
					Add(format('where e.movie=%d and e.season=%d', [MovieCode, season]));
					Add(' order by e.episode');
				end;
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount > 0 then begin
				seasons := seasons + '<table style="width: 100%"><tr><td>';
				//SeenList := TStringList.Create;
				UnseenList := TStringList.Create;
				UnseenEpisodes := '';
				for i:=1 to RecordCount do begin
					if GetIntegerField('e.season')>kol then begin
						kol:=GetIntegerField('e.season');
						if kol > 1 then
							seasons := seasons + '</td></tr></table>';
						s2 := format(GetLangStr(514), [kol]);
						if kol = 99 then
							s2 := GetLangStr(4441);
						s3 := format('<div style="text-align: center;"><a class="pic" href="userref:153,%d;%d">', [kol, MovieCode]) + '<img alt="' + GetLangStr(7011) + Format('" src="%sseen.gif" border="0" style="margin-top: 5px;"></a> ', [ImgPath]) + format('<a class="pic" href="userref:154,%d;%d">', [kol, MovieCode]) + '<img alt="' + GetLangStr(7012) + Format('" src="%snot-seen.gif" border="0" style="margin-top: 5px;"></a></div>', [ImgPath]);
						seasons:=seasons+'<p class="header">'+s2+'</p><table class="text-box"><tr><td style="width: 10; vertical-align: top;">';
						ShortFilename := SeasonCovers.Values[IntToStr(kol)];
						if ShortFileName <> '' then begin
							s := GetStr(ShortFilename, '>', '?');
							j := Pos(':', ShortFilename);
							ShortFilename := copy(ShortFilename, 1, j-1);
							FileName := GetImageFileName(ShortFilename, ThumbsCovers, NO_COVER_FILE[MOVIENIZER_PROGRAM], MainCoverWidth, 0);
							seasons := seasons + '<div class="img-outer" style="vertical-align: middle; margin: 10px;"><div class="img-inner"><a class="pic"' + format(' href="ShowImage:%s"><img style="width: %dpx" border="0" src="%s">', [s, MainCoverWidth, FileName]) + '</a></div></div>' + s3;
						end;
						seasons:=seasons+'</td><td>';
					end;
					temp := '';
					if (GetIntegerField('e.seen')=1) then begin
						temp := format('<a class="pic" href="userref:150,%d;%d"><img src="%sseen.gif" align="absmiddle"></a> ', [GetIntegerField('e.code'), MovieCode, ImgPath]);
					end
					else begin
						UnseenList.Add('#' + IntToStr(GetIntegerField('e.code')) + '#');
						UnseenEpisodes := UnseenList.CommaText;
						temp := format('<a class="pic" href="userref:151,%d;%d"><img src="%snot-seen.gif" align="absmiddle"></a> ', [GetIntegerField('e.code'), MovieCode, ImgPath]);
					end;
					  fl := False;
					  if MyFileExists(ImagesPath+GetStringField('i.path')) then begin
						FileName := GetImageFileName(GetStringField('i.path'), ThumbsEpisodeCovers, '', EpisodeCoverWidth, 0);
						seasons := seasons + '<table class="right-block" style="margin-top: 0px; line-height: 0px; padding: 0;"><tr><td><div class="shot-place"><div class="img-outer"><div class="img-inner"><a class="pic" ' + Format('href="ShowImage:%d"><img style="border: 0; margin: 0; width: %d;" src="%s">', [GetIntegerField('i.code'), EpisodeCoverWidth, Filename]) + '</a></div></div></div></td></tr></table>';
						fl := True;
					  end;
					  seasons:=seasons+'<p class="episode-header">'+temp+format(GetLangStr(518), [GetIntegerField('e.episode')])+'. '+GetStringField('e.title');
					  s:=GetStringField('e.original_air_date');
					  s:=SQLDate2Str(s);
					  if s<>'' then
						  seasons:=seasons+'. '+s;
						rating := GetIntegerField('e.rating');
						rate:='';
						for j:=1 to 10 do begin
							if j mod 2=1 then begin
								if j<=rating then
									rate:=rate+format('<a class="pic" href="userref:152,%d;%d;%d"><img src="%shalfstar-left.gif" align="absmiddle" border="0"></a>',  [GetIntegerField('e.code'), MovieCode, j, ImgPath])
								else
									rate:=rate+format('<a class="pic" href="userref:152,%d;%d;%d"><img src="%snot-halfstar-left.gif" align="absmiddle" border="0"></a>',  [GetIntegerField('e.code'), MovieCode, j, ImgPath])
							end
							else begin
								if j<=rating then
									rate:=rate+format('<a class="pic" href="userref:152,%d;%d;%d"><img src="%shalfstar-right.gif" align="absmiddle" border="0"></a>',  [GetIntegerField('e.code'), MovieCode, j, ImgPath])
								else
									rate:=rate+format('<a class="pic" href="userref:152,%d;%d;%d"><img src="%snot-halfstar-right.gif" align="absmiddle" border="0"></a>',  [GetIntegerField('e.code'), MovieCode, j, ImgPath])
							end;
						end;
					  if rate <> '' then
						seasons := seasons + '&nbsp;' + rate;
						  
					  if GetStringField('ed.filename')<>'' then
						seasons:=seasons+format('&nbsp;<a class="pic" href="play:%s">', [GetStringField('ed.filename')])+format('<img src="%splay.png" align="absmiddle" border="0"></a>', [ImgPath]);

					  seasons:=seasons+'</p>';
					  if GetStringField('e.description') <> '' then
						seasons:=seasons+GetStringField('e.description');
					  if fl then
						seasons := seasons + '<div style="clear: both;"></div>';
							GetNextRecord;
				  end;
				if seasons <> '' then
					seasons := seasons + '</td></tr></table></td></tr></table>';
				all := all + seasons;
				//SeenList.Free;
				UnseenList.Free;
			end;
		end;
		
		//show season covers on the general tab
		if (ActiveTab = 1) and (SeasonCnt > 0) and (RegReadInteger('ShowSeasonsOnGeneralTab', 0) = 0) then begin
			seasons := '';
			kol := 0;
			page_width := GetHTMLWidth - WholePageBorder + SeasonCoverSpace div 2;
			if FixedContentsWidth then
				page_width := page_width - LeftColumnWidth;
			i := ScreenshotAreaHeight + 100;
			if page_width > SuperWidePage then
				i := i - 400;
			if ScreenshotTotalHeight > i then
				page_width := page_width - ScreenshotWidth - ScreenshotPadding;
			if SeasonCovers.Count > 0 then begin
				seasons := seasons + '<table><tr>';
				temp := '';
				page_width_copy := page_width;
				PrevPicWidth := 0;
				for i := 0 to SeasonCovers.Count - 1 do begin
					//link to season cover
					ShortFilename := GetStr(SeasonCovers[i], '=', ':');
					//picture width
					s := GetStr(SeasonCovers[i], ':', '<');
					//picture height
					s2 := GetStr(SeasonCovers[i], '<', '>');
					//season number
					s3 := SeasonCovers.Names[i];
					
					this_width := 0;
					this_height := 0;
					this_season := 0;
					try
						this_width := StrToInt(s);
						this_height := StrToInt(s2);
						this_season := StrToInt(s3);
					except
					end;
					PicHeight := this_height;
					if PicHeight > 0 then
						PicWidth := Round(this_width * (NoCoverHeight / PicHeight)) + BigImageBorders + SeasonCoverSpace
					else
						PicWidth := MainCoverWidth + BigImageBorders + SeasonCoverSpace;
					if PicWidth < MainCoverWidth then
						PicWidth := MainCoverWidth + BigImageBorders + SeasonCoverSpace;
					if (MyFileExists(ImagesPath+ShortFilename)) then begin
						//      
						if ((page_width_copy - PicWidth) < 0) or (page_width_copy = page_width) then
							i := 0
						else
							i := SeasonCoverSpace;
						temp := temp + Format('<td style="padding-left: %dpx; padding-right: 0px;">', [i]);
						temp := temp + '<div class="img-outer"><div class="img-inner"><a class="pic" ' + Format('href="userref:114,%d;%d">', [MovieCode, this_season]);
						FileName := GetImageFileName(ShortFilename, ThumbsCovers, NO_COVER_FILE[MOVIENIZER_PROGRAM], MainCoverWidth, 0);
						s2 := Format(GetLangStr(514), [this_season]);
						if this_season = 99 then
							s2 := GetLangStr(4441);
						temp := temp + Format('<img style="width: %d; border: 0;" src="%s">', [MainCoverWidth, FileName]) + '</a></div></div>';
						temp := temp + Format('<div><p style="text-align: center; font-size: %dpt; padding: 0; margin: 0; padding-bottom: 10px;">', [SeasonTitleSize]) + format('<a href="userref:114,%d;%d">', [MovieCode, this_season]) + s2 + '</a></p></div>';
						temp := temp + '</td>';
					end;
					page_width_copy := page_width_copy - PicWidth;
					PrevPicWidth := PicWidth;
					if page_width_copy < 0 then begin
						seasons := seasons + '</tr><tr>' + temp;
						page_width_copy := page_width - PicWidth;
					end
					else
						seasons := seasons + temp;
					temp := '';
					GetNextRecord;
				end;
				seasons := seasons + '</tr></table>';
				all := all + seasons;
			end
			else
				all := all + Format('<p class="header"><a href="userref:114,%d;0">%s %d</a></p>',[MovieCode, GetLangStr(517), SeasonCnt]);
		end;
		SeasonCovers.Free;
		
		if (ActiveTab = 1) then begin
			//dates
			s:='';
			ThisBlockCnt := 0;
			s := '<table class="names-values">';
			border := bckgrnd;
			if DateAdd<>'' then
				s:=s+format('<tr><td class="big-table-name">%s</td><td class="middle-cell"></td><td class="big-table-value">%s</td></tr>', [GetLangStr(670), SQLDate2Str(DateAdd)]);
			if DateUpdate<>'' then
				s:=s+format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(671), border, SQLDate2Str(DateUpdate)]);
			if DateSeen<>'' then
				s:=s+format('<tr><td class="big-table-name">%s</td><td class="middle-cell"></td><td class="big-table-value">%s</td></tr>', [GetLangStr(672), SQLDate2Str(DateSeen)]);
			all:=all+s+'</table>';



			//salary
			cust := '';
			if salary<>'' then
				cust:=cust+'<table class="text-box"><tr><td>'+salary+'</td></tr></table>';
			all := all + cust;

			//comments
			cust := '';
			if comment<>'' then begin
				if not FullComments and (length(comment)>DescriptionLength) then begin
					comment:=copy(comment, 1, DescriptionLength);
					comment:=comment+format(GetLangStr(1250), [MovieCode]);
				end;
				cust:=cust+'<table class="text-box"><tr><td>'+comment+'</td></tr></table>';
			end;
			
			all := all + cust;
		end;
		
		cust := '';
		
		//awards
		if (ActiveTab = 3) then begin
			if awards<>'' then begin
				sl.Clear;
				sl.LoadFromFile(PicturesPath + 'awards\awards.txt');
				//the general description from kinopoisk
				i := Pos('<br>', awards);
				temp := copy(awards, 1, i-1);
				if Pos('.', temp) > 5 then begin
					cust := temp + '<br>';
					delete(awards, 1, i+3);
				end;
				temp := '';
				while awards <> '' do begin
					i := Pos('<br><br>', awards) + 8;
					if i = 8 then
						i := Pos('<br> <br>', awards) + 9;
					if i = 9 then
						i := length(awards) + 1;
					//process each award separately
					s := copy(awards, 1, i-1);
					j := Pos(',', s);
					k := Pos('<br>', s);
					if (k < j) or (j = 0) then
						j := k;
					temp_name := copy(s, 1, j-1);
					j := Pos('"', temp_name);
					if j > 0 then
						temp_name := GetStr(temp_name, '"', '"');
					new_name := '<a href="userref:302,' + temp_name + '">' + temp_name + '</a>';
					s := ReplaceStr(s, temp_name, new_name);
					for k := 0 to sl.Count - 1 do begin
						name := sl.Names[k];
						s3 := sl.Values[sl.Names[k]];
						s3 := ReplaceStr(s3, '-mid.', '.');
						j := Pos(':', name);
						if j > 0 then
							delete(name, j, length(name)-j+1);
						j := Pos('">' + LowerCase(name), LowerCase(new_name));
						if (j > 0) then
							l := Pos(LowerCase(new_name), LowerCase(s))
						else
							l := Pos(LowerCase(name), LowerCase(s));
						if (l = 1) or ((l > 0) and (s[l-1] = '>')) then begin
							s2 := '<div style="clear:both"><div style="float: left; margin: 5px;"><a class="pic" href="userref:302,'+ name + '"><img border="0" alt="' + name + '" src="' + PicturesPath + 'awards\' + s3 + '"></a></div>';
							insert(s2, s, l);
						end;
					end;
					temp := temp + s;
					delete(awards, 1, i - 1);
				end;
				cust:='<table class="text-box"><tr><td>'+cust+temp+'</td></tr></table>';
			end;
			all := all + cust;
		
		end;
		if ((ActiveTab = 1) and (RegReadInteger('ShowAwardsOnGeneralTab', 0) = 1)) then begin
			if awards <> '' then begin
				cust:='<table class="text-box"><tr><td>'+awards+'</td></tr></table>';
				all := all + cust;
			end;
		end;
		
		if (ActiveTab = 1) then
			all := all + '</td></tr></table>';


		sl.Free;
		SeasonNumbers.Free;
		result:=all;
	finally
		ResetRegistrySubKey();
	end;
end;

function GetUserReferenceForMovie(code: integer; text: string; page: integer = 1): string;
var
  sl, TempList, PreviousCodes: TStringList;
  i, j, kol, RecordCount, rating, page_width, LastCode, my_i, my_code, movie_code: integer;
  s, s2, description, year, director, writer, actor, bio, character, movie, movie_top: string;
  all, FileName, img, rate: string;
  IMDBRating: double;
  StartItem, EndItem, MoviesPage, ii, TotalItems, lines, SeasonNr, PageItems: integer;
  fl, ShowLastUpdated, loan_page: boolean;
  dd, mm, yy, loan_code, page_width_copy, PicWidth, PicHeight: integer;
  RatingIndex: Integer;
  current_site, sortby_string, mc_rating, header_img, temp: String;
begin
	result:='';
	SetRegistrySubKey(REGISTRY_SUB_KEYS[MOVIENIZER_PROGRAM]);
	try
		ProgramReference:='';
		TempReferenceCode:=code;
		TempReference:=666;
		TempText:=text;
		if code=100 then
			result := GetPatternTop+format('<p class="title">%s</p><div class="icons">&nbsp;</div>', [GetLangStr(1333)])+ClosePatternTop+'<p class="header">'+ShowScriptOptions
		
		//episodes seen
		else if code in [150..151] then begin
			i := Pos(';', text);
			movie_code := 0;
			my_code := 0;
			if i>0 then begin
				TempList := TStringList.Create;
				s := copy(text, i+1, Length(text)-i);
				s2 := copy(text, 1, i-1);
				try
					movie_code := StrToInt(s);
					my_code := StrToInt(s2);
				except
				end;
				i := Pos('#' + s2 + '#', UnseenEpisodes);
				if i>1 then
					delete(UnseenEpisodes, i-1, length(UnseenEpisodes)-i+2)
				else if i=1 then
					UnseenEpisodes := '';
				UnseenEpisodes := ReplaceStr(UnseenEpisodes, '#', '');
				if code=151 then begin
					TempList.CommaText := UnseenEpisodes;
				end;
				my_i := code - 150;
				if my_code <> 0 then begin
					s := Format('UPDATE episodes SET seen=%d WHERE code=%d', [my_i, my_code]);
					ExecuteSQL(s);
					if (TempList.Count > 0) and MarkPreviousAsSeen then begin
						ExecuteSQL('BEGIN TRANSACTION');
						for i := 0 to TempList.Count - 1 do begin
							s := Format('UPDATE episodes SET seen=1 WHERE code=%s', [TempList[i]]);
							ExecuteSQL(s);
						end;
						ExecuteSQL('COMMIT');
					end;
				end;
				if movie_code > 0 then begin
					SetMode(1, movie_code);
					result := GetMoviePage(movie_code, 0, false, false, false, false);
				end;
				TempList.Free;
			end;
		end
		//episode rating
		else if code = 152 then begin
			my_code := 0;
			i := Pos(';', text);
			if i>0 then begin
				s := copy(text, 1, i-1);
				delete(text, 1, i);
			end;
			i := Pos(';', text);
			if i>0 then begin
				s2 := copy(text, 1, i-1);
				delete(text, 1, i);
			end;
			i := 0;
			try
				i := StrToInt(text);
				my_code := StrToInt(s);
				movie_code := StrToInt(s2);
			except
			end;
			if i>0 then begin
				s := Format('UPDATE episodes SET seen=1 WHERE code=%d', [my_code]);
				ExecuteSQL(s);
				s := Format('UPDATE episodes SET rating=%d WHERE code=%d', [i, my_code]);
				ExecuteSQL(s);
			end;
			if movie_code > 0 then begin
				SetMode(1, movie_code);
				result := GetMoviePage(movie_code, 0, false, false, false, false);
			end;
		end
		//mark season as seen
		else if code = 153 then begin
			my_code := 0;
			i := Pos(';', text);
			if i>0 then begin
				s := copy(text, 1, i-1);
				delete(text, 1, i);
			end;
			try
				my_code := StrToInt(s);
				movie_code := StrToInt(text);
			except
			end;
			if i>0 then begin
				s := Format('UPDATE episodes SET seen=1 WHERE season=%d and movie=%d', [my_code, movie_code]);
				ExecuteSQL(s);
			end;
			if movie_code > 0 then begin
				SetMode(1, movie_code);
				result := GetMoviePage(movie_code, 0, false, false, false, false);
			end;
		end
		//mark season as unseen
		else if code = 154 then begin
			my_code := 0;
			i := Pos(';', text);
			if i>0 then begin
				s := copy(text, 1, i-1);
				delete(text, 1, i);
			end;
			try
				my_code := StrToInt(s);
				movie_code := StrToInt(text);
			except
			end;
			if i>0 then begin
				s := Format('UPDATE episodes SET seen=0 WHERE season=%d and movie=%d', [my_code, movie_code]);
				ExecuteSQL(s);
			end;
			if movie_code > 0 then begin
				SetMode(1, movie_code);
				result := GetMoviePage(movie_code, 0, false, false, false, false);
			end;
		end
		//Movie tabs
		else if code in [109..129]	then begin
			my_code := 0;
			SeasonNr := 0;
			i := Pos(';', text);
			if i>0 then begin
				s := copy(text, i+1, length(text) - i);
				delete(text, i, length(text) - i + 1);
				try
					SeasonNr := StrToInt(s);
				except
				end;
			end;
			try
				my_code := StrToInt(text);
			except
			end;

			//18.11.10
			SetMode(1, my_code);

			ActiveTab := code - 108;
			if my_code > 0 then
				result := GetMoviePage(my_code, SeasonNr, false, false, false, false);
		end
		//person tabs
		else if code in [200..209] then begin
			my_code := 0;
			try
				my_code := StrToInt(text);
			except
			end;
			PersonActiveTab := code - 199;
			SetMode(2, my_code);
			if my_code > 0 then
				result := GetPerson(my_code, false, false);
		end
		else begin

			sl:=TStringList.Create;
			all:='';
			
			
			// movies by studio
			if code = 12 then begin
				with sl do begin
					Clear;
					Add('select m.title as title, m.code as code, in_collection, rating, imdb_rating, path, width, height');
					Add('from movies m');
					Add('inner join movies_manuals mm on mm.movie=m.code and mm.reference=12');
					Add('inner join manuals mg on mg.code=mm.ref_code');
					Add('left outer join images i on i.movie=m.code and i.mode=1');
					Add(format('where mg.name=%s and m.in_collection=1', [TempText]));
					Add('AND m.item_type=' + IntToStr(MOVIENIZER_PROGRAM));
					Add('order by m.title, i.sort_order');
				end;
				RecordCount:=ExecuteSQL(sl.text);
				all := ProcessMovieReference(MOVIENIZER_PROGRAM, text, page);
			end;
			
			// movies by award
			if code = 302 then begin
				//detect award winners
				with sl do begin
					Clear;
					Add('select code, awards from movies');
					Add('where awards like ''%' + TempText + '%'' and in_collection=1');
					Add('AND item_type=' + IntToStr(MOVIENIZER_PROGRAM));
				end;
				RecordCount := ExecuteSQL(sl.text);
				TempList := TStringList.Create;
				header_img := '';
				i := 0;
				while i < RecordCount do begin
					s := LowerCase(GetStringField('awards'));
					s2 := '';
					j := Pos(LowerCase(TempText), s);
					if j > 0 then begin
						my_i := MyPos('<br><br>', s, j + 1);
						if my_i = 0 then
							my_i := MyPos('<br> <br>', s, j + 1);
						if my_i = 0 then
							my_i := Length(s);
						s2 := copy(s, j, my_i - j);
					end;
					if (Pos('won<br>', s2) > 0) or (Pos('', s2) > 0) or (Pos(' "' + LowerCase(TempText), s) > 0) then begin
						TempList.Add(IntToStr(GetIntegerField('code')));
					end;
					GetNextRecord;
					i := i + 1;
				end;
				//select award winners
				with sl do begin
					Clear;
					Add('select m.title as title, m.code as code, in_collection, rating, imdb_rating, path, width, height');
					Add('from movies m');
					Add('left outer join images i on i.movie=m.code and i.mode=1');
					Add(Format('where m.code in (%s)', [TempList.CommaText]));
					Add('order by m.title_sort, i.sort_order');
				end;
				TempList.LoadFromFile(PicturesPath + 'awards\awards.txt');
				for i := 0 to TempList.Count - 1 do
					if Pos(LowerCase(TempText), LowerCase(TempList[i])) = 1 then
						header_img := TempList.Values[TempList.Names[i]];
				TempList.Free;
				RecordCount:=ExecuteSQL(sl.text);
				if header_img <> '' then
					header_img := PicturesPath + 'awards/' + header_img;
				all := ProcessMovieReference(MOVIENIZER_PROGRAM, TempText, page, header_img);
			end;
			
			//filmography sorting
			if code in [231..236] then
      begin
        my_code := 0;
        i := Pos(';', text);
        s := copy(text, 1, i-1);
        try
          my_code := StrToInt(s);
        except
        end;
        delete(text, 1, i);
        s := text+'FilmSort';
				if code = 231 then
					RegWriteString(s, 'title asc');
				if code = 232 then
					RegWriteString(s, 'title desc');
				if code = 233 then
					RegWriteString(s, 'year asc');
				if code = 234 then
					RegWriteString(s, 'year desc');
				if code = 235 then
					RegWriteString(s, 'rating asc');
				if code = 236 then
					RegWriteString(s, 'rating desc');
				SetMode(2, my_code);
				all := GetPerson(my_code, false, false);
			end;
			
			//movies from the home page
			if (RegReadInteger('ShowLastUpdated', 0) = 1) then
				ShowLastUpdated := True
			else
				ShowLastUpdated := False;
			if ((code >= 1) and (code <= 5)) then begin
			    GenerateSQLForMoviesPages(sl, MOVIENIZER_PROGRAM, code);
				ExecuteSQL(sl.text);
				all := ProcessMovieReference(MOVIENIZER_PROGRAM, text, page);
			end;
			
			// people by award
			if code = 303 then begin
				header_img := '';
				//detect award winners
				with sl do begin
					Clear;
					Add('select code, awards from persons');
					Add('where awards like ''%' + TempText + '%'' and in_collection=1');
				end;
				RecordCount := ExecuteSQL(sl.text);
				TempList := TStringList.Create;
				i := 0;
				while i < RecordCount do begin
					s := LowerCase(GetStringField('awards'));
					s2 := '';
					temp := s;
					j := Pos(LowerCase(TempText), temp);
					while j > 0 do begin
						my_i := MyPos('<br><br>', temp, j + 1);
						if my_i = 0 then
							my_i := MyPos('<br> <br>', temp, j + 1);
						if my_i = 0 then
							my_i := Length(temp);
						s2 := copy(temp, j, my_i - j);
						if (Pos('won<br>', s2) > 0) or (Pos('', s2) > 0) then
							TempList.Add(IntToStr(GetIntegerField('code')));
						delete(temp, 1, j);
						j := Pos(LowerCase(TempText), temp);
					end;
					GetNextRecord;
					i := i + 1;
				end;
				//select award winners
				with sl do begin
					Clear;
					Add('select p.code as code, p.name, p.rating, p.birth_date, i.path, i.width, i.height, p.in_collection');
					Add('from persons p');
					Add('left outer join images i on i.person=p.code');
					Add(Format('where p.code in (%s)', [TempList.CommaText]));
					Add('order by p.name, i.sort_order');
				end;
				TempList.LoadFromFile(PicturesPath + 'awards\awards.txt');
				for i := 0 to TempList.Count - 1 do
					if Pos(LowerCase(TempText), LowerCase(TempList[i])) = 1 then
						header_img := TempList.Values[TempList.Names[i]];
				TempList.Free;
				if header_img <> '' then
					header_img := PicturesPath + 'awards/' + header_img;
				RecordCount:=ExecuteSQL(sl.text);
			end;
			
			//people from the homepage
			if (code in [6..9, 303, 210, 211]) then begin
				s2 := Text;
				if code <> 303 then begin
					header_img := '';
					with sl do begin
						Clear;

						Add('select p.code as code, p.name, p.rating, i.path, i.width, i.height, p.in_collection');
						Add('from persons p');
						Add('left outer join images i on i.person=p.code');
						case code of
							7: Add('where 1=1');
							8: Add('where p.date_update is not null');
							9: Add('where p.birth_date like ''%' + Format('%s', [GetTodaysDate]) + '%''');
							210: Add('where p.birthplace like ''%' + s2 + '%''');
							211: Add('where p.death_date<>''''');
							else
								if ShowLastUpdated then
									Add('where p.date_update is not null')
								else
									Add('where p.date_add is not null');
						end;
						Add('and p.in_collection=1');
						Add('AND p.item_type=' + IntToStr(MOVIENIZER_PROGRAM));
						case code of
							7: Add('order by p.rating desc, p.date_add desc, p.code, i.mode desc');
							8: Add('order by p.date_update desc, p.code, i.mode desc, i.sort_order');
							9: Add('order by p.date_add desc, p.code, i.sort_order');
							else
								if ShowLastUpdated then
									Add('order by p.date_update desc, p.code, i.mode desc, i.sort_order')
								else
									Add('order by p.date_add desc, p.code, i.mode desc, i.sort_order');
						end;
					end;
					RecordCount:=ExecuteSQL(sl.text);
				end;
				
				lines := RegReadInteger('LinesPeople', DefaultLinesPeople);
				page_width := GetHTMLWidth - WholePageBorder;
				CountedPages := 0;
				TotalItems := CountItemsForPages(page_width, page, RecordCount, 1, lines, HomePhotoHeight[MOVIENIZER_PROGRAM], HomePhotoWidth[MOVIENIZER_PROGRAM]);
				i := ProcessedRecords;
				movie := '';
				all := '';
				fl:=true;
				PageItems := 0;
				LastCode := 0;
				page_width_copy := page_width;
				PreviousCodes := TStringList.Create;
				while (i<=RecordCount) and fl do begin
					my_code:=GetIntegerField('code');
					if PreviousCodes.IndexOf(IntToStr(my_code)) < 0 then begin
						PreviousCodes.Add(IntToStr(my_code));
						LastCode:=my_code;
						PicHeight := GetIntegerField('i.height');
						if PicHeight > 0 then
							PicWidth := Round(GetIntegerField('i.width') * (HomePhotoHeight[MOVIENIZER_PROGRAM] / PicHeight)) + BigImageBorders
						else
							PicWidth := HomePhotoWidth[MOVIENIZER_PROGRAM] + BigImageBorders;
						page_width_copy := page_width_copy - PicWidth;
						if (page_width_copy < 0) then begin
							all := all + movie + '</tr></table><table class="white-bck-block"><tr>';
							movie := '';
							lines := lines - 1;
							page_width_copy := page_width - PicWidth;
						end;
						if (page<>0) and (lines <= 0) then
							fl:=false
						else begin	
						
							rating := GetIntegerField('p.rating');
							rate:=GetStarRatingWithoutLinks(rating);
							FileName := GetImageFileName(GetStringField('i.path'), ThumbsMoviePhotos,  NO_PHOTO_FILE[MOVIENIZER_PROGRAM], 0, HomePhotoHeight[MOVIENIZER_PROGRAM]);
							movie:=movie+'<td style="vertical-align: top; text-align: center;"><div style="width: 3px;"><div class="photo-outer"><div class="photo-inner">'+format('<a class="pic" href="person:%d"><img style="height: %dpx" src="%s"></a></div></div>', [my_code, HomePhotoHeight[MOVIENIZER_PROGRAM], Filename]);
							movie := movie + '<div class="image-text">';
							if rate<>'' then
								movie := movie + rate + '<br/>';
							movie:=movie + format('<a href="person:%d">%s</a></div></div></td>', [my_code, GetStringField('p.name')]);

							PageItems:=PageItems+1;
						end;
					end
					else begin
						GetNextRecord;
						i:=i+1;
					end;
				end;
				PreviousCodes.Free;
				TotalItems := TotalItems + PageItems;
				all := all+movie;
				if movie <> '' then
					all := all + format('<td style="width: %dpx;">&nbsp;</td>', [page_width_copy]);
				all:=all+'</tr></table>';

				kol := 0;
				lines := RegReadInteger('LinesPeople', DefaultLinesPeople);
				if (page > 0) and (i < RecordCount) then begin
					//set the maximum number of pages to 2000
					TotalItems := TotalItems + CountItemsForPages(page_width, 2000, RecordCount, i, lines, HomePhotoHeight[MOVIENIZER_PROGRAM], HomePhotoWidth[MOVIENIZER_PROGRAM]);
					kol := CountedPages;
				end;
				movie_top:=GetReferenceTop;
				s2 := Text;
				if code = 200 then
					s2 := GetLangStr(287) + ': ' + text;
				movie_top:= movie_top + '<p class="title">' + s2 + format(' (%d)', [TotalItems]);
				movie_top:=movie_top+'</p><div class="icons"></div>'+ClosePatternTop;
				movie_top:=movie_top+'<table class="white-bck-block"><tr>';
				
				all := movie_top + all;
				
				s:='userref:'+IntToStr(TempReferenceCode)+','+TempText;
				if (kol > 0) or (page > 1) then begin
					all:=all+Format('<center><div class="orange-line" style="margin-left: %d; margin-right: %d; height: 10;"></div><p>', [page_width div 3, page_width div 3]);
					if (kol>0) or (page > 1) then
						all:=all+format('<a href="%s,%d">%s</a>   ', [s, 0, GetLangStr(1330)]);
					if page>1 then
						all:=all+format('<a href="%s,%d">%s</a>   ', [s, page-1, GetLangStr(1328)]);
					for i:=1 to page do begin
						if page=i then
							all:=all+format(' <b class="search-active">%d</b> ', [i])
						else
							all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
					end;
					for i:=(page+1) to (page+kol) do
						all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);			
					if kol>0 then
						all:=all+format('   <a href="%s,%d">%s</a> ', [s, page+1, GetLangStr(1329)]);
					all:=all+'</p></center>';
				end;
			end;		
			
			sl.Free;
			result := all;
		end;
	finally
		ResetRegistrySubKey();
	end;
end;



begin

end.