program orange_program_part4;

uses 'orange_program_variables.pas', 'orange_program_global.pas';

function GetThumbnailAlbum(code, mode: integer; title, year: string; InCollection, rating: integer;
  AFullDescription: string = ''; ASearchDescription: string = ''): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img, seasons: string;
  fl, showCoversInList, FullList, ThisChecked, ShowCurrent, ShowDiscNr: boolean;
  i, j, kol, dir, amount, RecordCount, ThumbWidth: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
	BigOpen, BigClose, SmallOpen, SmallClose: string;
	kinopoisk_rating, imdb_rating, current_rating, current_site, disc_number: String;
	imdb_rating_number, kinopoisk_rating_number, current_rating_number: double;
begin
	result:='';
	sl:=TStringList.Create;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MUSICNIZER_PROGRAM]);
  try
	amount:=mode;
	s:='';
	ThumbWidth := RegReadInteger('ListCoverWidth', DefaultThumbWidth);
	ThumbsPath:=ImagesPath+Thumbs +'\';
	i := RegReadInteger('ShowCoversInList', 1);
	if i = 1 then
		showCoversInList := True
	else
		showCoversInList := False;
	i := RegReadInteger('MinimaList', 0);
	if i = 1 then
		FullList := False
	else
		FullList := True;
	if (RegReadInteger('ShowDiscNrInList', 0) = 1) then
		ShowDiscNr := True
	else
		ShowDiscNr := False;
    fl:=false;
    genres:='';
    directors:='';
    actors:='';
	ThisChecked := False;
	imdb_rating := '';
	kinopoisk_rating := '';
	current_rating := '';
	current_site := '';
	imdb_rating_number := 0;
	kinopoisk_rating_number := 0;
	current_rating_number := 0;
	disc_number := '';
	
	if RegReadInteger('ShowCurrentRatingInList', 1) = 1 then
		ShowCurrent := True
	else
		ShowCurrent := False;

    //    ,    
    if (InCollection=1) then begin
		if showCoversInList then begin
			//
			with sl do begin
				Clear;
				Add('select path from images');
				Add(format('where movie=%d and mode=1', [code]));
				Add('order by sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount>0 then begin
				FileIn:=ImagesPath+GetStringField('path');
				FileName:=ThumbsPath+GetStringField('path');

				if MyFileExists(FileIn) then begin
					if not MyFileExists(FileName) then begin
						ConvertThumb3(FileIn, FileName, Thumbs, ThumbWidth, 0, false);
					end;
					if not MyFileExists(FileName) then 
						FileName:=FileIn;
				end
				else
					FileName:=FileIn;
				if MyFileExists(FileName) then
					fl:=true;
			end;
			if not fl then begin
				FileName:=ImgPath + NO_COVER_FILE[MUSICNIZER_PROGRAM];
				fl:=true;
			end;
		end;
		
		if ShowCurrent then begin
			current_site := RegReadString('MovieScript', '');
			i := Pos(' (', current_site);
			if i>0 then
				delete(current_site, i, length(current_site)-i+1);
			if (current_site <> '') and (current_site <> 'kinopoisk') and (current_site <> 'imdb') then begin
				with sl do begin
					Clear;
					Add('select rating from movies_codes');
					Add(format('where movie=%d and script=''%s''', [code, current_site]));
				end;
				RecordCount := ExecuteSQL(sl.text);
				if RecordCount > 0 then begin
					current_rating_number := GetFloatField('rating');
					if current_rating_number > 0 then
						current_rating := '<NOBR>' + current_site + ': ' + FloatToStr(current_rating_number) + '</NOBR>; ';
				end;
			end;
		end;
		
		if (RegReadInteger('ShowIMDBRatingInList', 0) = 1) or ((current_site = 'imdb') and ShowCurrent) then begin
			with sl do begin
				Clear;
				Add('select imdb_rating from movies');
				Add(format('where code=%d', [code]));
			end;
			RecordCount:=ExecuteSQL(sl.text);
			if RecordCount > 0 then begin
				imdb_rating_number := GetFloatField('imdb_rating');
				if (imdb_rating_number > 0) then
					imdb_rating := Format('<NOBR><img align="absmiddle" src="%simdb-ico.png"> ', [PicturesPath]) + FloatToStr(imdb_rating_number) + '</NOBR>; ';
			end;
		end;
		
		if (RegReadInteger('ShowKinopoiskRatingInList', 0) = 1) or ((current_site = 'kinopoisk') and ShowCurrent) then begin
			with sl do begin
				Clear;
				Add('select rating from movies_codes');
				Add(format('where movie=%d and script=''kinopoisk''', [code]));
			end;
			RecordCount := ExecuteSQL(sl.text);
			if RecordCount > 0 then begin
				kinopoisk_rating_number := GetFloatField('rating');
				if (kinopoisk_rating_number > 0) then
					kinopoisk_rating := Format('<NOBR><img align="absmiddle" src="%skinopoisk-ico.png"> ', [PicturesPath]) + Format('%.1f', [kinopoisk_rating_number]) + '</NOBR>; ';
			end;
		end;
		
		//disc number (only first edition)
		if ShowDiscNr then begin
			with sl do begin
				Clear;
				Add('select disc_nom from editions');
				Add(format('where movie=%d', [code]));
				Add('order by sort_order');
			end;
			RecordCount := ExecuteSQL(sl.text);
			if RecordCount > 0 then begin
				s := GetStringField('disc_nom');
				if (s <> '') and (s <> '0') then
					disc_number := Format('<NOBR>%s: %s</NOBR>', [GetLangStr(391), s]);
			end;
		end;

     	if amount>0 then begin 
			//
			with sl do begin
				Clear;
				Add('select m.code, m.name from movies_manuals mm');
				Add('join manuals m on m.code=mm.ref_code');
				Add(format('where mm.movie=%d and m.reference=8', [code]));
			end;
			RecordCount:=ExecuteSQL(sl.text);
			for j:=1 to RecordCount do begin
				genres:=genres+format('<a href="genre:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
				GetNextRecord;
			end;
			if genres<>'' then
				genres:=copy(genres, 1, length(genres)-2);

			//  
			with sl do begin
				Clear;
				Add('select distinct p.code, p.name, p.in_collection, d.mode from data d');
				Add('inner join persons p on p.code=d.person');
				Add(format('where d.movie=%d and d.mode in (1,3)', [code]));
				//Add('and d.sort_order<10');//27.07.07
				Add('order by d.mode, d.sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			i:=0;
			j:=0;
			dir:=0;
			while (i<RecordCount) and (j<amount) do begin
				if GetIntegerField('p.in_collection')=1 then
					img:=format('<img src="%sperson.gif" align="absmiddle" border="0" style="margin-right: 2px;">', [ImgPath])
				else
					img:='';
				if GetIntegerField('d.mode')=1 then begin
					if dir<=3 then begin
						directors:=directors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), GetStringField('p.name')]);
						dir:=dir+1;
					end;
				end
				else begin
					actors:=actors+img+format('<a href="person:%d">%s</a>, ', [GetIntegerField('p.code'), GetStringField('p.name'), j]);
					j:=j+1;
				end;
				i:=i+1;
				GetNextRecord;
			end;
		end;
		if directors<>'' then
			directors:=copy(directors, 1, length(directors)-2);

		if actors<>'' then
			actors:=copy(actors, 1, length(actors)-2);
    // Fade 16.08.2011 - For Search Thumbs do not add CheckBox picture
		if ((mode <> 7) and (GroupOperation) and (mode <> 5)) then begin
			if IsMovieChecked(code) then
				CheckMode:=format('<a href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
			else
				CheckMode:=format('<a href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
			if showCoversInList then
				CheckMode := '<div id="group_overlay_image">' + CheckMode + '</div>';
		end
		else
			CheckMode:='';
      
		if year<>'' then
			year:=format(' (%s)', [year]);

		if rating>0 then
			rate:=format(' <NOBR><img src="%sfull-star.gif" width="16" height="15" border="0" align="absmiddle">%d</NOBR>', [ImgPath, rating])
		else
			rate:='';
			
		if showCoversInList then begin
			s:='<div class="photo-outer" style="float: left; line-height: 0px;"><div class="photo-inner">' + CheckMode + '<a class="pic" ' + format('href="movie:%d"><img border="0" style="width: %dpx;" src="%s"', [code, ThumbWidth, FileName]);
			if not GetCutePreview and (mode<>7) then
				s:=s+' width="50" align="left"';
			s:=s+'></a></div></div>';
		end
		else 
			s := s + CheckMode;
		s := s+format('<a href="movie:%d"><b>%s</b></a>%s%s<br>', [code, title, year, rate]);
		
		//site ratings
		if FullList and ((imdb_rating <> '') or (kinopoisk_rating <> '') or (current_rating <> '')) then begin
			s := s + current_rating + imdb_rating + kinopoisk_rating;
			s := copy(s, 1, length(s)-2) + '<br>';
		end;
		
		//disc number
		if (disc_number <> '') then
			s := s + disc_number + '<br>';
		
		//Genres
		if (genres<>'') and FullList then begin
			if mode<>1 then
				genres:=GetLangStr(179)+': '+genres;
			s:=s+genres+'<br>';
		end;
		//Directors
		if FullList and (mode<>1) and (directors<>'') then
			s:=s+GetLangStr(10000)+': '+directors+'<br>';
		//Actors
		if FullList and (actors<>'') then begin
			if mode<>1 then
				actors:=GetLangStr(164)+': '+actors;
			s:=s+actors+'<br>';
		end;
		s := s+SmallClose;
    end
    else begin
		if year<>'' then
			year:=format(' (%s)', [year]);
		s:=format('<a href="movie:%d"><b>%s</b>%s</a>', [code, title, year]);
    end;

	//seasons
	seasons:='';
	
	s := s + '<i>' + GenerateHTMLForDescriptionSearching(AFullDescription, ASearchDescription) + '</i>';
	
	//s := s+'</div>';
	if mode=7 then
		s:='<tr><td class="text-box">'+s+'</td></tr>';
	result:=s;
    sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;

//show movies by selected user reference
//links like <a href='userref:Code,Text'>link</a>
//links like <a href='userref:Code,Text,Page'>link</a>
function GetUserReferenceForAlbum(code: integer; text: string; Page: Integer = 1): string;
var
  sl, TempList: TStringList;
  i, j, k, kol, RecordCount, rating, page_width, LastCode, my_i, my_code, movie_code: integer;
  s, s2, description, year, director, writer, actor, bio, character, movie, movie_top: string;
  all, FileName, img, rate, DurationStr, TrackNumberStr: string;
  IMDBRating: double;
  StartItem, EndItem, MoviesPage, ii, TotalItems, lines, SeasonNr, PageItems: integer;
  fl, ShowLastUpdated, loan_page: boolean;
  dd, mm, yy, loan_code, page_width_copy, PicWidth, PicHeight, seconds, hours, minutes: integer;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MUSICNIZER_PROGRAM]);
  try
    ProgramReference:='';
    TempReferenceCode:=code;
    code := GetOldReferenceCodeForNewCode(code);
    TempReference:=666;
    TempText:=text;
    if code=100 then
      result := GetPatternTop + Format('<p class="page-header" style="font-size: %dpt;">', [BasicFontSize + PageHeaderModifier]) + format('%s</p>', [GetLangStr(1333)]) + ClosePatternTop + Format('<p class="header" style="font-size: %dpt;">', [BasicFontSize + SubHeaderModifier]) + ShowScriptOptions
    //Movie tabs
    else if code in [109..119]	then begin
      my_code := 0;
      SeasonNr := 0;
      i := Pos(';', text);
      if i>0 then begin
        s := copy(text, i+1, length(text) - i);
        delete(text, i, length(text) - i + 1);
        try
          SeasonNr := StrToInt(s);
        except
        end;
      end;
      try
        my_code := StrToInt(text);
      except
      end;

      //18.11.10
      SetMode(1, my_code);

      ActiveTab := code - 108;
      if my_code > 0 then
        result := GetAlbumPage(my_code, SeasonNr, false, false, false, false);
    end
    //person tabs
    else if code in [200..210] then begin
      my_code := 0;
      try
        my_code := StrToInt(text);
      except
      end;
      PersonActiveTab := code - 199;
      SetMode(2, my_code);
      if my_code > 0 then
        result := GetPerson(my_code, false, false);
    end
    else begin

      sl:=TStringList.Create;
      all:='';



      // movies by studio
      if code = 12 then begin
        with sl do begin
          Clear;
          Add('select m.title, m.code as code, m.in_collection, m.rating, m.imdb_rating, i.path as path, i.width, i.height');
          Add('from movies m');
          Add('inner join movies_manuals mm on mm.movie=m.code and mm.reference=12');
          Add('inner join manuals mg on mg.code=mm.ref_code');
          Add('left outer join images i on i.movie=m.code and i.mode=1');
          Add(format('where mg.name=%s and m.in_collection=1', [TempText]));
          Add('AND m.item_type=' + IntToStr(MUSICNIZER_PROGRAM));
          Add('order by m.title, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        all := ProcessMovieReference(MUSICNIZER_PROGRAM, text, page);
      end;

      //albums by edition type
      if code = 304 then begin
        with sl do begin
          Clear;
          Add('select m.title, m.code as code, m.in_collection, m.rating, m.imdb_rating, i.path as path, i.width, i.height');
          Add('from movies m');
          Add('join editions e on e.movie=m.code');
          Add('join manuals mg on mg.code=e.edition');
          Add('left outer join images i on i.movie=m.code and i.mode=1');
          Add(format('where mg.name=''%s'' and mg.reference=21 and m.in_collection=1', [TempText]));
          Add('AND m.item_type=' + IntToStr(MUSICNIZER_PROGRAM));
          Add('order by m.title, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        all := ProcessMovieReference(MUSICNIZER_PROGRAM, text, page);
      end;
      //albums by disc release year
      if code = 305 then
      begin
        with sl do begin
          Clear;
          Add('select m.title, m.code as code, m.in_collection, m.rating, m.imdb_rating, i.path as path, i.width, i.height');
          Add('from movies m');
          Add('join editions e on e.movie=m.code');
          Add('left outer join images i on i.movie=m.code and i.mode=1');
          Add(format('where e.year=''%s'' and m.in_collection=1', [TempText]));
          Add('AND m.item_type=' + IntToStr(MUSICNIZER_PROGRAM));
          Add('order by m.title, i.sort_order');
        end;
        RecordCount:=ExecuteSQL(sl.text);
        all := ProcessMovieReference(MUSICNIZER_PROGRAM, GetLangStr(10517) + ': ' + text, page);
      end;

      //set track rating
      if code = 160 then begin
        my_code := 0;
        movie_code := 0;
        i := Pos(';', text);
        j := MyPos(';', text, i+1);
        s := copy(text, i+1, j-i-1);
        s2 := copy(text, j+1, length(text)-j);
        delete(text, i, length(text)-i+1);
        try
          i := StrToInt(s);
          my_code := StrToInt(s2);
          movie_code := StrToInt(text);
        except
        end;
        if my_code <> 0 then begin
          with sl do begin
            Clear;
            Add(Format('update tracks set rating=%d', [i]));
            Add(Format('where code=%d', [my_code]));
          end;
          RecordCount:=ExecuteSQL(sl.text);
        end;
        SetMode(1, movie_code);
        all := GetAlbumPage(movie_code, 0, false, false, false, false);
      end;

      //all tracks by rating
      if code = 161 then begin
        with sl do begin
          Clear;
          Add('select * from tracks');
          Add('WHERE item_type=' + IntToStr(MUSICNIZER_PROGRAM));
          Add('order by rating desc, artist, movie');
        end;
        RecordCount := ExecuteSQL(sl.text);
        if RecordCount > 0 then begin
          all := Format('<table style="font-size: %dpt; line-height: %dpx; margin: 0 20 20 20;"><tr><td colspan="5">', [BasicFontSize + BiggerModifier, LineSpace]);
          all := all + Format('<p class="header" style="font-size: %dpt; line-height: %dpx; margin-bottom: 10px;">', [BasicFontSize+PageHeaderModifier, LineSpace]) + GetLangStr(10337) + ' ' + GetLangStr(3423) + '</p></td></tr>';
          PageItems := RecordCount div TracksPerPage;
          my_i := (page-1) * TracksPerPage;
          if page > 1 then begin
            for i := 1 to my_i do
              GetNextRecord;
          end;
          if RecordCount > (page * TracksPerPage) then
            RecordCount := page * TracksPerPage;
            for i:=my_i+1 to RecordCount do begin
              TrackNumberStr := '';
              DurationStr := '';
              //track rating
              k := GetIntegerField('code');
              kol := GetIntegerField('movie');
              rating := GetIntegerField('rating');
              rate:='';
              if (RegReadInteger('ShowRating', 1) = 1) then begin
                for j:=1 to 5 do begin
                    if j<=rating then
                      rate:=rate+format('<a href="userref:1160,%d;%d;%d"><img src="%sstar-transp.gif" border="0"></a>',  [kol, j, k, ImgPath])
                    else
                      rate:=rate+format('<a href="userref:1160,%d;%d;%d"><img src="%snot-star-transp.gif" border="0"></a>',  [kol, j, k, ImgPath]);
                end;
              end;
              if (GetIntegerField('duration') > 0) then begin
                Seconds := (GetIntegerField('duration') mod 60);
                Hours := GetIntegerField('duration') div 60 div 60;
                Minutes := (GetIntegerField('duration') - Hours * 60 * 60) div 60;
                if (Hours > 0) then
                  DurationStr := Format('%d:%0.2d:%.2d', [Hours, Minutes, Seconds])
                else
                  DurationStr := Format('%.2d:%.2d', [Minutes, Seconds]);
              end;
              //if (GetIntegerField('track_number') > 0) then
              TrackNumberStr := IntToStr(i);
              //create a line containing information about the track
              all := all + Format('<tr><td style="text-align: right; width: 20px;">%s', [TrackNumberStr]);
              //don't put points if there are not track numbers
              if TrackNumberStr<>'' then
                all := all + '.';
              all := all + '</td><td>';
              s := GetStringField('title');
              if s = '' then begin
                s :=GetStringField('filename');
                k := Pos('\', s);
                while k>0 do begin
                  delete(s, 1, k);
                  k := Pos('\', s);
                end;
                k := length(s);
                // 28.02.2012 Fade: AV for empty string
                // while (s[k] <> '.') and (k > 0) do
                while (k > 0) and (s[k] <> '.') do
                  k := k - 1;
                if (K > 0) and (s[k] = '.') then
                  delete(s, k, length(s) - k + 1);
              end;
              if (GetStringField('filename') <> '') and (RegReadInteger('ShowPlayBtn4Tracks', 0) = 0) then
                all := all + Format('<b><a href="playByCode:%s">%s</a></b>', [GetStringField('Code'), s])
              else
                all := all + Format('<b>%s</b>', [s]);

              //add artist
              if (GetStringField('artist') <> '') then begin
                all := all + ' (' + GetStringField('artist') + ')';
              end;

              //close
              all := all + ' </td>';

              //add duration
              all := all + Format('<td style="width: 20px; padding: 0 10px">%s</td>', [DurationStr]);

              //track rating 2
              if rate <> '' then
                all := all + '<td>' + rate + '</td>';

                //all := all + Format('<td>%s</td>', [rate]);
              (*s := '';
              if (GetIntegerField('rating') > 0) then begin
                s := Format('<img src="%sstar.gif"/>%d', [ImgPath, GetIntegerField('rating')]);
              end;
              all := all + Format('<td style="width: 60px;">%s</td>', [s]);*)

              //link to audio file
              all := all + '<td>';
              if RegReadInteger('ShowPlayBtn4Tracks', 0) = 1 then begin
                s := GetStringField('filename');
                if s<>'' then
                  all:=all+format('<a href="playByCode:%s">', [GetStringField('Code')])+format('<img src="%splay.png" align="absmiddle" border="0" alt="%s"></a>', [ImgPath, s]);
              end;
              all := all + '</td></tr>';
              GetNextRecord;
            end;
            all := all + '</table>';
            page_width:=GetHTMLWidth - WholePageBorder;
            all:=all+ Format('<center><hr><p>', [page_width div 3, page_width div 3]);
            s := 'userref:1161,1';
            if page>1 then
              all:=all+format('<a href="%s,%d">%s</a>   ', [s, page-1, GetLangStr(1328)]);
            for i:=1 to page do begin
              if page=i then
                all:=all+format(' <b class="search-active">%d</b> ', [i])
              else
                all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
            end;
            for i:=(page+1) to (PageItems+1) do
              all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
            if page <= PageItems then
              all:=all+format('   <a href="%s,%d">%s</a> ', [s, page+1, GetLangStr(1329)]);
            all:=all+'</p></center>';
            //all := all + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
        end;
      end;

      //filmography sorting
      if code in [231..234] then
      begin
        my_code := 0;
        i := Pos(';', text);
        s := copy(text, 1, i-1);
        try
          my_code := StrToInt(s);
        except
        end;
        delete(text, 1, i);
        s := text+'FilmSort';
        if code = 231 then
          RegWriteString(s, 'title asc');
        if code = 232 then
          RegWriteString(s, 'title desc');
        if code = 233 then
          RegWriteString(s, 'year asc');
        if code = 234 then
          RegWriteString(s, 'year desc');
        SetMode(2, my_code);
        all := GetPerson(my_code, false, false);
      end;

      //movies from the home page
      if (RegReadInteger('ShowLastUpdated', 0) = 1) then
        ShowLastUpdated := True
      else
        ShowLastUpdated := False;
      if ((code >= 1) and (code <= 5)) then
      begin
        GenerateSQLForMoviesPages(sl, MUSICNIZER_PROGRAM, code);
        ExecuteSQL(sl.text);
        all := ProcessMovieReference(MUSICNIZER_PROGRAM, text, page);
      end;

      //people from the homepage
      if (code >= 6) and (code <= 9) then
      begin

        GenerateSQLForPersonPages(sl, code - 5);
        RecordCount:=ExecuteSQL(sl.text);
        lines := RegReadInteger('BreezeLinesPeople', DefaultLinesPeople);
        page_width := GetHTMLWidth - WholePageBorder;
        CountedPages := 0;
        TotalItems := CountItemsForPages(page_width, page, RecordCount, 1, lines,
          HomePhotoHeight[MUSICNIZER_PROGRAM], HomePhotoWidth[MUSICNIZER_PROGRAM]);
        i := ProcessedRecords;
        movie := '';
        all := '';
        fl:=true;
        PageItems := 0;
        LastCode := 0;
        page_width_copy := page_width;
        while (i<=RecordCount) and fl do begin
          my_code:=GetIntegerField('code');
          if LastCode<>my_code then begin
            LastCode:=my_code;
            PicHeight := GetIntegerField('height');
            PicWidth := HomePhotoWidth[MUSICNIZER_PROGRAM] + NormalImageBorders;
            page_width_copy := page_width_copy - PicWidth;
            if (page_width_copy < 0) then begin
              all := all + movie + '<td></td></tr></table><table class="whole-page-images"><tr>';
              movie := '';
              lines := lines - 1;
              page_width_copy := page_width - PicWidth;
            end;
            if (page<>0) and (lines <= 0) then
            begin
              Dec(I);
              fl:=false;
            end
            else begin

              rating := GetIntegerField('p.rating');
              rate:=GetStarRatingWithoutLinks(rating);
              FileName := GetImageFileName(GetStringField('path'), ThumbsHomePhotos, NO_PHOTO_FILE[MUSICNIZER_PROGRAM], HomePhotoWidth[MUSICNIZER_PROGRAM], HomePhotoHeight[MUSICNIZER_PROGRAM], True);
              movie:=movie+'<td style="background-color: white; border: 1px solid ' + WhiteAreaBorderColor + '; width: 100px; padding: 5px;"><a class="pic"'+format(' href="person:%d"><img style="height: %dpx" border="0" src="%s"></a>', [my_code, HomePhotoHeight[MUSICNIZER_PROGRAM], FileName]);
              //movie := movie + '<div class="image-text">';
              movie:=movie + format('<div style="margin: 5 0;"><a href="person:%d">%s</a>', [my_code, GetStringField('p.name')]);
              if (code = 9) then begin
                DecodeDate(Date, kol, ii, my_i);
                movie := movie + ' (' + IntToStr(YearsBetween(GetStringField('p.birth_date'), IntToStr(kol))) + ')';
              end;
              movie := movie + '</div>';
              if rate<>'' then
                movie := movie + '<div style="vertical-align: bottom;">' + rate + '</div>';
              movie := movie + '</td>';

              PageItems:=PageItems+1;
            end;
          end
          else begin
            GetNextRecord;
            i:=i+1;
          end;
        end;
        TotalItems := TotalItems + PageItems;
        all := all+movie;
        if movie <> '' then
          //all := all + format('<td style="width: %dpx;"></td>', [page_width_copy  - BigImageBorders]);
          all := all + '<td></td>';
        all:=all+'</tr></table>';

        kol := 0;
        lines := RegReadInteger('BreezeLinesPeople', DefaultLinesPeople);
        if (page > 0) and (i < RecordCount) then begin
          //set the maximum number of pages to 2000
          TotalItems := TotalItems + CountItemsForPages(page_width, 2000, RecordCount,
            i, lines, HomePhotoHeight[MUSICNIZER_PROGRAM], HomePhotoWidth[MUSICNIZER_PROGRAM]);
          kol := CountedPages;
        end;
        movie_top:=GetReferenceTop;
        movie_top:= movie_top + Format('<p class="page-header" style="font-size: %dpt;">', [BasicFontSize + PageHeaderModifier]) + text + format(' (%d)', [TotalItems]);
        movie_top:=movie_top+'</p>'+ClosePatternTop;
        movie_top:=movie_top+'<table class="whole-page-images"><tr>';

        all := movie_top + all;

        s:='userref:'+IntToStr(TempReferenceCode)+','+TempText;
        if (kol > 0) or (page > 1) then begin
          all:=all+Format('<center><hr><p><big>', [page_width div 3, page_width div 3]);
          if (kol>0) or (page > 1) then
            all:=all+format('<a href="%s,%d">%s</a>   ', [s, 0, GetLangStr(1330)]);
          if page>1 then
            all:=all+format('<a href="%s,%d">%s</a>   ', [s, page-1, GetLangStr(1328)]);
          for i:=1 to page do begin
            if page=i then
              all:=all+format(' <b>%d</b> ', [i])
            else
              all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
          end;
          for i:=(page+1) to (page+kol) do
            all:=all+format(' <a href="%s,%d">%d</a> ', [s, i, i]);
          if kol>0 then
            all:=all+format('   <a href="%s,%d">%s</a> ', [s, page+1, GetLangStr(1329)]);
          all:=all+'</big></p></center>';
        end;
      end;

      sl.Free;
      result := all;
    end;

  finally
    ResetRegistrySubKey();
  end;

end;

function GetThumbnailAlbumExtended(code, mode: integer; title: string): string;
var
  sl: TStringList;
  s, rate, FileName, genres, directors, actors, img, seasons: string;
  fl, CutThumb: boolean;
  i, j, kol, dir, amount, RecordCount, CoverWidth, CoverHeight: integer;
	ThumbsPath, FileIn, FileOut, CheckMode: string;
	ProgramType: Integer;
begin
  ProgramType := MUSICNIZER_PROGRAM;
  SetRegistrySubKey(REGISTRY_SUB_KEYS[ProgramType]);
  try
	  result:='';
	  sl:=TStringList.Create;
	  amount:=mode;
	  s:='';

	  ThumbsPath:=ImagesPath+Thumbs2+'\';

	  fl:=false;
	  genres:='';
	  directors:='';
	  actors:='';


		//
		with sl do begin
		  Clear;
		  Add('select * from images');
		  Add(format('where movie=%d and mode=1', [code]));
		  Add('order by sort_order');      
		end;
		RecordCount:=ExecuteSQL(sl.text);

		  CoverWidth := RegReadInteger('ThCoverWidth', DefaultMultiCoverWidth[ProgramType]);
		  CoverHeight := RegReadInteger('ThCoverHeight', DefaultMultiCoverHeight[ProgramType]);
	  
		  if (CoverWidth <= 0) and (CoverHeight <= 0) then begin
			  CoverWidth := DefaultMultiCoverWidth[ProgramType];
			  CoverHeight := DefaultMultiCoverHeight[ProgramType];
		  end;

		if RecordCount>0 then
		begin
			  i := RegReadInteger('CutThumb', 1);
			  if i = 1 then
					CutThumb := True
			  else
					CutThumb := False;
		  FileIn:=ImagesPath+GetStringField('path');
		  FileName:=ThumbsPath+GetStringField('path');
		  if MyFileExists(FileName) then
			fl:=true
		  else if MyFileExists(FileIn) then
			ConvertThumb3(FileIn, FileName, Thumbs2, CoverWidth, CoverHeight, CutThumb);
		  if MyFileExists(FileName) then
			fl:=true;
		end;
		if not fl then
		begin
		  FileIn:=ImgPath+NO_COVER_FILE[MUSICNIZER_PROGRAM];
		  FileName:=ThumbsPath+NO_COVER_FILE[MUSICNIZER_PROGRAM];
		  //ShowMessage('FileName='+FileName);
		  //ShowMessage('FileIn='+FileIn);
		  if ((not MyFileExists(FileName)) and
			  (MyFileExists(FileIn))) then
		  begin
			ConvertThumb3(FileIn, FileName, Thumbs2, CoverWidth, CoverHeight, CutThumb);
		  end;
		  fl:=true;
		end;

		if GroupOperation then
		begin
		  if IsMovieChecked(code) then
			CheckMode:=format('<a class="pic" href="group_check_off:%d"><img src="%scheck.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath])
		  else
			CheckMode:=format('<a class="pic" href="group_check_on:%d"><img src="%scheckout.gif" align="absmiddle" border="0"></a>',  [code, PicturesPath]);
		  CheckMode := '<div id="group_overlay_image_multi">' + CheckMode + '</div>';
		end
		else
		  CheckMode:='';

		s:='<div class="img-outer" style="float: left;"><div class="img-inner">'+CheckMode+'<a class="pic" href="movie:' + format('%d"><img src="%s" border="0"></a></div></div>', [code, FileName])+'<div style="clear:both"></div><div class="cover-flow-text">'+format('<a href="movie:%d">%s</a></div>', [code, title]);


		if mode=7 then
		  s:='<tr><td>'+s+'</td></tr>';

		if amount=3 then
			s:='<div class="preview">'+s+'</div>';
	  result:=s;
	  sl.Free;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetAlbumTabs(MovieCode, SeasonNr, SeasonCnt: Integer; Awards, Shots, Params, Posters, Trailers, Desc, Connections: Boolean; AdditionalSpace: Integer = 0): String;
var
	s, media_format, prev_media_format, prefix: String;
	i, k, my_tabs, PageWidth, SeasonTabs, PageTabs, RecordCount: Integer;
	sl: TStringList;
begin
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MUSICNIZER_PROGRAM]);
  try
	PageWidth := GetHTMLWidth - TabBorders - AdditionalSpace;
	SeasonTabs := PageWidth div SeasonTabWidth;
	PageTabs := PageWidth div TabWidth;
	s := '';
	if (ActiveTab in [2, 6, 7]) then
		s := '<div class="left-block-holder">&nbsp;</div>';
	s := s + '<table class="tabs"><tr><td>';
	
	//general info tab
	s := s + GetTab(ActiveTab = 1, -100, GetLangStr(161), Format('userref:%d,%d', [1109, MovieCode]));
	PageTabs := PageTabs - 1;
	//i is assigned so that it should contain 1 if the previous tab is active
	i := ActiveTab;

	//screenshots	
	if (Shots) and (PageTabs > 0) and (RegReadInteger('ShowShotTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 2, i, GetLangStr(199), Format('userref:%d,%d', [1110, MovieCode]));
		i := ActiveTab - 1;
	end;

	//parameters
	if (Params) and (PageTabs > 0) and (RegReadInteger('ShowParameterTab', 1) = 1) then begin
		PageTabs := PageTabs - 1;
		s := s + GetTab(ActiveTab = 5, i, GetLangStr(10501), Format('userref:%d,%d', [1113, MovieCode]));
		i := ActiveTab - 4;
	end;

	
	if i = 1 then
		prefix := ''
	else
		prefix := 'in';
	s := s + '<div class="tab-end" style="background-image: url('+ GetProperPath(Format('%s%sactive-tab-end.gif', [ImgPath, prefix])) + ');"></div>';
	s := s + '<div class="orange-line"></div></td></tr></table>';
	Result := s;
  finally
    ResetRegistrySubKey();
  end;
end;

function GetAlbumPage(MovieCode, season: integer; FullDesc, FullComments, FullPersons, FullAwards: boolean): string;
var
  sl, TempList, SeenList, UnseenList, SeasonCovers: TStringList;
  duration, i, j, k, l, kol, rmax, RecordCount: integer;
  all, s, s2, s3, country, description, comment, genre, year, director, writer, composer, actor, character, down, salary, awards, studios: string;
  rating: integer;
  IMDBRating, SiteRating, EditionCost: double;
  FileName, img, OriginalTitle, site, url, postfix, ShortFilename: string;
  flCollection, flSeen, flWanted, flForSale, LastCode: integer;
  collection, seen, wanted, sale, rate, mpaa, mpaa_desc, disc_nom, seasons: string;
  VideoStandard, ScreenRatio, resolution, mpaa_code, VideoBitrate, VideoCodec, filesize: integer;
  DiscLabel: integer;
  custom: array[1..6] of integer;
  cust: string;
  DateAdd, DateUpdate, DateSeen, loan_date, return_date: string;
  age, border, bckgrnd: string;                                              
  editions: array [1..1000] of integer;
  EditionsCount, EditionCode, MediaFormat, ie: integer;
  ed, temp, barcode, OtherRating, EditionFeatures, EditionComment, VideoFileFolder, VideoFileName, TagLine: string;
  PrevBlockCnt, ThisBlockCnt, ShotCnt, MaxShots, hours, minutes, Seconds, SeasonCnt, PosterCnt, ConnectionsCnt: Integer;
  page_width, PicWidth, PicHeight, TrailerCnt, AdditionalSpace, ScreenshotTotalHeight, page_width_rest, page_width_copy, MediaType, PrevPicWidth, this_width, this_height, this_season, MovieSeries, MovieSeriesNumber: Integer;
  NoTrailerAdded, ShowScreenshots, fl, FixedContentsWidth, ShowUserRating: Boolean;
  trunc_name, trunc_character, media_format, prev_media_format: String;
  TrackNumberStr, DurationStr, ArtistName, EditionName, EditionYear: String;

  // movies liks variables
  HasLyrics: Boolean;
  OldLinkStatus: Integer;
  LinkYearStr: string;
  LinkMovieStr: string;
  LinkMovieStatusTitle: string;
  temp_name, new_name, name, FullAwardsText, status, ends_with: string;
begin
	result:='';
  SetRegistrySubKey(REGISTRY_SUB_KEYS[MUSICNIZER_PROGRAM]);
  try
	sl:=TStringList.Create;
	all:='';
	OtherRating := '';
	
	if (RegReadInteger('FixedContentsWidthOnMoviePage', 0) = 1) then
		FixedContentsWidth := True
	else
		FixedContentsWidth := False;

	bckgrnd := Format(' style="background-color: %s;" ', [CellColor]);
	with sl do begin
		Clear;
		Add('select code from images');
		Add(format('where movie=%d and mode in (3, 7)', [MovieCode]));
		Add('order by sort_order');    
	end;
	ShotCnt:=ExecuteSQL(sl.text);
  
      
    with sl do begin
        Clear;
        Add('select * from movies');
        Add(format('where code=%d', [MovieCode]));
    end;
    RecordCount:=ExecuteSQL(sl.text);
    if RecordCount=0 then
        exit;
    s:='movie:'+IntToStr(MovieCode);
    movie:=GetStringField('title');

    OriginalTitle:=GetStringField('original_title');
    rating:=GetIntegerField('rating');
    IMDBRating:=GetFloatField('imdb_rating');

	flCollection:=GetIntegerField('in_collection');
	flSeen:=GetIntegerField('seen');
	flWanted:=GetIntegerField('wanted');
	flForSale:=GetIntegerField('for_sale');
	mpaa_code:=GetIntegerField('mpaa');
	mpaa_desc:=GetStringField('mpaa_rating');
	MediaType := GetIntegerField('media_type');

	DateAdd:=GetStringField('date_add');
	DateUpdate:=GetStringField('date_update');
	DateSeen:=GetStringField('date_seen');
	TagLine := GetStringField('tagline');
	MovieSeriesNumber := GetIntegerField('series_nom');
	MovieSeries := GetIntegerField('series');
	
	if (ConnectionsCnt <= 0) and (MovieSeries > 0) then
		ConnectionsCnt := 1;

    //GoForward(s, GetStringField('m.title'), ChangeHistory);

    description:=GetStringField('description');
    salary:=GetStringField('salary');
    awards:=GetStringField('awards');
	comment:=GetStringField('comment');
	
	FullAwardsText := awards;

	custom[1]:=GetIntegerField('custom1');
	custom[2]:=GetIntegerField('custom2');
	custom[3]:=GetIntegerField('custom3');
	custom[4]:=GetIntegerField('custom4');

    if GetStringField('duration')='' then
        duration:=0
    else
        duration:=GetIntegerField('duration');
    year:=GetStringField('year');

    disc_nom:=GetStringField('disc_nom');
      
    if flCollection=0 then
	    collection:=format('<a class="pic" href="collection:%d"><img src="%snot-in-collection.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(326)])
    else
	    collection:=format('<a class="pic" href="collection:%d"><img src="%sin-collection.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(325)]);


    if flSeen=0 then
	    seen:=format('<a class="pic" href="seen:%d"><img src="%snot-seen.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(328)])
    else
	    seen:=format('<a class="pic" href="seen:%d"><img src="%sseen.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(327)]);

    if flWanted=0 then
	    wanted:=format('<a class="pic" href="wanted:%d"><img src="%snot-wanted.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(330)])
    else
	    wanted:=format('<a class="pic" href="wanted:%d"><img src="%swanted.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(329)]);

    if flForSale=0 then
	    sale:=format('<a class="pic" href="sale:%d"><img src="%snot-for-sale.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(332)])
    else
	    sale:=format('<a class="pic" href="sale:%d"><img src="%sfor-sale.gif" alt="%s" border="0"></a>',  [MovieCode, ImgPath, GetLangStr(331)]);
		
	i := RegReadInteger('ShowRating', 1);
	if i = 1 then
		ShowUserRating := True
	else
		ShowUserRating := False;

	rate:='';
	for i:=1 to 10 do begin
		if i mod 2=1 then begin
			if i<=rating then
		      	rate:=rate+format('<a class="pic" href="rating:%d"><img src="%shalfstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
			else
	    	  	rate:=rate+format('<a class="pic" href="rating:%d"><img src="%snot-halfstar-left.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
		end
		else begin
			if i<=rating then
		      	rate:=rate+format('<a class="pic" href="rating:%d"><img src="%shalfstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
			else
	    	  	rate:=rate+format('<a class="pic" href="rating:%d"><img src="%snot-halfstar-right.gif" align="absmiddle" border="0"></a>',  [i, ImgPath])
		end;
	end;

	//description
    if description<>'' then begin
		if (ActiveTab <> 10) and (not FullDesc) and (length(description)>DescriptionLength) then begin
			description:=copy(description, 1, DescriptionLength);
			description:=RemoveUnclosedTags(description);
			description:=description+format(GetLangStr(566), [MovieCode]);
		end;
	end;

	if description='' then
		down:='<br>'+format('<a href="DownloadMovie:%d">', [MovieCode])+GetLangStr(324)+'</a>'
	else
		down:='';

	VideoFileName := '';
    with sl do begin
      	Clear;
      	Add('select e.filename from editions e');
      	Add('left outer join manuals m on m.code=e.edition and m.reference=21');
      	Add(format('where e.movie=%d', [MovieCode]));
      	Add('order by e.sort_order');
    end;
    EditionsCount:=ExecuteSQL(sl.text);
	VideoFileName := GetStringField('e.filename');
	
	with sl do begin
		Clear;
        Add('select code from images');
        Add(format('where movie=%d and mode=4', [MovieCode]));
    		Add('order by sort_order');        
    end;
    PosterCnt:=ExecuteSQL(sl.text);
	
	if (ActiveTab <> 3) and (not FullAwards) and (length(awards)>DescriptionLength) then begin
		awards:=copy(awards, 1, DescriptionLength);
		awards:=RemoveUnclosedTags(awards);
		awards:=awards+format(GetLangStr(1331), [MovieCode]);
	end;

	all:=GetPatternTop;
	all:= all + '<p class="title">' + movie;
	if (OriginalTitle <> '') and (OriginalTitle <> movie) then
		all := all + ' <span style="color: #999999; font-size: 16pt;">('+OriginalTitle+')</span>';
	all:= all + '</p>' + Format('<div class="icons">%s&nbsp;&nbsp;%s&nbsp;&nbsp;%s&nbsp;&nbsp;%s&nbsp;&nbsp;</div>', [ collection, seen, wanted, sale]) + ClosePatternTop;
		
	if  not (ActiveTab in [2, 6, 7]) then begin
		//pictures
		all := all + '<div class="left-block">';
		with sl do begin
			Clear;
			Add('select path, code from images');
			Add(format('where movie=%d and mode=1', [MovieCode]));
  		Add('order by sort_order');      
		end;
		RecordCount:=ExecuteSQL(sl.text);
		all:=all+'<div class="cover-info">';
		fl := False;
		if RecordCount>0 then begin
			if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
    			FileName := GetImageFileName(GetStringField('path'), ThumbsCovers, '', MainCoverWidth, 0);
				all:=all+'<div class="img-outer"><div class="img-inner"><a class="pic"'+format(' href="ShowImage:%d"><img style="width: %dpx;" border="0" src="%s"></a></div></div>',
  	          [GetIntegerField('code'), MainCoverWidth, FileName]);
			  fl := True;
	  		end;
		end;
		if not fl then begin
			FileName:=ImgPath+NO_COVER_FILE[MUSICNIZER_PROGRAM];
			if (MyFileExists(FileName)) then
				all:=all+format('<div class="img-outer"><div class="img-inner"><img class="cover-image" border="0" src="%s"></div></div>', [FileName]);
		end;

		all:=all+'</div><div style="background-color: '+CellColor+'; height: 10px;"></div>';
	  
		//site links
		with sl do begin
			Clear;
			Add('select distinct mc.code, mc.site, mc.script, mc.rating, p.* from movies_codes mc');
			Add('left outer join partners p on mc.script=p.site');
      Add('AND mc.item_type = p.item_type');
			Add(format('where movie=%d', [MovieCode]));
			Add('order by p.sort_order, mc.scrispt');
		end;
		RecordCount:=ExecuteSQL(sl.text);
			
		for i:=1 to RecordCount do begin
			site:=GetStringField('mc.script');
			url:=GetStringField('mc.site');
			if (site <> 'trailer') and (url <> '') then begin
				postfix:=GetStringField('p.postfix');
				all := all+'<div class="site-link">'; 
				if postfix<>'' then
					url:=url+postfix;
				if site='buy' then begin
					if Pos('amazon', url)>0 then
						all:=all+'<a class="pic" alt="Buy at Amazon"  href="link:http://www.movienizer.com/redirect/'+url+'">'+format('<img src="%samazon.gif" border="0"></a> ', [PicturesPath])
					else if Pos('ozon', url)> 0 then
						all := all + '<a class="pic" alt="  "  href="link:http://www.movienizer.com/redirect/'+url+'">'+format('<img src="%sozon.gif" border="0"></a> ', [PicturesPath])
					else
						all:=all+format(GetLangStr(375), ['http://www.movienizer.com/redirect/'+url, movie])+' ';
				end
				else begin
					s:=GetStringField('p.picture');
					if s='' then
					all:=all+'<a href="link:http://www.movienizer.com/redirect/'+url+format('">%s</a> ', [site])
					else
						all:=all+'<a class="pic" href="link:http://www.movienizer.com/redirect/'+url+'">'+format('<img src="%s%s" border="0"></a> ', [PicturesPath, s]);
				end;
				all := all + '</div>';
				i := RegReadInteger('ShowSiteRating', 1);
				if i=1 then begin
					SiteRating:=GetFloatField('mc.rating');
					if (SiteRating>0) and (site<>'imdb') then
						all := all + format('<div class="site-rating">%s: %f</div>', [GetLangStr(75),SiteRating]);
				end;
			end;
			GetNextRecord;
		end; //for
		
		all := all + '<div class="free-space"></div>';
		//my rating
		i := RegReadInteger('ShowRating', 1);
		if i=1 then begin
			all := all + '<div class="site-rating">';
			all := all + Format('%s:<br/>', [GetLangStr(298)]);
			all := all + rate + '</div>';
		end;
		
		//imdb rating
		if IMDBRating <> 0 then begin
			all := all + Format('<div class="site-rating">%s: ', [GetLangStr(707)]) + Format ('<strong>%0.1f</strong></div>', [IMDBRating]);
		end;
		
		
		all := all + '</div>';
		
	end; //if ActiveTab <> 2
	
	//Check if the active tab exists
	if ((ActiveTab = 5) and (EditionsCount = 1) and (VideoFileName = '')) or 
	//no shots
	((ActiveTab = 2) and (shotCnt = 0)) or
	//no posters
	((ActiveTab = 7) and (PosterCnt = 0)) then begin
		ActiveTab := 1;
		Result := GetAlbumPage(MovieCode, season, FullDesc, FullComments, FullPersons, FullAwards);
		exit;
	end;

	//shots from the movie
	AdditionalSpace := 0;
	ShowScreenshots := False;
	MaxShots := RegReadInteger('ShotsCnt', 5);
	if (ActiveTab = 1) and (MaxShots > 0) then begin
		showScreenshots := True;
		i := GetHTMLWidth - LeftColumnWidth - ScreenshotWidth;
		if (i < DataArea) then
			showScreenshots := False;
	end;
	
	ScreenshotTotalHeight := 0;
	if ShowScreenshots then begin
		AdditionalSpace := ScreenshotWidth + NormalImageBorders;
		s := '';
		if (RegReadInteger('ShowCoversOnTheRight', 1) = 1) then
			s := '2';
		if (RegReadInteger('ShowPostersOnTheRight', 0) = 1) then begin
			if s<>'' then
				s := s + ',';
			s := s + '4';			
		end;
		if (RegReadInteger('ShowBackdropsOnTheRight', 1) = 1) then begin
			if s<>'' then
				s := s + ',';
			s := s + '7';
		end;
		if (RegReadInteger('ShowShotsOnTheRight', 1) = 1) then begin
			if s<>'' then
				s := s + ',';
			s := s + '3';
		end;
		with sl do begin
			Clear;
			Add('select path, i.code as code, mode, width, height from images i');
			Add('inner join images_modes im on i.mode=im.code');
			Add(format('where movie=%d', [MovieCode]));
			Add(format('and mode in (%s)', [s]));
  		Add('order by im.sort_order, i.sort_order');        
		end;
		RecordCount:=ExecuteSQL(sl.text);
		j := 0;
		//if there are other pictures than the main cover, show them according to the settings
		if ((fl or (GetIntegerField('mode') <> 1)) and (RecordCount>0)) or (RecordCount>1) then begin
			all := all + '<table class="right-block"><tr><td>';
			if RecordCount < MaxShots then
				MaxShots := RecordCount;
			ScreenshotTotalHeight := ScreenshotTotalHeight + ScreenshotPadding div 2;
			for i:=1 to MaxShots do begin
				//skip the main cover
				if (RegReadInteger('OnlyShots', 1) <> 1) and (GetIntegerField('mode') = 1) and (j = 0) then
					j := 1
				else
					if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
						FileName := GetImageFileName(GetStringField('path'), ThumbsScreenshots, '', ScreenshotWidth, 0);
						all:=all+'<div class="shot-place"><div class="img-outer"><div class="img-inner"><a class="pic" '+format('href="ShowImage:%d"><img style="width: %dpx" border="0" src="%s"></a></div></div></div>', [GetIntegerField('code'), ScreenshotWidth, FileName]);
						ScreenshotTotalHeight := ScreenshotTotalHeight + Round(GetIntegerField('height') * (ScreenshotWidth / GetIntegerField('width'))) + ScreenshotPadding div 2;
					end;
				GetNextRecord;
			end;
			if RecordCount > MaxShots then begin
				all:=all+format('<div class="arrow-down"><a class="pic" href="userref:1110,%d"><img border="0" alt="%s" src="%sarrow-down.gif"></a></div>', [MovieCode, GetLangStr(1411), ImgPath]);
				ScreenshotTotalHeight := ScreenshotTotalHeight + 30; //arrow down width
			end;
			all := all + '</td></tr></table>';
		end; //if
	end;
	
	//tabs
	if RegReadInteger('HideNavigationMenu', 0) = 0 then
		all := all + GetAlbumTabs(MovieCode, season, SeasonCnt, awards<>'', shotCnt>0, (EditionsCount > 1) or (VideoFileName <>''), PosterCnt>0, TrailerCnt>0, description <> '', ConnectionsCnt>0, AdditionalSpace);
	//actors
	if ActiveTab = 4 then begin
		all := all + GetCast(MovieCode);
	end;
	
	//Shots
	if ActiveTab = 2 then
		all := all + GetShots(MovieCode, 3, 'movie', 7, 5);
	//Posters
	if ActiveTab = 7 then
		all := all + GetShots(MovieCode, 4, 'movie');
	
	if ActiveTab = 1 then begin	
		if FixedContentsWidth then
			all := all + '<table style="width: 100%; border-collapse: collapse;"><tr><td>';
		all := all + '<table class="names-values">';
		ThisBlockCnt := -1;
		
		//media type
		if MediaType > 0 then begin
			with sl do begin
				Clear;
				Add('select * from manuals');
				Add(Format('where code=%d', [MediaType]));
			end;
			RecordCount := ExecuteSQL(sl.text);
			if RecordCount > 0 then begin
				ThisBlockCnt := ThisBlockCnt + 1;
				if (ThisBlockCnt mod 2 = 1) then
					border := bckgrnd
				else
					border := '';
				all := all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(173), border]);
				all := all + Format('<a href="media_type:%d">%s</a></td></tr>', [GetIntegerField('code'), GetStringField('name')]);
			end;
		end;
		
		//genres
		with sl do begin
			Clear;
			Add('select m.code, m.name from movies_manuals mm');
			Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference  ???
			Add(format('where mm.movie=%d and m.reference=8', [MovieCode]));
		end;
		RecordCount:=ExecuteSQL(sl.text);
		if RecordCount>0 then begin
			//'Genres: '
			ThisBlockCnt := ThisBlockCnt + 1;
			if (ThisBlockCnt mod 2 = 1) then
				border := bckgrnd
			else
				border := '';
			all:=all + '<tr><td class="small-table-name"' + border + Format('>%s</td><td class="middle-cell"></td><td class="small-table-value"', [GetLangStr(72)])+ border + '>';
			for i:=1 to RecordCount do begin
				if i>1 then
					all := all + ' / ';
				all:=all+format('<a href="genre:%d">%s</a>', [GetIntegerField('m.code'), GetStringField('m.name')]);
			GetNextRecord;
			end;
			all:=all+'</td></tr>';
		end;
	  
		//year
		if year<>'' then begin
			ThisBlockCnt := ThisBlockCnt + 1;
			if (ThisBlockCnt mod 2 = 1) then
				border := bckgrnd
			else
				border := '';
			all:=all+format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s><a href="year:%s">%s</a></td></tr>', [border, GetLangStr(169), border, year, year]);
		end;
		
		//countries
		with sl do begin
			Clear;
			Add('select m.code, m.name from movies_manuals mm');
			Add('join manuals m on m.code=mm.ref_code');//and m.reference=mm.reference  ???
			Add(format('where mm.movie=%d and m.reference=9', [MovieCode]));
		end;
		RecordCount:=ExecuteSQL(sl.text);
		if RecordCount>0 then begin
			//'Countries: '
			ThisBlockCnt := ThisBlockCnt + 1;
			if (ThisBlockCnt mod 2 = 1) then
				border := bckgrnd
			else
				border := '';
			all := all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(73), border]);
			country := '';
			for i:=1 to RecordCount do begin
				country:=country+format('<a href="country:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
				GetNextRecord;
			end;
			country:=copy(country, 1, length(country)-3);
			all:=all + country + '</td></tr>';
		end;
	
	
		//duration
		hours := duration div 60;
		minutes := duration mod 60;
		s := '';
		if hours>0 then
			s:=format('%d:%.2d', [hours, minutes]);
		if duration>0 then begin
			ThisBlockCnt := ThisBlockCnt + 1;
			if (ThisBlockCnt mod 2 = 1) then
				border := bckgrnd
			else
				border := '';
			all:=all+format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>%s</td></tr>', [border, GetLangStr(705), border, s]);
		end;
	
		//studios
		studios:='';
		with sl do begin
			Clear;
			Add('select m.code, m.name from movies_manuals mm');
			Add('join manuals m on m.code=mm.ref_code');
			Add(format('where mm.movie=%d and m.reference=12', [MovieCode]));
		end;
		RecordCount:=ExecuteSQL(sl.text);
		if RecordCount>0 then begin
			ThisBlockCnt := ThisBlockCnt + 1;
			if (ThisBlockCnt mod 2 = 1) then
				border := bckgrnd
			else
				border := '';
			studios := format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(10553), border]);
			for i:=1 to RecordCount do begin
				studios := studios + format('<a href="studio:%d">%s</a> / ', [GetIntegerField('m.code'), GetStringField('m.name')]);
				GetNextRecord;
			end;
			studios := copy(studios, 1, length(studios)-3);
			all := all + studios + '</td></tr>';
		end;

		//directors
		s := '';
		with sl do begin
			Clear;
			Add('select distinct p.code, p.name, p.in_collection from data d');
			Add('inner join persons p on p.code=d.person');
			Add(format('where d.movie=%d and d.mode=1', [MovieCode]));
			Add('order by d.sort_order');
		end;
		RecordCount:=ExecuteSQL(sl.text);
		if RecordCount>0 then begin
			//'Directors: ';
			ThisBlockCnt := ThisBlockCnt + 1;
			if (ThisBlockCnt mod 2 = 1) then
				border := bckgrnd
			else
				border := '';
			all:=all + Format('<tr><td class="small-table-name"%s>%s</td><td class="middle-cell"></td><td class="small-table-value"%s>', [border, GetLangStr(10010), border]);
			i:=1;
			while i<=RecordCount do begin
				if GetIntegerField('p.in_collection')=1 then
					img:=format('<img src="%sperson.gif" align="absmiddle" style="margin-right: 5px;">', [ImgPath])
				else
					img:='';
				s:=s+img+format('<a href="person:%d">', [GetIntegerField('p.code')])+GetStringField('p.name')+'</a>, ';
				if (i=5) and (i<RecordCount) and not FullPersons then
					i:=RecordCount;
				i:=i+1;
				ArtistName := GetStringField('p.name');
				GetNextRecord;
			end; //while
			s:=copy(s, 1, length(s)-2);
			if (RecordCount>=6) and not FullPersons then
				s:=s+format(GetLangStr(1251), [MovieCode]);
			all:=all+s+'</td></tr>';
		end; //if


		all := all + '</table>';
	end;


	if (ActiveTab = 1) or (ActiveTab = 10) then begin  
		//description
		if description<>'' then
			all:=all+'<table class="text-box"><tr><td>'+description+'</td></tr></table>';
	end;

	if (ActiveTab = 1) then begin
		if not FixedContentsWidth then
			all := all + '<table style="width: 100%; border-collapse: collapse;"><tr><td>';
		//photos of people
		temp := '';
		if (RegReadInteger('HidePhotosCovers', 0) = 0) then begin
			LastCode:=0;
			with sl do begin
				Clear;
				Add('select i.path as path, i.width, i.height, i.person as code, i.mode, p.name, p.birth_date, c.name');
				Add('from data d');
				Add('inner join images i on i.person=d.person');
				Add('inner join persons p on p.code=d.person');
				Add('left outer join characters c on c.person=d.person and c.movie=d.movie');
				Add(format('where d.movie=%d', [MovieCode]));
				Add('order by d.mode, d.sort_order, i.person, i.sort_order');
			end;
			RecordCount:=ExecuteSQL(sl.text);
			page_width := GetHTMLWidth - WholePageBorder;
			if FixedContentsWidth then
				page_width := page_width - LeftColumnWidth;
			i := ScreenshotAreaHeight;
			if page_width > WidePage then
				i := i - 100;
			if ScreenshotTotalHeight > i then
				page_width := page_width - ScreenshotWidth - ScreenshotPadding;
			if RecordCount>0 then begin
				TempList := TStringList.Create;
				all:=all+'<table class="white-bck-block"><tr><td>';
				j := 0;
				kol := 0;
				i := 0;
				fl := True;
				while (i < RecordCount) and fl do begin
					//only photos! no custom images are allowed
					if (GetIntegerField('i.mode') = 6) then begin
						if (TempList.IndexOf(IntToStr(GetIntegerField('code'))) < 0) then begin
							kol := kol + 1;
							TempList.Add(IntToStr(GetIntegerField('code')));
							PicHeight := GetIntegerField('i.height');
							if PicHeight > 0 then
								PicWidth := Round(GetIntegerField('i.width') * (SmallCoverHeight / PicHeight)) + NormalImageBorders
							else
								PicWidth := StandardCoverWidth + NormalImageBorders;
							if PicWidth < StandardCoverWidth then
								PicWidth := StandardCoverWidth + NormalImageBorders;
							//to do: count page width, next line
							{age := GetStringField('p.birth_date');
							while (Pos('/', age)> 1) do
								delete(age, 1, Pos('/', age));
							try
								if (StrToInt(age) > 0) then
									age := IntToStr(StrToInt(year) - StrToInt(age));
							except
							end;}
              age := '';
              if (YearsBetween(GetStringField('p.birth_date'), year) > 0) then
                age := IntToStr(YearsBetween(GetStringField('p.birth_date'), year));
							if (MyFileExists(ImagesPath+GetStringField('path'))) then begin
								temp := temp + '<div class="image-place"><div class="photo-outer"><div class="photo-inner">';
								trunc_name := TruncateName(GetStringField('p.name'), MaxNameLength);
								trunc_character := TruncateName(GetStringField('c.name'), MaxCharacterNameLength);

								FileName := GetImageFileName(GetStringField('path'), ThumbsMoviePhotos, 'nophoto.jpg', 0, SmallCoverHeight);
								temp:=temp+format('<a class="pic" href="person:%d"><img style="height: %dpx" src="%s" border="0"></a></div></div><div class="image-text"><a href="person:%d">%s', [GetIntegerField('code'), SmallCoverHeight, FileName, GetIntegerField('code'), trunc_name]);
							//end 2.05.11
								
								
								if age <> '' then
									temp := temp + format(' (%s)', [age]);
								temp := temp + '</a>';
								if trunc_character <> '' then
									temp := temp + '<br>(' + trunc_character + ')';
								temp := temp + '</div></div>';
								page_width := page_width - PicWidth;
								if (page_width >= 0) then begin
									all := all + temp;
									j := j + 1;
									temp := '';
									page_width_rest := page_width;
								end
								else
									fl := False;
							end;//if MyFileExists
						end;
					end;
					GetNextRecord;
					i := i + 1;
				end;//while
				//all := all + '<td colspan="' + IntToStr(kol-j) + '">';
				all := all + '</td>';
				//here comes a magic number :)
				if (kol > j) and (page_width_rest > 50) then
					all := all + '<td class="arrow-left-page"><a class="pic" href="userref:1112,'+IntToStr(MovieCode)+'">' + Format('<img border="0" src="%sarrow-left.gif"/>', [ImgPath])+'</a></td>';
				all := all + '</tr></table>';
				TempList.Free;
			end;//if recordcount
		end;

		//custom fields
		cust:='';
		PrevBlockCnt:=-1;
		for i:=1 to 4 do begin
			if custom[i]>0 then begin
				with sl do begin
					Clear;
					Add('select name from manuals');
					Add(format('where code=%d', [custom[i]]));
				end;
				RecordCount:=ExecuteSQL(sl.text);
				if RecordCount>0 then begin
					PrevBlockCnt:=PrevBlockCnt+1;
					if (PrevBlockCnt mod 2 = 1) then
						border := bckgrnd
					else border := '';
					cust:=cust+Format('<tr><td class="big-table-name"%s>', [border])+format(GetLangStr(539+i), [s])+format('</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border])+format('<a href="custom%d:%d">', [i, custom[i]])+GetStringField('name')+'</a></td></tr>';
				end;
			end;
		end;
	
		//custom list1
		with sl do begin
			Clear;
			Add('select m.code, m.name from movies_manuals mm');
			Add('join manuals m on m.code=mm.ref_code');
			Add(format('where mm.movie=%d and m.reference=17', [MovieCode]));
			Add('order by m.name');
		end;
		RecordCount:=ExecuteSQL(sl.text);
		if RecordCount>0 then begin
			PrevBlockCnt:=PrevBlockCnt+1;
			if (PrevBlockCnt mod 2 = 1) then
				border := bckgrnd
			else
				border := '';
			cust:=cust+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(544), border]);
			for i:=1 to RecordCount do begin
				cust:=cust+format('<a href="custom5:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
				GetNextRecord;
			end;
			cust:=copy(cust, 1, length(cust)-2);
			cust:=cust+'</td></tr>';
		end;

		//custom list2
		with sl do begin
			Clear;
			Add('select m.code, m.name from movies_manuals mm');
			Add('join manuals m on m.code=mm.ref_code');
			Add(format('where mm.movie=%d and m.reference=18', [MovieCode]));
			Add('order by m.name');
		end;
		RecordCount:=ExecuteSQL(sl.text);
		if RecordCount>0 then begin
			PrevBlockCnt:=PrevBlockCnt+1;
			if (PrevBlockCnt mod 2 = 1) then
				border := bckgrnd
			else
				border := '';
			cust:=cust+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(545), border]);
			for i:=1 to RecordCount do begin
				cust:=cust+format('<a href="custom6:%d">%s</a>, ', [GetIntegerField('m.code'), GetStringField('m.name')]);
				GetNextRecord;
			end;
			cust:=copy(cust, 1, length(cust)-2);
			cust:=cust+'</td></tr>';
		end;
		if cust <> '' then
			all:=all+'<table class="names-values">'+cust+'</table>';
	end; //if ActiveTab = 1
	
		
    //editions
	if ((ActiveTab = 1) and 
	(((SeasonCnt = 0) and (RegReadInteger('ShowEditionsOnMainTab', 1) = 1)) or ((SeasonCnt > 0) and (RegReadInteger('ShowEditionsOfTVSeries', 0) = 1)))) 
	or (ActiveTab = 5) or (ActiveTab = 8) then begin
		with sl do begin
			Clear;
			Add('select e.code from editions e');
			Add('left outer join manuals m on m.code=e.edition and m.reference=21');
			Add(format('where e.movie=%d', [MovieCode]));
			Add('order by e.sort_order');
		end;
		EditionsCount:=ExecuteSQL(sl.text);

		for ie:=1 to EditionsCount do begin
			editions[ie]:=GetIntegerField('e.code');
			GetNextRecord;
		end;
		
		if EditionsCount > 0 then
			all := all + '<table class="envelope-table"><tr><td>';

		for ie:=1 to EditionsCount do begin
			EditionCode:=editions[ie];
			//editions
			with sl do begin
				Clear;
				Add('select * from editions e');
				Add('left outer join manuals m on m.code=e.edition and m.reference=21');
				Add(format('where e.code=%d', [EditionCode]));
			end;
			ExecuteSQL(sl.text);

			ed:='';
	
			//video parameters
			VideoBitrate:=GetIntegerField('e.video_bitrate');
			filesize:=GetIntegerField('e.filesize');
			DiscLabel:=GetIntegerField('e.disc_label');
			disc_nom:=GetStringField('e.disc_nom');
			duration:=GetIntegerField('e.duration');
			barcode:=GetStringField('e.barcode');

			VideoStandard:=GetIntegerField('e.video_standard');
			ScreenRatio:=GetIntegerField('e.screen_ratio');
			resolution:=GetIntegerField('e.resolution');
			VideoCodec:=GetIntegerField('e.video_codec');
			MediaFormat:=GetIntegerField('e.media_format');
		
			EditionFeatures:=GetStringField('e.features');
			EditionComment:=GetStringField('e.comment');
			EditionCost:=GetFloatField('e.cost');
			EditionName := GetStringField('m.name');
			EditionYear := GetStringField('e.year');
		
			if ((EditionsCount > 1) or (RegReadInteger('ShowEditions', 0) = 1) or (ActiveTab = 5) or (ActiveTab=8)) then begin
				PrevBlockCnt:=-1;
				VideoFileName := GetStringField('e.filename');
				VideoFileFolder := VideoFileName;
				while (length(VideoFileFolder)>0) and (pos(VideoFileFolder[length(VideoFileFolder)],'/\')=0) do delete(VideoFileFolder,length(VideoFileFolder),1);
				ed:=ed + '<p class="header">';
				if VideoFileFolder<>'' then
					ed:=ed+format('<a class="pic" href="explore:%s">', [VideoFileName])+format('<img src="%sfolder.png" align="absmiddle" border="0" alt="%s"></a> ', [ImgPath, VideoFileName])+'&nbsp;';
				i := GetIntegerField('e.season');
				j := GetIntegerField('e.episode');
				if (i=0) and ((RegReadInteger('OnlyEditionName', 0) = 0) or (GetStringField('m.name') = '')) then
					ed:=ed+format(GetLangStr(1260), [ie])+'. ';
				if EditionYear <> '' then
					ed := ed + '(<a href="userref:1305,' + EditionYear + '">' + EditionYear + '</a>) ';
				if EditionName <> '' then
					ed := ed + '<a href="userref:1304,' + EditionName + '">' + EditionName + '</a>. ';
				if GetStringField('e.title')<>'' then
					ed:=ed+GetStringField('e.title')+'. ';
				barcode := GetStringField('e.barcode');
				if not ((i=0) and (j=0)) then begin
					ed:=ed+format(GetLangStr(1252), [i, j])+'. ';
					with sl do begin
						Clear;
						Add('SELECT title FROM episodes');
						Add(format('where movie=%d and season=%d and episode=%d', [MovieCode, i, j]));
					end;
					ExecuteSQL(sl.text);
					ed := ed+GetStringField('title')+'. ';
				end;
				if VideoFileName<>'' then
					ed:=ed+format('<a class="pic" href="play:%s">', [VideoFileName])+format('<img src="%splay.png" align="absmiddle" border="0" alt="%s"></a> ', [ImgPath, VideoFileName]);

			  
				if duration>0 then
					ed:=ed+Format('<font size="2">(%d:%0.2d)</font> ', [duration div 60, duration mod 60]);
				if barcode<>'' then
					ed:=ed+GetLangStr(1259)+': '+barcode;
				ed := ed + '</p>';
			end;

			all:=all+ed;
	
	
			//editions
			if (ActiveTab = 1) or (ActiveTab = 5) then begin
				
				//Tracks
				with sl do begin
					Clear;
					Add('SELECT * FROM tracks');
					Add(Format('WHERE edition=%d AND movie=%d', [EditionCode, MovieCode]));
					Add('ORDER BY sort_order, track_number_int');
				end;
				ed := '';
				RecordCount := ExecuteSQL(sl.text);
				if RecordCount>0 then begin
					ed := ed + '<table style="background-color: white; width: 100%;"><tr><td><table><tr><td colspan="5">';
					ed := ed + '<p class="header">' + GetLangStr(10337) + '</p></td></tr>';
					for i:=1 to RecordCount do
          begin
						TrackNumberStr := '';
						DurationStr := '';
            HasLyrics := (Trim(GetStringField('lyrics')) <> '');
						//track rating
						k := GetIntegerField('code');
						rating := GetIntegerField('rating');
						rate:='';
						if ShowUserRating then begin
							for i:=1 to 5 do begin
								if i<=rating then
									rate:=rate+format('<a href="userref:1160,%d;%d;%d"><img src="%sfull-star.gif" border="0"></a>',  [MovieCode, i, k, ImgPath])
								else
									rate:=rate+format('<a href="userref:1160,%d;%d;%d"><img src="%sfull-star-inactive.gif" border="0"></a>',  [MovieCode, i, k, ImgPath])
							end;
						end;
						if (GetIntegerField('duration') > 0) then begin        
							Seconds := (GetIntegerField('duration') mod 60);
							Hours := GetIntegerField('duration') div 60 div 60;
							Minutes := (GetIntegerField('duration') - Hours * 60 * 60) div 60;
							if (Hours > 0) then
								DurationStr := Format('%d:%0.2d:%.2d', [Hours, Minutes, Seconds])
							else
								DurationStr := Format('%.2d:%.2d', [Minutes, Seconds]);
						end;
						if (GetIntegerField('track_number') > 0) then
							TrackNumberStr := GetStringField('track_number');
						//create a line containing information about the track
						ed := ed + Format('<tr><td style="text-align: right; width: 20px;">%s', [TrackNumberStr]);
						//don't put points if there are not track numbers
						if TrackNumberStr<>'' then
							ed := ed + '.';
						ed := ed + '</td><td>';
            if (HasLyrics) then
            begin
              if (IsTrackLyricsExpanded(GetIntegerField('Code'))) then
                ed:=ed+format('<a href="collapse_lyrics:%d"><img align="absmiddle" style="margin:0px 1px" src="%scollapse.png" alt="%s" border="0"></a>',  [GetIntegerField('Code'), PicturesPath, GetLangStr(20849)])
              else
                ed:=ed+format('<a href="expand_lyrics:%d"><img align="absmiddle" style="margin:0px 1px" src="%sexpand.png" alt="%s" border="0"></a>',  [GetIntegerField('Code'), PicturesPath, GetLangStr(20848)]);
              ed:=ed+format('<a href="edit_lyrics:%d"><img align="absmiddle" style="margin:0px 3px" src="%slyrics.png" alt="%s" border="0"></a>',  [GetIntegerField('Code'), PicturesPath, GetLangStr(20850)]);
            end;
						s := GetStringField('title');
						if s = '' then begin
							s :=GetStringField('filename');
							k := Pos('\', s);
							while k>0 do begin
								delete(s, 1, k);
								k := Pos('\', s);
							end;
							k := length(s);
							// 28.02.2012 Fade: AV for empty string        
							// while (s[k] <> '.') and (k > 0) do
							while (k > 0) and (s[k] <> '.') do
								k := k - 1;
							if (K > 0) and (s[k] = '.') then
								delete(s, k, length(s) - k + 1);
						end;
						if (GetStringField('filename') <> '') and (RegReadInteger('ShowPlayBtn4Tracks', 0) = 0) then
							ed := ed + Format('<b><a href="playByCode:%s">%s</a></b>', [GetStringField('Code'), s])
						else
							ed := ed + Format('<b>%s</b>', [s]);
							
						//add artist
						if (GetStringField('artist') <> '') and (LowerCase(ArtistName) <> LowerCase(GetStringField('artist'))) then begin
							ed := ed + ' (' + GetStringField('artist') + ')';
						end;
					
						//close
						ed := ed + ' </td>';
					
						//add duration
						ed := ed + Format('<td style="width: 20px; padding: 0 10px">%s</td>', [DurationStr]);
						
						//track rating 2
						if rate <> '' then
							ed := ed + '<td>' + rate + '</td>';
						
						(*//track rating
						s := '';
						if (GetIntegerField('rating') > 0) then begin
							s := Format('<img src="%sstar.gif"/>%d', [ImgPath, GetIntegerField('rating')]);
						end;
						ed := ed + Format('<td style="width: 60px;">%s</td>', [s]);*)
						
						//link to audio file
						ed := ed + '<td>';
						if RegReadInteger('ShowPlayBtn4Tracks', 0) = 1 then begin
							s := GetStringField('filename');
							if s<>'' then
								ed:=ed+format('<a href="playByCode:%s">', [GetStringField('Code')])+format('<img src="%splay.png" align="absmiddle" border="0" alt="%s"></a>', [ImgPath, s]);
						end;
						ed := ed + '</td></tr>';
            // add lyrics text
            if ((HasLyrics) and
                (IsTrackLyricsExpanded(GetIntegerField('Code')))) then
            begin
              ed := ed + '<tr><td colspan="5" style="padding-left: 50px;">' + GetStringField('lyrics') + '</td></tr>';
            end;
						GetNextRecord;
					end;
					ed := ed + '</table></td></tr></table>';
					//ed := ed + Format('<tr><td class="free-space"></td></tr><tr style="background:url(%s) repeat-x;"><td colspan="2">&nbsp;</td></tr>', [WhiteBarFile]);
				end;
				
				all := all + ed;
				ed := '';
			
			
				ed:='<table class="names-values">';
				ThisBlockCnt := -1;
		
				if (ActiveTab = 1) then begin
					//disc #
					if disc_nom<>'' then begin
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						ed:=ed+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(391), border, disc_nom]);
					end;
					//disc label
					if DiscLabel>0 then begin
						with sl do begin
							Clear;
							Add('select name from manuals');
							Add(format('where code=%d', [DiscLabel]));
						end;
						RecordCount:=ExecuteSQL(sl.text);
						if RecordCount>0 then begin
							ThisBlockCnt := ThisBlockCnt + 1;
							if (ThisBlockCnt mod 2 = 1) then
								border := bckgrnd
							else
								border := '';
							ed:=ed+format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="disc_label:%d">%s</a></td></tr>', [border, GetLangStr(1000), border, DiscLabel, GetStringField('name')]);
						end;
					end;
					//edition cost
					if EditionCost > 0 then begin
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						ed:=ed+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%f</td></tr>', [border, GetLangStr(3350), border, EditionCost]);
					end;
		
					//loans
					border:='';
					with sl do begin
						Clear;
						Add('select l.location, m.name from loans l');
						Add('inner join manuals m on m.code=l.location');
						Add(format('where edition=%d', [EditionCode]));
						Add('and (return_date='''' or return_date is null)');
						Add('order by loan_date desc');
					end;
					RecordCount:=ExecuteSQL(sl.text);
					if RecordCount>0 then begin
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						ed:=ed+Format('<tr><td class="big-table-name"%s>', [border])+GetLangStr(333)+format('</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="location:%d">%s</a></td></tr>', [border, GetIntegerField('l.location'), GetStringField('m.name')]);
					end;
				end;
			
				if (ed<>'') then
					all := all + ed;
		
				//parameters
				with sl do begin
					Clear;
					Add('select name, reference from manuals');
					Add(format('where code in (%d, %d, %d, %d, %d)', [VideoStandard, ScreenRatio, resolution, VideoCodec, MediaFormat]));
					Add('order by reference');
				end;
				RecordCount:=ExecuteSQL(sl.text);
				for i:=1 to RecordCount do begin
					if GetIntegerField('reference')=1 then begin
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						//Video standard
						all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(201), border, GetStringField('name')]);
					end
					else if GetIntegerField('reference')=2 then begin
						//media format
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="media_format:%d">%s</a></td></tr>', [border, GetLangStr(249), border, MediaFormat, GetStringField('name')]);
					end
					else if GetIntegerField('reference')=4 then begin
						//screen ratio
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="aspect_ratio:%d">%s</a></td></tr>', [border, GetLangStr(202), border, ScreenRatio, GetStringField('name')]);
					end
        	
					else if GetIntegerField('reference')=5 then begin
						//resolution
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="resolution:%d">%s</a></td></tr>', [border, GetLangStr(203), border, resolution, GetStringField('name')]);
					end

					else if GetIntegerField('reference')=19 then begin
						//video codec
						ThisBlockCnt := ThisBlockCnt + 1;
						if (ThisBlockCnt mod 2 = 1) then
							border := bckgrnd
						else
							border := '';
						all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s><a href="video_codec:%d">%s</a></td></tr>', [border, GetLangStr(571), border, VideoCodec, GetStringField('name')]);
					end;
					GetNextRecord;
				end;
				s2:='';
				//video bitrate
				if VideoBitrate>0 then begin
					ThisBlockCnt := ThisBlockCnt + 1;
					if (ThisBlockCnt mod 2 = 1) then
						border := bckgrnd
					else
						border := '';
					s2:=format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%d</td></tr>', [border, GetLangStr(630), border, VideoBitrate]);
				end;
				//filesize
				if filesize>0 then begin
					ThisBlockCnt := ThisBlockCnt + 1;
					if (ThisBlockCnt mod 2 = 1) then
						border := bckgrnd
					else
						border := '';
					s2:=s2+format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%d</td></tr>', [border, GetLangStr(631), border, filesize]);
				end;
		
				//duration
				if (duration>0) and (EditionsCount=1) then begin
					ThisBlockCnt := ThisBlockCnt + 1;
					if (ThisBlockCnt mod 2 = 1) then
						border := bckgrnd
					else
						border := '';
					s2:=s2+format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(147), border]);
					s2:=s2+format('%.2d:%.2d</td></tr>', [duration div 60, duration mod 60]);
				end;
		
				all:=all+s2;

				//audio tracks
				with sl do begin
					Clear;
					Add('select m.code, m.name, am.Bitrate, am.Codec, am.Channel, am.Short_Comment from audio_manuals am');
					Add('left join manuals m on m.code=am.reference');
					Add(format('where am.edition=%d and am.media_type=0', [EditionCode]));
				end;
				RecordCount:=ExecuteSQL(sl.text);
				if RecordCount>0 then begin
					//Audio tracks
					ThisBlockCnt := ThisBlockCnt + 1;
					if (ThisBlockCnt mod 2 = 1) then
						border := bckgrnd
					else
						border := '';
					all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(254), border]);
					for i:=1 to RecordCount do begin
					    s2 := ' ' + GetStringField('am.codec');
						if (s2 <> '') then
						  S2 := s2 + ' ';
						if (GetIntegerField('am.channel') > 0) then
						  s2 := s2 + GetStringField('am.channel') + ' ch ';
						if (GetIntegerField('am.Bitrate') > 0) then
						  s2 := s2 + GetStringField('am.Bitrate') + ' kbps ';
						if (GetStringField('am.Short_Comment') <> '') then
						  s2 := s2 + GetStringField('am.Short_Comment') + ' ';
						if (s2<>'') then
							s2 := copy(s2, 1, length(s2) - 1);
						all:=all+format('<a href="audio_track:%d">%s</a>%s, ', [GetIntegerField('m.code'), GetStringField('m.name'), s2]);

						GetNextRecord;
					end;
					all:=copy(all, 1, length(all)-2);
					all := all + '</td></tr>';
				end;

				//subtitles
				with sl do begin
					Clear;
					Add('select m.code, m.name, am.Short_Comment from audio_manuals am');
					Add('join manuals m on m.code=am.reference');
					Add(format('where am.edition=%d and am.media_type=1', [EditionCode]));
				end;
				RecordCount:=ExecuteSQL(sl.text);
				if RecordCount>0 then begin
					//Subtitles
					ThisBlockCnt := ThisBlockCnt + 1;
					if (ThisBlockCnt mod 2 = 1) then
						border := bckgrnd
					else
						border := '';
					all:=all+Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(253), border]);
					for i:=1 to RecordCount do begin
						s2 := '';
						if (GetStringField('am.Short_Comment') <> '') then
							s2 := ' ' + Trim(GetStringField('am.Short_Comment'));
						all:=all+format('<a href="subtitle:%d">%s</a>%s, ', [GetIntegerField('m.code'), GetStringField('m.name'), s2]);
						GetNextRecord;
					end;
					all:=copy(all, 1, length(all)-2);
					all := all + '</td></tr>';
				end;
				//show filename
				if (RegReadInteger('ShowFileNames', 1) = 1) and (VideoFileName<>'') then begin
					ThisBlockCnt := ThisBlockCnt + 1;
					if (ThisBlockCnt mod 2 = 1) then
						border := bckgrnd
					else
						border := '';
					all := all + Format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>', [border, GetLangStr(195), border]);
					all := all + Format('<a href="play:%s">%s</a></td></tr>', [VideoFileName, VideoFileName]);
				end;
				all := all + '</table>';
				// DVD Features
				if EditionFeatures<>'' then begin
					all := all + '<p class="text-box">' + EditionFeatures + '</p>';
					PrevBlockCnt := 0;
				end;
		
				//Edition comments
				if EditionComment<>'' then begin
					all := all + '<p class="text-box">' + EditionComment + '</p>';
					PrevBlockCnt := 0;
				end;
		
			end;
		end; //editions 
		if EditionsCount > 0 then
			all := all + '</td></tr></table>';
	end;

	
	if (ActiveTab = 1) then begin
		//dates
		s:='';
		ThisBlockCnt := 0;
		s := '<table class="names-values">';
		border := bckgrnd;
		if DateAdd<>'' then
			s:=s+format('<tr><td class="big-table-name">%s</td><td class="middle-cell"></td><td class="big-table-value">%s</td></tr>', [GetLangStr(670), SQLDate2Str(DateAdd)]);
		if DateUpdate<>'' then
			s:=s+format('<tr><td class="big-table-name"%s>%s</td><td class="middle-cell"></td><td class="big-table-value"%s>%s</td></tr>', [border, GetLangStr(671), border, SQLDate2Str(DateUpdate)]);
		if DateSeen<>'' then
			s:=s+format('<tr><td class="big-table-name">%s</td><td class="middle-cell"></td><td class="big-table-value">%s</td></tr>', [GetLangStr(672), SQLDate2Str(DateSeen)]);
		all:=all+s+'</table>';



		//salary
		cust := '';
		if salary<>'' then
			cust:=cust+'<table class="text-box"><tr><td>'+salary+'</td></tr></table>';
		all := all + cust;

		//comments
		cust := '';
		if comment<>'' then begin
			if not FullComments and (length(comment)>DescriptionLength) then begin
				comment:=copy(comment, 1, DescriptionLength);
				comment:=comment+format(GetLangStr(1250), [MovieCode]);
			end;
			cust:=cust+'<table class="text-box"><tr><td>'+comment+'</td></tr></table>';
		end;
		
		all := all + cust;
	end;
	
	cust := '';
	
	
	if (ActiveTab = 1) then
		all := all + '</td></tr></table>';


	sl.Free;
	result:=all;
  finally
    ResetRegistrySubKey();
  end;
end;


begin

end.
