program orange_program_variables;
//Constants, Global variables and general utilities

const
	DefaultLinesPeople=4; //default number of rows for people (e.g. last added people)
	DefaultLinesMovies=3; //default number of rows for movies (e.g. movies by genre)
	DefaultLitresBlockVisible = False;
	WholePageBorder=40; //the space that cannot be used on the page (borders)
	NormalImageBorders=15; //space to take into account when calculating image width 
	BigImageBorders=20; //like above for home page
	SmallCoverHeight=130; //height of movie covers on person's page and of photos on movie page
	TabWidth=85; //approximate width of a "normal" tab on the movie/person page
	HomeTabWidth=180; //the same for the home page
	SeasonTabWidth=40;
	TabBorders=300; //space that cannot be used by tabs
	StandardShotWidth=350; //just a value, does not mean much
	ShotHeight=250; // height of images on the shots/posters/photos tabs
	//HomeCoverHeight=180; //height of covers on the home page
	//HomePhotoHeight=180; //height of photos on the home page
	MainPhotoWidth=150; //main photo on the person's page
	MainCoverWidth=150; //main cover on the movie page
	ScreenshotWidth=215; //width of shots and photos on movie/person page
	EpisodeCoverWidth=215;
	ArrowWidth=30; //width of the arrow shown next to covers and/or photos
	SmallImageBorder=5;
	LeftColumnWidth=200;
	MaxNameLength=12;
	MaxCharacterNameLength=10;
	DefaultThumbWidth=80; //width of thumbs in the detailed list (movies and people)
	DefaultTrailerWidth=200;
	DefaultCoverRows=1; //how many rows of covers should be displayed on the person's page
	NoCoverWidth=150; //full width of the 'no cover' image, assumed for photos, too
	NoCoverHeight=204; //full height of the 'no cover' image
	ScreenshotAreaHeight=600; //if screenshot area is shorter than this number, the full page width will be used to
							 //display photos
	ScreenshotPadding=40; //space around screenshots
	WidePage=1000; //if the available area bigger than this, photos are expected to be placed higher on the page
	SuperWidePage=1600;
	DataArea=320; //minimum space for the table with details on the movie page
	SeasonCoverSpace=30;
	SeasonTitleSize=10;
	CellColor='#ececec';
	WhiteAreaBorderColor='#d8d8d8';
	LitresAtTheTop=False;
	LitresCoverHeight=130;
	MaxTitleLength=30;
	DefaultOrangeLogo = 0;
	DefaultBreezeLogo = 0;
	
	{Breeze compatibility}
	TracksPerPage=100;
	ListModifier=-1;
	NormalModifier=1;
	BiggerModifier=2;
	SubHeaderModifier=4;
	SeasonHeaderModifier=6;
	PageHeaderModifier=9;
	LineSpacings=[1.0, 1.5, 2.0, 2.5, 3.0];
	IconSpace=210;
	
	DefaultBasicFontSize=11;
	DefaultLineSpacing=2;
	
	//folder names for thumbs
	ThumbsMoviePhotos='ThumbsOrangeMoviePhotos';
	ThumbsHomeMovies='ThumbsOrangeHomeMovies';
	ThumbsPersonMovies='ThumbsOrangePersonMovies';
	Thumbs = 'ThumbsOrange';
	Thumbs2 = 'ThumbsOrange2';
	ThumbsCovers = 'ThumbsOrangeCovers';
	ThumbsMainPhoto = 'ThumbsOrangeMainPhoto';
	ThumbsPhotos = 'ThumbsOrangePhotos';
	ThumbsScreenshots = 'ThumbsOrangeScreenshots';
	ThumbsHomePhotos = 'ThumbsOrangeHomePhotos';
	ThumbsEpisodeCovers = 'ThumbsOrangeEpisodes';

  MY_RATING_REFERENCE = 100;
  
    {    ,    .     }
  //   ,       (MOVIENIZER_PROGRAM, MUSICNIZER_PROGRAM, BOOKNIZER_PROGRAM)
	DefaultMultiCoverWidth = [90, 110, 90, 110]; //the width of cover for the coverflow view
	DefaultMultiCoverHeight = [120, 110, 140, 110]; //the height of cover for the coverflow view
	DefaultMultiCellWidth = [100, 120, 100, 120]; //width of the cell for cover in the coverflow mode
	DefaultMultiCellHeight = [165, 140, 185, 140]; //height of the cell for cover in the coverflow mode (cell contains the cover and some text, e.g. title of the movie)

  //height of covers on the home page
	HomeCoverHeight = [170, 160, 200, 160];
	HomeCoverWidth = [125, 160, 125, 160];
  NoCoverWidthes = [150, 185, 150, 185];


  //height of photos on the home page
	HomePhotoHeight = [170, 200, 170, 200];
	HomePhotoWidth = [125, 160, 125, 160];


	
	LangLastAdded = [1402, 10404, 2960, 2960];
	LangLastUpdated = [1421, 10408, 2961, 2961];
	LangBestRated = [1403, 10405, 2962, 2962];
	LangUnseen = [1404, 0, 2959, 35144];
	LangLastAddedShort = [1407, 1407, 1407, 1407];
	LangBestRatedShort = [1408, 1408, 1408, 1408];
	LangUnseenShort = [1409, 1409, 2963, 35144];
	
	UserrefAdjuster = [0, 1000, 2000, 3000];
  
  // New consts for Medianizer
  DefaultHomePageShowMovies = True;
  DefaultHomePageShowAlbums = True;
  DefaultHomePageShowBooks = True;
  DefaultHomePageShowGames = True;
  DefaultHomePageShowSupport = True;
  
  NO_COVER_FILE = ['no-cover.jpg', 'no-cover-music.jpg', 'nocoverbooks.jpg', 'no-cover-game.jpg'];
  NO_PHOTO_FILE = ['nophoto.jpg', 'nophoto.jpg', 'nophoto.jpg', 'nophotocompany.jpg'];
  NO_SHOT_FILE = '';
  REGISTRY_SUB_KEYS = ['Movies\', 'Music\', 'Books\', 'Games\'];

const
  MOVIENIZER_PROGRAM = 0;
  MUSICNIZER_PROGRAM = 1;
  BOOKNIZER_PROGRAM = 2;
  GAMENIZER_PROGRAM = 3;

  ALL_PROGRAM_TYPES = 15;

  // for loops
  LOW_PROGRAM_TYPE = MOVIENIZER_PROGRAM;
  HIGH_PROGRAM_TYPE = GAMENIZER_PROGRAM;

var
  MultiShowRowHeight: array [0..3] of Integer;
  // width of the image that will be displayed (with of the column will be MultiShowImageWidth + 2*MiltiShowDistanceBetweenCovers)
  MultiShowImageWidth: array [0..3] of Integer;
  RatingHTMLTemplates: array [0..10] of string;
  HomeTab: array[0..3] of Integer;
  // distance between images on the show area
  MiltiShowDistanceBetweenCovers: Integer;

  CountedPages: integer;
	genre, country, movie, person, title, year, studio, ProgramReference: string;
	InCollection, StandardCoverWidth: integer;
	ImgPath, WhiteBarFile, BackgroundMovies, BackgroundPeople, BackgroundImg: String;
	TempReferenceCode, TempReference, ActiveTab, PersonActiveTab, ProcessedRecords: integer;
	TempText, UnseenEpisodes: string;
	HomeMovieTab, HomeAlbumTab, HomeBookTab, HomeGameTab, HomePersonTab: Integer;
	BasicFontSize, ListFontSize, LineSpace: Integer;
	RemainingTabs: string;	
	UsedProgramTypes: Integer = ALL_PROGRAM_TYPES;
  DefaultHomePageShowPersons: Boolean = False;

	
function GetProperPath(s: String): string;
begin
	s := ReplaceStr(s, '(', '%28');
	s := ReplaceStr(s, ')', '%29');
	s := ReplaceStr(s, ' ', '%20');
	result := s;
end;
	
function GetPatternTop: String;
begin
	Result := '';
end;

function ClosePatternTop: String;
begin
	result:= '<div style="clear:both">';
end;  

function GetReferenceTop: String;
begin
	Result := '<div class="reference-header-spacing">';
end;

function GetPatternBottom: String;
begin
	Result := '';
end;

//make sure that each word of Name is no longer than MaxLength
function TruncateName(Name: String; MaxLength: Integer): String;
var
	i: Integer;
	s: String;
begin
	Result := '';
	i := Pos(' ', Name);
	while i>0 do begin
		s := copy(Name, 1, i-1);
		if Length(s) > MaxLength then begin
			delete(s, MaxLength - 1, Length(s) - MaxLength + 2);
			s := s + '.';
		end;
		Result := Result + s + ' ';
		delete(Name, 1, i);
		i := Pos(' ', Name);
	end;
	if Length(name) > MaxLength then begin
		delete(name, MaxLength - 1, Length(name) - MaxLength + 2);
		name := name + '.';
	end;
	Result := Result + name;
end;

function GetAge(datenow, birthdate: string): string;
var
  YearsBetweenDate: Integer;
begin
	result := '???';
  YearsBetweenDate := YearsBetween(dateNow, birthdate);
  if (YearsBetweenDate) then
    Result := IntToStr(YearsBetweenDate);
  
end;

function RemoveUnicodeCharacters(txt: string): string;
var
	i, txtlen, iPos, iLen, iHasDigit, iHasDotComma: integer;
	oneletter: string;
begin
	iPos := Pos('&#', txt);
//ShowMessage('has unicode = ' + IntToStr(iPos));
	while iPos > 0 do begin
		iHasDigit := 0;
		iHasDotComma := 0;
		iLen := 2;
		txtlen := length(txt);
		for i := (iPos + 2) to txtlen do begin
			oneletter := copy(txt, i, 1);
			if ((CompareText('0', oneletter) <= 0) and (CompareText('9', oneletter) >= 0)) then begin
				iHasDigit := 1;
				iLen := iLen + 1;
//ShowMessage('has digit = ' + oneletter);
			end
			else if oneletter = ';' then begin
				iHasDotComma := 1;
				iLen := iLen + 1;
				i := txtlen + 1;
//ShowMessage('has dotcomma = ' + oneletter);
			end
			else begin
				i := txtlen + 1;
			end;
		end;

		if (iHasDigit = 1) and (iHasDotComma = 1) then begin
			Delete(txt, iPos, iLen);
			Insert('%', txt, iPos);
//ShowMessage(txt);
		end;

		iPos := Pos('&#', txt);
	end;

	result := txt;
end;

function DateIsInThePast(some_date: String): Boolean;
var
	ddd1, ddd2, mmm1, mmm2, yyy1, yyy2: Integer;
	day, month, year: String;
begin
	if (some_date <> '') then begin
		DecodeDate(Date, yyy1, mmm1, ddd1);
		day := copy(some_date, 4, 2);
		month := copy(some_date, 1, 2);
		year := copy(some_date, 7, 4);
		try
			ddd2 := StrToInt(day);
			mmm2 := StrToInt(month);
			yyy2 := StrToInt(year);
		except
			result := False;
			exit;
		end;
		if (ddd2 - ddd1) < 0 then
			mmm2 := mmm2 - 1;
		if (mmm2 - mmm1) < 0 then
			yyy2 := yyy2 - 1;
		if (yyy2 - yyy1) < 0 then
			result := True
		else
			result := False;
	end
	else
		result := False;
end;

function MyPos(ssearch, shost: string; start: integer): integer;
var
	stemp: string;
	newpos: integer;
begin
	stemp:=copy(shost,start,length(shost)-start+1);
	newpos:=pos(ssearch, stemp);
	if (newpos>0) then newpos:=newpos+start-1;
	result:=newpos;
end;

//remove not closed html tags
function RemoveUnclosedTags(text: string): string;
var
	i, j, k: Integer;
begin
	i := Pos('<', text);
	if i>0 then
		k := i - 1
	else
		k := 0;
	while i > k do begin
		j := MyPos('>', text, i+1);
		if (j<i) then begin
			delete(text, i, length(text)-i+1);
			j := i;
		end;
		k := j;
		i := MyPos('<', text, k + 1);
	end;
	result := text;
end;

function GetTodaysDate: String;
var
	ddd1, mmm1, yyy1: Integer;
begin
	DecodeDate(Date, yyy1, mmm1, ddd1);
	Result := Format('-%.2d-%.2d', [mmm1, ddd1]);
end;

function ReplaceStr(SrcStr, SrcVal, DstVal: string): string;
var
	DstStr : string;
	i: integer;
begin
	DstStr:=SrcStr;
	i:=MyPos(SrcVal, SrcStr, 1);
	while (i>0) do begin
		delete(DstStr,i,length(SrcVal));
		insert(DstVal,DstStr,i);
		i:=MyPos(SrcVal, DstStr, i+length(DstVal));
	end;
	result:=DstStr;
end;

//gets the image filename as it is stored in the database
//returns the full path to the image file or to the image thumb
//depending on settings
function GetImageFileName(ImageFile, ThumbsDir, DefaultCover: String;
  ImageWidth, ImageHeight: Integer; CutThumb: Boolean=False): String;
var
  CoverExists: Boolean;
	Filename, ThumbsPath, ThumbsFileName: String;
begin
	Filename := ImagesPath + ImageFile;
  CoverExists := (MyFileExists(Filename));
	if (not CoverExists) then
		Filename:=ImgPath+DefaultCover;
	Result := Filename;
	if (RegReadInteger('UseThumbs', 1) = 1) or CutThumb then
  begin
		ThumbsPath := ImagesPath + ThumbsDir + '\';
    if (CoverExists) then
  		ThumbsFileName:=ThumbsPath+ImageFile
    else
      ThumbsFileName:=ThumbsPath + DefaultCover;
		if GetFileDateTime(ThumbsFileName)<GetFileDateTime(FileName) then
			DeleteFile(ThumbsFileName);
		if not MyFileExists(ThumbsFileName) then
			ConvertThumb3(FileName, ThumbsFileName, ThumbsDir, ImageWidth, ImageHeight, CutThumb);
		if MyFileExists(ThumbsFileName) then
			result := ThumbsFileName;
	end;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  //     s1  s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function MyExtractFileExt(s: String): String;
var
	i: Integer;
begin
	i := Pos('.', s);
	while i > 0 do begin
		delete(s, 1, i);
		i := Pos('.', s);
	end;
	result := s;
end;

function GetStarRatingWithoutLinks(rating: Integer): String;
var
	my_i: Integer;
	rate: String;
begin
	rate := '';
	if rating>0 then begin
		for my_i:=1 to 10 do begin
			if my_i mod 2=1 then begin
				if my_i<=rating then
					rate:=rate+format('<img src="%shalfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
				else
					rate:=rate+format('<img src="%snot-halfstar-left.gif" align="absmiddle" border="0">',  [ImgPath])
			end
			else begin
				if my_i<=rating then
					rate:=rate+format('<img src="%shalfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
				else
					rate:=rate+format('<img src="%snot-halfstar-right.gif" align="absmiddle" border="0">',  [ImgPath])
			end;
		end;
	end;
	result := rate;
end;

function IsProgramUsed(AProgramType: Integer): Boolean;
var
  SettedBit: Integer;
begin
  SettedBit := 1 shl AProgramType;
  Result := ((UsedProgramTypes and SettedBit) > 0);
end;

procedure SetUsedProgramTypes(AProgramTypes: Integer);
begin
  // AProgramTypes is set of bits for each media type
  // 0 bit - is for movies
  // 1 bit - is for music
  // 2 bit - is for Books
  // For example value 5 means two media types: movies and books
  UsedProgramTypes := AProgramTypes;
end;


begin

end.
