﻿const
 script_name='RusKino';
 language='Russian';
 version=19;
 author='Vlad';
 MinProgramBuild=8000;
 
 PostReferer = 'post';

 PERSON_DIRECTOR = 1;
 PERSON_WRITER   = 2;
 PERSON_ACTOR    = 3;
 PERSON_COMPOSER = 4;

 IMAGE_FRONT_COVER = 1;
 IMAGE_BACK_COVER  = 2;
 IMAGE_SCREENSHOT  = 3;
 IMAGE_POSTER = 4;
 
 InvalidChars = '~!@#$%^&*()_+`-"№;%:?*<>{}''\|/[]., ';


var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments, 
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList, DownloadMovieTechnicalInfo: boolean;
	MaxShotsCount, MaxPostersCount: integer;
	
 duration: Integer;
 imdb_rating, rating: Double;
 title, year, country, description, imdb_code, movie_code, movie_site_url,
 original_title, mpaa, mpaa_rating,
 InternalURL, BaseImageURL, MovieInfo: string;   //  результаты поиска фильмов
 resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
 ShotsPage, ShotName, PostersPage: String;
	AlreadyAddedPeople, RequestParameters: TStringList;



function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;

                  

//==================================================================================================
//  01-а. Получение название фильма по штрих-коду
//==================================================================================================
function GetMovieNameByUPC(barcode: string): string;
var
	url, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	result:=res;
end;


//==================================================================================================
//  01-б.Формирование URL для поиска фильма на сайте по названию
//==================================================================================================
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
 begin       
	MovieName := ReplaceStr(MovieName, ' ', '+', -1);
  Result:=Format('https://www.ruskino.ru/search/?s=%s', [EncodeURL(MovieName, 'utf-8')])
 end;


//==================================================================================================
//  02. Загрузка html-документа по поисковому
//==================================================================================================
function DownloadSearchURL(url: string): integer;
 begin
	AddRequestForHTMLPageContent(URL, True, 'http://www.ruskino.ru', '', RequestParameters);
	all:=GetHTMLPageContentFromRequest(url);
  
  if (all<>'-1')
   then   Result:=SelectMovie
   else   Result:=-1
 end;  
 

//==================================================================================================
//  03. Парсинг страницы поисков с фильмами 
//==================================================================================================
function SelectMovie: Integer;
 var
	Movie, Code, small_cover, description, year, actors, tempCode, s, s2, director : string;
	i, j : Integer;
 begin
  Result:=0;
  tempCode := GetStr(all, '<h1><small>запрос</small>', '<script');
  i := Pos('<div class="media"', tempCode);
  while i > 0 do begin
	j := MyPos('<div class="media"', tempCode, i + 1);
	if j = 0 then 
		j := length(tempCode);
    s := copy(tempCode, i, j - 1);
	small_cover := GetStr(s, ' src="', '"');
	if (Pos('noposter', small_cover)>0) then
		small_cover := '';
	Movie := GetStr(s, '<h5', '</h5>');
	Code := ParseString(Movie, '/mov/(\d+)', 1);
	if Movie <> '' then
		Movie := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + Movie)));
	s2 := GetStr(s, 'class="search-result-subtitle">', '</div>');
	year := ParseString(s2, '(\d+)г.', 1);
	director := ParseString(s2, 'реж. (.*?)$', 1);
	director := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(director)));
	description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(s, 'class="search-result-text">', '</'))));
	if (Movie <> '') and (Code <> '') then begin
		SetSearchResult2(Movie, Code, Year, director, description, small_cover);
		Inc(Result);
	end;
	delete(tempCode, 1, i);
	i := Pos('<div class="media"', tempCode);
  end;
 end;


//==================================================================================================
//  04. Формирование URL с информацией о фильме по коду фильма в формате сайта
//==================================================================================================
function GetMovieURL(code: string; images_only: boolean): string;
 begin
  if Code<>''
   then   Result:='https://ruskino.ru/mov/'+Code
   else   Result:=''
 end;

function GetMovieSiteURL(code: string): string;
 begin
  if Code<>''
   then   Result:='https://ruskino.ru/mov/'+Code
   else   Result:=''
 end;

//==================================================================================================
//
//==================================================================================================
function GetPersonSiteURL(Code: string): string;
 begin
  if Code<>''
   then   Result:='https://ruskino.ru/art/'+Code
   else   Result:=''
 end;

procedure ExtractActors(text: String; mode: Integer);
var
	s, s2, small_photo, name, code, character, character_additional: String;
	i, j, k, local_mode: Integer;
begin
	i := Pos('<div class="media">', text);
	while (i > 0) do begin
		j := MyPos('<div class="media">', text, i + 1);
		if j = 0 then
			j := length(text);
		s := copy(text, i, j - i);
		small_photo := GetStr(s, 'src="', '"');
		small_photo := ReplaceStr(small_photo, '/media/cache/portret_tn_pv', '', -1);
		//small_photo := ReplaceStr(small_photo, '_pv.jpg', '.jpg', -1);
		code := ParseString(s, 'href="/art/(\d+)', 1);
		name := GetStr(s, 'itemprop="name">', '</');
		name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(name)));
		character := GetStr(s, 'class="titr_titr_extra">', '</');
		k := Pos('<span class="titr_titr_extra">', character);
		if k > 0 then begin
			character_additional := ClearExtraBlankCharacters(ParseString(character, '<span class="titr_titr_extra">/ (.*?)$', 1));
			delete(character, k, length(character) - k + 1);
			character := ClearExtraBlankCharacters(character);
			if character_additional <> '' then begin
				if character <> '' then
					character := character + ' / ' + character_additional
				else
					character := character_additional;
			end;
		end;
		character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(character)));
		if (name <> '') then begin
			SetPersonName(name, character, mode, code, small_photo);
		end;
		delete(text, 1, i);
		i := Pos('<div class="media">', text);
	end;
end;

procedure ExtractCrew(text: String; mode: Integer);
var
	s, name, code: String;
	i: Integer;
begin
  i := Pos('<dd>', text);
  while (i > 0) do begin
	s := GetStr(text, '<dd>', '</dd>');
	if (Pos('<small>', s) = 0) then begin
		code := ParseString(s, 'href="/art/(\d+)', 1);
		name := GetStr(s, 'itemprop="name">', '</');
		name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(name)));
		if name <> '' then
			SetPersonName(name, '', mode, code);
	end;
	delete(text, 1, i);
	i := Pos('<dd>', text);
  end;
end;

function StringHexToInt(s: string): integer;
var
  i, digit: integer;
begin
  Result := 0;
  for i:=1 to length(s) do
  begin
    digit := -1;
    case s[i] of
      '0'..'9': digit := StrToInt(s[i]);
      'a'..'f': digit := 10 + Ord(s[i]) - Ord('a');
      'A'..'F': digit := 10 + Ord(s[i]) - Ord('A');
    end;
    if (digit = -1) then
      Exit;
    Result := 16 * Result + digit;
  end;
end;

function DecodeUnicodeSequences(AString: string): string;
var
  EscPos: Integer;
  wChar: Char;
  UnicodeCharStr: string;
  UnicodeCharWord: Integer;
begin
  Result := AString;
  EscPos := Pos('\u', AString);
  while (EscPos > 0) do
  begin
    Delete(Result, EscPos, Length('\u'));
    UnicodeCharStr := Copy(Result, EscPos, 4);
    Delete(Result, EscPos, 4);
    UnicodeCharWord := StringHexToInt(UnicodeCharStr);
    wChar := Chr(UnicodeCharWord);
    Insert(wChar, Result, EscPos);
    EscPos := Pos('\u', Result);
  end;
end;
//==================================================================================================
//  Получение данных по фильму по URL
//  images_only - признак закачки только картинок
//==================================================================================================
function GetInfo(URL: string; Images_Only: boolean): string;
const
	StudioWordsToReplace=['Первого', 'канала'];
	StudioWordsReplaced=['Первый', 'канал'];
 var
  Temp, Name, Value, Actors, ActorName, ActorInfo, ActorLink, s, s2, AllActorsURL: string;
  Step, i, j, k: Integer;
 begin
  InternalURL:=URL;
  BaseImageURL:=ReplaceStr(InternalURL, 'mov', 'film', -1);

  //  Проверка на ошибки
  if URL=''
   then   begin
           Result:='-1';
           Exit;
          end;

  if Images_Only
   then   begin
           Result:='';
           Exit
          end;          

  //  Скачивание главной страницы
  AddRequestForHTMLPageContent(URL, True, 'http://www.ruskino.ru', '', RequestParameters);
  Result:=GetHTMLPageContentFromRequest(url);
  if (Result='-1') then Exit;  
  MovieInfo:=Result;
  
  //------------------------------------------------------------------------------------------------
  //  Парсинг основной информации
  //------------------------------------------------------------------------------------------------
  all:=Result;
  

  //  Возврат кода фильма в формате сайта
  movie_code:=ParseString(URL, '(\d+)', 1);
  movie_site_url := GetMovieSiteURL(movie_code);
  title := GetStr(all, '<h1', '</h1>');
  if title <> '' then
	title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + title)));
  original_title := '';
  
  AllActorsURL := 'https://www.ruskino.ru/titr/' + movie_code + '/all-titrs';
  AddRequestForHTMLPageContent(AllActorsURL, True, url, '', RequestParameters);
  
  //описание
  description := GetStr(all, 'Аннотация</h4>', '<button');
  description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(description)));
  
  //год
  temp := GetStr(all, 'class="head_info_piece year">', '</span>');
  temp := ClearExtraBlankCharacters(RemoveTags(temp));
  year := ParseString(temp, '(\d+)', 1);
  
  //длительность
  duration := 0;
  temp := ParseString(all, '"head_info_piece">(\d+) мин.', 1);
  if temp <> '' then
	try
		duration := StrToInt(temp);
	except
	end;
	
  // жанры
  i := Pos('itemprop="genre">', all);
  while i > 0 do begin
	j := MyPos('</a', all, i + 1);
	temp := copy(all, i + 17, j - i - 17);
	temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	if temp <> '' then
		SetGenre(temp);
	i := MyPos('itemprop="genre">', all, i+1);
  end;
 
  //  Добавление страны по флагу
  if Pos('razdel=sov', Result)=0 then   SetCountry('Россия')
  else   SetCountry('СССР');
  
  //актеры
  i := Pos('<div id="mainTitrs">', all);
  if i>0 then begin
	j := MyPos('<div id="allTitrs">', all, i+1);
	if j=0 then
		j := MyPos(' id="crew"', all, i+1);
	temp := copy(all, i, j-i);
	ExtractActors(temp, 3);
  end;
  temp := GetHTMLPageContentFromRequest(AllActorsURL);
  temp := DecodeUnicodeSequences(temp);
  temp := ReplaceStr(temp, '\n', #10, -1);
  temp := ReplaceStr(temp, '\/', '/', -1);
  if temp <> '' then begin
	ExtractActors(temp, 3);
  end;
  
  //творческая группа
  temp := GetStr(all, 'id="crew"', '<script');
  // продюсеры
  s := GetStr(temp, '<dt>Продюсер', '</div>');
  ExtractCrew(s, 5);
  
  // режиссеры
  s := GetStr(temp, '<dt>Режиссер', '</div>');
  ExtractCrew(s, 1);
  
  // сценаристы
  s := GetStr(temp, '<dt>Сценарист', '</div>');
  ExtractCrew(s, 2);
  
  // операторы
  s := GetStr(temp, '<dt>Оператор', '</div>');
  ExtractCrew(s, 6);
  
  // композиторы
  s := GetStr(temp, '<dt>Композитор', '</div>');
  ExtractCrew(s, 4);
  
  //студии
  i := Pos('itemprop="productionCompany" content="', all);
  while i > 0 do begin
	i := i + length('itemprop="productionCompany" content="');
	j := MyPos('"', all, i + 1);
	temp := copy(all, i, j-i);
	temp := ClearExtraBlankCharacters(DecodeHTML(temp));
	if temp <> '' then
		SetStudio(temp);
	i := MyPos('itemprop="productionCompany" content="', all, i + 1);
  end;
  
  //рейтинг сайта
  temp := ClearExtraBlankCharacters(RemoveTags(GetStr(all, 'itemprop="ratingValue">', '</')));
  i:=pos('.', temp);
  if i>0 then
	temp[i]:=DecimalSeparator;
	try
		rating:=StrToFloat(temp);
	except
	end;
	

 end;


//==================================================================================================
//  Загрузка картинок
//==================================================================================================
procedure GetImages;
 var
  Temp, ImageURL, dup: string;
 begin                                   
	temp := GetStr(all, 'id="gallery-mainposter"', '</div');
	ImageURL := GetStr(temp, 'src="', '"');
	if ImageURL = '' then
		ImageURL := GetStr(all, 'property="og:image" content="', '"');
	if (ImageURL <> '') and (Pos('http:', ImageURL) = 0) then
		ImageURL := 'http://www.ruskino.ru' + ImageURL;
	SetImageName('', ImageURL, '', 1);

  //  Получение кадров из фильма
  dup := GetStr(all, 'id="gallery-photo', '</div>'#10'                    </div>');
  if (dup = '') then
	dup := GetStr(all, 'id="gallery-shot', '</div>'#10'                    </div>');
  ExtractImages(dup, 3, MaxShotsCount);

  //постеры
  dup := GetStr(all, 'id="gallery-poster"', '</div>'#10'                    </div>');
  ExtractImages(dup, 4, MaxPostersCount);
 end;
 
procedure ExtractImages(text: String; mode, max: Integer);
var
	temp, ImageURL: String;
	i, shot_cnt: Integer;
begin
  shot_cnt := 0;
  i := Pos('<a class="gallery-image"', text);
  while (i > 0) and (shot_cnt < max) do begin
	temp := GetStr(text, '<a class="gallery-image"', '</a>');
	ImageURL := GetStr(temp, ' src="', '"');
	ImageURL := ReplaceStr(ImageURL, '/media/cache/gallery_sm', '', -1);
	ImageURL := ReplaceStr(ImageURL, '/media/cache/resolve/gallery_sm', '', -1);
	if ImageURL <> '' then begin
		SetImageName('', ImageURL, '', mode);
		Inc(shot_cnt);
	end;
	delete(text, 1, i);
	i := Pos('<a class="gallery-image"', text);
  end; 
end;


//==================================================================================================
//  Сохранение картинки по ее URL в выбранный файл
//==================================================================================================
function SaveFrontCover(URL, FileName: string): boolean;
 var
  Stream: TFileStream;
  Temp  : string;
 begin
  Temp:=DownloadURL(URL);
  if (Length(Temp)>0) and (Temp<>'-1') and (GetResponseCode=200)
   then   try
						Stream:=TFileStream.Create(FileName, fmCreate);
    				Stream.Write(Temp, Length(Temp));
    				Stream.Free;
						Result:=True;
	         except
	          Result:=False
	         end
   else   Result:=False
 end;


begin

  RequestParameters := TStringList.Create();
  RequestParameters.Add('Host: www.ruskino.ru');
  RequestParameters.Add('Accept: text/html, application/xhtml+xml, image/jxr, */*');
  RequestParameters.Add('Accept-Encoding: gzip, deflate');
  RequestParameters.Add('Accept-Language: en-US,en;q=0.8,ru;q=0.7,uk;q=0.5,de-DE;q=0.3,de;q=0.2');
  RequestParameters.Add('Connection: close');
  RequestParameters.Add('User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko');

end.
