﻿const
 script_name='RusKino';
 language='Russian';
 version=13;
 author='Vlad';
 MinProgramBuild=8000;

 PostReferer = 'post';
 CRLF = #13#10;   

 PERSON_DIRECTOR = 1;
 PERSON_WRITER   = 2;
 PERSON_ACTOR    = 3;
 PERSON_COMPOSER = 4;

 IMAGE_PHOTO = 6;

 InvalidChars = '~!@#$%^&*()_+`-"№;%:?*<>{}''\|/[]., ';


var
	persons_count: integer;
	persons: array of string;
	imdb_codes: array of string;
	imdb_code, person_code: string;
	name, code, year, description: string;
	person, BasicURL, biography, trivia, character, birth_date, death_date, birthplace, birth_name, salary, height, original_name, person_site_url: string;
	photo_url: string;
	monthes: array [1..12] of string;
	prefixes: array [1..13] of string;
	person_height: integer;
	is_photos_present: boolean;
	DownloadPersonBiography, DownloadPersonAdditionalInfo: boolean;
	MaxPhotosCount: integer;
	RequestParameters: TStringList;

  SearchRes, InternalURL, BaseImageURL, ActorInfo: string;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;



//==================================================================================================
//  Вспомогательные функции
//==================================================================================================

 
//==================================================================================================
function Parse(var Str: string; const Separator: string): string;
 var
  Position: Integer;
 begin
  Position:=Pos(Separator, Str);
  if Position=0
   then   begin
           Result:=Str;
           Str:=''
          end
   else   begin
           Result:=Copy(Str, 1, Position-1);
           Delete(Str, 1, Position+Length(Separator)-1)
          end
 end;
              
                                                 
//==================================================================================================
function SeparateLeft(const Value, Delimiter: string): string;
 var
  Index: Integer;
 begin
  Index:=Pos(Delimiter, Value);
  if Index=0
   then   Result:=Value
   else   Result:=Copy(Value, 1, Index-1)
 end;  

    


//==================================================================================================
//  Удаление непечатных символов с разных сторон имени, HTML-декодирование, удаление "*" из имени,
//  вырезание "левых" скобок
//==================================================================================================
function CleanName(Name: string): string;
 var
  Start ,
  Finish,
  Step  : Integer;
 begin
  Start:=Pos('(', Name);
  Finish:=Pos(')', Name);
  if (Start>0) and (Finish>0)
   then   begin
           Delete(Name, Start, Finish-Start+1);
           Name:=ReplaceStr(Name, '  ', ' ', -1)
          end;

  Result:=Trim(ReplaceStr(DecodeHTML(Trim(Name)), '*', '', -1));

  Finish:=0;
  for Step:=Length(Result) downto 1
   do   if Pos(Result[Step], InvalidChars)>0
         then   Finish:=Step
         else   Break;
  if Finish<>0
   then   Delete(Result, Finish, Length(Name)-Finish+1)
 end;

                                             
//==================================================================================================
function CleanText(Text: string): string;
 begin
  Result:=ReplaceStr(Trim(Text), CRLF, '', -1);      
  Result:=ReplaceStr(Result, '<br /> ', CRLF, -1);
  Result:=ReplaceStr(Result, '<br />', CRLF, -1);
  Result:=Trim(DecodeHTML(Result))
 end;    



//==================================================================================================
//  Экспортируемые из скрипта функции
//==================================================================================================

             
//==================================================================================================
//  01. Формирование URL для поиска актёра на сайте по названию
//==================================================================================================
function GetSearchURLbyName(PersonName: string): string;
 begin
	PersonName := ReplaceStr(PersonName, ' ', '+', -1);
	Result:=Format('https://www.ruskino.ru/search/?s=%s', [EncodeURL(PersonName, 'utf-8')]);
 end;


//==================================================================================================
//  02. Загрузка html-документа по поисковой ссылке
//==================================================================================================
function DownloadSearchURL(URL: string): Integer;
 begin          
	AddRequestForHTMLPageContent(URL, True, 'http://www.ruskino.ru', '', RequestParameters);
	SearchRes:=GetHTMLPageContentFromRequest(url);
  if (SearchRes<>'-1')
   then   Result:=SelectActor
   else   Result:=-1
 end;    

                                                                                                  
//==================================================================================================
//  03. Парсинг страницы поисков с актёрами
//==================================================================================================
function SelectActor: Integer;
 var
  Actor, Code, year, tempCode, small_photo, description, s2, s : string; 
  i, j: Integer;
 begin
  Result:=0;
  tempCode := GetStr(SearchRes, '<h1><small>запрос</small>', '<script');
  i := Pos('<div class="media"', tempCode);
  while i > 0 do begin
	j := MyPos('<div class="media"', tempCode, i + 1);
	if j = 0 then 
		j := length(tempCode);
    s := copy(tempCode, i, j - 1);
	small_photo := GetStr(s, ' src="', '"');
	if (Pos('noposter', small_photo)>0) then
		small_photo := '';
	Actor := GetStr(s, '<h5', '</h5>');
	Code := ParseString(Actor, '/art/(\d+)', 1);
	if Actor <> '' then
		Actor := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + Actor)));
	s2 := GetStr(s, 'class="search-result-subtitle">', '</div>');
	year := ParseString(s2, '(\d+)г.', 1);
	description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(s, 'class="search-result-text">', '</'))));
	if (Actor <> '') and (Code <> '') then begin
		SetSearchResult2(Actor, Code, Year, '', description, small_photo);
		Inc(Result);
	end;
	delete(tempCode, 1, i);
	i := Pos('<div class="media"', tempCode);
  end;
 end;


//==================================================================================================
//  04. Формирование URL с информацией об актёре по коду актёра в формате сайта 
//  images_only - признак закачки только картинок
//==================================================================================================
function GetPersonURL(Code: string; Images_Only: Boolean): string;
 begin
  if Code<>''
   then   Result:='https://ruskino.ru/art/'+Code
   else   Result:=''
 end;     

procedure ExtractMovies(text: String; mode: Integer);
var
	s, s2, title, code, year, character: String;
	i, j: Integer;
begin
	i := Pos('<div class="media titr_credit">', text);
	while i>0 do begin
		j := MyPos('<div class="media titr_credit">', text, i+1);
		if j = 0 then
			j := length(text);
		s := copy(text, i, j-i);
		code := ParseString(s, '/mov/(\d+)', 1);
		title := GetStr(s, 'titr_titr_info">', '</a>');
		if title <> '' then
			title := RemoveTags('<' + title);
		title := ClearExtraBlankCharacters(DecodeHTML(title));
		year := ParseString(s, '\((\d+)г.', 1);
		character := '';
		if (mode = 3) then begin
			character := GetStr(s, '"titr_titr_extra">', '</');
			if character = '' then
				character := GetStr(s, ' class="rolabout">', '</');
			s2 := ParseString(character, '/(.*?)/', 1);
			if s2 = '' then
				s2 := ParseString(character, '/(.*?)$', 1);
			character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
		end;
		if (title <> '') then
			SetMovieName(title, character, mode, code, year);
		delete(text, 1, i);
		i := Pos('<div class="media titr_credit">', text);
	end;	
end;

//==================================================================================================
//  05. Получение данных по фильму по URL
//  images_only - признак закачки только картинок
//==================================================================================================
function GetInfo(URL: string; Images_Only: Boolean): string;
 var
  Temp, day, month, year, s: string;
  ActorIndex, i, j: Integer;
  sl: TStringList;
 begin
  InternalURL:=URL;
  BaseImageURL:=ReplaceStr(InternalURL, 'art', 'artist', -1);
  Person_Code:=URL;
  Parse(Person_Code, '/art/');
  person_site_url:=GetPersonSiteURL(Person_Code);

  //  Проверка на ошибки
  if URL=''
   then   begin
           Result:='-1';
           Exit;
          end;
  if Images_Only
   then   begin
           Result:='';
           Exit
          end;

  //  Скачивание главной страницы
  AddRequestForHTMLPageContent(URL, True, 'http://www.ruskino.ru', '', RequestParameters);
  Result:=GetHTMLPageContentFromRequest(url);
  if (Result='-1')
   then   Exit;
  ActorInfo:=Result;
  all := Result;
  
  Person := GetStr(all, '<title>', ' — ');
  if Person = '' then begin
	  Person := GetStr(all, '<h1', '</h1>');
	  if Person <> '' then
		Person := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + Person)));
	  i := Pos('  ', Person);
	  if i > 0 then
		delete(Person, i, length(Person) - i + 1);
  end;
	

  //  Получение биографии
  biography := GetStr(all, 'id="info"', '</div>');
  if (biography <> '') and (Pos('<ul id="bl-', biography) = 0) then
	biography := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + biography)))
  else
	biography := '';
  
  //дата рождения
  sl := TStringList.Create;
  sl.Text := biography;
  temp := '';
  for i := 0 to sl.Count - 1 do begin
	if (Pos('Родился ', sl[i]) > 0) then begin
		temp := sl[i];
		s := 'Родился ';
	end
	else if (Pos('Родилась ', sl[i]) > 0) then begin
		temp := sl[i];
		s := 'Родилась ';
	end;
  end;
  day := ParseString(temp, s+'(\d+)', 1);
  month := ParseString(temp, s+'\d+ (.*?) \d+', 1);
  year := ParseString(temp, s+'.*? (\d+)', 1);
  i:=1;
  while (i<=12) and (monthes[i]<>month) do
	i:=i+1;
  if (i<=12) and (year<>'') and (day <> '') then
	birth_date:=IntToStr(i)+format('/%s/%s', [day, year])
  else if (year <> '') then
	birth_date := year;
	
  //дата смерти
  temp := '';
  for i := 0 to sl.Count - 1 do begin
	if (Pos('Ушел из жизни ', sl[i]) > 0) then begin
		temp := sl[i];
		s := 'Ушел из жизни ';
	end
	else if (Pos('Ушла из жизни ', sl[i]) > 0) then begin
		temp := sl[i];
		s := 'Ушла из жизни ';
	end;
  end;
  day := ParseString(temp, s + '(\d+)', 1);
  month := ParseString(temp, s + '\d+ (.*?) \d+г.', 1);
  year := ParseString(temp, s + '.*? (\d+)г.', 1);
  i:=1;
  while (i<=12) and (monthes[i]<>month) do
	i:=i+1;
  if (i<=12) and (year<>'') and (day <> '') then
	death_date:=IntToStr(i)+format('/%s/%s', [day, year])
  else if (year <> '') then
	death_date := year;

  
  //фильмография
  
  //актер
  i := Pos('id="bl-actor"', all);
  if i>0 then begin
	j := MyPos('<ul id="bl-', all, i + 1);
	if j = 0 then
		j := MyPos('<div id="footer">', all, i+1);
	temp := copy(all, i, j-i);
	ExtractMovies(temp, 3);
  end;
  
  //режиссер
  i := Pos('id="bl-director', all);
  if i>0 then begin
	j := MyPos('<ul id="bl-', all, i + 1);
	if j = 0 then
		j := MyPos('<div id="footer">', all, i+1);
	temp := copy(all, i, j-i);
	ExtractMovies(temp, 1);
  end;
  
  //сценарист
  i := Pos('id="bl-screenwriter', all);
  if i>0 then begin
	j := MyPos('<ul id="bl-', all, i + 1);
	if j = 0 then
		j := MyPos('<div id="footer">', all, i+1);
	temp := copy(all, i, j-i);
	ExtractMovies(temp, 2);
  end;
  
  //композитор
  i := Pos('id="bl-composer', all);
  if i>0 then begin
	j := MyPos('<ul id="bl-', all, i + 1);
	if j = 0 then
		j := MyPos('<div id="footer">', all, i+1);
	temp := copy(all, i, j-i);
	ExtractMovies(temp, 4);
  end;
  
  //продюсер
  i := Pos('id="bl-producer', all);
  if i>0 then begin
	j := MyPos('<ul id="bl-', all, i + 1);
	if j = 0 then
		j := MyPos('<div id="footer">', all, i+1);
	temp := copy(all, i, j-i);
	ExtractMovies(temp, 5);
  end;
  
  //оператор
  i := Pos('id="bl-operator', all);
  if i>0 then begin
	j := MyPos('<ul id="bl-', all, i + 1);
	if j = 0 then
		j := MyPos('<div id="footer">', all, i+1);
	temp := copy(all, i, j-i);
	ExtractMovies(temp, 6);
  end;

 end;


//==================================================================================================
//  07. Загрузка картинок
//==================================================================================================
procedure GetImages;
 var
  Temp   ,
  Photo  : string;
  Counter, i: Integer;
 begin
	Counter := 0;
	Photo := GetStr(all, 'itemprop="image" src="', '"');
	if (Photo <> '') then begin
		if Pos('http', photo) = 0 then
			Photo := 'https://www.ruskino.ru' + Photo;
		Counter := 1;
		SetImageName('', Photo, '', 6);
	end;
	
	Temp := GetStr(all, 'id="gallery-portrets"', '<div class="main_gallery');
	if Temp = '' then
		Temp := GetStr(all, 'id="gallery-portrets"', '</div>'#10'        </div>');
	i := Pos('src="', temp);
	while (i > 0) and (Counter < MaxPhotosCount) do begin
		Photo := GetStr(Temp, 'src="', '"');
		Photo := ReplaceStr(Photo, 'media/cache/photo_sm/', '', -1);
		if Photo <> '' then begin
			Inc(Counter);
			SetImageName('', Photo, '', 6);
		end;
		delete(Temp, 1, i);
		i := Pos('src="', temp);
	end;
 
 end;

                                                                                                
//==================================================================================================
//  08. Сохранение картинки по ее URL в выбранный файл
//==================================================================================================
function SavePhoto(URL, FileName: string): Boolean;
 var
  Stream: TFileStream;
  Temp  : string;
 begin          
  Temp:=DownloadURL(URL);
  if (Length(Temp)>0) and (Temp<>'-1') and (GetResponseCode=200)
   then   try
						Stream:=TFileStream.Create(FileName, fmCreate);
    				Stream.Write(Temp, Length(Temp));
    				Stream.Free;
						Result:=True;
	         except
	          Result:=False
	         end
   else   Result:=False
 end;


//==================================================================================================
//  Получение ссылки на страницу фильма по коду в формате сайта
//==================================================================================================
function GetMovieSiteURL(Code: string): string;
 begin
	if Code=''
   then   Result:=''
   else   Result:='https://ruskino.ru/mov/'+Code
 end;


//==================================================================================================
//  Получение ссылки на страницу актёра по коду в формате сайта
//==================================================================================================
function GetPersonSiteURL(Code: string): string;
 begin
	if Code=''
   then  Result:=''
   else  Result:='https://ruskino.ru/art/'+Code
 end;


begin

  monthes[1]:='января';
  monthes[2]:='февраля';
  monthes[3]:='марта';
  monthes[4]:='апреля';
  monthes[5]:='мая';
  monthes[6]:='июня';
  monthes[7]:='июля';
  monthes[8]:='августа';
  monthes[9]:='сентября';
  monthes[10]:='октября';
  monthes[11]:='ноября';
  monthes[12]:='декабря';
  
  RequestParameters := TStringList.Create();
  RequestParameters.Add('Host: www.ruskino.ru');
  RequestParameters.Add('Accept: text/html, application/xhtml+xml, image/jxr, */*');
  RequestParameters.Add('Accept-Encoding: gzip, deflate');
  RequestParameters.Add('Accept-Language: en-US,en;q=0.8,ru;q=0.7,uk;q=0.5,de-DE;q=0.3,de;q=0.2');
  RequestParameters.Add('Connection: close');
  RequestParameters.Add('User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko');

end.
