﻿const
	script_name='shikimori';
	language='Russian';
	version=3;
	author='Vlad';
	MinProgramBuild=8000;
	PCount = 12;
	//MaxPicturesCount = 3;
var
	title, MovieName, s, s2, s3, s4, year, director, name, character, BasicURL, country, description, salary: string;
	episodes, movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	i, j: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	rating, imdb_rating: double;
	front_cover_url: string;
	posters_exists: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	MaxShotsCount: Integer;
	RequestParameters: TStringList;
	
const
	SITE_URL='https://shikimori.org';
	
function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function MovieSearch: integer;
var
	i, j, k: integer;
	title, code, year, description, small_cover, original_title: string;
begin
	s:='';
	titles_count:=0;
	i := Pos('{"id"', all);
	while i > 0 do begin
		s := GetStr(all, '{"id"', '},{"id"');
		if s = '' then
			s := GetStr(all, '{"id"', '}]');
		code := GetStr(s, ':', ',');
		original_title := GetStr(s, '"name":"', '"');
		title := GetStr(s, '"russian":"', '"');
		small_cover := GetStr(s, '"preview":"', '"');
		if small_cover <> '' then
			small_cover := SITE_URL + small_cover;
		description := ParseString(s, '"episodes":(\d+)', 1);
		if description <> '' then
			description := 'Episodes: ' + description;
		if (code <> '') then begin
			Inc(titles_count);
			SetSearchResult2(title, code, '', original_title, description, small_cover);
		end;
		delete(all, 1, i);
		i := Pos('{"id"', all);
	end;
	result:=titles_count;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
	code := '';
	MovieName := EncodeURL(MovieName, 'utf-8');
	url:=SITE_URL + '/api/animes/search?q=' + MovieName;
	//url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	if code <> '' then begin
		SetSearchResult('Title', code);
		result := 1;
	end
	else begin
		all:=DownloadURL(url, False, RequestParameters, 'utf-8');
		if all='-1' then
			result:=-1
		else
			result:=MovieSearch;
	end;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
		result:=SITE_URL + format('/api/animes/%s', [code]);
end;

//returned link to front cover
function GetFrontCoverURL: string;
var
	res, all, url, s, s2, s3, amazon_url: string;
	i, j: integer;
begin
	res:=front_cover_url;
	s:=title;
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [title]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	amazon_url:='';
	i:=pos('<Item>', all);
	while (i>0) and (amazon_url='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then 
			begin
				//if title=s3 then begin //!!!
				if pos(title, s3)=1 then 
				begin
					amazon_url:=ParseString(s2, '<LargeImage><URL>(.*?)</URL>', 1);
				end;
			end;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	if amazon_url<>'' then
		SetImageName('', amazon_url, '', 1);
	if front_cover_url<>'' then
		SetImageName('', front_cover_url, '', 1);
	if amazon_url<>'' then
		res:=amazon_url;
	result:=res;
end;

//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
  fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;


function GetInfo(url: string; images_only: boolean): string;
var 
	keyword, s, s2, s3, plot_outline, eng_title, jap_title, temp: string;
	i, j: integer;
begin
	result:='';
	all:=DownloadURL(url, False, RequestParameters, 'utf-8');
  // SaveStringToFile('C:\temp123.bin', all);
	if all='-1' then
		result:='-1'
	else
		result:=all;

	movie_code:=ParseString(url, '/animes/(\d+)',1);
	movie_site_url:=GetMovieSiteURL(movie_code);
	
	//movie title
	eng_title := GetStr(all, '"name":"', '"');
	jap_title := GetStr(all, '"japanese":["', '"');
	title := GetStr(all, '"russian":"', '"');
	original_title := jap_title;
	if title='' then
		exit;
		
	//main cover
	temp := GetStr(all, '"image":{', '}');
	front_cover_url := GetStr(temp, '"original":"', '"');
	if front_cover_url <> '' then
		front_cover_url := SITE_URL + front_cover_url;

	//description
  description := '';
  i := Pos('"description":"', all);
  if (I > 0) then
  begin
    I := I + Length('"description":"');
    J := I;
    repeat
      J := MyPos('"', all, J + 1);
      if ((J > 0) and
          (Copy(all, J - 1, 1) <> '\')) then
      begin
        Break;
      end;
    until (J = 0);
    if (J > 0) then
    begin
    	description := Copy(all, I, J - I - 1);
      description := ReplaceStr(description, '\"', '"', -1);
  	  description := ReplaceStr(description, '\r\n', #13#10#13#10, -1);
    end;
  end;

	//duration
	s := ParseString(all, '"duration":(\d+)', 1);
	duration := 0;
	if s <> '' then begin
		try
			duration := StrToInt(s);
		except
		end;
	end;
	//rating
	rating := 0;
	s := GetStr(all, '"score":"', '"');
	i := Pos('.', s);
	if i > 0 then begin
		s[i] := DecimalSeparator;
		try
			rating := StrToFloat(s);
		except
		end;
	end;
	
	//mpaa
	mpaa := GetStr(all, '"rating":"', '"');
	mpaa := UpperCase(mpaa);
	
	//genres
	temp := GetStr(all, '"genres":[', ']');
	i := Pos('{', temp);
	while i > 0 do begin
		s := GetStr(temp, '{', '}');
		s2 := GetStr(s, '"russian":"', '"');
		if s2 <> '' then
			SetGenre(s2);
		delete(temp, 1, i);
		i := Pos('{', temp);
	end;
	
	//studios
	temp := GetStr(all, '"studios":[', ']');
	i := Pos('{', temp);
	while i > 0 do begin
		s := GetStr(temp, '{', '}');
		s2 := GetStr(s, '"name":"', '"');
		if s2 <> '' then
			SetStudio(s2);
		delete(temp, 1, i);
		i := Pos('{', temp);
	end;
end;

//returned images links
procedure GetImages;
var
	i, img_cnt: Integer;
	temp, s, img_url: String;
begin
	if front_cover_url <> '' then
		SetImageName('', front_cover_url, '', 1);
	img_cnt := 0;
	temp := GetStr(all, '"screenshots":', ']');
	i := Pos('{', temp);
	while (i > 0) and (img_cnt < MaxShotsCount) do begin
		s := GetStr(temp, '{', '}');
		img_url := GetStr(s, '"original":"', '"');
		if img_url <> '' then begin
			SetImageName('', SITE_URL + img_url, '', 3);
			Inc(img_cnt);
		end;
		delete(temp, 1, i);
		i := Pos('{', temp);
	end;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:=SITE_URL + format('/animes/%s-s', [code]);
end;

//get person url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:=SITE_URL + format('/seyu/%s-s', [code]);
end;


begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

  RequestParameters := TStringList.Create();
  RequestParameters.Add('Host=shikimori.org');
  RequestParameters.Add('AcceptLanguage=ru-RU');
  RequestParameters.Add('Connection=Close'); 
  RequestParameters.Add('useragent=Mozilla/5.0');

end.
